/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/path","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/json","os","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","child_process","vs/platform/request/common/request","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/platform/product/common/product","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensions/node/extensionHostStarter","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","path","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(J){for(var e=[],D=0,T=J.length;D<T;D++)e[D]=te[J[D]];return e};define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(T,P){if(!T)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=D}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function T(i){const I=[];for(let m in i)D.call(i,m)&&I.push(i[m]);return I}e.values=T;function P(i,I){for(let m in i)if(D.call(i,m)&&I({key:m,value:i[m]},function(){delete i[m]})===!1)return}e.forEach=P;function R(i,I){const m=Object.create(null);for(const E of i){const h=I(E);let S=m[h];S||(S=m[h]=[]),S.push(E)}return m}e.groupBy=R;function k(i){const I=Object.create(null);return i&&i.forEach((m,E)=>{I[E]=m}),I}e.fromMap=k;function C(i,I){const m=[],E=[];for(let h of i)I.has(h)||m.push(h);for(let h of I)i.has(h)||E.push(h);return{removed:m,added:E}}e.diffSets=C;function w(i,I){const m=[],E=[];for(let[h,S]of i)I.has(h)||m.push(S);for(let[h,S]of I)i.has(h)||E.push(S);return{removed:m,added:E}}e.diffMaps=w;class b{constructor(){this.map=new Map}add(I,m){let E=this.map.get(I);E||(E=new Set,this.map.set(I,E)),E.add(m)}delete(I,m){const E=this.map.get(I);!E||(E.delete(m),E.size===0&&this.map.delete(I))}forEach(I,m){const E=this.map.get(I);!E||E.forEach(m)}}e.SetMap=b}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(k){return(C,w,b)=>{let i=null,I=null;if(typeof b.value=="function"?(i="value",I=b.value):typeof b.get=="function"&&(i="get",I=b.get),!I)throw new Error("not supported");b[i]=k(I,w)}}e.createDecorator=D;function T(k,C,w){let b=null,i=null;if(typeof w.value=="function"?(b="value",i=w.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(b="get",i=w.get),!i)throw new Error("not supported");const I=`$memoize$${C}`;w[b]=function(...m){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,m)}),this[I]}}e.memoize=T;function P(k,C,w){return D((b,i)=>{const I=`$debounce$${i}`,m=`$debounce$result$${i}`;return function(...E){this[m]||(this[m]=w?w():void 0),clearTimeout(this[I]),C&&(this[m]=C(this[m],...E),E=[this[m]]),this[I]=setTimeout(()=>{b.apply(this,E),this[m]=w?w():void 0},k)}})}e.debounce=P;function R(k,C,w){return D((b,i)=>{const I=`$throttle$timer$${i}`,m=`$throttle$result$${i}`,E=`$throttle$lastRun$${i}`,h=`$throttle$pending$${i}`;return function(...S){if(this[m]||(this[m]=w?w():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),C&&(this[m]=C(this[m],...S)),this[h])return;const g=this[E]+k;g<=Date.now()?(this[E]=Date.now(),b.apply(this,[this[m]]),this[m]=w?w():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[E]=Date.now(),b.apply(this,[this[m]]),this[m]=w?w():void 0},g-Date.now()))}})}e.throttle=R}),define(te[7],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(s=>{s(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=D,e.errorHandler=new D;function T(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=T;function P(l){w(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=P;function R(l){w(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function k(l){if(l instanceof Error){let{name:n,message:s}=l;const r=l.stacktrace||l.stack;return{$isError:!0,name:n,message:s,stack:r}}return l}e.transformErrorForSerialization=k;const C="Canceled";function w(l){return l instanceof Error&&l.name===C&&l.message===C}e.isPromiseCanceledError=w;class b extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=b;function i(){const l=new Error(C);return l.name=l.message,l}e.canceled=i;function I(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=I;function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=m;function E(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function h(l){const n=new Error(`${l} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function S(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=S;class g extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=g;class v extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=v;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function d(l){const n=l;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=d;function c(l,n=Object.create(null)){const s=new Error(l);return n.actions&&(s.actions=n.actions),s}e.createErrorWithActions=c}),define(te[17],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(U,B=0){return U[U.length-(1+B)]}e.tail=T;function P(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=P;function R(U,B,j=(Q,Z)=>Q===Z){if(U===B)return!0;if(!U||!B||U.length!==B.length)return!1;for(let Q=0,Z=U.length;Q<Z;Q++)if(!j(U[Q],B[Q]))return!1;return!0}e.equals=R;function k(U,B,j){let Q=0,Z=U.length-1;for(;Q<=Z;){const G=(Q+Z)/2|0,H=j(U[G],B);if(H<0)Q=G+1;else if(H>0)Z=G-1;else return G}return-(Q+1)}e.binarySearch=k;function C(U,B){let j=0,Q=U.length;if(Q===0)return 0;for(;j<Q;){const Z=Math.floor((j+Q)/2);B(U[Z])?Q=Z:j=Z+1}return j}e.findFirstInSorted=C;function w(U,B,j){if(U=U|0,U>=B.length)throw new TypeError("invalid index");let Q=B[Math.floor(B.length*Math.random())],Z=[],G=[],H=[];for(let re of B){const ie=j(re,Q);ie<0?Z.push(re):ie>0?G.push(re):H.push(re)}return U<Z.length?w(U,Z,j):U<Z.length+H.length?H[0]:w(U-(Z.length+H.length),G,j)}e.quickSelect=w;function b(U,B){const j=[];let Q;for(const Z of U.slice(0).sort(B))!Q||B(Q[0],Z)!==0?(Q=[Z],j.push(Q)):Q.push(Z);return j}e.groupBy=b;function i(U,B,j){const Q=[];function Z(re,ie,ce){if(ie===0&&ce.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===re?(le.deleteCount+=ie,le.toInsert.push(...ce)):Q.push({start:re,deleteCount:ie,toInsert:ce})}let G=0,H=0;for(;;){if(G===U.length){Z(G,0,B.slice(H));break}if(H===B.length){Z(G,U.length-G,[]);break}const re=U[G],ie=B[H],ce=j(re,ie);ce===0?(G+=1,H+=1):ce<0?(Z(G,1,[]),G+=1):ce>0&&(Z(G,0,[ie]),H+=1)}return Q}e.sortedDiff=i;function I(U,B,j){const Q=i(U,B,j),Z=[],G=[];for(const H of Q)Z.push(...U.slice(H.start,H.start+H.deleteCount)),G.push(...H.toInsert);return{removed:Z,added:G}}e.delta=I;function m(U,B,j){if(j===0)return[];const Q=U.slice(0,j).sort(B);return h(U,B,Q,j,U.length),Q}e.top=m;function E(U,B,j,Q,Z){return j===0?Promise.resolve([]):new Promise((G,H)=>{(async()=>{const re=U.length,ie=U.slice(0,j).sort(B);for(let ce=j,le=Math.min(j+Q,re);ce<re;ce=le,le=Math.min(le+Q,re)){if(ce>j&&await new Promise(de=>setTimeout(de)),Z&&Z.isCancellationRequested)throw(0,D.canceled)();h(U,B,ie,ce,le)}return ie})().then(G,H)})}e.topAsync=E;function h(U,B,j,Q,Z){for(const G=j.length;Q<Z;Q++){const H=U[Q];if(B(H,j[G-1])<0){j.pop();const re=C(j,ie=>B(H,ie)<0);j.splice(re,0,H)}}}function S(U){return U.filter(B=>!!B)}e.coalesce=S;function g(U){let B=0;for(let j=0;j<U.length;j++)U[j]&&(U[B]=U[j],B+=1);U.length=B}e.coalesceInPlace=g;function v(U,B,j){U.splice(j,0,U.splice(B,1)[0])}e.move=v;function y(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=y;function d(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=d;function c(U,B=j=>j){const j=new Set;return U.filter(Q=>{const Z=B(Q);return j.has(Z)?!1:(j.add(Z),!0)})}e.distinct=c;function l(U){const B=Object.create(null);return j=>{const Q=U(j);return B[Q]?!1:(B[Q]=!0,!0)}}e.uniqueFilter=l;function n(U,B){const j=s(U,B);if(j!==-1)return U[j]}e.findLast=n;function s(U,B){for(let j=U.length-1;j>=0;j--){const Q=U[j];if(B(Q))return j}return-1}e.lastIndex=s;function r(U,B){return U.length>0?U[0]:B}e.firstOrDefault=r;function t(U,B,j=(Q,Z)=>Q===Z){let Q=0;for(let Z=0,G=Math.min(U.length,B.length);Z<G&&j(U[Z],B[Z]);Z++)Q++;return Q}e.commonPrefixLength=t;function a(U){return[].concat(...U)}e.flatten=a;function o(U,B){let j=typeof B=="number"?U:0;typeof B=="number"?j=U:(j=0,B=U);const Q=[];if(j<=B)for(let Z=j;Z<B;Z++)Q.push(Z);else for(let Z=j;Z>B;Z--)Q.push(Z);return Q}e.range=o;function u(U,B,j){return U.reduce((Q,Z)=>(Q[B(Z)]=j?j(Z):Z,Q),Object.create(null))}e.index=u;function f(U,B){return U.push(B),()=>p(U,B)}e.insert=f;function p(U,B){const j=U.indexOf(B);if(j>-1)return U.splice(j,1),B}e.remove=p;function A(U,B,j){const Q=U.slice(0,B),Z=U.slice(B);return Q.concat(j,Z)}e.arrayInsert=A;function O(U,B){let j;if(typeof B=="number"){let Q=B;j=()=>{const Z=Math.sin(Q++)*179426549;return Z-Math.floor(Z)}}else j=Math.random;for(let Q=U.length-1;Q>0;Q-=1){const Z=Math.floor(j()*(Q+1)),G=U[Q];U[Q]=U[Z],U[Z]=G}}e.shuffle=O;function M(U,B){const j=U.indexOf(B);j>-1&&(U.splice(j,1),U.unshift(B))}e.pushToStart=M;function q(U,B){const j=U.indexOf(B);j>-1&&(U.splice(j,1),U.push(B))}e.pushToEnd=q;function N(U,B){return Array.isArray(U)?U.map(B):B(U)}e.mapArrayOrNot=N;function L(U){return Array.isArray(U)?U:[U]}e.asArray=L;function $(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=$;function _(U,B){for(const j of U){const Q=B(j);if(Q!==void 0)return Q}}e.mapFind=_;function F(U,B,j){const Q=W(U,B),Z=U.length,G=j.length;U.length=Z+G;for(let H=Z-1;H>=Q;H--)U[H+G]=U[H];for(let H=0;H<G;H++)U[H+Q]=j[H]}e.insertInto=F;function V(U,B,j,Q){const Z=W(U,B),G=U.splice(Z,j);return F(U,Z,Q),G}e.splice=V;function W(U,B){return B<0?Math.max(B+U.length,0):Math.min(B,U.length)}function x(U,B){let j=Number.MAX_SAFE_INTEGER,Q=0;return U.forEach((Z,G)=>{const H=B(Z);H<j&&(j=H,Q=G)}),Q}e.minIndex=x;function z(U,B){let j=Number.MIN_SAFE_INTEGER,Q=0;return U.forEach((Z,G)=>{const H=B(Z);H>j&&(j=H,Q=G)}),Q}e.maxIndex=z;class K{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let j=this.firstIdx;for(;j<this.items.length&&B(this.items[j]);)j++;const Q=j===this.firstIdx?null:this.items.slice(this.firstIdx,j);return this.firstIdx=j,Q}takeFromEndWhile(B){let j=this.lastIdx;for(;j>=0&&B(this.items[j]);)j--;const Q=j===this.lastIdx?null:this.items.slice(j+1,this.lastIdx+1);return this.lastIdx=j,Q}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=K}),define(te[68],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(T){const P=this;let R=!1,k;return function(){return R||(R=!0,k=T.apply(P,arguments)),k}}e.once=D}),define(te[55],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function P(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}T.is=P;const R=Object.freeze([]);function k(){return R}T.empty=k;function*C(l){yield l}T.single=C;function w(l){return l||R}T.from=w;function b(l){return!l||l[Symbol.iterator]().next().done===!0}T.isEmpty=b;function i(l){return l[Symbol.iterator]().next().value}T.first=i;function I(l,n){for(const s of l)if(n(s))return!0;return!1}T.some=I;function m(l,n){for(const s of l)if(n(s))return s}T.find=m;function*E(l,n){for(const s of l)n(s)&&(yield s)}T.filter=E;function*h(l,n){let s=0;for(const r of l)yield n(r,s++)}T.map=h;function*S(...l){for(const n of l)for(const s of n)yield s}T.concat=S;function*g(l){for(const n of l)for(const s of n)yield s}T.concatNested=g;function v(l,n,s){let r=s;for(const t of l)r=n(r,t);return r}T.reduce=v;function*y(l,n,s=l.length){for(n<0&&(n+=l.length),s<0?s+=l.length:s>l.length&&(s=l.length);n<s;n++)yield l[n]}T.slice=y;function d(l,n=Number.POSITIVE_INFINITY){const s=[];if(n===0)return[s,l];const r=l[Symbol.iterator]();for(let t=0;t<n;t++){const a=r.next();if(a.done)return[s,T.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return r}}]}T.consume=d;function c(l,n,s=(r,t)=>r===t){const r=l[Symbol.iterator](),t=n[Symbol.iterator]();for(;;){const a=r.next(),o=t.next();if(a.done!==o.done)return!1;if(a.done)return!0;if(!s(a.value,o.value))return!1}}T.equals=c})(D=e.Iterable||(e.Iterable={}))}),define(te[33],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var T;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function k(n,s=!1){let r=0,t=n.length,a="",o=0,u=16,f=0;function p($){let _=0,F=0;for(;_<$;){const V=n.charCodeAt(r);if(V>=48&&V<=57)F=F*16+V-48;else if(V>=65&&V<=70)F=F*16+V-65+10;else if(V>=97&&V<=102)F=F*16+V-97+10;else break;r++,_++}return _<$&&(F=-1),F}function A($){r=$,a="",o=0,u=16,f=0}function O(){const $=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&b(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&b(n.charCodeAt(r)))for(r++;r<n.length&&b(n.charCodeAt(r));)r++;else return f=3,n.substring($,r);let _=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&b(n.charCodeAt(r))){for(r++;r<n.length&&b(n.charCodeAt(r));)r++;_=r}else f=3;return n.substring($,_)}function M(){let $="",_=r;for(;;){if(r>=t){$+=n.substring(_,r),f=2;break}const F=n.charCodeAt(r);if(F===34){$+=n.substring(_,r),r++;break}if(F===92){if($+=n.substring(_,r),r++,r>=t){f=2;break}switch(n.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const W=p(4);W>=0?$+=String.fromCharCode(W):f=4;break;default:f=5}_=r;continue}if(F>=0&&F<=31)if(w(F)){$+=n.substring(_,r),f=2;break}else f=6;r++}return $}function q(){if(a="",f=0,o=r,r>=t)return o=t,u=17;let $=n.charCodeAt(r);if(C($)){do r++,a+=String.fromCharCode($),$=n.charCodeAt(r);while(C($));return u=15}if(w($))return r++,a+=String.fromCharCode($),$===13&&n.charCodeAt(r)===10&&(r++,a+=`
`),u=14;switch($){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,a=M(),u=10;case 47:const _=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<t&&!w(n.charCodeAt(r));)r++;return a=n.substring(_,r),u=12}if(n.charCodeAt(r+1)===42){r+=2;const F=t-1;let V=!1;for(;r<F;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,V=!0;break}r++}return V||(r++,f=1),a=n.substring(_,r),u=13}return a+=String.fromCharCode($),r++,u=16;case 45:if(a+=String.fromCharCode($),r++,r===t||!b(n.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=O(),u=11;default:for(;r<t&&N($);)r++,$=n.charCodeAt(r);if(o!==r){switch(a=n.substring(o,r),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode($),r++,u=16}}function N($){if(C($)||w($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let $;do $=q();while($>=12&&$<=15);return $}return{setPosition:A,getPosition:()=>r,scan:s?L:q,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>f}}e.createScanner=k;function C(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function w(n){return n===10||n===13||n===8232||n===8233}function b(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function I(n,s){const r=[],t=new Object;let a;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function f(p,A,O,M){o.value=p,o.offset=A,o.length=O,o.type=M,o.colonOffset=void 0,a=o}try{d(n,{onObjectBegin:(p,A)=>{if(s<=p)throw t;a=void 0,u=s>p,r.push("")},onObjectProperty:(p,A,O)=>{if(s<A||(f(p,A,O,"property"),r[r.length-1]=p,s<=A+O))throw t},onObjectEnd:(p,A)=>{if(s<=p)throw t;a=void 0,r.pop()},onArrayBegin:(p,A)=>{if(s<=p)throw t;a=void 0,r.push(0)},onArrayEnd:(p,A)=>{if(s<=p)throw t;a=void 0,r.pop()},onLiteralValue:(p,A,O)=>{if(s<A||(f(p,A,O,l(p)),s<=A+O))throw t},onSeparator:(p,A,O)=>{if(s<=A)throw t;if(p===":"&&a&&a.type==="property")a.colonOffset=A,u=!1,a=void 0;else if(p===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(u=!0,r[r.length-1]=""),a=void 0}}})}catch(p){if(p!==t)throw p}return{path:r,previousNode:a,isAtPropertyKey:u,matches:p=>{let A=0;for(let O=0;A<p.length&&O<r.length;O++)if(p[A]===r[O]||p[A]==="*")A++;else if(p[A]!=="**")return!1;return A===p.length}}}e.getLocation=I;function m(n,s=[],r=R.DEFAULT){let t=null,a=[];const o=[];function u(p){Array.isArray(a)?a.push(p):t!==null&&(a[t]=p)}return d(n,{onObjectBegin:()=>{const p={};u(p),o.push(a),a=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const p=[];u(p),o.push(a),a=p,t=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:u,onError:(p,A,O)=>{s.push({error:p,offset:A,length:O})}},r),a[0]}e.parse=m;function E(n,s=[],r=R.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){t.type==="property"&&(t.length=p-t.offset,t=t.parent)}function o(p){return t.children.push(p),p}d(n,{onObjectBegin:p=>{t=o({type:"object",offset:p,length:-1,parent:t,children:[]})},onObjectProperty:(p,A,O)=>{t=o({type:"property",offset:A,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:p,offset:A,length:O,parent:t})},onObjectEnd:(p,A)=>{t.length=p+A-t.offset,t=t.parent,a(p+A)},onArrayBegin:(p,A)=>{t=o({type:"array",offset:p,length:-1,parent:t,children:[]})},onArrayEnd:(p,A)=>{t.length=p+A-t.offset,t=t.parent,a(p+A)},onLiteralValue:(p,A,O)=>{o({type:l(p),offset:A,length:O,parent:t,value:p}),a(A+O)},onSeparator:(p,A,O)=>{t.type==="property"&&(p===":"?t.colonOffset=A:p===","&&a(A))},onError:(p,A,O)=>{s.push({error:p,offset:A,length:O})}},r);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=E;function h(n,s){if(!n)return;let r=n;for(let t of s)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===t){r=o.children[1],a=!0;break}if(!a)return}else{const a=t;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=h;function S(n){if(!n.parent||!n.parent.children)return[];const s=S(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;s.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&s.push(r)}return s}e.getNodePath=S;function g(n){switch(n.type){case"array":return n.children.map(g);case"object":const s=Object.create(null);for(let r of n.children){const t=r.children[1];t&&(s[r.children[0].value]=g(t))}return s;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=g;function v(n,s,r=!1){return s>=n.offset&&s<n.offset+n.length||r&&s===n.offset+n.length}e.contains=v;function y(n,s,r=!1){if(v(n,s,r)){const t=n.children;if(Array.isArray(t))for(let a=0;a<t.length&&t[a].offset<=s;a++){const o=y(t[a],s,r);if(o)return o}return n}}e.findNodeAtOffset=y;function d(n,s,r=R.DEFAULT){const t=k(n,!1);function a(j){return j?()=>j(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(j){return j?Q=>j(Q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=a(s.onObjectBegin),f=o(s.onObjectProperty),p=a(s.onObjectEnd),A=a(s.onArrayBegin),O=a(s.onArrayEnd),M=o(s.onLiteralValue),q=o(s.onSeparator),N=a(s.onComment),L=o(s.onError),$=r&&r.disallowComments,_=r&&r.allowTrailingComma;function F(){for(;;){const j=t.scan();switch(t.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:$||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(j){case 12:case 13:$?V(10):N();break;case 16:V(1);break;case 15:case 14:break;default:return j}}}function V(j,Q=[],Z=[]){if(L(j),Q.length+Z.length>0){let G=t.getToken();for(;G!==17;){if(Q.indexOf(G)!==-1){F();break}else if(Z.indexOf(G)!==-1)break;G=F()}}}function W(j){const Q=t.getTokenValue();return j?M(Q):f(Q),F(),!0}function x(){switch(t.getToken()){case 11:let j=0;try{j=JSON.parse(t.getTokenValue()),typeof j!="number"&&(V(2),j=0)}catch(Q){V(2)}M(j);break;case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return F(),!0}function z(){return t.getToken()!==10?(V(3,[],[2,5]),!1):(W(!1),t.getToken()===6?(q(":"),F(),B()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function K(){u(),F();let j=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(j||V(4,[],[]),q(","),F(),t.getToken()===2&&_)break}else j&&V(6,[],[]);z()||V(4,[],[2,5]),j=!0}return p(),t.getToken()!==2?V(7,[2],[]):F(),!0}function U(){A(),F();let j=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(j||V(4,[],[]),q(","),F(),t.getToken()===4&&_)break}else j&&V(6,[],[]);B()||V(4,[],[4,5]),j=!0}return O(),t.getToken()!==4?V(8,[4],[]):F(),!0}function B(){switch(t.getToken()){case 3:return U();case 1:return K();case 10:return W(!0);default:return x()}}return F(),t.getToken()===17?r.allowEmptyContent?!0:(V(4,[],[]),!1):B()?(t.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=d;function c(n,s){let r=k(n),t=[],a,o=0,u;do switch(u=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:o!==u&&t.push(n.substring(o,u)),s!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(a!==17);return t.join("")}e.stripComments=c;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[49],ne([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function T(w,b,i){let I,m,E,h,S;if(b){for(h=b.offset,S=h+b.length,E=h;E>0&&!C(w,E-1);)E--;let o=S;for(;o<w.length&&!C(w,o);)o++;m=w.substring(E,o),I=R(m,i)}else m=w,I=0,E=0,h=0,S=w.length;const g=k(i,w);let v=!1,y=0,d;i.insertSpaces?d=P(" ",i.tabSize||4):d="	";const c=(0,D.createScanner)(m,!1);let l=!1;function n(){return g+P(d,I+y)}function s(){let o=c.scan();for(v=!1;o===15||o===14;)v=v||o===14,o=c.scan();return l=o===16||c.getTokenError()!==0,o}const r=[];function t(o,u,f){!l&&u<S&&f>h&&w.substring(u,f)!==o&&r.push({offset:u,length:f-u,content:o})}let a=s();if(a!==17){const o=c.getTokenOffset()+E,u=P(d,I);t(u,E,o)}for(;a!==17;){let o=c.getTokenOffset()+c.getTokenLength()+E,u=s(),f="";for(;!v&&(u===12||u===13);){const A=c.getTokenOffset()+E;t(" ",o,A),o=c.getTokenOffset()+c.getTokenLength()+E,f=u===12?n():"",u=s()}if(u===2)a!==1&&(y--,f=n());else if(u===4)a!==3&&(y--,f=n());else{switch(a){case 3:case 1:y++,f=n();break;case 5:case 12:f=n();break;case 13:v?f=n():f=" ";break;case 6:f=" ";break;case 10:if(u===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?f=" ":u!==5&&u!==17&&(l=!0);break;case 16:l=!0;break}v&&(u===12||u===13)&&(f=n())}const p=c.getTokenOffset()+E;t(f,o,p),a=u}return r}e.format=T;function P(w,b){let i="";for(let I=0;I<b;I++)i+=w;return i}function R(w,b){let i=0,I=0;const m=b.tabSize||4;for(;i<w.length;){const E=w.charAt(i);if(E===" ")I++;else if(E==="	")I+=m;else break;i++}return Math.floor(I/m)}function k(w,b){for(let i=0;i<b.length;i++){const I=b.charAt(i);if(I==="\r")return i+1<b.length&&b.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=k;function C(w,b){return`\r
`.indexOf(w.charAt(b))!==-1}e.isEOL=C}),define(te[39],ne([0,1,33,49]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(b,i,I){return R(b,i,void 0,I)}e.removeProperty=P;function R(b,i,I,m,E){const h=i.slice(),S=[],g=(0,D.parseTree)(b,S);let v,y;for(;h.length>0&&(y=h.pop(),v=(0,D.findNodeAtLocation)(g,h),v===void 0&&I!==void 0);)typeof y=="string"?I={[y]:I}:I=[I];if(v)if(v.type==="object"&&typeof y=="string"&&Array.isArray(v.children)){const d=(0,D.findNodeAtLocation)(v,[y]);if(d!==void 0)if(I===void 0){if(!d.parent)throw new Error("Malformed AST");const c=v.children.indexOf(d.parent);let l,n=d.parent.offset+d.parent.length;if(c>0){const s=v.children[c-1];l=s.offset+s.length}else l=v.offset+1,v.children.length>1&&(n=v.children[1].offset);return k(b,{offset:l,length:n-l,content:""},m)}else return k(b,{offset:d.offset,length:d.length,content:JSON.stringify(I)},m);else{if(I===void 0)return[];const c=`${JSON.stringify(y)}: ${JSON.stringify(I)}`,l=E?E(v.children.map(s=>s.children[0].value)):v.children.length;let n;if(l>0){const s=v.children[l-1];n={offset:s.offset+s.length,length:0,content:","+c}}else v.children.length===0?n={offset:v.offset+1,length:0,content:c}:n={offset:v.offset+1,length:0,content:c+","};return k(b,n,m)}}else if(v.type==="array"&&typeof y=="number"&&Array.isArray(v.children))if(I!==void 0){const d=`${JSON.stringify(I)}`;let c;if(v.children.length===0||y===0)c={offset:v.offset+1,length:0,content:v.children.length===0?d:d+","};else{const l=y===-1||y>v.children.length?v.children.length:y,n=v.children[l-1];c={offset:n.offset+n.length,length:0,content:","+d}}return k(b,c,m)}else{const d=y,c=v.children[d];let l;if(v.children.length===1)l={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===d){const n=v.children[d-1],s=n.offset+n.length,r=v.offset+v.length;l={offset:s,length:r-2-s,content:""}}else l={offset:c.offset,length:v.children[d+1].offset-c.offset,content:""};return k(b,l,m)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${v.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return k(b,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(I)},m)}}e.setProperty=R;function k(b,i,I){let m=C(b,i),E=i.offset,h=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;E>0&&!(0,T.isEOL)(m,E-1);)E--;for(;h<m.length&&!(0,T.isEOL)(m,h);)h++}const S=(0,T.format)(m,{offset:E,length:h-E},I);for(let v=S.length-1;v>=0;v--){const y=S[v];m=C(m,y),E=Math.min(E,y.offset),h=Math.max(h,y.offset+y.length),h+=y.content.length-y.length}const g=b.length-(m.length-h)-E;return[{offset:E,length:g,content:m.substring(E,h)}]}e.withFormatting=k;function C(b,i){return b.substring(0,i.offset)+i.content+b.substring(i.offset+i.length)}e.applyEdit=C;function w(b,i){let I=i.slice(0).sort((E,h)=>{const S=E.offset-h.offset;return S===0?E.length-h.length:S}),m=b.length;for(let E=I.length-1;E>=0;E--){let h=I[E];if(h.offset+h.length<=m)b=C(b,h);else throw new Error("Overlapping edit");m=h.offset}return b}e.applyEdits=w}),define(te[2],ne([0,1,68,55]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let R=null;function k(t){R=t}if(e.setDisposableTracker=k,P){const t="__is_disposable_tracked__";k(new class{trackDisposable(a){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[t]||console.log(o)},3e3)}setParent(a,o){if(a&&a!==y.None)try{a[t]=!0}catch{}}markAsDisposed(a){if(a&&a!==y.None)try{a[t]=!0}catch{}}markAsSingleton(a){}})}function C(t){return R?.trackDisposable(t),t}function w(t){R?.markAsDisposed(t)}function b(t,a){R?.setParent(t,a)}function i(t,a){if(!!R)for(const o of t)R.setParent(o,a)}function I(t){return R?.markAsSingleton(t),t}e.markAsSingleton=I;class m extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=m;function E(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=E;function h(t){if(T.Iterable.is(t)){let a=[];for(const o of t)if(o)try{o.dispose()}catch(u){a.push(u)}if(a.length===1)throw a[0];if(a.length>1)throw new m(a);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function S(...t){const a=g(()=>h(t));return i(t,a),a}e.combinedDisposable=S;function g(t){const a=C({dispose:(0,D.once)(()=>{w(a),t()})});return a}e.toDisposable=g;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return b(a,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new v,C(this),b(this._store,this)}dispose(){w(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&b(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&b(a,null),a}}e.MutableDisposable=d;class c{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class l{constructor(){this.references=new Map}acquire(a,...o){let u=this.references.get(a);u||(u={counter:0,object:this.createReferencedObject(a,...o)},this.references.set(a,u));const{object:f}=u,p=(0,D.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(a,u.object),this.references.delete(a))});return u.counter++,{object:f,dispose:p}}}e.ReferenceCollection=l;class n{constructor(a){this.referenceCollection=a}async acquire(a,...o){const u=this.referenceCollection.acquire(a,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(f){throw u.dispose(),f}}}e.AsyncReferenceCollection=n;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function r(t){const a=new v;try{t(a)}finally{a.dispose()}}e.disposeOnReturn=r}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(R){this.element=R,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class T{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let R=this._first;for(;R!==D.Undefined;){const k=R.next;R.prev=D.Undefined,R.next=D.Undefined,R=k}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,k){const C=new D(R);if(this._first===D.Undefined)this._first=C,this._last=C;else if(k){const b=this._last;this._last=C,C.prev=b,b.next=C}else{const b=this._first;this._first=C,C.next=b,b.prev=C}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(C))}}shift(){if(this._first!==D.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==D.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==D.Undefined&&R.next!==D.Undefined){const k=R.prev;k.next=R.next,R.next.prev=k}else R.prev===D.Undefined&&R.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):R.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):R.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==D.Undefined;)yield R.element,R=R.next}}e.LinkedList=T}),function(){function J(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function k(w){R.push(w,Date.now())}function C(){const w=[];for(let b=0;b<R.length;b+=2)w.push({name:R[b],startTime:R[b+1]});return w}return{mark:k,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const k of performance.getEntriesByType("mark"))R.push({name:k.name,startTime:Math.round(P+k.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let T=!1,P=!1,R=!1,k=!1,C=!1,w=!1,b=!1,i,I=D,m,E;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const S=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=S&&h?.sandboxed,typeof navigator=="object"&&!S)E=navigator.userAgent,T=E.indexOf("Windows")>=0,P=E.indexOf("Macintosh")>=0,b=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=E.indexOf("Linux")>=0,w=!0,i=navigator.language,I=i;else if(typeof h=="object"){T=h.platform==="win32",P=h.platform==="darwin",R=h.platform==="linux",k=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,i=D,I=D;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const t=JSON.parse(r),a=t.availableLanguages["*"];i=t.locale,I=a||D,m=t._translationsConfigFile}catch(t){}C=!0}else console.error("Unable to resolve platform.");var g;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function v(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let y=0;P?y=1:T?y=3:R&&(y=2),e.isWindows=T,e.isMacintosh=P,e.isLinux=R,e.isLinuxSnap=k,e.isNative=C,e.isWeb=w,e.isIOS=b,e.platform=y,e.userAgent=E,e.language=I;var d;(function(r){function t(){return e.language}r.value=t;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function o(){return e.language==="en"}r.isDefault=o})(d=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let f=0,p=a.length;f<p;f++){const A=a[f];if(A.id===u.data.vscodeSetImmediateId){a.splice(f,1),A.callback();return}}});let o=0;return u=>{const f=++o;a.push({id:f,callback:u}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return a=>t.then(a)}();var c;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||b?2:T?1:3;let l=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,l=new Uint16Array(r.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const P=D.globals.vscode.process;T={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()},nextTick(R){return(0,D.setImmediate)(R)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:T={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(P){return(0,D.setImmediate)(P)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick,e.arch=T.arch}),define(te[8],ne([0,1,31]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,P=97,R=90,k=122,C=46,w=47,b=92,i=58,I=63;class m extends Error{constructor(c,l,n){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const r=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${r} ${s} of type ${l}`;t+=`. Received type ${typeof n}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function E(d,c){if(typeof d!="string")throw new m(c,"string",d)}function h(d){return d===w||d===b}function S(d){return d===w}function g(d){return d>=T&&d<=R||d>=P&&d<=k}function v(d,c,l,n){let s="",r=0,t=-1,a=0,o=0;for(let u=0;u<=d.length;++u){if(u<d.length)o=d.charCodeAt(u);else{if(n(o))break;o=w}if(n(o)){if(!(t===u-1||a===1))if(a===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==C||s.charCodeAt(s.length-2)!==C){if(s.length>2){const f=s.lastIndexOf(l);f===-1?(s="",r=0):(s=s.slice(0,f),r=s.length-1-s.lastIndexOf(l)),t=u,a=0;continue}else if(s.length!==0){s="",r=0,t=u,a=0;continue}}c&&(s+=s.length>0?`${l}..`:"..",r=2)}else s.length>0?s+=`${l}${d.slice(t+1,u)}`:s=d.slice(t+1,u),r=u-t-1;t=u,a=0}else o===C&&a!==-1?++a:a=-1}return s}function y(d,c){if(c===null||typeof c!="object")throw new m("pathObject","Object",c);const l=c.dir||c.root,n=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${n}`:`${l}${d}${n}`:n}e.win32={resolve(...d){let c="",l="",n=!1;for(let s=d.length-1;s>=-1;s--){let r;if(s>=0){if(r=d[s],E(r,"path"),r.length===0)continue}else c.length===0?r=D.cwd():(r=D.env[`=${c}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===b)&&(r=`${c}\\`));const t=r.length;let a=0,o="",u=!1;const f=r.charCodeAt(0);if(t===1)h(f)&&(a=1,u=!0);else if(h(f))if(u=!0,h(r.charCodeAt(1))){let p=2,A=p;for(;p<t&&!h(r.charCodeAt(p));)p++;if(p<t&&p!==A){const O=r.slice(A,p);for(A=p;p<t&&h(r.charCodeAt(p));)p++;if(p<t&&p!==A){for(A=p;p<t&&!h(r.charCodeAt(p));)p++;(p===t||p!==A)&&(o=`\\\\${O}\\${r.slice(A,p)}`,a=p)}}}else a=1;else g(f)&&r.charCodeAt(1)===i&&(o=r.slice(0,2),a=2,t>2&&h(r.charCodeAt(2))&&(u=!0,a=3));if(o.length>0)if(c.length>0){if(o.toLowerCase()!==c.toLowerCase())continue}else c=o;if(n){if(c.length>0)break}else if(l=`${r.slice(a)}\\${l}`,n=u,u&&c.length>0)break}return l=v(l,!n,"\\",h),n?`${c}\\${l}`:`${c}${l}`||"."},normalize(d){E(d,"path");const c=d.length;if(c===0)return".";let l=0,n,s=!1;const r=d.charCodeAt(0);if(c===1)return S(r)?"\\":d;if(h(r))if(s=!0,h(d.charCodeAt(1))){let a=2,o=a;for(;a<c&&!h(d.charCodeAt(a));)a++;if(a<c&&a!==o){const u=d.slice(o,a);for(o=a;a<c&&h(d.charCodeAt(a));)a++;if(a<c&&a!==o){for(o=a;a<c&&!h(d.charCodeAt(a));)a++;if(a===c)return`\\\\${u}\\${d.slice(o)}\\`;a!==o&&(n=`\\\\${u}\\${d.slice(o,a)}`,l=a)}}}else l=1;else g(r)&&d.charCodeAt(1)===i&&(n=d.slice(0,2),l=2,c>2&&h(d.charCodeAt(2))&&(s=!0,l=3));let t=l<c?v(d.slice(l),!s,"\\",h):"";return t.length===0&&!s&&(t="."),t.length>0&&h(d.charCodeAt(c-1))&&(t+="\\"),n===void 0?s?`\\${t}`:t:s?`${n}\\${t}`:`${n}${t}`},isAbsolute(d){E(d,"path");const c=d.length;if(c===0)return!1;const l=d.charCodeAt(0);return h(l)||c>2&&g(l)&&d.charCodeAt(1)===i&&h(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let c,l;for(let r=0;r<d.length;++r){const t=d[r];E(t,"path"),t.length>0&&(c===void 0?c=l=t:c+=`\\${t}`)}if(c===void 0)return".";let n=!0,s=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++s;const r=l.length;r>1&&h(l.charCodeAt(1))&&(++s,r>2&&(h(l.charCodeAt(2))?++s:n=!1))}if(n){for(;s<c.length&&h(c.charCodeAt(s));)s++;s>=2&&(c=`\\${c.slice(s)}`)}return e.win32.normalize(c)},relative(d,c){if(E(d,"from"),E(c,"to"),d===c)return"";const l=e.win32.resolve(d),n=e.win32.resolve(c);if(l===n||(d=l.toLowerCase(),c=n.toLowerCase(),d===c))return"";let s=0;for(;s<d.length&&d.charCodeAt(s)===b;)s++;let r=d.length;for(;r-1>s&&d.charCodeAt(r-1)===b;)r--;const t=r-s;let a=0;for(;a<c.length&&c.charCodeAt(a)===b;)a++;let o=c.length;for(;o-1>a&&c.charCodeAt(o-1)===b;)o--;const u=o-a,f=t<u?t:u;let p=-1,A=0;for(;A<f;A++){const M=d.charCodeAt(s+A);if(M!==c.charCodeAt(a+A))break;M===b&&(p=A)}if(A!==f){if(p===-1)return n}else{if(u>f){if(c.charCodeAt(a+A)===b)return n.slice(a+A+1);if(A===2)return n.slice(a+A)}t>f&&(d.charCodeAt(s+A)===b?p=A:A===2&&(p=3)),p===-1&&(p=0)}let O="";for(A=s+p+1;A<=r;++A)(A===r||d.charCodeAt(A)===b)&&(O+=O.length===0?"..":"\\..");return a+=p,O.length>0?`${O}${n.slice(a,o)}`:(n.charCodeAt(a)===b&&++a,n.slice(a,o))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const c=e.win32.resolve(d);if(c.length<=2)return d;if(c.charCodeAt(0)===b){if(c.charCodeAt(1)===b){const l=c.charCodeAt(2);if(l!==I&&l!==C)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(g(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===b)return`\\\\?\\${c}`;return d},dirname(d){E(d,"path");const c=d.length;if(c===0)return".";let l=-1,n=0;const s=d.charCodeAt(0);if(c===1)return h(s)?d:".";if(h(s)){if(l=n=1,h(d.charCodeAt(1))){let a=2,o=a;for(;a<c&&!h(d.charCodeAt(a));)a++;if(a<c&&a!==o){for(o=a;a<c&&h(d.charCodeAt(a));)a++;if(a<c&&a!==o){for(o=a;a<c&&!h(d.charCodeAt(a));)a++;if(a===c)return d;a!==o&&(l=n=a+1)}}}}else g(s)&&d.charCodeAt(1)===i&&(l=c>2&&h(d.charCodeAt(2))?3:2,n=l);let r=-1,t=!0;for(let a=c-1;a>=n;--a)if(h(d.charCodeAt(a))){if(!t){r=a;break}}else t=!1;if(r===-1){if(l===-1)return".";r=l}return d.slice(0,r)},basename(d,c){c!==void 0&&E(c,"ext"),E(d,"path");let l=0,n=-1,s=!0,r;if(d.length>=2&&g(d.charCodeAt(0))&&d.charCodeAt(1)===i&&(l=2),c!==void 0&&c.length>0&&c.length<=d.length){if(c===d)return"";let t=c.length-1,a=-1;for(r=d.length-1;r>=l;--r){const o=d.charCodeAt(r);if(h(o)){if(!s){l=r+1;break}}else a===-1&&(s=!1,a=r+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=a))}return l===n?n=a:n===-1&&(n=d.length),d.slice(l,n)}for(r=d.length-1;r>=l;--r)if(h(d.charCodeAt(r))){if(!s){l=r+1;break}}else n===-1&&(s=!1,n=r+1);return n===-1?"":d.slice(l,n)},extname(d){E(d,"path");let c=0,l=-1,n=0,s=-1,r=!0,t=0;d.length>=2&&d.charCodeAt(1)===i&&g(d.charCodeAt(0))&&(c=n=2);for(let a=d.length-1;a>=c;--a){const o=d.charCodeAt(a);if(h(o)){if(!r){n=a+1;break}continue}s===-1&&(r=!1,s=a+1),o===C?l===-1?l=a:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||s===-1||t===0||t===1&&l===s-1&&l===n+1?"":d.slice(l,s)},format:y.bind(null,"\\"),parse(d){E(d,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return c;const l=d.length;let n=0,s=d.charCodeAt(0);if(l===1)return h(s)?(c.root=c.dir=d,c):(c.base=c.name=d,c);if(h(s)){if(n=1,h(d.charCodeAt(1))){let p=2,A=p;for(;p<l&&!h(d.charCodeAt(p));)p++;if(p<l&&p!==A){for(A=p;p<l&&h(d.charCodeAt(p));)p++;if(p<l&&p!==A){for(A=p;p<l&&!h(d.charCodeAt(p));)p++;p===l?n=p:p!==A&&(n=p+1)}}}}else if(g(s)&&d.charCodeAt(1)===i){if(l<=2)return c.root=c.dir=d,c;if(n=2,h(d.charCodeAt(2))){if(l===3)return c.root=c.dir=d,c;n=3}}n>0&&(c.root=d.slice(0,n));let r=-1,t=n,a=-1,o=!0,u=d.length-1,f=0;for(;u>=n;--u){if(s=d.charCodeAt(u),h(s)){if(!o){t=u+1;break}continue}a===-1&&(o=!1,a=u+1),s===C?r===-1?r=u:f!==1&&(f=1):r!==-1&&(f=-1)}return a!==-1&&(r===-1||f===0||f===1&&r===a-1&&r===t+1?c.base=c.name=d.slice(t,a):(c.name=d.slice(t,r),c.base=d.slice(t,a),c.ext=d.slice(r,a))),t>0&&t!==n?c.dir=d.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let c="",l=!1;for(let n=d.length-1;n>=-1&&!l;n--){const s=n>=0?d[n]:D.cwd();E(s,"path"),s.length!==0&&(c=`${s}/${c}`,l=s.charCodeAt(0)===w)}return c=v(c,!l,"/",S),l?`/${c}`:c.length>0?c:"."},normalize(d){if(E(d,"path"),d.length===0)return".";const c=d.charCodeAt(0)===w,l=d.charCodeAt(d.length-1)===w;return d=v(d,!c,"/",S),d.length===0?c?"/":l?"./":".":(l&&(d+="/"),c?`/${d}`:d)},isAbsolute(d){return E(d,"path"),d.length>0&&d.charCodeAt(0)===w},join(...d){if(d.length===0)return".";let c;for(let l=0;l<d.length;++l){const n=d[l];E(n,"path"),n.length>0&&(c===void 0?c=n:c+=`/${n}`)}return c===void 0?".":e.posix.normalize(c)},relative(d,c){if(E(d,"from"),E(c,"to"),d===c||(d=e.posix.resolve(d),c=e.posix.resolve(c),d===c))return"";const l=1,n=d.length,s=n-l,r=1,t=c.length-r,a=s<t?s:t;let o=-1,u=0;for(;u<a;u++){const p=d.charCodeAt(l+u);if(p!==c.charCodeAt(r+u))break;p===w&&(o=u)}if(u===a)if(t>a){if(c.charCodeAt(r+u)===w)return c.slice(r+u+1);if(u===0)return c.slice(r+u)}else s>a&&(d.charCodeAt(l+u)===w?o=u:u===0&&(o=0));let f="";for(u=l+o+1;u<=n;++u)(u===n||d.charCodeAt(u)===w)&&(f+=f.length===0?"..":"/..");return`${f}${c.slice(r+o)}`},toNamespacedPath(d){return d},dirname(d){if(E(d,"path"),d.length===0)return".";const c=d.charCodeAt(0)===w;let l=-1,n=!0;for(let s=d.length-1;s>=1;--s)if(d.charCodeAt(s)===w){if(!n){l=s;break}}else n=!1;return l===-1?c?"/":".":c&&l===1?"//":d.slice(0,l)},basename(d,c){c!==void 0&&E(c,"ext"),E(d,"path");let l=0,n=-1,s=!0,r;if(c!==void 0&&c.length>0&&c.length<=d.length){if(c===d)return"";let t=c.length-1,a=-1;for(r=d.length-1;r>=0;--r){const o=d.charCodeAt(r);if(o===w){if(!s){l=r+1;break}}else a===-1&&(s=!1,a=r+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=a))}return l===n?n=a:n===-1&&(n=d.length),d.slice(l,n)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===w){if(!s){l=r+1;break}}else n===-1&&(s=!1,n=r+1);return n===-1?"":d.slice(l,n)},extname(d){E(d,"path");let c=-1,l=0,n=-1,s=!0,r=0;for(let t=d.length-1;t>=0;--t){const a=d.charCodeAt(t);if(a===w){if(!s){l=t+1;break}continue}n===-1&&(s=!1,n=t+1),a===C?c===-1?c=t:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||n===-1||r===0||r===1&&c===n-1&&c===l+1?"":d.slice(c,n)},format:y.bind(null,"/"),parse(d){E(d,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return c;const l=d.charCodeAt(0)===w;let n;l?(c.root="/",n=1):n=0;let s=-1,r=0,t=-1,a=!0,o=d.length-1,u=0;for(;o>=n;--o){const f=d.charCodeAt(o);if(f===w){if(!a){r=o+1;break}continue}t===-1&&(a=!1,t=o+1),f===C?s===-1?s=o:u!==1&&(u=1):s!==-1&&(u=-1)}if(t!==-1){const f=r===0&&l?1:r;s===-1||u===0||u===1&&s===t-1&&s===r+1?c.base=c.name=d.slice(f,t):(c.name=d.slice(f,s),c.base=d.slice(f,t),c.ext=d.slice(s,t))}return r>0?c.dir=d.slice(0,r-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var T;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(R,...k){const C=k.reduce((i,I)=>(i[I]=!0,i),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(i=>!C[i]).forEach(i=>{for(let I=0;I<w.length;I++)if(i.search(w[I])!==-1){delete R[i];break}})}e.sanitizeProcessEnvironment=P}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:J)[T]=D[T]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function D(T){if(e[T])return e[T].exports;var P=e[T]={i:T,l:!1,exports:{}};return J[T].call(P.exports,P,P.exports,D),P.l=!0,P.exports}return D.m=J,D.c=e,D.d=function(T,P,R){D.o(T,P)||Object.defineProperty(T,P,{enumerable:!0,get:R})},D.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,P){if(1&P&&(T=D(T)),8&P||4&P&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(D.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&P&&typeof T!="string")for(var k in T)D.d(R,k,function(C){return T[C]}.bind(null,k));return R},D.n=function(T){var P=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(P,"a",P),P},D.o=function(T,P){return Object.prototype.hasOwnProperty.call(T,P)},D.p="",D(D.s=0)}([function(J,e,D){(function(T){var P;e=J.exports=Z,P=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],w=e.src=[],b=0,i=b++;w[i]="0|[1-9]\\d*";var I=b++;w[I]="[0-9]+";var m=b++;w[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=b++;w[E]="("+w[i]+")\\.("+w[i]+")\\.("+w[i]+")";var h=b++;w[h]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var S=b++;w[S]="(?:"+w[i]+"|"+w[m]+")";var g=b++;w[g]="(?:"+w[I]+"|"+w[m]+")";var v=b++;w[v]="(?:-("+w[S]+"(?:\\."+w[S]+")*))";var y=b++;w[y]="(?:-?("+w[g]+"(?:\\."+w[g]+")*))";var d=b++;w[d]="[0-9A-Za-z-]+";var c=b++;w[c]="(?:\\+("+w[d]+"(?:\\."+w[d]+")*))";var l=b++,n="v?"+w[E]+w[v]+"?"+w[c]+"?";w[l]="^"+n+"$";var s="[v=\\s]*"+w[h]+w[y]+"?"+w[c]+"?",r=b++;w[r]="^"+s+"$";var t=b++;w[t]="((?:<|>)?=?)";var a=b++;w[a]=w[I]+"|x|X|\\*";var o=b++;w[o]=w[i]+"|x|X|\\*";var u=b++;w[u]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[v]+")?"+w[c]+"?)?)?";var f=b++;w[f]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[y]+")?"+w[c]+"?)?)?";var p=b++;w[p]="^"+w[t]+"\\s*"+w[u]+"$";var A=b++;w[A]="^"+w[t]+"\\s*"+w[f]+"$";var O=b++;w[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=b++;w[M]="(?:~>?)";var q=b++;w[q]="(\\s*)"+w[M]+"\\s+",C[q]=new RegExp(w[q],"g");var N=b++;w[N]="^"+w[M]+w[u]+"$";var L=b++;w[L]="^"+w[M]+w[f]+"$";var $=b++;w[$]="(?:\\^)";var _=b++;w[_]="(\\s*)"+w[$]+"\\s+",C[_]=new RegExp(w[_],"g");var F=b++;w[F]="^"+w[$]+w[u]+"$";var V=b++;w[V]="^"+w[$]+w[f]+"$";var W=b++;w[W]="^"+w[t]+"\\s*("+s+")$|^$";var x=b++;w[x]="^"+w[t]+"\\s*("+n+")$|^$";var z=b++;w[z]="(\\s*)"+w[t]+"\\s*("+s+"|"+w[u]+")",C[z]=new RegExp(w[z],"g");var K=b++;w[K]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var U=b++;w[U]="^\\s*("+w[f]+")\\s+-\\s+("+w[f]+")\\s*$";var B=b++;w[B]="(<|>)?=?\\s*\\*";for(var j=0;j<35;j++)P(j,w[j]),C[j]||(C[j]=new RegExp(w[j]));function Q(ee,ae){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>R||!(ae?C[r]:C[l]).test(ee))return null;try{return new Z(ee,ae)}catch(oe){return null}}function Z(ee,ae){if(ee instanceof Z){if(ee.loose===ae)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Z))return new Z(ee,ae);P("SemVer",ee,ae),this.loose=ae;var oe=ee.trim().match(ae?C[r]:C[l]);if(!oe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var Se=+pe;if(Se>=0&&Se<k)return Se}return pe}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ee,ae){var oe=Q(ee,ae);return oe?oe.version:null},e.clean=function(ee,ae){var oe=Q(ee.trim().replace(/^[=v]+/,""),ae);return oe?oe.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return P("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),H(this.major,ee.major)||H(this.minor,ee.minor)||H(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ae=0;do{var oe=this.prerelease[ae],pe=ee.prerelease[ae];if(P("prerelease compare",ae,oe,pe),oe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(oe===void 0)return-1;if(oe!==pe)return H(oe,pe)}while(++ae)},Z.prototype.inc=function(ee,ae){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ae,oe,pe){typeof oe=="string"&&(pe=oe,oe=void 0);try{return new Z(ee,oe).inc(ae,pe).version}catch(Se){return null}},e.diff=function(ee,ae){if(le(ee,ae))return null;var oe=Q(ee),pe=Q(ae);if(oe.prerelease.length||pe.prerelease.length){for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return"pre"+Se;return"prerelease"}for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return Se},e.compareIdentifiers=H;var G=/^[0-9]+$/;function H(ee,ae){var oe=G.test(ee),pe=G.test(ae);return oe&&pe&&(ee=+ee,ae=+ae),oe&&!pe?-1:pe&&!oe?1:ee<ae?-1:ee>ae?1:0}function re(ee,ae,oe){return new Z(ee,oe).compare(new Z(ae,oe))}function ie(ee,ae,oe){return re(ee,ae,oe)>0}function ce(ee,ae,oe){return re(ee,ae,oe)<0}function le(ee,ae,oe){return re(ee,ae,oe)===0}function de(ee,ae,oe){return re(ee,ae,oe)!==0}function fe(ee,ae,oe){return re(ee,ae,oe)>=0}function be(ee,ae,oe){return re(ee,ae,oe)<=0}function Ce(ee,ae,oe,pe){var Se;switch(ae){case"===":typeof ee=="object"&&(ee=ee.version),typeof oe=="object"&&(oe=oe.version),Se=ee===oe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof oe=="object"&&(oe=oe.version),Se=ee!==oe;break;case"":case"=":case"==":Se=le(ee,oe,pe);break;case"!=":Se=de(ee,oe,pe);break;case">":Se=ie(ee,oe,pe);break;case">=":Se=fe(ee,oe,pe);break;case"<":Se=ce(ee,oe,pe);break;case"<=":Se=be(ee,oe,pe);break;default:throw new TypeError("Invalid operator: "+ae)}return Se}function Ee(ee,ae){if(ee instanceof Ee){if(ee.loose===ae)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,ae);P("comparator",ee,ae),this.loose=ae,this.parse(ee),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(ee,ae){return H(ae,ee)},e.major=function(ee,ae){return new Z(ee,ae).major},e.minor=function(ee,ae){return new Z(ee,ae).minor},e.patch=function(ee,ae){return new Z(ee,ae).patch},e.compare=re,e.compareLoose=function(ee,ae){return re(ee,ae,!0)},e.rcompare=function(ee,ae,oe){return re(ae,ee,oe)},e.sort=function(ee,ae){return ee.sort(function(oe,pe){return e.compare(oe,pe,ae)})},e.rsort=function(ee,ae){return ee.sort(function(oe,pe){return e.rcompare(oe,pe,ae)})},e.gt=ie,e.lt=ce,e.eq=le,e.neq=de,e.gte=fe,e.lte=be,e.cmp=Ce,e.Comparator=Ee;var Ae={};function Pe(ee,ae){if(ee instanceof Pe)return ee.loose===ae?ee:new Pe(ee.raw,ae);if(ee instanceof Ee)return new Pe(ee.value,ae);if(!(this instanceof Pe))return new Pe(ee,ae);if(this.loose=ae,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Le(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,ae,oe,pe,Se,_e,Re,Y,se,ue,ge,me,Ie){return((ae=Le(oe)?"":Le(pe)?">="+oe+".0.0":Le(Se)?">="+oe+"."+pe+".0":">="+ae)+" "+(Y=Le(se)?"":Le(ue)?"<"+(+se+1)+".0.0":Le(ge)?"<"+se+"."+(+ue+1)+".0":me?"<="+se+"."+ue+"."+ge+"-"+me:"<="+Y)).trim()}function Ne(ee,ae){for(var oe=0;oe<ee.length;oe++)if(!ee[oe].test(ae))return!1;if(ae.prerelease.length){for(oe=0;oe<ee.length;oe++)if(P(ee[oe].semver),ee[oe].semver!==Ae&&ee[oe].semver.prerelease.length>0){var pe=ee[oe].semver;if(pe.major===ae.major&&pe.minor===ae.minor&&pe.patch===ae.patch)return!0}return!1}return!0}function $e(ee,ae,oe){try{ae=new Pe(ae,oe)}catch(pe){return!1}return ae.test(ee)}function xe(ee,ae,oe,pe){var Se,_e,Re,Y,se;switch(ee=new Z(ee,pe),ae=new Pe(ae,pe),oe){case">":Se=ie,_e=be,Re=ce,Y=">",se=">=";break;case"<":Se=ce,_e=fe,Re=ie,Y="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ee,ae,pe))return!1;for(var ue=0;ue<ae.set.length;++ue){var ge=ae.set[ue],me=null,Ie=null;if(ge.forEach(function(ke){ke.semver===Ae&&(ke=new Ee(">=0.0.0")),me=me||ke,Ie=Ie||ke,Se(ke.semver,me.semver,pe)?me=ke:Re(ke.semver,Ie.semver,pe)&&(Ie=ke)}),me.operator===Y||me.operator===se||(!Ie.operator||Ie.operator===Y)&&_e(ee,Ie.semver)||Ie.operator===se&&Re(ee,Ie.semver))return!1}return!0}Ee.prototype.parse=function(ee){var ae=this.loose?C[W]:C[x],oe=ee.match(ae);if(!oe)throw new TypeError("Invalid comparator: "+ee);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new Z(oe[2],this.loose):this.semver=Ae},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return P("Comparator.test",ee,this.loose),this.semver===Ae||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ce(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,ae){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Pe(ee.value,ae),$e(this.value,oe,ae);if(ee.operator==="")return oe=new Pe(this.value,ae),$e(ee.semver,oe,ae);var pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),_e=this.semver.version===ee.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Y=Ce(this.semver,"<",ee.semver,ae)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ce(this.semver,">",ee.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return pe||Se||_e&&Re||Y||se},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ee){var ae=this.loose;ee=ee.trim(),P("range",ee,ae);var oe=ae?C[U]:C[K];ee=ee.replace(oe,Fe),P("hyphen replace",ee),ee=ee.replace(C[z],"$1$2$3"),P("comparator trim",ee,C[z]),ee=(ee=(ee=ee.replace(C[q],"$1~")).replace(C[_],"$1^")).split(/\s+/).join(" ");var pe=ae?C[W]:C[x],Se=ee.split(" ").map(function(_e){return function(Re,Y){return P("comp",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ie){P("caret",me,Ie);var ke=Ie?C[V]:C[F];return me.replace(ke,function(Te,ye,we,De,Oe){var Ue;return P("caret",me,Te,ye,we,De,Oe),Le(ye)?Ue="":Le(we)?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":Le(De)?Ue=ye==="0"?">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+".0 <"+(+ye+1)+".0.0":Oe?(P("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=ye==="0"?we==="0"?">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+we+"."+(+De+1):">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+De+Oe+" <"+(+ye+1)+".0.0"):(P("no pr"),Ue=ye==="0"?we==="0"?">="+ye+"."+we+"."+De+" <"+ye+"."+we+"."+(+De+1):">="+ye+"."+we+"."+De+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+De+" <"+(+ye+1)+".0.0"),P("caret return",Ue),Ue})}(ge,ue)}).join(" ")}(Re,Y),P("caret",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ie){var ke=Ie?C[L]:C[N];return me.replace(ke,function(Te,ye,we,De,Oe){var Ue;return P("tilde",me,Te,ye,we,De,Oe),Le(ye)?Ue="":Le(we)?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":Le(De)?Ue=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":Oe?(P("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+(+we+1)+".0"):Ue=">="+ye+"."+we+"."+De+" <"+ye+"."+(+we+1)+".0",P("tilde return",Ue),Ue})}(ge,ue)}).join(" ")}(Re,Y),P("tildes",Re),Re=function(se,ue){return P("replaceXRanges",se,ue),se.split(/\s+/).map(function(ge){return function(me,Ie){me=me.trim();var ke=Ie?C[A]:C[p];return me.replace(ke,function(Te,ye,we,De,Oe,Ue){P("xRange",me,Te,ye,we,De,Oe,Ue);var Qe=Le(we),Ye=Qe||Le(De),We=Ye||Le(Oe);return ye==="="&&We&&(ye=""),Qe?Te=ye===">"||ye==="<"?"<0.0.0":"*":ye&&We?(Ye&&(De=0),We&&(Oe=0),ye===">"?(ye=">=",Ye?(we=+we+1,De=0,Oe=0):We&&(De=+De+1,Oe=0)):ye==="<="&&(ye="<",Ye?we=+we+1:De=+De+1),Te=ye+we+"."+De+"."+Oe):Ye?Te=">="+we+".0.0 <"+(+we+1)+".0.0":We&&(Te=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),P("xRange return",Te),Te})}(ge,ue)}).join(" ")}(Re,Y),P("xrange",Re),Re=function(se,ue){return P("replaceStars",se,ue),se.trim().replace(C[B],"")}(Re,Y),P("stars",Re),Re}(_e,ae)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(_e){return!!_e.match(pe)})),Se=Se.map(function(_e){return new Ee(_e,ae)})},Pe.prototype.intersects=function(ee,ae){if(!(ee instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(pe){return ee.set.some(function(Se){return Se.every(function(_e){return pe.intersects(_e,ae)})})})})},e.toComparators=function(ee,ae){return new Pe(ee,ae).set.map(function(oe){return oe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ne(this.set[ae],ee))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ee,ae,oe){var pe=null,Se=null;try{var _e=new Pe(ae,oe)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&Se.compare(Re)!==-1||(Se=new Z(pe=Re,oe)))}),pe},e.minSatisfying=function(ee,ae,oe){var pe=null,Se=null;try{var _e=new Pe(ae,oe)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&Se.compare(Re)!==1||(Se=new Z(pe=Re,oe)))}),pe},e.validRange=function(ee,ae){try{return new Pe(ee,ae).range||"*"}catch(oe){return null}},e.ltr=function(ee,ae,oe){return xe(ee,ae,"<",oe)},e.gtr=function(ee,ae,oe){return xe(ee,ae,">",oe)},e.outside=xe,e.prerelease=function(ee,ae){var oe=Q(ee,ae);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(ee,ae,oe){return ee=new Pe(ee,oe),ae=new Pe(ae,oe),ee.intersects(ae)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var ae=ee.match(C[O]);return ae==null?null:Q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(J,e){var D,T,P=J.exports={};function R(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function C(g){if(D===setTimeout)return setTimeout(g,0);if((D===R||!D)&&setTimeout)return D=setTimeout,setTimeout(g,0);try{return D(g,0)}catch(v){try{return D.call(null,g,0)}catch(y){return D.call(this,g,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:R}catch(g){D=R}try{T=typeof clearTimeout=="function"?clearTimeout:k}catch(g){T=k}})();var w,b=[],i=!1,I=-1;function m(){i&&w&&(i=!1,w.length?b=w.concat(b):I=-1,b.length&&E())}function E(){if(!i){var g=C(m);i=!0;for(var v=b.length;v;){for(w=b,b=[];++I<v;)w&&w[I].run();I=-1,v=b.length}w=null,i=!1,function(y){if(T===clearTimeout)return clearTimeout(y);if((T===k||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(y);try{T(y)}catch(d){try{return T.call(null,y)}catch(c){return T.call(this,y)}}}(g)}}function h(g,v){this.fun=g,this.array=v}function S(){}P.nextTick=function(g){var v=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)v[y-1]=arguments[y];b.push(new h(g,v)),b.length!==1||i||C(E)},h.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=S,P.addListener=S,P.once=S,P.off=S,P.removeListener=S,P.removeAllListeners=S,P.emit=S,P.prependListener=S,P.prependOnceListener=S,P.listeners=function(g){return[]},P.binding=function(g){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(g){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(te[103],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=D.globals.performance&&typeof D.globals.performance.now=="function";class P{constructor(k){this._highResolution=T&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new P(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=P}),define(te[3],ne([0,1,7,68,2,101,103]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(c){c.None=()=>P.Disposable.None;function l(_){return(F,V=null,W)=>{let x=!1,z;return z=_(K=>{if(!x)return z?z.dispose():x=!0,F.call(V,K)},null,W),x&&z.dispose(),z}}c.once=l;function n(_,F){return u((V,W=null,x)=>_(z=>V.call(W,F(z)),null,x))}c.map=n;function s(_,F){return u((V,W=null,x)=>_(z=>{F(z),V.call(W,z)},null,x))}c.forEach=s;function r(_,F){return u((V,W=null,x)=>_(z=>F(z)&&V.call(W,z),null,x))}c.filter=r;function t(_){return _}c.signal=t;function a(..._){return(F,V=null,W)=>(0,P.combinedDisposable)(..._.map(x=>x(z=>F.call(V,z),null,W)))}c.any=a;function o(_,F,V){let W=V;return n(_,x=>(W=F(W,x),W))}c.reduce=o;function u(_){let F;const V=new m({onFirstListenerAdd(){F=_(V.fire,V)},onLastListenerRemove(){F.dispose()}});return V.event}function f(_,F,V=100,W=!1,x){let z,K,U,B=0;const j=new m({leakWarningThreshold:x,onFirstListenerAdd(){z=_(Q=>{B++,K=F(K,Q),W&&!U&&(j.fire(K),K=void 0),clearTimeout(U),U=setTimeout(()=>{const Z=K;K=void 0,U=void 0,(!W||B>1)&&j.fire(Z),B=0},V)})},onLastListenerRemove(){z.dispose()}});return j.event}c.debounce=f;function p(_,F=(V,W)=>V===W){let V=!0,W;return r(_,x=>{const z=V||!F(x,W);return V=!1,W=x,z})}c.latch=p;function A(_,F){return[c.filter(_,F),c.filter(_,V=>!F(V))]}c.split=A;function O(_,F=!1,V=[]){let W=V.slice(),x=_(U=>{W?W.push(U):K.fire(U)});const z=()=>{W&&W.forEach(U=>K.fire(U)),W=null},K=new m({onFirstListenerAdd(){x||(x=_(U=>K.fire(U)))},onFirstListenerDidAdd(){W&&(F?setTimeout(z):z())},onLastListenerRemove(){x&&x.dispose(),x=null}});return K.event}c.buffer=O;class M{constructor(F){this.event=F}map(F){return new M(n(this.event,F))}forEach(F){return new M(s(this.event,F))}filter(F){return new M(r(this.event,F))}reduce(F,V){return new M(o(this.event,F,V))}latch(){return new M(p(this.event))}debounce(F,V=100,W=!1,x){return new M(f(this.event,F,V,W,x))}on(F,V,W){return this.event(F,V,W)}once(F,V,W){return l(this.event)(F,V,W)}}function q(_){return new M(_)}c.chain=q;function N(_,F,V=W=>W){const W=(...U)=>K.fire(V(...U)),x=()=>_.on(F,W),z=()=>_.removeListener(F,W),K=new m({onFirstListenerAdd:x,onLastListenerRemove:z});return K.event}c.fromNodeEventEmitter=N;function L(_,F,V=W=>W){const W=(...U)=>K.fire(V(...U)),x=()=>_.addEventListener(F,W),z=()=>_.removeEventListener(F,W),K=new m({onFirstListenerAdd:x,onLastListenerRemove:z});return K.event}c.fromDOMEventEmitter=L;function $(_){return new Promise(F=>l(_)(F))}c.toPromise=$})(C=e.Event||(e.Event={}));class w{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${w._idPool++}`}start(l){this._stopWatch=new k.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let b=-1;function i(c){const l=b;return b=c,{dispose(){b=l}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(l,n=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let n=b;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||l<n)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let t,a=0;for(const[o,u]of this._stacks)(!t||a<u)&&(t=o,a=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${a}):`),console.warn(t)}return()=>{const t=this._stacks.get(s)||0;this._stacks.set(s,t-1)}}}class m{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=b>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(l,n,s)=>{this._listeners||(this._listeners=new R.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(n?[l,n]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,n);const a=this._leakageMon?.check(this._listeners.size),o=(0,P.toDisposable)(()=>{a&&a(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof P.DisposableStore?s.add(o):Array.isArray(s)&&s.push(o),o}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,s]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,s):n[0].call(n[1],s)}catch(r){(0,D.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class E extends m{async fireAsync(l,n,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[r,t]=this._asyncDeliveryQueue.shift(),a=[],o={...t,waitUntil:u=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof r=="function"?r:r[0])),a.push(u)}};try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(u){(0,D.onUnexpectedError)(u);continue}Object.freeze(a),await Promise.allSettled(a).then(u=>{for(const f of u)f.status==="rejected"&&(0,D.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=E;class h extends m{constructor(l){super(l);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class S extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=S;class g extends m{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=g;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const n={event:l,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const s=()=>{this.hasListeners&&this.unhook(n);const r=this.events.indexOf(n);this.events.splice(r,1)};return(0,P.toDisposable)((0,T.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(n=>this.emitter.fire(n))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class y{constructor(){this.buffers=[]}wrapEvent(l){return(n,s,r)=>l(t=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>n.call(s,t)):n.call(s,t)},void 0,r)}bufferEvents(l){const n=[];this.buffers.push(n);const s=l();return this.buffers.pop(),n.forEach(r=>r()),s}}e.EventBufferer=y;class d{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=P.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=d}),define(te[27],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(C,w){const b=setTimeout(C.bind(w),0);return{dispose(){clearTimeout(b)}}});var P;(function(C){function w(b){return b===C.None||b===C.Cancelled||b instanceof R?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}C.isCancellationToken=w,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(P=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=P.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=k}),define(te[50],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(I){const m=this._icons.get(I.id);m?I.description?m.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new T;e.iconRegistry=P;function R(i,I){return new C(i,I)}e.registerCodicon=R;function k(i){return i?i.replace(/\$\((.*?)\)/g,(I,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=k;class C{constructor(I,m,E){this.id=I,this.definition=m,this.description=E,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function w(i,I){const m=["codicon","codicon-"+i];return I&&m.push("codicon-modifier-"+I),m}e.getClassNamesArray=w;var b;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function m(S){if(S instanceof C)return["codicon","codicon-"+S.id];const g=I.exec(S.id);if(!g)return m(C.error);let[,v,y]=g;const d=["codicon","codicon-"+v];return y&&d.push("codicon-modifier-"+y.substr(1)),d}i.asClassNameArray=m;function E(S){return m(S).join(" ")}i.asClassName=E;function h(S){return"."+m(S).join(".")}i.asCSSSelector=h})(b=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"})}(C=e.Codicon||(e.Codicon={}))}),define(te[51],ne([0,1,7,2]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(d){const c=d;return c?[c.on,c.pause,c.resume,c.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=P;function R(d){const c=d;return c?P(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=R;function k(d,c){return new C(d,c)}e.newWriteableStream=k;class C{constructor(c,l){this.reducer=c,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(l=>l(c))}emitError(c){this.listeners.error.length===0?(0,D.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(l=>l(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,l){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(c,l){if(this.state.destroyed)return;let n;switch(c){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const s=n.indexOf(l);s>=0&&n.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(d,c){const l=[];let n;for(;(n=d.read())!==null;)l.push(n);return c(l)}e.consumeReadable=w;function b(d,c,l){const n=[];let s;for(;(s=d.read())!==null&&n.length<l;)n.push(s);return s===null&&n.length>0?c(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return d.read()}}}e.peekReadable=b;function i(d,c){return new Promise((l,n)=>{const s=[];I(d,{onData:r=>{c&&s.push(r)},onError:r=>{c?n(r):l(void 0)},onEnd:()=>{l(c?c(s):void 0)}})})}e.consumeStream=i;function I(d,c){d.on("error",l=>c.onError(l)),d.on("end",()=>c.onEnd()),d.on("data",l=>c.onData(l))}e.listenStream=I;function m(d,c){return new Promise((l,n)=>{const s=new T.DisposableStore,r=[],t=u=>{if(r.push(u),r.length>c)return s.dispose(),d.pause(),l({stream:d,buffer:r,ended:!1})},a=u=>n(u),o=()=>l({stream:d,buffer:r,ended:!0});s.add((0,T.toDisposable)(()=>d.removeListener("error",a))),d.on("error",a),s.add((0,T.toDisposable)(()=>d.removeListener("end",o))),d.on("end",o),s.add((0,T.toDisposable)(()=>d.removeListener("data",t))),d.on("data",t)})}e.peekStream=m;function E(d,c){const l=k(c);return l.end(d),l}e.toStream=E;function h(){const d=k(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=h;function S(d){let c=!1;return{read:()=>c?null:(c=!0,d)}}e.toReadable=S;function g(d,c,l){const n=k(l);return I(d,{onData:s=>n.write(c.data(s)),onError:s=>n.error(c.error?c.error(s):s),onEnd:()=>n.end()}),n}e.transform=g;function v(d,c,l){let n=!1;return{read:()=>{const s=c.read();return n?s:(n=!0,s!==null?l([d,s]):d)}}}e.prefixedReadable=v;function y(d,c,l){let n=!1;const s=k(l);return I(c,{onData:r=>n?s.write(r):(n=!0,s.write(l([d,r]))),onError:r=>s.error(r),onEnd:()=>{n||(n=!0,s.write(d)),s.end()}}),s}e.prefixedStream=y}),define(te[19],ne([0,1,51]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined";let P,R;class k{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return T?new k(Buffer.allocUnsafe(t)):new k(new Uint8Array(t))}static wrap(t){return T&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new k(t)}static fromString(t,a){return!(a?.dontUseNodeBuffer||!1)&&T?new k(Buffer.from(t)):(P||(P=new TextEncoder),new k(P.encode(t)))}static concat(t,a){if(typeof a=="undefined"){a=0;for(let f=0,p=t.length;f<p;f++)a+=t[f].byteLength}const o=k.alloc(a);let u=0;for(let f=0,p=t.length;f<p;f++){const A=t[f];o.set(A,u),u+=A.byteLength}return o}toString(){return T?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,a){return new k(this.buffer.subarray(t,a))}set(t,a){t instanceof k?this.buffer.set(t.buffer,a):this.buffer.set(t,a)}readUInt32BE(t){return b(this.buffer,t)}writeUInt32BE(t,a){i(this.buffer,t,a)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,a){m(this.buffer,t,a)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,a){h(this.buffer,t,a)}}e.VSBuffer=k;function C(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0}e.readUInt16LE=C;function w(r,t,a){r[a+0]=t&255,t=t>>>8,r[a+1]=t&255}e.writeUInt16LE=w;function b(r,t){return r[t]*2**24+r[t+1]*2**16+r[t+2]*2**8+r[t+3]}e.readUInt32BE=b;function i(r,t,a){r[a+3]=t,t=t>>>8,r[a+2]=t,t=t>>>8,r[a+1]=t,t=t>>>8,r[a]=t}e.writeUInt32BE=i;function I(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0|r[t+2]<<16>>>0|r[t+3]<<24>>>0}e.readUInt32LE=I;function m(r,t,a){r[a+0]=t&255,t=t>>>8,r[a+1]=t&255,t=t>>>8,r[a+2]=t&255,t=t>>>8,r[a+3]=t&255}e.writeUInt32LE=m;function E(r,t){return r[t]}e.readUInt8=E;function h(r,t,a){r[a]=t}e.writeUInt8=h;function S(r){return D.consumeReadable(r,t=>k.concat(t))}e.readableToBuffer=S;function g(r){return D.toReadable(r)}e.bufferToReadable=g;function v(r){return D.consumeStream(r,t=>k.concat(t))}e.streamToBuffer=v;async function y(r){return r.ended?k.concat(r.buffer):k.concat([...r.buffer,await v(r.stream)])}e.bufferedStreamToBuffer=y;function d(r){return D.toStream(r,t=>k.concat(t))}e.bufferToStream=d;function c(r){return D.transform(r,{data:t=>typeof t=="string"?k.fromString(t):k.wrap(t)},t=>k.concat(t))}e.streamToBufferReadableStream=c;function l(r){return D.newWriteableStream(t=>k.concat(t),r)}e.newWriteableBufferStream=l;function n(r,t){return D.prefixedReadable(r,t,a=>k.concat(a))}e.prefixedBufferReadable=n;function s(r,t){return D.prefixedStream(r,t,a=>k.concat(a))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=D;const T=/{(\d+)}/g;function P(Y,...se){return se.length===0?Y:Y.replace(T,function(ue,ge){const me=parseInt(ge,10);return isNaN(me)||me<0||me>=se.length?ue:se[me]})}e.format=P;const R=/{([^}]+)}/g;function k(Y,se){return Y.replace(R,(ue,ge)=>se[ge]??ue)}e.format2=k;function C(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=C;function w(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function b(Y,se){let ue=0;const ge=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===ge&&ue++;return ue}e.count=b;function i(Y,se,ue="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${ue}`}e.truncate=i;function I(Y,se=" "){const ue=m(Y,se);return E(ue,se)}e.trim=I;function m(Y,se){if(!Y||!se)return Y;const ue=se.length;if(ue===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(se,ge)===ge;)ge=ge+ue;return Y.substring(ge)}e.ltrim=m;function E(Y,se){if(!Y||!se)return Y;const ue=se.length,ge=Y.length;if(ue===0||ge===0)return Y;let me=ge,Ie=-1;for(;Ie=Y.lastIndexOf(se,me-1),!(Ie===-1||Ie+ue!==me);){if(Ie===0)return"";me=Ie}return Y.substring(0,me)}e.rtrim=E;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function S(Y){return Y.replace(/\*/g,"")}e.stripWildcards=S;function g(Y,se,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=w(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return ue.global&&(ge+="g"),ue.matchCase||(ge+="i"),ue.multiline&&(ge+="m"),ue.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=g;function v(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function y(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function d(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=d;function c(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=c;function l(Y){for(let se=0,ue=Y.length;se<ue;se++){const ge=Y.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=l;function n(Y,se=0,ue=Y.length){for(let ge=se;ge<ue;ge++){const me=Y.charCodeAt(ge);if(me!==32&&me!==9)return Y.substring(se,ge)}return Y.substring(se,ue)}e.getLeadingWhitespace=n;function s(Y,se=Y.length-1){for(let ue=se;ue>=0;ue--){const ge=Y.charCodeAt(ue);if(ge!==32&&ge!==9)return ue}return-1}e.lastNonWhitespaceIndex=s;function r(Y,se){return Y<se?-1:Y>se?1:0}e.compare=r;function t(Y,se,ue=0,ge=Y.length,me=0,Ie=se.length){for(;ue<ge&&me<Ie;ue++,me++){let ye=Y.charCodeAt(ue),we=se.charCodeAt(me);if(ye<we)return-1;if(ye>we)return 1}const ke=ge-ue,Te=Ie-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstring=t;function a(Y,se){return o(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=a;function o(Y,se,ue=0,ge=Y.length,me=0,Ie=se.length){for(;ue<ge&&me<Ie;ue++,me++){let ye=Y.charCodeAt(ue),we=se.charCodeAt(me);if(ye===we)continue;if(ye>=128||we>=128)return t(Y.toLowerCase(),se.toLowerCase(),ue,ge,me,Ie);u(ye)&&(ye-=32),u(we)&&(we-=32);const De=ye-we;if(De!==0)return De}const ke=ge-ue,Te=Ie-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstringIgnoreCase=o;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function f(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=f;function p(Y,se){return Y.length===se.length&&o(Y,se)===0}e.equalsIgnoreCase=p;function A(Y,se){const ue=se.length;return se.length>Y.length?!1:o(Y,se,0,ue)===0}e.startsWithIgnoreCase=A;function O(Y,se){let ue,ge=Math.min(Y.length,se.length);for(ue=0;ue<ge;ue++)if(Y.charCodeAt(ue)!==se.charCodeAt(ue))return ue;return ge}e.commonPrefixLength=O;function M(Y,se){let ue,ge=Math.min(Y.length,se.length);const me=Y.length-1,Ie=se.length-1;for(ue=0;ue<ge;ue++)if(Y.charCodeAt(me-ue)!==se.charCodeAt(Ie-ue))return ue;return ge}e.commonSuffixLength=M;function q(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=q;function N(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=N;function L(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=L;function $(Y,se,ue){const ge=Y.charCodeAt(ue);if(q(ge)&&ue+1<se){const me=Y.charCodeAt(ue+1);if(N(me))return L(ge,me)}return ge}e.getNextCodePoint=$;function _(Y,se){const ue=Y.charCodeAt(se-1);if(N(ue)&&se>1){const ge=Y.charCodeAt(se-2);if(q(ge))return L(ge,ue)}return ue}function F(Y,se){const ue=ee.getInstance(),ge=se,me=Y.length,Ie=$(Y,me,se);se+=Ie>=65536?2:1;let ke=ue.getGraphemeBreakType(Ie);for(;se<me;){const Te=$(Y,me,se),ye=ue.getGraphemeBreakType(Te);if($e(ke,ye))break;se+=Te>=65536?2:1,ke=ye}return se-ge}e.nextCharLength=F;function V(Y,se){const ue=ee.getInstance(),ge=se,me=_(Y,se);se-=me>=65536?2:1;let Ie=ue.getGraphemeBreakType(me);for(;se>0;){const ke=_(Y,se),Te=ue.getGraphemeBreakType(ke);if($e(Te,Ie))break;se-=ke>=65536?2:1,Ie=Te}return ge-se}e.prevCharLength=V;function W(Y,se){const ue=ee.getInstance(),ge=Y.length,me=se,Ie=$(Y,ge,se),ke=ue.getGraphemeBreakType(Ie);se+=Ie>=65536?2:1;let Te=ke;for(;se<ge;){const we=$(Y,ge,se),De=ue.getGraphemeBreakType(we);if($e(Te,De))break;se+=we>=65536?2:1,Te=De}const ye=se;for(se=me,Te=ke;se>0;){const we=_(Y,se),De=ue.getGraphemeBreakType(we);if($e(De,Te))break;se-=we>=65536?2:1,Te=De}return[se,ye]}function x(Y,se){return se>0&&N(Y.charCodeAt(se))?W(Y,se-1):W(Y,se)}e.getCharContainingOffset=x;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(Y){return z.test(Y)}e.containsRTL=K;const U=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(Y){return U.test(Y)}e.containsEmoji=B;const j=/^[\t\n\r\x20-\x7E]*$/;function Q(Y){return j.test(Y)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=Z;function G(Y){for(let se=0,ue=Y.length;se<ue;se++)if(H(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=G;function H(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=H;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=re;function ie(Y,se){if(Y.length<se)return Y;const ue=/\b/g;let ge=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<se);)ge=ue.lastIndex,ue.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ce=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,de=/\x1b\[0?m/g;function fe(Y){return Y&&(Y=Y.replace(ce,""),Y=Y.replace(le,""),Y=Y.replace(de,"")),Y}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ce(Y){return be(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ce;function Ee(Y,se){if(!Y||!se||Y.length<se.length)return!1;const ue=se.length,ge=Y.toLowerCase();let me=0,Ie=-1;for(;me<ue;){const ke=ge.indexOf(se[me],Ie+1);if(ke<0)return!1;Ie=ke,me++}return!0}e.fuzzyContains=Ee;function Ae(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ae;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function Le(Y,se=1){if(se===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),se--;while(se>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Le;function Fe(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Fe;function Ne(Y){return ee.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ne;function $e(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=$e;var xe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=ae()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ue=this._data,ge=ue.length/3;let me=1;for(;me<=ge;)if(se<ue[3*me])me=2*me;else if(se>ue[3*me+1])me=2*me+1;else return ue[3*me+2];return 0}}ee._INSTANCE=null;function ae(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function oe(Y,se){if(Y===0)return 0;const ue=pe(Y,se);if(ue!==void 0)return ue;const ge=_(se,Y);return Y-=Se(ge),Y}e.getLeftDeleteOffset=oe;function pe(Y,se){let ue=_(se,Y);for(Y-=Se(ue);_e(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=_(se,Y),Y-=Se(ue)}if(!!re(ue)){if(Y>=0){const ge=_(se,Y);ge===8205&&(Y-=Se(ge))}return Y}}function Se(Y){return Y>=65536?2:1}function _e(Y){return 127995<=Y&&Y<=127999}var Re;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={}))}),define(te[104],ne([0,1,25]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function T(v){return P(v,0)}e.hash=T;function P(v,y){switch(typeof v){case"object":return v===null?R(349,y):Array.isArray(v)?w(v,y):b(v,y);case"string":return C(v,y);case"boolean":return k(v,y);case"number":return R(v,y);case"undefined":return R(937,y);default:return R(617,y)}}e.doHash=P;function R(v,y){return(y<<5)-y+v|0}e.numberHash=R;function k(v,y){return R(v?433:863,y)}function C(v,y){y=R(149417,y);for(let d=0,c=v.length;d<c;d++)y=R(v.charCodeAt(d),y);return y}e.stringHash=C;function w(v,y){return y=R(104579,y),v.reduce((d,c)=>P(c,d),y)}function b(v,y){return y=R(181387,y),Object.keys(v).sort().reduce((d,c)=>(d=C(c,d),P(v[c],d)),y)}class i{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=P(y,this._value),this._value}}e.Hasher=i;var I;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function m(v,y,d=32){const c=d-y,l=~((1<<c)-1);return(v<<y|(l&v)>>>c)>>>0}function E(v,y=0,d=v.byteLength,c=0){for(let l=0;l<d;l++)v[y+l]=c}function h(v,y,d="0"){for(;v.length<y;)v=d+v;return v}function S(v,y=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(d=>d.toString(16).padStart(2,"0")).join(""):h((v>>>0).toString(16),y/4)}e.toHexString=S;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const d=y.length;if(d===0)return;const c=this._buff;let l=this._buffLen,n=this._leftoverHighSurrogate,s,r;for(n!==0?(s=n,r=-1,n=0):(s=y.charCodeAt(0),r=0);;){let t=s;if(D.isHighSurrogate(s))if(r+1<d){const a=y.charCodeAt(r+1);D.isLowSurrogate(a)?(r++,t=D.computeCodePoint(s,a)):t=65533}else{n=s;break}else D.isLowSurrogate(s)&&(t=65533);if(l=this._push(c,l,t),r++,r<d)s=y.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=n}_push(y,d,c){return c<128?y[d++]=c:c<2048?(y[d++]=192|(c&1984)>>>6,y[d++]=128|(c&63)>>>0):c<65536?(y[d++]=224|(c&61440)>>>12,y[d++]=128|(c&4032)>>>6,y[d++]=128|(c&63)>>>0):(y[d++]=240|(c&1835008)>>>18,y[d++]=128|(c&258048)>>>12,y[d++]=128|(c&4032)>>>6,y[d++]=128|(c&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=g._bigBlock32,d=this._buffDV;for(let u=0;u<64;u+=4)y.setUint32(u,d.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)y.setUint32(u,m(y.getUint32(u-12,!1)^y.getUint32(u-32,!1)^y.getUint32(u-56,!1)^y.getUint32(u-64,!1),1),!1);let c=this._h0,l=this._h1,n=this._h2,s=this._h3,r=this._h4,t,a,o;for(let u=0;u<80;u++)u<20?(t=l&n|~l&s,a=1518500249):u<40?(t=l^n^s,a=1859775393):u<60?(t=l&n|l&s|n&s,a=2400959708):(t=l^n^s,a=3395469782),o=m(c,5)+t+r+a+y.getUint32(u*4,!1)&4294967295,r=s,s=n,n=m(l,30),l=c,c=o;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))});var wt=this&&this.__classPrivateFieldSet||function(J,e,D,T,P){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?P.call(J,D):P?P.value=D:e.set(J,D),D},Be=this&&this.__classPrivateFieldGet||function(J,e,D,T){if(D==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?T:D==="a"?T.call(J):T?T.value:e.get(J)};define(te[40],ne([0,1,17,25]),function(J,e,D,T){"use strict";var P,R,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(r,t,a){let o=r.get(t);return o===void 0&&(o=a,r.set(t,o)),o}e.getOrSet=C;function w(r){const t=[];return r.forEach((a,o)=>{t.push(`${o} => ${a}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=w;function b(r){const t=[];return r.forEach(a=>{t.push(a)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=b;class i{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const a=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return a-o}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,T.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class m{constructor(t=!0,a=!0){this._splitOnBackslash=t,this._caseSensitive=a}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,T.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var E;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,T.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(g||(g={}));class v{constructor(t){this._iter=t}static forUris(t=()=>!1){return new v(new h(t))}static forPaths(){return new v(new m)}static forStrings(){return new v(new i)}static forConfigKeys(){return new v(new I)}clear(){this._root=void 0}fill(t,a){if(a){const o=a.slice(0);(0,D.shuffle)(o);for(let u of o)this.set(u,t)}else{const o=t.slice(0);(0,D.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(t,a){const o=this._iter.reset(t);let u;this._root||(this._root=new S,this._root.segment=o.value());const f=[];for(u=this._root;;){const A=o.cmp(u.segment);if(A>0)u.left||(u.left=new S,u.left.segment=o.value()),f.push([-1,u]),u=u.left;else if(A<0)u.right||(u.right=new S,u.right.segment=o.value()),f.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new S,u.mid.segment=o.value()),f.push([0,u]),u=u.mid;else break}const p=u.value;u.value=a,u.key=t;for(let A=f.length-1;A>=0;A--){const O=f[A][1];O.updateHeight();const M=O.balanceFactor();if(M<-1||M>1){const q=f[A][0],N=f[A+1][0];if(q===1&&N===1)f[A][1]=O.rotateLeft();else if(q===-1&&N===-1)f[A][1]=O.rotateRight();else if(q===1&&N===-1)O.right=f[A+1][1]=f[A+1][1].rotateRight(),f[A][1]=O.rotateLeft();else if(q===-1&&N===1)O.left=f[A+1][1]=f[A+1][1].rotateLeft(),f[A][1]=O.rotateRight();else throw new Error;if(A>0)switch(f[A-1][0]){case-1:f[A-1][1].left=f[A][1];break;case 1:f[A-1][1].right=f[A][1];break;case 0:f[A-1][1].mid=f[A][1];break}else this._root=f[0][1]}}return p}get(t){return this._getNode(t)?.value}_getNode(t){const a=this._iter.reset(t);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else break}return o}has(t){const a=this._getNode(t);return!(a?.value===void 0&&a?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,a){const o=this._iter.reset(t),u=[];let f=this._root;for(;f;){const p=o.cmp(f.segment);if(p>0)u.push([-1,f]),f=f.left;else if(p<0)u.push([1,f]),f=f.right;else if(o.hasNext())o.next(),u.push([0,f]),f=f.mid;else break}if(!!f){if(a?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const p=this._min(f.right),{key:A,value:O,segment:M}=p;this._delete(p.key,!1),f.key=A,f.value=O,f.segment=M}else{const p=f.left??f.right;if(u.length>0){const[A,O]=u[u.length-1];switch(A){case-1:O.left=p;break;case 0:O.mid=p;break;case 1:O.right=p;break}}else this._root=p}for(let p=u.length-1;p>=0;p--){const A=u[p][1];A.updateHeight();const O=A.balanceFactor();if(O>1?(A.right.balanceFactor()>=0||(A.right=u[p+1][1]=u[p+1][1].rotateRight()),u[p][1]=A.rotateLeft()):O<-1&&(A.left.balanceFactor()<=0||(A.left=u[p+1][1]=u[p+1][1].rotateLeft()),u[p][1]=A.rotateRight()),p>0)switch(u[p-1][0]){case-1:u[p-1][1].left=u[p][1];break;case 1:u[p-1][1].right=u[p][1];break;case 0:u[p-1][1].mid=u[p][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const a=this._iter.reset(t);let o=this._root,u;for(;o;){const f=a.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(a.hasNext())a.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(t){const a=this._iter.reset(t);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[a,o]of this)t(o,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=a=>{if(!a)return!0;const o=a.balanceFactor();return o<-1||o>1?!1:t(a.left)&&t(a.right)};return t(this._root)}}e.TernarySearchTree=v;class y{constructor(t,a){this.uri=t,this.value=a}}class d{constructor(t,a){this[P]="ResourceMap",t instanceof d?(this.map=new Map(t.map),this.toKey=a??d.defaultToKey):(this.map=new Map,this.toKey=t??d.defaultToKey)}set(t,a){return this.map.set(this.toKey(t),new y(t,a)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,a){typeof a!="undefined"&&(t=t.bind(a));for(let[o,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=d,d.defaultToKey=r=>r.toString();var c;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class l{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,a=0){const o=this._map.get(t);if(!!o)return a!==0&&this.touch(o,a),o.value}set(t,a,o=0){let u=this._map.get(t);if(u)u.value=a,o!==0&&this.touch(u,o);else{switch(u={key:t,value:a,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this._map.get(t);if(!!a)return this._map.delete(t),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,a){const o=this._state;let u=this._head;for(;u;){if(a?t.bind(a)(u.value,u.key,this):t(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.key,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return u}values(){const t=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.value,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return u}entries(){const t=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:[o.key,o.value],done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return u}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this._head,o=this.size;for(;a&&o>t;)this._map.delete(a.key),a=a.next,o--;this._head=a,this._size=o,a&&(a.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const a=t.next,o=t.previous;if(!a||!o)throw new Error("Invalid list");a.previous=o,o.next=a}t.next=void 0,t.previous=void 0,this._state++}touch(t,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this._head)return;const o=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(a===2){if(t===this._tail)return;const o=t.next,u=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((a,o)=>{t.push([o,a])}),t}fromJSON(t){this.clear();for(const[a,o]of t)this.set(a,o)}}e.LinkedMap=l;class n extends l{constructor(t,a=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class s{constructor(t){k.set(this,void 0),wt(this,k,t,"f")}get size(){return Be(this,k,"f").size}forEach(t,a){Be(this,k,"f").forEach(t,a)}get(t){return Be(this,k,"f").get(t)}has(t){return Be(this,k,"f").has(t)}entries(){return Be(this,k,"f").entries()}keys(){return Be(this,k,"f").keys()}values(){return Be(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Be(this,k,"f").entries()}}e.ReadonlyMapView=s}),define(te[69],ne([0,1,40]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const T=new D.LRUCache(1e4);function P(b){return w(b,"NFC",T)}e.normalizeNFC=P;const R=new D.LRUCache(1e4);function k(b){return w(b,"NFD",R)}e.normalizeNFD=k;const C=/[^\u0000-\u0080]/;function w(b,i,I){if(!b)return b;const m=I.get(b);if(m)return m;let E;return C.test(b)?E=b.normalize(i):E=b,I.set(b,E),E}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(i){return k(i).replace(b,"")}}()}),define(te[18],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(f){return Array.isArray(f)}e.isArray=D;function T(f){return typeof f=="string"}e.isString=T;function P(f){return Array.isArray(f)&&f.every(p=>T(p))}e.isStringArray=P;function R(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=R;function k(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=k;function C(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=C;function w(f){return f===!0||f===!1}e.isBoolean=w;function b(f){return typeof f=="undefined"}e.isUndefined=b;function i(f){return!I(f)}e.isDefined=i;function I(f){return b(f)||f===null}e.isUndefinedOrNull=I;function m(f,p){if(!f)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=m;function E(f){if(I(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=E;function h(...f){const p=[];for(let A=0;A<f.length;A++){const O=f[A];if(I(O))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);p.push(O)}return p}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function g(f){if(!R(f))return!1;for(let p in f)if(S.call(f,p))return!1;return!0}e.isEmptyObject=g;function v(f){return typeof f=="function"}e.isFunction=v;function y(...f){return f.length>0&&f.every(v)}e.areFunctions=y;function d(f,p){const A=Math.min(f.length,p.length);for(let O=0;O<A;O++)c(f[O],p[O])}e.validateConstraints=d;function c(f,p){if(T(p)){if(typeof f!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(v(p)){try{if(f instanceof p)return}catch{}if(!I(f)&&f.constructor===p||p.length===1&&p.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(f){let p=[],A=Object.getPrototypeOf(f);for(;Object.prototype!==A;)p=p.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return p}e.getAllPropertyNames=l;function n(f){const p=[];for(const A of l(f))typeof f[A]=="function"&&p.push(A);return p}e.getAllMethodNames=n;function s(f,p){const A=M=>function(){const q=Array.prototype.slice.call(arguments,0);return p(M,q)};let O={};for(const M of f)O[M]=A(M);return O}e.createProxyObject=s;function r(f){return f===null?void 0:f}e.withNullAsUndefined=r;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function a(f){return class{constructor(){return new Proxy({},{get(p,A){if(p[A])return p[A];throw new Error(`Not Implemented: ${f}->${String(A)}`)}})}}}e.NotImplementedProxy=a;function o(f,p="Unreachable"){throw new Error(p)}e.assertNever=o;function u(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=u}),define(te[41],ne([0,1,8,4,25,18]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function C(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=C;function w(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function b(r,t=D.posix.sep){if(!r)return"";const a=r.length,o=r.charCodeAt(0);if(k(o)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let f=3;const p=f;for(;f<a&&!k(r.charCodeAt(f));f++);if(p!==f&&!k(r.charCodeAt(f+1))){for(f+=1;f<a;f++)if(k(r.charCodeAt(f)))return r.slice(0,f+1).replace(/[\\/]/g,t)}}return t}else if(v(o)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(k(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=b;function i(r){if(!T.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let a=2;const o=a;for(;a<r.length&&(t=r.charCodeAt(a),t!==92);a++);return!(o===a||(t=r.charCodeAt(a+1),isNaN(t)||t===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,t=T.isWindows){const a=t?I:m;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||t&&E.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function S(r,t,a){const o=r===t;return!a||o?o:!r||!t?!1:(0,P.equalsIgnoreCase)(r,t)}e.isEqual=S;function g(r,t,a,o=D.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(a){if(!(0,P.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let f=t.length;return t.charAt(t.length-1)===o&&f--,r.charAt(f)===o}return t.charAt(t.length-1)!==o&&(t+=o),r.indexOf(t)===0}e.isEqualOrParent=g;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function y(r,t){return T.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(t,r)),r=(0,D.normalize)(r),T.isWindows?(r=(0,P.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,P.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=y;function d(r){const t=(0,D.normalize)(r);return T.isWindows?r.length>3?!1:c(t)&&(r.length===2||t.charCodeAt(2)===92):t===D.posix.sep}e.isRootOrDriveLetter=d;function c(r){return T.isWindows?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(r){return c(r)?r[0]:void 0}e.getDriveLetter=l;function n(r,t,a){return t.length>r.length?-1:r===t?0:(a&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=n;function s(r){const t=r.split(":");let a,o,u;if(t.forEach(f=>{const p=Number(f);(0,R.isNumber)(p)?o===void 0?o=p:u===void 0&&(u=p):a=a?[a,f].join(":"):f}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,18]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const g=Array.isArray(S)?[]:{};return Object.keys(S).forEach(v=>{S[v]&&typeof S[v]=="object"?g[v]=T(S[v]):g[v]=S[v]}),g}e.deepClone=T;function P(S){if(!S||typeof S!="object")return S;const g=[S];for(;g.length>0;){const v=g.shift();Object.freeze(v);for(const y in v)if(R.call(v,y)){const d=v[y];typeof d=="object"&&!Object.isFrozen(d)&&g.push(d)}}return S}e.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function k(S,g){return C(S,g,new Set)}e.cloneAndChange=k;function C(S,g,v){if((0,D.isUndefinedOrNull)(S))return S;const y=g(S);if(typeof y!="undefined")return y;if((0,D.isArray)(S)){const d=[];for(const c of S)d.push(C(c,g,v));return d}if((0,D.isObject)(S)){if(v.has(S))throw new Error("Cannot clone recursive data-structure");v.add(S);const d={};for(let c in S)R.call(S,c)&&(d[c]=C(S[c],g,v));return v.delete(S),d}return S}function w(S,g,v=!0){return(0,D.isObject)(S)?((0,D.isObject)(g)&&Object.keys(g).forEach(y=>{y in S?v&&((0,D.isObject)(S[y])&&(0,D.isObject)(g[y])?w(S[y],g[y],v):S[y]=g[y]):S[y]=g[y]}),S):g}e.mixin=w;function b(S,g){if(S===g)return!0;if(S==null||g===null||g===void 0||typeof S!=typeof g||typeof S!="object"||Array.isArray(S)!==Array.isArray(g))return!1;let v,y;if(Array.isArray(S)){if(S.length!==g.length)return!1;for(v=0;v<S.length;v++)if(!b(S[v],g[v]))return!1}else{const d=[];for(y in S)d.push(y);d.sort();const c=[];for(y in g)c.push(y);if(c.sort(),!b(d,c))return!1;for(v=0;v<d.length;v++)if(!b(S[d[v]],g[d[v]]))return!1}return!0}e.equals=b;function i(S){const g=new Set;return JSON.stringify(S,(v,y)=>{if((0,D.isObject)(y)||Array.isArray(y)){if(g.has(y))return"[Circular]";g.add(y)}return y})}e.safeStringify=i;function I(S,g,v){const y=g(S);return typeof y=="undefined"?v:y}e.getOrDefault=I;function m(S,g){const v=Object.create(null);return!S||!g||Object.keys(g).forEach(d=>{const c=S[d],l=g[d];b(c,l)||(v[d]=l)}),v}e.distinct=m;function E(S,g){const v=g.toLowerCase(),y=Object.keys(S).find(d=>d.toLowerCase()===v);return y?S[y]:S[g]}e.getCaseInsensitive=E;function h(S,g){const v=Object.create(null);for(const y of Object.keys(S))g(y,S[y])&&(v[y]=S[y]);return v}e.filter=h}),define(te[9],ne([0,1,8,4]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,R=/^\//,k=/^\/\//;function C(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!P.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(r,t){return!r&&!t?"file":r}function b(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const i="",I="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(t,a,o,u,f,p=!1){typeof t=="object"?(this.scheme=t.scheme||i,this.authority=t.authority||i,this.path=t.path||i,this.query=t.query||i,this.fragment=t.fragment||i):(this.scheme=w(t,p),this.authority=a||i,this.path=b(this.scheme,o||i),this.query=u||i,this.fragment=f||i,C(this,p))}static isUri(t){return t instanceof E?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return d(this,!1)}with(t){if(!t)return this;let{scheme:a,authority:o,path:u,query:f,fragment:p}=t;return a===void 0?a=this.scheme:a===null&&(a=i),o===void 0?o=this.authority:o===null&&(o=i),u===void 0?u=this.path:u===null&&(u=i),f===void 0?f=this.query:f===null&&(f=i),p===void 0?p=this.fragment:p===null&&(p=i),a===this.scheme&&o===this.authority&&u===this.path&&f===this.query&&p===this.fragment?this:new S(a,o,u,f,p)}static parse(t,a=!1){const o=m.exec(t);return o?new S(o[2]||i,s(o[4]||i),s(o[5]||i),s(o[7]||i),s(o[9]||i),a):new S(i,i,i,i,i)}static file(t){let a=i;if(T.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const o=t.indexOf(I,2);o===-1?(a=t.substring(2),t=I):(a=t.substring(2,o),t=t.substring(o)||I)}return new S("file",a,t,i,i)}static from(t){const a=new S(t.scheme,t.authority,t.path,t.query,t.fragment);return C(a,!0),a}static joinPath(t,...a){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return T.isWindows&&t.scheme==="file"?o=E.file(D.win32.join(d(t,!0),...a)).path:o=D.posix.join(t.path,...a),t.with({path:o})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof E)return t;{const a=new S(t);return a._formatted=t.external,a._fsPath=t._sep===h?t.fsPath:null,a}}else return t}}e.URI=E;const h=T.isWindows?1:void 0;class S extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,t){let a,o=-1;for(let u=0;u<r.length;u++){const f=r.charCodeAt(u);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a!==void 0&&(a+=r.charAt(u));else{a===void 0&&(a=r.substr(0,u));const p=g[f];p!==void 0?(o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a+=p):o===-1&&(o=u)}}return o!==-1&&(a+=encodeURIComponent(r.substring(o))),a!==void 0?a:r}function y(r){let t;for(let a=0;a<r.length;a++){const o=r.charCodeAt(a);o===35||o===63?(t===void 0&&(t=r.substr(0,a)),t+=g[o]):t!==void 0&&(t+=r[a])}return t!==void 0?t:r}function d(r,t){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,T.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=d;function c(r,t){const a=t?y:v;let o="",{scheme:u,authority:f,path:p,query:A,fragment:O}=r;if(u&&(o+=u,o+=":"),(f||u==="file")&&(o+=I,o+=I),f){let M=f.indexOf("@");if(M!==-1){const q=f.substr(0,M);f=f.substr(M+1),M=q.indexOf(":"),M===-1?o+=a(q,!1):(o+=a(q.substr(0,M),!1),o+=":",o+=a(q.substr(M+1),!1)),o+="@"}f=f.toLowerCase(),M=f.indexOf(":"),M===-1?o+=a(f,!1):(o+=a(f.substr(0,M),!1),o+=f.substr(M))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const M=p.charCodeAt(1);M>=65&&M<=90&&(p=`/${String.fromCharCode(M+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const M=p.charCodeAt(0);M>=65&&M<=90&&(p=`${String.fromCharCode(M+32)}:${p.substr(2)}`)}o+=a(p,!0)}return A&&(o+="?",o+=a(A,!1)),O&&(o+="#",o+=t?O:v(O,!1)),o}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(n)?r.replace(n,t=>l(t)):r}}),define(te[105],ne([0,1,9]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(b){const i=b;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=T;function P(b){const i=[];let I;try{const m=JSON.parse(b.arguments),E=m[m.length-1];E&&E.__$stack&&(m.pop(),I=E.__$stack),i.push(...m)}catch(m){i.push("Unable to log remote console arguments",b.arguments)}return{args:i,stack:I}}e.parse=P;function R(b){if(typeof b!="string")return R(P(b).stack);const i=b;if(i){const I=k(i),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=R;function k(b){if(!b)return b;const i=b.indexOf(`
`);return i===-1?b:b.substring(0,i)}function C(b,i){const{args:I,stack:m}=P(b),E=typeof I[0]=="string"&&I.length===1;let h=k(m);h&&(h=`(${h.trim()})`);let S=[];if(typeof I[0]=="string"?h&&E?S=[`%c[${i}] %c${I[0]} %c${h}`,w("blue"),w(""),w("grey")]:S=[`%c[${i}] %c${I[0]}`,w("blue"),w(""),...I.slice(1)]:S=[`%c[${i}]%`,w("blue"),...I],h&&!E&&S.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,S)}e.log=C;function w(b){return`color: ${b}`}}),define(te[106],ne([0,1,19,25,9]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function R(i){return JSON.stringify(i,w)}e.stringify=R;function k(i){let I=JSON.parse(i);return I=b(I),I}e.parse=k;var C;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function w(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,T.regExpFlags)(I)}:I}function b(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return P.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof D.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let m=0;m<i.length;++m)i[m]=b(i[m],I+1);else for(const m in i)Object.hasOwnProperty.call(i,m)&&(i[m]=b(i[m],I+1))}return i}e.revive=b}),define(te[15],ne([0,1,4,9]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(P=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,b,i){this._hosts[w]=b,this._ports[w]=i}setConnectionToken(w,b){this._connectionTokens[w]=b}rewrite(w){if(this._delegate)return this._delegate(w);const b=w.authority;let i=this._hosts[b];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[b],m=this._connectionTokens[b];let E=`path=${encodeURIComponent(w.path)}`;return typeof m=="string"&&(E+=`&tkn=${encodeURIComponent(m)}`),T.URI.from({scheme:D.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new R;class k{asBrowserUri(w,b){const i=this.toUri(w,b);return i.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===P.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${P.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?i.with({scheme:P.vscodeFileResource,authority:i.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(w,b){const i=this.toUri(w,b);return i.scheme===P.vscodeFileResource?i.with({scheme:P.file,authority:i.authority!==k.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(w,b){return T.URI.isUri(w)?w:T.URI.parse(b.toUrl(w))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(te[16],ne([0,1,41,15,8,4,25,9]),function(J,e,D,T,P,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(E){return(0,C.uriToFsPath)(E,!0)}e.originalFSPath=w;class b{constructor(h){this._ignorePathCasing=h}compare(h,S,g=!1){return h===S?0:(0,k.compare)(this.getComparisonKey(h,g),this.getComparisonKey(S,g))}isEqual(h,S,g=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,g)===this.getComparisonKey(S,g)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,g=!1){if(h.scheme===S.scheme){if(h.scheme===T.Schemas.file)return D.isEqualOrParent(w(h),w(S),this._ignorePathCasing(h))&&h.query===S.query&&(g||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return D.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(g||h.fragment===S.fragment)}return!1}joinPath(h,...S){return C.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return P.posix.basename(h.path)}extname(h){return P.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===T.Schemas.file?S=C.URI.file(P.dirname(w(h))).path:(S=P.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===T.Schemas.file?S=C.URI.file(P.normalize(w(h))).path:S=P.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===T.Schemas.file){const y=P.relative(w(h),w(S));return R.isWindows?D.toSlashes(y):y}let g=h.path||"/",v=S.path||"/";if(this._ignorePathCasing(h)){let y=0;for(const d=Math.min(g.length,v.length);y<d&&!(g.charCodeAt(y)!==v.charCodeAt(y)&&g.charAt(y).toLowerCase()!==v.charAt(y).toLowerCase());y++);g=v.substr(0,y)+g.substr(y)}return P.posix.relative(g,v)}resolvePath(h,S){if(h.scheme===T.Schemas.file){const g=C.URI.file(P.resolve(w(h),S));return h.with({authority:g.authority,path:g.path})}return S=D.toPosixPath(S),h.with({path:P.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||(0,k.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=P.sep){if(h.scheme===T.Schemas.file){const g=w(h);return g.length>D.getRoot(g).length&&g[g.length-1]===S}else{const g=h.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=P.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=P.sep){let g=!1;if(h.scheme===T.Schemas.file){const v=w(h);g=v!==void 0&&v.length===D.getRoot(v).length&&v[v.length-1]===S}else{S="/";const v=h.path;g=v.length===1&&v.charCodeAt(v.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(E=>E.scheme===T.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new b(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(E,h){const S=[];for(let g=0;g<E.length;g++){const v=h(E[g]);E.some((y,d)=>d===g?!1:(0,e.isEqualOrParent)(v,h(y)))||S.push(E[g])}return S}e.distinctParents=i;var I;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function h(S){const g=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(d=>{const[c,l]=d.split(":");c&&l&&g.set(c,l)});const y=S.path.substring(0,S.path.indexOf(";"));return y&&g.set(E.META_DATA_MIME,y),g}E.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function m(E,h,S){if(h){let g=E.path;return g&&g[0]!==P.posix.sep&&(g=P.posix.sep+g),E.with({scheme:S,authority:h,path:g})}return E.with({scheme:S})}e.toLocalResource=m}),define(te[5],ne([0,1,27,7,3,2,16]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(V){return!!V&&typeof V.then=="function"}e.isThenable=C;function w(V){const W=new D.CancellationTokenSource,x=V(W.token),z=new Promise((K,U)=>{const B=W.token.onCancellationRequested(()=>{B.dispose(),W.dispose(),U((0,T.canceled)())});Promise.resolve(x).then(j=>{B.dispose(),W.dispose(),K(j)},j=>{B.dispose(),W.dispose(),U(j)})});return new class{cancel(){W.cancel()}then(K,U){return z.then(K,U)}catch(K){return this.then(void 0,K)}finally(K){return z.finally(K)}}}e.createCancelablePromise=w;function b(V,W,x){return Promise.race([V,new Promise(z=>W.onCancellationRequested(()=>z(x)))])}e.raceCancellation=b;async function i(V){let W=-1;const x=V.map((K,U)=>K.then(B=>(W=U,B))),z=await Promise.race(x);return V.forEach((K,U)=>{U!==W&&K.cancel()}),z}e.raceCancellablePromises=i;function I(V,W,x){let z;const K=setTimeout(()=>{z?.(void 0),x?.()},W);return Promise.race([V.finally(()=>clearTimeout(K)),new Promise(U=>z=U)])}e.raceTimeout=I;function m(V){return new Promise((W,x)=>{const z=V();C(z)?z.then(W,x):W(z)})}e.asPromise=m;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(x,x).then(z)})}return new Promise((x,z)=>{this.queuedPromise.then(x,z)})}return this.activePromise=W(),new Promise((x,z)=>{this.activePromise.then(K=>{this.activePromise=null,x(K)},K=>{this.activePromise=null,z(K)})})}}e.Throttler=E;class h{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=h;class S{constructor(){this.promiseMap=new Map}queue(W,x){const K=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(W)===K&&this.promiseMap.delete(W)});return this.promiseMap.set(W,K),K}}e.SequencerByKey=S;class g{constructor(W){this.defaultDelay=W,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,x=this.defaultDelay){return this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,K)=>{this.doResolve=z,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,T.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=g;class v{constructor(W){this.delayer=new g(W),this.throttler=new E}trigger(W,x){return this.delayer.trigger(()=>this.throttler.queue(W),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class y{constructor(){this._isOpen=!1,this._promise=new Promise((W,x)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class d extends y{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function c(V,W){return W?new Promise((x,z)=>{const K=setTimeout(()=>{U.dispose(),x()},V),U=W.onCancellationRequested(()=>{clearTimeout(K),U.dispose(),z((0,T.canceled)())})}):w(x=>c(V,x))}e.timeout=c;function l(V,W=0){const x=setTimeout(V,W);return(0,R.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=l;function n(V){const W=[];let x=0;const z=V.length;function K(){return x<z?V[x++]():null}function U(B){B!=null&&W.push(B);const j=K();return j?j.then(U):Promise.resolve(W)}return Promise.resolve(null).then(U)}e.sequence=n;function s(V,W=z=>!!z,x=null){let z=0;const K=V.length,U=()=>{if(z>=K)return Promise.resolve(x);const B=V[z++];return Promise.resolve(B()).then(Q=>W(Q)?Promise.resolve(Q):U())};return U()}e.first=s;function r(V,W=z=>!!z,x=null){if(V.length===0)return Promise.resolve(x);let z=V.length;const K=()=>{z=-1;for(const U of V)U.cancel?.()};return new Promise((U,B)=>{for(const j of V)j.then(Q=>{--z>=0&&W(Q)?(K(),U(Q)):z===0&&U(x)}).catch(Q=>{--z>=0&&(K(),B(Q))})})}e.firstParallel=r;class t{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(W){return this._size++,new Promise((x,z)=>{this.outstandingPromises.push({factory:W,c:x,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const x=W.factory();x.then(W.c,W.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class a extends t{constructor(){super(1)}}e.Queue=a;class o{constructor(){this.queues=new Map}queueFor(W,x=k.extUri){const z=x.getComparisonKey(W);let K=this.queues.get(z);return K||(K=new a,P.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete(z)}),this.queues.set(z,K)),K}dispose(){this.queues.forEach(W=>W.dispose()),this.queues.clear()}}e.ResourceQueue=o;class u{constructor(W,x){this._token=-1,typeof W=="function"&&typeof x=="number"&&this.setIfNotSet(W,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},x)}setIfNotSet(W,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},x))}}e.TimeoutTimer=u;class f{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,x){this.cancel(),this._token=setInterval(()=>{W()},x)}}e.IntervalTimer=f;class p{constructor(W,x){this.timeoutToken=-1,this.runner=W,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=p;class A{constructor(W,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class O extends p{constructor(W,x){super(W,x);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class M extends R.Disposable{constructor(W,x,z,K){super();this.maxWorkChunkSize=W,this.maxPendingWork=x,this.throttleDelay=z,this.handler=K,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.maxPendingWork)return!1}else if(this.pending+W.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new p(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{const W=setTimeout(()=>{const z=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0,clearTimeout(W))}}}:e.runWhenIdle=(V,W)=>{const x=requestIdleCallback(V,typeof W=="number"?{timeout:W}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(x))}}}}();class q{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function N(V,W,x){let z;for(let K=0;K<x;K++)try{return await V()}catch(U){z=U,await c(W)}throw z}e.retry=N;class L{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,x,z){return this._pending={taskId:W,cancel:()=>z?.(),promise:x},x.then(()=>this.donePending(W),()=>this.donePending(W)),x}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let x,z;const K=new Promise((U,B)=>{x=U,z=B});this._next={run:W,promise:K,promiseResolve:x,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=L;class ${constructor(W){this.interval=W,this.lastIncrementTime=0,this.value=0}increment(){const W=Date.now();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,x)=>{this.completeCallback=W,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(x=>{this.completeCallback(W),this.resolved=!0,x()})}error(W){return new Promise(x=>{this.errorCallback(W),this.rejected=!0,x()})}cancel(){new Promise(W=>{this.errorCallback((0,T.canceled)()),this.rejected=!0,W()})}}e.DeferredPromise=_;var F;(function(V){async function W(z){let K;const U=await Promise.all(z.map(B=>B.then(j=>j,j=>{K||(K=j)})));if(typeof K!="undefined")throw K;return U}V.settled=W;function x(z){return new Promise(async(K,U)=>{try{await z(K,U)}catch(B){U(B)}})}V.withAsyncBody=x})(F=e.Promises||(e.Promises={}))}),define(te[107],ne([0,1,5,41,40,8,25]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const w="**",b="/",i="[/\\\\]",I="[^/\\\\]",m=/\//g;function E(z){switch(z){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function h(z,K){if(!z)return[];const U=[];let B=!1,j=!1,Q="";for(const Z of z){switch(Z){case K:if(!B&&!j){U.push(Q),Q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":j=!0;break;case"]":j=!1;break}Q+=Z}return Q&&U.push(Q),U}e.splitGlobAware=h;function S(z){if(!z)return"";let K="";const U=h(z,b);if(U.every(B=>B===w))K=".*";else{let B=!1;U.forEach((j,Q)=>{if(j===w){B||(K+=E(2),B=!0);return}let Z=!1,G="",H=!1,re="";for(const ie of j){if(ie!=="}"&&Z){G+=ie;continue}if(H&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===b?ce="":ce=k.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":K+=`(?:${h(G,",").map(de=>S(de)).join("|")})`,Z=!1,G="";break;case"]":K+="["+re+"]",H=!1,re="";break;case"?":K+=I;continue;case"*":K+=E(1);continue;default:K+=k.escapeRegExpCharacters(ie)}}Q<U.length-1&&(U[Q+1]!==w||Q+2<U.length)&&(K+=i),B=!1})}return K}const g=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new P.LRUCache(1e4),s=function(){return!1},r=function(){return null};function t(z,K){if(!z)return r;let U;typeof z!="string"?U=z.pattern:U=z,U=U.trim();const B=`${U}_${!!K.trimForExclusions}`;let j=n.get(B);if(j)return a(j,z);let Q;if(g.test(U)){const Z=U.substr(4);j=function(G,H){return typeof G=="string"&&G.endsWith(Z)?U:null}}else(Q=v.exec(o(U,K)))?j=u(Q[1],U):(K.trimForExclusions?d:y).test(U)?j=f(U,K):(Q=c.exec(o(U,K)))?j=p(Q[1].substr(1),U,!0):(Q=l.exec(o(U,K)))?j=p(Q[1],U,!1):j=A(U);return n.set(B,j),a(j,z)}function a(z,K){return typeof K=="string"?z:function(U,B){return T.isEqualOrParent(U,K.base)?z(R.relative(K.base,U),B):null}}function o(z,K){return K.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function u(z,K){const U=`/${z}`,B=`\\${z}`,j=function(Z,G){return typeof Z!="string"?null:G?G===z?K:null:Z===z||Z.endsWith(U)||Z.endsWith(B)?K:null},Q=[z];return j.basenames=Q,j.patterns=[K],j.allBasenames=Q,j}function f(z,K){const U=x(z.slice(1,-1).split(",").map(G=>t(G,K)).filter(G=>G!==r),z),B=U.length;if(!B)return r;if(B===1)return U[0];const j=function(G,H){for(let re=0,ie=U.length;re<ie;re++)if(U[re](G,H))return z;return null},Q=U.find(G=>!!G.allBasenames);Q&&(j.allBasenames=Q.allBasenames);const Z=U.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(j.allPaths=Z),j}function p(z,K,U){const B=R.sep===R.posix.sep,j=B?z:z.replace(m,R.sep),Q=R.sep+j,Z=R.posix.sep+z,G=U?function(H,re){return typeof H=="string"&&(H===j||H.endsWith(Q)||!B&&(H===z||H.endsWith(Z)))?K:null}:function(H,re){return typeof H=="string"&&(H===j||!B&&H===z)?K:null};return G.allPaths=[(U?"*/":"./")+z],G}function A(z){try{const K=new RegExp(`^${S(z)}$`);return function(U){return K.lastIndex=0,typeof U=="string"&&K.test(U)?z:null}}catch(K){return r}}function O(z,K,U){return!z||typeof K!="string"?!1:M(z)(K,void 0,U)}e.match=O;function M(z,K={}){if(!z)return s;if(typeof z=="string"||$(z)){const U=t(z,K);if(U===r)return s;const B=function(j,Q){return!!U(j,Q)};return U.allBasenames&&(B.allBasenames=U.allBasenames),U.allPaths&&(B.allPaths=U.allPaths),B}return V(z,K)}e.parse=M;function q(z){if(!z)return;let K;return U=>(K||(K=(z()||Promise.resolve([])).then(B=>B?L(B):{})),K.then(B=>!!B[U]))}e.hasSiblingPromiseFn=q;function N(z){if(!z)return;let K;return U=>{if(!K){const B=z();K=B?L(B):{}}return!!K[U]}}e.hasSiblingFn=N;function L(z){const K={};for(const U of z)K[U]=!0;return K}function $(z){const K=z;return K&&typeof K.base=="string"&&typeof K.pattern=="string"}e.isRelativePattern=$;function _(z){return z.allBasenames||[]}e.getBasenameTerms=_;function F(z){return z.allPaths||[]}e.getPathTerms=F;function V(z,K){const U=x(Object.getOwnPropertyNames(z).map(G=>W(G,z[G],K)).filter(G=>G!==r)),B=U.length;if(!B)return r;if(!U.some(G=>!!G.requiresSiblings)){if(B===1)return U[0];const G=function(ie,ce){for(let le=0,de=U.length;le<de;le++){const fe=U[le](ie,ce);if(fe)return fe}return null},H=U.find(ie=>!!ie.allBasenames);H&&(G.allBasenames=H.allBasenames);const re=U.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(G.allPaths=re),G}const j=function(G,H,re){let ie;for(let ce=0,le=U.length;ce<le;ce++){const de=U[ce];de.requiresSiblings&&re&&(H||(H=R.basename(G)),ie||(ie=H.substr(0,H.length-R.extname(G).length)));const fe=de(G,H,ie,re);if(fe)return fe}return null},Q=U.find(G=>!!G.allBasenames);Q&&(j.allBasenames=Q.allBasenames);const Z=U.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(j.allPaths=Z),j}function W(z,K,U){if(K===!1)return r;const B=t(z,U);if(B===r)return r;if(typeof K=="boolean")return B;if(K){const j=K.when;if(typeof j=="string"){const Q=(Z,G,H,re)=>{if(!re||!B(Z,G))return null;const ie=j.replace("$(basename)",H),ce=re(ie);return(0,D.isThenable)(ce)?ce.then(le=>le?z:null):ce?z:null};return Q.requiresSiblings=!0,Q}}return B}function x(z,K){const U=z.filter(G=>!!G.basenames);if(U.length<2)return z;const B=U.reduce((G,H)=>{const re=H.basenames;return re?G.concat(re):G},[]);let j;if(K){j=[];for(let G=0,H=B.length;G<H;G++)j.push(K)}else j=U.reduce((G,H)=>{const re=H.patterns;return re?G.concat(re):G},[]);const Q=function(G,H){if(typeof G!="string")return null;if(!H){let ie;for(ie=G.length;ie>0;ie--){const ce=G.charCodeAt(ie-1);if(ce===47||ce===92)break}H=G.substr(ie)}const re=B.indexOf(H);return re!==-1?j[re]:null};Q.basenames=B,Q.patterns=j,Q.allBasenames=B;const Z=z.filter(G=>!G.basenames);return Z.push(Q),Z}}),define(te[108],ne([0,1,107,15,8,16,25]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(C=e.Mimes||(e.Mimes={}));let w=[],b=[],i=[];function I(t,a=!1){const o=m(t);w.push(o),o.userConfigured?i.push(o):b.push(o),a&&!o.userConfigured&&w.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=I;function m(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,D.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(P.posix.sep)>=0:!1}}function E(t){t?(w=w.filter(a=>!a.userConfigured),i=[]):(w=[],b=[],i=[])}e.clearTextMimes=E;function h(t,a){let o;if(t)switch(t.scheme){case T.Schemas.file:o=t.fsPath;break;case T.Schemas.data:o=R.DataUri.parseMetaData(t).get(R.DataUri.META_DATA_LABEL);break;default:o=t.path}if(!o)return[C.unknown];o=o.toLowerCase();const u=(0,P.basename)(o),f=S(o,u,i);if(f)return[f,C.text];const p=S(o,u,b);if(p)return[p,C.text];if(a){const A=g(a);if(A)return[A,C.text]}return[C.unknown]}e.guessMimeTypes=h;function S(t,a,o){let u=null,f=null,p=null;for(let A=o.length-1;A>=0;A--){const O=o[A];if(a===O.filenameLowercase){u=O;break}if(O.filepattern&&(!f||O.filepattern.length>f.filepattern.length)){const M=O.filepatternOnPath?t:a;O.filepatternLowercase?.(M)&&(f=O)}O.extension&&(!p||O.extension.length>p.extension.length)&&a.endsWith(O.extensionLowercase)&&(p=O)}return u?u.mime:f?f.mime:p?p.mime:null}function g(t){if((0,k.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let a=w.length-1;a>=0;a--){const o=w[a];if(!o.firstline)continue;const u=t.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function v(t){return t?typeof t=="string"?t===C.binary||t===C.text||t===C.unknown:t.length===1&&v(t[0]):!0}e.isUnspecific=v;const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(t){const a=(0,P.extname)(t),o=y[a.toLowerCase()];return o!==void 0?o:l(t)}e.getMediaOrTextMime=c;function l(t){const a=(0,P.extname)(t);return d[a.toLowerCase()]}e.getMediaMime=l;function n(t){for(const a in d)if(d[a]===t)return a}e.getExtensionForMimeType=n;const s=/^(.+)\/(.+?)(;.+)?$/;function r(t,a){const o=s.exec(t);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:a?void 0:t}e.normalizeMimeType=r}),define(te[109],ne([0,1,9]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(i){return i.toJSON()}class P{constructor(I){this._uriTransformer=I}transformIncoming(I){const m=this._uriTransformer.transformIncoming(I);return m===I?I:T(D.URI.from(m))}transformOutgoing(I){const m=this._uriTransformer.transformOutgoing(I);return m===I?I:T(D.URI.from(m))}transformOutgoingURI(I){const m=this._uriTransformer.transformOutgoing(I);return m===I?I:D.URI.from(m)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function R(i,I,m){if(!i||m>200)return null;if(typeof i=="object"){if(i instanceof D.URI)return I.transformOutgoing(i);for(let E in i)if(Object.hasOwnProperty.call(i,E)){const h=R(i[E],I,m+1);h!==null&&(i[E]=h)}}return null}function k(i,I){const m=R(i,I,0);return m===null?i:m}e.transformOutgoingURIs=k;function C(i,I,m,E){if(!i||E>200)return null;if(typeof i=="object"){if(i.$mid===1)return m?D.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const S=C(i[h],I,m,E+1);S!==null&&(i[h]=S)}}return null}function w(i,I){const m=C(i,I,!1,0);return m===null?i:m}e.transformIncomingURIs=w;function b(i,I){const m=C(i,I,!0,0);return m===null?i:m}e.transformAndReviveIncomingURIs=b}),define(te[29],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(w){return D.test(w)}e.isUUID=T;const P=new Uint8Array(16),R=[];for(let w=0;w<256;w++)R.push(w.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(w){for(let b=0;b<w.length;b++)w[b]=Math.floor(Math.random()*256);return w};function C(){k(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let w=0,b="";return b+=R[P[w++]],b+=R[P[w++]],b+=R[P[w++]],b+=R[P[w++]],b+="-",b+=R[P[w++]],b+=R[P[w++]],b+="-",b+=R[P[w++]],b+=R[P[w++]],b+="-",b+=R[P[w++]],b+=R[P[w++]],b+="-",b+=R[P[w++]],b+=R[P[w++]],b+=R[P[w++]],b+=R[P[w++]],b+=R[P[w++]],b+=R[P[w++]],b}e.generateUuid=C}),define(te[110],ne([0,1,111]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class T{constructor(R="utf8"){this.stringDecoder=new D.StringDecoder(R),this.remaining=null}write(R){const k=[],C=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(C.length<1)return k;let w=0,b,i=w;for(;i<C.length;)if(b=C.charCodeAt(i),b===13||b===10){if(k.push(C.substring(w,i)),i++,i<C.length){const I=b;b=C.charCodeAt(i),(I===13&&b===10||I===10&&b===13)&&i++}w=i}else i++;return this.remaining=w<C.length?C.substr(w):null,k}end(){return this.remaining}}e.LineDecoder=T}),define(te[112],ne([0,1,34]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(C){const w=C.replace(/\-/g,":").toLowerCase();return!T.has(w)}function R(){return new Promise(async(C,w)=>{const b=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{C(await k())}catch(i){w(i)}finally{clearTimeout(b)}})}e.getMac=R;function k(){return new Promise((C,w)=>{try{const b=(0,D.networkInterfaces)();for(let i in b){const I=b[i];if(I){for(const{mac:m}of I)if(P(m))return C(m)}}w("Unable to retrieve mac address (unexpected format)")}catch(b){w(b)}})}}),define(te[113],ne([0,1,34,7,40,29,112]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=P.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const m=(0,D.networkInterfaces)();for(let E in m){const h=m[E];if(h)for(const{mac:S,internal:g}of h)g||(I+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let C;async function w(){return C||(C=(async()=>await b()||R.generateUuid())()),C}e.getMachineId=w;async function b(){try{const i=await new Promise((m,E)=>{J(["crypto"],m,E)}),I=await(0,k.getMac)();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){T.onUnexpectedError(i);return}}}),define(te[20],ne([0,1,52,34,241,5,41,69,8,4,16,9,29]),function(J,e,D,T,P,R,k,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(_,F=E.UNLINK){if((0,k.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return F===E.UNLINK?g(_):S(_)}async function S(_){try{const F=(0,w.join)((0,T.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(_,F)}catch(V){return g(_)}g(F).catch(V=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function g(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function v(_){if((0,k.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(_,{recursive:!0})}e.rimrafSync=v;async function y(_,F){return l(await(F?d(_):(0,P.promisify)(D.readdir)(_)))}async function d(_){try{return await(0,P.promisify)(D.readdir)(_,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const F=[],V=await y(_);for(const W of V){let x=!1,z=!1,K=!1;try{const U=await e.Promises.lstat((0,w.join)(_,W));x=U.isFile(),z=U.isDirectory(),K=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}F.push({name:W,isFile:()=>x,isDirectory:()=>z,isSymbolicLink:()=>K})}return F}function c(_){return l(D.readdirSync(_))}e.readdirSync=c;function l(_){return _.map(F=>typeof F=="string"?b.isMacintosh?(0,C.normalizeNFC)(F):F:(F.name=b.isMacintosh?(0,C.normalizeNFC)(F.name):F.name,F))}async function n(_){const F=await y(_),V=[];for(const W of F)await r.existsDirectory((0,w.join)(_,W))&&V.push(W);return V}function s(_,F=1e3){return new Promise(V=>{let W=!1;const x=setInterval(()=>{W||(W=!0,D.access(_,z=>{W=!1,z&&(clearInterval(x),V(void 0))}))},F)})}e.whenDeleted=s;var r;(function(_){async function F(x){let z;try{if(z=await e.Promises.lstat(x),!z.isSymbolicLink())return{stat:z}}catch(K){}try{return{stat:await e.Promises.stat(x),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(b.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw U}throw K}}_.stat=F;async function V(x){try{const{stat:z,symbolicLink:K}=await _.stat(x);return z.isFile()&&K?.dangling!==!0}catch(z){}return!1}_.existsFile=V;async function W(x){try{const{stat:z,symbolicLink:K}=await _.stat(x);return z.isDirectory()&&K?.dangling!==!0}catch(z){}return!1}_.existsDirectory=W})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new R.ResourceQueue;function a(_,F,V){return t.queueFor(I.URI.file(_),i.extUriBiasedIgnorePathCase).queue(()=>{const W=p(V);return new Promise((x,z)=>u(_,F,W,K=>K?z(K):x()))})}let o=!0;function u(_,F,V,W){if(!o)return D.writeFile(_,F,{mode:V.mode,flag:V.flag},W);D.open(_,V.flag,V.mode,(x,z)=>{if(x)return W(x);D.writeFile(z,F,K=>{if(K)return D.close(z,()=>W(K));D.fdatasync(z,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),o=!1),D.close(z,B=>W(B))))})})}function f(_,F,V){const W=p(V);if(!o)return D.writeFileSync(_,F,{mode:W.mode,flag:W.flag});const x=D.openSync(_,W.flag,W.mode);try{D.writeFileSync(x,F);try{D.fdatasyncSync(x)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o=!1}}finally{D.closeSync(x)}}e.writeFileSync=f;function p(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function A(_,F){if(_===F)return;async function V(W){try{const x=await e.Promises.lstat(W);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(W,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(_,F),await V(F)}catch(W){if(_.toLowerCase()!==F.toLowerCase()&&W.code==="EXDEV"||_.endsWith("."))await O(_,F,{preserveSymlinks:!1}),await h(_,E.MOVE),await V(F);else throw W}}async function O(_,F,V){return q(_,F,{root:{source:_,target:F},options:V,handledSourcePaths:new Set})}const M=511;async function q(_,F,V){if(V.handledSourcePaths.has(_))return;V.handledSourcePaths.add(_);const{stat:W,symbolicLink:x}=await r.stat(_);if(x){if(V.options.preserveSymlinks)try{return await $(_,F,V)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(x.dangling)return}return W.isDirectory()?N(_,F,W.mode&M,V):L(_,F,W.mode&M)}async function N(_,F,V,W){await e.Promises.mkdir(F,{recursive:!0,mode:V});const x=await y(_);for(const z of x)await q((0,w.join)(_,z),(0,w.join)(F,z),W)}async function L(_,F,V){await e.Promises.copyFile(_,F),await e.Promises.chmod(F,V)}async function $(_,F,V){let W=await e.Promises.readlink(_);(0,k.isEqualOrParent)(W,V.root.source,!b.isLinux)&&(W=(0,w.join)(V.root.target,W.substr(V.root.source.length+1))),await e.Promises.symlink(W,F)}e.Promises=new class{get access(){return(0,P.promisify)(D.access)}get stat(){return(0,P.promisify)(D.stat)}get lstat(){return(0,P.promisify)(D.lstat)}get utimes(){return(0,P.promisify)(D.utimes)}get read(){return(0,P.promisify)(D.read)}get readFile(){return(0,P.promisify)(D.readFile)}get write(){return(0,P.promisify)(D.write)}get appendFile(){return(0,P.promisify)(D.appendFile)}get fdatasync(){return(0,P.promisify)(D.fdatasync)}get truncate(){return(0,P.promisify)(D.truncate)}get rename(){return(0,P.promisify)(D.rename)}get copyFile(){return(0,P.promisify)(D.copyFile)}get open(){return(0,P.promisify)(D.open)}get close(){return(0,P.promisify)(D.close)}get symlink(){return(0,P.promisify)(D.symlink)}get readlink(){return(0,P.promisify)(D.readlink)}get chmod(){return(0,P.promisify)(D.chmod)}get mkdir(){return(0,P.promisify)(D.mkdir)}get unlink(){return(0,P.promisify)(D.unlink)}get rmdir(){return(0,P.promisify)(D.rmdir)}get realpath(){return(0,P.promisify)(D.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return n}get writeFile(){return a}get rm(){return h}get move(){return A}get copy(){return O}}}),define(te[114],ne([0,1,52,8,25,20]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(i){const I=(0,T.dirname)(i);if(i===I)return i;const m=((0,T.basename)(i)||i).toLowerCase();try{const h=(0,R.readdirSync)(I).filter(S=>S.toLowerCase()===m);if(h.length===1){const S=k(I);if(S)return(0,T.join)(S,h[0])}else if(h.length>1){const S=h.indexOf(m);if(S>=0){const g=k(I);if(g)return(0,T.join)(g,h[S])}}}catch(E){}return null}e.realcaseSync=k;async function C(i){try{return await R.Promises.realpath(i)}catch(I){const m=b(i);return await R.Promises.access(m,D.constants.R_OK),m}}e.realpath=C;function w(i){try{return D.realpathSync(i)}catch(I){const m=b(i);return D.accessSync(m,D.constants.R_OK),m}}e.realpathSync=w;function b(i){return(0,P.rtrim)((0,T.normalize)(i),T.sep)}}),define(te[115],ne([0,1,56]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function T(C,w,b,i=1){let I=!1;return new Promise(m=>{const E=setTimeout(()=>{if(!I)return I=!0,m(0)},b);P(C,w,i,h=>{if(!I)return I=!0,clearTimeout(E),m(h)})})}e.findFreePort=T;function P(C,w,b,i){if(w===0)return i(0);const I=new D.Socket;I.once("connect",()=>(k(I),P(C+b,w-1,b,i))),I.once("data",()=>{}),I.once("error",m=>(k(I),m.code!=="ECONNREFUSED"?P(C+b,w-1,b,i):i(C))),I.connect(C,"127.0.0.1")}function R(C,w,b){let i=!1,I,m=1;const E=D.createServer({pauseOnConnect:!0});function h(S,g){i||(i=!0,E.removeAllListeners(),E.close(),I&&clearTimeout(I),g(S))}return new Promise(S=>{I=setTimeout(()=>{h(0,S)},b),E.on("listening",()=>{h(C,S)}),E.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&m<w?(C++,m++,E.listen(C,"127.0.0.1")):h(0,S)}),E.on("close",()=>{h(0,S)}),E.listen(C,"127.0.0.1")})}e.findFreePortFaster=R;function k(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(w){console.error(w)}}}),define(te[70],ne([0,1,34,8,20]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,k=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var w;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(w||(w={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(l,n,s){this.exePath=l,this.displayName=n,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:c=!1}={}){return c?b===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:c=!1,findPreview:l=!1}={}){const n=m({useAlternateBitness:c});if(!n)return null;const s=T.join(n,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(s))return null;let r=-1,t=null;for(const u of await P.Promises.readdir(s)){let f=-1;if(l){const A=u.indexOf("-");if(A<0)continue;const O=u.substring(0,A);if(!R.test(O)||u.substring(A+1)!=="preview")continue;f=parseInt(O,10)}else{if(!R.test(u))continue;f=parseInt(u,10)}if(f<=r)continue;const p=T.join(s,u,"pwsh.exe");!await P.SymlinkSupport.existsFile(p)||(t=p,r=f)}if(!t)return null;const a=n.includes("x86")?" (x86)":"",o=l?" Preview":"";return new I(t,`PowerShell${o}${a}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const l=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=c?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const r of await P.Promises.readdir(l))if(n.test(r)){const t=T.join(l,r,"pwsh.exe");return new I(t,s)}return null}function S(){const c=T.join(D.homedir(),".dotnet","tools","pwsh.exe");return new I(c,".NET Core PowerShell Global Tool")}function g(){const c=T.join(process.env.windir,b===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(c,"Windows PowerShell",!0)}async function*v(){let c=await E();c&&(yield c),c=await E({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=S(),c&&(yield c),c=await E({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await E({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=g(),c&&(yield c)}async function*y(){for await(const c of v())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=y;async function d(){for await(const c of y())return c;return null}e.getFirstAvailablePowerShellInstallation=d}),define(te[116],ne([0,1,42,15]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(k){return new Promise((C,w)=>{let b;const i=new Map;function I(E,h,S,g,v){const y=i.get(h);if(E===k||y){const d={name:m(S),cmd:S,pid:E,ppid:h,load:g,mem:v};i.set(E,d),E===k&&(b=d),y&&(y.children||(y.children=[]),y.children.push(d),y.children.length>1&&(y.children=y.children.sort((c,l)=>c.pid-l.pid)))}}function m(E){const h=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,g=/--crashes-directory/,v=/\\pipe\\winpty-control/,y=/conhost\.exe/,d=/--type=([a-zA-Z-]+)/;if(S.exec(E))return"watcherService ";if(g.exec(E))return"electron-crash-reporter";if(v.exec(E))return"winpty-process";if(y.exec(E))return"console-window-host (Windows internal process)";let c=d.exec(E);if(c&&c.length===2)return c[1]==="renderer"?h.exec(E)?"shared-process":"window":c[1];const l=/[a-zA-Z-]+\.js/g;let n="";do c=l.exec(E),c&&(n+=c+" ");while(c);return n&&E.indexOf("node ")<0&&E.indexOf("node.exe")<0?`electron_node ${n}`:E}if(process.platform==="win32"){const E=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{J(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(k,S=>{h.getProcessCpuUsage(S,g=>{const v=new Map;g.forEach(y=>{const d=E(y.commandLine||"");v.set(y.pid,{name:m(d),cmd:d,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),b=v.get(k),b?(v.forEach(y=>{const d=v.get(y.ppid);d&&(d.children||(d.children=[]),d.children.push(y))}),v.forEach(y=>{y.children&&(y.children=y.children.sort((d,c)=>d.pid-c.pid))}),C(b)):w(new Error(`Root process ${k} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let E=function(){let h=[b];const S=[];for(;h.length;){const v=h.shift();v&&(S.push(v.pid),v.children&&(h=h.concat(v.children)))}let g=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);g+=" "+S.join(" "),(0,D.exec)(g,{},(v,y,d)=>{if(v||d)w(v||new Error(d.toString()));else{const c=y.toString().split(`
`);for(let l=0;l<S.length;l++){const n=i.get(S[l]);n.load=parseFloat(c[l])}if(!b){w(new Error(`Root process ${k} not found`));return}C(b)}})};(0,D.exec)("which ps",{},(h,S,g)=>{if(h||g)if(process.platform!=="linux")w(h||new Error(g.toString()));else{const v=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,D.exec)(v,{},(y,d,c)=>{y||c?w(y||new Error(c.toString())):(R(d,I),E())})}else{const v=S.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${v} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,c,l)=>{d||l&&!l.includes("screen size is bogus")?w(d||new Error(l.toString())):(R(c,I),process.platform==="linux"?E():b?C(b):w(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=P;function R(k,C){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=k.toString().split(`
`);for(const i of b){const I=w.exec(i.trim());I&&I.length===6&&C(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(te[117],ne([0,1,52,27,41,2,69,8,4,20]),function(J,e,D,T,P,R,k,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(h,S,g){return m({path:h,isDirectory:!1},S,g)}e.watchFile=i;function I(h,S,g){return m({path:h,isDirectory:!0},S,g)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function m(h,S,g){if(w.isMacintosh&&(0,P.isEqualOrParent)(h.path,"/Volumes/"))return g(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const v=(0,C.basename)(h.path),y=new Map;let d=!1,c=[(0,R.toDisposable)(()=>{y.forEach(l=>(0,R.dispose)(l)),y.clear()})];try{const l=(0,D.watch)(h.path);c.push((0,R.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const n=new Set;h.isDirectory&&b.Promises.readdir(h.path).then(s=>s.forEach(r=>n.add(r))),l.on("error",(s,r)=>{d||g(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${r})`)}),l.on("change",(s,r)=>{if(d)return;let t="";if(r&&(t=r.toString(),w.isMacintosh&&(t=(0,k.normalizeNFC)(t))),!t||s!=="change"&&s!=="rename")return;const a=h.isDirectory?(0,C.join)(h.path,t):h.path;if(h.isDirectory)if(s==="rename"){const o=y.get(a);o&&(0,R.dispose)(o);const u=setTimeout(async()=>{y.delete(a);const f=await b.Promises.exists(a);if(d)return;let p;f?n.has(t)?p="changed":(p="added",n.add(t)):(n.delete(t),p="deleted"),S(p,a)},e.CHANGE_BUFFER_DELAY);y.set(a,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let o;n.has(t)?o="changed":(o="added",n.add(t)),S(o,a)}else if(s==="rename"||t!==v){const o=setTimeout(async()=>{const u=await b.Promises.exists(a);d||(u?(S("changed",a),c=[m(h,S,g)]):S("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,R.dispose)(c),c=[(0,R.toDisposable)(()=>clearTimeout(o))]}else S("changed",a)})}catch(l){b.Promises.exists(h.path).then(n=>{n&&!d&&g(`Failed to watch ${h.path} for changes using fs.watch() (${l.toString()})`)})}return(0,R.toDisposable)(()=>{d=!0,c=(0,R.dispose)(c)})}async function E(h,S,g,v=512){const y=await b.Promises.open(h,"r"),d=Buffer.allocUnsafe(v),c=new T.CancellationTokenSource(g);let l,n=!1;const s=i(h,async r=>{if(r==="changed"){if(n)return;n=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:t}=await b.Promises.read(y,d,0,v,null);if(!t||c.token.isCancellationRequested)break;S(d.slice(0,t))}}catch(t){l=new Error(t),c.dispose(!0)}finally{n=!1}}},r=>{l=new Error(r),c.dispose(!0)});return new Promise((r,t)=>{c.token.onCancellationRequested(async()=>{s.dispose(),await b.Promises.close(y),l?t(l):r()})})}e.watchFileContents=E});var he=this&&this.__decorate||function(J,e,D,T){var P=arguments.length,R=P<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(J,e,D,T);else for(var C=J.length-1;C>=0;C--)(k=J[C])&&(R=(P<3?k(R):P>3?k(e,D,R):k(e,D))||R);return P>3&&R&&Object.defineProperty(e,D,R),R};define(te[32],ne([0,1,17,5,19,27,67,7,3,2,106,25,18]),function(J,e,D,T,P,R,k,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function h(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function g(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(v||(v={}));class y{constructor(z){this.buffer=z,this.pos=0}read(z){const K=this.buffer.slice(this.pos,this.pos+z);return this.pos+=K.byteLength,K}}class d{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var c;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(c||(c={}));function l(x){const z=P.VSBuffer.alloc(4);return z.writeUInt32BE(x,0),z}function n(x){return x.read(4).readUInt32BE(0)}function s(x){const z=P.VSBuffer.alloc(1);return z.writeUInt8(x,0),z}const r={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object)},t=typeof Buffer!="undefined";function a(x,z){if(typeof z=="undefined")x.write(r.Undefined);else if(typeof z=="string"){const K=P.VSBuffer.fromString(z);x.write(r.String),x.write(l(K.byteLength)),x.write(K)}else if(t&&Buffer.isBuffer(z)){const K=P.VSBuffer.wrap(z);x.write(r.Buffer),x.write(l(K.byteLength)),x.write(K)}else if(z instanceof P.VSBuffer)x.write(r.VSBuffer),x.write(l(z.byteLength)),x.write(z);else if(Array.isArray(z)){x.write(r.Array),x.write(l(z.length));for(const K of z)a(x,K)}else{const K=P.VSBuffer.fromString(JSON.stringify(z));x.write(r.Object),x.write(l(K.byteLength)),x.write(K)}}function o(x){switch(x.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return x.read(n(x)).toString();case c.Buffer:return x.read(n(x)).buffer;case c.VSBuffer:return x.read(n(x));case c.Array:{const K=n(x),U=[];for(let B=0;B<K;B++)U.push(o(x));return U}case c.Object:return JSON.parse(x.read(n(x)).toString())}}class u{constructor(z,K,U=null,B=1e3){this.protocol=z,this.ctx=K,this.logger=U,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(j=>this.onRawMessage(j)),this.sendResponse({type:200})}registerChannel(z,K){this.channels.set(z,K),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const K=this.send([z.type]);this.logger&&this.logger.logOutgoing(K,0,1,g(z.type));return}case 201:case 202:case 204:case 203:{const K=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(K,z.id,1,g(z.type),z.data);return}}}send(z,K=void 0){const U=new d;return a(U,z),a(U,K),this.sendBuffer(U.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(K){return 0}}onRawMessage(z){const K=new y(z),U=o(K),B=o(K),j=U[0];switch(j){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,U[1],1,`${h(j)}: ${U[2]}.${U[3]}`,B),this.onPromise({type:j,id:U[1],channelName:U[2],name:U[3],arg:B});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,U[1],1,`${h(j)}: ${U[2]}.${U[3]}`,B),this.onEventListen({type:j,id:U[1],channelName:U[2],name:U[3],arg:B});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,U[1],1,`${h(j)}`),this.disposeActiveRequest({type:j,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,U[1],1,`${h(j)}`),this.disposeActiveRequest({type:j,id:U[1]})}}onPromise(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const U=new R.CancellationTokenSource;let B;try{B=K.call(this.ctx,z.name,z.arg,U.token)}catch(Z){B=Promise.reject(Z)}const j=z.id;B.then(Z=>{this.sendResponse({id:j,data:Z,type:201}),this.activeRequests.delete(z.id)},Z=>{Z instanceof Error?this.sendResponse({id:j,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:j,data:Z,type:203}),this.activeRequests.delete(z.id)});const Q=(0,b.toDisposable)(()=>U.cancel());this.activeRequests.set(z.id,Q)}onEventListen(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const U=z.id,j=K.listen(this.ctx,z.name,z.arg)(Q=>this.sendResponse({id:U,data:Q,type:204}));this.activeRequests.set(z.id,j)}disposeActiveRequest(z){const K=this.activeRequests.get(z.id);K&&(K.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let K=this.pendingRequests.get(z.channelName);K||(K=[],this.pendingRequests.set(z.channelName,K));const U=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:z,timeoutTimer:U})}flushPendingRequests(z){const K=this.pendingRequests.get(z);if(K){for(const U of K)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var f;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(z,K=null){this.protocol=z,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=K}getChannel(z){const K=this;return{call(U,B,j){return K.isDisposed?Promise.reject(C.canceled()):K.requestPromise(z,U,B,j)},listen(U,B){return K.isDisposed?Promise.reject(C.canceled()):K.requestEvent(z,U,B)}}}requestPromise(z,K,U,B=R.CancellationToken.None){const j=this.lastRequestId++,Z={id:j,type:100,channelName:z,name:K,arg:U};if(B.isCancellationRequested)return Promise.reject(C.canceled());let G;return new Promise((re,ie)=>{if(B.isCancellationRequested)return ie(C.canceled());const ce=()=>{const be=Ce=>{switch(Ce.type){case 201:this.handlers.delete(j),re(Ce.data);break;case 202:this.handlers.delete(j);const Ee=new Error(Ce.data.message);Ee.stack=Ce.data.stack,Ee.name=Ce.data.name,ie(Ee);break;case 203:this.handlers.delete(j),ie(Ce.data);break}};this.handlers.set(j,be),this.sendRequest(Z)};let le=null;this.state===v.Idle?ce():(le=(0,T.createCancelablePromise)(be=>this.whenInitialized()),le.then(()=>{le=null,ce()}));const de=()=>{le?(le.cancel(),le=null):this.sendRequest({id:j,type:101}),ie(C.canceled())},fe=B.onCancellationRequested(de);G=(0,b.combinedDisposable)((0,b.toDisposable)(de),fe),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(z,K,U){const B=this.lastRequestId++,Q={id:B,type:102,channelName:z,name:K,arg:U};let Z=null;const G=new w.Emitter({onFirstListenerAdd:()=>{Z=(0,T.createCancelablePromise)(re=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(G),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(G),this.sendRequest({id:B,type:103}))}}),H=re=>G.fire(re.data);return this.handlers.set(B,H),G.event}sendRequest(z){switch(z.type){case 100:case 102:{const K=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(K,z.id,0,`${h(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const K=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(K,z.id,0,h(z.type));return}}}send(z,K=void 0){const U=new d;return a(U,z),a(U,K),this.sendBuffer(U.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(K){return 0}}onBuffer(z){const K=new y(z),U=o(K),B=o(K),j=U[0];switch(j){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,g(j)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,U[1],0,g(j),B),this.onResponse({type:U[0],id:U[1],data:B})}}onResponse(z){if(z.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(z.id);K&&K(z)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}he([k.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class A{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:K,onDidClientDisconnect:U})=>{w.Event.once(K.onMessage)(j=>{const Q=new y(j),Z=o(Q),G=new u(K,Z),H=new p(K);this.channels.forEach((ie,ce)=>G.registerChannel(ce,ie));const re={channelServer:G,channelClient:H,ctx:Z};this._connections.add(re),this._onDidAddConnection.fire(re),U(()=>{G.dispose(),H.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const z=[];return this._connections.forEach(K=>z.push(K)),z}getChannel(z,K){const U=this;return{call(B,j,Q){let Z;if((0,m.isFunction)(K)){let H=(0,D.getRandomElement)(U.connections.filter(K));Z=H?Promise.resolve(H):w.Event.toPromise(w.Event.filter(U.onDidAddConnection,K))}else Z=K.routeCall(U,B,j);const G=Z.then(H=>H.channelClient.getChannel(z));return M(G).call(B,j,Q)},listen(B,j){if((0,m.isFunction)(K))return U.getMulticastEvent(z,K,B,j);const Q=K.routeEvent(U,B,j).then(Z=>Z.channelClient.getChannel(z));return M(Q).listen(B,j)}}}getMulticastEvent(z,K,U,B){const j=this;let Q=new b.DisposableStore;const Z=new w.Emitter({onFirstListenerAdd:()=>{Q=new b.DisposableStore;const G=new w.EventMultiplexer,H=new Map,re=ce=>{const de=ce.channelClient.getChannel(z).listen(U,B),fe=G.add(de);H.set(ce,fe)},ie=ce=>{const le=H.get(ce);!le||(le.dispose(),H.delete(ce))};j.connections.filter(K).forEach(re),w.Event.filter(j.onDidAddConnection,K)(re,void 0,Q),j.onDidRemoveConnection(ie,void 0,Q),G.event(Z.fire,Z,Q),Q.add(G)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel(z,K){this.channels.set(z,K),this._connections.forEach(U=>{U.channelServer.registerChannel(z,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(z,K,U=null){const B=new d;a(B,K),z.send(B.buffer),this.channelClient=new p(z,U),this.channelServer=new u(z,K,U)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,K){this.channelServer.registerChannel(z,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function M(x){return{call(z,K,U){return x.then(B=>B.call(z,K,U))},listen(z,K){const U=new w.Relay;return x.then(B=>U.input=B.listen(z,K)),U.event}}}e.getDelayedChannel=M;function q(x){let z=!1;return{call(K,U,B){return z?x.call(K,U,B):(0,T.timeout)(0).then(()=>z=!0).then(()=>x.call(K,U,B))},listen(K,U){if(z)return x.listen(K,U);const B=new w.Relay;return(0,T.timeout)(0).then(()=>z=!0).then(()=>B.input=x.listen(K,U)),B.event}}}e.getNextTickChannel=q;class N{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const K of z.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await w.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=N;var L;(function(x){function z(j,Q){const Z=j,G=Q&&Q.disableMarshalling,H=new Map;for(const re in Z)U(re)&&H.set(re,w.Event.buffer(Z[re],!0));return new class{listen(re,ie,ce){const le=H.get(ie);if(le)return le;if(B(ie)){const de=Z[ie];if(typeof de=="function")return de.call(Z,ce)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ce){const le=Z[ie];if(typeof le=="function"){if(!G&&Array.isArray(ce))for(let de=0;de<ce.length;de++)ce[de]=(0,i.revive)(ce[de]);return le.apply(Z,ce)}throw new Error(`Method not found: ${ie}`)}}}x.fromService=z;function K(j,Q){const Z=Q&&Q.disableMarshalling;return new Proxy({},{get(G,H){if(typeof H=="string")return Q?.properties?.has(H)?Q.properties.get(H):B(H)?function(re){return j.listen(H,re)}:U(H)?j.listen(H):async function(...re){let ie;Q&&!(0,m.isUndefinedOrNull)(Q.context)?ie=[Q.context,...re]:ie=re;const ce=await j.call(H,ie);return Z?ce:(0,i.revive)(ce)};throw new Error(`Property not found: ${String(H)}`)}})}x.toService=K;function U(j){return j[0]==="o"&&j[1]==="n"&&I.isUpperAsciiLetter(j.charCodeAt(2))}function B(j){return/^onDynamic/.test(j)&&I.isUpperAsciiLetter(j.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let z=x.toString();if(z!=="[object Object]")return z}return x}function F(x){return Array.isArray(x)?x.map(_):_(x)}function V(x,z,K,U,B,j,Q){Q=F(Q);const Z=$[B],G=Z[U%Z.length];let H=[`%c[${x}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(j)?(H=H.concat(Q),H.push(")")):H.push(Q),console.log.apply(console,H)}e.logWithColors=V;class W{constructor(z,K){this._outgoingPrefix=z,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,K,U,B,j){this._totalOutgoing+=z,V(this._outgoingPrefix,this._totalOutgoing,z,K,U,B,j)}logIncoming(z,K,U,B,j){this._totalIncoming+=z,V(this._incomingPrefix,this._totalIncoming,z,K,U,B,j)}}e.IPCLogger=W}),define(te[118],ne([0,1,19,3,32]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(w){this.port=w,this.onMessage=T.Event.fromDOMEventEmitter(this.port,"message",b=>D.VSBuffer.wrap(b.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class k extends P.IPCClient{constructor(w,b){const i=new R(w);super(i,b);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=k}),define(te[71],ne([0,1,19,3,2,4,31,32]),function(J,e,D,T,P,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var w;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function i(){return b||(b=D.VSBuffer.alloc(0)),b}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,a){if(t===0)return i();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const p=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=t),p}if(this._chunks[0].byteLength>t){const p=this._chunks[0].slice(0,t);return a&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),p}let o=D.VSBuffer.alloc(t),u=0,f=0;for(;t>0;){const p=this._chunks[f];if(p.byteLength>t){const A=p.slice(0,t);o.set(A,u),u+=t,a&&(this._chunks[f]=p.slice(t),this._totalLength-=t),t-=t}else o.set(p,u),u+=p.byteLength,a?(this._chunks.shift(),this._totalLength-=p.byteLength):f++,t-=p.byteLength}return o}}e.ChunkStream=I;var m;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(m||(m={}));var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,a,o,u){this.type=t,this.id=a,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class S extends P.Disposable{constructor(t){super();this._onMessage=this._register(new T.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const o=this._state.messageType,u=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(o,u,f,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=D.VSBuffer.alloc(13);a.writeUInt8(t.type,0),a.writeUInt32BE(t.id,1),a.writeUInt32BE(t.ack,5),a.writeUInt32BE(t.data.byteLength,9),this._writeSoon(a,t.data)}_bufferAdd(t,a){const o=this._totalLength===0;return this._data.push(t,a),this._totalLength+=t.byteLength+a.byteLength,o}_bufferTake(){const t=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,a){this._bufferAdd(t,a)&&R.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class v extends P.Disposable{constructor(t){super();this._onMessage=new T.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new S(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=v;class y extends C.IPCClient{constructor(t,a,o=null){super(t,a,o);this.protocol=t}static fromSocket(t,a){return new y(new v(t),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=y;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new T.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class c{constructor(t){this.data=t,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],a=0,o=this._first;for(;o;)t[a++]=o.data,o=o.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const a=new c(t);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class n{constructor(){this.lastRuns=[];const t=Date.now();for(let a=0;a<n._HISTORY_LENGTH;a++)this.lastRuns[a]=t-1e3*a;setInterval(()=>{for(let a=n._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const t=Date.now(),a=(1+n._HISTORY_LENGTH)*1e3;let o=0;for(let u=0;u<n._HISTORY_LENGTH;u++)t-this.lastRuns[u]<=a&&o++;return 1-o/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class s{constructor(t,a=null,o=n.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,P.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,i());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const a=new h(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,a){this._isReconnecting=!0,this._socketDisposables=(0,P.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let a=0,o=t.length;a<o;a++)this._socketWriter.write(t[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new h(6,0,0,i())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const a=this._outgoingUnackMsg.toArray();for(let o=0,u=a.length;o<u;o++)this._socketWriter.write(a[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new h(1,a,this._incomingAckId,t);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(t){const a=new h(2,0,0,t);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),a=Date.now()-t.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,i());this._socketWriter.write(t)}}e.PersistentProtocol=s}),define(te[119],ne([0,1,72,3,32,118]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends P.IPCServer{static getOnDidClientConnect(){const w=T.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(b,i)=>i);return T.Event.map(w,b=>{const{port1:i,port2:I}=new MessageChannel,E={protocol:new R.Protocol(i),onDidClientDisconnect:T.Event.fromDOMEventEmitter(i,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[I]),E})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(te[120],ne([0,1,19,7]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function P(C,w){C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((i,I)=>{b.open(C.type||"GET",C.url||"",!0,C.user,C.password),R(b,C),b.responseType="arraybuffer",b.onerror=m=>I(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=m=>{i({res:{statusCode:b.status,headers:k(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=m=>I(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(b.timeout=C.timeout),b.send(C.data),w.onCancellationRequested(()=>{b.abort(),I((0,T.canceled)())})})}e.request=P;function R(C,w){if(w.headers){e:for(let b in w.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(b,w.headers[b])}}}function k(C){const w=Object.create(null);for(const b of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const i=b.indexOf(":");w[b.substr(0,i).trim().toLowerCase()]=b.substr(i+1).trim()}return w}}),define(te[73],ne([0,1,5,3,2,18]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function C(I){const m=I;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var w;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(w||(w={}));class b extends P.Disposable{constructor(m,E=Object.create(null)){super();this.database=m,this.options=E,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((E,h)=>this.accept(h,E)),m.deleted?.forEach(E=>this.accept(E,void 0))}accept(m,E){if(this.state===w.Closed)return;let h=!1;(0,R.isUndefinedOrNull)(E)?h=this.cache.delete(m):this.cache.get(m)!==E&&(this.cache.set(m,E),h=!0),h&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,E){const h=this.cache.get(m);return(0,R.isUndefinedOrNull)(h)?E:h}getBoolean(m,E){const h=this.get(m);return(0,R.isUndefinedOrNull)(h)?E:h==="true"}getNumber(m,E){const h=this.get(m);return(0,R.isUndefinedOrNull)(h)?E:parseInt(h,10)}async set(m,E){if(this.state===w.Closed)return;if((0,R.isUndefinedOrNull)(E))return this.delete(m);const h=String(E);if(this.cache.get(m)!==h)return this.cache.set(m,h),this.pendingInserts.set(m,h),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async delete(m){if(!(this.state===w.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((E,h)=>this.items.set(h,E)),m.delete&&m.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=i}),define(te[121],ne([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[57],ne([0,1,121]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,P=T*60,R=P*24,k=R*7,C=R*30,w=R*365;function b(I,m){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,D.localize)(0,null,b(new Date().getTime()+E*1e3,!1));if(E<30)return(0,D.localize)(1,null);let h;return E<T?(h=E,m?h===1?(0,D.localize)(2,null,h):(0,D.localize)(3,null,h):h===1?(0,D.localize)(4,null,h):(0,D.localize)(5,null,h)):E<P?(h=Math.floor(E/T),m?h===1?(0,D.localize)(6,null,h):(0,D.localize)(7,null,h):h===1?(0,D.localize)(8,null,h):(0,D.localize)(9,null,h)):E<R?(h=Math.floor(E/P),m?h===1?(0,D.localize)(10,null,h):(0,D.localize)(11,null,h):h===1?(0,D.localize)(12,null,h):(0,D.localize)(13,null,h)):E<k?(h=Math.floor(E/R),m?h===1?(0,D.localize)(14,null,h):(0,D.localize)(15,null,h):h===1?(0,D.localize)(16,null,h):(0,D.localize)(17,null,h)):E<C?(h=Math.floor(E/k),m?h===1?(0,D.localize)(18,null,h):(0,D.localize)(19,null,h):h===1?(0,D.localize)(20,null,h):(0,D.localize)(21,null,h)):E<w?(h=Math.floor(E/C),m?h===1?(0,D.localize)(22,null,h):(0,D.localize)(23,null,h):h===1?(0,D.localize)(24,null,h):(0,D.localize)(25,null,h)):(h=Math.floor(E/w),m?h===1?(0,D.localize)(26,null,h):(0,D.localize)(27,null,h):h===1?(0,D.localize)(28,null,h):(0,D.localize)(29,null,h))}e.fromNow=b;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(te[122],ne([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,17,18,122]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(b,i){return i&&(b.stack||b.stacktrace)?P.localize(0,null,C(b),k(b.stack)||k(b.stacktrace)):C(b)}function k(b){return Array.isArray(b)?b.join(`
`):b}function C(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?P.localize(1,null,b.message):b.message||P.localize(2,null)}function w(b=null,i=!1){if(!b)return P.localize(3,null);if(Array.isArray(b)){const I=D.coalesce(b),m=w(I[0],i);return I.length>1?P.localize(4,null,m,I.length):m}if(T.isString(b))return b;if(b.detail){const I=b.detail;if(I.error)return R(I.error,i);if(I.exception)return R(I.exception,i)}return b.stack?R(b,i):b.message?b.message:P.localize(5,null)}e.toErrorMessage=w}),define(te[123],ne([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,42,41,15,26,8,4,31,102,18,110,20,123]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function h(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(n,s){if(C.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};s&&(r.cwd=s);const t=D.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],r);return new Promise(a=>{t.once("error",o=>{a({success:!1,error:o})}),t.once("exit",(o,u)=>{a(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(C.isLinux||C.isMacintosh)try{const r=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{D.execFile(r,[n.pid.toString()],{encoding:"utf8",shell:!0},(a,o,u)=>{t(a?{success:!1,error:a}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function g(n){!n||(delete n.DEBUG,C.isMacintosh&&delete n.DYLD_LIBRARY_PATH,C.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=g;function v(n=w.env){return n.comspec||"cmd.exe"}e.getWindowsShell=v;class y{constructor(s,r,t,a){if(r!==void 0&&t!==void 0&&a!==void 0)this.cmd=s,this.args=r,this.shell=t,this.options=a;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(w.env).forEach(u=>{o[u]=w.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const r=s.lastIndexOf(k.sep);return r!==-1&&(s=s.substring(r+1)),y.WellKnowCommands[s]?s:"other"}start(s){return C.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(w.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(r=>{let t,a;const o=new Promise((u,f)=>{t=u,a=f});if(r){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(f,p,A)=>{this.childProcess=null;const O=f;O&&O.killed?a({killed:this.terminateRequested,stdout:p.toString(),stderr:A.toString()}):this.handleExec(t,s,f,p,A)})}else{let u=null;const f=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,t,s,a);const A={terminated:this.terminateRequested};i.isNumber(p)&&(A.cmdCode=p),t(A)};if(this.shell&&C.isWindows){const p=R.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let A=!1,O=!1;const M=[];let q=this.ensureQuotes(this.cmd);M.push(q.value),A=q.quoted,this.args&&this.args.forEach(L=>{q=this.ensureQuotes(L),M.push(q.value),O=O&&q.quoted});const N=["/s","/c"];A?O?N.push('"'+M.join(" ")+'"'):M.length>1?N.push('"'+M[0]+'" '+M.slice(1).join(" ")):N.push('"'+M[0]+'"'):N.push(M.join(" ")),u=D.spawn(v(),N,p)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(i.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",p=>{this.childProcess=null,a({terminated:this.terminateRequested,error:p})}),u.pid&&(this.childProcess.on("close",f),this.handleSpawn(u,t,s,a,!0)))}return o})}handleClose(s,r,t,a){}ensureQuotes(s){return y.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,S(s,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!C.isWindows)return s(!1);const r=D.spawn(v(),["/s","/c"]);r.on("error",t=>s(!0)),r.on("exit",t=>s(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class d extends y{constructor(s,r,t,a){super(s,r,t,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,r,t,a,o){[a,o].forEach((u,f)=>{const p=new I.LineDecoder;p.write(u).forEach(M=>{r({line:M,source:f===0?0:1})});const O=p.end();O&&r({line:O,source:f===0?0:1})}),s({terminated:this.terminateRequested,error:t})}handleSpawn(s,r,t,a,o){const u=new I.LineDecoder,f=new I.LineDecoder;s.stdout.on("data",p=>{u.write(p).forEach(O=>t({line:O,source:0}))}),s.stderr.on("data",p=>{f.write(p).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=f}handleClose(s,r,t,a){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=d;function c(n){let s=[],r=!1;const t=function(a){if(r){s.push(a);return}(!n.send(a,u=>{if(u&&console.error(u),r=!1,s.length>0){const f=s.slice(0);s=[],f.forEach(p=>t(p))}})||C.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=c;var l;(function(n){async function s(r,t,a){if(k.isAbsolute(r))return r;if(t===void 0&&(t=w.cwd()),k.dirname(r)!=="."||(a===void 0&&i.isString(w.env.PATH)&&(a=w.env.PATH.split(k.delimiter)),a===void 0||a.length===0))return k.join(t,r);async function u(f){if(await m.Promises.exists(f)){let p;try{p=await m.Promises.stat(f)}catch(A){A.message.startsWith("EACCES")&&(p=await m.Promises.lstat(f))}return p?!p.isDirectory():!1}return!1}for(let f of a){let p;if(k.isAbsolute(f)?p=k.join(f,r):p=k.join(t,f,r),await u(p))return p;let A=p+".com";if(await u(A)||(A=p+".exe",await u(A)))return A}return k.join(t,r)}n.findExecutable=s})(l=e.win32||(e.win32={}))}),define(te[124],ne([0,1,34,4,70,74]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(E,h){return E===1?T.isWindows?I():R.getWindowsShell(h):b(E,h)}e.getSystemShell=k;function C(E,h){return E===1?T.isWindows?m(h):R.getWindowsShell(h):b(E,h)}e.getSystemShellSync=C;let w=null;function b(E,h){if(T.isLinux&&E===2||T.isMacintosh&&E===3)return"/bin/bash";if(!w){let S;if(T.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,D.userInfo)().shell}catch(g){}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}w=S}return w}let i=null;async function I(){return i||(i=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),i}function m(E){if(i)return i;const h=T.isWindows&&parseFloat((0,D.release)())>=10,S=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${E.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?g:R.getWindowsShell(E)}}),define(te[44],ne([0,1,42,5,19,27,105,7,3,2,26,74,32]),function(J,e,D,T,P,R,k,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends m.ChannelServer{constructor(g){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(y){}},onMessage:w.Event.fromNodeEventEmitter(process,"message",v=>P.VSBuffer.wrap(Buffer.from(v,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=E;class h{constructor(g,v){this.modulePath=g,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new T.Delayer(y),this.child=null,this._client=null}getChannel(g){const v=this;return{call(y,d,c){return v.requestPromise(g,y,d,c)},listen(y,d){return v.requestEvent(g,y,d)}}}requestPromise(g,v,y,d=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(g),l=(0,T.createCancelablePromise)(r=>c.call(v,y,r)),n=d.onCancellationRequested(()=>l.cancel()),s=(0,b.toDisposable)(()=>l.cancel());return this.activeRequests.add(s),l.finally(()=>{n.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(g,v,y){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let d;const c=new w.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(g).listen(v,y)(c.fire,c),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,I.removeDangerousEnvVariables)(v.env),this.child=(0,D.fork)(this.modulePath,g,v);const y=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,k.isRemoteConsoleLog)(t)){(0,k.log)(t,`IPC Library: ${this.options.serverName}`);return}y.fire(P.VSBuffer.wrap(Buffer.from(t,"base64")))});const c=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&c.send(t.buffer.toString("base64")),n=y.event,s={send:l,onMessage:n};this._client=new m.ChannelClient(s);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,a)=>{process.removeListener("exit",r),this.activeRequests.forEach(o=>(0,b.dispose)(o)),this.activeRequests.clear(),t!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:a})})}return this._client}getCachedChannel(g){let v=this.channels.get(g);return v||(v=this.client.getChannel(g),this.channels.set(g,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[125],ne([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[126],ne([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[127],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[128],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[129],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[130],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[131],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[132],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[133],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[134],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[135],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[136],ne([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[137],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[138],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[139],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[140],ne([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[141],ne([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[142],ne([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[143],ne([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[144],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[145],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[146],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[147],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[148],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[149],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[75],ne([0,1,57,67,15,8,31,16,9]),function(J,e,D,T,P,R,k,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(S,g,v){this._args=S,this.paths=g,this.productService=v}get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("",J).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(w.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return w.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return w.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=k.env.VSCODE_PORTABLE;return S?w.URI.file((0,R.join)(S,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,R.resolve)(S):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,R.resolve)(S):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,R.resolve)(S);const g=k.env.VSCODE_EXTENSIONS;if(g)return g;const v=k.env.VSCODE_PORTABLE;return v?(0,R.join)(v,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(g=>/^[^:/?#]+?:\/\//.test(g)?w.URI.parse(g):w.URI.file((0,R.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?w.URI.parse(S):w.URI.file((0,R.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return w.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([T.memoize],b.prototype,"appRoot",null),he([T.memoize],b.prototype,"userHome",null),he([T.memoize],b.prototype,"userDataPath",null),he([T.memoize],b.prototype,"appSettingsHome",null),he([T.memoize],b.prototype,"tmpDir",null),he([T.memoize],b.prototype,"userRoamingDataHome",null),he([T.memoize],b.prototype,"settingsResource",null),he([T.memoize],b.prototype,"userDataSyncHome",null),he([T.memoize],b.prototype,"userDataSyncLogResource",null),he([T.memoize],b.prototype,"sync",null),he([T.memoize],b.prototype,"machineSettingsResource",null),he([T.memoize],b.prototype,"globalStorageHome",null),he([T.memoize],b.prototype,"workspaceStorageHome",null),he([T.memoize],b.prototype,"keybindingsResource",null),he([T.memoize],b.prototype,"keyboardLayoutResource",null),he([T.memoize],b.prototype,"argvResource",null),he([T.memoize],b.prototype,"snippetsHome",null),he([T.memoize],b.prototype,"isExtensionDevelopment",null),he([T.memoize],b.prototype,"untitledWorkspacesHome",null),he([T.memoize],b.prototype,"installSourcePath",null),he([T.memoize],b.prototype,"builtinExtensionsPath",null),he([T.memoize],b.prototype,"extensionsPath",null),he([T.memoize],b.prototype,"extensionDevelopmentLocationURI",null),he([T.memoize],b.prototype,"extensionDevelopmentKind",null),he([T.memoize],b.prototype,"extensionTestsLocationURI",null),he([T.memoize],b.prototype,"debugExtensionHost",null),he([T.memoize],b.prototype,"serviceMachineIdResource",null),he([T.memoize],b.prototype,"telemetryLogResource",null),he([T.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function i(h,S){return E(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=i;function I(h,S){return E(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=I;function m(h,S){return E(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=m;function E(h,S,g,v,y,d){const l=Number(S||h)||(v?null:g),n=l?Boolean(!!S):!1;let s;if(d)try{s=JSON.parse(d)}catch{}return{port:l,break:n,debugId:y,env:s}}}),define(te[150],ne([0,1,242,4,127]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,P.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(14,null)},category:{type:"string",cat:"e",description:(0,P.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,P.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,P.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,P.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,P.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,P.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,P.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,P.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,P.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,P.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,P.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function C(h,S,g=k){const v={},y=[],d=[];for(let s in S){const r=S[s];r.alias&&(v[s]=r.alias),r.type==="string"||r.type==="string[]"?(y.push(s),r.deprecates&&y.push(r.deprecates)):r.type==="boolean"&&(d.push(s),r.deprecates&&d.push(r.deprecates))}const c=D(h,{string:y,boolean:d,alias:v}),l={},n=c;l._=c._.map(s=>String(s)).filter(s=>s.length>0),delete n._;for(let s in S){const r=S[s];r.alias&&delete n[r.alias];let t=n[s];r.deprecates&&n.hasOwnProperty(r.deprecates)&&(t||(t=n[r.deprecates]),delete n[r.deprecates]),typeof t!="undefined"&&(r.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):r.type==="string"&&Array.isArray(t)&&(t=t.pop(),g.onMultipleValues(s,t)),l[s]=t),delete n[s]}for(let s in n)g.onUnknownOption(s);return l}e.parseArgs=C;function w(h,S){let g="";return S.args&&(Array.isArray(S.args)?g=` <${S.args.join("> <")}>`:g=` <${S.args}>`),S.alias?`-${S.alias} --${h}${g}`:`--${h}${g}`}function b(h,S){let g=0,v=[];for(const l in h){const n=h[l],s=w(l,n);g=Math.max(g,s.length),v.push([s,n.description])}let y=g+2+1;if(S-y<25)return v.reduce((l,n)=>l.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let d=S-y-1,c=[];for(const l of v){let n=l[0],s=I(l[1],d),r=i(y-n.length-2);c.push("  "+n+r+s[0]);for(let t=1;t<s.length;t++)c.push(i(y)+s[t])}return c}e.formatOptions=b;function i(h){return" ".repeat(h)}function I(h,S){let g=[];for(;h.length;){let v=h.length<S?h.length:h.lastIndexOf(" ",S),y=h.slice(0,v).trim();h=h.slice(v),g.push(y)}return g}function m(h,S,g,v,y=!0){const d=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${h} ${g}`];c.push(""),c.push(`${(0,P.localize)(32,null)}: ${S} [${(0,P.localize)(33,null)}][${(0,P.localize)(34,null)}...]`),c.push(""),y&&(T.isWindows?c.push((0,P.localize)(35,null,S)):c.push((0,P.localize)(36,null,S)),c.push(""));const l={};for(const n in v){const s=v[n];if(s.description&&s.cat){let r=l[s.cat];r||(l[s.cat]=r={}),r[n]=s}}for(let n in l){const s=n;let r=l[s];r&&(c.push(R[s]),c.push(...b(r,d)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=m;function E(h,S){return`${h||(0,P.localize)(37,null)}
${S||(0,P.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=E}),function(){"use strict";function J(e,D,T,P){function R(C){const w=k(C),b=[w];return e.isAbsolute(w)||b.unshift(P),e.resolve(...b)}function k(C){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,T);const i=C["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(I,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,T)}return{getUserDataPath:R}}if(typeof define=="function")define(te[151],ne([0,243,34,15,16,31]),function(e,D,T,P,R,k){const C=R.dirname(P.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(R.joinPath(C,"package.json").fsPath);return J(D,T,w.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),T=require("os");module.exports=J(D,T,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[152],ne([0,1,34,75,151]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends T.AbstractNativeEnvironmentService{constructor(C,w){super(C,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,P.getUserDataPath)(C)},w)}}e.NativeEnvironmentService=R}),define(te[153],ne([0,1,9]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const T=/^([^@:]+@)?([^:]+):/,P=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,C=/^\s*url\s*=\s*(.+\S)\s*$/mg,w=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(g){const v=g.match(k);return v?v[1]:null}function i(g){if(g.indexOf("://")===-1){const v=g.match(T);return v?b(v[2]):null}try{const v=D.URI.parse(g);if(v.authority)return b(v.authority)}catch(v){}return null}function I(g,v){const y=new Set;let d;for(;d=C.exec(g);){const l=i(d[1]);l&&y.add(l)}const c=new Set(v);return Array.from(y).map(l=>c.has(l)?l:l.replace(w,"a"))}e.getDomainsOfRemotes=I;function m(g){const v=g.match(R);return v?v[2]:null}function E(g,v,y){return g&&v?(y&&v.endsWith(".git")&&(v=v.substr(0,v.length-4)),v.indexOf("/")===0?`${g}${v}`:`${g}/${v}`):null}function h(g,v){if(g.indexOf("://")===-1){const y=g.match(P);if(y)return E(y[2],y[3],v)}try{const y=D.URI.parse(g);if(y.authority)return E(m(y.authority),y.path,v)}catch(y){}return null}function S(g,v=!1){const y=[];let d;for(;d=C.exec(g);){const c=h(d[1],v);c&&y.push(c)}return y}e.getRemotes=S}),define(te[154],ne([0,1,26]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function P(R,k){const C=w=>{if(typeof w!="string")return;const b=T.exec(w);if(!b)return;const i=k[b[1]]??w;return typeof i=="string"?i:typeof i.message=="string"?i.message:w};return(0,D.cloneAndChange)(R,C)}e.localizeManifest=P}),define(te[155],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,k,C,w){return this.channel.call("promptImportantExtensionsInstallNotification",[R,k,C,w])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class T{constructor(R){this.service=R}listen(R,k){throw new Error(`Event not found: ${k}`)}call(R,k,C){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(C[0],C[1],C[2],C[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=T}),define(te[76],ne([0,1,136]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function R(m){return m=m.trim(),m==="*"||T.test(m)}e.isValidVersionStr=R;function k(m){if(!R(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=m.match(T);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=k;function C(m){if(!m)return null;let E=m.majorBase,h=m.majorMustEqual,S=m.minorBase,g=m.minorMustEqual,v=m.patchBase,y=m.patchMustEqual;m.hasCaret&&(E===0||(g=!1),y=!1);let d=0;if(m.preRelease){const c=P.exec(m.preRelease);if(c){const[,l,n,s]=c;d=Date.UTC(Number(l),Number(n)-1,Number(s))}}return{majorBase:E,majorMustEqual:h,minorBase:S,minorMustEqual:g,patchBase:v,patchMustEqual:y,isMinimum:m.hasGreaterEquals,notBefore:d}}e.normalizeVersion=C;function w(m,E,h){let S;typeof m=="string"?S=C(k(m)):S=m;let g;E instanceof Date?g=E.getTime():typeof E=="string"&&(g=new Date(E).getTime());let v;if(typeof h=="string"?v=C(k(h)):v=h,!S||!v)return!1;let y=S.majorBase,d=S.minorBase,c=S.patchBase,l=v.majorBase,n=v.minorBase,s=v.patchBase,r=v.notBefore,t=v.majorMustEqual,a=v.minorMustEqual,o=v.patchMustEqual;return v.isMinimum?y>l?!0:y<l?!1:d>n?!0:d<n||g&&g<r?!1:c>=s:(y===1&&l===0&&(!t||!a||!o)&&(l=1,n=0,s=0,t=!0,a=!1,o=!1),y<l?!1:y>l?!t:d<n?!1:d>n?!a:c<s?!1:c>s?!o:!(g&&g<r))}e.isValidVersion=w;function b(m,E,h,S){return h.isBuiltin||typeof h.main=="undefined"?!0:I(m,E,h.engines.vscode,S)}e.isValidExtensionVersion=b;function i(m,E,h){return m==="*"||I(E,h,m)}e.isEngineValid=i;function I(m,E,h,S=[]){let g=C(k(h));if(!g)return S.push(D.localize(0,null,h)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return S.push(D.localize(1,null,h)),!1}else if(!g.majorMustEqual)return S.push(D.localize(2,null,h)),!1;return w(m,E,g)?!0:(S.push(D.localize(3,null,m,h)),!1)}}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(P,R=[],k=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=D}),define(te[77],ne([0,1,53]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function P(k,C,w){C instanceof D.SyncDescriptor||(C=new D.SyncDescriptor(C,[],w)),T.push([k,C])}e.registerSingleton=P;function R(){return T}e.getSingletonServiceDescriptors=R}),define(te[156],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=D;class T{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let k of this._nodes.values())k.outgoing.size===0&&R.push(k);return R}insertEdge(R,k){const C=this.lookupOrInsertNode(R),w=this.lookupOrInsertNode(k);C.outgoing.set(this._hashFn(k),w),w.incoming.set(this._hashFn(R),C)}removeNode(R){const k=this._hashFn(R);this._nodes.delete(k);for(let C of this._nodes.values())C.outgoing.delete(k),C.incoming.delete(k)}lookupOrInsertNode(R){const k=this._hashFn(R);let C=this._nodes.get(k);return C||(C=new D(R),this._nodes.set(k,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[k,C]of this._nodes)R.push(`${k}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,k]of this._nodes){const C=new Set([R]),w=this._findCycle(k,C);if(w)return w}}_findCycle(R,k){for(let[C,w]of R.outgoing){if(k.has(C))return[...k,C].join(" -> ");k.add(C);const b=this._findCycle(w,k);if(b)return b;k.delete(C)}}}e.Graph=T}),define(te[6],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function w(b){return b[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=w})(D=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function T(C,w,b,i){w[D.DI_TARGET]===w?w[D.DI_DEPENDENCIES].push({id:C,index:b,optional:i}):(w[D.DI_DEPENDENCIES]=[{id:C,index:b,optional:i}],w[D.DI_TARGET]=w)}function P(C){if(D.serviceIds.has(C))return D.serviceIds.get(C);const w=function(b,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(w,b,I,!1)};return w.toString=()=>C,D.serviceIds.set(C,w),w}e.createDecorator=P;function R(C){return C}e.refineServiceDecorator=R;function k(C){return function(w,b,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(C,w,i,!0)}}e.optional=k}),define(te[157],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[158],ne([0,1,4,25,6]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=D.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",R.indexOf("Edg/")>=0),k.set("isFirefox",R.indexOf("Firefox")>=0),k.set("isChrome",R.indexOf("Chrome")>=0),k.set("isSafari",R.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var w;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return m.INSTANCE}static true(){return E.INSTANCE}static has(L){return h.create(L)}static equals(L,$){return S.create(L,$)}static notEquals(L,$){return y.create(L,$)}static regex(L,$){return t.create(L,$)}static in(L,$){return g.create(L,$)}static not(L){return d.create(L)}static and(...L){return u.create(L,null)}static or(...L){return f.create(L,null,!0)}static greater(L,$){return l.create(L,$)}static greaterEquals(L,$){return n.create(L,$)}static smaller(L,$){return s.create(L,$)}static smallerEquals(L,$){return r.create(L,$)}static deserialize(L,$=!1){if(!!L)return this._deserializeOrExpression(L,$)}static _deserializeOrExpression(L,$){let _=L.split("||");return f.create(_.map(F=>this._deserializeAndExpression(F,$)),null,!0)}static _deserializeAndExpression(L,$){let _=L.split("&&");return u.create(_.map(F=>this._deserializeOne(F,$)),null)}static _deserializeOne(L,$){if(L=L.trim(),L.indexOf("!=")>=0){let _=L.split("!=");return y.create(_[0].trim(),this._deserializeValue(_[1],$))}if(L.indexOf("==")>=0){let _=L.split("==");return S.create(_[0].trim(),this._deserializeValue(_[1],$))}if(L.indexOf("=~")>=0){let _=L.split("=~");return t.create(_[0].trim(),this._deserializeRegexValue(_[1],$))}if(L.indexOf(" in ")>=0){let _=L.split(" in ");return g.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const _=L.split(">=");return n.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const _=L.split(">");return l.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const _=L.split("<=");return r.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const _=L.split("<");return s.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(L)?d.create(L.substr(1).trim()):h.create(L)}static _deserializeValue(L,$){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;let _=/^'([^']*)'$/.exec(L);return _?_[1].trim():L}static _deserializeRegexValue(L,$){if((0,T.isFalsyOrWhitespace)(L)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=L.indexOf("/"),F=L.lastIndexOf("/");if(_===F||_<0){if($)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}let V=L.slice(_+1,F),W=L[F+1]==="i"?"i":"";try{return new RegExp(V,W)}catch(x){if($)throw new Error(`bad regexp-value '${L}', parse error: ${x}`);return console.warn(`bad regexp-value '${L}', parse error: ${x}`),null}}}e.ContextKeyExpr=b;function i(N,L){const $=N?N.substituteConstants():void 0,_=L?L.substituteConstants():void 0;return!$&&!_?!0:!$||!_?!1:$.equals(_)}e.expressionsAreEqualWithConstantSubstitution=i;function I(N,L){return N.cmp(L)}class m{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class E{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class h{constructor(L,$){this.key=L,this.negated=$,this.type=2}static create(L,$=null){const _=k.get(L);return typeof _=="boolean"?_?E.INSTANCE:m.INSTANCE:new h(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=k.get(this.key);return typeof L=="boolean"?L?E.INSTANCE:m.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class S{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=4}static create(L,$,_=null){if(typeof $=="boolean")return $?h.create(L,_):d.create(L,_);const F=k.get(L);return typeof F=="boolean"?$===(F?"true":"false")?E.INSTANCE:m.INSTANCE:new S(L,$,_)}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=k.get(this.key);if(typeof L=="boolean"){const $=L?"true":"false";return this.value===$?E.INSTANCE:m.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class g{constructor(L,$){this.key=L,this.valueKey=$,this.type=10,this.negated=null}static create(L,$){return new g(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.valueKey),_=L.getValue(this.key);return Array.isArray($)?$.indexOf(_)>=0:typeof _=="string"&&typeof $=="object"&&$!==null?C.call($,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=g;class v{constructor(L){this._actual=L,this.type=11}static create(L){return new v(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new v(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class y{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=5}static create(L,$,_=null){if(typeof $=="boolean")return $?d.create(L,_):h.create(L,_);const F=k.get(L);return typeof F=="boolean"?$===(F?"true":"false")?m.INSTANCE:E.INSTANCE:new y(L,$,_)}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=k.get(this.key);if(typeof L=="boolean"){const $=L?"true":"false";return this.value===$?m.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class d{constructor(L,$){this.key=L,this.negated=$,this.type=3}static create(L,$=null){const _=k.get(L);return typeof _=="boolean"?_?m.INSTANCE:E.INSTANCE:new d(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=k.get(this.key);return typeof L=="boolean"?L?m.INSTANCE:E.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=d;function c(N,L){if(typeof N=="string"){const $=parseFloat(N);isNaN($)||(N=$)}return typeof N=="string"||typeof N=="number"?L(N):m.INSTANCE}class l{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=12}static create(L,$,_=null){return c($,F=>new l(L,F,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class n{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=13}static create(L,$,_=null){return c($,F=>new n(L,F,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=n;class s{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=14}static create(L,$,_=null){return c($,F=>new s(L,F,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class r{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=15}static create(L,$,_=null){return c($,F=>new r(L,F,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class t{constructor(L,$){this.key=L,this.regexp=$,this.type=7,this.negated=null}static create(L,$){return new t(L,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const $=this.regexp?this.regexp.source:"",_=L.regexp?L.regexp.source:"";return $<_?-1:$>_?1:0}equals(L){if(L.type===this.type){const $=this.regexp?this.regexp.source:"",_=L.regexp?L.regexp.source:"";return this.key===L.key&&$===_}return!1}substituteConstants(){return this}evaluate(L){let $=L.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=a.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class a{constructor(L){this._actual=L,this.type=8}static create(L){return new a(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new a(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;function o(N){let L=null;for(let $=0,_=N.length;$<_;$++){const F=N[$].substituteConstants();if(N[$]!==F&&L===null){L=[];for(let V=0;V<$;V++)L[V]=N[V]}L!==null&&(L[$]=F)}return L===null?N:L}class u{constructor(L,$){this.expr=L,this.negated=$,this.type=6}static create(L,$){return u._normalizeArr(L,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,_=this.expr.length;$<_;$++){const F=I(this.expr[$],L.expr[$]);if(F!==0)return F}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:u.create(L,this.negated)}evaluate(L){for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].evaluate(L))return!1;return!0}static _normalizeArr(L,$){const _=[];let F=!1;for(const V of L)if(!!V){if(V.type===1){F=!0;continue}if(V.type===0)return m.INSTANCE;if(V.type===6){_.push(...V.expr);continue}_.push(V)}if(_.length===0&&F)return E.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(I);for(let V=1;V<_.length;V++)_[V-1].equals(_[V])&&(_.splice(V,1),V--);if(_.length===1)return _[0];for(;_.length>1;){const V=_[_.length-1];if(V.type!==9)break;_.pop();const W=_.pop(),x=_.length===0,z=f.create(V.expr.map(K=>u.create([K,W],null)),null,x);z&&(_.push(z),_.sort(I))}return _.length===1?_[0]:new u(_,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(let $ of this.expr)L.push(...$.keys());return L}map(L){return new u(this.expr.map($=>$.map(L)),null)}negate(){if(!this.negated){const L=[];for(let $ of this.expr)L.push($.negate());this.negated=f.create(L,this,!0)}return this.negated}}class f{constructor(L,$){this.expr=L,this.negated=$,this.type=9}static create(L,$,_){return f._normalizeArr(L,$,_)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,_=this.expr.length;$<_;$++){const F=I(this.expr[$],L.expr[$]);if(F!==0)return F}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:f.create(L,this.negated,!1)}evaluate(L){for(let $=0,_=this.expr.length;$<_;$++)if(this.expr[$].evaluate(L))return!0;return!1}static _normalizeArr(L,$,_){let F=[],V=!1;if(L){for(let W=0,x=L.length;W<x;W++){const z=L[W];if(!!z){if(z.type===0){V=!0;continue}if(z.type===1)return E.INSTANCE;if(z.type===9){F=F.concat(z.expr);continue}F.push(z)}}if(F.length===0&&V)return m.INSTANCE;F.sort(I)}if(F.length!==0){if(F.length===1)return F[0];for(let W=1;W<F.length;W++)F[W-1].equals(F[W])&&(F.splice(W,1),W--);if(F.length===1)return F[0];if(_){for(let W=0;W<F.length;W++)for(let x=W+1;x<F.length;x++)M(F[W],F[x])&&(F.splice(x,1),x--);if(F.length===1)return F[0]}return new f(F,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(let $ of this.expr)L.push(...$.keys());return L}map(L){return new f(this.expr.map($=>$.map(L)),null)}negate(){if(!this.negated){let L=[];for(let $ of this.expr)L.push($.negate());for(;L.length>1;){const $=L.shift(),_=L.shift(),F=[];for(const W of q($))for(const x of q(_))F.push(u.create([W,x],null));const V=L.length===0;L.unshift(f.create(F,null,V))}this.negated=L[0]}return this.negated}}class p extends h{constructor(L,$,_){super(L,null);this._defaultValue=$,typeof _=="object"?p._info.push({..._,key:L}):_!==!0&&p._info.push({key:L,description:_,type:$!=null?typeof $:void 0})}static all(){return p._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return S.create(this.key,L)}notEqualsTo(L){return y.create(this.key,L)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function A(N,L){return N<L?-1:N>L?1:0}function O(N,L,$,_){return N<$?-1:N>$?1:L<_?-1:L>_?1:0}function M(N,L){if(L.type===6&&N.type!==9&&N.type!==6){for(const F of L.expr)if(N.equals(F))return!0}const $=N.negate(),_=q($).concat(q(L));_.sort(I);for(let F=0;F<_.length;F++){const W=_[F].negate();for(let x=F+1;x<_.length;x++){const z=_[x];if(W.equals(z))return!0}}return!1}e.implies=M;function q(N){return N.type===9?N.expr:[N]}}),define(te[78],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function T(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=T}),define(te[79],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[13],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,15,131,6]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var R;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));function k(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function C(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function w(d,c){switch(d){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=w;function b(d,c){return c==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function i(d,c,l){return b(c,l)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===l?!0:I(l).includes(d)}e.isTargetPlatformCompatible=i;function I(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function m(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=m;var E;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var h;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var S;(function(d){d.Install="install",d.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var g;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var v;(function(d){d.Unsupported="Unsupported",d.Malicious="Malicious",d.Incompatible="Incompatible",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(c,l){super(c);this.code=l,this.name=l}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(J,e){return function(D,T){e(D,T,J)}};define(te[159],ne([0,1,2,30]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let P=class extends D.Disposable{constructor(k){super();this.extensionManagementService=k,this._register(k),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};P=he([X(0,T.IExtensionManagementService)],P),e.DeprecatedExtensionsCleaner=P}),define(te[160],ne([0,1,3,2,26,9,109,30]),function(J,e,D,T,P,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(S,g){return R.URI.revive(g?g.transformIncoming(S):S)}function b(S,g){return g?g.transformOutgoingURI(S):S}function i(S,g){g=g||k.DefaultURITransformer;const v=S.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...S,manifest:void 0},g),manifest:v}}function I(S,g){return g?(0,P.cloneAndChange)(S,v=>v instanceof R.URI?g.transformOutgoingURI(v):void 0):S}class m{constructor(g,v){this.service=g,this.getUriTransformer=v,this.onInstallExtension=D.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,v){const y=this.getUriTransformer(g);switch(v){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(c=>({...c,local:c.local?I(c.local,y):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,v,y){const d=this.getUriTransformer(g);switch(v){case"zip":return this.service.zip(i(y[0],d)).then(c=>b(c,d));case"unzip":return this.service.unzip(w(y[0],d));case"install":return this.service.install(w(y[0],d),y[1]);case"getManifest":return this.service.getManifest(w(y[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],y[1]);case"uninstall":return this.service.uninstall(i(y[0],d),y[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(i(y[0],d));case"getInstalled":return this.service.getInstalled(y[0]).then(c=>c.map(l=>I(l,d)));case"updateMetadata":return this.service.updateMetadata(i(y[0],d),y[1]).then(c=>I(c,d));case"updateExtensionScope":return this.service.updateExtensionScope(i(y[0],d),y[1]).then(c=>I(c,d));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class E extends T.Disposable{constructor(g){super();this.channel=g,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(v=>this._onInstallExtension.fire({identifier:v.identifier,source:this.isUriComponents(v.source)?R.URI.revive(v.source):v.source}))),this._register(this.channel.listen("onDidInstallExtensions")(v=>this._onDidInstallExtensions.fire(v.map(y=>({...y,local:y.local?i(y.local,null):y.local,source:this.isUriComponents(y.source)?R.URI.revive(y.source):y.source}))))),this._register(this.channel.listen("onUninstallExtension")(v=>this._onUninstallExtension.fire(v))),this._register(this.channel.listen("onDidUninstallExtension")(v=>this._onDidUninstallExtension.fire(v)))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const v=await this.getTargetPlatform();return g.allTargetPlatforms.some(y=>(0,C.isTargetPlatformCompatible)(y,g.allTargetPlatforms,v))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(v=>R.URI.revive(v)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,v){return Promise.resolve(this.channel.call("install",[g,v])).then(y=>i(y,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,v){return Promise.resolve(this.channel.call("installFromGallery",[g,v])).then(y=>i(y,null))}uninstall(g,v){return Promise.resolve(this.channel.call("uninstall",[g,v]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null){return Promise.resolve(this.channel.call("getInstalled",[g])).then(v=>v.map(y=>i(y,null)))}updateMetadata(g,v){return Promise.resolve(this.channel.call("updateMetadata",[g,v])).then(y=>i(y,null))}updateExtensionScope(g,v){return Promise.resolve(this.channel.call("updateExtensionScope",[g,v])).then(y=>i(y,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=E;class h{constructor(g){this.service=g}listen(g,v){throw new Error("Invalid listen")}call(g,v,y){switch(v){case"getConfigBasedTips":return this.service.getConfigBasedTips(R.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var T;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(T=e.RecommendationSource||(e.RecommendationSource={}));function P(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=P;var R;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[81],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,D.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[14],ne([0,1,40,8,25,18,9,138,6]),function(J,e,D,T,P,R,k,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function b(_){return _.create===!0}e.isFileOpenForWriteOptions=b;var i;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(_){_[_.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var m;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=E;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function g(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=g;var v;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(F,V){super(F);this.code=V}}e.FileSystemProviderError=y;function d(_,F){const V=new y(_.toString(),F);return l(V,F),V}e.createFileSystemProviderError=d;function c(_){return _||d((0,C.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=c;function l(_,F){return _.name=F?`${F} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=l;function n(_){if(!_)return v.Unknown;if(_ instanceof y)return _.code;const F=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!F)return v.Unknown;switch(F[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=n;function s(_){if(_ instanceof f)return _.fileOperationResult;switch(n(_)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class t{constructor(F,V,W){this.resource=F,this.operation=V,this.target=W}isOperation(F){return this.operation===F}}e.FileOperationEvent=t;var a;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class o{constructor(F,V){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const x of F){const z=W.get(x.type);z?z.push([x.resource,x]):W.set(x.type,[[x.resource,x]])}for(const[x,z]of W)switch(x){case 1:this.added=D.TernarySearchTree.forUris(()=>V),this.added.fill(z);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>V),this.updated.fill(z);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>V),this.deleted.fill(z);break}}contains(F,...V){return this.doContains(F,{includeChildren:!1},...V)}affects(F,...V){return this.doContains(F,{includeChildren:!0},...V)}doContains(F,V,...W){if(!F)return!1;const x=W.length>0;return!!((!x||W.includes(1))&&(this.added?.get(F)||V.includeChildren&&this.added?.findSuperstr(F))||(!x||W.includes(0))&&(this.updated?.get(F)||V.includeChildren&&this.updated?.findSuperstr(F))||(!x||W.includes(2))&&(this.deleted?.findSubstr(F)||V.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function u(_,F,V){return!_||!F||_===F||F.length>_.length?!1:(F.charAt(F.length-1)!==T.sep&&(F+=T.sep),V?(0,P.startsWithIgnoreCase)(_,F):_.indexOf(F)===0)}e.isParent=u;class f extends Error{constructor(F,V,W){super(F);this.fileOperationResult=V,this.options=W}}e.FileOperationError=f;class p extends f{constructor(F,V,W){super(F,2,W);this.stat=V}}e.NotModifiedSinceFileOperationError=p;var A;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=M;async function q(_,F){if(!F.hasProvider(k.URI.from({scheme:_.scheme})))return new Promise(V=>{const W=F.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===_.scheme&&x.added&&(W.dispose(),V())})})}e.whenProviderRegistered=q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(F){return(0,R.isNumber)(F)||(F=0),F<N.KB?(0,C.localize)(1,null,F.toFixed(0)):F<N.MB?(0,C.localize)(2,null,(F/N.KB).toFixed(2)):F<N.GB?(0,C.localize)(3,null,(F/N.MB).toFixed(2)):F<N.TB?(0,C.localize)(4,null,(F/N.GB).toFixed(2)):(0,C.localize)(5,null,(F/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var L;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function $(_){return{maxFileSize:_===0?300*N.MB:16*N.GB,maxHeapSize:_===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=$}),define(te[161],ne([0,1,82,51,14]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let R=class{constructor(C){this.fileService=C}async checksum(C){const w=(await this.fileService.readFileStream(C)).value;return new Promise((b,i)=>{const I=(0,D.createHash)("md5");(0,T.listenStream)(w,{onData:m=>I.update(m.buffer),onError:m=>i(m),onEnd:()=>b(I.digest("base64").replace(/=+$/,""))})})}};R=he([X(0,P.IFileService)],R),e.ChecksumService=R}),define(te[162],ne([0,1,244,128,150,14]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(m,E){const h={onUnknownOption:g=>{console.warn((0,T.localize)(0,null,g))},onMultipleValues:(g,v)=>{console.warn((0,T.localize)(1,null,g,v))}},S=(0,P.parseArgs)(m,P.OPTIONS,E?h:void 0);return S.goto&&S._.forEach(g=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,T.localize)(2,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=R.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${R.MIN_MAX_MEMORY_SIZE_MB} MB.`),S}function C(m){const E=m.findIndex(h=>!/^-/.test(h));if(E>-1)return[...m.slice(0,E),...m.slice(E+1)]}function w(m){let[,...E]=m;process.env.VSCODE_DEV&&(E=C(E)||[]);const h=!I(process.env);return k(E,h)}e.parseMainProcessArgv=w;function b(m){const[,,...E]=m;return k(E,!0)}e.parseCLIProcessArgv=b;function i(m,...E){const h=m.indexOf("--");return h===-1?m.push(...E):m.splice(h,0,...E),m}e.addArg=i;function I(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(te[163],ne([0,1,42,8,129,27,37,7,4,29,124,162,5]),function(J,e,D,T,P,R,k,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const E=1e4;let h;async function S(v,y,d){return y["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(d)&&!y["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(d)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=m.Promises.withAsyncBody(async(c,l)=>{const n=new R.CancellationTokenSource,s=setTimeout(()=>{n.dispose(!0),l(new Error((0,P.localize)(0,null)))},E);try{c(await g(v,n.token))}catch(r){!(0,C.isPromiseCanceledError)(r)&&!n.token.isCancellationRequested?l(new Error((0,P.localize)(1,null,(0,k.toErrorMessage)(r)))):c({})}finally{clearTimeout(s),n.dispose()}})),h)}e.resolveShellEnv=S;async function g(v,y){const d=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",d);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",c);const l=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",s);const r=await(0,i.getSystemShell)(w.OS,s);return v.trace("getUnixShellEnvironment#shell",r),new Promise((t,a)=>{if(y.isCancellationRequested)return a((0,C.canceled)());const o=(0,T.basename)(r);let u,f;/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,f=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,f=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),u);const p=(0,D.spawn)(r,[...f,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});y.onCancellationRequested(()=>(p.kill(),a((0,C.canceled)()))),p.on("error",M=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(M)),a(M)});const A=[];p.stdout.on("data",M=>A.push(M));const O=[];p.stderr.on("data",M=>O.push(M)),p.on("close",(M,q)=>{const N=Buffer.concat(A).toString("utf8");v.trace("getUnixShellEnvironment#raw",N);const L=Buffer.concat(O).toString("utf8");if(L.trim()&&v.trace("getUnixShellEnvironment#stderr",L),M||q)return a(new Error((0,P.localize)(2,null,M,q)));const $=n.exec(N),_=$?$[1]:"{}";try{const F=JSON.parse(_);d?F.ELECTRON_RUN_AS_NODE=d:delete F.ELECTRON_RUN_AS_NODE,c?F.ELECTRON_NO_ATTACH_CONSOLE=c:delete F.ELECTRON_NO_ATTACH_CONSOLE,delete F.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",F),t(F)}catch(F){v.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(F)),a(F)}})})}}),define(te[83],ne([0,1,19,7,139,14]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(i,I,m,E,h,S){let g;try{await C(i,I,m,E,h,S)}catch(v){g=v}finally{g&&h.errorTransformer&&(g=h.errorTransformer(g)),typeof g!="undefined"&&m.error(g),m.end()}}e.readFileIntoStream=k;async function C(i,I,m,E,h,S){w(S);const g=await i.open(I,{create:!1});try{w(S);let v=0,y=0,d=h&&typeof h.length=="number"?h.length:void 0,c=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof d=="number"?d:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,n=0;do y=await i.read(g,l,c.buffer,n,c.byteLength-n),l+=y,n+=y,v+=y,typeof d=="number"&&(d-=y),n===c.byteLength&&(await m.write(E(c)),c=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof d=="number"?d:h.bufferSize)),n=0);while(y>0&&(typeof d!="number"||d>0)&&w(S)&&b(v,h));if(n>0){let s=n;typeof d=="number"&&(s=Math.min(n,d)),m.write(E(c.slice(0,s)))}}catch(v){throw(0,R.ensureFileSystemProviderError)(v)}finally{await i.close(g)}}function w(i){if(i.isCancellationRequested)throw(0,T.canceled)();return!0}function b(i,I){if(I?.limits){if(typeof I.limits.memory=="number"&&i>I.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&i>I.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[45],ne([0,1,2,4,9,14]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class k extends D.Disposable{constructor(m,E,h){super();this.onFileChanges=m,this.onLogMessage=E,this.verboseLogging=h,this.serviceDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new D.DisposableStore;this.serviceDisposables.value=m,this.service=this.createService(m),this.service.setVerboseLogging(this.verboseLogging),m.add(this.service.onDidChangeFile(E=>this.onFileChanges(E))),m.add(this.service.onDidLogMessage(E=>this.onLogMessage(E))),m.add(this.service.onDidError(E=>this.onError(E)))}onError(m){this.restartCounter<k.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.service?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.service?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${m}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=k,k.MAX_RESTARTS=5;class C extends D.Disposable{}e.WatcherService=C;function w(I){return I.map(m=>({type:m.type,resource:P.URI.file(m.path)}))}e.toFileChanges=w;function b(I){const m=new i;for(const E of I)m.processEvent(E);return m.normalize()}e.normalizeFileChanges=b;class i{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(m){return T.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const E=this.mapPathToChange.get(this.toKey(m));let h=!1;if(E){const S=E.type,g=m.type;E.path!==m.path&&m.type===2?h=!0:S===1&&g===2?(this.mapPathToChange.delete(this.toKey(m)),this.normalized.delete(E)):S===2&&g===1?E.type=0:S===1&&g===0||(E.type=g)}else h=!0;h&&(this.normalized.add(m),this.mapPathToChange.set(this.toKey(m),m))}normalize(){const m=[],E=[];return Array.from(this.normalized).filter(h=>h.type!==2?(m.push(h),!1):!0).sort((h,S)=>h.path.length-S.path.length).filter(h=>E.some(S=>(0,R.isParent)(h.path,S,!T.isLinux))?!1:(E.push(h.path),!0)).concat(m)}}}),define(te[164],ne([0,1,5,2,8,114,20,117,45]),function(J,e,D,T,P,R,k,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends T.Disposable{constructor(I,m,E,h){super();this.path=I,this.onDidFilesChange=m,this.onLogMessage=E,this.verboseLogging=h,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(C.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:m}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(m)try{E=await(0,R.realpath)(E)}catch(h){if(this.onError(h),m.dangling)return}I.isDirectory()?this._register((0,C.watchFolder)(E,(h,S)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,P.join)(this.path,(0,P.basename)(S))})},h=>this.onError(h))):this._register((0,C.watchFile)(E,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,w.normalizeFileChanges)(m);if(this.verboseLogging)for(const h of E)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(te[165],ne([0,1,15,32,44,45]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends R.WatcherService{constructor(w,b,i){super();this.onDidFilesChange=w,this.onLogMessage=b,this.verboseLogging=i,this.isDisposed=!1,this.startWatching()}startWatching(){const w=this._register(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=T.ProxyChannel.toService((0,T.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b)))}async setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||await this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}async watch(w){this.isDisposed||await this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k}),define(te[166],ne([0,1,15,32,44,45]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends R.AbstractWatcherService{constructor(w,b,i){super(w,b,i);this.init()}createService(w){const b=w.add(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(b.onDidProcessExit(({code:i,signal:I})=>this.onError(`terminated by itself with code ${i}, signal: ${I}`))),T.ProxyChannel.toService((0,T.getNextTickChannel)(b.getChannel("watcher")))}}e.FileWatcher=k}),define(te[167],ne([0,1,15,32,44,45]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends R.WatcherService{constructor(w,b,i,I={}){super();this.onDidFilesChange=w,this.onLogMessage=b,this.verboseLogging=i,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.requests=void 0,this.startWatching()}startWatching(){const w=this._register(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching(),this.service?.watch(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=T.ProxyChannel.toService((0,T.getNextTickChannel)(w.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b)))}async setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||await this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}async watch(w){this.requests=w,await this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(te[84],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...P){this._entries=new Map;for(let[R,k]of P)this.set(R,k)}set(P,R){const k=this._entries.get(P);return this._entries.set(P,R),k}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=D}),define(te[168],ne([0,1,5,7,53,156,6,84]),function(J,e,D,T,P,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class b extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class i{constructor(h=new C.ServiceCollection,S=!1,g){this._activeInstantiations=new Set,this._services=h,this._strict=S,this._parent=g,this._services.set(k.IInstantiationService,this)}createChild(h){return new i(h,this._strict,this)}invokeFunction(h,...S){let g=m.traceInvocation(h),v=!1;try{return h({get:(d,c)=>{if(v)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(d,g);if(!l&&c!==k.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return l}},...S)}finally{v=!0,g.stop()}}createInstance(h,...S){let g,v;return h instanceof P.SyncDescriptor?(g=m.traceCreation(h.ctor),v=this._createInstance(h.ctor,h.staticArguments.concat(S),g)):(g=m.traceCreation(h),v=this._createInstance(h,S,g)),g.stop(),v}_createInstance(h,S=[],g){let v=k._util.getServiceDependencies(h).sort((c,l)=>c.index-l.index),y=[];for(const c of v){let l=this._getOrCreateServiceInstance(c.id,g);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);y.push(l)}let d=v.length>0?v[0].index:S.length;if(S.length!==d){console.warn(`[createInstance] First service dependency of ${h.name} at position ${d+1} conflicts with ${S.length} static arguments`);let c=d-S.length;c>0?S=S.concat(new Array(c)):S=S.slice(0,d)}return new h(...[...S,...y])}_setServiceInstance(h,S){if(this._services.get(h)instanceof P.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){let g=this._getServiceInstanceOrDescriptor(h);return g instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,g,S.branch(h,!0)):(S.branch(h,!1),g)}_safeCreateAndCacheServiceInstance(h,S,g){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,g)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,g){const v=new R.Graph(c=>c.id.toString());let y=0;const d=[{id:h,desc:S,_trace:g}];for(;d.length;){const c=d.pop();if(v.lookupOrInsertNode(c),y++>1e3)throw new b(v);for(let l of k._util.getServiceDependencies(c.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(l.id);if(!n&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),n instanceof P.SyncDescriptor){const s={id:l.id,desc:n,_trace:c._trace.branch(l.id,!0)};v.insertEdge(c,s),d.push(s)}}}for(;;){const c=v.roots();if(c.length===0){if(!v.isEmpty())throw new b(v);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof P.SyncDescriptor){const s=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,s)}v.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,g=[],v,y){if(this._services.get(h)instanceof P.SyncDescriptor)return this._createServiceInstance(S,g,v,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,g,v,y);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S=[],g,v){if(g){const y=new D.IdleValue(()=>this._createInstance(h,S,v));return new Proxy(Object.create(null),{get(d,c){if(c in d)return d[c];let l=y.value,n=l[c];return typeof n!="function"||(n=n.bind(l),d[c]=n),n},set(d,c,l){return y.value[c]=l,!0}})}else return this._createInstance(h,S,v)}}e.InstantiationService=i;var I;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(I||(I={}));class m{constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return w?new m(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(h){return w?new m(0,h.name):m._None}branch(h,S){let g=new m(2,h.toString());return this._dep.push([h,S,g]),g}stop(){let h=Date.now()-this._start;m._totals+=h;let S=!1;function g(y,d){let c=[],l=new Array(y+1).join("	");for(const[n,s,r]of d._dep)if(s&&r){S=!0,c.push(`${l}CREATES -> ${n}`);let t=g(y+1,r);t&&c.push(t)}else c.push(`${l}uses -> ${n}`);return c.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(h>2||S)&&console.log(v.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(te[169],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(P,R){this.server=P,this.router=R}getChannel(P){return this.server.getChannel(P,this.router)}registerChannel(P,R){this.server.registerChannel(P,R)}}e.MessagePortMainProcessService=D}),define(te[170],ne([0,1,32,53,77,6]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(E,h,S){const g=S.getChannel(E);return C(h)?new h.channelClientCtor(g):D.ProxyChannel.toService(g,h?.proxyOptions)}}function C(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,R.createDecorator)("mainProcessService");let w=class extends k{constructor(E,h,S){super(E,h,S)}};w=he([X(2,e.IMainProcessService)],w);function b(m,E,h){(0,P.registerSingleton)(m,new T.SyncDescriptor(w,[E,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let i=class extends k{constructor(E,h,S){super(E,h,S)}};i=he([X(2,e.ISharedProcessService)],i);function I(m,E,h){(0,P.registerSingleton)(m,new T.SyncDescriptor(i,[E,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=I}),define(te[58],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function T(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const R of P.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}e.isValidLocalization=T}),define(te[171],ne([0,1,2,58]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let P=class extends D.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};P=he([X(0,T.ILocalizationsService)],P),e.LocalizationsUpdater=P}),define(te[10],ne([0,1,37,3,2,4,6]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function C(){return new Date().toISOString()}var w;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class b extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class i extends b{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...s){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([n,...s]))}debug(n,...s){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([n,...s]))}info(n,...s){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([n,...s]))}warn(n,...s){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([n,...s]))}error(n,...s){if(this.checkLogLevel(w.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(w.Error,this.format(r))}else this.log(w.Error,this.format([n,...s]))}critical(n,...s){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([n,...s]))}flush(){}format(n){let s="";for(let r=0;r<n.length;r++){let t=n[r];if(typeof t=="object")try{t=JSON.stringify(t)}catch(a){}s+=(r>0?" ":"")+t}return s}}e.AbstractMessageLogger=i;class I extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!R.isWindows}trace(n,...s){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,n,...s):console.log(`[main ${C()}]`,n,...s))}debug(n,...s){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,n,...s):console.log(`[main ${C()}]`,n,...s))}info(n,...s){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,n,...s):console.log(`[main ${C()}]`,n,...s))}warn(n,...s){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,n,...s):console.warn(`[main ${C()}]`,n,...s))}error(n,...s){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,n,...s):console.error(`[main ${C()}]`,n,...s))}critical(n,...s){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,n,...s):console.error(`[main ${C()}]`,n,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class m extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...s){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",n,...s)}debug(n,...s){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...s)}info(n,...s){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",n,...s)}warn(n,...s){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",n,...s)}error(n,...s){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",n,...s)}critical(n,...s){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...s)}dispose(){}flush(){}}e.ConsoleLogger=m;class E extends b{constructor(n,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(s)}trace(n,...s){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(n),...s])}debug(n,...s){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(n),...s])}info(n,...s){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(n),...s])}warn(n,...s){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(n),...s])}error(n,...s){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(n),...s])}critical(n,...s){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(n),...s])}extractMessage(n){return typeof n=="string"?n:(0,D.toErrorMessage)(n,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class h extends b{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const s of this.logServices)s.setLevel(n);super.setLevel(n)}trace(n,...s){for(const r of this.logServices)r.trace(n,...s)}debug(n,...s){for(const r of this.logServices)r.debug(n,...s)}info(n,...s){for(const r of this.logServices)r.info(n,...s)}warn(n,...s){for(const r of this.logServices)r.warn(n,...s)}error(n,...s){for(const r of this.logServices)r.error(n,...s)}critical(n,...s){for(const r of this.logServices)r.critical(n,...s)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=h;class S extends P.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...s){this.logger.trace(n,...s)}debug(n,...s){this.logger.debug(n,...s)}info(n,...s){this.logger.info(n,...s)}warn(n,...s){this.logger.warn(n,...s)}error(n,...s){this.logger.error(n,...s)}critical(n,...s){this.logger.critical(n,...s)}flush(){this.logger.flush()}}e.LogService=S;class g extends P.Disposable{constructor(n,s){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,s){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,s?.always?w.Trace:this.logLevel,s),this.loggers.set(n.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class v{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(n){}getLevel(){return w.Info}trace(n,...s){}debug(n,...s){}info(n,...s){}warn(n,...s){}error(n,...s){}critical(n,...s){}dispose(){}flush(){}}e.NullLogService=v;function y(l){if(l.verbose)return w.Trace;if(typeof l.logLevel=="string"){const n=d(l.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function d(l){switch(l){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=d;function c(l){switch(l){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=c}),define(te[172],ne([0,1,5,7,2,8,20,13,10]),function(J,e,D,T,P,R,k,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends P.Disposable{constructor(I,m){super();this.environmentService=I,this.logService=m,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const I=(0,R.basename)(this.environmentService.logsPath),m=(0,R.dirname)(this.environmentService.logsPath),S=(await k.Promises.readdir(m)).filter(v=>/^\d{8}T\d{6}$/.test(v)).sort().filter(v=>v!==I),g=S.slice(0,Math.max(0,S.length-9));g.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${g.join(", ")}'`),await Promise.all(g.map(v=>k.Promises.rm((0,R.join)(m,v)))))}catch(I){(0,T.onUnexpectedError)(I)}}};b=he([X(0,C.IEnvironmentService),X(1,w.ILogService)],b),e.LogsDataCleaner=b}),define(te[173],ne([0,1,5,7,2,8,20,13,10]),function(J,e,D,T,P,R,k,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class pt extends P.Disposable{constructor(I,m,E){super();this.backupWorkspacesPath=I,this.environmentService=m,this.logService=E,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const I=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),E=JSON.parse(I).emptyWorkspaceInfos.map(S=>S.backupFolder),h=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async S=>{S.length!==pt.NON_EMPTY_WORKSPACE_ID_LENGTH&&E.indexOf(S)===-1&&(this.logService.trace(`[storage cleanup]: Deleting storage folder ${S}.`),await k.Promises.rm((0,R.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(I){(0,T.onUnexpectedError)(I)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b=he([X(1,C.INativeEnvironmentService),X(2,w.ILogService)],b),e.StorageDataCleaner=b}),define(te[85],ne([0,1,5,19,33,39,13,14,6,10]),function(J,e,D,T,P,R,k,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(m){m.ERROR_INVALID_FILE="ERROR_INVALID_FILE",m.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,w.createDecorator)(e.UserConfigurationFileServiceId);let I=class{constructor(E,h,S){this.environmentService=E,this.fileService=h,this.logService=S,this.queue=new D.Queue}async updateSettings(E,h){return this.queue.queue(()=>this.doWrite(E,h))}async doWrite(E,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),E);const{value:S,mtime:g,etag:v}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let y=S.toString();const d=[];if((0,P.parse)(y,d,{allowTrailingComma:!0,allowEmptyContent:!0}),d.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(E,y,h)[0];if(c){y=y.substring(0,c.offset)+c.content+y.substring(c.offset+c.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,T.VSBuffer.fromString(y),{etag:v,mtime:g})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(E,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,E,h)})}getEdits({value:E,path:h},S,g){return h.length?(0,R.setProperty)(S,h,E,g):[{content:JSON.stringify(E,null,g.insertSpaces&&g.tabSize?" ".repeat(g.tabSize):"	"),length:S.length,offset:0}]}};I=he([X(0,k.IEnvironmentService),X(1,C.IFileService),X(2,b.ILogService)],I),e.UserConfigurationFileService=I}),define(te[174],ne([0,1,42,5,37,3,2,15,8,20,13,10]),function(J,e,D,T,P,R,k,C,w,b,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends k.Disposable{constructor(h,S){super();this.environmentService=h,this.logService=S,this.processesLimiter=new T.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${g}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(h,S){const g=`vscode:${S}`;if(h.location.scheme===C.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[g]=="string"){const v=h.manifest.scripts[g].split(" ");return v.length<2||v[0]!=="node"||!v[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${g} should be a node script`),null):{script:(0,w.join)(h.location.fsPath,v[1]),args:v.slice(2)||[]}}return null}runLifecycleHook(h,S,g,v,y){return new Promise((d,c)=>{const l=this.start(h,S,g,y);let n;const s=r=>{n&&(clearTimeout(n),n=null),r?c(r):d(void 0)};l.on("error",r=>{s((0,P.toErrorMessage)(r)||"Unknown")}),l.on("exit",(r,t)=>{s(r?`post-${S} process exited with code ${r}`:void 0)}),v&&(n=setTimeout(()=>{n=null,l.kill(),c("timed out")},5e3))})}start(h,S,g,v){const y={silent:!0,execArgv:void 0},d=(0,D.fork)(h,[`--type=extension-post-${S}`,...g],y);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const c=R.Event.fromNodeEventEmitter(d.stdout,"data"),l=R.Event.fromNodeEventEmitter(d.stderr,"data");c(r=>this.logService.info(v.identifier.id,v.manifest.version,`post-${S}`,r)),l(r=>this.logService.error(v.identifier.id,v.manifest.version,`post-${S}`,r));const n=R.Event.any(R.Event.map(c,r=>({data:`%c${r}`,format:[""]})),R.Event.map(l,r=>({data:`%c${r}`,format:["color: red"]})));return R.Event.debounce(n,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100)(r=>{console.group(v.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),d}getExtensionStoragePath(h){return(0,w.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=he([X(0,i.IEnvironmentService),X(1,I.ILogService)],m),e.ExtensionsLifecycle=m}),define(te[175],ne([0,1,7,2,81,3,42,15,111,4,10,77,26,31]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let h=class extends T.Disposable{constructor(v,y){super();this.id=v,this._logService=y,this._onStdout=this._register(new R.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new R.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onExit=this._register(new R.Emitter),this.onExit=this._onExit.event,this._process=null}register(v){this._register(v)}start(v){this._process=(0,k.fork)(C.FileAccess.asFileUri("bootstrap-fork",J).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,m.mixin)({cwd:(0,E.cwd)()},v));const y=this._process.pid;this._logService.info(`Starting extension host with pid ${y}.`);const d=new w.StringDecoder("utf-8");this._process.stdout?.on("data",l=>{const n=typeof l=="string"?l:d.write(l);this._onStdout.fire(n)});const c=new w.StringDecoder("utf-8");return this._process.stderr?.on("data",l=>{const n=typeof l=="string"?l:c.write(l);this._onStderr.fire(n)}),this._process.on("message",l=>{this._onMessage.fire(l)}),this._process.on("error",l=>{this._onError.fire({error:(0,D.transformErrorForSerialization)(l)})}),this._process.on("exit",(l,n)=>{this._onExit.fire({pid:y,code:l,signal:n})}),{pid:y}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):b.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};h=he([X(1,i.ILogService)],h);let S=class yt{constructor(v){this._logService=v,this._extHosts=new Map}dispose(){}_getExtHost(v){const y=this._extHosts.get(v);if(!y)throw new Error("Unknown extension host!");return y}onDynamicStdout(v){return this._getExtHost(v).onStdout}onDynamicStderr(v){return this._getExtHost(v).onStderr}onDynamicMessage(v){return this._getExtHost(v).onMessage}onDynamicError(v){return this._getExtHost(v).onError}onDynamicExit(v){return this._getExtHost(v).onExit}async createExtensionHost(){const v=String(++yt._lastId),y=new h(v,this._logService);return this._extHosts.set(v,y),y.onExit(({pid:d,code:c,signal:l})=>{this._logService.info(`Extension host with pid ${d} exited with code: ${c}, signal: ${l}.`),setTimeout(()=>{y.dispose(),this._extHosts.delete(v)})}),{id:v}}async start(v,y){return this._getExtHost(v).start(y)}async enableInspectPort(v){const y=this._extHosts.get(v);return y?y.enableInspectPort():!1}async kill(v){const y=this._extHosts.get(v);!y||y.kill()}};S._lastId=0,S=he([X(0,i.ILogService)],S),e.ExtensionHostStarter=S,(0,I.registerSingleton)(P.IExtensionHostStarter,S,!0)}),define(te[176],ne([0,1,17,5,7,3,2,8,45,10]),function(J,e,D,T,P,R,k,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class i extends k.Disposable{constructor(m){super();this.logService=m,this._onDidErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new T.ThrottledDelayer(0))}watch(m,E){return E.recursive?this.watchRecursive(m,E):this.watchNonRecursive(m)}watchRecursive(m,E){const h={path:this.toFilePath(m),excludes:E.excludes},S=(0,D.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(m=>(0,P.onUnexpectedError)(m))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,m=>this._onDidChangeFile.fire((0,w.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(m,E){return m.watch(E)}watchNonRecursive(m){const E=this.createNonRecursiveWatcher(this.toFilePath(m),S=>this._onDidChangeFile.fire((0,w.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===b.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{E.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,k.combinedDisposable)(E,h)}onWatcherLogMessage(m){m.type==="error"&&this._onDidErrorOccur.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,C.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=i}),define(te[177],ne([0,1,17,5,19,27,3,55,2,40,15,178,16,51,137,14,83,10]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class Ke extends w.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new S.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new S.FileChangesEvent(l,!0)))),this.watchedResources=b.TernarySearchTree.forUris(l=>{const n=this.getProvider(l.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new T.ResourceQueue)}registerProvider(c,l){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:l});const n=new w.DisposableStore;return n.add(l.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(l)))),n.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:c}))),typeof l.onDidErrorOccur=="function"&&n.add(l.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:l}),this.provider.delete(c),(0,w.dispose)(n)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(n){l.push(n)}}),!this.provider.has(c)&&await T.Promises.settled(l)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,l){const n=this.provider.get(c.scheme);return!!(n&&n.capabilities&l)}listCapabilities(){return C.Iterable.map(this.provider,([c,l])=>({scheme:c,capabilities:l.capabilities}))}async withProvider(c){if(!(0,m.isAbsolutePath)(c))throw new S.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const l=this.provider.get(c.scheme);if(!l){const n=new Error;throw n.name="ENOPRO",n.message=(0,h.localize)(1,null,c.toString()),n}return l}async withReadProvider(c){const l=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasReadWriteCapability)(l)||(0,S.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const l=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,l){try{return await this.doResolveFile(c,l)}catch(n){throw(0,S.toFileSystemProviderErrorCode)(n)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,S.ensureFileSystemProviderError)(n)}}async doResolveFile(c,l){const n=await this.withProvider(c),s=this.isPathCaseSensitive(n),r=l?.resolveTo,t=l?.resolveSingleChildDescendants,a=l?.resolveMetadata,o=await n.stat(c);let u;return this.toFileStat(n,c,o,void 0,!!a,(f,p)=>(u||(u=b.TernarySearchTree.forUris(()=>!s),u.set(c,!0),r&&u.fill(!0,r)),u.get(f.resource)||u.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&t?p===1:!1))}async toFileStat(c,l,n,s,r,t){const{providerExtUri:a}=this.getExtUri(c),o={resource:l,name:a.basename(l),isFile:(n.type&S.FileType.File)!=0,isDirectory:(n.type&S.FileType.Directory)!=0,isSymbolicLink:(n.type&S.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&S.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,S.etag)({mtime:n.mtime,size:n.size})};if(o.isDirectory&&t(o,s)){try{const u=await c.readdir(l),f=await T.Promises.settled(u.map(async([p,A])=>{try{const O=a.joinPath(l,p),M=r?await c.stat(O):{type:A};return await this.toFileStat(c,O,M,u.length,r,t)}catch(O){return this.logService.trace(O),null}}));o.children=(0,D.coalesce)(f)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(c){return T.Promises.settled(c.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(c){const l=await this.withProvider(c);try{return!!await l.stat(c)}catch(n){return!1}}async canCreateFile(c,l){try{await this.doValidateCreateFile(c,l)}catch(n){return n}return!0}async doValidateCreateFile(c,l){if(!l?.overwrite&&await this.exists(c))throw new S.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,l)}async createFile(c,l=P.VSBuffer.fromString(""),n){await this.doValidateCreateFile(c,n);const s=await this.writeFile(c,l);return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,s)),s}async writeFile(c,l,n){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,c,n)||await this.mkdirp(s,r.dirname(c));let a;if((0,S.hasReadWriteCapability)(s)&&!(l instanceof P.VSBuffer))if((0,E.isReadableStream)(l)){const o=await(0,E.peekStream)(l,3);o.ended?a=P.VSBuffer.concat(o.buffer):a=o}else a=(0,E.peekReadable)(l,o=>P.VSBuffer.concat(o),3);else a=l;!(0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s)&&a instanceof P.VSBuffer?await this.doWriteUnbuffered(s,c,n,a):await this.doWriteBuffered(s,c,n,a instanceof P.VSBuffer?(0,P.bufferToReadable)(a):a)}catch(t){throw new S.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),n)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,l,n){if(!!n?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(l)));let r;try{r=await c.stat(l)}catch(t){return}if((r.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,h.localize)(6,null,this.resourceForError(l)),0,n);if(this.throwIfFileIsReadonly(l,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,S.etag)({mtime:n.mtime,size:r.size}))throw new S.FileOperationError((0,h.localize)(7,null),3,n);return r}async readFile(c,l){const n=await this.withReadProvider(c);return l?.atomic?this.doReadFileAtomic(n,c,l):this.doReadFile(n,c,l)}async doReadFileAtomic(c,l,n){return new Promise((s,r)=>{this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(c,l,n);s(t)}catch(t){r(t)}})})}async doReadFile(c,l,n){const s=await this.doReadFileStream(c,l,{...n,preferUnbuffered:!0});return{...s,value:await(0,P.streamToBuffer)(s.value)}}async readFileStream(c,l){const n=await this.withReadProvider(c);return this.doReadFileStream(n,c,l)}async doReadFileStream(c,l,n){const s=new R.CancellationTokenSource,r=this.validateReadFile(l,n).then(a=>a,a=>{throw s.cancel(),a});let t;try{return typeof n?.etag=="string"&&n.etag!==S.ETAG_DISABLED&&await r,!((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasFileReadStreamCapability)(c))||(0,S.hasReadWriteCapability)(c)&&n?.preferUnbuffered?t=this.readFileUnbuffered(c,l,n):(0,S.hasFileReadStreamCapability)(c)?t=this.readFileStreamed(c,l,s.token,n):t=this.readFileBuffered(c,l,s.token,n),{...await r,value:t}}catch(a){t&&await(0,E.consumeStream)(t);const o=(0,h.localize)(8,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(a).toString());throw a instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(o,a.stat,n):new S.FileOperationError(o,(0,S.toFileOperationResult)(a),n)}}readFileStreamed(c,l,n,s=Object.create(null)){const r=c.readFileStream(l,s,n);return(0,E.transform)(r,{data:t=>t instanceof P.VSBuffer?t:P.VSBuffer.wrap(t),error:t=>new S.FileOperationError((0,h.localize)(9,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),s)},t=>P.VSBuffer.concat(t))}readFileBuffered(c,l,n,s=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,g.readFileIntoStream)(c,l,r,t=>t,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new S.FileOperationError((0,h.localize)(10,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),s)},n),r}readFileUnbuffered(c,l,n){const s=(0,E.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r=await c.readFile(l);typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(l,r.byteLength,n),s.end(P.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(c,l){const n=await this.resolve(c,{resolveMetadata:!0});if(n.isDirectory)throw new S.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,l);if(typeof l?.etag=="string"&&l.etag!==S.ETAG_DISABLED&&l.etag===n.etag)throw new S.NotModifiedSinceFileOperationError((0,h.localize)(12,null),n,l);return this.validateReadFileLimits(c,n.size,l),n}validateReadFileLimits(c,l,n){if(n?.limits){let s;if(typeof n.limits.memory=="number"&&l>n.limits.memory&&(s=9),typeof n.limits.size=="number"&&l>n.limits.size&&(s=7),typeof s=="number")throw new S.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,l,n){return this.doCanMoveCopy(c,l,"move",n)}async canCopy(c,l,n){return this.doCanMoveCopy(c,l,"copy",n)}async doCanMoveCopy(c,l,n,s){if(c.toString()!==l.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(r,c,t,l,n,s)}catch(r){return r}return!0}async move(c,l,n){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(s,c,r,l,"move",!!n),a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,t==="move"?2:3,a)),a}async copy(c,l,n){const s=await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(s,c,r,l,"copy",!!n),a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,t==="copy"?3:2,a)),a}async doMoveCopy(c,l,n,s,r,t){if(l.toString()===s.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(c,l,n,s,r,t);if(a&&!o&&t&&await this.del(s,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s)),r==="copy"){if(c===n&&(0,S.hasFileFolderCopyCapability)(c))await c.copy(l,s,{overwrite:t});else{const u=await this.resolve(l);u.isDirectory?await this.doCopyFolder(c,u,n,s):await this.doCopyFile(c,l,n,s)}return r}else return c===n?(await c.rename(l,s,{overwrite:t}),r):(await this.doMoveCopy(c,l,n,s,"copy",t),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(c,l,n,s){if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(c,l,n,s);if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(c,l,n,s);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(c,l,n,s);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasReadWriteCapability)(n))return this.doPipeUnbuffered(c,l,n,s)}async doCopyFolder(c,l,n,s){await n.mkdir(s),Array.isArray(l.children)&&await T.Promises.settled(l.children.map(async r=>{const t=this.getExtUri(n).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(c,await this.resolve(r.resource),n,t):this.doCopyFile(c,r.resource,n,t)}))}async doValidateMoveCopy(c,l,n,s,r,t){let a=!1;if(c===n){const{providerExtUri:u,isPathCaseSensitive:f}=this.getExtUri(c);if(f||(a=u.isEqual(l,s)),a&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(l),this.resourceForError(s)));if(!a&&u.isEqualOrParent(s,l))throw new Error((0,h.localize)(15,null,this.resourceForError(l),this.resourceForError(s)))}const o=await this.exists(s);if(o&&!a){if(!t)throw new S.FileOperationError((0,h.localize)(16,null,this.resourceForError(l),this.resourceForError(s)),4);if(c===n){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(l,s))throw new Error((0,h.localize)(17,null,this.resourceForError(l),this.resourceForError(s)))}}return{exists:o,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const l=this.isPathCaseSensitive(c);return{providerExtUri:l?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(l,c);const n=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,n)),n}async mkdirp(c,l){const n=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(l,s.dirname(l));)try{if(((await c.stat(l)).type&S.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(l)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(s.basename(l)),l=s.dirname(l)}for(let r=n.length-1;r>=0;r--){l=s.joinPath(l,n[r]);try{await c.mkdir(l)}catch(t){if((0,S.toFileSystemProviderErrorCode)(t)!==S.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(c,l){try{await this.doValidateDelete(c,l)}catch(n){return n}return!0}async doValidateDelete(c,l){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!l?.useTrash&&!(n.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let r;try{r=await n.stat(c)}catch(a){}if(r)this.throwIfFileIsReadonly(c,r);else throw new S.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!l?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return n}async del(c,l){const n=await this.doValidateDelete(c,l),s=!!l?.useTrash,r=!!l?.recursive;await n.delete(c,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new S.FileOperationEvent(c,1))}onDidChangeFile(c,l){this._onDidChangeFilesRaw.fire({changes:c});let n,s;{for(const r of c)this.watchedResources.has(r.resource)?(n||(n=[]),n.push(r)):(s||(s=[]),s.push(r));n&&this._onDidFilesChange.fire(new S.FileChangesEvent(n,!l))}if(s){const r=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,l={recursive:!1,excludes:[]}){const n=new w.DisposableStore;let s=!1,r=()=>{s=!0};return n.add((0,w.toDisposable)(()=>r())),this.doWatch(c,l).then(t=>{s?(0,w.dispose)(t):r=()=>(0,w.dispose)(t)},t=>this.logService.error(t)),l.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),n.add((0,w.toDisposable)(()=>{const t=this.watchedResources.get(c);typeof t=="number"&&(t<=1?this.watchedResources.delete(c):this.watchedResources.set(c,t-1))}))),n}async doWatch(c,l){const n=await this.withProvider(c),s=this.toWatchKey(n,c,l);let r=this.activeWatchers.get(s);return r||(r={count:0,disposable:n.watch(c,l)},this.activeWatchers.set(s,r)),r.count+=1,(0,w.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,w.dispose)(r.disposable),this.activeWatchers.delete(s)))})}toWatchKey(c,l,n){const{providerExtUri:s}=this.getExtUri(c);return[s.getComparisonKey(l),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,w.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,l,n,s){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{const r=await c.open(l,{create:!0,unlock:n?.unlock??!1});try{(0,E.isReadableStream)(s)||(0,E.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,r,s):await this.doWriteReadableBufferedQueued(c,r,s)}catch(t){throw(0,S.ensureFileSystemProviderError)(t)}finally{await c.close(r)}})}async doWriteStreamBufferedQueued(c,l,n){let s=0,r;if((0,E.isReadableBufferedStream)(n)){if(n.buffer.length>0){const t=P.VSBuffer.concat(n.buffer);await this.doWriteBuffer(c,l,t,t.byteLength,s,0),s+=t.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((t,a)=>{(0,E.listenStream)(r,{onData:async o=>{r.pause();try{await this.doWriteBuffer(c,l,o,o.byteLength,s,0)}catch(u){return a(u)}s+=o.byteLength,setTimeout(()=>r.resume())},onError:o=>a(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(c,l,n){let s=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(c,l,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(c,l,n,s,r,t){let a=0;for(;a<s;)a+=await c.write(l,r+a,n.buffer,t+a,s-a)}async doWriteUnbuffered(c,l,n,s){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,l,n,s))}async doWriteUnbufferedQueued(c,l,n,s){let r;s instanceof P.VSBuffer?r=s:(0,E.isReadableStream)(s)?r=await(0,P.streamToBuffer)(s):(0,E.isReadableBufferedStream)(s)?r=await(0,P.bufferedStreamToBuffer)(s):r=(0,P.readableToBuffer)(s),await c.writeFile(l,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(c,l,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,l,n,s))}async doPipeBufferedQueued(c,l,n,s){let r,t;try{r=await c.open(l,{create:!1}),t=await n.open(s,{create:!0,unlock:!1});const a=P.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,f=0;do f=await c.read(r,o,a.buffer,u,a.byteLength-u),await this.doWriteBuffer(n,t,a,f,o,u),o+=f,u+=f,u===a.byteLength&&(u=0);while(f>0)}catch(a){throw(0,S.ensureFileSystemProviderError)(a)}finally{await T.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof t=="number"?n.close(t):Promise.resolve()])}}async doPipeUnbuffered(c,l,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,l,n,s))}async doPipeUnbufferedQueued(c,l,n,s){return n.writeFile(s,await c.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,l,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,l,n,s))}async doPipeUnbufferedToBufferedQueued(c,l,n,s){const r=await n.open(s,{create:!0,unlock:!1});try{const t=await c.readFile(l);await this.doWriteBuffer(n,r,P.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,S.ensureFileSystemProviderError)(t)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(c,l,n,s){const r=await(0,P.streamToBuffer)(this.readFileBuffered(c,l,R.CancellationToken.None));await this.doWriteUnbuffered(n,s,void 0,r)}throwIfFileSystemIsReadonly(c,l){if(c.capabilities&2048)throw new S.FileOperationError((0,h.localize)(22,null,this.resourceForError(l)),6);return c}throwIfFileIsReadonly(c,l){if((l.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===i.Schemas.file?c.fsPath:c.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=he([X(0,v.ILogService)],y),e.FileService=y}),define(te[86],ne([0,1,3,9,10]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(m){this.service=m,this.onDidChangeLogLevel=D.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,E){switch(E){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${E}`)}async call(m,E,h){switch(E){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${E}`)}}e.LogLevelChannel=R;class k{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){k.setLevel(this.channel,m)}static setLevel(m,E){return m.call("setLevel",E)}}e.LogLevelChannelClient=k;class C{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,E){throw new Error(`Event not found: ${E}`)}async call(m,E,h){switch(E){case"createLogger":this.createLogger(T.URI.revive(h[0]),h[1]);return;case"log":return this.log(T.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${E}`)}createLogger(m,E){this.loggers.set(m.toString(),this.loggerService.createLogger(m,E))}consoleLog(m,E){let h=console.log;switch(m){case P.LogLevel.Error:h=console.error;break;case P.LogLevel.Warning:h=console.warn;break;case P.LogLevel.Info:h=console.info;break}h.call(console,...E)}log(m,E){const h=this.loggers.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,g]of E)switch(S){case P.LogLevel.Trace:h.trace(g);break;case P.LogLevel.Debug:h.debug(g);break;case P.LogLevel.Info:h.info(g);break;case P.LogLevel.Warning:h.warn(g);break;case P.LogLevel.Error:h.error(g);break;case P.LogLevel.Critical:h.critical(g);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=C;class w extends P.AbstractLoggerService{constructor(m,E,h){super(m,E);this.channel=h}createConsoleMainLogger(){return new P.AdapterLogger({log:(m,E)=>{this.channel.call("consoleLog",[m,E])}})}doCreateLogger(m,E,h){return new b(this.channel,m,E,h)}}e.LoggerChannelClient=w;class b extends P.AbstractMessageLogger{constructor(m,E,h,S){super(S?.always);this.channel=m,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[E,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,E){const h=[[m,E]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(m){this.channel.call("log",[this.file,m])}}class i extends P.LogService{constructor(m,E){super(E);this.parent=m,this._register(m.onDidChangeLogLevel(h=>E.setLevel(h)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=i}),define(te[59],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[60],ne([0,1,15,4,31,16]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof T.globals.vscode!="undefined"&&typeof T.globals.vscode.context!="undefined"){const C=T.globals.vscode.context.configuration();if(C)k=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const C=(0,R.dirname)(D.FileAccess.asFileUri("",J));k=J.__$__nodeRequire((0,R.joinPath)(C,"product.json").fsPath);const w=J.__$__nodeRequire((0,R.joinPath)(C,"package.json").fsPath);P.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:w.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.62.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(te[179],ne([0,1,52,245,5,19,3,41,8,4,16,51,20,140,14,83,164,165,166,167,60,176,37]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d,c,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.toErrorMessage)(r)}`)}})();class s extends l.AbstractDiskFileSystemProvider{constructor(t,a){super(t);this.options=a,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:a,symbolicLink:o}=await m.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(a,o),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(t){try{const a=await m.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(a.map(async u=>{try{let f;u.isSymbolicLink()?f=(await this.stat((0,i.joinPath)(t,u.name))).type:f=this.toType(u),o.push([u.name,f])}catch(f){this.logService.trace(f)}})),o}catch(a){throw this.toFileSystemProviderError(a)}}toType(t,a){let o;return a?.dangling?o=h.FileType.Unknown:t.isFile()?o=h.FileType.File:t.isDirectory()?o=h.FileType.Directory:o=h.FileType.Unknown,a&&(o|=h.FileType.SymbolicLink),o}async readFile(t){try{const a=this.toFilePath(t);return await m.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(t,a,o){const u=(0,I.newWriteableStream)(f=>R.VSBuffer.concat(f.map(p=>R.VSBuffer.wrap(p))).buffer);return(0,S.readFileIntoStream)(this,t,u,f=>f.buffer,{...a,bufferSize:256*1024},o),u}async writeFile(t,a,o){let u;try{const f=this.toFilePath(t);if(!o.create||!o.overwrite){if(await m.Promises.exists(f)){if(!o.overwrite)throw(0,h.createFileSystemProviderError)((0,E.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,h.createFileSystemProviderError)((0,E.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(u,0,a,0,a.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(t,f)}finally{typeof u=="number"&&await this.close(u)}}async open(t,a){try{const o=this.toFilePath(t);if((0,h.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:p}=await m.SymlinkSupport.stat(o);p.mode&128||await m.Promises.chmod(o,p.mode|128)}catch(p){this.logService.trace(p)}let u;if((0,h.isFileOpenForWriteOptions)(a)){if(b.isWindows)try{await m.Promises.truncate(o,0),u="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}u||(u="w")}else u="r";const f=await m.Promises.open(o,u);return this.mapHandleToPos.set(f,0),(0,h.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(f,t),f}catch(o){throw(0,h.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(t,o):this.toFileSystemProviderError(o)}}async close(t){try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&this.canFlush)try{await m.Promises.fdatasync(t)}catch(a){this.canFlush=!1,this.logService.error(a)}return await m.Promises.close(t)}catch(a){throw this.toFileSystemProviderError(a)}}async read(t,a,o,u,f){const p=this.normalizePos(t,a);let A=null;try{const O=await m.Promises.read(t,o,u,f,p);return typeof O=="number"?A=O:A=O.bytesRead,A}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(t,p,A)}}normalizePos(t,a){return a===this.mapHandleToPos.get(t)?null:a}updatePos(t,a,o){const u=this.mapHandleToPos.get(t);typeof u=="number"&&(typeof a=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,u+o):this.mapHandleToPos.delete(t)))}async write(t,a,o,u,f){return(0,P.retry)(()=>this.doWrite(t,a,o,u,f),100,3)}async doWrite(t,a,o,u,f){const p=this.normalizePos(t,a);let A=null;try{const O=await m.Promises.write(t,o,u,f,p);return typeof O=="number"?A=O:A=O.bytesWritten,A}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),O)}finally{this.updatePos(t,p,A)}}async mkdir(t){try{await m.Promises.mkdir(this.toFilePath(t))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(t,a){try{const o=this.toFilePath(t);await this.doDelete(o,a)}catch(o){throw this.toFileSystemProviderError(o)}}async doDelete(t,a){a.recursive?await m.Promises.rm(t,m.RimRafMode.MOVE):await m.Promises.unlink(t)}async rename(t,a,o){const u=this.toFilePath(t),f=this.toFilePath(a);if(u!==f)try{await this.validateTargetDeleted(t,a,"move",o.overwrite),await m.Promises.move(u,f)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(2,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(f)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(t,a,o){const u=this.toFilePath(t),f=this.toFilePath(a);if(u!==f)try{await this.validateTargetDeleted(t,a,"copy",o.overwrite),await m.Promises.copy(u,f,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(3,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(f)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(t,a,o,u){const f=this.toFilePath(t),p=this.toFilePath(a);let A=!1;if(!!(this.capabilities&1024)||(A=(0,C.isEqual)(f,p,!0)),A&&o==="copy")throw(0,h.createFileSystemProviderError)((0,E.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!A&&await m.Promises.exists(p)){if(!u)throw(0,h.createFileSystemProviderError)((0,E.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(t,a,o,u){let f,p=!1;return this.options?.watcher?.usePolling?p=!1:this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?p=this.options.legacyWatcher==="on":c.default.quality==="stable"&&(p=t===1),p?b.isLinux?f=d.FileWatcher:f=v.FileWatcher:f=y.FileWatcher,new f(A=>a(A),A=>o(A),u,this.options?.watcher)}doWatch(t,a){const o=this.options?.watcher?.usePolling;if(o===!0)for(const u of a)u.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(o))for(const u of a)o.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(t,a)}createNonRecursiveWatcher(t,a,o,u){return new g.FileWatcher(t,f=>a(f),f=>o(f),u)}toFileSystemProviderError(t){if(t instanceof h.FileSystemProviderError)return t;let a;switch(t.code){case"ENOENT":a=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=h.FileSystemProviderErrorCode.NoPermissions;break;default:a=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(t,a)}async toFileSystemProviderWriteError(t,a){let o=this.toFileSystemProviderError(a);if(t&&o.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await m.SymlinkSupport.stat(this.toFilePath(t));u.mode&128||(o=(0,h.createFileSystemProviderError)(a,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}}e.DiskFileSystemProvider=s}),define(te[28],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(te[180],ne([0,1,5,7,2,8,20,10,28]),function(J,e,D,T,P,R,k,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends P.Disposable{constructor(I,m,E){super();this.productService=m,this.logService=E,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},30*1e3)).schedule()}async cleanUpCodeCaches(I){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),E=(0,R.dirname)(I),h=(0,R.basename)(I),S=await k.Promises.readdir(E);await Promise.all(S.map(async g=>{if(g===h)return;const v=(0,R.join)(E,g),y=await k.Promises.stat(v);if(y.isDirectory()&&m-y.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),k.Promises.rm(v)}))}catch(m){(0,T.onUnexpectedError)(m)}}};b=he([X(1,w.IProductService),X(2,C.ILogService)],b),e.CodeCacheCleaner=b}),define(te[181],ne([0,1,5,7,2,8,20,13,10,28]),function(J,e,D,T,P,R,k,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends P.Disposable{constructor(m,E,h){super();this.environmentService=m,this.logService=E,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),E=JSON.parse(await k.Promises.readFile((0,R.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let y of Object.keys(E)){const d=E[y];m[`${d.hash}.${y}`]=!0}const h=(0,R.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(h))return;const g=await k.Promises.readdir(h);for(const y of g){if(m[y]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${y}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${y}`),await k.Promises.rm((0,R.join)(h,y))}const v=Date.now();for(const y of Object.keys(m)){const d=(0,R.join)(h,y),c=await k.Promises.readdir(d);for(const l of c){if(l==="tcf.json")continue;const n=(0,R.join)(d,l),s=await k.Promises.stat(n);s.isDirectory()&&v-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,R.join)(y,l)}`),await k.Promises.rm(n))}}}catch(m){(0,T.onUnexpectedError)(m)}}};i=he([X(0,C.INativeEnvironmentService),X(1,w.ILogService),X(2,b.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(te[35],ne([0,1,100,18]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(k,C){D.ok(T.isString(k)),D.ok(T.isObject(C)),D.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,C)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new P}),define(te[87],ne([0,1,3,35]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,b){this.schemasById[P(w)]=b,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new R;T.Registry.add(e.Extensions.JSONContribution,k)}),define(te[38],ne([0,1,17,3,18,126,87,35]),function(J,e,D,T,P,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=C.Registry.as(k.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(d,c=!0){this.registerConfigurations([d],c)}registerConfigurations(d,c=!0){const l=this.doRegisterConfigurations(d,c);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(d){const c=this.doDeregisterConfigurations(d);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}updateConfigurations({add:d,remove:c}){const l=[];l.push(...this.doDeregisterConfigurations(c)),l.push(...this.doRegisterConfigurations(d,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,D.distinct)(l))}registerDefaultConfigurations(d){const c=[],l=[];for(const n of d)for(const s in n)if(c.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...n[s]};const r={type:"object",default:this.defaultValues[s],description:R.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};l.push(E(s)),this.configurationProperties[s]=r,this.defaultLanguageConfigurationOverridesNode.properties[s]=r}else{this.defaultValues[s]=n[s];const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(d){const c=[];for(const l of d)for(const n in l)if(c.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const s=this.configurationProperties[n];s&&(this.updatePropertyDefaultValue(n,s),this.updateSchema(n,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...d){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(d){for(const c of d)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(d,c){const l=[];return d.forEach(n=>{l.push(...this.validateAndRegisterProperties(n,c,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),l}doDeregisterConfigurations(d){const c=[],l=n=>{if(n.properties)for(const s in n.properties)c.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s]);n.allOf&&n.allOf.forEach(s=>l(s))};for(const n of d){l(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return c}validateAndRegisterProperties(d,c=!0,l,n=3){n=P.isUndefinedOrNull(d.scope)?n:d.scope;let s=[],r=d.properties;if(r)for(let a in r){if(c&&g(a)){delete r[a];continue}const o=r[a];if(this.updatePropertyDefaultValue(a,o),e.OVERRIDE_PROPERTY_PATTERN.test(a)?o.scope=void 0:(o.scope=P.isUndefinedOrNull(o.scope)?n:o.scope,o.restricted=P.isUndefinedOrNull(o.restricted)?!!l?.restrictedConfigurations?.includes(a):o.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),s.push(a)}let t=d.allOf;if(t)for(let a of t)s.push(...this.validateAndRegisterProperties(a,c,l,n));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(d){const c=l=>{let n=l.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let s=l.allOf;s&&s.forEach(c)};c(d)}updateSchema(d,c){switch(e.allSettings.properties[d]=c,c.scope){case 1:e.applicationSettings.properties[d]=c;break;case 2:e.machineSettings.properties[d]=c;break;case 6:e.machineOverridableSettings.properties[d]=c;break;case 3:e.windowSettings.properties[d]=c;break;case 4:e.resourceSettings.properties[d]=c;break;case 5:e.resourceSettings.properties[d]=c,this.resourceLanguageSettingsSchema.properties[d]=c;break}}removeFromSchema(d,c){switch(delete e.allSettings.properties[d],c.scope){case 1:delete e.applicationSettings.properties[d];break;case 2:delete e.machineSettings.properties[d];break;case 6:delete e.machineOverridableSettings.properties[d];break;case 3:delete e.windowSettings.properties[d];break;case 4:case 5:delete e.resourceSettings.properties[d];break}}updateOverridePropertyPatternKey(){for(const d of this.overrideIdentifiers.values()){const c=`[${d}]`,l={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,l),e.allSettings.properties[c]=l,e.applicationSettings.properties[c]=l,e.machineSettings.properties[c]=l,e.machineOverridableSettings.properties[c]=l,e.windowSettings.properties[c]=l,e.resourceSettings.properties[c]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(d,c){let l=this.defaultValues[d];P.isUndefined(l)&&(l=c.default),P.isUndefined(l)&&(l=h(c.type)),c.default=l}}const m="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(m);function E(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=E;function h(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const S=new I;C.Registry.add(e.Extensions.Configuration,S);function g(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?R.localize(5,null,y):S.getConfigurationProperties()[y]!==void 0?R.localize(6,null,y):null:R.localize(4,null)}e.validateProperty=g;function v(){const y=[],d=S.getConfigurationProperties();for(const c of Object.keys(d))y.push([c,d[c].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=v}),define(te[21],ne([0,1,26,18,9,38,6,35]),function(J,e,D,T,P,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function w(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof P.URI)}e.isConfigurationOverrides=w;var b;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(s,r){const t=r?s?r.keys.filter(O=>s.keys.indexOf(O)===-1):[...r.keys]:[],a=s?r?s.keys.filter(O=>r.keys.indexOf(O)===-1):[...s.keys]:[],o=[];if(r&&s){for(const O of s.keys)if(r.keys.indexOf(O)!==-1){const M=v(s.contents,O),q=v(r.contents,O);D.equals(M,q)||o.push(O)}}const u=[],f=O=>{const M={};for(const q of O)for(const N of q.identifiers)M[l(N)]=q;return M},p=r?f(r.overrides):{},A=s?f(s.overrides):{};if(Object.keys(p).length)for(const O of t){const M=p[O];M&&u.push([(0,R.overrideIdentifierFromKey)(O),M.keys])}if(Object.keys(A).length)for(const O of a){const M=A[O];M&&u.push([(0,R.overrideIdentifierFromKey)(O),M.keys])}if(Object.keys(p).length&&Object.keys(A).length)for(const O of o){const M=A[O],q=p[O];if(M&&q){const N=I({contents:M.contents,keys:M.keys,overrides:[]},{contents:q.contents,keys:q.keys,overrides:[]});u.push([(0,R.overrideIdentifierFromKey)(O),[...N.added,...N.removed,...N.updated]])}}return{added:t,removed:a,updated:o,overrides:u}}e.compare=I;function m(s,r){const t=[];for(const a of Object.keys(s))if(R.OVERRIDE_PROPERTY_PATTERN.test(a)){const o={};for(const u in s[a])o[u]=s[a][u];t.push({identifiers:[(0,R.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(o),contents:E(o,r)})}return t}e.toOverrides=m;function E(s,r){const t=Object.create(null);for(let a in s)h(t,a,s[a],r);return t}e.toValuesTree=E;function h(s,r,t,a){const o=r.split("."),u=o.pop();let f=s;for(let p=0;p<o.length;p++){let A=o[p],O=f[A];switch(typeof O){case"undefined":O=f[A]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${o.slice(0,p+1).join(".")} is ${JSON.stringify(O)}`);return}f=O}if(typeof f=="object"&&f!==null)try{f[u]=t}catch(p){a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(f)}`)}else a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(f)}`)}e.addToValueTree=h;function S(s,r){const t=r.split(".");g(s,t)}e.removeFromValueTree=S;function g(s,r){const t=r.shift();if(r.length===0){delete s[t];return}if(Object.keys(s).indexOf(t)!==-1){const a=s[t];typeof a=="object"&&!Array.isArray(a)&&(g(a,r),Object.keys(a).length===0&&delete s[t])}}function v(s,r,t){function a(f,p){let A=f;for(const O of p){if(typeof A!="object"||A===null)return;A=A[O]}return A}const o=r.split("."),u=a(s,o);return typeof u=="undefined"?t:u}e.getConfigurationValue=v;function y(s,r,t){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?T.isObject(s[a])&&T.isObject(r[a])?y(s[a],r[a],t):t&&(s[a]=r[a]):s[a]=r[a])})}e.merge=y;function d(){const s=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=d;function c(){const s=Object.create(null),r=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let t in r){let a=r[t].default;h(s,t,a,o=>console.error(`Conflict in default settings: ${o}`))}return s}e.getDefaultValues=c;function l(s){return`[${s}]`}e.keyFromOverrideIdentifier=l;function n(s,r,t){const a=s.inspect(r),o=s.inspect(t);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:a.defaultValue}e.getMigratedSettingValue=n}),define(te[88],ne([0,1,17,3,33,2,40,26,18,9,21,38,35]),function(J,e,D,T,P,R,k,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(n={},s=[],r=[]){this._contents=n,this._keys=s,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,s){const r=this.getContentsForOverrideIdentifer(s);return r?n?(0,i.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){for(const s of this.overrides)if(s.identifiers.indexOf(n)!==-1)return s.keys;return[]}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=C.deepClone(this.contents),r=C.deepClone(this.overrides),t=[...this.keys];for(const a of n){this.mergeContents(s,a.contents);for(const o of a.overrides){const[u]=r.filter(f=>D.equals(f.identifiers,o.identifiers));u?this.mergeContents(u.contents,o.contents):r.push(C.deepClone(o))}for(const o of a.keys)t.indexOf(o)===-1&&t.push(o)}return new E(s,t,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const t of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[t],o=s[t];o&&(typeof a=="object"&&typeof o=="object"?(a=C.deepClone(a),this.mergeContents(a,o)):a=o),r[t]=a}return new E(r,this.keys,this.overrides)}mergeContents(n,s){for(const r of Object.keys(s)){if(r in n&&w.isObject(n[r])&&w.isObject(s[r])){this.mergeContents(n[r],s[r]);continue}n[r]=C.deepClone(s[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?C.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const s of this.overrides)if(s.identifiers.indexOf(n)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,s){this.addKey(n),(0,i.addToValueTree)(this.contents,n,s,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let s=this.keys.length;for(let r=0;r<s;r++)n.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,n)}removeKey(n){let s=this.keys.indexOf(n);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=E;class h extends E{constructor(){const n=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),r=[];for(const t of Object.keys(n))I.OVERRIDE_PROPERTY_PATTERN.test(t)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(t).trim()],keys:Object.keys(n[t]),contents:(0,i.toValuesTree)(n[t],a=>console.error(`Conflict in default settings file: ${a}`))});super(n,s,r)}}e.DefaultConfigurationModel=h;class S{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!w.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:r,keys:t,overrides:a,restricted:o}=this.doParseRaw(n,s);this._configurationModel=new E(r,t,a),this._restrictedConfigurations=o||[]}doParseContent(n){let s={},r=null,t=[],a=[],o=[];function u(p){Array.isArray(t)?t.push(p):r!==null&&(t[r]=p)}let f={onObjectBegin:()=>{let p={};u(p),a.push(t),t=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{let p=[];u(p),a.push(t),t=p,r=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:u,onError:(p,A,O)=>{o.push({error:p,offset:A,length:O})}};if(n)try{P.visit(n,f),s=t[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return s}doParseRaw(n,s){const r=m.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),t=this.filter(n,r,!0,s);n=t.raw;const a=(0,i.toValuesTree)(n,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),o=Object.keys(n),u=(0,i.toOverrides)(n,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:a,keys:o,overrides:u,restricted:t.restricted}}filter(n,s,r,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:n,restricted:[]};const a={},o=[];for(let u in n)if(I.OVERRIDE_PROPERTY_PATTERN.test(u)&&r){const f=this.filter(n[u],s,!1,t);a[u]=f.raw,o.push(...f.restricted)}else{const f=s[u],p=f?typeof f.scope!="undefined"?f.scope:3:void 0;f?.restricted&&o.push(u),(p===void 0||t.scopes===void 0||t.scopes.includes(p))&&(t.skipRestricted&&f?.restricted||(a[u]=n[u]))}return{raw:a,restricted:o}}}e.ConfigurationModelParser=S;class g extends R.Disposable{constructor(n,s,r,t){super();this.userSettingsResource=n,this.scopes=s,this.fileService=t,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class v{constructor(n,s,r=new E,t=new E,a=new k.ResourceMap,o=new E,u=new k.ResourceMap,f=!0){this._defaultConfiguration=n,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=t,this._folderConfigurations=a,this._memoryConfiguration=o,this._memoryConfigurationByResource=u,this._freeze=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(n,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(n)}updateValue(n,s,r={}){let t;r.resource?(t=this._memoryConfigurationByResource.get(r.resource),t||(t=new E,this._memoryConfigurationByResource.set(r.resource,t))):t=this._memoryConfiguration,s===void 0?t.removeValue(n):t.setValue(n,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,r){const t=this.getConsolidateConfigurationModel(s,r),a=this.getFolderConfigurationModelForResource(s.resource,r),o=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),f=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),p=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),O=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,M=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(n):a.freeze().getValue(n):void 0,q=s.overrideIdentifier?o.override(s.overrideIdentifier).getValue(n):o.getValue(n),N=t.getValue(n),L=D.distinct(D.flatten(t.overrides.map($=>$.identifiers))).filter($=>t.getOverrideValue(n,$)!==void 0);return{defaultValue:u,userValue:f,userLocalValue:p,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:M,memoryValue:q,value:N,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,user:f!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,workspaceFolder:M!==void 0?{value:a?.freeze().getValue(n),override:s.overrideIdentifier?a?.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,memory:q!==void 0?{value:o.getValue(n),override:s.overrideIdentifier?o.getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:L.length?L:void 0}}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const r=s.filter(t=>I.OVERRIDE_PROPERTY_PATTERN.test(t)).map(t=>{const a=(0,I.overrideIdentifierFromKey)(t),o=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=n.getKeysForOverrideIdentifier(a),f=[...u.filter(p=>o.indexOf(p)===-1),...o.filter(p=>u.indexOf(p)===-1),...o.filter(p=>!C.equals(this._defaultConfiguration.override(a).getValue(p),n.override(a).getValue(p)))];return[a,f]});return this.updateDefaultConfiguration(n),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:r,removed:t,overrides:a}=(0,i.compare)(this.localUserConfiguration,n),o=[...s,...r,...t];return o.length&&this.updateLocalUserConfiguration(n),{keys:o,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:r,removed:t,overrides:a}=(0,i.compare)(this.remoteUserConfiguration,n);let o=[...s,...r,...t];return o.length&&this.updateRemoteUserConfiguration(n),{keys:o,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:r,removed:t,overrides:a}=(0,i.compare)(this.workspaceConfiguration,n);let o=[...s,...r,...t];return o.length&&this.updateWorkspaceConfiguration(n),{keys:o,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const r=this.folderConfigurations.get(n),{added:t,updated:a,removed:o,overrides:u}=(0,i.compare)(r,s);let f=[...t,...a,...o];return(f.length||!r)&&this.updateFolderConfiguration(n,s),{keys:f,overrides:u}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:t,removed:a,overrides:o}=(0,i.compare)(s,void 0);return{keys:[...r,...t,...a],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,s){let r=this.getConsolidatedConfigurationModelForResource(n,s);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const t=s.getFolder(n);t&&(r=this.getFolderConsolidatedConfiguration(t.uri)||r);const a=this._memoryConfigurationByResource.get(n);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(n);t?(s=r.merge(t),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(n,s)):s=r}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const r=s.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:r,overrides:t,keys:a}=this._folderConfigurations.get(s);return n.push([s,{contents:r,overrides:t,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>n.add(s)),this.userConfiguration.freeze().keys.forEach(s=>n.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),t=this.parseConfigurationModel(n.workspace),a=n.folders.reduce((o,u)=>(o.set(b.URI.revive(u[0]),this.parseConfigurationModel(u[1])),o),new k.ResourceMap);return new v(s,r,new E,t,a,new E,new k.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=v;function y(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const n=new Set,s=new Map;for(const t of l)t.keys.forEach(a=>n.add(a)),t.overrides.forEach(([a,o])=>{const u=(0,k.getOrSet)(s,a,new Set);o.forEach(f=>u.add(f))});const r=[];return s.forEach((t,a)=>r.push([a,[...t.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=y;class d{constructor(n,s,r,t){this.change=n,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=t,this._previousConfiguration=void 0;const a=new Set;n.keys.forEach(u=>a.add(u)),n.overrides.forEach(([,u])=>u.forEach(f=>a.add(f))),this.affectedKeys=[...a.values()];const o=new E;this.affectedKeys.forEach(u=>o.setValue(u,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!C.equals(r,t)}return!0}return!1}doesAffectedKeysTreeContains(n,s){let r=(0,i.toValuesTree)({[s]:!0},()=>{}),t;for(;typeof r=="object"&&(t=Object.keys(r)[0]);){if(n=n[t],!n)return!1;r=r[t]}return!0}}e.ConfigurationChangeEvent=d;class c extends d{constructor(n,s,r,t){super({keys:n.allKeys(),overrides:[]},void 0,n,s);this.source=r,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=c}),define(te[182],ne([0,1,5,3,2,16,21,88,38,35]),function(J,e,D,T,P,R,k,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends P.Disposable{constructor(m,E){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,E)),this.configuration=new C.Configuration(new C.DefaultConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new C.Configuration(new C.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,E){const h=typeof m=="string"?m:void 0,S=(0,k.isConfigurationOverrides)(m)?m:(0,k.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(h,S,void 0)}updateValue(m,E,h,S){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const E=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(h,E,1)}onDidDefaultConfigurationChange(m){const E=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new C.DefaultConfigurationModel,m);this.trigger(h,E,6)}trigger(m,E,h){const S=new C.ConfigurationChangeEvent(m,{data:E},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(te[183],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends Error{constructor(k,C=T.Unknown,w){super(k);this._message=k,this._code=C,this._detail=w,this.isHandled=C===T.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(k){return k instanceof P&&k._code===T.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof P&&k._code===T.NoResolverFound}static isHandled(k){return k instanceof P&&k.isHandled}}e.RemoteAuthorityResolverError=P}),define(te[184],ne([0,1,5,19,27,7,3,2,29,71,183]),function(J,e,D,T,P,R,k,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var m;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function E(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(U){const B=new P.CancellationTokenSource;return setTimeout(()=>B.cancel(),U),B.token}function S(U,B){if(U.isCancellationRequested||B.isCancellationRequested)return P.CancellationToken.Cancelled;const j=new P.CancellationTokenSource;return U.onCancellationRequested(()=>j.cancel()),B.onCancellationRequested(()=>j.cancel()),j.token}class g{constructor(B){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((j,Q)=>{this._resolvePromise=j,this._rejectPromise=Q}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function v(U,B){const j=new g(B);return j.registerDisposable(U.onControlMessage(Q=>{const Z=JSON.parse(Q.toString()),G=V(Z);G?j.reject(G):j.resolve(Z)})),j.promise}function y(U,B,j,Q,Z,G){const H=new g(G);return B.connect(j,Q,Z,(re,ie)=>{H.didTimeout?(re&&U.error(re),ie?.dispose()):re||!ie?H.reject(re):H.resolve(ie)}),H.promise}function d(U,B){const j=new g(B);return U.then(Q=>{j.didTimeout||j.resolve(Q)},Q=>{j.didTimeout||j.reject(Q)}),j.promise}async function c(U,B,j,Q){const Z=z(U,B);U.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let G;try{G=await y(U.logService,U.socketFactory,U.host,U.port,`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,Q)}catch(le){throw U.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),U.logService.error(le),le}U.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let H,re;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(G,null),H=U.reconnectionProtocol,re=!1):(H=new b.PersistentProtocol(G,null),re=!0),U.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ie=await d(U.signService.createNewMessage((0,w.generateUuid)()),Q),ce={type:"auth",auth:U.connectionToken||"00000000000000000000",data:ie.data};H.sendControl(T.VSBuffer.fromString(JSON.stringify(ce)));try{const le=await v(H,S(Q,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(U.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await d(U.signService.validate(ie,le.signedData),Q)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const fe=await d(U.signService.sign(le.data),Q),be={type:"connectionType",commit:U.commit,signedData:fe,desiredConnectionType:B};return j&&(be.args=j),U.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(T.VSBuffer.fromString(JSON.stringify(be))),{protocol:H,ownsProtocol:re}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(U.logService.error(`${Z} the handshake timed out. Error:`),U.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${Z} received error control message when negotiating connection. Error:`),U.logService.error(le)),re&&F(H),le}}async function l(U,B,j,Q){const Z=Date.now(),G=z(U,B),{protocol:H,ownsProtocol:re}=await c(U,B,j,Q),ie=new g(Q);return ie.registerDisposable(H.onControlMessage(ce=>{const le=JSON.parse(ce.toString()),de=V(le);de?(U.logService.error(`${G} received error control message when negotiating connection. Error:`),U.logService.error(de),re&&F(H),ie.reject(de)):(U.reconnectionProtocol&&U.reconnectionProtocol.endAcceptReconnection(),U.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${K(Z)}!`),ie.resolve({protocol:H,firstMessage:le}))})),ie.promise}async function n(U,B){const{protocol:j}=await l(U,1,void 0,B);return{protocol:j}}async function s(U,B,j){const{protocol:Q,firstMessage:Z}=await l(U,2,B,j),G=Z&&Z.debugPort;return{protocol:Q,debugPort:G}}async function r(U,B,j){const Q=Date.now(),Z=z(U,3),{protocol:G}=await c(U,3,B,j);return U.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${K(Q)}!`),G}async function t(U,B,j){const{host:Q,port:Z,connectionToken:G}=await U.addressProvider.getAddress();return{commit:U.commit,host:Q,port:Z,connectionToken:G,reconnectionToken:B,reconnectionProtocol:j,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function a(U,B,j){try{const Q=(0,w.generateUuid)(),Z=await t(U,Q,null),{protocol:G}=await n(Z,P.CancellationToken.None);return new $(U,B,j,Q,G)}catch(Q){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(Q),L.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=a;async function o(U,B){try{const j=(0,w.generateUuid)(),Q=await t(U,j,null),{protocol:Z,debugPort:G}=await s(Q,B,P.CancellationToken.None);return new _(U,B,j,Z,G)}catch(j){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(j),L.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(j)),j}}e.connectRemoteAgentExtensionHost=o;async function u(U,B,j){const Q=await t(U,(0,w.generateUuid)(),null);return await r(Q,{host:B,port:j},P.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function f(U){return(0,D.createCancelablePromise)(B=>new Promise((j,Q)=>{const Z=setTimeout(j,U*1e3);B.onCancellationRequested(()=>{clearTimeout(Z),j()})}))}var p;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(p=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(B,j){this.reconnectionToken=B,this.millisSinceLastIncomingData=j,this.type=0}}e.ConnectionLostEvent=A;class O{constructor(B,j,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=j,this.durationSeconds=Q,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class M{constructor(B,j,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=j,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=M;class q{constructor(B,j,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=j,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=q;class N{constructor(B,j,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=j,this.attempt=Q,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=N;class L extends C.Disposable{constructor(B,j,Q,Z){super();this._connectionType=B,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=j,this.reconnectionToken=Q,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new q(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(G=>{const H=x(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const G=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${G} received socket timeout event.`),this._beginReconnecting()})),L._instances.push(this),L._permanentFailure&&this._gotoPermanentFailure(L._permanentFailureMillisSinceLastIncomingData,L._permanentFailureAttempt,L._permanentFailureHandled)}static triggerPermanentFailure(B,j,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=j,this._permanentFailureHandled=Q,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(L._permanentFailure)return;const B=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const Z=Q<j.length?j[Q]:j[j.length-1];try{if(Z>0){const H=f(Z);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,H)),this._options.logService.info(`${B} waiting for ${Z} seconds before reconnecting...`);try{await H}catch{}}if(L._permanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${B} resolving connection...`);const G=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,h(I)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,R.isPromiseCanceledError)(G)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,i.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!L._permanentFailure)}_gotoPermanentFailure(B,j,Q){this._onDidStateChange.fire(new N(this.reconnectionToken,B,j,Q)),F(this.protocol)}}L._permanentFailure=!1,L._permanentFailureMillisSinceLastIncomingData=0,L._permanentFailureAttempt=0,L._permanentFailureHandled=!1,L._instances=[];class $ extends L{constructor(B,j,Q,Z,G){super(1,B,Z,G);this.client=this._register(new b.Client(G,{remoteAuthority:j,clientId:Q},B.ipcLogger))}async _reconnect(B,j){await n(B,j)}}e.ManagementPersistentConnection=$;class _ extends L{constructor(B,j,Q,Z,G){super(2,B,Q,Z);this._startArguments=j,this.debugPort=G}async _reconnect(B,j){await s(B,this._startArguments,j)}}e.ExtensionHostPersistentConnection=_;function F(U){try{U.acceptDisconnect();const B=U.getSocket();U.dispose(),B.dispose()}catch(B){(0,R.onUnexpectedError)(B)}}function V(U){if(U&&U.type==="error"){const B=new Error(`Connection error: ${U.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function W(U,B){for(;U.length<B;)U+=" ";return U}function x(U,B,j){return`[remote-connection][${W(E(U),13)}][${B.substr(0,5)}\u2026][${j?"reconnect":"initial"}]`}function z(U,B){return`${x(B,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function K(U){return`${Date.now()-U} ms`}}),define(te[185],ne([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function T(b){return b.scheme===D.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=T;function P(b){if(!b)return;const i=b.indexOf("+");return i<0?b:b.substr(0,i)}e.getRemoteName=P;function R(b){return b.scheme!==D.Schemas.file&&b.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=R;function k(b){if(b.folders.length)return b.folders.every(i=>R(i.uri))?b.folders[0].uri:void 0;if(b.configuration&&R(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=k;function C(b){return k(b)?.scheme}e.getVirtualWorkspaceScheme=C;function w(b){return k(b)!==void 0}e.isVirtualWorkspace=w}),define(te[89],ne([0,1,25,6,185]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=R;function k(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class w{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,h){if(typeof E=="undefined"||E===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof E=="string"||typeof h=="string"){let S=typeof E=="string"?E:E.value,g=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(S,g)}return E._lower===h._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=w;function b(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function i(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function I(m,E){if(E&&m.enableProposedApi){const h=`onResolveRemoteAuthority:${(0,P.getRemoteName)(E)}`;return m.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[36],ne([0,1,25,89]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(h,S){return h.uuid&&S.uuid?h.uuid===S.uuid:h.id===S.id?!0:(0,D.compareIgnoreCase)(h.id,S.id)===0}e.areSameExtensions=P;class R{constructor(S,g){this.version=g,this.id=S.id,this.uuid=S.uuid}key(){return`${this.id}-${this.version}`}equals(S){return S instanceof R?P(this,S)&&this.version===S.version:!1}}e.ExtensionIdentifierWithVersion=R;function k(h,S){return`${h}.${S}`}e.getExtensionId=k;function C(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function w(h,S){return C(k(h,S))}e.getGalleryExtensionId=w;function b(h,S){const g=[],v=y=>{for(const d of g)if(d.some(c=>P(S(c),S(y))))return d;return null};for(const y of h){const d=v(y);d?d.push(y):g.push([y])}return g}e.groupByExtension=b;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function m(h){const S=new Set;for(const g of h)g.malicious&&S.add(g.id.id);return S}e.getMaliciousExtensionsSet=m;function E(h,S){const g=[],v=S.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const y=v.shift();if(y&&g.every(d=>!P(d.identifier,{id:y}))){const d=h.filter(c=>P(c.identifier,{id:y}));d.length===1&&(g.push(d[0]),v.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=E}),define(te[186],ne([0,1,5,7,2,4,16,61,9,29,20,13,30,36,14,10]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends P.Disposable{constructor(d,c,l,n){super();this.fileService=c,this.extensionGalleryService=l,this.logService=n,this.extensionsDownloadDir=w.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,c){await this.cleanUpPromise;const l=this.getName(d),n=(0,k.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(n)){const s=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(d,s,c);try{await this.rename(s,n,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch(t){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return n}async delete(d){await this.cleanUpPromise,await this.fileService.del(d)}async rename(d,c,l){try{await i.Promises.rename(d.fsPath,c.fsPath)}catch(n){if(R.isWindows&&n&&n.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${d} to ${c} with 'EPERM' error. Trying again...`),this.rename(d,c,l);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const c=[],l=[];for(const r of d.children){const t=this.parse(r.name);t&&l.push([t,r])}const n=(0,E.groupByExtension)(l,([r])=>r),s=[];for(const r of n)r.sort((t,a)=>C.rcompare(t[0].version,a[0].version)),c.push(...r.slice(1).map(t=>t[1].resource)),s.push(r[0][1]);s.sort((r,t)=>r.mtime-t.mtime),c.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(c.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?`${new E.ExtensionIdentifierWithVersion(d.identifier,d.version).key().toLowerCase()}${d.properties.targetPlatform!=="undefined"?`-${d.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(d){const c=g.exec(d);return c&&c[1]&&c[2]?new E.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};v=he([X(0,I.INativeEnvironmentService),X(1,h.IFileService),X(2,m.IExtensionGalleryService),X(3,S.ILogService)],v),e.ExtensionsDownloader=v}),define(te[187],ne([0,1,2,8,20,89]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends D.Disposable{constructor(w,b){super();this.environmentService=w,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(b.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(w){w.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(w){w.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(te[188],ne([0,1,3,2,16,9,13,36,14,10]),function(J,e,D,T,P,R,k,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends T.Disposable{constructor(m,E,h,S){super();this.extensionsManagementService=m,this.logService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(y=>this.onInstallExtension(y))),this._register(m.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(m.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const g=R.URI.file(h.extensionsPath),v=new P.ExtUri(y=>!E.hasCapability(y,1024));this._register(E.watch(g)),this._register(D.Event.filter(E.onDidChangeFilesRaw,y=>y.changes.some(d=>this.doesChangeAffects(d,g,v)))(()=>this.onDidChange()))}doesChangeAffects(m,E,h){return h.isEqual(h.dirname(m.resource),E)?h.isEqual(m.resource,h.joinPath(E,".obsolete"))?!0:!(m.type!==1&&m.type!==2||h.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const E of m)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(E=>!(0,C.areSameExtensions)(E,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,C.areSameExtensions)(E,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),E=m.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,C.areSameExtensions)(g,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(g=>(0,C.areSameExtensions)(g,S))?!1:m.every(g=>!(0,C.areSameExtensions)(g.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=m.map(S=>S.identifier),(E.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:h})}}};i=he([X(1,w.IFileService),X(2,k.INativeEnvironmentService),X(3,b.ILogService)],i),e.ExtensionsWatcher=i}),define(te[189],ne([0,1,82,17,5,2,15,8,20,13,30,36,58,10]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends R.Disposable{constructor(v,y,d){super();this.extensionManagementService=v,this.logService=d,this.cache=this._register(new S(y,d)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const v=await this.cache.getLanguagePacks(),y=["en",...Object.keys(v)];return(0,T.distinct)(y)}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const y=await this.cache.getLanguagePacks();Object.keys(y).some(d=>y[d]&&y[d].extensions.some(c=>(0,I.areSameExtensions)(c.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),d=await this.cache.update(y);return!(0,T.equals)(Object.keys(v),Object.keys(d))}};h=he([X(0,i.IExtensionManagementService),X(1,b.INativeEnvironmentService),X(2,E.ILogService)],h),e.LocalizationsService=h;let S=class extends R.Disposable{constructor(v,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(y=>{Object.keys(y).forEach(d=>delete y[d]),this.createLanguagePacksFromExtensions(y,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...y){for(const d of y)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,d);Object.keys(v).forEach(d=>this.updateHash(v[d]))}createLanguagePacksFromExtension(v,y){const d=y.identifier,c=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const l of c)if(y.location.scheme===k.Schemas.file&&(0,m.isValidLocalization)(l)){let n=v[l.languageId];n||(n={hash:"",extensions:[],translations:{}},v[l.languageId]=n);let s=n.extensions.filter(r=>(0,I.areSameExtensions)(r.extensionIdentifier,d))[0];s?s.version=y.manifest.version:n.extensions.push({extensionIdentifier:d,version:y.manifest.version});for(const r of l.translations)n.translations[r.id]=(0,C.join)(y.location.fsPath,r.path)}}updateHash(v){if(v){const y=(0,D.createHash)("md5");for(const d of v.extensions)y.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);v.hash=y.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return w.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch(c){return{}}}).then(d=>(y=v(d),d)).then(d=>{for(const l of Object.keys(d))d[l]||delete d[l];this.languagePacks=d,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),w.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>y,d=>this.logService.error(d))})}};S=he([X(0,b.INativeEnvironmentService),X(1,E.ILogService)],S)}),define(te[190],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,10]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,P.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,P.createDecorator)("sharedTunnelsService");var k;(function(h){h.Http="http",h.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const S=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!S)return{address:S[1],port:+S[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function m(h,S){return S?S!==1&&h<1024:!T.isWindows&&h<1024}e.isPortPrivileged=m;let E=class{constructor(S){this.logService=S,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(S,g){return this._tunnelProvider=S,S?(this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const S=[],g=Array.from(this._tunnels.values());for(let v of g){const y=Array.from(v.values());for(let d of y){const c=await d.value;c&&S.push(c)}}return S}async dispose(){for(const S of this._tunnels.values()){for(const{value:g}of S.values())await g.then(v=>v?.dispose());S.clear()}this._tunnels.clear()}openTunnel(S,g,v,y,d=!1,c=C.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${v} on local port ${y}.`),!S)return;g||(g="localhost");const n=this.retainOrCreateTunnel(S,g,v,y,d,c,l);return n?n.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(s);return(s.tunnelRemoteHost!==g||s.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(S){return{tunnelRemotePort:S.tunnelRemotePort,tunnelRemoteHost:S.tunnelRemoteHost,tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress,privacy:S.privacy,protocol:S.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${S.tunnelRemoteHost}:${S.tunnelRemotePort} `);const g=this._tunnels.get(S.tunnelRemoteHost);if(g){const v=g.get(S.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(S.tunnelRemoteHost,S.tunnelRemotePort,v))}}}}async tryDisposeTunnel(S,g,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${S}:${g}.`);const y=v.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(S)&&this._tunnels.get(S).delete(g),y}}async closeTunnel(S,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${S}:${g} `);const v=this._tunnels.get(S);if(v&&v.has(g)){const y=v.get(g);y.refcount=0,await this.tryDisposeTunnel(S,g,y)}}addTunnelToMap(S,g,v){this._tunnels.has(S)||this._tunnels.set(S,new Map),this._tunnels.get(S).set(g,{refcount:1,value:v})}async removeEmptyTunnelFromMap(S,g){const v=this._tunnels.get(S);v&&(await v.get(g)||v.delete(g),v.size===0&&this._tunnels.delete(S))}getTunnelFromMap(S,g){let v=[S];i(S)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):I(S)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const y=v.map(d=>this._tunnels.get(d));for(const d of y){const c=d?.get(g);if(c)return c}}canTunnel(S){return!!b(S)}createWithProvider(S,g,v,y,d,c,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${v} on local port ${y}.`);const s={elevationRequired:d?m(y===void 0?v:y):!1},r={remoteAddress:{host:g,port:v},localAddressPort:y,privacy:c,public:c!==C.Private,protocol:l},t=S.forwardPort(r,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(g,v,t),t}};E=he([X(0,R.ILogService)],E),e.AbstractTunnelService=E}),define(te[191],ne([0,1,10,62,2,7,5]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class C extends P.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(i){this._address=i,this._addressPromise&&(this._addressPromise.complete(i),this._addressPromise=null)}setTunnel(i){this._register(i)}}let w=class St extends P.Disposable{constructor(i,I){super();this._tunnelService=i,this._logService=I,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(i=>i.dispose())}async createTunnel(){return{id:String(++St._lastId)}}async startTunnel(i,I,m,E,h,S){const g=new C,v=await Promise.resolve(this._tunnelService.openTunnel(i,g,m,E,h,S));if(!v)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${E} (remote).`),g.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(I))throw this._disposedTunnels.delete(I),g.dispose(),await v.dispose(),(0,R.canceled)();return g.setTunnel(v),this._tunnels.set(I,g),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${I}: ${v.localAddress} (local) to ${m}:${E} (remote).`),{tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress}}async setAddress(i,I){const m=this._tunnels.get(i);!m||m.setAddress(I)}async destroyTunnel(i){const I=this._tunnels.get(i);if(I){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${i}.`),this._tunnels.delete(i),await I.dispose();return}this._disposedTunnels.add(i)}};w._lastId=0,w=he([X(0,T.ISharedTunnelsService),X(1,D.ILogService)],w),e.SharedProcessTunnelService=w}),define(te[192],ne([0,1,120,21,10]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(C,w){this.configurationService=C,this.logService=w}request(C,w){return this.logService.trace("RequestService#request",C.url),C.proxyAuthorization||(C.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(C,w)}async resolveProxy(C){}};R=he([X(0,T.IConfigurationService),X(1,P.ILogService)],R),e.RequestService=R}),define(te[43],ne([0,1,19,141,38,6,35]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function C(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=C;function w(h){return h.res.statusCode===204}async function b(h){if(!C(h))throw new Error("Server returned "+h.res.statusCode);return w(h)?null:(await(0,D.streamToBuffer)(h.stream)).toString()}e.asText=b;async function i(h){if(!C(h))throw new Error("Server returned "+h.res.statusCode);if(w(h))return null;const g=(await(0,D.streamToBuffer)(h.stream)).toString();try{return JSON.parse(g)}catch(v){throw v.message+=`:
`+g,v}}e.asJson=i;function I(h){E(h)}e.updateProxyConfigurationsScope=I;let m;function E(h){const S=k.Registry.as(P.Extensions.Configuration),g=m;m={id:"http",order:15,title:(0,T.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(4,null),(0,T.localize)(5,null),(0,T.localize)(6,null),(0,T.localize)(7,null)],default:"override",description:(0,T.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[m],remove:g?[g]:[]})}E(2)}),define(te[193],ne([0,1,27,15,14,43]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(w,b){this.requestService=w,this.fileService=b}async download(w,b,i=D.CancellationToken.None){if(w.scheme===T.Schemas.file||w.scheme===T.Schemas.vscodeRemote){await this.fileService.copy(w,b);return}const I={type:"GET",url:w.toString()},m=await this.requestService.request(I,i);if(m.res.statusCode===200)await this.fileService.writeFile(b,m.stream);else{const E=await(0,R.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${E}`)}}};k=he([X(0,R.IRequestService),X(1,P.IFileService)],k),e.DownloadService=k}),define(te[194],ne([0,1,17,27,66,2,16,153,14,10,28,43]),function(J,e,D,T,P,R,k,C,w,b,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends R.Disposable{constructor(h,S,g,v){super();this.fileService=h,this.productService=S,this.requestService=g,this.logService=v,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,P.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const S=[];for(const[g,v]of this.allConfigBasedTips)if(!(v.configScheme&&v.configScheme!==h.scheme))try{const y=await this.fileService.readFile((0,k.joinPath)(h,g)),d=new Map;(0,P.forEach)(v.recommendations,({key:l,value:n})=>{if((0,D.isNonEmptyArray)(n.remotes))for(const s of n.remotes)d.set(s,{extensionId:l,extensionName:n.name,configName:v.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack});else S.push({extensionId:l,extensionName:n.name,configName:v.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack})});const c=(0,C.getDomainsOfRemotes)(y.value.toString(),[...d.keys()]);for(const l of c){const n=d.get(l);n&&S.push(n)}}catch(y){}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},T.CancellationToken.None);if(h.res.statusCode!==200)return[];const S=await(0,I.asJson)(h);return S?S.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};m=he([X(0,w.IFileService),X(1,i.IProductService),X(2,I.IRequestService),X(3,b.ILogService)],m),e.ExtensionTipsService=m}),define(te[46],ne([0,1,19,29]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(R,k,C){let w=C&&C.get("storage.serviceMachineId",0)||null;if(w)return w;try{const i=(await k.readFile(R.serviceMachineIdResource)).value.toString();w=(0,T.isUUID)(i)?i:null}catch(b){w=null}if(!w){w=(0,T.generateUuid)();try{await k.writeFile(R.serviceMachineIdResource,D.VSBuffer.fromString(w))}catch(b){}}return C&&C.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=P}),define(te[90],ne([0,1,104,6]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function P(R){return(0,D.hash)({moduleId:R.process.moduleId,windowId:R.reply.windowId})}e.hash=P,e.ISharedProcessWorkerService=(0,T.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[195],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(T){T.Spawn="vscode:shared-process->shared-process-worker=spawn",T.Terminate="vscode:shared-process->shared-process-worker=terminate",T.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",T.Ready="vscode:shared-process-worker->shared-process=ready",T.Ack="vscode:shared-process-worker->shared-process=ack",T.Trace="vscode:shared-process-worker->shared-process=trace",T.Info="vscode:shared-process-worker->shared-process=info",T.Warn="vscode:shared-process-worker->shared-process=warn",T.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[196],ne([0,1,72,27,3,2,15,29,10,90,195]),function(J,e,D,T,P,R,k,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let I=class{constructor(h){this.logService=h,this.workers=new Map,this.processes=new Map}async createWorker(h){const S=`window: ${h.reply.windowId}, moduleId: ${h.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${S})`);const g=(0,b.hash)(h);this.processes.has(g)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${S})`),this.disposeWorker(h));const v=new T.CancellationTokenSource;let y,d,c;if(this.processes.set(g,(0,R.toDisposable)(()=>{v.dispose(!0),y?.terminate(h,T.CancellationToken.None),d?.close(),c?.close(),this.processes.delete(g)})),y=await this.getOrCreateWebWorker(h),v.token.isCancellationRequested)return;const{port1:l,port2:n}=new MessageChannel;d=l,c=n,await y.spawn(h,c,v.token),!v.token.isCancellationRequested&&(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${S})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",h,[d]))}getOrCreateWebWorker(h){let S=this.workers.get(h.process.moduleId);if(!S){this.logService.trace(`SharedProcess: creating new web worker (${h.process.moduleId})`);const g=new m(h.process.type,this.logService);S=g.init(),g.onDidProcessSelfTerminate(v=>{this.disposeWorker(v)}),this.workers.set(h.process.moduleId,S)}return S}async disposeWorker(h){const S=this.processes.get((0,b.hash)(h));S&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${h.reply.windowId}, moduleId: ${h.process.moduleId})`),S.dispose())}};I=he([X(0,w.ILogService)],I),e.SharedProcessWorkerService=I;class m extends R.Disposable{constructor(h,S){super();this.type=h,this.logService=S,this._onDidProcessSelfTerminate=this._register(new P.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){let h;const S=new Promise(v=>h=v),g=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return g.onerror=v=>{this.logService.error(`SharedProcess: worker error (${this.type})`,v.message)},g.onmessageerror=v=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,v)},g.onmessage=v=>{const{id:y,message:d,configuration:c,nonce:l}=v.data;switch(y){case i.SharedProcessWorkerMessages.Ready:h(g);break;case i.SharedProcessWorkerMessages.Ack:if(l){const n=this.mapMessageNonceToPendingMessageResolve.get(l);n&&(this.mapMessageNonceToPendingMessageResolve.delete(l),n())}break;case i.SharedProcessWorkerMessages.SelfTerminated:c&&this._onDidProcessSelfTerminate.fire(c);break;case i.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,d);break;case i.SharedProcessWorkerMessages.Info:d&&this.logService.info(d);break;case i.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,d);break;case i.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,d);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,v)}},g.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S}async send(h,S,g){const v=await this.workerReady;if(!S.isCancellationRequested)return new Promise(y=>{const d=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(d,y);const c={...h,nonce:d};g?v.postMessage(c,[g]):v.postMessage(c),S.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(d)&&y()})})}spawn(h,S,g){const v={id:i.SharedProcessWorkerMessages.Spawn,configuration:h,environment:{bootstrapPath:k.FileAccess.asFileUri("bootstrap-fork",J).fsPath}};return this.send(v,g,S)}terminate(h,S){const g={id:i.SharedProcessWorkerMessages.Terminate,configuration:h};return this.send(g,S)}}}),define(te[91],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[197],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((P,R)=>J(["vsda"],P,R))}async createNewMessage(P){try{const R=await this.vsda(),k=new R.validator;if(k){const C=String(D._nextId++);return this.validators.set(C,k),{id:C,data:k.createNewMessage(P)}}}catch(R){}return{id:"",data:P}}async validate(P,R){if(!P.id)return!0;const k=this.validators.get(P.id);if(!k)return!1;this.validators.delete(P.id);try{return k.validate(R)==="ok"}catch(C){return!1}}async sign(P){try{const R=await this.vsda(),k=new R.signer;if(k)return k.sign(P)}catch(R){}return P}}e.SignService=D,D._nextId=1}),define(te[23],ne([0,1,5,3,2,178,18,73,6]),function(J,e,D,T,P,R,k,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,w.createDecorator)("storageService");var i;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(i=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class E extends P.Disposable{constructor(v={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,y){y===b?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:y,target:this.getKeyTargets(v)[y]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,y,d){return this.getStorage(y)?.get(v,d)}getBoolean(v,y,d){return this.getStorage(y)?.getBoolean(v,d)}getNumber(v,y,d){return this.getStorage(y)?.getNumber(v,d)}store(v,y,d,c){if((0,k.isUndefinedOrNull)(y)){this.remove(v,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,d,c),this.getStorage(d)?.set(v,y)})}remove(v,y){this.withPausedEmitters(()=>{this.updateKeyTarget(v,y,void 0),this.getStorage(y)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,y){const d=[],c=this.getKeyTargets(v);for(const l of Object.keys(c))c[l]===y&&d.push(l);return d}updateKeyTarget(v,y,d){const c=this.getKeyTargets(y);typeof d=="number"?c[v]!==d&&(c[v]=d,this.getStorage(y)?.set(b,JSON.stringify(c))):typeof c[v]=="number"&&(delete c[v],this.getStorage(y)?.set(b,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const y=this.get(b,v);if(y)try{return JSON.parse(y)}catch(d){}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=i.NONE){this._onWillSaveState.fire({reason:v}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const v=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return S(v,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends E{constructor(){super();this.globalStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=h;async function S(g,v,y,d){const c=o=>{try{return JSON.parse(o)}catch(u){return o}},l=new Map,n=new Map;g.forEach((o,u)=>{l.set(u,o),n.set(u,c(o))});const s=new Map,r=new Map;v.forEach((o,u)=>{s.set(u,o),r.set(u,c(o))}),console.group(`Storage: Global (path: ${y})`);let t=[];l.forEach((o,u)=>{t.push({key:u,value:o})}),console.table(t),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${d})`);let a=[];s.forEach((o,u)=>{a.push({key:u,value:o})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=S}),define(te[198],ne([0,1,3,2,18,30,36,23]),function(J,e,D,T,P,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let w=class extends T.Disposable{constructor(I){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(I)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"})))}async enableExtension(I,m){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:m}),!0):!1}async disableExtension(I,m){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){let m=this.getDisabledExtensions();return m.every(E=>!(0,k.areSameExtensions)(E,I))?(m.push(I),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(I){let m=this.getDisabledExtensions();for(let E=0;E<m.length;E++){const h=m[E];if((0,k.areSameExtensions)(h,I))return m.splice(E,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(I){this._setExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,m){this.storageManger.set(I,m,0)}};w=he([X(0,C.IStorageService)],w),e.GlobalExtensionEnablementService=w;class b extends T.Disposable{constructor(I){super();this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(I,m){let E;return m===0?((0,P.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,m)),E=this.storage[I]):E=this._get(I,m),JSON.parse(E)}set(I,m,E){let h=JSON.stringify(m.map(({id:g,uuid:v})=>({id:g,uuid:v})));this._get(I,E)!==h&&(E===0&&(m.length?this.storage[I]=h:delete this.storage[I]),this._set(I,m.length?h:void 0,E))}onDidStorageChange(I){if(I.scope===0&&!(0,P.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const E=this.get(I.key,I.scope);delete this.storage[I.key];const h=this.get(I.key,I.scope),S=E.filter(v=>!h.some(y=>(0,k.areSameExtensions)(v,y))),g=h.filter(v=>!E.some(y=>(0,k.areSameExtensions)(y,v)));(S.length||g.length)&&this._onDidChange.fire([...S,...g])}}_get(I,m){return this.storageService.get(I,m,"[]")}_set(I,m,E){m?this.storageService.store(I,m,E,1):this.storageService.remove(I,E)}}e.StorageManager=b}),define(te[199],ne([0,1,3,2]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class P extends T.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i}async getItems(){const b={workspace:this.workspace},i=await this.channel.call("getItems",b);return new Map(i)}updateItems(b){const i={workspace:this.workspace};return b.insert&&(i.insert=Array.from(b.insert.entries())),b.delete&&(i.delete=Array.from(b.delete.values())),this.channel.call("updateItems",i)}}class R extends P{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class k extends P{constructor(b,i){super(b,i);this.onDidChangeItemsExternal=D.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class C extends T.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new R(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=C}),define(te[200],ne([0,1,5,2,16,73,23,199]),function(J,e,D,T,P,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends k.AbstractStorageService{constructor(i,I,m){super();this.mainProcessService=I,this.environmentService=m,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new T.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(i)}createGlobalStorage(){const i=new C.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),I=new R.Storage(i.globalStorage);return this._register(I.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),I}createWorkspaceStorage(i){const I=new C.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),i);if(I.workspaceStorage){const m=new R.Storage(I.workspaceStorage);return this.workspaceStorageDisposable.value=m.onDidChangeStorage(E=>this.emitDidChangeValue(1,E)),this.workspaceStorageId=i?.id,m}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(i){return i===0?this.globalStorage:this.workspaceStorage}getLogDetails(i){return i===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,P.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(i){const I=this.workspaceStorage,m=I?.items??new Map;I&&(await I.close(),I.dispose()),this.workspaceStorage=this.createWorkspaceStorage(i),await this.workspaceStorage.init();for(const[E,h]of m)this.workspaceStorage.set(E,h)}}e.NativeStorageService=w}),define(te[201],ne([0,1,4,31,9,29]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(b){if(D.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function C(b,i,I,m,E,h,S,g,v,y){const d=Object.create(null);d["common.machineId"]=S,d.sessionID=(0,R.generateUuid)()+Date.now(),d.commitHash=E,d.version=h,d["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,D.PlatformToString)(D.platform),d["common.nodePlatform"]=T.platform,d["common.nodeArch"]=m,d["common.product"]=y||"desktop";const c=w(g||[]);c&&(d["common.msftInternal"]=c);let l=0;const n=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(d["common.snap"]="true");const s=k(I);s&&(d["common.platformDetail"]=s);try{const r=await b.readFile(P.URI.file(v));d["common.source"]=r.value.toString().slice(0,30)}catch(r){}return d}e.resolveCommonProperties=C;function w(b){const i=T.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return b.some(m=>I===m)}e.verifyMicrosoftInternalDomain=w}),define(te[22],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[202],ne([0,1,34,55,5,33,15,8,4,9,113,20,116,78,14,28,22]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(n,s){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],t=new Map,a=new Map,o=2e4;function u(A,O,M,q){const N=O.substring(A.length+1);return P.Promises.withAsyncBody(async L=>{let $;try{$=await I.Promises.readdir(O,{withFileTypes:!0})}catch(V){L();return}if(q.count>=o){q.count+=$.length,q.maxReached=!0,L();return}let _=$.length;if(_===0){L();return}let F=$;q.count+$.length>o&&(q.maxReached=!0,_=o-q.count,F=$.slice(0,_)),q.count+=$.length;for(const V of F)if(V.isDirectory()){if(M.includes(V.name)||await u(A,(0,C.join)(O,V.name),M,q),--_==0){L();return}}else{const W=V.name.lastIndexOf(".");if(W>=0){const x=V.name.substring(W+1);x&&t.set(x,(t.get(x)??0)+1)}for(const x of r)x.relativePathPattern?.test(N)!==!1&&x.filePattern.test(V.name)&&a.set(x.tag,(a.get(x.tag)??0)+1);if(--_==0){L();return}}})}const f={count:0,maxReached:!1};await u(n,n,s,f);const p=await c(n);return{configFiles:y(a),fileTypes:y(t),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:p}}e.collectWorkspaceStats=v;function y(n){return[...T.Iterable.map(n.entries(),([s,r])=>({name:s,count:r}))].sort((s,r)=>r.count-s.count)}function d(){const n={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(i.virtualMachineHint.value()*100)}%`},s=D.cpus();return s&&s.length>0&&(n.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),n}e.getMachineInfo=d;async function c(n){try{const s=new Map,r=(0,C.join)(n,".vscode","launch.json"),t=await I.Promises.readFile(r),a=[],o=(0,R.parse)(t.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(o)==="object"&&o.configurations)for(const u of o.configurations){const f=u.type;f&&(s.has(f)?s.set(f,s.get(f)+1):s.set(f,1))}return y(s)}catch(s){return[]}}e.collectLaunchConfigs=c;let l=class{constructor(s,r){this.telemetryService=s,this.productService=r}formatMachineInfo(s){const r=[];return r.push(`OS Version:       ${s.os}`),r.push(`CPUs:             ${s.cpus}`),r.push(`Memory (System):  ${s.memory}`),r.push(`VM:               ${s.vmHint}`),r.join(`
`)}formatEnvironment(s){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const t=D.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${D.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(i.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${s.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(s,r){return Promise.all([(0,m.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async t=>{let[a,o]=t,u=this.formatProcessList(s,a);return r.forEach(f=>{if((0,E.isRemoteDiagnosticError)(f))u+=`
${f.errorMessage}`,o+=`
${f.errorMessage}`;else if(u+=`

Remote: ${f.hostName}`,f.processes&&(u+=`
${this.formatProcessList(s,f.processes)}`),f.workspaceMetadata){o+=`
|  Remote: ${f.hostName}`;for(const p of Object.keys(f.workspaceMetadata)){const A=f.workspaceMetadata[p];let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),o+=`|    Folder (${p}): ${O}`,o+=this.formatWorkspaceStats(A)}}}),{processInfo:u,workspaceInfo:o}})}async getSystemInfo(s,r){const{memory:t,vmHint:a,os:o,cpus:u}=d(),f={os:o,memory:t,cpus:u,vmHint:a,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(f.load=`${D.loadavg().map(p=>Math.round(p)).join(", ")}`),w.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(s,r){const t=[];return(0,m.listProcesses)(s.mainPID).then(async a=>(t.push(""),t.push(this.formatEnvironment(s)),t.push(""),t.push(this.formatProcessList(s,a)),s.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(s))),r.forEach(o=>{if((0,E.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(s,o.processes)),o.workspaceMetadata)for(const u of Object.keys(o.workspaceMetadata)){const f=o.workspaceMetadata[u];let p=`${f.fileCount} files`;f.maxFilesReached&&(p=`more than ${p}`),t.push(`Folder (${u}): ${p}`),t.push(this.formatWorkspaceStats(f))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(s){const r=[],t=60;let a=0;const o=(A,O)=>{const M=` ${A}(${O})`;a+M.length>t?(r.push(u),u="|                 ",a=u.length):a+=M.length,u+=M};let u="|      File types:";const f=10;let p=s.fileTypes.length>f?f:s.fileTypes.length;for(let A=0;A<p;A++){const O=s.fileTypes[A];o(O.name,O.count)}if(r.push(u),s.configFiles.length>=0&&(u="|      Conf files:",a=0,s.configFiles.forEach(A=>{o(A.name,A.count)}),r.push(u)),s.launchConfigFiles.length>0){let A="|      Launch Configs:";s.launchConfigFiles.forEach(O=>{A+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),r.push(A)}return r.join(`
`)}expandGPUFeatures(s){const r=Math.max(...Object.keys(s).map(t=>t.length));return Object.keys(s).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${s[t]}`).join(`
                  `)}formatWorkspaceMetadata(s){const r=[],t=[];return s.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(o=>{const u=b.URI.revive(o);if(u.scheme===k.Schemas.file){const f=u.fsPath;t.push(v(f,["node_modules",".git"]).then(p=>{let A=`${p.fileCount} files`;p.maxFilesReached&&(A=`more than ${A}`),r.push(`|    Folder (${(0,C.basename)(f)}): ${A}`),r.push(this.formatWorkspaceStats(p))}).catch(p=>{r.push(`|      Error: Unable to collect workspace stats for folder ${f} (${p.toString()})`)}))}else r.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(s,r){const t=new Map;s.windows.forEach(o=>t.set(o.pid,o.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(s.mainPID,t,a,r,0),a.join(`
`)}formatProcessItem(s,r,t,a,o){const u=o===0;let f;u?f=a.pid===s?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(o)} ${a.name}`,a.name==="window"&&(f=`${f} (${r.get(a.pid)})`));const p=process.platform==="win32"?a.mem:D.totalmem()*(a.mem/100);t.push(`${a.load.toFixed(0).padStart(5," ")}	${(p/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(a.children)&&a.children.forEach(A=>this.formatProcessItem(s,r,t,A,o+1))}async reportWorkspaceStats(s){for(const{uri:r}of s.folders){const t=b.URI.revive(r);if(t.scheme!==k.Schemas.file)continue;const a=t.fsPath;try{const o=await v(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),o.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),o.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),o.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};l=he([X(0,g.ITelemetryService),X(1,S.IProductService)],l),e.DiagnosticsService=l}),define(te[203],ne([0,1,17,5,27,7,3,2,4,9,130,30,36,10,28,22]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends C.Disposable{constructor(l,n,s,r){super();this.galleryService=l,this.telemetryService=n,this.logService=s,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,C.toDisposable)(()=>{this.installingExtensions.forEach(t=>t.cancel()),this.uninstallingExtensions.forEach(t=>t.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(l){const n=await this.getTargetPlatform();return l.allTargetPlatforms.some(s=>(0,I.isTargetPlatformCompatible)(s,l.allTargetPlatforms,n))}async installFromGallery(l,n={}){if(!this.galleryService.isEnabled())throw new I.ExtensionManagementError(i.localize(0,null),I.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(l)){const r=await this.getTargetPlatform(),t=new I.ExtensionManagementError(i.localize(1,null,l.identifier.id,this.productService.nameLong,(0,I.TargetPlatformToString)(r)),I.ExtensionManagementErrorCode.Incompatible);throw this.logService.error("Cannot install extension.",l.identifier.id,t.message),y(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(l),void 0,t),t}try{l=await this.checkAndGetCompatibleVersion(l,!n.installGivenVersion)}catch(r){throw this.logService.error((0,R.getErrorMessage)(r)),y(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(l),void 0,r),r}const s=await this.galleryService.getManifest(l,P.CancellationToken.None);if(s===null){const r=new I.ExtensionManagementError(`Missing manifest for extension ${l.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);throw this.logService.error("Failed to install extension:",l.identifier.id,r.message),y(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(l),void 0,r),r}if(s.version!==l.version){const r=new I.ExtensionManagementError(`Cannot install '${l.identifier.id}' extension because of version mismatch in Marketplace`,I.ExtensionManagementErrorCode.Invalid);throw this.logService.error(r.message),y(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(l),void 0,r),r}return this.installExtension(s,l,n)}async uninstall(l,n={}){return this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id),this.unininstallExtension(l,n)}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(2,null));const n=await this.findGalleryExtension(l);if(!n)throw new Error(i.localize(3,null));await this.createUninstallExtensionTask(l,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsReport(){const l=new Date().getTime();return(!this.reportedExtensions||l-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=l),this.reportedExtensions}registerParticipant(l){this.participants.push(l)}async installExtension(l,n,s){if(!b.URI.isUri(n)){let u=this.installingExtensions.get(new m.ExtensionIdentifierWithVersion(n.identifier,n.version).key());if(u)return this.logService.info("Extensions is already requested to install",n.identifier.id),u.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],t=[],a=this.createInstallExtensionTask(l,n,s);b.URI.isUri(n)||this.installingExtensions.set(new m.ExtensionIdentifierWithVersion(a.identifier,l.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:n}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:l});let o=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const f=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,l,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:A}of f)if(o=o||!!A.extensionDependencies?.some(O=>(0,m.areSameExtensions)({id:O},a.identifier)),this.installingExtensions.has(new m.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const O=this.createInstallExtensionTask(A,p,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new m.ExtensionIdentifierWithVersion(O.identifier,A.version).key(),O),this._onInstallExtension.fire({identifier:O.identifier,source:p}),this.logService.info("Installing extension:",O.identifier.id),r.push({task:O,manifest:A})}}catch(f){if(b.URI.isUri(a.source))(0,D.isNonEmptyArray)(l.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,f.message),(0,D.isNonEmptyArray)(l.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,f.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(f),f}const u=r.reduce((f,{task:p,manifest:A})=>(f.set(p.identifier.id.toLowerCase(),{task:p,manifest:A}),f),new Map);for(;u.size;){let f;const p=[...u.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(O=>u.has(O.toLowerCase())));p.length?f=u.size===1?p:p.filter(({task:A})=>!(A===a&&!o)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:A})=>A.identifier.id)),f=[...u.values()]),await this.joinAllSettled(f.map(async({task:A})=>{const O=new Date().getTime();try{const M=await A.run();if(await this.joinAllSettled(this.participants.map(q=>q.postInstall(M,A.source,s,P.CancellationToken.None))),!b.URI.isUri(A.source)&&(y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,void 0),w.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch(q){}t.push({local:M,identifier:A.identifier,operation:A.operation,source:A.source})}catch(M){throw b.URI.isUri(A.source)||y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,M),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(M),M}finally{u.delete(A.identifier.id.toLowerCase())}}))}return t.forEach(({identifier:f})=>this.logService.info("Extension installed successfully:",f.id)),this._onDidInstallExtensions.fire(t),t.filter(({identifier:f})=>(0,m.areSameExtensions)(f,a.identifier))[0].local}catch(u){if(r.forEach(({task:f})=>f.cancel()),t.length)try{const f=await Promise.allSettled(t.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<f.length;p++){const A=f[p],{identifier:O}=t[p];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,R.getErrorMessage)(A.reason))}}catch(f){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(f),t.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,R.getErrorMessage)(u)),this._onDidInstallExtensions.fire(r.map(({task:f})=>({identifier:f.identifier,operation:1,source:f.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:I.ExtensionManagementErrorCode.Internal),u}finally{for(const{task:u,manifest:f}of r)if(!b.URI.isUri(u.source)){const p=new m.ExtensionIdentifierWithVersion(u.identifier,f.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(l){const n=[],s=[],r=await Promise.allSettled(l);for(const t of r)t.status==="fulfilled"?n.push(t.value):s.push(t.reason);if(s.length)throw v(s);return n}async getAllDepsAndPackExtensionsToInstall(l,n,s){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const t=[l,...r.map(u=>u.identifier)],a=[],o=async(u,f)=>{const p=f.extensionDependencies||[],A=[...p];if(f.extensionPack){const O=s?r.find(M=>(0,m.areSameExtensions)(M.identifier,u)):void 0;for(const M of f.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(q=>(0,m.areSameExtensions)({id:q},{id:M}))||A.every(q=>!(0,m.areSameExtensions)({id:q},{id:M}))&&A.push(M)}if(A.length){const O=[...t,...a.map(q=>q.gallery.identifier)],M=A.filter(q=>O.every(N=>!(0,m.areSameExtensions)(N,{id:q})));if(M.length){const q=await this.galleryService.query({names:M,pageSize:A.length},P.CancellationToken.None);for(const N of q.firstPage){if(O.find(F=>(0,m.areSameExtensions)(F,N.identifier)))continue;if(!p.some(F=>(0,m.areSameExtensions)({id:F},N.identifier))&&!await this.canInstall(N)){this.logService.info("Skipping the packed extension as it cannot be installed",N.identifier.id);continue}const $=await this.checkAndGetCompatibleVersion(N,!0),_=await this.galleryService.getManifest($,P.CancellationToken.None);if(_===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${$.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);a.push({gallery:$,manifest:_}),await o($.identifier,_)}}}};return await o(l,n),r=await this.getInstalled(),a.filter(u=>!r.some(f=>(0,m.areSameExtensions)(f.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(l,n){if(await this.isMalicious(l))throw new I.ExtensionManagementError(i.localize(4,null,l.identifier.id),I.ExtensionManagementErrorCode.Malicious);const s=await this.getCompatibleVersion(l,n);if(!s)throw new I.ExtensionManagementError(i.localize(5,null,l.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.Incompatible);return s}async getCompatibleVersion(l,n){const s=await this.getTargetPlatform();let r=null;return await this.galleryService.isExtensionCompatible(l,s)&&(r=l),!r&&n&&(r=await this.galleryService.getCompatibleExtension(l,s)),r}async isMalicious(l){const n=await this.getExtensionsReport();return(0,m.getMaliciousExtensionsSet)(n).has(l.identifier.id)}async unininstallExtension(l,n){const s=this.uninstallingExtensions.get(l.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",l.identifier.id),s.waitUntilTaskIsFinished();const r=(u,f)=>{const p=this.createUninstallExtensionTask(u,f);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),p},t=(u,f)=>{f?this.logService.error("Failed to uninstall extension:",u.identifier.id,f.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,m.getLocalExtensionTelemetryData)(u),void 0,f),this._onDidUninstallExtension.fire({identifier:u.identifier,error:f?.code})},a=[],o=[];try{a.push(r(l,{}));const u=await this.getInstalled(1);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",l.identifier.id);else{const f=this.getAllPackExtensionsToUninstall(l,u);for(const p of f)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):a.push(r(p,{}))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",l.identifier.id):this.checkForDependents(a.map(f=>f.extension),u,l),await this.joinAllSettled(a.map(async f=>{try{if(await f.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(f.extension,n,P.CancellationToken.None))),f.extension.identifier.uuid)try{await this.galleryService.reportStatistic(f.extension.manifest.publisher,f.extension.manifest.name,f.extension.manifest.version,"uninstall")}catch(p){}t(f.extension)}catch(p){const A=p instanceof I.ExtensionManagementError?p:new I.ExtensionManagementError((0,R.getErrorMessage)(p),I.ExtensionManagementErrorCode.Internal);throw t(f.extension,A),A}finally{o.push(f)}}))}catch(u){const f=u instanceof I.ExtensionManagementError?u:new I.ExtensionManagementError((0,R.getErrorMessage)(u),I.ExtensionManagementErrorCode.Internal);for(const p of a){try{p.cancel()}catch(A){}o.includes(p)||t(p.extension,f)}throw f}finally{for(const u of a)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(l,n,s){for(const r of l){const t=this.getDependents(r,n);if(t.length){const a=t.filter(o=>!l.some(u=>(0,m.areSameExtensions)(u.identifier,o.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,s))}}}getDependentsErrorMessage(l,n,s){return s===l?n.length===1?i.localize(6,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?i.localize(7,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):i.localize(8,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?i.localize(9,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?i.localize(10,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):i.localize(11,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(l,n,s=[]){if(s.indexOf(l)!==-1)return[];s.push(l);const r=l.manifest.extensionPack?l.manifest.extensionPack:[];if(r.length){const t=n.filter(o=>!o.isBuiltin&&r.some(u=>(0,m.areSameExtensions)({id:u},o.identifier))),a=[];for(const o of t)a.push(...this.getAllPackExtensionsToUninstall(o,n,s));return[...t,...a]}return[]}getDependents(l,n){return n.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(r=>(0,m.areSameExtensions)({id:r},l.identifier)))}async findGalleryExtension(l){if(l.identifier.uuid){const n=await this.findGalleryExtensionById(l.identifier.uuid);return n||this.findGalleryExtensionByName(l.identifier.id)}return this.findGalleryExtensionByName(l.identifier.id)}async findGalleryExtensionById(l){return(await this.galleryService.query({ids:[l],pageSize:1},P.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(l){return(await this.galleryService.query({names:[l],pageSize:1},P.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${l.length} reported extensions from service`),l}catch(l){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};g=he([X(0,I.IExtensionGalleryService),X(1,S.ITelemetryService),X(2,E.ILogService),X(3,h.IProductService)],g),e.AbstractExtensionManagementService=g;function v(c){const l=Array.isArray(c)?c:[c];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((n,s)=>new Error(`${n.message}${n.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=v;function y(c,l,n,s,r){const t=r?r instanceof I.ExtensionManagementError?r.code:I.ExtensionManagementErrorCode.Internal:void 0;c.publicLogError(l,{...n,success:!r,duration:s,errorcode:t})}e.reportTelemetry=y;class d{constructor(){this.barrier=new T.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(l=>this.doRun(l))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(l=>new Promise((n,s)=>{const r=l.onCancellationRequested(()=>{r.dispose(),s((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=d}),define(te[204],ne([0,1,17,5,66,3,8,4,31,9,132,13,30,194,80,14,10,59,28,43,23,22]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let r=class extends E.ExtensionTipsService{constructor(a,o,u,f,p,A,O,M,q,N){super(O,M,q,N);this.environmentService=a,this.telemetryService=o,this.extensionManagementService=u,this.storageService=f,this.nativeHostService=p,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,M.exeBasedExtensionTips&&(0,P.forEach)(M.exeBasedExtensionTips,({key:L,value:$})=>{const _=[],F=[],V=[];(0,P.forEach)($.recommendations,({key:W,value:x})=>{x.important?$.important?_.push({extensionId:W,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):F.push({extensionId:W,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):V.push({extensionId:W,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),_.length&&this.highImportanceExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:_}),F.length&&this.mediumImportanceExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:F}),V.length&&this.allOtherExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:V})}),(0,T.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(a,o){const u=new Map;a.forEach(M=>u.set(M.extensionId.toLowerCase(),M));const{installed:f,uninstalled:p}=this.groupByInstalled([...u.keys()],o);for(const M of f){const q=u.get(M);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:M,exeName:q.exeName})}for(const M of p){const q=u.get(M);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:M,exeName:q.exeName})}const A=this.getPromptedExecutableTips(),O=new Map;for(const M of p){const q=u.get(M);if(q&&(!A[q.exeName]||!A[q.exeName].includes(q.extensionId))){let N=O.get(q.exeName);N||(N=[],O.set(q.exeName,N)),N.push(q)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[a,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const f=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const p=this._register((0,T.disposableTimeout)(()=>{p.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const a=this.getLastPromptedMediumExeTime(),o=Date.now()-a,u=7*24*60*60*1e3;if(o<u){const A=this._register((0,T.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[f,p]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(p[0].exeName,p);const O=this._register((0,T.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const M=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(M(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const q=this._register((0,T.disposableTimeout)(()=>{q.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(a){const o=a.map(({extensionId:f})=>f.toLowerCase()),u=(0,i.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(s,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(s,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,0,"{}"))}addToRecommendedExecutables(a,o){const u=this.getPromptedExecutableTips();u[a]=o.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(n,JSON.stringify(u),0,0)}groupByInstalled(a,o){const u=[],f=[],p=o.reduce((A,O)=>(A.add(O.identifier.id.toLowerCase()),A),new Set);return a.forEach(A=>{p.has(A.toLowerCase())?u.push(A):f.push(A)}),{installed:u,uninstalled:f}}async getValidExecutableBasedExtensionTips(a){const o=[],u=new Map;for(const f of a.keys()){const p=a.get(f);if(!p||!(0,D.isNonEmptyArray)(p.recommendations))continue;const A=[];C.isWindows?p.windowsPath&&A.push(p.windowsPath.replace("%USERPROFILE%",w.env.USERPROFILE).replace("%ProgramFiles(x86)%",w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",w.env.ProgramFiles).replace("%APPDATA%",w.env.APPDATA).replace("%WINDIR%",w.env.WINDIR)):(A.push((0,k.join)("/usr/local/bin",f)),A.push((0,k.join)("/usr/bin",f)),A.push((0,k.join)(this.environmentService.userHome.fsPath,f)));for(const O of A){let M=u.get(O);if(M===void 0&&(M=await this.fileService.exists(b.URI.file(O)),u.set(O,M)),M)for(const{extensionId:q,extensionName:N,isExtensionPack:L}of p.recommendations)o.push({extensionId:q,extensionName:N,isExtensionPack:L,exeName:f,exeFriendlyName:p.exeFriendlyName,windowsPath:p.windowsPath})}}return o}};r=he([X(0,I.INativeEnvironmentService),X(1,l.ITelemetryService),X(2,m.IExtensionManagementService),X(3,c.IStorageService),X(4,v.INativeHostService),X(5,h.IExtensionRecommendationNotificationService),X(6,S.IFileService),X(7,y.IProductService),X(8,d.IRequestService),X(9,g.ILogService)],r),e.ExtensionTipsService=r}),define(te[92],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(R){this.appenders=R}listen(R,k){throw new Error(`Event not found: ${k}`)}call(R,k,{eventName:C,data:w}){return this.appenders.forEach(b=>b.log(C,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class T{constructor(R){this.channel=R}log(R,k){return this.channel.call("log",{eventName:R,data:k}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=T}),define(te[47],ne([0,1,26,18,21,22]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,y){return Promise.resolve(void 0)}publicLog2(v,y){return this.publicLog(v,y)}publicLogError(v,y){return Promise.resolve(void 0)}publicLogError2(v,y){return this.publicLogError(v,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class C{async publicLog(v,y,d){}async publicLogError(v,y,d){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(g,v){return v.onDidChangeConfiguration(y=>{y.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(y.source),configurationKeys:h(y.sourceConfig)})})}e.configurationTelemetry=w;function b(g,v){return!(v.disableTelemetry||!g.enableTelemetry)}e.supportsTelemetry=b;function i(g){const v=g.getValue(R.TELEMETRY_SETTING_ID),y=g.getValue("telemetry.enableCrashReporter");if(g.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function I(g){const v=Object.create(null),y=Object.create(null),d=Object.create(null);E(g,d);for(let c in d){c=c.length>150?c.substr(c.length-149):c;const l=d[c];typeof l=="number"?y[c]=l:typeof l=="boolean"?y[c]=l?1:0:typeof l=="string"?v[c]=l.substring(0,1023):typeof l!="undefined"&&l!==null&&(v[c]=l)}return{properties:v,measurements:y}}e.validateTelemetryData=I;function m(g){if(!g)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(d=>{g.indexOf(`${d}+`)===0&&(v=d)}),v}e.cleanRemoteAuthority=m;function E(g,v,y=0,d){if(!!g)for(let c of Object.getOwnPropertyNames(g)){const l=g[c],n=d?d+c:c;Array.isArray(l)?v[n]=(0,D.safeStringify)(l):l instanceof Date?v[n]=l.toISOString():(0,T.isObject)(l)?y<2?E(l,v,y+1,n+"."):v[n]=(0,D.safeStringify)(l):v[n]=l}}function h(g){if(!g)return[];const v=[];return S(v,"",g),v}function S(g,v,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(d=>S(g,v?`${v}.${d}`:d,y[d])):g.push(v)}}),define(te[205],ne([0,1,17,27,7,26,4,31,9,21,13,30,36,76,14,10,28,43,46,23,22,47]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=k.isWeb?"web":(0,I.getTargetPlatform)(k.platform,C.arch);var s;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished"})(s||(s={}));function r(...G){return String(G.reduce((H,re)=>H|re,0))}var t;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},f={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class p{constructor(H=f){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,re=this.state.pageSize){return new p({...this.state,pageNumber:H,pageSize:re})}withFilter(H,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:H,value:ce})):[{filterType:H}]];return new p({...this.state,criteria:ie})}withSortBy(H){return new p({...this.state,sortBy:H})}withSortOrder(H){return new p({...this.state,sortOrder:H})}withFlags(...H){return new p({...this.state,flags:H.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...H){return new p({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le,flags:de,assetTypes:fe}=this.state;return{filters:[{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le}],assetTypes:fe,flags:de}}get searchText(){const H=this.state.criteria.filter(re=>re.filterType===t.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(G,H){const re=(G||[]).filter(ie=>ie.statisticName===H)[0];return re?re.value:0}function O(G){const H="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(ie=>ie.assetType.indexOf(H)===0).reduce((ie,ce)=>{const le=L(G,ce.assetType);return le&&ie.push([ce.assetType.substring(H.length),le]),ie},[])}function M(G){if(G.properties){const H=G.properties.filter(ce=>ce.key===a.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=H.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return L(G,a.Repository)}function q(G){return{uri:`${G.fallbackAssetUri}/${a.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${a.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function N(G){const H=L(G,a.Icon);if(H)return H;const re=I.DefaultIconPath;return{uri:re,fallbackUri:re}}function L(G,H){return G.files.filter(ie=>ie.assetType===H)[0]?{uri:`${G.assetUri}/${H}`,fallbackUri:`${G.fallbackAssetUri}/${H}`}:null}function $(G,H){const re=G.properties?G.properties.filter(ce=>ce.key===H):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,m.adoptToGalleryExtensionId)(ce)):[]}function _(G){const H=G.properties?G.properties.filter(re=>re.key===o.Engine):[];return H.length>0&&H[0].value||""}function F(G){const H=G.properties?G.properties.filter(ie=>ie.key===o.LocalizedLanguages):[],re=H.length>0&&H[0].value||"";return re?re.split(","):[]}function V(G){return G.indexOf("preview")!==-1}function W(G){return G.targetPlatform?(0,I.toTargetPlatform)(G.targetPlatform):"undefined"}function x(G){const H=(0,D.distinct)(G.versions.map(W)),re=!!G.tags?.includes(I.WEB_EXTENSION_TAG),ie=H.indexOf("web");return re?ie===-1&&H.push("web"):ie!==-1&&H.splice(ie,1),H}function z(G,H){const re=(0,I.getFallbackTargetPlarforms)(H);for(let ie=0;ie<G.length;ie++){const ce=G[ie];if(ce.version===G[ie-1]?.version){let le=ie;const de=W(ce);if(de===H)for(;le>0&&G[le-1].version===ce.version;)le--;else if(re.includes(de))for(;le>0&&G[le-1].version===ce.version&&W(G[le-1])!==H;)le--;le!==ie&&(G.splice(ie,1),G.splice(le,0,ce))}}return G}e.sortExtensionVersions=z;function K(G,H,re,ie,ce){const le=x(G);let de=G.versions[0];return de=G.versions.find(fe=>fe.version===de.version&&(0,I.isTargetPlatformCompatible)(W(fe),le,ce))||de,U(G,de,le,H,re,ie)}function U(G,H,re,ie,ce,le){const de={manifest:L(H,a.Manifest),readme:L(H,a.Details),changelog:L(H,a.Changelog),license:L(H,a.License),repository:M(H),download:q(H),icon:N(H),coreTranslations:O(H)};return{identifier:{id:(0,m.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:H.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,description:G.shortDescription||"",installCount:A(G.statistics,"install"),rating:A(G.statistics,"averagerating"),ratingCount:A(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:re,assets:de,properties:{dependencies:$(H,o.Dependency),extensionPack:$(H,o.ExtensionPack),engine:_(H),localizedLanguages:F(H),targetPlatform:W(H)},preview:V(G.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:le}}}let B=class{constructor(H,re,ie,ce,le,de,fe,be){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=le,this.fileService=de,this.productService=fe,this.configurationService=be;const Ce=fe.extensionsGallery;this.extensionsGalleryUrl=Ce&&Ce.serviceUrl,this.extensionsControlUrl=Ce&&Ce.controlUrl,this.commonHeadersPromise=Z(fe.version,fe,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,re){const ie=[];let ce=new p().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,H.length).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExtensionName,...H.map(({id:de})=>de.toLowerCase()));H.every(de=>!de.version)&&(ce=ce.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,n,T.CancellationToken.None);for(let de=0;de<le.length;de++){const fe=le[de];if(!fe.versions.length)continue;const be=(0,m.getGalleryExtensionId)(fe.publisher.publisherName,fe.extensionName),Ce=H.find(Ee=>(0,m.areSameExtensions)(Ee,{id:be}))?.version;if(Ce){const Ee=fe.versions.find(Ae=>Ae.version===Ce);Ee&&ie.push(U(fe,Ee,x(fe),de,ce))}else ie.push(K(fe,de,ce,void 0,n))}return ie}async getCompatibleExtension(H,re){const ie=(0,I.isIExtensionIdentifier)(H)?null:H;if(ie){if((0,I.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:le}=ie?ie.identifier:H;let de=new p().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?de=de.withFilter(t.ExtensionId,le):de=de.withFilter(t.ExtensionName,ce);const{galleryExtensions:fe}=await this.queryGallery(de,re,T.CancellationToken.None),[be]=fe;if(!be||!be.versions.length)return null;const Ce=x(be);if((0,I.isNotWebExtensionInWebTargetPlatform)(Ce,re))return null;for(let Ee of be.versions){if(!_(Ee)){const Ae=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:o.Engine,value:Ae}]}}if(await this.isRawExtensionVersionCompatible(Ee,Ce,re))return U(be,Ee,Ce,0,de)}return null}async isExtensionCompatible(H,re){if(!(0,I.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re))return!1;let ie=H.properties.engine;if(!ie){const ce=await this.getManifest(H,T.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,E.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,re,ie){if(!(0,I.isTargetPlatformCompatible)(W(H),re,ie))return!1;const ce=await this.getEngine(H);return(0,E.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(H,re){const ie=T.CancellationToken.isCancellationToken(H)?{}:H,ce=T.CancellationToken.isCancellationToken(H)?H:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=ie.text||"";const de=(0,R.getOrDefault)(ie,Pe=>Pe.pageSize,50);let fe=new p().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,de).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(fe=fe.withFilter(t.Category,Fe||Le),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(fe=fe.withFilter(t.Tag,Fe||Le),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(fe=fe.withFilter(t.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),fe=fe.withFilter(t.SearchText,le)),fe=fe.withSortBy(0)):ie.ids?fe=fe.withFilter(t.ExtensionId,...ie.ids):ie.names?fe=fe.withFilter(t.ExtensionName,...ie.names):fe=fe.withSortBy(4),typeof ie.sortBy=="number"&&(fe=fe.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(fe=fe.withSortOrder(ie.sortOrder));const{galleryExtensions:be,total:Ce}=await this.queryGallery(fe,n,ce),Ee=be.map((Pe,Le)=>K(Pe,Le,fe,ie.source,n)),Ae=async(Pe,Le)=>{if(Le.isCancellationRequested)throw(0,P.canceled)();const Fe=fe.withPage(Pe+1),{galleryExtensions:Ne}=await this.queryGallery(Fe,n,Le);return Ne.map(($e,xe)=>K($e,xe,Fe,ie.source,n))};return{firstPage:Ee,total:Ce,pageSize:fe.pageSize,getPage:Ae}}async queryGallery(H,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,s.ExcludeNonValidated).withFilter(t.ExcludeWithFlags,r(s.Unpublished));const ce=await this.commonHeadersPromise,le=JSON.stringify(H.raw),de={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},fe=new Date().getTime();let be,Ce,Ee=0;try{if(be=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:de},ie),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Ae=await(0,v.asJson)(be);if(Ae){const Pe=Ae.results[0],Le=Pe.extensions;Le.forEach(Ne=>z(Ne.versions,re));const Fe=Pe.resultMetadata&&Pe.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(Ae){throw Ce=Ae,Ae}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-fe,success:!!be&&(0,v.isSuccess)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Ce?(0,P.isPromiseCanceledError)(Ce)?"canceled":(0,P.getErrorMessage)(Ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(H,re,ie,ce){if(!this.isEnabled())return;const le=k.isWeb?this.api(`/itemName/${H}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${re}/${ie}/stats?statType=${ce}`),de=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",be={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:le,headers:be},T.CancellationToken.None)}catch(Ce){}}async download(H,re,ie){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ce=(0,m.getGalleryExtensionTelemetryData)(H),le=new Date().getTime(),de=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),fe=ie===1?"install":ie===2?"update":"",be=fe?{uri:`${H.assets.download.uri}${w.URI.parse(H.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${H.assets.download.fallbackUri}${w.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:H.assets.download,Ce=await this.getAsset(be);await this.fileService.writeFile(re,Ce.stream),de(new Date().getTime()-le)}async getReadme(H,re){if(H.assets.readme){const ie=await this.getAsset(H.assets.readme,{},re);return await(0,v.asText)(ie)||""}return""}async getManifest(H,re){if(H.assets.manifest){const ie=await this.getAsset(H.assets.manifest,{},re),ce=await(0,v.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(H,re){const ie=L(H,a.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:ce});return await(0,v.asJson)(le)}async getCoreTranslation(H,re){const ie=H.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),le=await(0,v.asText)(ce);return le?JSON.parse(le):null}return null}async getChangelog(H,re){if(H.assets.changelog){const ie=await this.getAsset(H.assets.changelog,{},re);return await(0,v.asText)(ie)||""}return""}async getAllCompatibleVersions(H,re){let ie=new p().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?ie=ie.withFilter(t.ExtensionId,H.identifier.uuid):ie=ie.withFilter(t.ExtensionName,H.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,T.CancellationToken.None);if(!ce.length)return[];const le=x(ce[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(le,re))return[];const de=[];for(const fe of ce[0].versions)try{de[de.length-1]?.version!==fe.version&&await this.isRawExtensionVersionCompatible(fe,le,re)&&de.push({version:fe.version,date:fe.lastUpdated})}catch(be){}return de}async getAsset(H,re={},ie=T.CancellationToken.None){const ce=await this.commonHeadersPromise,le={type:"GET"},de={...ce,...re.headers||{}};re={...re,...le,headers:de};const fe=H.uri,be=H.fallbackUri,Ce={...re,url:fe};try{const Ee=await this.requestService.request(Ce,ie);if(Ee.res.statusCode===200)return Ee;const Ae=await(0,v.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Ae}`)}catch(Ee){if((0,P.isPromiseCanceledError)(Ee))throw Ee;const Ae=(0,P.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:fe,message:Ae});const Pe={...re,url:be};return this.requestService.request(Pe,ie)}}async getEngine(H){let re=_(H);if(!re){const ie=await this.getManifestFromRawExtensionVersion(H,T.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,v.asJson)(H),ie=new Map;if(re)for(const ce of re.malicious){const le=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};le.malicious=!0,ie.set(ce,le)}return[...ie.values()]}};B=he([X(1,v.IRequestService),X(2,S.ILogService),X(3,i.IEnvironmentService),X(4,c.ITelemetryService),X(5,h.IFileService),X(6,g.IProductService),X(7,b.IConfigurationService)],B);let j=class extends B{constructor(H,re,ie,ce,le,de,fe,be){super(H,re,ie,ce,le,de,fe,be)}};j=he([X(0,d.IStorageService),X(1,v.IRequestService),X(2,S.ILogService),X(3,i.IEnvironmentService),X(4,c.ITelemetryService),X(5,h.IFileService),X(6,g.IProductService),X(7,b.IConfigurationService)],j),e.ExtensionGalleryService=j;let Q=class extends B{constructor(H,re,ie,ce,le,de,fe){super(void 0,H,re,ie,ce,le,de,fe)}};Q=he([X(0,v.IRequestService),X(1,S.ILogService),X(2,i.IEnvironmentService),X(3,c.ITelemetryService),X(4,h.IFileService),X(5,g.IProductService),X(6,b.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q;async function Z(G,H,re,ie,ce,le){const de={"X-Market-Client-Id":`VSCode ${G}`,"User-Agent":`VSCode ${G}`},fe=await(0,y.getServiceMachineId)(re,ce,le);return(0,l.supportsTelemetry)(H,re)&&(0,l.getTelemetryLevel)(ie)===3&&(de["X-Market-User-Id"]=fe),de}e.resolveMarketplaceHeaders=Z}),define(te[93],ne([0,1,2,13,10,47]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends D.Disposable{constructor(w,b,i=""){super();this.prefix=i;const I=w.getLogger(b.telemetryLogResource);I?this.logger=this._register(I):(this.logger=this._register(w.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(w,b){this.logger.trace(`${this.prefix}telemetry/${w}`,(0,R.validateTelemetryData)(b))}};k=he([X(0,P.ILoggerService),X(1,T.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(te[94],ne([0,1,2,26,4,25,142,21,38,60,35,22,47]),function(J,e,D,T,P,R,k,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(g,v){this._configurationService=v,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(y=>{const d=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!d})})}setExperimentProperty(g,v){this._experimentProperties[g]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const g=await this._commonProperties;let v=g.sessionID,y=g["common.instanceId"],d=g["common.machineId"],c=g["common.firstSessionDate"],l=g["common.msftInternal"];return{sessionId:v,instanceId:y,machineId:d,firstSessionDate:c,msftInternal:l}}dispose(){this._disposables.dispose()}_log(g,v,y,d){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(c=>{y=(0,T.mixin)(y,c),y=(0,T.mixin)(y,this._experimentProperties),y=(0,T.cloneAndChange)(y,l=>{if(typeof l=="string")return this._cleanupInfo(l,d)}),this._appenders.forEach(l=>l.log(g,y))},c=>{console.error(c)})}publicLog(g,v,y){return this._log(g,3,v,y)}publicLog2(g,v,y){return this.publicLog(g,v,y)}publicLogError(g,v){return this.sendErrorTelemetry?this._log(g,2,v,!0):Promise.resolve(void 0)}publicLogError2(g,v){return this.publicLogError(g,v)}_anonymizeFilePaths(g){let v=g;const y=[];for(let n of this._cleanupPatterns)for(;;){const s=n.exec(g);if(!s)break;y.push([s.index,n.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(v="";;){const n=c.exec(g);if(!n)break;!d.test(n[0])&&y.every(([s,r])=>n.index<s||n.index>=r)&&(v+=g.substring(l,n.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}return l<g.length&&(v+=g.substr(l)),v}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const v=g.toLowerCase(),y=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(v)?"<REDACTED: secret>":y.test(v)?"<REDACTED: email>":g}_cleanupInfo(g,v){let y=g;v&&(y=this._anonymizeFilePaths(y));for(let d of this._cleanupPatterns)y=y.replace(d,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([X(1,C.IConfigurationService)],E),e.TelemetryService=E;function h(){const S=(0,k.localize)(0,null,b.default.nameLong),g=b.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=P.isWeb?"":(0,k.localize)(3,null),y=(0,k.localize)(4,null),d=(0,k.localize)(5,null),c=(0,k.localize)(6,null),l=(0,k.localize)(7,null),n=`
|       | ${y} | ${d} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,k.localize)(8,null);return`
${S} ${g} ${v}

&nbsp;

${l}
${n}

&nbsp;

${s}
`}i.Registry.as(w.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(w.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,k.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,k.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[206],ne([0,1,7,26,47]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function R(C){const w=await new Promise((i,I)=>{J(["applicationinsights"],i,I)});let b;return w.defaultClient?(b=new w.TelemetryClient(C),b.channel.setUseDiskRetryCaching(!0)):(w.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=w.defaultClient),C.indexOf("AIF-")===0&&(b.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),b}class k{constructor(w,b,i){this._eventPrefix=w,this._defaultData=b,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(w){if(!!this._aiClient){if(typeof this._aiClient!="string"){w(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(b=>{w(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(w,b){!this._aiClient||(b=(0,T.mixin)(b,this._defaultData),b=(0,P.validateTelemetryData)(b),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+w,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(w=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,w(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(te[207],ne([0,1,15,44,21,13,10,22,92,93,94]),function(J,e,D,T,P,R,k,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let I=class{constructor(E,h,S,g){this.configurationService=E,this.telemetryService=h,this.loggerService=S,this.environmentService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(E){if(!this.customTelemetryServices.has(E.id)){const{machineId:h,sessionId:S}=await this.telemetryService.getTelemetryInfo(),g=Object.create(null);g["common.vscodemachineid"]=h,g["common.vscodesessionid"]=S;const v=[E.id,JSON.stringify(g),E.aiKey],d=new T.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:v,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new w.TelemetryAppenderClient(d),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${E.id}] `)];this.customTelemetryServices.set(E.id,new i.TelemetryService({appenders:c,sendErrorTelemetry:E.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(E.id)}async publicLog(E,h,S){await(await this.getCustomTelemetryService(E)).publicLog(h,S)}async publicLogError(E,h,S){await(await this.getCustomTelemetryService(E)).publicLogError(h,S)}};I=he([X(0,P.IConfigurationService),X(1,C.ITelemetryService),X(2,k.ILoggerService),X(3,R.IEnvironmentService)],I),e.CustomEndpointTelemetryService=I}),define(te[208],ne([0,1,5,27,3,2,10]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends R.Disposable{constructor(b,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new P.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((i,I)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,i),this._onCreateRequest.fire({requestId:m,...b});const E=new T.CancellationTokenSource;(0,D.timeout)(this._timeout,E.token).then(()=>I(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,R.toDisposable)(()=>E.cancel())])})}acceptReply(b,i){const I=this._pendingRequests.get(b);I?(this._pendingRequests.delete(b),(0,R.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),I(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};C=he([X(1,k.ILogService)],C),e.RequestStore=C}),define(te[95],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var T;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(T=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var P;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(P=e.TerminalSettingId||(e.TerminalSettingId={}));var R;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var w;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions"})(w=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var i;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(i=e.TerminalLocation||(e.TerminalLocation={}));var I;(function(g){g.TerminalView="view",g.Editor="editor"})(I=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(g){g.CwdDetection="cwdDetection"})(m=e.ProcessCapability||(e.ProcessCapability={}));var E;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(E=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(te[209],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[210],ne([0,1,34,26,8,4,31,18,20]),function(J,e,D,T,P,R,k,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let m=0;return I&&I.length===4&&(m=parseInt(I[3])),m}e.getWindowsBuildNumber=b;async function i(I,m,E,h=k.env,S=w.Promises.exists){if(P.isAbsolute(I))return await S(I)?I:void 0;if(m===void 0&&(m=k.cwd()),P.dirname(I)!=="."){const d=P.join(m,I);return await S(d)?d:void 0}const v=(0,T.getCaseInsensitive)(h,"PATH");if(E===void 0&&(0,C.isString)(v)&&(E=v.split(P.delimiter)),E===void 0||E.length===0){const d=P.join(m,I);return await S(d)?d:void 0}for(let d of E){let c;if(P.isAbsolute(d)?c=P.join(d,I):c=P.join(m,d,I),await S(c))return c;if(R.isWindows){let l=c+".com";if(await S(l)||(l=c+".exe",await S(l)))return l}}const y=P.join(m,I);return await S(y)?y:void 0}e.findExecutable=i}),define(te[211],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[96],ne([0,1,50,3,2,6,35,211]),function(J,e,D,T,P,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var w;(function(g){function v(y){return y&&typeof y=="object"&&typeof y.id=="string"}g.isThemeColor=v})(w=e.ThemeColor||(e.ThemeColor={}));function b(g){return{id:g}}e.themeColorFromId=b;var i;(function(g){function v(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||w.isThemeColor(s.color))}g.isThemeIcon=v;const y=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function d(s){const r=y.exec(s);if(!r)return;let[,t]=r;return{id:t}}g.fromString=d;function c(s,r){let t=s.id;const a=t.lastIndexOf("~");return a!==-1&&(t=t.substring(0,a)),r&&(t=`${t}~${r}`),{id:t}}g.modify=c;function l(s,r){return s.id===r.id&&s.color?.id===r.color?.id}g.isEqual=l;function n(s,r){return{id:s.id,color:r?b(r):void 0}}g.asThemeIcon=n,g.asClassNameArray=D.CSSIcon.asClassNameArray,g.asClassName=D.CSSIcon.asClassName,g.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function I(g){switch(g){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,P.toDisposable)(()=>{const y=this.themingParticipants.indexOf(v);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new m;k.Registry.add(e.Extensions.ThemingContribution,E);function h(g){return E.onColorThemeChange(g)}e.registerThemingParticipant=h;class S extends P.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,y){let d=this.theme.getColor(v);return d&&y&&(d=y(d,this.theme)),d?d.toString():null}}e.Themable=S}),define(te[212],ne([0,1,50,96]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function P(C,w){const b=C.map(i=>({name:i.profileName,description:R(i)}));return w&&b.push(...w.map(i=>({name:i.title,description:k(i)}))),{values:b.map(i=>i.name),markdownDescriptions:b.map(i=>i.description)}}e.createProfileSchemaEnums=P;function R(C){let w=`$(${T.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?w+=`
- args: "${C.args}"`:w+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(w+=`
- overrideName: ${C.overrideName}`),C.color&&(w+=`
- color: ${C.color}`),C.env&&(w+=`
- env: ${JSON.stringify(C.env)}`),w}function k(C){return`$(${T.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}}),define(te[213],ne([0,1,50,143,38,35,212]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const C={args:{description:(0,T.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,T.localize)(1,null),type:"boolean"},icon:{description:(0,T.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,g=>g.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,g=>`$(${g.id})`)},color:{description:(0,T.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,T.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,T.localize)(5,null),type:["string","array"],items:{type:"string"}},...C}},b=(0,T.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,T.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),I=(0,T.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m={id:"terminal",order:100,title:(0,T.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,T.localize)(19,null)}},{type:"string",markdownDescription:(0,T.localize)(20,null)}],default:[],markdownDeprecationMessage:I},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(21,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,T.localize)(22,null),enum:["PowerShell","Git Bash"]},...C}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(23,null),type:"string"},id:{description:(0,T.localize)(24,null),type:"string"},title:{description:(0,T.localize)(25,null),type:"string"},...C}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(26,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(27,null),type:"string"},id:{description:(0,T.localize)(28,null),type:"string"},title:{description:(0,T.localize)(29,null),type:"string"},...C}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(30,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(31,null),type:"string"},id:{description:(0,T.localize)(32,null),type:"string"},title:{description:(0,T.localize)(33,null),type:"string"},...C}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,T.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,T.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,T.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,T.localize)(37,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,T.localize)(38,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function E(){R.Registry.as(P.Extensions.Configuration).registerConfiguration(m),S()}e.registerTerminalPlatformConfiguration=E;let h;function S(g,v){const y=R.Registry.as(P.Extensions.Configuration);let d;g&&(d=(0,k.createProfileSchemaEnums)(g?.profiles,v));const c=h;h={id:"terminal",order:100,title:(0,T.localize)(39,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(40,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:g?.os===3?d?.values:void 0,markdownEnumDescriptions:g?.os===3?d?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(41,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:g?.os===2?d?.values:void 0,markdownEnumDescriptions:g?.os===2?d?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(42,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:g?.os===1?d?.values:void 0,markdownEnumDescriptions:g?.os===1?d?.markdownDescriptions:void 0}}},y.updateConfigurations({add:[h],remove:c?[c]:[]})}e.registerTerminalDefaultProfileConfiguration=S}),define(te[214],ne([0,1,42,50,8,4,20,70,210,96]),function(J,e,D,T,P,R,k,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i,I=!0;function m(s,r,t,a,o=process.env,u,f,p,A){return u=u||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},R.isWindows?E(t,u,o,f,a.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:a.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:a.getValue("terminal.integrated.defaultProfile.windows"),A,p):c(u,f,t,s&&typeof s=="object"?{...s}:a.getValue(R.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:a.getValue(R.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,p,o)}e.detectAvailableProfiles=m;async function E(s,r,t,a,o,u,f,p,A){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),M=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let q=!1;(0,w.getWindowsBuildNumber)()>=16299&&(q=!0),await g(p);const N=new Map;s&&(N.set("PowerShell",{source:"PowerShell",icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${M}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${M}\\cmd.exe`,icon:T.Codicon.terminalCmd,isAutoDetected:!0})),l(u,N);const L=await h(N.entries(),f,r,t,a,A);if(s||!s&&o)try{const $=await y(`${M}\\${q?"wsl":"bash"}.exe`,f);for(const _ of $)(!u||!(_.profileName in u))&&L.push(_)}catch($){I&&(a?.info("WSL is not installed, so could not detect WSL profiles"),I=!1)}return L}async function h(s,r,t,a=process.env,o,u){const f=[];for(const[p,A]of s){if(A===null)continue;let O,M,q;if("source"in A){const $=i?.get(A.source);if(!$)continue;O=$.paths,M=A.args||$.args,A.icon?q=S(A.icon):$.icon&&(q=$.icon)}else O=Array.isArray(A.path)?A.path:[A.path],M=R.isWindows||Array.isArray(A.args)?A.args:void 0,q=S(A.icon)||void 0;const N=await u?.(O)||O.slice(),L=await n(p,r,N,t,a,M,A.env,A.overrideName,A.isAutoDetected,o);L?(L.isAutoDetected=A.isAutoDetected,L.icon=q,L.color=A.color,f.push(L)):o?.trace("profile not validated",p,O)}return f}function S(s){return typeof s=="string"?{id:s}:s}async function g(s){i&&!s||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:s||await v(),icon:b.ThemeIcon.asThemeIcon(T.Codicon.terminalPowershell)}))}async function v(){const s=[];for await(const r of(0,C.enumeratePowerShellInstallations)())s.push(r.exePath);return s}async function y(s,r){const t=[],a=await new Promise((f,p)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(A,O)=>{if(A)return p("Problem occurred when getting wsl distros");f(O)})});if(!a)return[];const o=new RegExp(/[\r?\n]/),u=a.split(o).filter(f=>f.trim().length>0&&f!=="");for(const f of u){if(f===""||f.startsWith("docker-desktop"))continue;const p=`${f} (WSL)`,A={profileName:p,path:s,args:["-d",`${f}`],isDefault:p===r,icon:d(f)};t.push(A)}return t}function d(s){return s.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(T.Codicon.terminalUbuntu):s.includes("Debian")?b.ThemeIcon.asThemeIcon(T.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(T.Codicon.terminalLinux)}async function c(s,r,t,a,o,u,f,p){const A=new Map;if(t){const O=(await s.readFile("/etc/shells")).toString(),M=u||O.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),q=new Map;for(const N of M){let L=(0,P.basename)(N),$=q.get(L)||0;$++,$>1&&(L=`${L} (${$})`),q.set(L,$),A.set(L,{path:N,isAutoDetected:!0})}}return l(a,A),await h(A.entries(),o,s,p,r,f)}function l(s,r){if(!!s)for(const[t,a]of Object.entries(s))a===null||!("path"in a)&&!("source"in a)?r.delete(t):r.set(t,a)}async function n(s,r,t,a,o,u,f,p,A,O){if(t.length===0)return Promise.resolve(void 0);const M=t.shift();if(M==="")return n(s,r,t,a,o,u,f,p,A);const q={profileName:s,path:M,args:u,env:f,overrideName:p,isAutoDetected:A,isDefault:s===r};if((0,P.basename)(M)===M){const L=o.PATH?o.PATH.split(P.delimiter):void 0;return await(0,w.findExecutable)(M,void 0,L,void 0,a.existsFile)?q:n(s,r,t,a,o,u)}return await a.existsFile((0,P.normalize)(M))?q:n(s,r,t,a,o,u,f,p,A)}}),define(te[215],ne([0,1,3,2,15,4,32,44,21,13,75,163,10,86,22,208,95,213,214]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(n){n[n.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let c=0,l=class extends T.Disposable{constructor(s,r,t,a,o){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=t,this._logService=a,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,v.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,T.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new S.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(R.isWindows)return process.env;try{return await(0,I.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,i.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const t=new C.Client(P.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s);this._onPtyHostStart.fire(),k.ProxyChannel.toService(t.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(f=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(f.code),this._isDisposed||(this._restartCount<=d.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}, giving up`))}));const o=t.getChannel(g.TerminalIpcChannels.Log);E.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{E.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=k.ProxyChannel.toService(t.getChannel(g.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(f=>this._onProcessData.fire(f))),this._register(u.onProcessExit(f=>this._onProcessExit.fire(f))),this._register(u.onProcessReady(f=>this._onProcessReady.fire(f))),this._register(u.onProcessTitleChanged(f=>this._onProcessTitleChanged.fire(f))),this._register(u.onProcessShellTypeChanged(f=>this._onProcessShellTypeChanged.fire(f))),this._register(u.onProcessOverrideDimensions(f=>this._onProcessOverrideDimensions.fire(f))),this._register(u.onProcessResolvedShellLaunchConfig(f=>this._onProcessResolvedShellLaunchConfig.fire(f))),this._register(u.onProcessDidChangeHasChildProcesses(f=>this._onProcessDidChangeHasChildProcesses.fire(f))),this._register(u.onDidChangeProperty(f=>this._onDidChangeProperty.fire(f))),this._register(u.onProcessReplay(f=>this._onProcessReplay.fire(f))),this._register(u.onProcessOrphanQuestion(f=>this._onProcessOrphanQuestion.fire(f))),this._register(u.onDidRequestDetach(f=>this._onDidRequestDetach.fire(f))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,t,a,o,u,f,p,A,O,M){const q=setTimeout(()=>this._handleUnresponsiveCreateProcess(),g.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(s,r,t,a,o,u,f,p,A,O,M);return clearTimeout(q),c=Math.max(c,N),N}updateTitle(s,r,t){return this._proxy.updateTitle(s,r,t)}updateIcon(s,r,t){return this._proxy.updateIcon(s,r,t)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,t){return this._proxy.resize(s,r,t)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,t,a=!1){const o=await this._shellEnv;return(0,y.detectAvailableProfiles)(r,t,a,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,t){return this._proxy.updateProperty(s,r,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};l=he([X(1,w.IConfigurationService),X(2,b.IEnvironmentService),X(3,m.ILogService),X(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(te[54],ne([0,1,39]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function T(k,C,w,b){const i=(0,D.setProperty)(k,C,w,b)[0];return i&&(k=k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)),k}e.edit=T;function P(k,C,w){let b=w;for(;b>=0;){if(k.charAt(b)===C.charAt(C.length-1)&&C.length===1)return b+1;if(b--,C.length===2&&b>=0&&k.charAt(b)===C.charAt(0))return b+2}return 0}e.getLineStartOffset=P;function R(k,C,w){let b=w;for(;b>=0;)if(k.charAt(b)===C.charAt(C.length-1)&&C.length===1||(b++,C.length===2&&b>=0&&k.charAt(b)===C.charAt(1)))return b;return k.length-1}e.getLineEndOffset=R}),define(te[216],ne([0,1,26,61]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(I,m,E,h,S){const g=[],v=[],y=[];if(!m){const O=I.filter(({identifier:M})=>S.every(q=>q.toLowerCase()!==M.id.toLowerCase()));return{local:{added:g,removed:v,updated:y},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}I=I.map(b),m=m.map(b),E=E?E.map(b):null;const d=new Map,c=O=>{O.uuid&&d.set(O.id.toLowerCase(),O.uuid)};I.forEach(({identifier:O})=>c(O)),m.forEach(({identifier:O})=>c(O)),E&&E.forEach(({identifier:O})=>c(O));const l=O=>{const M=O.identifier.uuid||d.get(O.identifier.id.toLowerCase());return M?`uuid:${M}`:`id:${O.identifier.id.toLowerCase()}`},n=(O,M)=>(O.set(l(M),M),O),s=I.reduce(n,new Map),r=m.reduce(n,new Map),t=m.reduce((O,M)=>{const q=l(M);M=(0,D.deepClone)(M);const N=s.get(q);return N&&(N.installed&&(M.installed=!0),M.version||(M.version=N.version)),n(O,M)},new Map),a=E?E.reduce(n,new Map):null,o=h.reduce(n,new Map),u=S.reduce((O,M)=>{const q=d.get(M.toLowerCase());return O.add(q?`uuid:${q}`:`id:${M.toLowerCase()}`)},new Set),f=R(s,r,u);if(f.added.size>0||f.removed.size>0||f.updated.size>0){const O=R(a,s,u),M=R(a,r,u),q=(N,L)=>{const $=s.get(N);if($){const _=r.get(N);return{...L?_:$,version:(_.version&&T.gt(_.version,$.version),$.version),state:k($,_,a?.get(N))}}};for(const N of M.removed.values()){const L=s.get(N);L&&v.push(L.identifier)}for(const N of M.added.values())if(O.added.has(N)){if(f.updated.has(N)){const L=q(N,!0);L&&(y.push(i(L,N)),t.set(N,L))}}else{const L=r.get(N);L.installed&&g.push(i(L,N))}for(const N of M.updated.values()){const L=q(N,!0);L&&(y.push(i(L,N)),t.set(N,L))}for(const N of O.added.values())M.added.has(N)||t.set(N,s.get(N));for(const N of O.updated.values())if(!M.removed.has(N)&&!M.updated.has(N)){const L=q(N,!1);L&&(t.get(N)?.installed&&(L.installed=!0),t.set(N,L))}for(const N of O.removed.values())!o.has(N)&&!M.updated.has(N)&&a?.get(N)?.installed&&t.delete(N)}const p=[],A=R(r,t,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&t.forEach((O,M)=>p.push(i(O,M))),{local:{added:g,removed:v,updated:y},remote:p.length?{added:[...A.added].map(O=>t.get(O)),updated:[...A.updated].map(O=>t.get(O)),removed:[...A.removed].map(O=>r.get(O)),all:p}:null}}e.merge=P;function R(I,m,E,{checkInstalledProperty:h,checkVersionProperty:S}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=I?[...I.keys()].filter(l=>!E.has(l)):[],v=[...m.keys()].filter(l=>!E.has(l)),y=v.filter(l=>g.indexOf(l)===-1).reduce((l,n)=>(l.add(n),l),new Set),d=g.filter(l=>v.indexOf(l)===-1).reduce((l,n)=>(l.add(n),l),new Set),c=new Set;for(const l of g){if(d.has(l))continue;const n=I.get(l),s=m.get(l);(!s||n.disabled!==s.disabled||!w(n.state,s.state)||S&&n.version!==s.version||h&&n.installed!==s.installed)&&c.add(l)}return{added:y,removed:d,updated:c}}function k(I,m,E){const h=I.state,S=m.state,g=E?.state;if(!m.version||h&&T.gt(I.version,m.version))return h;if(S&&T.gt(m.version,I.version)||!h)return S;if(!S)return h;const v=(0,D.deepClone)(h),y=g?C(g,S):{added:Object.keys(S).reduce((c,l)=>(c.add(l),c),new Set),removed:new Set,updated:new Set},d=g?C(g,h):{added:Object.keys(h).reduce((c,l)=>(c.add(l),c),new Set),removed:new Set,updated:new Set};for(const c of[...y.added.values(),...y.updated.values()])v[c]=S[c];for(const c of y.removed.values())d.updated.has(c)||delete v[c];return v}function C(I,m){const E=Object.keys(I),h=Object.keys(m),S=h.filter(y=>E.indexOf(y)===-1).reduce((y,d)=>(y.add(d),y),new Set),g=E.filter(y=>h.indexOf(y)===-1).reduce((y,d)=>(y.add(d),y),new Set),v=new Set;for(const y of E){if(g.has(y))continue;const d=I[y],c=m[y];(0,D.equals)(d,c)||v.add(y)}return{added:S,removed:g,updated:v}}function w(I={},m={}){const{added:E,removed:h,updated:S}=C(I,m);return E.size===0&&h.size===0&&S.size===0}function b(I){return{...I,disabled:!!I.disabled,installed:!!I.installed}}function i(I,m){const E={identifier:{id:I.identifier.id,uuid:m.startsWith("uuid:")?m.substring("uuid:".length):void 0}};return I.version&&(E.version=I.version),I.disabled&&(E.disabled=!0),I.installed&&(E.installed=!0),I.state&&(E.state=I.state),E}}),define(te[97],ne([0,1,17,3,2,36,6,28,23]),function(J,e,D,T,P,R,k,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class it extends P.Disposable{constructor(m,E){super();this.storageService=m,this.productService=E,this._onDidChangeExtensionsStorage=this._register(new T.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(m){return`extensionKeys/${(0,R.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static fromKey(m){const E=b.exec(m);if(E&&E[1])return{id:E[1],version:E[2]}}initialize(){const m=this.storageService.keys(0,1);for(const E of m){const h=it.fromKey(E);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(m){if(m.scope!==0)return;if(this.extensionsWithKeysForSync.has(m.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const E=it.fromKey(m.key);if(E){this.extensionsWithKeysForSync.add(E.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(m,E){this.storageService.store(it.toKey(m),JSON.stringify(E),0,1)}getKeysForSync(m){const E=this.productService.extensionSyncedKeys?.[m.id.toLowerCase()],h=this.storageService.get(it.toKey(m),0),S=h?JSON.parse(h):void 0;return S&&E?(0,D.distinct)([...S,...E]):S||E}};i=he([X(0,w.IStorageService),X(1,C.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(te[98],ne([0,1,17,21,6]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,P.createDecorator)("IIgnoredExtensionsManagementService");let R=class{constructor(C){this.configurationService=C}hasToNeverSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,w){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==C&&i!==`-${C}`),w&&b.push(C.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(C,w){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==C&&i!==`-${C}`),w&&b.push(`-${C.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(C){const w=C.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),i=[],I=[];if(Array.isArray(b))for(const m of b)m.startsWith("-")?I.push(m.substring(1)):i.push(m);return(0,D.distinct)([...w,...i].filter(m=>I.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let C=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.configurationService.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(w=>w.toLowerCase())}};R=he([X(0,T.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(te[217],ne([0,1,17,33,26,158,54]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function C(c){return(0,T.parse)(c)||[]}e.parseKeybindings=C;async function w(c,l,n,s,r){const t=C(c),a=C(l),o=n?C(n):null,u=[...t,...a,...o||[]].map(F=>F.key),f=await r.resolveUserBindings(u);let p=i(t,a,o,f);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const A=m(t),O=m(a),M=o?m(o):null,q=h(A,O,f),N=M?h(M,A,f):{added:[...A.keys()].reduce((F,V)=>(F.add(V),F),new Set),removed:new Set,updated:new Set},L=M?h(M,O,f):{added:[...O.keys()].reduce((F,V)=>(F.add(V),F),new Set),removed:new Set,updated:new Set},$=b(q,N,L);let _=c;for(const F of $.removed.values())$.conflicts.has(F)||(_=y(_,F,s));for(const F of $.added.values()){if($.conflicts.has(F))continue;const V=O.get(F);if(V.some(W=>W.command!==`-${F}`&&p.conflicts.has(f[W.key]))){$.conflicts.add(F);continue}_=v(_,V,s)}for(const F of $.updated.values()){if($.conflicts.has(F))continue;const V=O.get(F);if(V.some(W=>W.command!==`-${F}`&&p.conflicts.has(f[W.key]))){$.conflicts.add(F);continue}_=d(_,F,V,s)}return{mergeContent:_,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=w;function b(c,l,n){const s=new Set,r=new Set,t=new Set,a=new Set;for(const o of l.removed.values())n.updated.has(o)&&a.add(o);for(const o of n.removed.values())a.has(o)||(l.updated.has(o)?a.add(o):r.add(o));for(const o of l.added.values())a.has(o)||n.added.has(o)&&c.updated.has(o)&&a.add(o);for(const o of n.added.values())a.has(o)||(l.added.has(o)?c.updated.has(o)&&a.add(o):s.add(o));for(const o of l.updated.values())a.has(o)||n.updated.has(o)&&c.updated.has(o)&&a.add(o);for(const o of n.updated.values())a.has(o)||(l.updated.has(o)?c.updated.has(o)&&a.add(o):t.add(o));return{added:s,removed:r,updated:t,conflicts:a}}function i(c,l,n,s){const r=new Set,t=I(c,s),a=I(l,s),o=n?I(n,s):null,u=E(t,a);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const f=o?E(o,t):{added:[...t.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const p=o?E(o,a):{added:[...a.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:A,removed:O,updated:M,conflicts:q}=b(u,f,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:O,updated:M,conflicts:q}}function I(c,l){const n=new Map;for(const s of c){const r=l[s.key];let t=n.get(r);t||(t=[],n.set(r,t)),t.push(s)}return n}function m(c){const l=new Map;for(const n of c){const s=n.command[0]==="-"?n.command.substring(1):n.command;let r=l.get(s);r||(r=[],l.set(s,r)),r.push(n)}return l}function E(c,l){const n=[...c.keys()],s=[...l.keys()],r=s.filter(o=>n.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),t=n.filter(o=>s.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),a=new Set;for(const o of n){if(t.has(o))continue;const u=c.get(o).map(p=>({...p,key:o})),f=l.get(o).map(p=>({...p,key:o}));(0,D.equals)(u,f,(p,A)=>g(p,A))||a.add(o)}return{added:r,removed:t,updated:a}}function h(c,l,n){const s=[...c.keys()],r=[...l.keys()],t=r.filter(u=>s.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),a=s.filter(u=>r.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),o=new Set;for(const u of s){if(a.has(u))continue;const f=c.get(u).map(A=>({...A,key:n[A.key]})),p=l.get(u).map(A=>({...A,key:n[A.key]}));S(f,p)||o.add(u)}return{added:t,removed:a,updated:o}}function S(c,l){return!(!(0,D.equals)(c.filter(({command:n})=>n[0]!=="-"),l.filter(({command:n})=>n[0]!=="-"),(n,s)=>g(n,s))||!(0,D.equals)(c.filter(({command:n})=>n[0]==="-"),l.filter(({command:n})=>n[0]==="-"),(n,s)=>g(n,s)))}function g(c,l){if(c.command!==l.command||c.key!==l.key)return!1;const n=R.ContextKeyExpr.deserialize(c.when),s=R.ContextKeyExpr.deserialize(l.when);return!(n&&!s||!n&&s||n&&s&&!n.equals(s)||!P.equals(c.args,l.args))}function v(c,l,n){for(const s of l)c=k.edit(c,[-1],s,n);return c}function y(c,l,n){const s=C(c);for(let r=s.length-1;r>=0;r--)(s[r].command===l||s[r].command===`-${l}`)&&(c=k.edit(c,[r],void 0,n));return c}function d(c,l,n,s){const r=C(c),t=r.findIndex(a=>a.command===l||a.command===`-${l}`);for(let a=r.length-1;a>=0;a--)(r[a].command===l||r[a].command===`-${l}`)&&(c=k.edit(c,[a],void 0,s));for(let a=n.length-1;a>=0;a--)c=k.edit(c,[t],n[a],s);return c}}),define(te[218],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(R,k,C){const w={},b={},i=new Set;if(!k)return{local:{added:w,updated:b,removed:[...i.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const I=T(R,k);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:w,updated:b,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=T(C,R),E=T(C,k),h={},S={},g=new Set,v=new Set;for(const y of m.removed.values())E.updated.has(y)?w[y]=k[y]:g.add(y);for(const y of E.removed.values())v.has(y)||(m.updated.has(y)?v.add(y):i.add(y));for(const y of m.updated.values())v.has(y)||(E.updated.has(y)?I.updated.has(y)&&v.add(y):S[y]=R[y]);for(const y of E.updated.values())v.has(y)||(m.updated.has(y)?I.updated.has(y)&&v.add(y):R[y]!==void 0&&(b[y]=k[y]));for(const y of m.added.values())v.has(y)||(E.added.has(y)?I.updated.has(y)&&v.add(y):h[y]=R[y]);for(const y of E.added.values())v.has(y)||(m.added.has(y)?I.updated.has(y)&&v.add(y):w[y]=k[y]);return{local:{added:w,removed:[...i.values()],updated:b},remote:{added:h,removed:[...g.values()],updated:S},conflicts:[...v.values()]}}e.merge=D;function T(R,k){const C=R?Object.keys(R):[],w=k?Object.keys(k):[],b=w.filter(m=>C.indexOf(m)===-1).reduce((m,E)=>(m.add(E),m),new Set),i=C.filter(m=>w.indexOf(m)===-1).reduce((m,E)=>(m.add(E),m),new Set),I=new Set;for(const m of C){if(i.has(m))continue;const E=R[m],h=k[m];E!==h&&I.add(m)}return{added:b,removed:i,updated:I}}function P(R,k){const{added:C,removed:w,updated:b}=T(R,k);return C.size===0&&w.size===0&&b.size===0}e.areSame=P}),define(te[24],ne([0,1,17,16,18,148,38,30,6,87,35]),function(J,e,D,T,P,R,k,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const o=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function m(){const o=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(A=>!!o[A].ignoreSync),f=Object.keys(o).filter(A=>o[A].scope===2||o[A].scope===6),p=I();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...f,...p])}e.getDefaultIgnoredSettings=m,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function E(){const o="vscode://schemas/ignoredSettings",u=i.Registry.as(k.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:C.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const f=i.Registry.as(b.Extensions.JSONContribution),p=()=>{const A=I(),O=m().filter(L=>L!==e.CONFIGURATION_SYNC_STORE_KEY),M=Object.keys(k.allSettings.properties).filter(L=>O.indexOf(L)===-1),q=O.filter(L=>A.indexOf(L)===-1),N={items:{type:"string",enum:[...M,...q.map(L=>`-${L}`)]}};f.registerSchema(o,N)};return u.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=E;function h(o){return o&&(0,P.isObject)(o)&&(0,P.isString)(o.id)&&(0,P.isArray)(o.scopes)}e.isAuthenticationProvider=h;var S;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function g(o,u,f){return f.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=g,e.IUserDataSyncStoreManagementService=(0,w.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,w.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,w.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function v(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=v;var y;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(y=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class d extends Error{constructor(u,f,p,A){super(u);this.code=f,this.resource=p,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=d;class c extends d{constructor(u,f,p,A,O){super(u,p,void 0,O);this.url=f,this.serverCode=A}}e.UserDataSyncStoreError=c;class l extends d{constructor(u,f){super(u,f)}}e.UserDataAutoSyncError=l,function(o){function u(f){if(f instanceof o)return f;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(f.name);if(p&&p[1]){const A=p[2]==="unknown"?void 0:p[2],O=p[3]==="unknown"?void 0:p[3];return new o(f.message,p[1],A,O)}return new o(f.message,"Unknown")}o.toUserDataSyncError=u}(d=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var s;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var r;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncResourceEnablementService=(0,w.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,w.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,w.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,w.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,w.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,w.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(f=>(0,T.isEqualOrParent)(o,(0,T.joinPath)(u.userDataSyncHome,f,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(te[48],ne([0,1,17,5,19,27,3,33,2,16,25,18,9,144,21,13,14,46,23,22,24]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function l(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=l;let n=class extends w.Disposable{constructor(o,u,f,p,A,O,M,q,N,L){super();this.resource=o,this.fileService=u,this.environmentService=f,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=O,this.userDataSyncResourceEnablementService=M,this.telemetryService=q,this.logService=N,this.configurationService=L,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new T.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(f.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(f.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(o,f,this.extUri),this.currentMachineIdPromise=(0,v.getServiceMachineId)(f,u,p)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?(await this.doGenerateSyncResourcePreview(o,o,!0,this.getUserDataSyncConfiguration(),R.CancellationToken.None)).resourcePreviews.some(({remoteChange:f})=>f!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){if(this._status!==o){const u=this._status;o==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&o==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=o,this._onDidChangStatus.fire(o)}}async sync(o,u={}){await this._sync(o,!0,this.getUserDataSyncConfiguration(),u)}async preview(o,u,f={}){return this._sync(o,!1,u,f)}async apply(o,u={}){try{this.syncHeaders={...u};const f=await this.doApply(o);return this.setStatus(f),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,u,f,p){try{if(this.syncHeaders={...p},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const O=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(o,O);return A=await this.performSync(M,O,u,f),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(o){const u=await this.resolveContent(o);if(!u)return!1;const f=this.parseSyncData(u);if(!f)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const p=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,p),O=await this.isRemoteDataFromCurrentMachine(A),M=await this.generateSyncPreview({ref:A.ref,syncData:f},p,O,this.getUserDataSyncConfiguration(),R.CancellationToken.None),q=[];for(const N of M){const L=await this.getAcceptResult(N,N.remoteResource,void 0,R.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(N,N.previewResource,N.remoteContent,R.CancellationToken.None);q.push([N,{...L,remoteChange:$!==0?$:2}])}await this.applyResult(A,p,q,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){const u=await this.currentMachineIdPromise;return!!o.syncData?.machineId&&o.syncData.machineId===u}async getLatestRemoteUserData(o,u){if(u){const f=o&&o.latest?o.latest[this.resource]:void 0;if(u.ref===f||f===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(o,u,f,p){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,E.localize)(0,null,this.resource,this.version,o.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(o,u,f,p)}catch(A){if(A instanceof c.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,u,f,p);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(o,u,f,p)}throw A}}async doSync(o,u,f,p){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,T.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(o,u,f,p,O)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":f?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(o){return await this.updateSyncResourcePreview(o,async u=>{const f=await this.getMergeResult(u,R.CancellationToken.None);await this.fileService.writeFile(u.previewResource,P.VSBuffer.fromString(f?.content||""));const p=f&&!f.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,R.CancellationToken.None):void 0;return u.acceptResult=p,u.mergeState=f.hasConflicts?"conflict":p?"accepted":"preview",u.localChange=p?p.localChange:f.localChange,u.remoteChange=p?p.remoteChange:f.remoteChange,u}),this.syncPreviewPromise}async accept(o,u){return await this.updateSyncResourcePreview(o,async f=>{const p=await this.getAcceptResult(f,o,u,R.CancellationToken.None);return f.acceptResult=p,f.mergeState="accepted",f.localChange=p.localChange,f.remoteChange=p.remoteChange,f}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async u=>{const f=await this.getMergeResult(u,R.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,P.VSBuffer.fromString(f.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=f.localChange,u.remoteChange=f.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(o,u){if(!this.syncPreviewPromise)return;let f=await this.syncPreviewPromise;const p=f.resourcePreviews.findIndex(({localResource:A,remoteResource:O,previewResource:M})=>this.extUri.isEqual(A,o)||this.extUri.isEqual(O,o)||this.extUri.isEqual(M,o));p!==-1&&(this.syncPreviewPromise=(0,T.createCancelablePromise)(async A=>{const O=[...f.resourcePreviews];return O[p]=await u(O[p]),{...f,resourcePreviews:O}}),f=await this.syncPreviewPromise,this.updateConflicts(f.resourcePreviews),f.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:f})=>f==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:f})=>f!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(f=>[f,f.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(o){}}updateConflicts(o){const u=o.filter(({mergeState:f})=>f==="conflict");(0,D.equals)(this._conflicts,u,(f,p)=>this.extUri.isEqual(f.previewResource,p.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:f})=>({created:u,uri:this.toRemoteBackupResource(f)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:f})=>({created:u,uri:this.toLocalBackupResource(f)}))}toRemoteBackupResource(o){return m.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return m.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:f}=await this.getUserData(u);if(f)return this.parseSyncData(f)?.machineId}}async resolveContent(o){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:f}=await this.getUserData(u);return f}return this.extUri.isEqual(o,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(o){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const f of u.resourcePreviews){if(this.extUri.isEqual(f.acceptedResource,o))return f.acceptResult?f.acceptResult.content:null;if(this.extUri.isEqual(f.remoteResource,o))return f.remoteContent;if(this.extUri.isEqual(f.localResource,o))return f.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(o){}}async doGenerateSyncResourcePreview(o,u,f,p,A){const O=await this.isRemoteDataFromCurrentMachine(o),M=await this.generateSyncPreview(o,u,O,p,A),q=[];for(const N of M){const L=N.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(N.localChange===0&&N.remoteChange===0)q.push({...N,acceptedResource:L,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=f?await this.getMergeResult(N,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(N.previewResource,P.VSBuffer.fromString($?.content||""));const _=$&&!$.hasConflicts?await this.getAcceptResult(N,N.previewResource,void 0,A):void 0;q.push({...N,acceptResult:_,mergeState:$?.hasConflicts?"conflict":_?"accepted":"preview",localChange:_?_.localChange:$?$.localChange:N.localChange,remoteChange:_?_.remoteChange:$?$.remoteChange:N.remoteChange})}}return{remoteUserData:o,lastSyncUserData:u,resourcePreviews:q,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(o.value.toString()),f=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&f&&u.version!==f,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${f}.`),await this.resetLocal(),null;const p=u;if(p.content===null)return{ref:u.ref,syncData:null};const A=JSON.parse(p.content);if(l(A))return{...u,syncData:A,content:void 0}}catch(o){o instanceof g.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const f=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),p={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:f,...u};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(p)))}async getRemoteUserData(o){const{ref:u,content:f}=await this.getUserData(o);let p=null;return f!==null&&(p=this.parseSyncData(f)),{ref:u,syncData:p}}parseSyncData(o){try{const u=JSON.parse(o);if(l(u))return u}catch(u){this.logService.error(u)}throw new c.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(o){if((0,I.isString)(o)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:u}}else{const u=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(o,u){const f=await this.currentMachineIdPromise,p={version:this.version,machineId:f,content:o};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(p),u,this.syncHeaders),{ref:u,syncData:p}}async backupLocal(o){const u={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};n=he([X(1,g.IFileService),X(2,S.IEnvironmentService),X(3,y.IStorageService),X(4,c.IUserDataSyncStoreService),X(5,c.IUserDataSyncBackupStoreService),X(6,c.IUserDataSyncResourceEnablementService),X(7,d.ITelemetryService),X(8,c.IUserDataSyncLogService),X(9,h.IConfigurationService)],n),e.AbstractSynchroniser=n;let s=class extends n{constructor(o,u,f,p,A,O,M,q,N,L,$){super(u,f,p,A,O,M,q,N,L,$);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange(_=>this.onFileChanges(_)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(o){return null}}async updateLocalFileContent(o,u,f){try{u?await this.writeFileContent(o,u,f):await this.fileService.createFile(this.file,P.VSBuffer.fromString(o),{overwrite:f})}catch(p){throw p instanceof g.FileOperationError&&p.fileOperationResult===1||p instanceof g.FileOperationError&&p.fileOperationResult===3?new c.UserDataSyncError(p.message,"LocalPreconditionFailed"):p}}async writeFileContent(o,u,f){await this.fileService.writeFile(this.file,P.VSBuffer.fromString(o),f?void 0:u)}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};s=he([X(2,g.IFileService),X(3,S.IEnvironmentService),X(4,y.IStorageService),X(5,c.IUserDataSyncStoreService),X(6,c.IUserDataSyncBackupStoreService),X(7,c.IUserDataSyncResourceEnablementService),X(8,d.ITelemetryService),X(9,c.IUserDataSyncLogService),X(10,h.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let r=class extends s{constructor(o,u,f,p,A,O,M,q,N,L,$,_){super(o,u,f,p,A,O,M,q,N,L,_);this.userDataSyncUtilService=$,this._formattingOptions=void 0}hasErrors(o){const u=[];return(0,C.parse)(o,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};r=he([X(2,g.IFileService),X(3,S.IEnvironmentService),X(4,y.IStorageService),X(5,c.IUserDataSyncStoreService),X(6,c.IUserDataSyncBackupStoreService),X(7,c.IUserDataSyncResourceEnablementService),X(8,d.ITelemetryService),X(9,c.IUserDataSyncLogService),X(10,c.IUserDataSyncUtilService),X(11,h.IConfigurationService)],r),e.AbstractJsonFileSynchroniser=r;let t=class{constructor(o,u,f,p){this.resource=o,this.environmentService=u,this.logService=f,this.fileService=p,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,u,b.extUri)}async initialize({ref:o,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const f=this.parseSyncData(u);if(!f)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:o,syncData:f})}catch(A){this.logService.error(A)}}parseSyncData(o){try{const u=JSON.parse(o);if(l(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,u={}){const f={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(f)))}};t=he([X(1,S.IEnvironmentService),X(2,c.IUserDataSyncLogService),X(3,g.IFileService)],t),e.AbstractInitializer=t}),define(te[219],ne([0,1,5,27,7,3,39,49,25,9,21,13,30,36,14,23,22,48,216,97,98,24]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function n(o,u){const f=JSON.parse(o.content);if(o.version===1||o.version===2){const p=(await u.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of f)o.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),o.version===2&&p.every(O=>!(0,E.areSameExtensions)(O.identifier,A.identifier))&&(A.installed=!0)}return f}function s(o,u,f){const p=f.get((0,E.getExtensionId)(o,u),0)||"{}";return JSON.parse(p)}e.getExtensionStorageState=s;function r(o,u,f,p){p.store((0,E.getExtensionId)(o,u),JSON.stringify(f),0,1)}e.storeExtensionStorageState=r;let t=class ht extends v.AbstractSynchroniser{constructor(u,f,p,A,O,M,q,N,L,$,_,F,V,W){super("extensions",f,u,p,A,O,F,V,L,_);this.storageService=p,this.extensionManagementService=M,this.extensionEnablementService=q,this.ignoredExtensionsManagementService=N,this.extensionGalleryService=$,this.extensionsStorageSyncService=W,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:z})=>!!z)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(u,f){const p=u.syncData?await n(u.syncData,this.extensionManagementService):null,A=f?.skippedExtensions||[],O=f?.syncData?await n(f.syncData,this.extensionManagementService):null,M=await this.extensionManagementService.getInstalled(void 0,!0),q=this.getLocalExtensions(M),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(M);p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:L,remote:$}=(0,y.merge)(q,p,O,A,N),_={local:L,remote:$,content:this.getPreviewContent(q,L.added,L.updated,L.removed),localChange:L.added.length>0||L.removed.length>0||L.updated.length>0?2:0,remoteChange:$!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.format(q),localExtensions:q,remoteResource:this.remoteResource,remoteContent:p?this.format(p):null,previewResource:this.previewResource,previewResult:_,localChange:_.localChange,remoteChange:_.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(u,f,p,A){const O=[...f,...p],M=new Set,q=N=>{M.add(N.id.toLowerCase()),N.uuid&&M.add(N.uuid)};O.forEach(({identifier:N})=>q(N)),A.forEach(q);for(const N of u)M.has(N.identifier.id.toLowerCase())||N.identifier.uuid&&M.has(N.identifier.uuid)||O.push(N);return this.format(O)}async getMergeResult(u,f){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,f,p,A){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(f,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(u){const f=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),A=(0,y.merge)(u.localExtensions,null,null,u.skippedExtensions,p),{local:O,remote:M}=A;return{content:u.localContent,local:O,remote:M,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:M!==null?2:0}}async acceptRemote(u){const f=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),A=u.remoteContent?JSON.parse(u.remoteContent):null;if(A!==null){const O=(0,y.merge)(u.localExtensions,A,u.localExtensions,[],p),{local:M,remote:q}=O;return{content:u.remoteContent,local:M,remote:q,localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,f,p,A){let{skippedExtensions:O,localExtensions:M}=p[0][0],{local:q,remote:N,localChange:L,remoteChange:$}=p[0][1];if(L===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),L!==0&&(await this.backupLocal(JSON.stringify(M)),O=await this.updateLocalExtensions(q.added,q.removed,q.updated,O)),N){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const _=JSON.stringify(N.all);u=await this.updateRemoteUserData(_,A?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${N.added.length?` Added: ${JSON.stringify(N.added.map(F=>F.identifier.id))}.`:""}${N.updated.length?` Updated: ${JSON.stringify(N.updated.map(F=>F.identifier.id))}.`:""}${N.removed.length?` Removed: ${JSON.stringify(N.removed.map(F=>F.identifier.id))}.`:""}`)}f?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(_=>_.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:ht.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,ht.EXTENSIONS_DATA_URI)){const p=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(p),O=this.getLocalExtensions(p).filter(M=>!A.some(q=>(0,E.areSameExtensions)({id:q},M.identifier)));return this.format(O)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let f=await super.resolveContent(u);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(u)),f){const p=this.parseSyncData(f);if(p)switch(this.extUri.basename(u)){case"extensions.json":return this.format(this.parseExtensions(p))}}return null}format(u){u.sort((A,O)=>!A.identifier.uuid&&O.identifier.uuid?-1:A.identifier.uuid&&!O.identifier.uuid?1:(0,w.compare)(A.identifier.id,O.identifier.id));const f=JSON.stringify(u),p=(0,C.format)(f,void 0,{});return(0,k.applyEdits)(f,p)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(u).some(p=>p.installed||p.disabled))return!0}catch(u){}return!1}async updateLocalExtensions(u,f,p,A){const O=[],M=[],q=await this.extensionManagementService.getInstalled();if(f.length){const L=q.filter(({identifier:$,isBuiltin:_})=>!_&&f.some(F=>(0,E.areSameExtensions)($,F)));await D.Promises.settled(L.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),O.push($.identifier)}))}(u.length||p.length)&&await D.Promises.settled([...u,...p].map(async L=>{const $=q.find(F=>(0,E.areSameExtensions)(F.identifier,L.identifier));if($&&$.isBuiltin){L.state&&$.manifest.version===L.version&&this.updateExtensionState(L.state,$.manifest.publisher,$.manifest.name,$.manifest.version),L.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,L.identifier.id),await this.extensionEnablementService.disableExtension(L.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,L.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,L.identifier.id),await this.extensionEnablementService.enableExtension(L.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,L.identifier.id)),O.push(L.identifier);return}const _=(await this.extensionGalleryService.getExtensions([L.identifier],T.CancellationToken.None))[0];if(L.state&&($?$.manifest.version===L.version:!!_)){const F=$?$.manifest.publisher:_.publisher,V=$?$.manifest.name:_.name;this.updateExtensionState(L.state,F,V,$?.manifest.version)}if(_)try{L.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,L.identifier.id,_.version),await this.extensionEnablementService.disableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,L.identifier.id,_.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,L.identifier.id,_.version),await this.extensionEnablementService.enableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,L.identifier.id,_.version)),$||(await this.extensionManagementService.canInstall(_)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,L.identifier.id,_.version),await this.extensionManagementService.installFromGallery(_,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,L.identifier.id,_.version),O.push(_.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,_.displayName||_.identifier.id),M.push(L)))}catch(F){M.push(L),F instanceof m.ExtensionManagementError&&F.code===m.ExtensionManagementErrorCode.Incompatible?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,_.displayName||_.identifier.id):(this.logService.error(F),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,_.displayName||_.identifier.id))}else M.push(L),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,L.identifier.id)}));const N=[];for(const L of A)O.some($=>(0,E.areSameExtensions)($,L.identifier))||N.push(L);for(const L of M)N.some($=>(0,E.areSameExtensions)($.identifier,L.identifier))||N.push(L);return N}updateExtensionState(u,f,p,A){const O=s(f,p,this.storageService),M=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,E.getGalleryExtensionId)(f,p),version:A}):void 0;M?M.forEach(q=>{O[q]=u[q]}):Object.keys(u).forEach(q=>O[q]=u[q]),r(f,p,O,this.storageService)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const f=this.extensionEnablementService.getDisabledExtensions();return u.map(({identifier:p,isBuiltin:A,manifest:O})=>{const M={identifier:p,version:O.version};f.some(q=>(0,E.areSameExtensions)(q,p))&&(M.disabled=!0),A||(M.installed=!0);try{const q=this.extensionsStorageSyncService.getKeysForSync({id:p.id,version:O.version});if(q){const N=s(O.publisher,O.name,this.storageService);M.state=Object.keys(N).reduce((L,$)=>(q.includes($)&&(L[$]=N[$]),L),{})}}catch(q){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,P.getErrorMessage)(q))}return M})}};t.EXTENSIONS_DATA_URI=b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),t=he([X(0,I.IEnvironmentService),X(1,h.IFileService),X(2,S.IStorageService),X(3,l.IUserDataSyncStoreService),X(4,l.IUserDataSyncBackupStoreService),X(5,m.IExtensionManagementService),X(6,m.IGlobalExtensionEnablementService),X(7,c.IIgnoredExtensionsManagementService),X(8,l.IUserDataSyncLogService),X(9,m.IExtensionGalleryService),X(10,i.IConfigurationService),X(11,l.IUserDataSyncResourceEnablementService),X(12,g.ITelemetryService),X(13,d.IExtensionsStorageSyncService)],t),e.ExtensionsSynchroniser=t;let a=class extends v.AbstractInitializer{constructor(u,f,p,A,O){super("extensions",A,O,p);this.extensionManagementService=u,this.ignoredExtensionsManagementService=f}async parseExtensions(u){return u.syncData?await n(u.syncData,this.extensionManagementService):null}generatePreview(u,f){const p=[],A=[],O=[];for(const M of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(M.identifier.id))continue;const q=f.find(N=>(0,E.areSameExtensions)(N.identifier,M.identifier));q?(p.push(q),M.disabled&&O.push(M.identifier)):M.installed&&(A.push(M.identifier),M.disabled&&O.push(M.identifier))}return{installedExtensions:p,newExtensions:A,disabledExtensions:O,remoteExtensions:u}}};a=he([X(0,m.IExtensionManagementService),X(1,c.IIgnoredExtensionsManagementService),X(2,h.IFileService),X(3,I.IEnvironmentService),X(4,l.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(te[220],ne([0,1,26,24]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(C,w,b,i,I){if(!w)return{remote:Object.keys(C).length>0?C:null,local:{added:{},removed:[],updated:{}}};const m=R(C,w);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const E=b?R(b,w):{added:Object.keys(w).reduce((y,d)=>(y.add(d),y),new Set),removed:new Set,updated:new Set},h=b?R(b,C):{added:Object.keys(C).reduce((y,d)=>(y.add(d),y),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},g=D.deepClone(w),v=!b;for(const y of h.added.values())y!==T.SYNC_SERVICE_URL_TYPE&&v&&E.added.has(y)||(g[y]=C[y]);for(const y of h.updated.values())g[y]=C[y];for(const y of h.removed.values())i.unregistered.includes(y)||delete g[y];for(const y of E.added.values()){const d=w[y];if(i.machine.includes(y)){I.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(y))continue;const c=C[y];c&&c.value===d.value||y===T.SYNC_SERVICE_URL_TYPE&&v&&h.added.has(y)||(c?S.updated[y]=d:S.added[y]=d)}for(const y of E.updated.values()){const d=w[y];if(i.machine.includes(y)){I.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(y)||h.removed.has(y))continue;const c=C[y];c&&c.value===d.value||(S.updated[y]=d)}for(const y of E.removed.values()){if(i.machine.includes(y)){I.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}h.updated.has(y)||h.removed.has(y)||S.removed.push(y)}return{local:S,remote:k(g,w)?null:g}}e.merge=P;function R(C,w){const b=Object.keys(C),i=Object.keys(w),I=i.filter(h=>b.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),m=b.filter(h=>i.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),E=new Set;for(const h of b){if(m.has(h))continue;const S=C[h],g=w[h];D.equals(S,g)||E.add(h)}return{added:I,removed:m,updated:E}}function k(C,w){const{added:b,removed:i,updated:I}=R(C,w);return b.size===0&&i.size===0&&I.size===0}}),define(te[221],ne([0,1,19,7,3,33,39,49,4,9,29,21,13,14,10,46,23,22,48,54,220,24]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const n="globalState.argv.",s=["locale"];function r(f){const p=f.storage?Object.keys(f.storage).sort():[],A={};p.forEach(q=>A[q]=f.storage[q]),f.storage=A;const O=JSON.stringify(f),M=(0,C.format)(O,void 0,{});return(0,k.applyEdits)(O,M)}const t=1;let a=class ft extends y.AbstractSynchroniser{constructor(p,A,O,M,q,N,L,$,_){super("globalState",p,q,_,A,O,N,L,M,$);this.storageService=_,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(p.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(P.Event.any(P.Event.filter(p.onDidFilesChange,F=>F.contains(this.environmentService.argvResource)),P.Event.filter(_.onDidChangeValue,F=>F.scope===0&&F.target!==void 0?F.target===0:_.keys(0,0).includes(F.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(p,A,O){const M=p.syncData?JSON.parse(p.syncData.content):null;A=A===null&&O?p:A;const q=A&&A.syncData?JSON.parse(A.syncData.content):null,N=await this.getLocalGlobalState();M?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const L=this.getStorageKeys(q),{local:$,remote:_}=(0,c.merge)(N.storage,M?M.storage:null,q?q.storage:null,L,this.logService),F={content:null,local:$,remote:_,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:_!==null?2:0};return[{localResource:this.localResource,localContent:r(N),localUserData:N,remoteResource:this.remoteResource,remoteContent:M?r(M):null,previewResource:this.previewResource,previewResult:F,localChange:F.localChange,remoteChange:F.remoteChange,acceptedResource:this.acceptedResource,storageKeys:L}]}async getMergeResult(p,A){return{...p.previewResult,hasConflicts:!1}}async getAcceptResult(p,A,O,M){if(this.extUri.isEqual(A,this.localResource))return this.acceptLocal(p);if(this.extUri.isEqual(A,this.remoteResource))return this.acceptRemote(p);if(this.extUri.isEqual(A,this.previewResource))return p.previewResult;throw new Error(`Invalid Resource: ${A.toString()}`)}async acceptLocal(p){return{content:p.localContent,local:{added:{},removed:[],updated:{}},remote:p.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(p){if(p.remoteContent!==null){const A=JSON.parse(p.remoteContent),{local:O,remote:M}=(0,c.merge)(p.localUserData.storage,A.storage,null,p.storageKeys,this.logService);return{content:p.remoteContent,local:O,remote:M,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:p.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(p,A,O,M){let{localUserData:q}=O[0][0],{local:N,remote:L,localChange:$,remoteChange:_}=O[0][1];if($===0&&_===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),$!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(q)),await this.writeLocalGlobalState(N),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),_!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const F=JSON.stringify({storage:L});p=await this.updateRemoteUserData(F,M?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}A?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:p}){return[{resource:this.extUri.joinPath(p,"globalState.json"),comparableResource:ft.GLOBAL_STATE_DATA_URI}]}async resolveContent(p){if(this.extUri.isEqual(p,ft.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return r(O)}if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let A=await super.resolveContent(p);if(A)return A;if(A=await super.resolveContent(this.extUri.dirname(p)),A){const O=this.parseSyncData(A);if(O)switch(this.extUri.basename(p)){case"globalState.json":return r(JSON.parse(O.content))}}return null}async hasLocalData(){try{const{storage:p}=await this.getLocalGlobalState();if(Object.keys(p).length>1||p[`${n}.locale`]?.value!=="en")return!0}catch(p){}return!1}async getLocalGlobalState(){const p={},A=await this.getLocalArgvContent(),O=(0,R.parse)(A);for(const M of s)O[M]!==void 0&&(p[`${n}${M}`]={version:1,value:O[M]});for(const M of this.storageService.keys(0,0)){const q=this.storageService.get(M,0);q&&(p[M]={version:1,value:q})}return{storage:p}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const p=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),p.value.toString()}catch(p){this.logService.debug((0,T.getErrorMessage)(p))}return"{}"}async writeLocalGlobalState({added:p,removed:A,updated:O}){const M={},q={},N=($,_)=>{for(const F of $){if(F.startsWith(n)){M[F.substring(n.length)]=_?_[F].value:void 0;continue}if(_){const V=_[F];V.value!==String(this.storageService.get(F,0))&&(q[F]=V.value)}else this.storageService.get(F,0)!==void 0&&(q[F]=void 0)}};if(N(Object.keys(p),p),N(Object.keys(O),O),N(A),Object.keys(M).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(M),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(q).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const $ of Object.keys(q))this.storageService.store($,q[$],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(q))}}async updateArgv(p){const A=await this.getLocalArgvContent();let O=A;for(const M of Object.keys(p))O=(0,d.edit)(O,[M],p[M],{});A!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(p){const A=this.storageService.keys(0,0),O=this.storageService.keys(0,1),M=[...A,...O],q=p?.storage?Object.keys(p.storage).filter(N=>!N.startsWith(n)&&!M.includes(N)&&this.storageService.get(N,0)!==void 0):[];if(!w.isWeb){const N=[...l.ALL_SYNC_RESOURCES.map(L=>(0,l.getEnablementKey)(L)),l.SYNC_SERVICE_URL_TYPE];q.push(...N),O.push(...N)}return{user:A,machine:O,unregistered:q}}};a.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=he([X(0,E.IFileService),X(1,l.IUserDataSyncStoreService),X(2,l.IUserDataSyncBackupStoreService),X(3,l.IUserDataSyncLogService),X(4,m.IEnvironmentService),X(5,l.IUserDataSyncResourceEnablementService),X(6,v.ITelemetryService),X(7,I.IConfigurationService),X(8,g.IStorageService)],a),e.GlobalStateSynchroniser=a;let o=class extends y.AbstractInitializer{constructor(p,A,O,M){super("globalState",O,M,A);this.storageService=p}async doInitialize(p){const A=p.syncData?JSON.parse(p.syncData.content):null;if(!A){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},M={};for(const q of Object.keys(A.storage))q.startsWith(n)?O[q.substring(n.length)]=A.storage[q].value:this.storageService.get(q,0)===void 0&&(M[q]=A.storage[q].value);if(Object.keys(O).length){let q="{}";try{q=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(N){}for(const N of Object.keys(O))q=(0,d.edit)(q,[N],O[N],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(q))}if(Object.keys(M).length)for(const q of Object.keys(M))this.storageService.store(q,M[q],0,0)}};o=he([X(0,g.IStorageService),X(1,E.IFileService),X(2,m.IEnvironmentService),X(3,l.IUserDataSyncLogService)],o),e.GlobalStateInitializer=o;let u=class{constructor(p,A,O,M,q){this.userDataSyncStoreClient=p,this.storageService=A,this.environmentService=O,this.fileService=M,this.logService=q}getSyncStoreType(p){return this.parseGlobalState(p)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(p){const A=(0,l.createSyncHeaders)((0,i.generateUuid)());try{return await this.doSync(p,A)}catch(O){if(O instanceof l.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(p,A)}throw O}}async doSync(p,A){const O=await this.userDataSyncStoreClient.read("globalState",null,A),M=this.parseGlobalState(O)||{storage:{}};M.storage[l.SYNC_SERVICE_URL_TYPE]={value:p,version:t};const q=await(0,S.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),N={version:t,machineId:q,content:r(M)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(N),O.ref,A)}parseGlobalState({content:p}){if(!p)return null;const A=JSON.parse(p);if((0,y.isSyncData)(A))return A?JSON.parse(A.content):null;throw new Error("Invalid remote data")}};u=he([X(1,g.IStorageService),X(2,m.IEnvironmentService),X(3,E.IFileService),X(4,h.ILogService)],u),e.UserDataSyncStoreTypeSynchronizer=u}),define(te[222],ne([0,1,17,19,3,33,4,18,145,21,13,14,23,22,48,217,24]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function v(c,l,n){try{const s=JSON.parse(c);if(!l)return(0,C.isUndefined)(s.all)?null:s.all;switch(k.OS){case 2:return(0,C.isUndefined)(s.mac)?null:s.mac;case 3:return(0,C.isUndefined)(s.linux)?null:s.linux;case 1:return(0,C.isUndefined)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.getKeybindingsContentFromSyncContent=v;let y=class extends h.AbstractJsonFileSynchroniser{constructor(l,n,s,r,t,a,o,u,f,p){super(o.keybindingsResource,"keybindings",a,o,u,l,n,t,p,s,f,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.Event.filter(r.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(l,n,s,r){const t=l.syncData?v(l.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&s?l:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,o=await this.getLocalFileContent(),u=await this.getFormattingOptions();let f=null,p=!1,A=!1,O=!1;if(t){let q=o?o.value.toString():"[]";if(q=q||"[]",this.hasErrors(q))throw new g.UserDataSyncError((0,w.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==t){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const N=await(0,S.merge)(q,t,a,u,this.userDataSyncUtilService);N.hasChanges&&(f=N.mergeContent,O=N.hasConflicts,p=O||N.mergeContent!==q,A=O||N.mergeContent!==t)}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=o.value.toString(),A=!0);const M={content:f,localChange:p?o?2:1:0,remoteChange:A?2:0,hasConflicts:O};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:t,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async getMergeResult(l,n){return l.previewResult}async getAcceptResult(l,n,s,r){if(this.extUri.isEqual(n,this.localResource))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return s===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(l,n,s,r){const{fileContent:t}=s[0][0];let{content:a,localChange:o,remoteChange:u}=s[0][1];if(o===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a)))throw new g.UserDataSyncError((0,w.localize)(1,null),"LocalInvalidContent",this.resource);if(o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),t&&await this.backupLocal(this.toSyncContent(t.value.toString())),await this.updateLocalFileContent(a||"[]",t,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const f=this.toSyncContent(a||"[]",l.syncData?.content);l=await this.updateRemoteUserData(f,r?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(f){}n?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(l,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const l=await this.getLocalFileContent();if(l){const n=(0,R.parse)(l.value.toString());if((0,D.isNonEmptyArray)(n))return!0}}catch(l){if(l.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:l}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(l,"keybindings.json"),comparableResource:n}]}async resolveContent(l){if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l))return this.resolvePreviewContent(l);let n=await super.resolveContent(l);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(l)),n){const s=this.parseSyncData(n);if(s)switch(this.extUri.basename(l)){case"keybindings.json":return v(s.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(l){return!l.syncData||l.platformSpecific!==void 0&&l.platformSpecific!==this.syncKeybindingsPerPlatform()?null:v(l.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(l,n){let s={};try{s=JSON.parse(n||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=l,k.OS){case 2:s.mac=l;break;case 3:s.linux=l;break;case 1:s.windows=l;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=he([X(0,g.IUserDataSyncStoreService),X(1,g.IUserDataSyncBackupStoreService),X(2,g.IUserDataSyncLogService),X(3,b.IConfigurationService),X(4,g.IUserDataSyncResourceEnablementService),X(5,I.IFileService),X(6,i.IEnvironmentService),X(7,m.IStorageService),X(8,g.IUserDataSyncUtilService),X(9,E.ITelemetryService)],y),e.KeybindingsSynchroniser=y;let d=class extends h.AbstractInitializer{constructor(l,n,s){super("keybindings",n,s,l)}async doInitialize(l){const n=l.syncData?this.getKeybindingsContentFromSyncContent(l.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,T.VSBuffer.fromString(n)),await this.updateLastSyncUserData(l)}async isEmpty(){try{const l=await this.fileService.readFile(this.environmentService.settingsResource),n=(0,R.parse)(l.value.toString());return!(0,D.isNonEmptyArray)(n)}catch(l){return l.fileOperationResult===1}}getKeybindingsContentFromSyncContent(l){try{return v(l,!0,this.logService)}catch(n){return this.logService.error(n),null}}};d=he([X(0,I.IFileService),X(1,i.IEnvironmentService),X(2,g.IUserDataSyncLogService)],d),e.KeybindingsInitializer=d}),define(te[223],ne([0,1,17,33,39,49,26,54,24]),function(J,e,D,T,P,R,k,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(o,u,f){let p=[];f?p=I(f):p=i(u);const A=[],O=[...(0,w.getDisallowedIgnoredSettings)()];if(Array.isArray(p))for(const M of p)M.startsWith("-")?O.push(M.substring(1)):A.push(M);return(0,D.distinct)([...o,...A].filter(M=>O.indexOf(M)===-1))}e.getIgnoredSettings=b;function i(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function I(o){const u=(0,T.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function m(o,u,f,p){if(f.length){const A=a(u),O=(0,T.parse)(u),M=(0,T.parse)(o),q=[];for(const N of f){const L=O[N],$=M[N];L===void 0?o=C.edit(o,[N],void 0,p):$!==void 0?o=C.edit(o,[N],L,p):q.push(l(N,A))}q.sort((N,L)=>N.startOffset-L.startOffset),q.forEach(N=>o=v(N.setting.key,u,o,p))}return o}e.updateIgnoredSettings=m;function E(o,u,f,p,A,O){const M=m(o,u,p,O),q=f!==M,N=f!==u;if(!q&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(q&&!N)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(N&&!q)return{conflictsSettings:[],localContent:m(u,o,p,O),remoteContent:null,hasConflicts:!1};if(f===null&&S(o)){const H=h(o,u,p)?null:m(u,o,p,O);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let L=o,$=u;const _=(0,T.parse)(o),F=(0,T.parse)(u),V=f?(0,T.parse)(f):null,W=p.reduce((H,re)=>(H.add(re),H),new Set),x=g(_,F,W),z=g(V,_,W),K=g(V,F,W),U=new Map,B=new Set,j=H=>{B.add(H);const re=A.filter(({key:ie})=>ie===H)[0];re?(L=C.edit(L,[H],re.value,O),$=C.edit($,[H],re.value,O)):U.set(H,{key:H,localValue:_[H],remoteValue:F[H]})};for(const H of z.removed.values())K.updated.has(H)?j(H):$=C.edit($,[H],void 0,O);for(const H of K.removed.values())B.has(H)||(z.updated.has(H)?j(H):L=C.edit(L,[H],void 0,O));for(const H of z.updated.values())B.has(H)||(K.updated.has(H)?x.updated.has(H)&&j(H):$=C.edit($,[H],_[H],O));for(const H of K.updated.values())B.has(H)||(z.updated.has(H)?x.updated.has(H)&&j(H):L=C.edit(L,[H],F[H],O));for(const H of z.added.values())B.has(H)||(K.added.has(H)?x.updated.has(H)&&j(H):$=v(H,L,$,O));for(const H of K.added.values())B.has(H)||(z.added.has(H)?x.updated.has(H)&&j(H):L=v(H,$,L,O));const Q=U.size>0||!h(L,$,p),Z=Q||!h(L,o,[]),G=Q||!h($,u,[]);return{localContent:Z?L:null,remoteContent:G?$:null,conflictsSettings:[...U.values()],hasConflicts:Q}}e.merge=E;function h(o,u,f){if(o===u)return!0;const p=(0,T.parse)(o),A=(0,T.parse)(u),O=f.reduce((N,L)=>(N.add(L),N),new Set),M=a(o).filter(N=>!(N.setting&&O.has(N.setting.key))),q=a(u).filter(N=>!(N.setting&&O.has(N.setting.key)));if(M.length!==q.length)return!1;for(let N=0;N<M.length;N++){const L=M[N],$=q[N];if(L.setting&&$.setting){if(L.setting.key!==$.setting.key||!k.equals(p[L.setting.key],A[L.setting.key]))return!1}else if(!L.setting&&!$.setting){if(L.value!==$.value)return!1}else return!1}return!0}e.areSame=h;function S(o){return o?a(o).length===0:!0}e.isEmpty=S;function g(o,u,f){const p=o?Object.keys(o).filter(N=>!f.has(N)):[],A=Object.keys(u).filter(N=>!f.has(N)),O=A.filter(N=>p.indexOf(N)===-1).reduce((N,L)=>(N.add(L),N),new Set),M=p.filter(N=>A.indexOf(N)===-1).reduce((N,L)=>(N.add(L),N),new Set),q=new Set;if(o)for(const N of p){if(M.has(N))continue;const L=o[N],$=u[N];k.equals(L,$)||q.add(N)}return{added:O,removed:M,updated:q}}function v(o,u,f,p){const A=(0,T.parse)(u),O=a(u),M=a(f),q=y(o,O,M);return d(f,o,A[o],q,M,p)}e.addSetting=v;function y(o,u,f){const p=u.findIndex(O=>O.setting?.key===o),A=u[p-1];if(A){if(A.setting){const M=l(A.setting.key,f);if(M)return{index:f.indexOf(M),insertAfter:!0}}else{const M=n(p,u);if(M){const q=l(M.setting.key,f);if(q){const N=s(f.indexOf(q),f),L=r(u,M,u[p]);if(N){const $=r(f,q,N),_=t(L,$);return _?{index:f.indexOf(_),insertAfter:!0}:{index:f.indexOf(N),insertAfter:!1}}else{const $=r(f,q,f[f.length-1]),_=t(L,$);return _?{index:f.indexOf(_),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const O=u[p+1];if(O)if(O.setting){const M=l(O.setting.key,f);if(M)return{index:f.indexOf(M),insertAfter:!1}}else{const M=s(p,u);if(M){const q=l(M.setting.key,f);if(q){const N=n(f.indexOf(q),f),L=r(u,u[p],M);if(N){const $=r(f,N,q),_=t(L.reverse(),$.reverse());return _?{index:f.indexOf(_),insertAfter:!1}:{index:f.indexOf(N),insertAfter:!0}}else{const $=r(f,f[0],q),_=t(L.reverse(),$.reverse());return _?{index:f.indexOf(_),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function d(o,u,f,p,A,O){let M;return p.index===-1?M=(0,P.setProperty)(o,[u],f,O):M=c(o,u,f,p,A,O).map(q=>(0,P.withFormatting)(o,q,O)[0]),(0,P.applyEdits)(o,M)}function c(o,u,f,p,A,O){const M=`${JSON.stringify(u)}: ${JSON.stringify(f)}`,q=(0,R.getEOL)(O,o),N=A[p.index];if(p.insertAfter){const L=[];if(N.setting)L.push({offset:N.endOffset,length:0,content:","+M});else{const $=s(p.index,A),_=n(p.index,A),F=_?.setting?.commaOffset;_&&F===void 0&&L.push({offset:_.endOffset,length:0,content:","});const V=F!==void 0&&F>N.endOffset;L.push({offset:V?F+1:N.endOffset,length:0,content:$?q+M+",":q+M})}return L}else{if(N.setting)return[{offset:N.startOffset,length:0,content:M+","}];const L=(A[p.index-1]&&!A[p.index-1].setting?q:"")+M+(s(p.index,A)?",":"")+q;return[{offset:N.startOffset,length:0,content:L}]}}function l(o,u){return u.filter(f=>f.setting?.key===o)[0]}function n(o,u){for(let f=o-1;f>=0;f--)if(u[f].setting)return u[f]}function s(o,u){for(let f=o+1;f<u.length;f++)if(u[f].setting)return u[f]}function r(o,u,f){const p=o.indexOf(u),A=o.indexOf(f);return o.filter((O,M)=>p<M&&M<A)}function t(o,u){if(o.length&&u.length){let f=0;for(;f<u.length&&f<o.length;f++)if(o[f].value!==u[f].value)return u[f-1];return u[f-1]}}function a(o){const u=[];let f=-1,p,A;const O={onObjectBegin:M=>{f++},onObjectProperty:(M,q,N)=>{f===0&&(p=q,A=M)},onObjectEnd:(M,q)=>{f--,f===0&&u.push({startOffset:p,endOffset:M+q,value:o.substring(p,M+q),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(M,q)=>{f++},onArrayEnd:(M,q)=>{f--,f===0&&u.push({startOffset:p,endOffset:M+q,value:o.substring(p,M+q),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(M,q,N)=>{f===0&&u.push({startOffset:p,endOffset:q+N,value:o.substring(p,q+N),setting:{key:A,commaOffset:void 0}})},onSeparator:(M,q,N)=>{if(f===0&&M===","){let L=u.length-1;for(;L>=0&&!u[L].setting;L--);const $=u[L];$&&u.splice(L,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:q}})}},onComment:(M,q)=>{f===0&&u.push({startOffset:M,endOffset:M+q,value:o.substring(M,M+q)})}};return(0,T.visit)(o,O),u}}),define(te[224],ne([0,1,19,3,39,146,21,88,85,13,30,14,23,22,48,54,223,24]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function y(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function d(s){const r=JSON.parse(s);return y(r)?r:{settings:s}}e.parseSettingsSyncContent=d;let c=class extends h.AbstractJsonFileSynchroniser{constructor(r,t,a,o,u,f,p,A,O,M,q,N){super(t.settingsResource,"settings",r,t,a,o,u,O,M,f,p,A);this.extensionManagementService=q,this.userConfigurationFileService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),a=await this.getLatestRemoteUserData(r,t),o=this.getSettingsSyncContent(a),u=new C.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&u.parse(o.settings),u.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,t,a){const o=await this.getLocalFileContent(),u=await this.getFormattingOptions(),f=this.getSettingsSyncContent(r);t=t===null&&a?r:t;const p=t?this.getSettingsSyncContent(t):null,A=await this.getIgnoredSettings();let O=null,M=!1,q=!1,N=!1;if(f){let $=o?o.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const _=(0,g.merge)($,f.settings,p?p.settings:null,A,[],u);O=_.localContent||_.remoteContent,M=_.localContent!==null,q=_.remoteContent!==null,N=_.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),O=o.value.toString(),q=!0);const L={content:O,localChange:M?2:0,remoteChange:q?2:0,hasConflicts:N};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:L.localChange,remoteResource:this.remoteResource,remoteContent:f?f.settings:null,remoteChange:L.remoteChange,previewResource:this.previewResource,previewResult:L,acceptedResource:this.acceptedResource}]}async getMergeResult(r,t){const a=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,g.updateIgnoredSettings)(r.previewResult.content,"{}",o,a):null}}async getAcceptResult(r,t,a,o){const u=await this.getFormattingOptions(),f=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?(0,g.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",f,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,g.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",f,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a!==null?(0,g.updateIgnoredSettings)(a,r.fileContent?r.fileContent.value.toString():"{}",f,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,a,o){const{fileContent:u}=a[0][0];let{content:f,localChange:p,remoteChange:A}=a[0][1];if(p===0&&A===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),f=f?f.trim():"{}",f=f||"{}",this.validateContent(f),p!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(f,u,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),A!==0){const O=await this.getFormattingOptions(),M=this.getSettingsSyncContent(r),q=await this.getIgnoredSettings(f);f=(0,g.updateIgnoredSettings)(f,M?M.settings:"{}",q,O),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(f)),o?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(O){}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=await this.getFormattingOptions(),a=(0,S.edit)(r.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,g.isEmpty)(a)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const a=this.parseSyncData(t);if(a){const o=this.parseSettingsSyncContent(a.content);if(o)switch(this.extUri.basename(r)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(r){let t=await super.resolvePreviewContent(r);if(t){const a=await this.getFormattingOptions(),o=await this.getIgnoredSettings();t=(0,g.updateIgnoredSettings)(t,"{}",o,a)}return t}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return d(r)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const a=T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:u})=>!!u)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{a.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,g.getIgnoredSettings)(t,this.configurationService,r)}async writeFileContent(r,t,a){await this.userConfigurationFileService.write(D.VSBuffer.fromString(r),a?void 0:{etag:t.etag,mtime:t.mtime})}validateContent(r){if(this.hasErrors(r))throw new v.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const r=await this.getLocalFileContent();if(!r)return;const t=JSON.parse(r.value.toString());if(!n(t))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const a=this.parseSettingsSyncContent(t.content);if(!a||!a.settings)return;let o=a.settings;const u=await this.getFormattingOptions();for(const f in t)if(["version","content","machineId"].indexOf(f)===-1&&t[f]!==void 0){const p=(0,P.setProperty)(o,[f],t[f],u);p.length&&(o=(0,P.applyEdits)(o,p))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(o))}catch(r){}}};c=he([X(0,I.IFileService),X(1,b.IEnvironmentService),X(2,m.IStorageService),X(3,v.IUserDataSyncStoreService),X(4,v.IUserDataSyncBackupStoreService),X(5,v.IUserDataSyncLogService),X(6,v.IUserDataSyncUtilService),X(7,k.IConfigurationService),X(8,v.IUserDataSyncResourceEnablementService),X(9,E.ITelemetryService),X(10,i.IExtensionManagementService),X(11,w.IUserConfigurationFileService)],c),e.SettingsSynchroniser=c;let l=class extends h.AbstractInitializer{constructor(r,t,a){super("settings",t,a,r)}async doInitialize(r){const t=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,g.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return d(r)}catch(t){this.logService.error(t)}return null}};l=he([X(0,I.IFileService),X(1,b.IEnvironmentService),X(2,v.IUserDataSyncLogService)],l),e.SettingsInitializer=l;function n(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&s.machineId!==void 0&&typeof s.machineId=="string")}}),define(te[225],ne([0,1,19,3,26,21,13,14,23,22,48,218,24]),function(J,e,D,T,P,R,k,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let E=class extends i.AbstractSynchroniser{constructor(g,v,y,d,c,l,n,s,r){super("snippets",v,g,y,d,c,s,r,l,n);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(T.Event.filter(this.fileService.onDidFilesChange,t=>t.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,v,y){const d=await this.getSnippetsFileContents(),c=this.toSnippetsContents(d),l=g.syncData?this.parseSnippets(g.syncData):null;v=v===null&&y?g:v;const n=v&&v.syncData?this.parseSnippets(v.syncData):null;l?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,I.merge)(c,l,n);return this.getResourcePreviews(s,d,l||{})}async getMergeResult(g,v){return g.previewResult}async getAcceptResult(g,v,y,d){if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder))return y===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:y,localChange:y===null?g.fileContent!==null?3:0:2,remoteChange:y===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async applyResult(g,v,y,d){const c=y.map(([l,n])=>({...l,acceptResult:n}));c.every(({localChange:l,remoteChange:n})=>l===0&&n===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),c.some(({localChange:l})=>l!==0)&&(await this.updateLocalBackup(c),await this.updateLocalSnippets(c,d)),c.some(({remoteChange:l})=>l!==0)&&(g=await this.updateRemoteSnippets(c,g,d)),v?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:l}of c)try{await this.fileService.del(l)}catch(n){}}getResourcePreviews(g,v,y){const d=new Map;for(const c of Object.keys(g.local.added)){const l={content:g.local.added[c],hasConflicts:!1,localChange:1,remoteChange:0};d.set(c,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:l,localChange:l.localChange,remoteChange:l.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(g.local.updated)){const l={content:g.local.updated[c],hasConflicts:!1,localChange:2,remoteChange:0};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c],localContent:v[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:l,localChange:l.localChange,remoteChange:l.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of g.local.removed){const l={content:null,hasConflicts:!1,localChange:3,remoteChange:0};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c],localContent:v[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:l,localChange:l.localChange,remoteChange:l.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(g.remote.added)){const l={content:g.remote.added[c],hasConflicts:!1,localChange:0,remoteChange:1};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c],localContent:v[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:l,localChange:l.localChange,remoteChange:l.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(g.remote.updated)){const l={content:g.remote.updated[c],hasConflicts:!1,localChange:0,remoteChange:2};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c],localContent:v[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:l,localChange:l.localChange,remoteChange:l.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of g.remote.removed){const l={content:null,hasConflicts:!1,localChange:0,remoteChange:3};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:l,localChange:l.localChange,remoteChange:l.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of g.conflicts){const l={content:v[c]?v[c].value.toString():null,hasConflicts:!0,localChange:v[c]?2:1,remoteChange:y[c]?2:1};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c]||null,localContent:v[c]?v[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:l,localChange:l.localChange,remoteChange:l.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(v))if(!d.has(c)){const l={content:v[c]?v[c].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c]||null,localContent:v[c]?v[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:l,localChange:l.localChange,remoteChange:l.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...d.values()]}async getAssociatedResources({uri:g}){let v=await super.resolveContent(g);if(v){const y=this.parseSyncData(v);if(y){const d=this.parseSnippets(y),c=[];for(const l of Object.keys(d)){const n=this.extUri.joinPath(g,l),s=this.extUri.joinPath(this.snippetsFolder,l),r=await this.fileService.exists(s);c.push({resource:n,comparableResource:r?s:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})})}return c}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let v=await super.resolveContent(g);if(v)return v;if(v=await super.resolveContent(this.extUri.dirname(g)),v){const y=this.parseSyncData(v);if(y)return this.parseSnippets(y)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch(g){}return!1}async updateLocalBackup(g){const v={};for(const y of g)y.fileContent&&(v[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(v)))}async updateLocalSnippets(g,v){for(const{fileContent:y,acceptResult:d,localResource:c,remoteResource:l,localChange:n}of g)if(n!==0){const s=l?this.extUri.basename(l):this.extUri.basename(c),r=this.extUri.joinPath(this.snippetsFolder,s);n===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):n===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,D.VSBuffer.fromString(d.content),{overwrite:v}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,D.VSBuffer.fromString(d.content),v?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(g,v,y){const d=v.syncData?this.parseSnippets(v.syncData):{},c=(0,P.deepClone)(d);for(const{acceptResult:l,localResource:n,remoteResource:s,remoteChange:r}of g)if(r!==0){const t=n?this.extUri.basename(n):this.extUri.basename(s);r===3?delete c[t]:c[t]=l.content}return(0,I.areSame)(d,c)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),v=await this.updateRemoteUserData(JSON.stringify(c),y?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),v}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const v={};for(const y of Object.keys(g))v[y]=g[y].value.toString();return v}async getSnippetsFileContents(){const g={};let v;try{v=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof C.FileOperationError&&y.fileOperationResult===1)return g;throw y}for(const y of v.children||[]){const d=y.resource,c=this.extUri.extname(d);if(c===".json"||c===".code-snippets"){const l=this.extUri.relativePath(this.snippetsFolder,d),n=await this.fileService.readFile(d);g[l]=n}}return g}};E=he([X(0,k.IEnvironmentService),X(1,C.IFileService),X(2,w.IStorageService),X(3,m.IUserDataSyncStoreService),X(4,m.IUserDataSyncBackupStoreService),X(5,m.IUserDataSyncLogService),X(6,R.IConfigurationService),X(7,m.IUserDataSyncResourceEnablementService),X(8,b.ITelemetryService)],E),e.SnippetsSynchroniser=E;let h=class extends i.AbstractInitializer{constructor(g,v,y){super("snippets",v,y,g)}async doInitialize(g){const v=g.syncData?JSON.parse(g.syncData.content):null;if(!v){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const d of Object.keys(v)){const c=v[d];if(c){const l=this.extUri.joinPath(this.environmentService.snippetsHome,d);await this.fileService.createFile(l,D.VSBuffer.fromString(c)),this.logService.info("Created snippet",this.extUri.basename(l))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};h=he([X(0,C.IFileService),X(1,k.IEnvironmentService),X(2,m.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(te[63],ne([0,1,3,2,6,24]),function(J,e,D,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,P.createDecorator)("IUserDataSyncAccountService");let k=class extends T.Disposable{constructor(w){super();this.userDataSyncStoreService=w,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(w.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(w.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(w){(w&&this._account?w.token!==this._account.token||w.authenticationProviderId!==this._account.authenticationProviderId:w!==this._account)&&(this._account=w,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(w))}};k=he([X(0,R.IUserDataSyncStoreService)],k),e.UserDataSyncAccountService=k}),define(te[226],ne([0,1,5,19,57,2,16,21,13,14,24]),function(J,e,D,T,P,R,k,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends R.Disposable{constructor(E,h,S,g){super();this.environmentService=E,this.fileService=h,this.configurationService=S,this.logService=g,i.ALL_SYNC_RESOURCES.forEach(v=>this.cleanUpBackup(v))}async getAllRefs(E){const h=(0,k.joinPath)(this.environmentService.userDataSyncHome,E),S=await this.fileService.resolve(h);return S.children?S.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort().reverse().map(v=>({ref:v.name,created:this.getCreationTime(v)})):[]}async resolveContent(E,h){if(!h){const S=await this.getAllRefs(E);S.length&&(h=S[S.length-1].ref)}if(h){const S=(0,k.joinPath)(this.environmentService.userDataSyncHome,E,h);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(E,h){const S=(0,k.joinPath)(this.environmentService.userDataSyncHome,E),g=(0,k.joinPath)(S,`${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(g,T.VSBuffer.fromString(h))}catch(v){this.logService.error(v)}try{this.cleanUpBackup(E)}catch(v){}}async cleanUpBackup(E){const h=(0,k.joinPath)(this.environmentService.userDataSyncHome,E);try{try{if(!await this.fileService.exists(h))return}catch(g){return}const S=await this.fileService.resolve(h);if(S.children){const g=S.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),v=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=g.filter(c=>Date.now()-this.getCreationTime(c)>v);const d=g.length-y.length;d<10&&(y=y.slice(10-d)),await D.Promises.settled(y.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(E){return E.ctime||new Date(parseInt(E.name.substring(0,4)),parseInt(E.name.substring(4,6))-1,parseInt(E.name.substring(6,8)),parseInt(E.name.substring(9,11)),parseInt(E.name.substring(11,13)),parseInt(E.name.substring(13,15))).getTime()}};I=he([X(0,w.IEnvironmentService),X(1,b.IFileService),X(2,C.IConfigurationService),X(3,i.IUserDataSyncLogService)],I),e.UserDataSyncBackupStoreService=I}),define(te[227],ne([0,1,2,9]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class P{constructor(m){this.service=m}listen(m,E){switch(E){case"onError":return this.service.onError}throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=P;class R{constructor(m){this.service=m}listen(m,E){throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(T.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=R;class k{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=k;class C{constructor(m){this.service=m}listen(m,E){switch(E){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${E}`)}async call(m,E,h){switch(E){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=C;class w{constructor(m){this.service=m}listen(m,E){switch(E){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=w;class b{constructor(m){this.service=m}listen(m,E){switch(E){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class i extends D.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:T.URI.revive(m.url),type:m.type,defaultUrl:T.URI.revive(m.defaultUrl),insidersUrl:T.URI.revive(m.insidersUrl),stableUrl:T.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(te[228],ne([0,1,13,10]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let P=class extends T.AbstractLogger{constructor(k,C){super();this.logger=this._register(k.createLogger(C.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...C){this.logger.trace(k,...C)}debug(k,...C){this.logger.debug(k,...C)}info(k,...C){this.logger.info(k,...C)}warn(k,...C){this.logger.warn(k,...C)}error(k,...C){this.logger.error(k,...C)}critical(k,...C){this.logger.critical(k,...C)}flush(){this.logger.flush()}};P=he([X(0,T.ILoggerService),X(1,D.IEnvironmentService)],P),e.UserDataSyncLogService=P}),define(te[64],ne([0,1,3,2,4,25,149,13,14,6,28,46,23,24]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let S=class tt extends T.Disposable{constructor(v,y,d,c,l,n){super();this.storageService=d,this.userDataSyncStoreService=c,this.logService=l,this.productService=n,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(v,y,d)}async getMachines(v){const y=await this.currentMachineIdPromise;return(await this.readMachinesData(v)).machines.map(c=>({...c,isCurrent:c.id===y}))}async addCurrentMachine(v){const y=await this.currentMachineIdPromise,d=await this.readMachinesData(v);d.machines.some(({id:c})=>c===y)||(d.machines.push({id:y,name:this.computeCurrentMachineName(d.machines)}),await this.writeMachinesData(d))}async removeCurrentMachine(v){const y=await this.currentMachineIdPromise,d=await this.readMachinesData(v),c=d.machines.filter(({id:l})=>l!==y);c.length!==d.machines.length&&(d.machines=c,await this.writeMachinesData(d))}async renameMachine(v,y,d){const c=await this.currentMachineIdPromise,l=await this.readMachinesData(d),n=l.machines.find(({id:s})=>s===v);n&&(n.name=y,await this.writeMachinesData(l),l.machines.some(({id:s})=>s===c)&&this.storageService.store(h,y,0,1))}async setEnablement(v,y){const d=await this.readMachinesData(),c=d.machines.find(({id:l})=>l===v);c&&(c.disabled=y?void 0:!0,await this.writeMachinesData(d))}computeCurrentMachineName(v){const y=this.storageService.get(h,0);if(y)return y;const d=`${this.productService.nameLong} (${(0,P.PlatformToString)(P.isWeb?0:P.platform)})`,c=new RegExp(`${(0,R.escapeRegExpCharacters)(d)}\\s#(\\d+)`);let l=0;for(const n of v){const s=c.exec(n.name),r=s?parseInt(s[1]):0;l=r>l?r:l}return`${d} #${l+1}`}async readMachinesData(v){this.userData=await this.readUserData(v);const y=this.parse(this.userData);if(y.version!==tt.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return y}async writeMachinesData(v){const y=JSON.stringify(v),d=await this.userDataSyncStoreService.write(tt.RESOURCE,y,this.userData?.ref||null);this.userData={ref:d,content:y},this._onDidChange.fire()}async readUserData(v){if(this.userData){const y=v&&v.latest?v.latest[tt.RESOURCE]:void 0;if(this.userData.ref===y)return this.userData;if(y===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(tt.RESOURCE,this.userData)}parse(v){if(v.content!==null)try{return JSON.parse(v.content)}catch(y){this.logService.error(y)}return{version:tt.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=he([X(0,C.IEnvironmentService),X(1,w.IFileService),X(2,m.IStorageService),X(3,E.IUserDataSyncStoreService),X(4,E.IUserDataSyncLogService),X(5,i.IProductService)],S),e.UserDataSyncMachinesService=S}),define(te[99],ne([0,1,5,57,37,7,3,2,4,16,9,147,13,28,23,22,24,63,64]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const d="sync.enable",c="sync.disableMachineEventually",l="sync.sessionId",n="sync.storeUrl",s="sync.productQuality";let r=class extends C.Disposable{constructor(u,f,p){super();this.storageService=u,this.environmentService=f,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(d,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(d,u,0,1)}onDidStorageChange(u){if(u.scope===0&&d===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=he([X(0,h.IStorageService),X(1,m.IEnvironmentService),X(2,g.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let t=class extends C.Disposable{constructor(u,f,p,A,O,M,q,N,L,$,_){super();this.userDataSyncStoreManagementService=f,this.userDataSyncStoreService=p,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=O,this.logService=M,this.userDataSyncAccountService=q,this.telemetryService=N,this.userDataSyncMachinesService=L,this.storageService=$,this.autoSync=this._register(new C.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=_,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(f.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,f.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(q.onDidChangeAccount(()=>this.updateAutoSync())),this._register(p.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(O.onDidChangeLocal,(F,V)=>F?[...F,V]:[V],1e3)(F=>this.triggerSync(F,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(n,0);return u?i.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(n,u.toString(),0,1):this.storageService.remove(n,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:f}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(p=>this.onDidFinishSync(p))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(f&&this.logService.info(f),this.autoSync.clear()):f&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(f))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,T.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,f,p){try{this.userDataSyncAccountService.account&&!p&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(l,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(f)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(d,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const f=g.UserDataSyncError.toUserDataSyncError(u);f instanceof g.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:f.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),f.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):f.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):f.code==="LocalTooManyRequests"||f.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):f.code==="UpgradeRequired"||f.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):f.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with newer version than of client. Requires client upgrade.`)):f.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with older version than of client. Requires server reset.`)):f.code==="ServiceChanged"||f.code==="DefaultServiceChanged"?w.isWeb&&f.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(f),this.successiveFailures++),this._onError.fire(f)}async disableMachineEventually(){this.storageService.store(c,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(c,0,!1)}stopDisableMachineEventually(){this.storageService.remove(c,0)}async triggerSync(u,f,p){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(f&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",p)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};t=he([X(0,E.IProductService),X(1,g.IUserDataSyncStoreManagementService),X(2,g.IUserDataSyncStoreService),X(3,g.IUserDataSyncResourceEnablementService),X(4,g.IUserDataSyncService),X(5,g.IUserDataSyncLogService),X(6,v.IUserDataSyncAccountService),X(7,S.ITelemetryService),X(8,y.IUserDataSyncMachinesService),X(9,h.IStorageService),X(10,g.IUserDataAutoSyncEnablementService)],t),e.UserDataAutoSyncService=t;class a extends C.Disposable{constructor(u,f,p,A,O,M,q,N){super();this.lastSyncUrl=u,this.interval=f,this.userDataSyncStoreManagementService=p,this.userDataSyncStoreService=A,this.userDataSyncService=O,this.userDataSyncMachinesService=M,this.logService=q,this.storageService=N,this.intervalHandler=this._register(new C.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,C.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(u,f){const p=(0,D.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,R.isPromiseCanceledError)(O))return}return this.doSync(u,f,A)});return this.syncPromise=p,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),f=this.userDataSyncStoreManagementService.userDataSyncStore;return!!f&&!!u&&(!(0,b.isEqual)(f.defaultUrl,u.defaultUrl)||!(0,b.isEqual)(f.insidersUrl,u.insidersUrl)||!(0,b.isEqual)(f.stableUrl,u.stableUrl))}async doSync(u,f,p){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,f),p.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const O=this.storageService.get(l,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const M=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(p.isCancellationRequested)return;const q=M.find(N=>N.isCurrent);if(q?.disabled)throw new g.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(N){throw new g.UserDataAutoSyncError((0,P.toErrorMessage)(N),N instanceof g.UserDataSyncError?N.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(l,this.manifest.session,0,1),p.isCancellationRequested)return;q||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),A=O}this._onDidFinishSync.fire(A)}register(u){return super._register(u)}}a.INTERVAL_SYNCING="Interval"}),define(te[229],ne([0,1,3,2,4,23,22,24]),function(J,e,D,T,P,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let w=class extends T.Disposable{constructor(i,I){super();this.storageService=i,this.telemetryService=I,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(m=>this.onDidStorageChange(m)))}isResourceEnabled(i){return this.storageService.getBoolean((0,C.getEnablementKey)(i),0,!0)}setResourceEnablement(i,I){if(this.isResourceEnabled(i)!==I){const m=(0,C.getEnablementKey)(i);this.telemetryService.publicLog2(m,{enabled:I}),this.storeResourceEnablement(m,I)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,I){this.storageService.store(i,I,0,P.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const I=C.ALL_SYNC_RESOURCES.filter(m=>(0,C.getEnablementKey)(m)===i.key)[0];if(I){this._onDidChangeResourceEnablement.fire([I,this.isResourceEnabled(I)]);return}}}};w=he([X(0,R.IStorageService),X(1,k.ITelemetryService)],w),e.UserDataSyncResourceEnablementService=w}),define(te[230],ne([0,1,17,5,37,7,3,2,16,29,21,6,23,22,219,221,222,224,225,24]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let l=class extends C.Disposable{constructor(t,a,o,u,f,p,A){super();this.userDataSyncStoreService=t,this.userDataSyncStoreManagementService=a,this.instantiationService=o,this.configurationService=u,this.logService=f,this.telemetryService=p,this.storageService=A,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(v.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(g.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(y.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(S.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(O=>k.Event.map(O.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(O=>k.Event.map(O.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(c,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(O=>k.Event.map(O.onDidChangeLocal,()=>O.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(t,a){await this.checkEnablement();const o=(0,b.generateUuid)();try{const A=(0,d.createSyncHeaders)(o);a&&(A["Cache-Control"]="no-cache"),t=await this.userDataSyncStoreService.manifest(t,A)}catch(A){const O=d.UserDataSyncError.toUserDataSyncError(A);throw this.reportUserDataSyncError(O,o),O}let u=!1;const f=this;let p;return{manifest:t,run(){if(u)throw new Error("Can run a task only once");return p=(0,T.createCancelablePromise)(A=>f.sync(t,o,A)),p.finally(()=>p=void 0)},async stop(){if(p&&p.cancel(),f.status!=="idle")return f.stop()}}}async createManualSyncTask(){await this.checkEnablement();const t=(0,b.generateUuid)(),a=(0,d.createSyncHeaders)(t);let o;try{o=await this.userDataSyncStoreService.manifest(null,a)}catch(u){const f=d.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(f,t),f}return new n(t,o,a,this.synchronisers,this.configurationService,this.logService)}async sync(t,a,o){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),o.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const f=(0,d.createSyncHeaders)(a);for(const p of this.synchronisers){if(o.isCancellationRequested)return;try{await p.sync(t,f)}catch(A){let O=!1;if(A instanceof d.UserDataSyncError)switch(A.code){case"TooLarge":A=new d.UserDataSyncError(A.message,A.code,p.resource),O=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":O=!0;break}const M=d.UserDataSyncError.toUserDataSyncError(A);if(this.reportUserDataSyncError(M,a),O)throw M;this.logService.error(A),this.logService.error(`${p.resource}: ${(0,P.toErrorMessage)(A)}`),this._syncErrors.push([p.resource,M])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(f){const p=d.UserDataSyncError.toUserDataSyncError(f);throw this.reportUserDataSyncError(p,a),p}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const t of this.synchronisers)try{t.status!=="idle"&&await t.stop()}catch(a){this.logService.error(a)}}async replace(t){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(t))return}async accept(t,a,o,u){await this.checkEnablement();const f=this.getSynchroniser(t);await f.accept(a,o),u&&await f.apply(!1,(0,d.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(t){for(const a of this.synchronisers){const o=await a.resolveContent(t);if(o)return o}return null}getRemoteSyncResourceHandles(t){return this.getSynchroniser(t).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(t){return this.getSynchroniser(t).getLocalSyncResourceHandles()}getAssociatedResources(t,a){return this.getSynchroniser(t).getAssociatedResources(a)}getMachineId(t,a){return this.getSynchroniser(t).getMachineId(a)}async hasLocalData(){const t=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of t)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(t){this.logService.error(t)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(c,0);for(const t of this.synchronisers)try{await t.resetLocal()}catch(a){this.logService.error(`${t.resource}: ${(0,P.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const t of this.synchronisers)if(await t.hasPreviouslySynced())return!0;return!1}setStatus(t){const a=this._status;this._status!==t&&(this._status=t,this._onDidChangeStatus.fire(t),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const t=this.computeStatus();this.setStatus(t)}updateConflicts(){const t=this.computeConflicts();(0,D.equals)(this._conflicts,t,([a,o],[u,f])=>a===a&&(0,D.equals)(o,f,(p,A)=>(0,w.isEqual)(p.previewResource,A.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(t))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(t,a){this.telemetryService.publicLog2("sync/error",{code:t.code,serverCode:t instanceof d.UserDataSyncStoreError?String(t.serverCode):void 0,url:t instanceof d.UserDataSyncStoreError?t.url:void 0,resource:t.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(t=>t.status==="hasConflicts").map(t=>[t.resource,t.conflicts.map(s)])}getSynchroniser(t){return this.synchronisers.find(a=>a.resource===t)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};l=he([X(0,d.IUserDataSyncStoreService),X(1,d.IUserDataSyncStoreManagementService),X(2,I.IInstantiationService),X(3,i.IConfigurationService),X(4,d.IUserDataSyncLogService),X(5,E.ITelemetryService),X(6,m.IStorageService)],l),e.UserDataSyncService=l;class n extends C.Disposable{constructor(t,a,o,u,f,p){super();this.id=t,this.manifest=a,this.syncHeaders=o,this.synchronisers=u,this.configurationService=f,this.logService=p,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,T.createCancelablePromise)(t=>this.getPreviews(t))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(t){throw this.logService.error(t),t}}async accept(t,a){try{return await this.performAction(t,o=>o.accept(t,a))}catch(o){throw this.logService.error(o),o}}async merge(t){try{return t?await this.performAction(t,a=>a.merge(t)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(t){try{return await this.performAction(t,a=>a.discard(t))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const t=[];for(const[,a]of this.previews)for(const o of a.resourcePreviews)o.mergeState==="conflict"&&t.push(o.previewResource);for(const a of t)await this.discard(a);return this.previews}catch(t){throw this.logService.error(t),t}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const t=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(p=>p.resource===a);for(const p of o.resourcePreviews)(p.localChange!==0||p.remoteChange!==0)&&p.mergeState==="preview"&&await u.merge(p.previewResource);const f=await u.apply(!1,this.syncHeaders);f&&t.push(this.toSyncResourcePreview(u.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}catch(t){throw this.logService.error(t),t}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,a]of this.previews){this.synchronizingResources.push([t,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===t);for(const u of a.resourcePreviews)await o.accept(u.remoteResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,a]of this.previews){this.synchronizingResources.push([t,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===t);for(const u of a.resourcePreviews)await o.accept(u.localResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async stop(){for(const t of this.synchronisers)try{await t.stop()}catch(a){(0,R.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(t,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const o=this.previews.findIndex(([,N])=>N.resourcePreviews.some(({localResource:L,previewResource:$,remoteResource:_})=>(0,w.isEqual)(t,L)||(0,w.isEqual)(t,$)||(0,w.isEqual)(t,_)));if(o===-1)return this.previews;const[u,f]=this.previews[o],p=f.resourcePreviews.find(({localResource:N,remoteResource:L,previewResource:$})=>(0,w.isEqual)(N,t)||(0,w.isEqual)(L,t)||(0,w.isEqual)($,t));if(!p)return this.previews;let A=this.synchronizingResources.find(N=>N[0]===u);A||(A=[u,[]],this.synchronizingResources.push(A)),A[1].some(N=>(0,w.isEqual)(N,p.localResource))||(A[1].push(p.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const O=this.synchronisers.find(N=>N.resource===this.previews[o][0]),M=await a(O);M?this.previews.splice(o,1,this.toSyncResourcePreview(O.resource,M)):this.previews.splice(o,1);const q=this.synchronizingResources.findIndex(N=>N[0]===u);return this.synchronizingResources[q][1].splice(A[1].findIndex(N=>(0,w.isEqual)(N,p.localResource)),1),A[1].length||(this.synchronizingResources.splice(q,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const t=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(p=>p.resource===a);let f=o;for(const p of o.resourcePreviews)(p.localChange!==0||p.remoteChange!==0)&&p.mergeState==="preview"&&(f=await u.merge(p.previewResource));f&&t.push(this.toSyncResourcePreview(u.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}async getPreviews(t){const a=[],o=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(t.isCancellationRequested)return[];const f=await u.preview(this.manifest,o,this.syncHeaders);f&&a.push(this.toSyncResourcePreview(u.resource,f))}return a}async getUserDataSyncConfiguration(){const t=this.configurationService.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE),a=await this.synchronisers.find(o=>o instanceof v.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...t,...a}}toSyncResourcePreview(t,a){return[t,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(te[231],ne([0,1,3,2,18,9,24]),function(J,e,D,T,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class C{constructor(I,m){this.service=I,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(I,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(I,m,E){try{return await this._call(I,m,E)}catch(h){throw this.logService.error(h),h}}async _call(I,m,E){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(R.URI.revive(E[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(E[0],R.URI.revive(E[1]),E[2],E[3]);case"resolveContent":return this.service.resolveContent(R.URI.revive(E[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(E[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(E[0]);case"getAssociatedResources":return this.service.getAssociatedResources(E[0],{created:E[1].created,uri:R.URI.revive(E[1].uri)});case"getMachineId":return this.service.getMachineId(E[0],{created:E[1].created,uri:R.URI.revive(E[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const h=m.substring("manualSync/".length),S=E[0],g=this.getManualSyncTask(S);switch(E=E.slice(1),h){case"preview":return g.preview();case"accept":return g.accept(R.URI.revive(E[0]),E[1]);case"merge":return g.merge(R.URI.revive(E[0]));case"discard":return g.discard(R.URI.revive(E[0]));case"discardConflicts":return g.discardConflicts();case"apply":return g.apply();case"pull":return g.pull();case"push":return g.push();case"stop":return g.stop();case"_getStatus":return g.status;case"dispose":return this.disposeManualSyncTask(g)}}throw new Error("Invalid call")}getManualSyncTask(I){const m=this.manualSyncTasks.get(this.createKey(I));if(!m)throw new Error(`Manual sync taks not found: ${I}`);return m.manualSyncTask}async createManualSyncTask(){const I=new T.DisposableStore,m=I.add(await this.service.createManualSyncTask());return I.add(m.onSynchronizeResources(E=>this.onManualSynchronizeResources.fire({manualSyncTaskId:m.id,data:E}))),this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:I}),{id:m.id,manifest:m.manifest,status:m.status}}disposeManualSyncTask(I){I.dispose();const m=this.createKey(I.id);this.manualSyncTasks.get(m)?.disposables.dispose(),this.manualSyncTasks.delete(m)}createKey(I){return`manualSyncTask-${I}`}}e.UserDataSyncChannel=C;class w extends T.Disposable{constructor(I){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,E,h){return I.call(m,E,h).then(null,S=>{throw k.UserDataSyncError.toUserDataSyncError(S)})},listen(m,E){return I.listen(m,E)}},this.channel.call("_getInitialData").then(([m,E,h])=>{this.updateStatus(m),this.updateConflicts(E),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(([E,h])=>[E,k.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:I,manifest:m,status:E}=await this.channel.call("createManualSyncTask"),h=this,S=new b(I,m,E,{async call(g,v,y){return h.channel.call(`manualSync/${g}`,[I,...(0,P.isArray)(v)?v:[v]],y)},listen(g,v){return D.Event.map(D.Event.filter(h.channel.listen(`manualSync/${g}`,v),y=>!S.isDiposed()&&y.manualSyncTaskId===I),y=>y.data)}});return S}replace(I){return this.channel.call("replace",[I])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(I,m,E,h){return this.channel.call("accept",[I,m,E,h])}resolveContent(I){return this.channel.call("resolveContent",[I])}async getLocalSyncResourceHandles(I){return(await this.channel.call("getLocalSyncResourceHandles",[I])).map(({created:E,uri:h})=>({created:E,uri:R.URI.revive(h)}))}async getRemoteSyncResourceHandles(I){return(await this.channel.call("getRemoteSyncResourceHandles",[I])).map(({created:E,uri:h})=>({created:E,uri:R.URI.revive(h)}))}async getAssociatedResources(I,m){return(await this.channel.call("getAssociatedResources",[I,m])).map(({resource:h,comparableResource:S})=>({resource:R.URI.revive(h),comparableResource:R.URI.revive(S)}))}async getMachineId(I,m){return this.channel.call("getMachineId",[I,m])}async updateStatus(I){this._status=I,this._onDidChangeStatus.fire(I)}async updateConflicts(I){this._conflicts=I.map(([m,E])=>[m,E.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(I){this._lastSyncTime!==I&&(this._lastSyncTime=I,this._onDidChangeLastSyncTime.fire(I))}}e.UserDataSyncChannelClient=w;class b extends T.Disposable{constructor(I,m,E,h){super();this.id=I,this.manifest=m,this._disposed=!1,this._status=E;const S=this;this.channel={async call(g,v,y){try{const d=await h.call(g,v,y);return S.isDiposed()||(S._status=await h.call("_getStatus")),d}catch(d){throw k.UserDataSyncError.toUserDataSyncError(d)}},listen(g,v){return h.listen(g,v)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const I=await this.channel.call("preview");return this.deserializePreviews(I)}async accept(I,m){const E=await this.channel.call("accept",[I,m]);return this.deserializePreviews(E)}async merge(I){const m=await this.channel.call("merge",[I]);return this.deserializePreviews(m)}async discard(I){const m=await this.channel.call("discard",[I]);return this.deserializePreviews(m)}async discardConflicts(){const I=await this.channel.call("discardConflicts");return this.deserializePreviews(I)}async apply(){const I=await this.channel.call("apply");return this.deserializePreviews(I)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(I){return I.map(([m,E])=>[m,{isLastSyncFromCurrentMachine:E.isLastSyncFromCurrentMachine,resourcePreviews:E.resourcePreviews.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource),acceptedResource:R.URI.revive(h.acceptedResource)}))}])}}}),define(te[232],ne([0,1,5,27,7,3,2,108,4,16,18,9,29,21,13,14,28,43,46,23,24]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",n="sync.donot-make-requests-until",s="sync.user-session-id",r="sync.machine-session-id",t=100,a=1e3*60*5;let o=class extends k.Disposable{constructor(M,q,N){super();this.productService=M,this.configurationService=q,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new R.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(R.Event.filter(N.onDidChangeValue,L=>L.key===c.SYNC_SERVICE_URL_TYPE&&L.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(M){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,M,0,w.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(M,q){M=w.isWeb&&M?.web?{...M,...M.web}:M;const N={...M||{},...q||{}};if(N&&(0,i.isString)(N.url)&&(0,i.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(L=>(0,i.isArray)(N.authenticationProviders[L].scopes))){const L=N,$=!!L.canSwitch&&!q?.url,_=L.url===L.insidersUrl?"insiders":"stable",F=($?this.userDataSyncStoreType:void 0)||_,V=q?.url||(F==="insiders"?L.insidersUrl:F==="stable"?L.stableUrl:L.url);return{url:I.URI.parse(V),type:F,defaultType:_,defaultUrl:I.URI.parse(L.url),stableUrl:I.URI.parse(L.stableUrl),insidersUrl:I.URI.parse(L.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(L.authenticationProviders).reduce((W,x)=>(W.push({id:x,scopes:L.authenticationProviders[x].scopes}),W),[])}}}};o=he([X(0,g.IProductService),X(1,E.IConfigurationService),X(2,d.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(M,q,N){super(M,q,N);const L=this.storageService.get(l,0);L&&(this.previousConfigurationSyncStore=JSON.parse(L));const $=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(l,JSON.stringify($),0,1):this.storageService.remove(l,0)}async switch(M){M!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=M,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([X(0,g.IProductService),X(1,E.IConfigurationService),X(2,d.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let f=class extends k.Disposable{constructor(M,q,N,L,$,_,F){super();this.requestService=N,this.logService=L,this.storageService=F,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new R.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new R.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(M),this.commonHeadersPromise=(0,y.getServiceMachineId)($,_,F).then(V=>{const W={"X-Client-Name":`${q.applicationName}${w.isWeb?"-web":""}`,"X-Client-Version":q.version};return q.commit&&(W["X-Client-Commit"]=q.commit),W}),this.session=new A(t,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(M,q){this.authToken={token:M,type:q}}updateUserDataSyncStoreUrl(M){this.userDataSyncStoreUrl=M?(0,b.joinPath)(M,"v1"):void 0}initDonotMakeRequestsUntil(){const M=this.storageService.getNumber(n,0);M&&Date.now()<M&&this.setDonotMakeRequestsUntil(new Date(M))}setDonotMakeRequestsUntil(M){this._donotMakeRequestsUntil?.getTime()!==M?.getTime()&&(this._donotMakeRequestsUntil=M,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(q=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),q).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,q=>null)):this.storageService.remove(n,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M),N={},L=await this.request(q.toString(),{type:"GET",headers:N},[],T.CancellationToken.None);return(await(0,v.asJson)(L)||[]).map(({url:_,created:F})=>({ref:(0,b.relativePath)(q,q.with({path:_})),created:F*1e3}))}async resolveContent(M,q){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M,q).toString(),L={};L["Cache-Control"]="no-cache";const $=await this.request(N,{type:"GET",headers:L},[],T.CancellationToken.None);return await(0,v.asText)($)}async delete(M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M).toString(),N={};await this.request(q,{type:"DELETE",headers:N},[],T.CancellationToken.None)}async read(M,q,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M,"latest").toString();N={...N},N["Cache-Control"]="no-cache",q&&(N["If-None-Match"]=q.ref);const $=await this.request(L,{type:"GET",headers:N},[304],T.CancellationToken.None);let _=null;if($.res.statusCode===304&&(_=q),_===null){const F=$.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",L,"NoRef",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);const V=await(0,v.asText)($);if(!V&&$.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",L,"EmptyResponse",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);_={ref:F,content:V}}return _}async write(M,q,N,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M).toString();L={...L},L["Content-Type"]=C.Mimes.text,N&&(L["If-Match"]=N);const _=await this.request($,{type:"POST",data:q,headers:L},[],T.CancellationToken.None),F=_.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",_.res.statusCode,_.res.headers[c.HEADER_OPERATION_ID]);return F}async manifest(M,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();q={...q},q["Content-Type"]="application/json",M&&(q["If-None-Match"]=M.ref);const L=await this.request(N,{type:"GET",headers:q},[304],T.CancellationToken.None);let $=null;if(L.res.statusCode===304&&($=M),!$){const F=L.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",L.res.statusCode,L.res.headers[c.HEADER_OPERATION_ID]);const V=await(0,v.asText)(L);if(!V&&L.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",N,"EmptyResponse",L.res.statusCode,L.res.headers[c.HEADER_OPERATION_ID]);V&&($={...JSON.parse(V),ref:F})}const _=this.storageService.get(s,0);return _&&$&&_!==$.session&&this.clearSession(),$===null&&_&&this.clearSession(),$&&this.storageService.store(s,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),q={"Content-Type":C.Mimes.text};await this.request(M,{type:"DELETE",headers:q},[],T.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(r,0)}async request(M,q,N,L){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",M,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${q.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;q.headers={...q.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(q.headers),this.logService.trace("Sending request to server",{url:M,type:q.type,headers:{...q.headers,authorization:void 0}});let _;try{_=await this.session.request(M,q,L)}catch(x){if(!(x instanceof c.UserDataSyncStoreError)){let z="RequestFailed";const K=(0,P.getErrorMessage)(x).toLowerCase();K.includes("xhr timeout")?z="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?z="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":K.includes("headers must be an object")?z="RequestHeadersNotObject":(0,P.isPromiseCanceledError)(x)&&(z="RequestCanceled"),x=new c.UserDataSyncStoreError(`Connection refused for the request '${M}'.`,M,z,void 0,void 0)}throw this.logService.info("Request failed",M),x}const F=_.res.headers[c.HEADER_OPERATION_ID],V={url:M,status:_.res.statusCode,"execution-id":q.headers[c.HEADER_EXECUTION_ID],"operation-id":F},W=(0,v.isSuccess)(_)||_.res.statusCode&&N.indexOf(_.res.statusCode)!==-1;if(W?this.logService.trace("Request succeeded",V):this.logService.info("Request failed",V),_.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${M}' failed because of Unauthorized (401).`,M,"Unauthorized",_.res.statusCode,F);if(this._onTokenSucceed.fire(),_.res.statusCode===409)throw new c.UserDataSyncStoreError(`${q.type} request '${M}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,M,"Conflict",_.res.statusCode,F);if(_.res.statusCode===410)throw new c.UserDataSyncStoreError(`${q.type} request '${M}' failed because the requested resource is not longer available (410).`,M,"Gone",_.res.statusCode,F);if(_.res.statusCode===412)throw new c.UserDataSyncStoreError(`${q.type} request '${M}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,M,"PreconditionFailed",_.res.statusCode,F);if(_.res.statusCode===413)throw new c.UserDataSyncStoreError(`${q.type} request '${M}' failed because of too large payload (413).`,M,"TooLarge",_.res.statusCode,F);if(_.res.statusCode===426)throw new c.UserDataSyncStoreError(`${q.type} request '${M}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,M,"UpgradeRequired",_.res.statusCode,F);if(_.res.statusCode===429){const x=_.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new c.UserDataSyncStoreError(`${q.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",_.res.statusCode,F)):new c.UserDataSyncStoreError(`${q.type} request '${M}' failed because of too many requests (429).`,M,"RemoteTooManyRequests",_.res.statusCode,F)}if(!W)throw new c.UserDataSyncStoreError("Server returned "+_.res.statusCode,M,"Unknown",_.res.statusCode,F);return _}addSessionHeaders(M){let q=this.storageService.get(r,0);q===void 0&&(q=(0,m.generateUuid)(),this.storageService.store(r,q,0,1)),M["X-Machine-Session-Id"]=q;const N=this.storageService.get(s,0);N!==void 0&&(M["X-User-Session-Id"]=N)}};f=he([X(1,g.IProductService),X(2,v.IRequestService),X(3,c.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,S.IFileService),X(6,d.IStorageService)],f),e.UserDataSyncStoreClient=f;let p=class extends f{constructor(M,q,N,L,$,_,F){super(M.userDataSyncStore?.url,q,N,L,$,_,F);this._register(M.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(M.userDataSyncStore?.url)))}};p=he([X(0,c.IUserDataSyncStoreManagementService),X(1,g.IProductService),X(2,v.IRequestService),X(3,c.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,S.IFileService),X(6,d.IStorageService)],p),e.UserDataSyncStoreService=p;class A{constructor(M,q,N,L){this.limit=M,this.interval=q,this.requestService=N,this.logService=L,this.requests=[],this.startTime=void 0}request(M,q,N){if(this.isExpired()&&this.reset(),q.url=M,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,M,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(M),this.requestService.request(q,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(te[233],ne([0,1,3,59,28,23,22,99,24,63,64]),function(J,e,D,T,P,R,k,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends C.UserDataAutoSyncService{constructor(E,h,S,g,v,y,d,c,l,n,s,r){super(E,h,S,g,v,d,c,l,n,s,r);this._register(D.Event.debounce(D.Event.any(D.Event.map(y.onDidFocusWindow,()=>"windowFocus"),D.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(t,a)=>t?[...t,a]:[a],1e3)(t=>this.triggerSync(t,!0,!1)))}};I=he([X(0,P.IProductService),X(1,w.IUserDataSyncStoreManagementService),X(2,w.IUserDataSyncStoreService),X(3,w.IUserDataSyncResourceEnablementService),X(4,w.IUserDataSyncService),X(5,T.INativeHostService),X(6,w.IUserDataSyncLogService),X(7,b.IUserDataSyncAccountService),X(8,k.ITelemetryService),X(9,i.IUserDataSyncMachinesService),X(10,R.IStorageService),X(11,w.IUserDataAutoSyncEnablementService)],I),e.UserDataAutoSyncService=I}),define(te[234],ne([0,1,5,3,2]),function(J,e,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends P.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:w,getActiveWindowId:b}){super();this.disposables=this._register(new P.DisposableStore),T.Event.latch(T.Event.any(C,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>b()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(te[65],ne([0,1,52,5,8,18,20,125,246,247]),function(J,e,D,T,P,R,k,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(n,s){let r=s.message;switch(n){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=n,this.cause=s}}e.ExtractError=i;function I(l){const n=l.externalFileAttributes>>16||33188;return[448,56,7].map(s=>n&s).reduce((s,r)=>s+r,n&61440)}function m(l){if(l instanceof i)return l;let n;return/end of central directory record signature not found/.test(l.message)&&(n="CorruptZip"),new i(n,l)}function E(l,n,s,r,t,a){const o=P.dirname(n),u=P.join(r,o);if(!u.startsWith(r))return Promise.reject(new Error(C.localize(0,null,n)));const f=P.join(r,n);let p;return a.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(k.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,O)=>{if(!a.isCancellationRequested)try{p=(0,D.createWriteStream)(f,{mode:s}),p.once("close",()=>A()),p.once("error",O),l.once("error",O),l.pipe(p)}catch(M){O(M)}}))}function h(l,n,s,r){let t=(0,T.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((o,u)=>{const f=new T.Sequencer,p=A=>{A.isCancellationRequested||(a++,l.readEntry())};l.once("error",u),l.once("close",()=>t.then(()=>{r.isCancellationRequested||l.entryCount===a?o():u(new i("Incomplete",new Error(C.localize(1,null,a,l.entryCount))))},u)),l.readEntry(),l.on("entry",A=>{if(r.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){p(r);return}const O=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(O)){const N=P.join(n,O);t=(0,T.createCancelablePromise)(L=>k.Promises.mkdir(N,{recursive:!0}).then(()=>p(L)).then(void 0,u));return}const M=g(l,A),q=I(A);t=(0,T.createCancelablePromise)(N=>f.queue(()=>M.then(L=>E(L,O,q,n,s,N).then(()=>p(N)))).then(null,u))})})}function S(l,n=!1){return new Promise((s,r)=>{(0,w.open)(l,n?{lazyEntries:!0}:void 0,(t,a)=>{t?r(m(t)):s((0,R.assertIsDefined)(a))})})}function g(l,n){return new Promise((s,r)=>{l.openReadStream(n,(t,a)=>{t?r(m(t)):s((0,R.assertIsDefined)(a))})})}function v(l,n){return new Promise((s,r)=>{const t=new b.ZipFile;n.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const a=(0,D.createWriteStream)(l);t.outputStream.pipe(a),t.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>s(l))})}e.zip=v;function y(l,n,s={},r){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let a=S(l,!0);return s.overwrite&&(a=a.then(o=>k.Promises.rm(n).then(()=>o))),a.then(o=>h(o,n,{sourcePathRegex:t},r))}e.extract=y;function d(l,n){return S(l).then(s=>new Promise((r,t)=>{s.on("entry",a=>{a.fileName===n&&g(s,a).then(o=>r(o),o=>t(o))}),s.once("close",()=>t(new Error(C.localize(2,null,n))))}))}function c(l,n){return d(l,n).then(s=>new Promise((r,t)=>{const a=[];s.once("error",t),s.on("data",o=>a.push(o)),s.on("end",()=>r(Buffer.concat(a)))}))}e.buffer=c}),define(te[235],ne([0,1,65,134]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(R){return(0,D.buffer)(R,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(C){throw new Error((0,T.localize)(0,null))}})}e.getManifest=P}),define(te[236],ne([0,1,17,5,7,2,15,8,4,16,61,9,29,20,65,135,13,30,36,154,14,10,28]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d,c,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let s=class extends R.Disposable{constructor(t,a,o,u,f){super();this.beforeRemovingExtension=t,this.fileService=a,this.logService=o,this.environmentService=u,this.productService=f,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=C.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new T.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const a=[];(t===null||t===0)&&a.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(o).message,v.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&a.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(o).message,v.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(a);return(0,D.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[a,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(u=>!a[new y.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),t&&(o=(0,y.groupByExtension)(o,f=>f.identifier).map(f=>f.sort((p,A)=>i.rcompare(p.manifest.version,A.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,a,o,u){const f=t.key(),p=C.join(this.extensionsPath,`.${(0,m.generateUuid)()}`),A=C.join(this.extensionsPath,f);try{await E.Promises.rm(A)}catch(M){try{await E.Promises.rm(A)}catch(q){}throw new v.ExtensionManagementError((0,S.localize)(0,null,A,t.id),v.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,a,p,u);let O=await this.scanExtension(I.URI.file(p),1);if(!O)throw new Error((0,S.localize)(1,null,p));await this.storeMetadata(O,{...o,installedTimestamp:Date.now()});try{await this.rename(t,p,A,Date.now()+2*60*1e3),this.logService.info("Renamed to",A)}catch(M){try{await E.Promises.rm(p)}catch(q){}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(M)}. Deleted from extracted location`,p),M}try{O=await this.scanExtension(I.URI.file(A),1)}catch(M){}if(O)return O;throw new Error((0,S.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,a){return this.setMetadata(t,a),await this.storeMetadata(t,{...a,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const o=C.join(t.location.fsPath,"package.json"),u=await E.Promises.readFile(o,"utf8"),{manifest:f}=await this.parseManifest(u);return f.__metadata=a,await E.Promises.writeFile(o,JSON.stringify(f,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const a=t.map(o=>new y.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{a.forEach(u=>o[u.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(u=>delete u[t.key()]);const o=(await this.scanExtensions(1)).find(u=>new y.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let o={};if(a)try{o=JSON.parse(a)}catch(u){}return t&&(t(o),Object.keys(o).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await E.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,a){this.logService.trace(`Deleting ${a} extension from disk`,t.identifier.id,t.location.fsPath),await E.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new y.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,a,o,u){this.logService.trace(`Started extracting the extension from ${a} to ${o}`);try{await E.Promises.rm(o)}catch(f){throw new v.ExtensionManagementError(this.joinErrors(f).message,v.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(a,o,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(f){try{await E.Promises.rm(o)}catch(A){}let p=v.ExtensionManagementErrorCode.Extract;throw f instanceof h.ExtractError&&(f.type==="CorruptZip"?p=v.ExtensionManagementErrorCode.CorruptZip:f.type==="Incomplete"&&(p=v.ExtensionManagementErrorCode.IncompleteZip)),new v.ExtensionManagementError(f.message,p)}}async rename(t,a,o,u){try{await E.Promises.rename(a,o)}catch(f){if(w.isWindows&&f&&f.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${a} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,a,o,u);throw new v.ExtensionManagementError(f.message||(0,S.localize)(3,null,a,o),f.code||v.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const a=this.scanDevSystemExtensions(),[o,u]=await Promise.all([t,a]);return[...o,...u]}async scanExtensionsInDir(t,a){const o=new T.Limiter(10),u=await this.fileService.resolve(I.URI.file(t));return u.children?(await Promise.all(u.children.filter(p=>p.isDirectory).map(p=>o.queue(async()=>a===1&&(0,b.basename)(p.resource).indexOf(".")===0?null:this.scanExtension(p.resource,a))))).filter(p=>p&&p.identifier):[]}async scanExtension(t,a){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:u,metadata:f}=await this.readManifest(t.fsPath),p=o.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,A=o.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource,O={id:(0,y.getGalleryExtensionId)(u.publisher,u.name)},M={type:a,identifier:O,manifest:u,location:t,readmeUrl:p,changelogUrl:A,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return f&&(this.setMetadata(M,f),M.installedTimestamp=f.installedTimestamp),M}}catch(o){a!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(o=>t.some(u=>(0,y.areSameExtensions)(o.identifier,{id:u})))}else return[]}setMetadata(t,a){t.publisherDisplayName=a.publisherDisplayName||null,t.publisherId=a.publisherId||null,t.identifier.uuid=a.id,t.isMachineScoped=!!a.isMachineScoped,t.isBuiltin=t.type===0||!!a.isBuiltin}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),o=new Set;for(const p of a)t[new y.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]||o.add(p.identifier.id.toLowerCase());const u=(0,y.groupByExtension)(a,p=>p.identifier);await T.Promises.settled(u.map(async p=>{const A=p.sort((O,M)=>i.rcompare(O.manifest.version,M.manifest.version))[0];o.has(A.identifier.id.toLowerCase())||await this.beforeRemovingExtension(A)}));const f=a.filter(p=>t[new y.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]);await T.Promises.settled(f.map(p=>this.removeUninstalledExtension(p)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),a=[],o=(0,y.groupByExtension)(t,u=>u.identifier);a.push(...(0,D.flatten)(o.map(u=>u.sort((f,p)=>i.rcompare(f.manifest.version,p.manifest.version)).slice(1)))),await T.Promises.settled(a.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const a=Array.isArray(t)?t:[t];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((o,u)=>new Error(`${o.message}${o.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=C.normalize(C.join(k.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const a=[E.Promises.readFile(C.join(t,"package.json"),"utf8").then(p=>this.parseManifest(p)),E.Promises.readFile(C.join(t,"package.nls.json"),"utf8").then(void 0,p=>p.code!=="ENOENT"?Promise.reject(p):"{}").then(p=>JSON.parse(p))],[{manifest:o,metadata:u},f]=await Promise.all(a);return{manifest:(0,d.localizeManifest)(o,f),metadata:u}}parseManifest(t){return new Promise((a,o)=>{try{const u=JSON.parse(t),f=u.__metadata||null;a({manifest:u,metadata:f})}catch(u){o(new Error((0,S.localize)(4,null)))}})}};s=he([X(1,c.IFileService),X(2,l.ILogService),X(3,g.INativeEnvironmentService),X(4,n.IProductService)],s),e.ExtensionsScanner=s}),define(te[237],ne([0,1,37,7,15,8,4,31,16,61,9,29,20,65,133,79,13,203,30,36,186,174,235,187,236,188,76,14,6,10,28,22]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d,c,l,n,s,r,t,a,o,u,f,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends v.AbstractExtensionManagementService{constructor(_,F,V,W,x,z,K,U){super(_,F,V,U);this.environmentService=W,this.downloadService=x,this.fileService=K;const B=this._register(z.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(z.createInstance(r.ExtensionsScanner,Q=>B.postUninstall(Q))),this.manifestCache=this._register(new s.ExtensionsManifestCache(W,this)),this.extensionsDownloader=this._register(z.createInstance(c.ExtensionsDownloader));const j=this._register(new t.ExtensionsWatcher(this,K,W,V));this._register(j.onDidChangeExtensionsByAnotherSource(({added:Q,removed:Z})=>{Q.length&&this._onDidInstallExtensions.fire(Q.map(G=>({identifier:G.identifier,operation:0,local:G}))),Z.forEach(G=>this._onDidUninstallExtension.fire({identifier:G}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const _=await this.isAlpineLinux(),F=(0,y.getTargetPlatform)(_?"alpine":k.platform,C.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",F),F})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let _;try{_=(await this.fileService.readFile(i.URI.file("/etc/os-release"))).value.toString()}catch(F){try{_=(await this.fileService.readFile(i.URI.file("/usr/lib/os-release"))).value.toString()}catch(V){this.logService.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(V))}}return!!_&&(_.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(_){this.logService.trace("ExtensionManagementService#zip",_.identifier.id);const F=await this.collectFiles(_),V=await(0,E.zip)((0,w.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,F);return i.URI.file(V)}async unzip(_){return this.logService.trace("ExtensionManagementService#unzip",_.toString()),(await this.install(_)).identifier}async getManifest(_){const F=await this.downloadVsix(_),V=R.resolve(F.fsPath);return(0,n.getManifest)(V)}getInstalled(_=null){return this.extensionsScanner.scanExtensions(_)}async install(_,F={}){this.logService.trace("ExtensionManagementService#install",_.toString());const V=await this.downloadVsix(_),W=await(0,n.getManifest)(R.resolve(V.fsPath));if(W.engines&&W.engines.vscode&&!(0,a.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,d.getGalleryExtensionId)(W.publisher,W.name),this.productService.version));return this.installExtension(W,V,F)}async updateMetadata(_,F){return this.logService.trace("ExtensionManagementService#updateMetadata",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,{..._.manifest.__metadata||{},...F}),this.manifestCache.invalidate(),_}async updateExtensionScope(_,F){return this.logService.trace("ExtensionManagementService#updateExtensionScope",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,{..._.manifest.__metadata||{},isMachineScoped:F}),this.manifestCache.invalidate(),_}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(_){if(_.scheme===P.Schemas.file)return _;const F=(0,w.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(_,F),F}createInstallExtensionTask(_,F,V){return i.URI.isUri(F)?new N(_,F,V,this.galleryService,this.extensionsScanner,this.logService):new q(F,V,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(_,F){return new L(_,F,this.extensionsScanner)}async collectFiles(_){const F=async W=>{let x=await m.Promises.readdir(W);x=x.map(U=>R.join(W,U));const z=await Promise.all(x.map(U=>m.Promises.stat(U)));let K=Promise.resolve([]);return z.forEach((U,B)=>{const j=x[B];U.isFile()&&(K=K.then(Q=>[...Q,j])),U.isDirectory()&&(K=K.then(Q=>F(j).then(Z=>[...Q,...Z])))}),K};return(await F(_.location.fsPath)).map(W=>({path:`extension/${R.relative(_.location.fsPath,W)}`,localPath:W}))}};O=he([X(0,y.IExtensionGalleryService),X(1,A.ITelemetryService),X(2,f.ILogService),X(3,g.INativeEnvironmentService),X(4,S.IDownloadService),X(5,u.IInstantiationService),X(6,o.IFileService),X(7,p.IProductService)],O),e.ExtensionManagementService=O;class M extends v.AbstractExtensionTask{constructor(_,F,V,W){super();this.identifier=_,this.source=F,this.extensionsScanner=V,this.logService=W,this._operation=1}get operation(){return this._operation}async installExtension(_,F){try{const V=await this.unsetUninstalledAndGetLocal(_.identifierWithVersion);if(V)return _.metadata?this.extensionsScanner.saveMetadataForLocalExtension(V,_.metadata):V}catch(V){throw k.isMacintosh?new y.ExtensionManagementError(h.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(h.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(_,F)}async unsetUninstalledAndGetLocal(_){if(!await this.isUninstalled(_))return null;this.logService.trace("Removing the extension from uninstalled list:",_.id);const V=await this.extensionsScanner.setInstalled(_);return this.logService.info("Removed the extension from uninstalled list:",_.id),V}async isUninstalled(_){return!!(await this.extensionsScanner.getUninstalledExtensions())[_.key()]}async extract({zipPath:_,identifierWithVersion:F,metadata:V},W){let x=await this.extensionsScanner.extractUserExtension(F,_,V,W);return this.logService.info("Extracting completed.",F.id),x}}class q extends M{constructor(_,F,V,W,x){super(_.identifier,_,W,x);this.gallery=_,this.options=F,this.extensionsDownloader=V}async doRun(_){const V=(await this.extensionsScanner.scanExtensions(null)).find(x=>(0,d.areSameExtensions)(x.identifier,this.gallery.identifier));V&&(this._operation=2);const W=await this.downloadInstallableExtension(this.gallery,this._operation);W.metadata.isMachineScoped=this.options.isMachineScoped||V?.isMachineScoped,W.metadata.isBuiltin=this.options.isBuiltin||V?.isBuiltin;try{const x=await this.installExtension(W,_);return V&&b.neq(V.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(V),x}catch(x){throw await this.deleteDownloadedVSIX(W.zipPath),x}}async deleteDownloadedVSIX(_){try{await this.extensionsDownloader.delete(i.URI.file(_))}catch(F){this.logService.warn("Error while deleting the downloaded vsix",_.toString(),(0,T.getErrorMessage)(F))}}async downloadInstallableExtension(_,F){const V={id:_.identifier.uuid,publisherId:_.publisherId,publisherDisplayName:_.publisherDisplayName};let W;try{this.logService.trace("Started downloading extension:",_.identifier.id),W=(await this.extensionsDownloader.downloadExtension(_,F)).fsPath,this.logService.info("Downloaded extension:",_.identifier.id,W)}catch(x){throw new y.ExtensionManagementError((0,v.joinErrors)(x).message,y.ExtensionManagementErrorCode.Download)}try{const x=await(0,n.getManifest)(W);return{zipPath:W,identifierWithVersion:new d.ExtensionIdentifierWithVersion(_.identifier,x.version),metadata:V}}catch(x){throw await this.deleteDownloadedVSIX(W),new y.ExtensionManagementError((0,v.joinErrors)(x).message,y.ExtensionManagementErrorCode.Invalid)}}}class N extends M{constructor(_,F,V,W,x,z){super({id:(0,d.getGalleryExtensionId)(_.publisher,_.name)},F,x,z);this.manifest=_,this.location=F,this.options=V,this.galleryService=W}async doRun(_){const F=new d.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),W=(await this.extensionsScanner.scanExtensions(1)).find(z=>(0,d.areSameExtensions)(this.identifier,z.identifier)),x=await this.getMetadata(this.identifier.id,_);if(x.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||W?.isBuiltin,W)if(this._operation=2,F.equals(new d.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch(z){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(W.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(W);else{const z=await this.unsetUninstalledAndGetLocal(F);if(z)try{await this.extensionsScanner.removeExtension(z,"existing")}catch(K){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:F,metadata:x},_)}async getMetadata(_,F){try{const V=(await this.galleryService.query({names:[_],pageSize:1},F)).firstPage[0];if(V)return{id:V.identifier.uuid,publisherDisplayName:V.publisherDisplayName,publisherId:V.publisherId}}catch(V){}return{}}}class L extends v.AbstractExtensionTask{constructor(_,F,V){super();this.extension=_,this.options=F,this.extensionsScanner=V}async doRun(_){const F=[],V=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const W=new d.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);F.push(...V.filter(x=>W.equals(new d.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version))))}else F.push(...V.filter(W=>(0,d.areSameExtensions)(W.identifier,this.extension.identifier)));if(!F.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...F),this.options.remove)for(const W of F)try{_.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(W)}catch(x){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(x)))}}}}),define(te[238],ne([0,1,82,56,34,19,7,3,2,8,4,29,32,71,248]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(u){this.socket=u,this._errorListener=f=>{if(f){if(f.code==="EPIPE")return;(0,k.onUnexpectedError)(f)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const f=p=>u(R.VSBuffer.wrap(p));return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(u){const f=p=>{u({type:0,hadError:p,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,k.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,k.onUnexpectedError)(f)}}end(){this.socket.end()}drain(){return new Promise((u,f)=>{if(this.socket.bufferSize===0){u();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),u()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=S;var g;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var v;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(v||(v={}));class y extends w.Disposable{constructor(u,f,p,A){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=f,this._recordInflateBytes=A,f?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,k.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),p&&(this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,k.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):R.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let f=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.length-4),this._isEnded||this._write(R.VSBuffer.wrap(f),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,f){let p=2;u.byteLength<126?p+=0:u.byteLength<2**16?p+=2:p+=8;const A=R.VSBuffer.alloc(p);if(f?A.writeUInt8(194,0):A.writeUInt8(130,0),u.byteLength<126)A.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){A.writeUInt8(126,1);let O=1;A.writeUInt8(u.byteLength>>>8&255,++O),A.writeUInt8(u.byteLength>>>0&255,++O)}else{A.writeUInt8(127,1);let O=1;A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(u.byteLength>>>24&255,++O),A.writeUInt8(u.byteLength>>>16&255,++O),A.writeUInt8(u.byteLength>>>8&255,++O),A.writeUInt8(u.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=A.byteLength+u.byteLength,this.socket.write(R.VSBuffer.concat([A,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),p=f.readUInt8(0),A=(p&128)>>>7,O=(p&64)>>>6,M=f.readUInt8(1),q=(M&128)>>>7,N=M&127;this._state.state=2,this._state.readLen=2+(q?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),p=f.readUInt8(1),A=(p&128)>>>7;let O=p&127,M=1;O===126?O=f.readUInt8(++M)*2**8+f.readUInt8(++M):O===127&&(O=f.readUInt8(++M)*0+f.readUInt8(++M)*0+f.readUInt8(++M)*0+f.readUInt8(++M)*0+f.readUInt8(++M)*2**24+f.readUInt8(++M)*2**16+f.readUInt8(++M)*2**8+f.readUInt8(++M));let q=0;A&&(q=f.readUInt8(++M)*2**24+f.readUInt8(++M)*2**16+f.readUInt8(++M)*2**8+f.readUInt8(++M)),this._state.state=3,this._state.readLen=O,this._state.mask=q}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);d(f,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(f.buffer)),this._zlibInflate.write(f.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const p=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=p.length,this._onData.fire(R.VSBuffer.wrap(p))})):(this._totalIncomingDataBytes+=f.byteLength,this._onData.fire(f))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=y;function d(o,u){if(u===0)return;let f=o.byteLength>>>2;for(let N=0;N<f;N++){const L=o.readUInt32BE(N*4);o.writeUInt32BE(L^u,N*4)}let p=f*4,A=o.byteLength-p;const O=u>>>24&255,M=u>>>16&255,q=u>>>8&255;A>=1&&o.writeUInt8(o.readUInt8(p)^O,p),A>=2&&o.writeUInt8(o.readUInt8(p+1)^M,p+1),A>=3&&o.writeUInt8(o.readUInt8(p+2)^q,p+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function l(){const o=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):u=(0,b.join)((0,P.tmpdir)(),`vscode-ipc-${o}.sock`),s(u),u}e.createRandomIPCHandle=l;function n(o,u,f){const p=(0,D.createHash)("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${f}-${u}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${f}-${u}.sock`):A=(0,b.join)(o,`${f}-${u}.sock`),s(A),A}e.createStaticIPCHandle=n;function s(o){const u=c[i.platform];typeof u=="number"&&o.length>=u&&console.warn(`WARNING: IPC handle "${o}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends m.IPCServer{constructor(u){super(r.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const f=C.Event.fromNodeEventEmitter(u,"connection");return C.Event.map(f,p=>({protocol:new E.Protocol(new S(p)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(p,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function t(o){return new Promise((u,f)=>{const p=(0,T.createServer)();p.on("error",f),p.listen(o,()=>{p.removeListener("error",f),u(new r(p))})})}e.serve=t;function a(o,u){return new Promise((f,p)=>{const A=(0,T.createConnection)(o,()=>{A.removeListener("error",p),f(E.Client.fromSocket(new S(A),u))});A.once("error",p)})}e.connect=a}),define(te[239],ne([0,1,56,238]),function(J,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(P,R,k,C){const w=i=>C(i,void 0),b=D.createConnection({host:P,port:R},()=>{b.removeListener("error",w);const i=Buffer.alloc(16);for(let h=0;h<16;h++)i[h]=Math.round(Math.random()*256);const I=i.toString("base64");let m=[`GET ws://${/:/.test(P)?`[${P}]`:P}:${R}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];b.write(m.join(`\r
`)+`\r
\r
`);const E=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",E),C(void 0,new T.NodeSocket(b)))};b.on("data",E)});b.once("error",w)}}}),define(te[240],ne([0,1,56,115,239,5,2,21,10,28,184,62,91]),function(J,e,D,T,P,R,k,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function E(y,d,c,l,n){return new h(y,d,c,l,n).waitForReady()}class h extends k.Disposable{constructor(d,c,l,n,s){super();this.defaultTunnelHost=c,this.suggestedLocalPort=s,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=D.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let d=await(0,T.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(d=0,this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(d){d.pause();const c=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,i.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),n=l.getSocket().socket,s=l.readEntireBuffer();l.dispose(),s.byteLength>0&&d.write(s.buffer),d.on("end",()=>{this._socketsDispose.delete(d.localAddress),n.end()}),d.on("close",()=>n.end()),d.on("error",()=>{this._socketsDispose.delete(d.localAddress),n.destroy()}),n.on("end",()=>d.end()),n.on("close",()=>d.end()),n.on("error",()=>{d.destroy()}),d.pipe(n),n.pipe(d),this._socketsDispose.set(d.localAddress,()=>{d.end(),n.end()})}}let S=class extends I.AbstractTunnelService{constructor(d,c,l,n,s){super(c);this.socketFactory=d,this.signService=l,this.productService=n,this.configurationService=s}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(d,c,l,n,s,r,t){const a=this.getTunnelFromMap(c,l);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,l,n,s,r,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${l} on local port ${n}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},u=E(o,this.defaultTunnelHost,c,l,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,l,u),u}}};S=he([X(1,w.ILogService),X(2,m.ISignService),X(3,b.IProductService),X(4,C.IConfigurationService)],S),e.BaseTunnelService=S;let g=class extends S{constructor(d,c,l,n){super(P.nodeSocketFactory,d,c,l,n)}};g=he([X(0,w.ILogService),X(1,m.ISignService),X(2,b.IProductService),X(3,C.IConfigurationService)],g),e.TunnelService=g;let v=class extends k.Disposable{constructor(d,c,l,n){super();this.logService=d,this.productService=c,this.signService=l,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(d,c,l,n,s,r,t,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${n} on local port ${s}.`),!this._tunnelServices.has(d)){const o=new g(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(d,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(c,l,n,s,r,t,a)}};v=he([X(0,w.ILogService),X(1,b.IProductService),X(2,m.ISignService),X(3,C.IConfigurationService)],v),e.SharedTunnelsService=v}),define(te[249],ne([0,1,72,34,37,7,2,15,16,9,32,119,180,159,181,171,172,173,157,161,21,182,78,202,79,193,13,152,198,205,30,160,204,237,80,155,14,177,179,53,6,168,84,169,170,58,189,10,86,59,60,28,192,43,23,200,201,22,92,93,94,47,206,207,95,209,215,97,98,99,24,63,226,227,228,64,229,230,231,232,233,234,81,175,91,197,62,240,190,191,90,196,85]),function(J,e,D,T,P,R,k,C,w,b,i,I,m,E,h,S,g,v,y,d,c,l,n,s,r,t,a,o,u,f,p,A,O,M,q,N,L,$,_,F,V,W,x,z,K,U,B,j,Q,Z,G,H,re,ie,ce,le,de,fe,be,Ce,Ee,Ae,Pe,Le,Fe,Ne,$e,xe,ee,ae,oe,pe,Se,_e,Re,Y,se,ue,ge,me,Ie,ke,Te,ye,we,De,Oe,Ue,Qe,Ye,We,Et,dt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class bt extends k.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new I.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Me="vscode:electron-main->shared-process=disposeWorker",ze=(Ve,qe)=>this.onDisposeWorker(qe);D.ipcRenderer.on(Me,ze),this._register((0,k.toDisposable)(()=>D.ipcRenderer.removeListener(Me,ze)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,oe.registerConfiguration)(),ve.invokeFunction(Me=>{const ze=Me.get(j.ILogService);ze.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(ze)}),this._register((0,k.combinedDisposable)(ve.createInstance(m.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(h.LanguagePackCachedDataCleaner),ve.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(g.LogsDataCleaner),ve.createInstance(S.LocalizationsUpdater),ve.createInstance(E.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new x.ServiceCollection,Me={_serviceBrand:void 0,...G.default};ve.set(H.IProductService,Me);const ze=new i.StaticRouter(je=>je==="main"),Ve=new z.MessagePortMainProcessService(this.server,ze);ve.set(K.IMainProcessService,Ve);const qe=new o.NativeEnvironmentService(this.configuration.args,Me);ve.set(a.INativeEnvironmentService,qe);const rt=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",ze)),Ze=new Q.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ve.getChannel("logger"));ve.set(j.ILoggerService,Ze);const at=this._register(new j.MultiplexLogService([this._register(new j.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,w.joinPath)(b.URI.file(qe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),He=this._register(new Q.FollowerLogService(rt,at));ve.set(j.ILogService,He),this.sharedProcessWorkerService=new Et.SharedProcessWorkerService(He),ve.set(We.ISharedProcessWorkerService,this.sharedProcessWorkerService);const et=this._register(new $.FileService(He));ve.set(L.IFileService,et);const ot=this._register(new _.DiskFileSystemProvider(He));et.registerProvider(C.Schemas.file,ot);const Ge=this._register(new l.ConfigurationService(qe.settingsResource,et));ve.set(c.IConfigurationService,Ge);const nt=new le.NativeStorageService(void 0,Ve,qe);ve.set(ce.IStorageService,nt),this._register((0,k.toDisposable)(()=>nt.flush())),await Promise.all([Ge.initialize(),nt.initialize()]),ve.set(dt.IUserConfigurationFileService,i.ProxyChannel.toService(Ve.getChannel(dt.UserConfigurationFileServiceId))),ve.set(ie.IRequestService,new F.SyncDescriptor(re.RequestService)),ve.set(y.IChecksumService,new F.SyncDescriptor(d.ChecksumService));const st=i.ProxyChannel.toService(Ve.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(Z.INativeHostService,st),ve.set(r.IDownloadService,new F.SyncDescriptor(t.DownloadService));const ct=this._register(new ke.ActiveWindowManager(st)),lt=new i.StaticRouter(je=>ct.getActiveClientId().then(ut=>je===ut));ve.set(q.IExtensionRecommendationNotificationService,new N.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let Je;const Xe=[];if((0,Ae.supportsTelemetry)(Me,qe)){const je=new Ce.TelemetryLogAppender(Ze,qe);Xe.push(je);const{appRoot:ut,extensionsPath:Pt,installSourcePath:Dt}=qe;if(Me.aiConfig&&Me.aiConfig.asimovKey){const vt=new Pe.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey);this._register((0,k.toDisposable)(()=>vt.flush())),Xe.push(vt)}Je=new Ee.TelemetryService({appenders:Xe,commonProperties:(0,de.resolveCommonProperties)(et,(0,T.release)(),(0,T.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Dt),sendErrorTelemetry:!0,piiPaths:[ut,Pt]},Ge)}else{Je=Ae.NullTelemetryService;const je=Ae.NullAppender;Xe.push(je)}this.server.registerChannel("telemetryAppender",new be.TelemetryAppenderChannel(Xe)),ve.set(fe.ITelemetryService,Je);const Ct=new Le.CustomEndpointTelemetryService(Ge,Je,Ze,qe);ve.set(fe.ICustomEndpointTelemetryService,Ct),ve.set(p.IExtensionManagementService,new F.SyncDescriptor(M.ExtensionManagementService)),ve.set(p.IExtensionGalleryService,new F.SyncDescriptor(f.ExtensionGalleryService)),ve.set(p.IExtensionTipsService,new F.SyncDescriptor(O.ExtensionTipsService)),ve.set(U.ILocalizationsService,new F.SyncDescriptor(B.LocalizationsService)),ve.set(n.IDiagnosticsService,new F.SyncDescriptor(s.DiagnosticsService)),ve.set(pe.IUserDataSyncAccountService,new F.SyncDescriptor(pe.UserDataSyncAccountService)),ve.set(oe.IUserDataSyncLogService,new F.SyncDescriptor(Re.UserDataSyncLogService)),ve.set(oe.IUserDataSyncUtilService,new _e.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",je=>je.ctx!=="main"))),ve.set(p.IGlobalExtensionEnablementService,new F.SyncDescriptor(u.GlobalExtensionEnablementService)),ve.set(ee.IIgnoredExtensionsManagementService,new F.SyncDescriptor(ee.IgnoredExtensionsManagementService)),ve.set(xe.IExtensionsStorageSyncService,new F.SyncDescriptor(xe.ExtensionsStorageSyncService)),ve.set(oe.IUserDataSyncStoreManagementService,new F.SyncDescriptor(me.UserDataSyncStoreManagementService)),ve.set(oe.IUserDataSyncStoreService,new F.SyncDescriptor(me.UserDataSyncStoreService)),ve.set(Y.IUserDataSyncMachinesService,new F.SyncDescriptor(Y.UserDataSyncMachinesService)),ve.set(oe.IUserDataSyncBackupStoreService,new F.SyncDescriptor(Se.UserDataSyncBackupStoreService)),ve.set(oe.IUserDataAutoSyncEnablementService,new F.SyncDescriptor(ae.UserDataAutoSyncEnablementService)),ve.set(oe.IUserDataSyncResourceEnablementService,new F.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ve.set(oe.IUserDataSyncService,new F.SyncDescriptor(ue.UserDataSyncService));const mt=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ge.getValue("terminal.integrated.persistentSessionScrollback")??100},Ge,qe,He,Je);return await mt.initialize(),ve.set(Ne.ILocalPtyService,this._register(mt)),ve.set(Te.IExtensionHostStarter,this._register(new ye.ExtensionHostStarter(He))),ve.set(we.ISignService,new F.SyncDescriptor(De.SignService)),ve.set(Oe.ISharedTunnelsService,new F.SyncDescriptor(Ue.SharedTunnelsService)),ve.set(Qe.ISharedProcessTunnelService,new F.SyncDescriptor(Ye.SharedProcessTunnelService)),new W.InstantiationService(ve)}initChannels(ve){const Me=new A.ExtensionManagementChannel(ve.get(p.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const ze=i.ProxyChannel.fromService(ve.get(U.ILocalizationsService));this.server.registerChannel("localizations",ze);const Ve=i.ProxyChannel.fromService(ve.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",Ve);const qe=new A.ExtensionTipsChannel(ve.get(p.IExtensionTipsService));this.server.registerChannel("extensionTipsService",qe);const rt=i.ProxyChannel.fromService(ve.get(y.IChecksumService));this.server.registerChannel("checksum",rt);const Ze=new _e.UserDataSyncMachinesServiceChannel(ve.get(Y.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const at=i.ProxyChannel.fromService(ve.get(fe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const He=new _e.UserDataSyncAccountServiceChannel(ve.get(pe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",He);const et=new _e.UserDataSyncStoreManagementServiceChannel(ve.get(oe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",et);const ot=new ge.UserDataSyncChannel(ve.get(oe.IUserDataSyncService),ve.get(j.ILogService));this.server.registerChannel("userDataSync",ot);const Ge=this._register(ve.get(V.IInstantiationService).createInstance(Ie.UserDataAutoSyncService)),nt=new _e.UserDataAutoSyncChannel(Ge);this.server.registerChannel("userDataAutoSync",nt);const st=ve.get(Ne.ILocalPtyService),ct=i.ProxyChannel.fromService(st);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,ct);const lt=i.ProxyChannel.fromService(ve.get(Te.IExtensionHostStarter));this.server.registerChannel(Te.ipcExtensionHostStarterChannelName,lt);const Je=i.ProxyChannel.fromService(ve.get(Qe.ISharedProcessTunnelService));this.server.registerChannel(Qe.ipcSharedProcessTunnelChannelName,Je);const Xe=i.ProxyChannel.fromService(ve.get(We.ISharedProcessWorkerService));this.server.registerChannel(We.ipcSharedProcessWorkerChannelName,Xe)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,R.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,R.setUnexpectedErrorHandler)(Me=>{const ze=(0,P.toErrorMessage)(Me,!0);!ze||ve.error(`[uncaught exception in sharedProcess]: ${ze}`)})}}async function It(gt){const ve=new bt(gt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=It})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4bbec283c36a51cf80f9b77c7a81c140a76a363b/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
