/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","electron","vs/base/common/types","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/node/pfs","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","fs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/process","vs/base/common/extpath","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","child_process","vs/base/common/errorMessage","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","vs/code/electron-main/main"],x=function(j){for(var e=[],v=0,L=j.length;v<L;v++)e[v]=Z[j[v]];return e};define(Z[104],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(Z[47],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(P){return(b,h,d)=>{let i=null,S=null;if(typeof d.value=="function"?(i="value",S=d.value):typeof d.get=="function"&&(i="get",S=d.get),!S)throw new Error("not supported");d[i]=P(S,h)}}e.createDecorator=v;function L(P,b,h){let d=null,i=null;if(typeof h.value=="function"?(d="value",i=h.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(d="get",i=h.get),!i)throw new Error("not supported");const S=`$memoize$${b}`;h[d]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,m)}),this[S]}}e.memoize=L;function D(P,b,h){return v((d,i)=>{const S=`$debounce$${i}`,m=`$debounce$result$${i}`;return function(...p){this[m]||(this[m]=h?h():void 0),clearTimeout(this[S]),b&&(this[m]=b(this[m],...p),p=[this[m]]),this[S]=setTimeout(()=>{d.apply(this,p),this[m]=h?h():void 0},P)}})}e.debounce=D;function M(P,b,h){return v((d,i)=>{const S=`$throttle$timer$${i}`,m=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,t=`$throttle$pending$${i}`;return function(...g){if(this[m]||(this[m]=h?h():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...g)),this[t])return;const E=this[p]+P;E<=Date.now()?(this[p]=Date.now(),d.apply(this,[this[m]]),this[m]=h?h():void 0):(this[t]=!0,this[S]=setTimeout(()=>{this[t]=!1,this[p]=Date.now(),d.apply(this,[this[m]]),this[m]=h?h():void 0},E-Date.now()))}})}e.throttle=M}),define(Z[16],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(a=>{a(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=v,e.errorHandler=new v;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function D(u){h(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=D;function M(u){h(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=M;function P(u){if(u instanceof Error){let{name:n,message:a}=u;const s=u.stacktrace||u.stack;return{$isError:!0,name:n,message:a,stack:s}}return u}e.transformErrorForSerialization=P;const b="Canceled";function h(u){return u instanceof Error&&u.name===b&&u.message===b}e.isPromiseCanceledError=h;class d extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=d;function i(){const u=new Error(b);return u.name=u.message,u}e.canceled=i;function S(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=S;function m(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=m;function p(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function t(u){const n=new Error(`${u} has been disposed`);return n.name="DISPOSED",n}e.disposed=t;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=g;class E extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=E;class y extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=y;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function c(u){const n=u;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=c;function o(u,n=Object.create(null)){const a=new Error(u);return n.actions&&(a.actions=n.actions),a}e.createErrorWithActions=o}),define(Z[31],x([0,1,16]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,z=0){return W[W.length-(1+z)]}e.tail=L;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function M(W,z,K=(O,q)=>O===q){if(W===z)return!0;if(!W||!z||W.length!==z.length)return!1;for(let O=0,q=W.length;O<q;O++)if(!K(W[O],z[O]))return!1;return!0}e.equals=M;function P(W,z,K){let O=0,q=W.length-1;for(;O<=q;){const N=(O+q)/2|0,$=K(W[N],z);if($<0)O=N+1;else if($>0)q=N-1;else return N}return-(O+1)}e.binarySearch=P;function b(W,z){let K=0,O=W.length;if(O===0)return 0;for(;K<O;){const q=Math.floor((K+O)/2);z(W[q])?O=q:K=q+1}return K}e.findFirstInSorted=b;function h(W,z,K){if(W=W|0,W>=z.length)throw new TypeError("invalid index");let O=z[Math.floor(z.length*Math.random())],q=[],N=[],$=[];for(let J of z){const Q=K(J,O);Q<0?q.push(J):Q>0?N.push(J):$.push(J)}return W<q.length?h(W,q,K):W<q.length+$.length?$[0]:h(W-(q.length+$.length),N,K)}e.quickSelect=h;function d(W,z){const K=[];let O;for(const q of W.slice(0).sort(z))!O||z(O[0],q)!==0?(O=[q],K.push(O)):O.push(q);return K}e.groupBy=d;function i(W,z,K){const O=[];function q(J,Q,ne){if(Q===0&&ne.length===0)return;const ae=O[O.length-1];ae&&ae.start+ae.deleteCount===J?(ae.deleteCount+=Q,ae.toInsert.push(...ne)):O.push({start:J,deleteCount:Q,toInsert:ne})}let N=0,$=0;for(;;){if(N===W.length){q(N,0,z.slice($));break}if($===z.length){q(N,W.length-N,[]);break}const J=W[N],Q=z[$],ne=K(J,Q);ne===0?(N+=1,$+=1):ne<0?(q(N,1,[]),N+=1):ne>0&&(q(N,0,[Q]),$+=1)}return O}e.sortedDiff=i;function S(W,z,K){const O=i(W,z,K),q=[],N=[];for(const $ of O)q.push(...W.slice($.start,$.start+$.deleteCount)),N.push(...$.toInsert);return{removed:q,added:N}}e.delta=S;function m(W,z,K){if(K===0)return[];const O=W.slice(0,K).sort(z);return t(W,z,O,K,W.length),O}e.top=m;function p(W,z,K,O,q){return K===0?Promise.resolve([]):new Promise((N,$)=>{(async()=>{const J=W.length,Q=W.slice(0,K).sort(z);for(let ne=K,ae=Math.min(K+O,J);ne<J;ne=ae,ae=Math.min(ae+O,J)){if(ne>K&&await new Promise(ie=>setTimeout(ie)),q&&q.isCancellationRequested)throw(0,v.canceled)();t(W,z,Q,ne,ae)}return Q})().then(N,$)})}e.topAsync=p;function t(W,z,K,O,q){for(const N=K.length;O<q;O++){const $=W[O];if(z($,K[N-1])<0){K.pop();const J=b(K,Q=>z($,Q)<0);K.splice(J,0,$)}}}function g(W){return W.filter(z=>!!z)}e.coalesce=g;function E(W){let z=0;for(let K=0;K<W.length;K++)W[K]&&(W[z]=W[K],z+=1);W.length=z}e.coalesceInPlace=E;function y(W,z,K){W.splice(K,0,W.splice(z,1)[0])}e.move=y;function I(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=I;function c(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=c;function o(W,z=K=>K){const K=new Set;return W.filter(O=>{const q=z(O);return K.has(q)?!1:(K.add(q),!0)})}e.distinct=o;function u(W){const z=Object.create(null);return K=>{const O=W(K);return z[O]?!1:(z[O]=!0,!0)}}e.uniqueFilter=u;function n(W,z){const K=a(W,z);if(K!==-1)return W[K]}e.findLast=n;function a(W,z){for(let K=W.length-1;K>=0;K--){const O=W[K];if(z(O))return K}return-1}e.lastIndex=a;function s(W,z){return W.length>0?W[0]:z}e.firstOrDefault=s;function r(W,z,K=(O,q)=>O===q){let O=0;for(let q=0,N=Math.min(W.length,z.length);q<N&&K(W[q],z[q]);q++)O++;return O}e.commonPrefixLength=r;function l(W){return[].concat(...W)}e.flatten=l;function f(W,z){let K=typeof z=="number"?W:0;typeof z=="number"?K=W:(K=0,z=W);const O=[];if(K<=z)for(let q=K;q<z;q++)O.push(q);else for(let q=K;q>z;q--)O.push(q);return O}e.range=f;function w(W,z,K){return W.reduce((O,q)=>(O[z(q)]=K?K(q):q,O),Object.create(null))}e.index=w;function k(W,z){return W.push(z),()=>R(W,z)}e.insert=k;function R(W,z){const K=W.indexOf(z);if(K>-1)return W.splice(K,1),z}e.remove=R;function A(W,z,K){const O=W.slice(0,z),q=W.slice(z);return O.concat(K,q)}e.arrayInsert=A;function F(W,z){let K;if(typeof z=="number"){let O=z;K=()=>{const q=Math.sin(O++)*179426549;return q-Math.floor(q)}}else K=Math.random;for(let O=W.length-1;O>0;O-=1){const q=Math.floor(K()*(O+1)),N=W[O];W[O]=W[q],W[q]=N}}e.shuffle=F;function H(W,z){const K=W.indexOf(z);K>-1&&(W.splice(K,1),W.unshift(z))}e.pushToStart=H;function te(W,z){const K=W.indexOf(z);K>-1&&(W.splice(K,1),W.push(z))}e.pushToEnd=te;function se(W,z){return Array.isArray(W)?W.map(z):z(W)}e.mapArrayOrNot=se;function le(W){return Array.isArray(W)?W:[W]}e.asArray=le;function Y(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=Y;function T(W,z){for(const K of W){const O=z(K);if(O!==void 0)return O}}e.mapFind=T;function B(W,z,K){const O=_(W,z),q=W.length,N=K.length;W.length=q+N;for(let $=q-1;$>=O;$--)W[$+N]=W[$];for(let $=0;$<N;$++)W[$+O]=K[$]}e.insertInto=B;function V(W,z,K,O){const q=_(W,z),N=W.splice(q,K);return B(W,q,O),N}e.splice=V;function _(W,z){return z<0?Math.max(z+W.length,0):Math.min(z,W.length)}function U(W,z){let K=Number.MAX_SAFE_INTEGER,O=0;return W.forEach((q,N)=>{const $=z(q);$<K&&(K=$,O=N)}),O}e.minIndex=U;function C(W,z){let K=Number.MIN_SAFE_INTEGER,O=0;return W.forEach((q,N)=>{const $=z(q);$>K&&(K=$,O=N)}),O}e.maxIndex=C;class X{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let K=this.firstIdx;for(;K<this.items.length&&z(this.items[K]);)K++;const O=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,O}takeFromEndWhile(z){let K=this.lastIdx;for(;K>=0&&z(this.items[K]);)K--;const O=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,O}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=X}),define(Z[42],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(L){const D=this;let M=!1,P;return function(){return M||(M=!0,P=L.apply(D,arguments)),P}}e.once=v}),define(Z[69],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(L){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=D;const M=Object.freeze([]);function P(){return M}L.empty=P;function*b(u){yield u}L.single=b;function h(u){return u||M}L.from=h;function d(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=d;function i(u){return u[Symbol.iterator]().next().value}L.first=i;function S(u,n){for(const a of u)if(n(a))return!0;return!1}L.some=S;function m(u,n){for(const a of u)if(n(a))return a}L.find=m;function*p(u,n){for(const a of u)n(a)&&(yield a)}L.filter=p;function*t(u,n){let a=0;for(const s of u)yield n(s,a++)}L.map=t;function*g(...u){for(const n of u)for(const a of n)yield a}L.concat=g;function*E(u){for(const n of u)for(const a of n)yield a}L.concatNested=E;function y(u,n,a){let s=a;for(const r of u)s=n(s,r);return s}L.reduce=y;function*I(u,n,a=u.length){for(n<0&&(n+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);n<a;n++)yield u[n]}L.slice=I;function c(u,n=Number.POSITIVE_INFINITY){const a=[];if(n===0)return[a,u];const s=u[Symbol.iterator]();for(let r=0;r<n;r++){const l=s.next();if(l.done)return[a,L.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return s}}]}L.consume=c;function o(u,n,a=(s,r)=>s===r){const s=u[Symbol.iterator](),r=n[Symbol.iterator]();for(;;){const l=s.next(),f=r.next();if(l.done!==f.done)return!1;if(l.done)return!0;if(!a(l.value,f.value))return!1}}L.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(Z[39],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function P(n,a=!1){let s=0,r=n.length,l="",f=0,w=16,k=0;function R(Y){let T=0,B=0;for(;T<Y;){const V=n.charCodeAt(s);if(V>=48&&V<=57)B=B*16+V-48;else if(V>=65&&V<=70)B=B*16+V-65+10;else if(V>=97&&V<=102)B=B*16+V-97+10;else break;s++,T++}return T<Y&&(B=-1),B}function A(Y){s=Y,l="",f=0,w=16,k=0}function F(){const Y=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&d(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&d(n.charCodeAt(s)))for(s++;s<n.length&&d(n.charCodeAt(s));)s++;else return k=3,n.substring(Y,s);let T=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&d(n.charCodeAt(s))){for(s++;s<n.length&&d(n.charCodeAt(s));)s++;T=s}else k=3;return n.substring(Y,T)}function H(){let Y="",T=s;for(;;){if(s>=r){Y+=n.substring(T,s),k=2;break}const B=n.charCodeAt(s);if(B===34){Y+=n.substring(T,s),s++;break}if(B===92){if(Y+=n.substring(T,s),s++,s>=r){k=2;break}switch(n.charCodeAt(s++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const _=R(4);_>=0?Y+=String.fromCharCode(_):k=4;break;default:k=5}T=s;continue}if(B>=0&&B<=31)if(h(B)){Y+=n.substring(T,s),k=2;break}else k=6;s++}return Y}function te(){if(l="",k=0,f=s,s>=r)return f=r,w=17;let Y=n.charCodeAt(s);if(b(Y)){do s++,l+=String.fromCharCode(Y),Y=n.charCodeAt(s);while(b(Y));return w=15}if(h(Y))return s++,l+=String.fromCharCode(Y),Y===13&&n.charCodeAt(s)===10&&(s++,l+=`
`),w=14;switch(Y){case 123:return s++,w=1;case 125:return s++,w=2;case 91:return s++,w=3;case 93:return s++,w=4;case 58:return s++,w=6;case 44:return s++,w=5;case 34:return s++,l=H(),w=10;case 47:const T=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<r&&!h(n.charCodeAt(s));)s++;return l=n.substring(T,s),w=12}if(n.charCodeAt(s+1)===42){s+=2;const B=r-1;let V=!1;for(;s<B;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,V=!0;break}s++}return V||(s++,k=1),l=n.substring(T,s),w=13}return l+=String.fromCharCode(Y),s++,w=16;case 45:if(l+=String.fromCharCode(Y),s++,s===r||!d(n.charCodeAt(s)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=F(),w=11;default:for(;s<r&&se(Y);)s++,Y=n.charCodeAt(s);if(f!==s){switch(l=n.substring(f,s),l){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return l+=String.fromCharCode(Y),s++,w=16}}function se(Y){if(b(Y)||h(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let Y;do Y=te();while(Y>=12&&Y<=15);return Y}return{setPosition:A,getPosition:()=>s,scan:a?le:te,getToken:()=>w,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>k}}e.createScanner=P;function b(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function h(n){return n===10||n===13||n===8232||n===8233}function d(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function S(n,a){const s=[],r=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function k(R,A,F,H){f.value=R,f.offset=A,f.length=F,f.type=H,f.colonOffset=void 0,l=f}try{c(n,{onObjectBegin:(R,A)=>{if(a<=R)throw r;l=void 0,w=a>R,s.push("")},onObjectProperty:(R,A,F)=>{if(a<A||(k(R,A,F,"property"),s[s.length-1]=R,a<=A+F))throw r},onObjectEnd:(R,A)=>{if(a<=R)throw r;l=void 0,s.pop()},onArrayBegin:(R,A)=>{if(a<=R)throw r;l=void 0,s.push(0)},onArrayEnd:(R,A)=>{if(a<=R)throw r;l=void 0,s.pop()},onLiteralValue:(R,A,F)=>{if(a<A||(k(R,A,F,u(R)),a<=A+F))throw r},onSeparator:(R,A,F)=>{if(a<=A)throw r;if(R===":"&&l&&l.type==="property")l.colonOffset=A,w=!1,l=void 0;else if(R===","){const H=s[s.length-1];typeof H=="number"?s[s.length-1]=H+1:(w=!0,s[s.length-1]=""),l=void 0}}})}catch(R){if(R!==r)throw R}return{path:s,previousNode:l,isAtPropertyKey:w,matches:R=>{let A=0;for(let F=0;A<R.length&&F<s.length;F++)if(R[A]===s[F]||R[A]==="*")A++;else if(R[A]!=="**")return!1;return A===R.length}}}e.getLocation=S;function m(n,a=[],s=M.DEFAULT){let r=null,l=[];const f=[];function w(R){Array.isArray(l)?l.push(R):r!==null&&(l[r]=R)}return c(n,{onObjectBegin:()=>{const R={};w(R),f.push(l),l=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const R=[];w(R),f.push(l),l=R,r=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:w,onError:(R,A,F)=>{a.push({error:R,offset:A,length:F})}},s),l[0]}e.parse=m;function p(n,a=[],s=M.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function f(R){return r.children.push(R),R}c(n,{onObjectBegin:R=>{r=f({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,A,F)=>{r=f({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:A,length:F,parent:r})},onObjectEnd:(R,A)=>{r.length=R+A-r.offset,r=r.parent,l(R+A)},onArrayBegin:(R,A)=>{r=f({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,A)=>{r.length=R+A-r.offset,r=r.parent,l(R+A)},onLiteralValue:(R,A,F)=>{f({type:u(R),offset:A,length:F,parent:r,value:R}),l(A+F)},onSeparator:(R,A,F)=>{r.type==="property"&&(R===":"?r.colonOffset=A:R===","&&l(A))},onError:(R,A,F)=>{a.push({error:R,offset:A,length:F})}},s);const k=r.children[0];return k&&delete k.parent,k}e.parseTree=p;function t(n,a){if(!n)return;let s=n;for(let r of a)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===r){s=f.children[1],l=!0;break}if(!l)return}else{const l=r;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=t;function g(n){if(!n.parent||!n.parent.children)return[];const a=g(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;a.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&a.push(s)}return a}e.getNodePath=g;function E(n){switch(n.type){case"array":return n.children.map(E);case"object":const a=Object.create(null);for(let s of n.children){const r=s.children[1];r&&(a[s.children[0].value]=E(r))}return a;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=E;function y(n,a,s=!1){return a>=n.offset&&a<n.offset+n.length||s&&a===n.offset+n.length}e.contains=y;function I(n,a,s=!1){if(y(n,a,s)){const r=n.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=a;l++){const f=I(r[l],a,s);if(f)return f}return n}}e.findNodeAtOffset=I;function c(n,a,s=M.DEFAULT){const r=P(n,!1);function l(K){return K?()=>K(r.getTokenOffset(),r.getTokenLength()):()=>!0}function f(K){return K?O=>K(O,r.getTokenOffset(),r.getTokenLength()):()=>!0}const w=l(a.onObjectBegin),k=f(a.onObjectProperty),R=l(a.onObjectEnd),A=l(a.onArrayBegin),F=l(a.onArrayEnd),H=f(a.onLiteralValue),te=f(a.onSeparator),se=l(a.onComment),le=f(a.onError),Y=s&&s.disallowComments,T=s&&s.allowTrailingComma;function B(){for(;;){const K=r.scan();switch(r.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:Y||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(K){case 12:case 13:Y?V(10):se();break;case 16:V(1);break;case 15:case 14:break;default:return K}}}function V(K,O=[],q=[]){if(le(K),O.length+q.length>0){let N=r.getToken();for(;N!==17;){if(O.indexOf(N)!==-1){B();break}else if(q.indexOf(N)!==-1)break;N=B()}}}function _(K){const O=r.getTokenValue();return K?H(O):k(O),B(),!0}function U(){switch(r.getToken()){case 11:let K=0;try{K=JSON.parse(r.getTokenValue()),typeof K!="number"&&(V(2),K=0)}catch(O){V(2)}H(K);break;case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return B(),!0}function C(){return r.getToken()!==10?(V(3,[],[2,5]),!1):(_(!1),r.getToken()===6?(te(":"),B(),z()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function X(){w(),B();let K=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(K||V(4,[],[]),te(","),B(),r.getToken()===2&&T)break}else K&&V(6,[],[]);C()||V(4,[],[2,5]),K=!0}return R(),r.getToken()!==2?V(7,[2],[]):B(),!0}function W(){A(),B();let K=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(K||V(4,[],[]),te(","),B(),r.getToken()===4&&T)break}else K&&V(6,[],[]);z()||V(4,[],[4,5]),K=!0}return F(),r.getToken()!==4?V(8,[4],[]):B(),!0}function z(){switch(r.getToken()){case 3:return W();case 1:return X();case 10:return _(!0);default:return U()}}return B(),r.getToken()===17?s.allowEmptyContent?!0:(V(4,[],[]),!1):z()?(r.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=c;function o(n,a){let s=P(n),r=[],l,f=0,w;do switch(w=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:f!==w&&r.push(n.substring(f,w)),a!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,a)),f=s.getPosition();break}while(l!==17);return r.join("")}e.stripComments=o;function u(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Z[105],x([0,1,39]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(h,d,i){let S,m,p,t,g;if(d){for(t=d.offset,g=t+d.length,p=t;p>0&&!b(h,p-1);)p--;let f=g;for(;f<h.length&&!b(h,f);)f++;m=h.substring(p,f),S=M(m,i)}else m=h,S=0,p=0,t=0,g=h.length;const E=P(i,h);let y=!1,I=0,c;i.insertSpaces?c=D(" ",i.tabSize||4):c="	";const o=(0,v.createScanner)(m,!1);let u=!1;function n(){return E+D(c,S+I)}function a(){let f=o.scan();for(y=!1;f===15||f===14;)y=y||f===14,f=o.scan();return u=f===16||o.getTokenError()!==0,f}const s=[];function r(f,w,k){!u&&w<g&&k>t&&h.substring(w,k)!==f&&s.push({offset:w,length:k-w,content:f})}let l=a();if(l!==17){const f=o.getTokenOffset()+p,w=D(c,S);r(w,p,f)}for(;l!==17;){let f=o.getTokenOffset()+o.getTokenLength()+p,w=a(),k="";for(;!y&&(w===12||w===13);){const A=o.getTokenOffset()+p;r(" ",f,A),f=o.getTokenOffset()+o.getTokenLength()+p,k=w===12?n():"",w=a()}if(w===2)l!==1&&(I--,k=n());else if(w===4)l!==3&&(I--,k=n());else{switch(l){case 3:case 1:I++,k=n();break;case 5:case 12:k=n();break;case 13:y?k=n():k=" ";break;case 6:k=" ";break;case 10:if(w===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?k=" ":w!==5&&w!==17&&(u=!0);break;case 16:u=!0;break}y&&(w===12||w===13)&&(k=n())}const R=o.getTokenOffset()+p;r(k,f,R),l=w}return s}e.format=L;function D(h,d){let i="";for(let S=0;S<d;S++)i+=h;return i}function M(h,d){let i=0,S=0;const m=d.tabSize||4;for(;i<h.length;){const p=h.charAt(i);if(p===" ")S++;else if(p==="	")S+=m;else break;i++}return Math.floor(S/m)}function P(h,d){for(let i=0;i<d.length;i++){const S=d.charAt(i);if(S==="\r")return i+1<d.length&&d.charAt(i+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=P;function b(h,d){return`\r
`.indexOf(h.charAt(d))!==-1}e.isEOL=b}),define(Z[79],x([0,1,39,105]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(d,i,S){return M(d,i,void 0,S)}e.removeProperty=D;function M(d,i,S,m,p){const t=i.slice(),g=[],E=(0,v.parseTree)(d,g);let y,I;for(;t.length>0&&(I=t.pop(),y=(0,v.findNodeAtLocation)(E,t),y===void 0&&S!==void 0);)typeof I=="string"?S={[I]:S}:S=[S];if(y)if(y.type==="object"&&typeof I=="string"&&Array.isArray(y.children)){const c=(0,v.findNodeAtLocation)(y,[I]);if(c!==void 0)if(S===void 0){if(!c.parent)throw new Error("Malformed AST");const o=y.children.indexOf(c.parent);let u,n=c.parent.offset+c.parent.length;if(o>0){const a=y.children[o-1];u=a.offset+a.length}else u=y.offset+1,y.children.length>1&&(n=y.children[1].offset);return P(d,{offset:u,length:n-u,content:""},m)}else return P(d,{offset:c.offset,length:c.length,content:JSON.stringify(S)},m);else{if(S===void 0)return[];const o=`${JSON.stringify(I)}: ${JSON.stringify(S)}`,u=p?p(y.children.map(a=>a.children[0].value)):y.children.length;let n;if(u>0){const a=y.children[u-1];n={offset:a.offset+a.length,length:0,content:","+o}}else y.children.length===0?n={offset:y.offset+1,length:0,content:o}:n={offset:y.offset+1,length:0,content:o+","};return P(d,n,m)}}else if(y.type==="array"&&typeof I=="number"&&Array.isArray(y.children))if(S!==void 0){const c=`${JSON.stringify(S)}`;let o;if(y.children.length===0||I===0)o={offset:y.offset+1,length:0,content:y.children.length===0?c:c+","};else{const u=I===-1||I>y.children.length?y.children.length:I,n=y.children[u-1];o={offset:n.offset+n.length,length:0,content:","+c}}return P(d,o,m)}else{const c=I,o=y.children[c];let u;if(y.children.length===1)u={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===c){const n=y.children[c-1],a=n.offset+n.length,s=y.offset+y.length;u={offset:a,length:s-2-a,content:""}}else u={offset:o.offset,length:y.children[c+1].offset-o.offset,content:""};return P(d,u,m)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${y.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return P(d,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(S)},m)}}e.setProperty=M;function P(d,i,S){let m=b(d,i),p=i.offset,t=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,L.isEOL)(m,p-1);)p--;for(;t<m.length&&!(0,L.isEOL)(m,t);)t++}const g=(0,L.format)(m,{offset:p,length:t-p},S);for(let y=g.length-1;y>=0;y--){const I=g[y];m=b(m,I),p=Math.min(p,I.offset),t=Math.max(t,I.offset+I.length),t+=I.content.length-I.length}const E=d.length-(m.length-t)-p;return[{offset:p,length:E,content:m.substring(p,t)}]}e.withFormatting=P;function b(d,i){return d.substring(0,i.offset)+i.content+d.substring(i.offset+i.length)}e.applyEdit=b;function h(d,i){let S=i.slice(0).sort((p,t)=>{const g=p.offset-t.offset;return g===0?p.length-t.length:g}),m=d.length;for(let p=S.length-1;p>=0;p--){let t=S[p];if(t.offset+t.length<=m)d=b(d,t);else throw new Error("Overlapping edit");m=t.offset}return d}e.applyEdits=h}),define(Z[80],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var v;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(v=e.KeyCode||(e.KeyCode={}));var L;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(L=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(g,E){this._keyCodeToStr[g]=E,this._strToKeyCode[E.toLowerCase()]=g}keyCodeToStr(g){return this._keyCodeToStr[g]}strToKeyCode(g){return this._strToKeyCode[g.toLowerCase()]||0}}const M=new D,P=new D,b=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],d=Object.create(null),i=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>i[t]||0,toEnum:t=>d[t]||0,toString:t=>h[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",g=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let E=[],y=[];for(const I of g){const[c,o,u,n,a,s,r,l,f,w]=I;if(y[u]||(y[u]=!0,h[u]=n,d[n]=u,i[n.toLowerCase()]=u,o&&(e.IMMUTABLE_CODE_TO_KEY_CODE[u]=a,a!==0&&a!==3&&a!==5&&a!==4&&a!==6&&a!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[a]=u))),!E[a]){if(E[a]=!0,!s)throw new Error(`String representation missing for key code ${a} around scan code ${n}`);M.define(a,s),P.define(a,f||s),b.define(a,w||f||s)}r&&(e.EVENT_KEY_CODE_MAP[r]=a),l&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[l]=a)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var S;(function(t){function g(u){return M.keyCodeToStr(u)}t.toString=g;function E(u){return M.strToKeyCode(u)}t.fromString=E;function y(u){return P.keyCodeToStr(u)}t.toUserSettingsUS=y;function I(u){return b.keyCodeToStr(u)}t.toUserSettingsGeneral=I;function c(u){return P.strToKeyCode(u)||b.strToKeyCode(u)}t.fromUserSettings=c;function o(u){if(u>=93&&u<=108)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(u)}t.toElectronAccelerator=o})(S=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(m=e.KeyMod||(e.KeyMod={}));function p(t,g){const E=(g&65535)<<16>>>0;return(t|E)>>>0}e.KeyChord=p}),define(Z[59],x([0,1,16]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var L;(function(S){S[S.CtrlCmd=2048]="CtrlCmd",S[S.Shift=1024]="Shift",S[S.Alt=512]="Alt",S[S.WinCtrl=256]="WinCtrl",S[S.KeyCode=255]="KeyCode"})(L||(L={}));function D(S,m){if(S===0)return null;const p=(S&65535)>>>0,t=(S&4294901760)>>>16;return t!==0?new b([M(p,m),M(t,m)]):new b([M(p,m)])}e.createKeybinding=D;function M(S,m){const p=!!(S&2048),t=!!(S&256),g=m===2?t:p,E=!!(S&1024),y=!!(S&512),I=m===2?p:t,c=S&255;return new P(g,E,y,I,c)}e.createSimpleKeybinding=M;class P{constructor(m,p,t,g,E){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=g,this.keyCode=E}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.keyCode===m.keyCode}getHashCode(){const m=this.ctrlKey?"1":"0",p=this.shiftKey?"1":"0",t=this.altKey?"1":"0",g=this.metaKey?"1":"0";return`${m}${p}${t}${g}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=P;class b{constructor(m){if(m.length===0)throw(0,v.illegalArgument)("parts");this.parts=m}getHashCode(){let m="";for(let p=0,t=this.parts.length;p<t;p++)p!==0&&(m+=";"),m+=this.parts[p].getHashCode();return m}equals(m){if(m===null||this.parts.length!==m.parts.length)return!1;for(let p=0;p<this.parts.length;p++)if(!this.parts[p].equals(m.parts[p]))return!1;return!0}}e.ChordKeybinding=b;class h{constructor(m,p,t,g,E){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=g,this.scanCode=E}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.scanCode===m.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=h;class d{constructor(m,p,t,g,E,y){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=g,this.keyLabel=E,this.keyAriaLabel=y}}e.ResolvedKeybindingPart=d;class i{}e.ResolvedKeybinding=i}),define(Z[106],x([0,1,80,59]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(P){P=P.toLowerCase().trim();let b=!1,h=!1,d=!1,i=!1,S;do S=!1,/^ctrl(\+|\-)/.test(P)&&(b=!0,P=P.substr("ctrl-".length),S=!0),/^shift(\+|\-)/.test(P)&&(h=!0,P=P.substr("shift-".length),S=!0),/^alt(\+|\-)/.test(P)&&(d=!0,P=P.substr("alt-".length),S=!0),/^meta(\+|\-)/.test(P)&&(i=!0,P=P.substr("meta-".length),S=!0),/^win(\+|\-)/.test(P)&&(i=!0,P=P.substr("win-".length),S=!0),/^cmd(\+|\-)/.test(P)&&(i=!0,P=P.substr("cmd-".length),S=!0);while(S);let m;const p=P.indexOf(" ");return p>0?(m=P.substring(0,p),P=P.substring(p)):(m=P,P=""),{remains:P,ctrl:b,shift:h,alt:d,meta:i,key:m}}static parseSimpleKeybinding(P){const b=this._readModifiers(P),h=v.KeyCodeUtils.fromUserSettings(b.key);return[new L.SimpleKeybinding(b.ctrl,b.shift,b.alt,b.meta,h),b.remains]}static parseKeybinding(P,b){if(!P)return null;const h=[];let d;do[d,P]=this.parseSimpleKeybinding(P),h.push(d);while(P.length>0);return new L.ChordKeybinding(h)}static parseSimpleUserBinding(P){const b=this._readModifiers(P),h=b.key.match(/^\[([^\]]+)\]$/);if(h){const i=h[1],S=v.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(b.ctrl,b.shift,b.alt,b.meta,S),b.remains]}const d=v.KeyCodeUtils.fromUserSettings(b.key);return[new L.SimpleKeybinding(b.ctrl,b.shift,b.alt,b.meta,d),b.remains]}static parseUserBinding(P){if(!P)return[];const b=[];let h;for(;P.length>0;)[h,P]=this.parseSimpleUserBinding(P),b.push(h);return b}}e.KeybindingParser=D}),define(Z[2],x([0,1,42,69]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let M=null;function P(r){M=r}if(e.setDisposableTracker=P,D){const r="__is_disposable_tracked__";P(new class{trackDisposable(l){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[r]||console.log(f)},3e3)}setParent(l,f){if(l&&l!==I.None)try{l[r]=!0}catch{}}markAsDisposed(l){if(l&&l!==I.None)try{l[r]=!0}catch{}}markAsSingleton(l){}})}function b(r){return M?.trackDisposable(r),r}function h(r){M?.markAsDisposed(r)}function d(r,l){M?.setParent(r,l)}function i(r,l){if(!!M)for(const f of r)M.setParent(f,l)}function S(r){return M?.markAsSingleton(r),r}e.markAsSingleton=S;class m extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=m;function p(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=p;function t(r){if(L.Iterable.is(r)){let l=[];for(const f of r)if(f)try{f.dispose()}catch(w){l.push(w)}if(l.length===1)throw l[0];if(l.length>1)throw new m(l);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=t;function g(...r){const l=E(()=>t(r));return i(r,l),l}e.combinedDisposable=g;function E(r){const l=b({dispose:(0,v.once)(()=>{h(l),r()})});return l}e.toDisposable=E;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return d(l,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new y,b(this),d(this._store,this)}dispose(){h(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&d(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&d(l,null),l}}e.MutableDisposable=c;class o{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class u{constructor(){this.references=new Map}acquire(l,...f){let w=this.references.get(l);w||(w={counter:0,object:this.createReferencedObject(l,...f)},this.references.set(l,w));const{object:k}=w,R=(0,v.once)(()=>{--w.counter==0&&(this.destroyReferencedObject(l,w.object),this.references.delete(l))});return w.counter++,{object:k,dispose:R}}}e.ReferenceCollection=u;class n{constructor(l){this.referenceCollection=l}async acquire(l,...f){const w=this.referenceCollection.acquire(l,...f);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(k){throw w.dispose(),k}}}e.AsyncReferenceCollection=n;class a{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=a;function s(r){const l=new y;try{r(l)}finally{l.dispose()}}e.disposeOnReturn=s}),define(Z[107],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(M){this.element=M,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class L{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let M=this._first;for(;M!==v.Undefined;){const P=M.next;M.prev=v.Undefined,M.next=v.Undefined,M=P}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,P){const b=new v(M);if(this._first===v.Undefined)this._first=b,this._last=b;else if(P){const d=this._last;this._last=b,b.prev=d,d.next=b}else{const d=this._first;this._first=b,b.next=d,d.prev=b}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(b))}}shift(){if(this._first!==v.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==v.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==v.Undefined&&M.next!==v.Undefined){const P=M.prev;P.next=M.next,M.next.prev=P}else M.prev===v.Undefined&&M.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):M.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):M.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==v.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function j(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function P(h){M.push(h,Date.now())}function b(){const h=[];for(let d=0;d<M.length;d+=2)h.push({name:M[d],startTime:M[d+1]});return h}return{mark:P,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const P of performance.getEntriesByType("mark"))M.push({name:P.name,startTime:Math.round(D+P.startTime)});return M}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=v(L))}(),define(Z[3],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let L=!1,D=!1,M=!1,P=!1,b=!1,h=!1,d=!1,i,S=v,m,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let t;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?t=e.globals.vscode.process:typeof process!="undefined"&&(t=process);const g=typeof t?.versions?.electron=="string"&&t.type==="renderer";if(e.isElectronSandboxed=g&&t?.sandboxed,typeof navigator=="object"&&!g)p=navigator.userAgent,L=p.indexOf("Windows")>=0,D=p.indexOf("Macintosh")>=0,d=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=p.indexOf("Linux")>=0,h=!0,i=navigator.language,S=i;else if(typeof t=="object"){L=t.platform==="win32",D=t.platform==="darwin",M=t.platform==="linux",P=M&&!!t.env.SNAP&&!!t.env.SNAP_REVISION,i=v,S=v;const s=t.env.VSCODE_NLS_CONFIG;if(s)try{const r=JSON.parse(s),l=r.availableLanguages["*"];i=r.locale,S=l||v,m=r._translationsConfigFile}catch(r){}b=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function y(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let I=0;D?I=1:L?I=3:M&&(I=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=M,e.isLinuxSnap=P,e.isNative=b,e.isWeb=h,e.isIOS=d,e.platform=I,e.userAgent=p,e.language=S;var c;(function(s){function r(){return e.language}s.value=r;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function f(){return e.language==="en"}s.isDefault=f})(c=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeSetImmediateId)for(let k=0,R=l.length;k<R;k++){const A=l[k];if(A.id===w.data.vscodeSetImmediateId){l.splice(k,1),A.callback();return}}});let f=0;return w=>{const k=++f;l.push({id:k,callback:w}),e.globals.postMessage({vscodeSetImmediateId:k},"*")}}if(typeof t?.nextTick=="function")return t.nextTick.bind(t);const r=Promise.resolve();return l=>r.then(l)}();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||d?2:L?1:3;let u=!0,n=!1;function a(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,u=new Uint16Array(s.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=a}),define(Z[32],x([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const D=v.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(M){return(0,v.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,v.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],x([0,1,32]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,M=90,P=122,b=46,h=47,d=92,i=58,S=63;class m extends Error{constructor(o,u,n){let a;typeof u=="string"&&u.indexOf("not ")===0?(a="must not be",u=u.replace(/^not /,"")):a="must be";const s=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${s} ${a} of type ${u}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function p(c,o){if(typeof c!="string")throw new m(o,"string",c)}function t(c){return c===h||c===d}function g(c){return c===h}function E(c){return c>=L&&c<=M||c>=D&&c<=P}function y(c,o,u,n){let a="",s=0,r=-1,l=0,f=0;for(let w=0;w<=c.length;++w){if(w<c.length)f=c.charCodeAt(w);else{if(n(f))break;f=h}if(n(f)){if(!(r===w-1||l===1))if(l===2){if(a.length<2||s!==2||a.charCodeAt(a.length-1)!==b||a.charCodeAt(a.length-2)!==b){if(a.length>2){const k=a.lastIndexOf(u);k===-1?(a="",s=0):(a=a.slice(0,k),s=a.length-1-a.lastIndexOf(u)),r=w,l=0;continue}else if(a.length!==0){a="",s=0,r=w,l=0;continue}}o&&(a+=a.length>0?`${u}..`:"..",s=2)}else a.length>0?a+=`${u}${c.slice(r+1,w)}`:a=c.slice(r+1,w),s=w-r-1;r=w,l=0}else f===b&&l!==-1?++l:l=-1}return a}function I(c,o){if(o===null||typeof o!="object")throw new m("pathObject","Object",o);const u=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return u?u===o.root?`${u}${n}`:`${u}${c}${n}`:n}e.win32={resolve(...c){let o="",u="",n=!1;for(let a=c.length-1;a>=-1;a--){let s;if(a>=0){if(s=c[a],p(s,"path"),s.length===0)continue}else o.length===0?s=v.cwd():(s=v.env[`=${o}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===d)&&(s=`${o}\\`));const r=s.length;let l=0,f="",w=!1;const k=s.charCodeAt(0);if(r===1)t(k)&&(l=1,w=!0);else if(t(k))if(w=!0,t(s.charCodeAt(1))){let R=2,A=R;for(;R<r&&!t(s.charCodeAt(R));)R++;if(R<r&&R!==A){const F=s.slice(A,R);for(A=R;R<r&&t(s.charCodeAt(R));)R++;if(R<r&&R!==A){for(A=R;R<r&&!t(s.charCodeAt(R));)R++;(R===r||R!==A)&&(f=`\\\\${F}\\${s.slice(A,R)}`,l=R)}}}else l=1;else E(k)&&s.charCodeAt(1)===i&&(f=s.slice(0,2),l=2,r>2&&t(s.charCodeAt(2))&&(w=!0,l=3));if(f.length>0)if(o.length>0){if(f.toLowerCase()!==o.toLowerCase())continue}else o=f;if(n){if(o.length>0)break}else if(u=`${s.slice(l)}\\${u}`,n=w,w&&o.length>0)break}return u=y(u,!n,"\\",t),n?`${o}\\${u}`:`${o}${u}`||"."},normalize(c){p(c,"path");const o=c.length;if(o===0)return".";let u=0,n,a=!1;const s=c.charCodeAt(0);if(o===1)return g(s)?"\\":c;if(t(s))if(a=!0,t(c.charCodeAt(1))){let l=2,f=l;for(;l<o&&!t(c.charCodeAt(l));)l++;if(l<o&&l!==f){const w=c.slice(f,l);for(f=l;l<o&&t(c.charCodeAt(l));)l++;if(l<o&&l!==f){for(f=l;l<o&&!t(c.charCodeAt(l));)l++;if(l===o)return`\\\\${w}\\${c.slice(f)}\\`;l!==f&&(n=`\\\\${w}\\${c.slice(f,l)}`,u=l)}}}else u=1;else E(s)&&c.charCodeAt(1)===i&&(n=c.slice(0,2),u=2,o>2&&t(c.charCodeAt(2))&&(a=!0,u=3));let r=u<o?y(c.slice(u),!a,"\\",t):"";return r.length===0&&!a&&(r="."),r.length>0&&t(c.charCodeAt(o-1))&&(r+="\\"),n===void 0?a?`\\${r}`:r:a?`${n}\\${r}`:`${n}${r}`},isAbsolute(c){p(c,"path");const o=c.length;if(o===0)return!1;const u=c.charCodeAt(0);return t(u)||o>2&&E(u)&&c.charCodeAt(1)===i&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let o,u;for(let s=0;s<c.length;++s){const r=c[s];p(r,"path"),r.length>0&&(o===void 0?o=u=r:o+=`\\${r}`)}if(o===void 0)return".";let n=!0,a=0;if(typeof u=="string"&&t(u.charCodeAt(0))){++a;const s=u.length;s>1&&t(u.charCodeAt(1))&&(++a,s>2&&(t(u.charCodeAt(2))?++a:n=!1))}if(n){for(;a<o.length&&t(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.win32.normalize(o)},relative(c,o){if(p(c,"from"),p(o,"to"),c===o)return"";const u=e.win32.resolve(c),n=e.win32.resolve(o);if(u===n||(c=u.toLowerCase(),o=n.toLowerCase(),c===o))return"";let a=0;for(;a<c.length&&c.charCodeAt(a)===d;)a++;let s=c.length;for(;s-1>a&&c.charCodeAt(s-1)===d;)s--;const r=s-a;let l=0;for(;l<o.length&&o.charCodeAt(l)===d;)l++;let f=o.length;for(;f-1>l&&o.charCodeAt(f-1)===d;)f--;const w=f-l,k=r<w?r:w;let R=-1,A=0;for(;A<k;A++){const H=c.charCodeAt(a+A);if(H!==o.charCodeAt(l+A))break;H===d&&(R=A)}if(A!==k){if(R===-1)return n}else{if(w>k){if(o.charCodeAt(l+A)===d)return n.slice(l+A+1);if(A===2)return n.slice(l+A)}r>k&&(c.charCodeAt(a+A)===d?R=A:A===2&&(R=3)),R===-1&&(R=0)}let F="";for(A=a+R+1;A<=s;++A)(A===s||c.charCodeAt(A)===d)&&(F+=F.length===0?"..":"\\..");return l+=R,F.length>0?`${F}${n.slice(l,f)}`:(n.charCodeAt(l)===d&&++l,n.slice(l,f))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const o=e.win32.resolve(c);if(o.length<=2)return c;if(o.charCodeAt(0)===d){if(o.charCodeAt(1)===d){const u=o.charCodeAt(2);if(u!==S&&u!==b)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(E(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===d)return`\\\\?\\${o}`;return c},dirname(c){p(c,"path");const o=c.length;if(o===0)return".";let u=-1,n=0;const a=c.charCodeAt(0);if(o===1)return t(a)?c:".";if(t(a)){if(u=n=1,t(c.charCodeAt(1))){let l=2,f=l;for(;l<o&&!t(c.charCodeAt(l));)l++;if(l<o&&l!==f){for(f=l;l<o&&t(c.charCodeAt(l));)l++;if(l<o&&l!==f){for(f=l;l<o&&!t(c.charCodeAt(l));)l++;if(l===o)return c;l!==f&&(u=n=l+1)}}}}else E(a)&&c.charCodeAt(1)===i&&(u=o>2&&t(c.charCodeAt(2))?3:2,n=u);let s=-1,r=!0;for(let l=o-1;l>=n;--l)if(t(c.charCodeAt(l))){if(!r){s=l;break}}else r=!1;if(s===-1){if(u===-1)return".";s=u}return c.slice(0,s)},basename(c,o){o!==void 0&&p(o,"ext"),p(c,"path");let u=0,n=-1,a=!0,s;if(c.length>=2&&E(c.charCodeAt(0))&&c.charCodeAt(1)===i&&(u=2),o!==void 0&&o.length>0&&o.length<=c.length){if(o===c)return"";let r=o.length-1,l=-1;for(s=c.length-1;s>=u;--s){const f=c.charCodeAt(s);if(t(f)){if(!a){u=s+1;break}}else l===-1&&(a=!1,l=s+1),r>=0&&(f===o.charCodeAt(r)?--r==-1&&(n=s):(r=-1,n=l))}return u===n?n=l:n===-1&&(n=c.length),c.slice(u,n)}for(s=c.length-1;s>=u;--s)if(t(c.charCodeAt(s))){if(!a){u=s+1;break}}else n===-1&&(a=!1,n=s+1);return n===-1?"":c.slice(u,n)},extname(c){p(c,"path");let o=0,u=-1,n=0,a=-1,s=!0,r=0;c.length>=2&&c.charCodeAt(1)===i&&E(c.charCodeAt(0))&&(o=n=2);for(let l=c.length-1;l>=o;--l){const f=c.charCodeAt(l);if(t(f)){if(!s){n=l+1;break}continue}a===-1&&(s=!1,a=l+1),f===b?u===-1?u=l:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||a===-1||r===0||r===1&&u===a-1&&u===n+1?"":c.slice(u,a)},format:I.bind(null,"\\"),parse(c){p(c,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return o;const u=c.length;let n=0,a=c.charCodeAt(0);if(u===1)return t(a)?(o.root=o.dir=c,o):(o.base=o.name=c,o);if(t(a)){if(n=1,t(c.charCodeAt(1))){let R=2,A=R;for(;R<u&&!t(c.charCodeAt(R));)R++;if(R<u&&R!==A){for(A=R;R<u&&t(c.charCodeAt(R));)R++;if(R<u&&R!==A){for(A=R;R<u&&!t(c.charCodeAt(R));)R++;R===u?n=R:R!==A&&(n=R+1)}}}}else if(E(a)&&c.charCodeAt(1)===i){if(u<=2)return o.root=o.dir=c,o;if(n=2,t(c.charCodeAt(2))){if(u===3)return o.root=o.dir=c,o;n=3}}n>0&&(o.root=c.slice(0,n));let s=-1,r=n,l=-1,f=!0,w=c.length-1,k=0;for(;w>=n;--w){if(a=c.charCodeAt(w),t(a)){if(!f){r=w+1;break}continue}l===-1&&(f=!1,l=w+1),a===b?s===-1?s=w:k!==1&&(k=1):s!==-1&&(k=-1)}return l!==-1&&(s===-1||k===0||k===1&&s===l-1&&s===r+1?o.base=o.name=c.slice(r,l):(o.name=c.slice(r,s),o.base=c.slice(r,l),o.ext=c.slice(s,l))),r>0&&r!==n?o.dir=c.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let o="",u=!1;for(let n=c.length-1;n>=-1&&!u;n--){const a=n>=0?c[n]:v.cwd();p(a,"path"),a.length!==0&&(o=`${a}/${o}`,u=a.charCodeAt(0)===h)}return o=y(o,!u,"/",g),u?`/${o}`:o.length>0?o:"."},normalize(c){if(p(c,"path"),c.length===0)return".";const o=c.charCodeAt(0)===h,u=c.charCodeAt(c.length-1)===h;return c=y(c,!o,"/",g),c.length===0?o?"/":u?"./":".":(u&&(c+="/"),o?`/${c}`:c)},isAbsolute(c){return p(c,"path"),c.length>0&&c.charCodeAt(0)===h},join(...c){if(c.length===0)return".";let o;for(let u=0;u<c.length;++u){const n=c[u];p(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.posix.normalize(o)},relative(c,o){if(p(c,"from"),p(o,"to"),c===o||(c=e.posix.resolve(c),o=e.posix.resolve(o),c===o))return"";const u=1,n=c.length,a=n-u,s=1,r=o.length-s,l=a<r?a:r;let f=-1,w=0;for(;w<l;w++){const R=c.charCodeAt(u+w);if(R!==o.charCodeAt(s+w))break;R===h&&(f=w)}if(w===l)if(r>l){if(o.charCodeAt(s+w)===h)return o.slice(s+w+1);if(w===0)return o.slice(s+w)}else a>l&&(c.charCodeAt(u+w)===h?f=w:w===0&&(f=0));let k="";for(w=u+f+1;w<=n;++w)(w===n||c.charCodeAt(w)===h)&&(k+=k.length===0?"..":"/..");return`${k}${o.slice(s+f)}`},toNamespacedPath(c){return c},dirname(c){if(p(c,"path"),c.length===0)return".";const o=c.charCodeAt(0)===h;let u=-1,n=!0;for(let a=c.length-1;a>=1;--a)if(c.charCodeAt(a)===h){if(!n){u=a;break}}else n=!1;return u===-1?o?"/":".":o&&u===1?"//":c.slice(0,u)},basename(c,o){o!==void 0&&p(o,"ext"),p(c,"path");let u=0,n=-1,a=!0,s;if(o!==void 0&&o.length>0&&o.length<=c.length){if(o===c)return"";let r=o.length-1,l=-1;for(s=c.length-1;s>=0;--s){const f=c.charCodeAt(s);if(f===h){if(!a){u=s+1;break}}else l===-1&&(a=!1,l=s+1),r>=0&&(f===o.charCodeAt(r)?--r==-1&&(n=s):(r=-1,n=l))}return u===n?n=l:n===-1&&(n=c.length),c.slice(u,n)}for(s=c.length-1;s>=0;--s)if(c.charCodeAt(s)===h){if(!a){u=s+1;break}}else n===-1&&(a=!1,n=s+1);return n===-1?"":c.slice(u,n)},extname(c){p(c,"path");let o=-1,u=0,n=-1,a=!0,s=0;for(let r=c.length-1;r>=0;--r){const l=c.charCodeAt(r);if(l===h){if(!a){u=r+1;break}continue}n===-1&&(a=!1,n=r+1),l===b?o===-1?o=r:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||n===-1||s===0||s===1&&o===n-1&&o===u+1?"":c.slice(o,n)},format:I.bind(null,"/"),parse(c){p(c,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return o;const u=c.charCodeAt(0)===h;let n;u?(o.root="/",n=1):n=0;let a=-1,s=0,r=-1,l=!0,f=c.length-1,w=0;for(;f>=n;--f){const k=c.charCodeAt(f);if(k===h){if(!l){s=f+1;break}continue}r===-1&&(l=!1,r=f+1),k===b?a===-1?a=f:w!==1&&(w=1):a!==-1&&(w=-1)}if(r!==-1){const k=s===0&&u?1:s;a===-1||w===0||w===1&&a===r-1&&a===s+1?o.base=o.name=c.slice(k,r):(o.name=c.slice(k,a),o.base=c.slice(k,r),o.ext=c.slice(a,r))}return s>0?o.dir=c.slice(0,s-1):u&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[81],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(M,...P){const b=P.reduce((i,S)=>(i[S]=!0,i),{}),h=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(i=>!b[i]).forEach(i=>{for(let S=0;S<h.length;S++)if(i.search(h[S])!==-1){delete M[i];break}})}e.sanitizeProcessEnvironment=D}),define(Z[108],x([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(P){this._highResolution=L&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new D(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Z[4],x([0,1,16,42,2,107,108]),function(j,e,v,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var b;(function(o){o.None=()=>D.Disposable.None;function u(T){return(B,V=null,_)=>{let U=!1,C;return C=T(X=>{if(!U)return C?C.dispose():U=!0,B.call(V,X)},null,_),U&&C.dispose(),C}}o.once=u;function n(T,B){return w((V,_=null,U)=>T(C=>V.call(_,B(C)),null,U))}o.map=n;function a(T,B){return w((V,_=null,U)=>T(C=>{B(C),V.call(_,C)},null,U))}o.forEach=a;function s(T,B){return w((V,_=null,U)=>T(C=>B(C)&&V.call(_,C),null,U))}o.filter=s;function r(T){return T}o.signal=r;function l(...T){return(B,V=null,_)=>(0,D.combinedDisposable)(...T.map(U=>U(C=>B.call(V,C),null,_)))}o.any=l;function f(T,B,V){let _=V;return n(T,U=>(_=B(_,U),_))}o.reduce=f;function w(T){let B;const V=new m({onFirstListenerAdd(){B=T(V.fire,V)},onLastListenerRemove(){B.dispose()}});return V.event}function k(T,B,V=100,_=!1,U){let C,X,W,z=0;const K=new m({leakWarningThreshold:U,onFirstListenerAdd(){C=T(O=>{z++,X=B(X,O),_&&!W&&(K.fire(X),X=void 0),clearTimeout(W),W=setTimeout(()=>{const q=X;X=void 0,W=void 0,(!_||z>1)&&K.fire(q),z=0},V)})},onLastListenerRemove(){C.dispose()}});return K.event}o.debounce=k;function R(T,B=(V,_)=>V===_){let V=!0,_;return s(T,U=>{const C=V||!B(U,_);return V=!1,_=U,C})}o.latch=R;function A(T,B){return[o.filter(T,B),o.filter(T,V=>!B(V))]}o.split=A;function F(T,B=!1,V=[]){let _=V.slice(),U=T(W=>{_?_.push(W):X.fire(W)});const C=()=>{_&&_.forEach(W=>X.fire(W)),_=null},X=new m({onFirstListenerAdd(){U||(U=T(W=>X.fire(W)))},onFirstListenerDidAdd(){_&&(B?setTimeout(C):C())},onLastListenerRemove(){U&&U.dispose(),U=null}});return X.event}o.buffer=F;class H{constructor(B){this.event=B}map(B){return new H(n(this.event,B))}forEach(B){return new H(a(this.event,B))}filter(B){return new H(s(this.event,B))}reduce(B,V){return new H(f(this.event,B,V))}latch(){return new H(R(this.event))}debounce(B,V=100,_=!1,U){return new H(k(this.event,B,V,_,U))}on(B,V,_){return this.event(B,V,_)}once(B,V,_){return u(this.event)(B,V,_)}}function te(T){return new H(T)}o.chain=te;function se(T,B,V=_=>_){const _=(...W)=>X.fire(V(...W)),U=()=>T.on(B,_),C=()=>T.removeListener(B,_),X=new m({onFirstListenerAdd:U,onLastListenerRemove:C});return X.event}o.fromNodeEventEmitter=se;function le(T,B,V=_=>_){const _=(...W)=>X.fire(V(...W)),U=()=>T.addEventListener(B,_),C=()=>T.removeEventListener(B,_),X=new m({onFirstListenerAdd:U,onLastListenerRemove:C});return X.event}o.fromDOMEventEmitter=le;function Y(T){return new Promise(B=>u(T)(B))}o.toPromise=Y})(b=e.Event||(e.Event={}));class h{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${h._idPool++}`}start(u){this._stopWatch=new P.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}h._idPool=0;let d=-1;function i(o){const u=d;return d=o,{dispose(){d=u}}}e.setGlobalLeakWarningThreshold=i;class S{constructor(u,n=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let n=d;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||u<n)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(a)||0;if(this._stacks.set(a,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let r,l=0;for(const[f,w]of this._stacks)(!r||l<w)&&(r=f,l=w);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${l}):`),console.warn(r)}return()=>{const r=this._stacks.get(a)||0;this._stacks.set(a,r-1)}}}class m{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=d>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0}get event(){return this._event||(this._event=(u,n,a)=>{this._listeners||(this._listeners=new M.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(n?[u,n]:u);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,n);const l=this._leakageMon?.check(this._listeners.size),f=(0,D.toDisposable)(()=>{l&&l(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof D.DisposableStore?a.add(f):Array.isArray(a)&&a.push(f),f}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,a]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,a):n[0].call(n[1],a)}catch(s){(0,v.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class p extends m{async fireAsync(u,n,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,u]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),l=[],f={...r,waitUntil:w=>{if(Object.isFrozen(l))throw new Error("waitUntil can NOT be called asynchronous");a&&(w=a(w,typeof s=="function"?s:s[0])),l.push(w)}};try{typeof s=="function"?s.call(void 0,f):s[0].call(s[1],f)}catch(w){(0,v.onUnexpectedError)(w);continue}Object.freeze(l),await Promise.allSettled(l).then(w=>{for(const k of w)k.status==="rejected"&&(0,v.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=p;class t extends m{constructor(u){super(u);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=t;class g extends t{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=g;class E extends m{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const n={event:u,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const a=()=>{this.hasListeners&&this.unhook(n);const s=this.events.indexOf(n);this.events.splice(s,1)};return(0,D.toDisposable)((0,L.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(n=>this.emitter.fire(n))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=y;class I{constructor(){this.buffers=[]}wrapEvent(u){return(n,a,s)=>u(r=>{const l=this.buffers[this.buffers.length-1];l?l.push(()=>n.call(a,r)):n.call(a,r)},void 0,s)}bufferEvents(u){const n=[];this.buffers.push(n);const a=u();return this.buffers.pop(),n.forEach(s=>s()),a}}e.EventBufferer=I;class c{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=D.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(Z[23],x([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(b,h){const d=setTimeout(b.bind(h),0);return{dispose(){clearTimeout(d)}}});var D;(function(b){function h(d){return d===b.None||d===b.Cancelled||d instanceof M?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}b.isCancellationToken=h,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=D.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=P}),define(Z[109],x([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(S){const m=this._icons.get(S.id);m?S.description?m.description=S.description:console.error(`Duplicate registration of codicon ${S.id}`):(this._icons.set(S.id,S),this._onDidRegister.fire(S))}get(S){return this._icons.get(S)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function M(i,S){return new b(i,S)}e.registerCodicon=M;function P(i){return i?i.replace(/\$\((.*?)\)/g,(S,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=P;class b{constructor(S,m,p){this.id=S,this.definition=m,this.description=p,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=b;function h(i,S){const m=["codicon","codicon-"+i];return S&&m.push("codicon-modifier-"+S),m}e.getClassNamesArray=h;var d;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const S=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function m(g){if(g instanceof b)return["codicon","codicon-"+g.id];const E=S.exec(g.id);if(!E)return m(b.error);let[,y,I]=E;const c=["codicon","codicon-"+y];return I&&c.push("codicon-modifier-"+I.substr(1)),c}i.asClassNameArray=m;function p(g){return m(g).join(" ")}i.asClassName=p;function t(g){return"."+m(g).join(".")}i.asCSSSelector=t})(d=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"})}(b=e.Codicon||(e.Codicon={}))}),define(Z[60],x([0,1,16,2]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(c){const o=c;return o?[o.on,o.pause,o.resume,o.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=D;function M(c){const o=c;return o?D(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=M;function P(c,o){return new b(c,o)}e.newWriteableStream=P;class b{constructor(o,u){this.reducer=o,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(u=>u(o))}emitError(o){this.listeners.error.length===0?(0,v.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(u=>u(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,u){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(o,u){if(this.state.destroyed)return;let n;switch(o){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const a=n.indexOf(u);a>=0&&n.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(c,o){const u=[];let n;for(;(n=c.read())!==null;)u.push(n);return o(u)}e.consumeReadable=h;function d(c,o,u){const n=[];let a;for(;(a=c.read())!==null&&n.length<u;)n.push(a);return a===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof a!="undefined"){const s=a;return a=void 0,s}return c.read()}}}e.peekReadable=d;function i(c,o){return new Promise((u,n)=>{const a=[];S(c,{onData:s=>{o&&a.push(s)},onError:s=>{o?n(s):u(void 0)},onEnd:()=>{u(o?o(a):void 0)}})})}e.consumeStream=i;function S(c,o){c.on("error",u=>o.onError(u)),c.on("end",()=>o.onEnd()),c.on("data",u=>o.onData(u))}e.listenStream=S;function m(c,o){return new Promise((u,n)=>{const a=new L.DisposableStore,s=[],r=w=>{if(s.push(w),s.length>o)return a.dispose(),c.pause(),u({stream:c,buffer:s,ended:!1})},l=w=>n(w),f=()=>u({stream:c,buffer:s,ended:!0});a.add((0,L.toDisposable)(()=>c.removeListener("error",l))),c.on("error",l),a.add((0,L.toDisposable)(()=>c.removeListener("end",f))),c.on("end",f),a.add((0,L.toDisposable)(()=>c.removeListener("data",r))),c.on("data",r)})}e.peekStream=m;function p(c,o){const u=P(o);return u.end(c),u}e.toStream=p;function t(){const c=P(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function g(c){let o=!1;return{read:()=>o?null:(o=!0,c)}}e.toReadable=g;function E(c,o,u){const n=P(u);return S(c,{onData:a=>n.write(o.data(a)),onError:a=>n.error(o.error?o.error(a):a),onEnd:()=>n.end()}),n}e.transform=E;function y(c,o,u){let n=!1;return{read:()=>{const a=o.read();return n?a:(n=!0,a!==null?u([c,a]):c)}}}e.prefixedReadable=y;function I(c,o,u){let n=!1;const a=P(u);return S(o,{onData:s=>n?a.write(s):(n=!0,a.write(u([c,s]))),onError:s=>a.error(s),onEnd:()=>{n||(n=!0,a.write(c)),a.end()}}),a}e.prefixedStream=I}),define(Z[17],x([0,1,60]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,M;class P{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new P(Buffer.allocUnsafe(r)):new P(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new P(r)}static fromString(r,l){return!(l?.dontUseNodeBuffer||!1)&&L?new P(Buffer.from(r)):(D||(D=new TextEncoder),new P(D.encode(r)))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let k=0,R=r.length;k<R;k++)l+=r[k].byteLength}const f=P.alloc(l);let w=0;for(let k=0,R=r.length;k<R;k++){const A=r[k];f.set(A,w),w+=A.byteLength}return f}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(r,l){return new P(this.buffer.subarray(r,l))}set(r,l){r instanceof P?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return d(this.buffer,r)}writeUInt32BE(r,l){i(this.buffer,r,l)}readUInt32LE(r){return S(this.buffer,r)}writeUInt32LE(r,l){m(this.buffer,r,l)}readUInt8(r){return p(this.buffer,r)}writeUInt8(r,l){t(this.buffer,r,l)}}e.VSBuffer=P;function b(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0}e.readUInt16LE=b;function h(s,r,l){s[l+0]=r&255,r=r>>>8,s[l+1]=r&255}e.writeUInt16LE=h;function d(s,r){return s[r]*2**24+s[r+1]*2**16+s[r+2]*2**8+s[r+3]}e.readUInt32BE=d;function i(s,r,l){s[l+3]=r,r=r>>>8,s[l+2]=r,r=r>>>8,s[l+1]=r,r=r>>>8,s[l]=r}e.writeUInt32BE=i;function S(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0|s[r+2]<<16>>>0|s[r+3]<<24>>>0}e.readUInt32LE=S;function m(s,r,l){s[l+0]=r&255,r=r>>>8,s[l+1]=r&255,r=r>>>8,s[l+2]=r&255,r=r>>>8,s[l+3]=r&255}e.writeUInt32LE=m;function p(s,r){return s[r]}e.readUInt8=p;function t(s,r,l){s[l]=r}e.writeUInt8=t;function g(s){return v.consumeReadable(s,r=>P.concat(r))}e.readableToBuffer=g;function E(s){return v.toReadable(s)}e.bufferToReadable=E;function y(s){return v.consumeStream(s,r=>P.concat(r))}e.streamToBuffer=y;async function I(s){return s.ended?P.concat(s.buffer):P.concat([...s.buffer,await y(s.stream)])}e.bufferedStreamToBuffer=I;function c(s){return v.toStream(s,r=>P.concat(r))}e.bufferToStream=c;function o(s){return v.transform(s,{data:r=>typeof r=="string"?P.fromString(r):P.wrap(r)},r=>P.concat(r))}e.streamToBufferReadableStream=o;function u(s){return v.newWriteableStream(r=>P.concat(r),s)}e.newWriteableBufferStream=u;function n(s,r){return v.prefixedReadable(s,r,l=>P.concat(l))}e.prefixedBufferReadable=n;function a(s,r){return v.prefixedStream(s,r,l=>P.concat(l))}e.prefixedBufferStream=a}),define(Z[25],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function v(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=v;const L=/{(\d+)}/g;function D(G,...oe){return oe.length===0?G:G.replace(L,function(ue,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=oe.length?ue:oe[be]})}e.format=D;const M=/{([^}]+)}/g;function P(G,oe){return G.replace(M,(ue,me)=>oe[me]??ue)}e.format2=P;function b(G){return G.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=b;function h(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=h;function d(G,oe){let ue=0;const me=oe.charCodeAt(0);for(let be=G.length-1;be>=0;be--)G.charCodeAt(be)===me&&ue++;return ue}e.count=d;function i(G,oe,ue="\u2026"){return G.length<=oe?G:`${G.substr(0,oe)}${ue}`}e.truncate=i;function S(G,oe=" "){const ue=m(G,oe);return p(ue,oe)}e.trim=S;function m(G,oe){if(!G||!oe)return G;const ue=oe.length;if(ue===0||G.length===0)return G;let me=0;for(;G.indexOf(oe,me)===me;)me=me+ue;return G.substring(me)}e.ltrim=m;function p(G,oe){if(!G||!oe)return G;const ue=oe.length,me=G.length;if(ue===0||me===0)return G;let be=me,Te=-1;for(;Te=G.lastIndexOf(oe,be-1),!(Te===-1||Te+ue!==be);){if(Te===0)return"";be=Te}return G.substring(0,be)}e.rtrim=p;function t(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=t;function g(G){return G.replace(/\*/g,"")}e.stripWildcards=g;function E(G,oe,ue={}){if(!G)throw new Error("Cannot create regex from empty string");oe||(G=h(G)),ue.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(G,me)}e.createRegExp=E;function y(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function I(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function c(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=c;function o(G){return G.split(/\r\n|\r|\n/)}e.splitLines=o;function u(G){for(let oe=0,ue=G.length;oe<ue;oe++){const me=G.charCodeAt(oe);if(me!==32&&me!==9)return oe}return-1}e.firstNonWhitespaceIndex=u;function n(G,oe=0,ue=G.length){for(let me=oe;me<ue;me++){const be=G.charCodeAt(me);if(be!==32&&be!==9)return G.substring(oe,me)}return G.substring(oe,ue)}e.getLeadingWhitespace=n;function a(G,oe=G.length-1){for(let ue=oe;ue>=0;ue--){const me=G.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=a;function s(G,oe){return G<oe?-1:G>oe?1:0}e.compare=s;function r(G,oe,ue=0,me=G.length,be=0,Te=oe.length){for(;ue<me&&be<Te;ue++,be++){let Be=G.charCodeAt(ue),Ce=oe.charCodeAt(be);if(Be<Ce)return-1;if(Be>Ce)return 1}const _e=me-ue,Ue=Te-be;return _e<Ue?-1:_e>Ue?1:0}e.compareSubstring=r;function l(G,oe){return f(G,oe,0,G.length,0,oe.length)}e.compareIgnoreCase=l;function f(G,oe,ue=0,me=G.length,be=0,Te=oe.length){for(;ue<me&&be<Te;ue++,be++){let Be=G.charCodeAt(ue),Ce=oe.charCodeAt(be);if(Be===Ce)continue;if(Be>=128||Ce>=128)return r(G.toLowerCase(),oe.toLowerCase(),ue,me,be,Te);w(Be)&&(Be-=32),w(Ce)&&(Ce-=32);const ze=Be-Ce;if(ze!==0)return ze}const _e=me-ue,Ue=Te-be;return _e<Ue?-1:_e>Ue?1:0}e.compareSubstringIgnoreCase=f;function w(G){return G>=97&&G<=122}e.isLowerAsciiLetter=w;function k(G){return G>=65&&G<=90}e.isUpperAsciiLetter=k;function R(G,oe){return G.length===oe.length&&f(G,oe)===0}e.equalsIgnoreCase=R;function A(G,oe){const ue=oe.length;return oe.length>G.length?!1:f(G,oe,0,ue)===0}e.startsWithIgnoreCase=A;function F(G,oe){let ue,me=Math.min(G.length,oe.length);for(ue=0;ue<me;ue++)if(G.charCodeAt(ue)!==oe.charCodeAt(ue))return ue;return me}e.commonPrefixLength=F;function H(G,oe){let ue,me=Math.min(G.length,oe.length);const be=G.length-1,Te=oe.length-1;for(ue=0;ue<me;ue++)if(G.charCodeAt(be-ue)!==oe.charCodeAt(Te-ue))return ue;return me}e.commonSuffixLength=H;function te(G){return 55296<=G&&G<=56319}e.isHighSurrogate=te;function se(G){return 56320<=G&&G<=57343}e.isLowSurrogate=se;function le(G,oe){return(G-55296<<10)+(oe-56320)+65536}e.computeCodePoint=le;function Y(G,oe,ue){const me=G.charCodeAt(ue);if(te(me)&&ue+1<oe){const be=G.charCodeAt(ue+1);if(se(be))return le(me,be)}return me}e.getNextCodePoint=Y;function T(G,oe){const ue=G.charCodeAt(oe-1);if(se(ue)&&oe>1){const me=G.charCodeAt(oe-2);if(te(me))return le(me,ue)}return ue}function B(G,oe){const ue=Ae.getInstance(),me=oe,be=G.length,Te=Y(G,be,oe);oe+=Te>=65536?2:1;let _e=ue.getGraphemeBreakType(Te);for(;oe<be;){const Ue=Y(G,be,oe),Be=ue.getGraphemeBreakType(Ue);if(ke(_e,Be))break;oe+=Ue>=65536?2:1,_e=Be}return oe-me}e.nextCharLength=B;function V(G,oe){const ue=Ae.getInstance(),me=oe,be=T(G,oe);oe-=be>=65536?2:1;let Te=ue.getGraphemeBreakType(be);for(;oe>0;){const _e=T(G,oe),Ue=ue.getGraphemeBreakType(_e);if(ke(Ue,Te))break;oe-=_e>=65536?2:1,Te=Ue}return me-oe}e.prevCharLength=V;function _(G,oe){const ue=Ae.getInstance(),me=G.length,be=oe,Te=Y(G,me,oe),_e=ue.getGraphemeBreakType(Te);oe+=Te>=65536?2:1;let Ue=_e;for(;oe<me;){const Ce=Y(G,me,oe),ze=ue.getGraphemeBreakType(Ce);if(ke(Ue,ze))break;oe+=Ce>=65536?2:1,Ue=ze}const Be=oe;for(oe=be,Ue=_e;oe>0;){const Ce=T(G,oe),ze=ue.getGraphemeBreakType(Ce);if(ke(ze,Ue))break;oe-=Ce>=65536?2:1,Ue=ze}return[oe,Be]}function U(G,oe){return oe>0&&se(G.charCodeAt(oe))?_(G,oe-1):_(G,oe)}e.getCharContainingOffset=U;const C=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(G){return C.test(G)}e.containsRTL=X;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function z(G){return W.test(G)}e.containsEmoji=z;const K=/^[\t\n\r\x20-\x7E]*$/;function O(G){return K.test(G)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=q;function N(G){for(let oe=0,ue=G.length;oe<ue;oe++)if($(G.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=N;function $(G){return G=+G,G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=$;function J(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129003||G>=129280&&G<=129535||G>=129648&&G<=129750}e.isEmojiImprecise=J;function Q(G,oe){if(G.length<oe)return G;const ue=/\b/g;let me=0;for(;ue.test(G)&&!(G.length-ue.lastIndex<oe);)me=ue.lastIndex,ue.lastIndex+=1;return G.substring(me).replace(/^\s/,"")}e.lcut=Q;const ne=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function re(G){return G&&(G=G.replace(ne,""),G=G.replace(ae,""),G=G.replace(ie,"")),G}e.removeAnsiEscapeCodes=re,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function fe(G){return ce(G)?G.substr(1):G}e.stripUTF8BOM=fe;function de(G,oe){if(!G||!oe||G.length<oe.length)return!1;const ue=oe.length,me=G.toLowerCase();let be=0,Te=-1;for(;be<ue;){const _e=me.indexOf(oe[be],Te+1);if(_e<0)return!1;Te=_e,be++}return!0}e.fuzzyContains=de;function Ee(G,oe=!1){return G?(oe&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Ee;function Pe(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Pe;function Ie(G,oe=1){if(oe===0)return"";let ue=-1;do ue=G.indexOf(`
`,ue+1),oe--;while(oe>0&&ue>=0);return ue===-1?G:(G[ue-1]==="\r"&&ue--,G.substr(0,ue))}e.getNLines=Ie;function ve(G){const oe=90-65+1;return G=G%(2*oe),G<oe?String.fromCharCode(97+G):String.fromCharCode(65+G-oe)}e.singleLetterHash=ve;function ye(G){return Ae.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=ye;function ke(G,oe){return G===0?oe!==5&&oe!==7:G===2&&oe===3?!1:G===4||G===2||G===3||oe===4||oe===2||oe===3?!0:!(G===8&&(oe===8||oe===9||oe===11||oe===12)||(G===11||G===9)&&(oe===9||oe===10)||(G===12||G===10)&&oe===10||oe===5||oe===13||oe===7||G===1||G===13&&oe===14||G===6&&oe===6)}e.breakBetweenGraphemeBreakType=ke;var We;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(We=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{constructor(){this._data=Ve()}static getInstance(){return Ae._INSTANCE||(Ae._INSTANCE=new Ae),Ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ue=this._data,me=ue.length/3;let be=1;for(;be<=me;)if(oe<ue[3*be])be=2*be;else if(oe>ue[3*be+1])be=2*be+1;else return ue[3*be+2];return 0}}Ae._INSTANCE=null;function Ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function xe(G,oe){if(G===0)return 0;const ue=st(G,oe);if(ue!==void 0)return ue;const me=T(oe,G);return G-=Ke(me),G}e.getLeftDeleteOffset=xe;function st(G,oe){let ue=T(oe,G);for(G-=Ke(ue);ht(ue)||ue===65039||ue===8419;){if(G===0)return;ue=T(oe,G),G-=Ke(ue)}if(!!J(ue)){if(G>=0){const me=T(oe,G);me===8205&&(G-=Ke(me))}return G}}function Ke(G){return G>=65536?2:1}function ht(G){return 127995<=G&&G<=127999}var et;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={}))}),define(Z[82],x([0,1,25]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(y){return D(y,0)}e.hash=L;function D(y,I){switch(typeof y){case"object":return y===null?M(349,I):Array.isArray(y)?h(y,I):d(y,I);case"string":return b(y,I);case"boolean":return P(y,I);case"number":return M(y,I);case"undefined":return M(937,I);default:return M(617,I)}}e.doHash=D;function M(y,I){return(I<<5)-I+y|0}e.numberHash=M;function P(y,I){return M(y?433:863,I)}function b(y,I){I=M(149417,I);for(let c=0,o=y.length;c<o;c++)I=M(y.charCodeAt(c),I);return I}e.stringHash=b;function h(y,I){return I=M(104579,I),y.reduce((c,o)=>D(o,c),I)}function d(y,I){return I=M(181387,I),Object.keys(y).sort().reduce((c,o)=>(c=b(o,c),D(y[o],c)),I)}class i{constructor(){this._value=0}get value(){return this._value}hash(I){return this._value=D(I,this._value),this._value}}e.Hasher=i;var S;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function m(y,I,c=32){const o=c-I,u=~((1<<o)-1);return(y<<I|(u&y)>>>o)>>>0}function p(y,I=0,c=y.byteLength,o=0){for(let u=0;u<c;u++)y[I+u]=o}function t(y,I,c="0"){for(;y.length<I;)y=c+y;return y}function g(y,I=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((y>>>0).toString(16),I/4)}e.toHexString=g;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(I){const c=I.length;if(c===0)return;const o=this._buff;let u=this._buffLen,n=this._leftoverHighSurrogate,a,s;for(n!==0?(a=n,s=-1,n=0):(a=I.charCodeAt(0),s=0);;){let r=a;if(v.isHighSurrogate(a))if(s+1<c){const l=I.charCodeAt(s+1);v.isLowSurrogate(l)?(s++,r=v.computeCodePoint(a,l)):r=65533}else{n=a;break}else v.isLowSurrogate(a)&&(r=65533);if(u=this._push(o,u,r),s++,s<c)a=I.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=n}_push(I,c,o){return o<128?I[c++]=o:o<2048?(I[c++]=192|(o&1984)>>>6,I[c++]=128|(o&63)>>>0):o<65536?(I[c++]=224|(o&61440)>>>12,I[c++]=128|(o&4032)>>>6,I[c++]=128|(o&63)>>>0):(I[c++]=240|(o&1835008)>>>18,I[c++]=128|(o&258048)>>>12,I[c++]=128|(o&4032)>>>6,I[c++]=128|(o&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,I[0]=I[64+0],I[1]=I[64+1],I[2]=I[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const I=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(I/4294967296),!1),this._buffDV.setUint32(60,I%4294967296,!1),this._step()}_step(){const I=E._bigBlock32,c=this._buffDV;for(let w=0;w<64;w+=4)I.setUint32(w,c.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)I.setUint32(w,m(I.getUint32(w-12,!1)^I.getUint32(w-32,!1)^I.getUint32(w-56,!1)^I.getUint32(w-64,!1),1),!1);let o=this._h0,u=this._h1,n=this._h2,a=this._h3,s=this._h4,r,l,f;for(let w=0;w<80;w++)w<20?(r=u&n|~u&a,l=1518500249):w<40?(r=u^n^a,l=1859775393):w<60?(r=u&n|u&a|n&a,l=2400959708):(r=u^n^a,l=3395469782),f=m(o,5)+r+s+l+I.getUint32(w*4,!1)&4294967295,s=a,a=n,n=m(u,30),u=o,o=f;this._h0=this._h0+o&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))});var Et=this&&this.__classPrivateFieldSet||function(j,e,v,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(j,v):D?D.value=v:e.set(j,v),v},He=this&&this.__classPrivateFieldGet||function(j,e,v,L){if(v==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!L:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?L:v==="a"?L.call(j):L?L.value:e.get(j)};define(Z[40],x([0,1,31,25]),function(j,e,v,L){"use strict";var D,M,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(s,r,l){let f=s.get(r);return f===void 0&&(f=l,s.set(r,f)),f}e.getOrSet=b;function h(s){const r=[];return s.forEach((l,f)=>{r.push(`${f} => ${l}`)}),`Map(${s.size}) {${r.join(", ")}}`}e.mapToString=h;function d(s){const r=[];return s.forEach(l=>{r.push(l)}),`Set(${s.size}) {${r.join(", ")}}`}e.setToString=d;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const l=r.charCodeAt(0),f=this._value.charCodeAt(this._pos);return l-f}value(){return this._value[this._pos]}}e.StringIterator=i;class S{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class m{constructor(r=!0,l=!0){this._splitOnBackslash=r,this._caseSensitive=l}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var p;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(p||(p={}));class t{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(E||(E={}));class y{constructor(r){this._iter=r}static forUris(r=()=>!1){return new y(new t(r))}static forPaths(){return new y(new m)}static forStrings(){return new y(new i)}static forConfigKeys(){return new y(new S)}clear(){this._root=void 0}fill(r,l){if(l){const f=l.slice(0);(0,v.shuffle)(f);for(let w of f)this.set(w,r)}else{const f=r.slice(0);(0,v.shuffle)(f);for(let w of f)this.set(w[0],w[1])}}set(r,l){const f=this._iter.reset(r);let w;this._root||(this._root=new g,this._root.segment=f.value());const k=[];for(w=this._root;;){const A=f.cmp(w.segment);if(A>0)w.left||(w.left=new g,w.left.segment=f.value()),k.push([-1,w]),w=w.left;else if(A<0)w.right||(w.right=new g,w.right.segment=f.value()),k.push([1,w]),w=w.right;else if(f.hasNext())f.next(),w.mid||(w.mid=new g,w.mid.segment=f.value()),k.push([0,w]),w=w.mid;else break}const R=w.value;w.value=l,w.key=r;for(let A=k.length-1;A>=0;A--){const F=k[A][1];F.updateHeight();const H=F.balanceFactor();if(H<-1||H>1){const te=k[A][0],se=k[A+1][0];if(te===1&&se===1)k[A][1]=F.rotateLeft();else if(te===-1&&se===-1)k[A][1]=F.rotateRight();else if(te===1&&se===-1)F.right=k[A+1][1]=k[A+1][1].rotateRight(),k[A][1]=F.rotateLeft();else if(te===-1&&se===1)F.left=k[A+1][1]=k[A+1][1].rotateLeft(),k[A][1]=F.rotateRight();else throw new Error;if(A>0)switch(k[A-1][0]){case-1:k[A-1][1].left=k[A][1];break;case 1:k[A-1][1].right=k[A][1];break;case 0:k[A-1][1].mid=k[A][1];break}else this._root=k[0][1]}}return R}get(r){return this._getNode(r)?.value}_getNode(r){const l=this._iter.reset(r);let f=this._root;for(;f;){const w=l.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(l.hasNext())l.next(),f=f.mid;else break}return f}has(r){const l=this._getNode(r);return!(l?.value===void 0&&l?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,l){const f=this._iter.reset(r),w=[];let k=this._root;for(;k;){const R=f.cmp(k.segment);if(R>0)w.push([-1,k]),k=k.left;else if(R<0)w.push([1,k]),k=k.right;else if(f.hasNext())f.next(),w.push([0,k]),k=k.mid;else break}if(!!k){if(l?(k.left=void 0,k.mid=void 0,k.right=void 0,k.height=1):(k.key=void 0,k.value=void 0),!k.mid&&!k.value)if(k.left&&k.right){const R=this._min(k.right),{key:A,value:F,segment:H}=R;this._delete(R.key,!1),k.key=A,k.value=F,k.segment=H}else{const R=k.left??k.right;if(w.length>0){const[A,F]=w[w.length-1];switch(A){case-1:F.left=R;break;case 0:F.mid=R;break;case 1:F.right=R;break}}else this._root=R}for(let R=w.length-1;R>=0;R--){const A=w[R][1];A.updateHeight();const F=A.balanceFactor();if(F>1?(A.right.balanceFactor()>=0||(A.right=w[R+1][1]=w[R+1][1].rotateRight()),w[R][1]=A.rotateLeft()):F<-1&&(A.left.balanceFactor()<=0||(A.left=w[R+1][1]=w[R+1][1].rotateLeft()),w[R][1]=A.rotateRight()),R>0)switch(w[R-1][0]){case-1:w[R-1][1].left=w[R][1];break;case 1:w[R-1][1].right=w[R][1];break;case 0:w[R-1][1].mid=w[R][1];break}else this._root=w[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const l=this._iter.reset(r);let f=this._root,w;for(;f;){const k=l.cmp(f.segment);if(k>0)f=f.left;else if(k<0)f=f.right;else if(l.hasNext())l.next(),w=f.value||w,f=f.mid;else break}return f&&f.value||w}findSuperstr(r){const l=this._iter.reset(r);let f=this._root;for(;f;){const w=l.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(l.hasNext())l.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(r){for(const[l,f]of this)r(f,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=l=>{if(!l)return!0;const f=l.balanceFactor();return f<-1||f>1?!1:r(l.left)&&r(l.right)};return r(this._root)}}e.TernarySearchTree=y;class I{constructor(r,l){this.uri=r,this.value=l}}class c{constructor(r,l){this[D]="ResourceMap",r instanceof c?(this.map=new Map(r.map),this.toKey=l??c.defaultToKey):(this.map=new Map,this.toKey=r??c.defaultToKey)}set(r,l){return this.map.set(this.toKey(r),new I(r,l)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,l){typeof l!="undefined"&&(r=r.bind(l));for(let[f,w]of this.map)r(w.value,w.uri,this)}*values(){for(let r of this.map.values())yield r.value}*keys(){for(let r of this.map.values())yield r.uri}*entries(){for(let r of this.map.values())yield[r.uri,r.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=c,c.defaultToKey=s=>s.toString();var o;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class u{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,l=0){const f=this._map.get(r);if(!!f)return l!==0&&this.touch(f,l),f.value}set(r,l,f=0){let w=this._map.get(r);if(w)w.value=l,f!==0&&this.touch(w,f);else{switch(w={key:r,value:l,next:void 0,previous:void 0},f){case 0:this.addItemLast(w);break;case 1:this.addItemFirst(w);break;case 2:this.addItemLast(w);break;default:this.addItemLast(w);break}this._map.set(r,w),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const l=this._map.get(r);if(!!l)return this._map.delete(r),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,l){const f=this._state;let w=this._head;for(;w;){if(l?r.bind(l)(w.value,w.key,this):r(w.value,w.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const r=this,l=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.key,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return w}values(){const r=this,l=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.value,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return w}entries(){const r=this,l=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:[f.key,f.value],done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return w}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let l=this._head,f=this.size;for(;l&&f>r;)this._map.delete(l.key),l=l.next,f--;this._head=l,this._size=f,l&&(l.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const l=r.next,f=r.previous;if(!l||!f)throw new Error("Invalid list");l.previous=f,f.next=l}r.next=void 0,r.previous=void 0,this._state++}touch(r,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(r===this._head)return;const f=r.next,w=r.previous;r===this._tail?(w.next=void 0,this._tail=w):(f.previous=w,w.next=f),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(l===2){if(r===this._tail)return;const f=r.next,w=r.previous;r===this._head?(f.previous=void 0,this._head=f):(f.previous=w,w.next=f),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((l,f)=>{r.push([f,l])}),r}fromJSON(r){this.clear();for(const[l,f]of r)this.set(l,f)}}e.LinkedMap=u;class n extends u{constructor(r,l=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,l=2){return super.get(r,l)}peek(r){return super.get(r,0)}set(r,l){return super.set(r,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class a{constructor(r){P.set(this,void 0),Et(this,P,r,"f")}get size(){return He(this,P,"f").size}forEach(r,l){He(this,P,"f").forEach(r,l)}get(r){return He(this,P,"f").get(r)}has(r){return He(this,P,"f").has(r)}entries(){return He(this,P,"f").entries()}keys(){return He(this,P,"f").keys()}values(){return He(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return He(this,P,"f").entries()}}e.ReadonlyMapView=a}),define(Z[70],x([0,1,40]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new v.LRUCache(1e4);function D(d){return h(d,"NFC",L)}e.normalizeNFC=D;const M=new v.LRUCache(1e4);function P(d){return h(d,"NFD",M)}e.normalizeNFD=P;const b=/[^\u0000-\u0080]/;function h(d,i,S){if(!d)return d;const m=S.get(d);if(m)return m;let p;return b.test(d)?p=d.normalize(i):p=d,S.set(d,p),p}e.removeAccents=function(){const d=/[\u0300-\u036f]/g;return function(i){return P(i).replace(d,"")}}()}),define(Z[14],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(k){return Array.isArray(k)}e.isArray=v;function L(k){return typeof k=="string"}e.isString=L;function D(k){return Array.isArray(k)&&k.every(R=>L(R))}e.isStringArray=D;function M(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.isObject=M;function P(k){return typeof k=="number"&&!isNaN(k)}e.isNumber=P;function b(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.isIterable=b;function h(k){return k===!0||k===!1}e.isBoolean=h;function d(k){return typeof k=="undefined"}e.isUndefined=d;function i(k){return!S(k)}e.isDefined=i;function S(k){return d(k)||k===null}e.isUndefinedOrNull=S;function m(k,R){if(!k)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=m;function p(k){if(S(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.assertIsDefined=p;function t(...k){const R=[];for(let A=0;A<k.length;A++){const F=k[A];if(S(F))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);R.push(F)}return R}e.assertAllDefined=t;const g=Object.prototype.hasOwnProperty;function E(k){if(!M(k))return!1;for(let R in k)if(g.call(k,R))return!1;return!0}e.isEmptyObject=E;function y(k){return typeof k=="function"}e.isFunction=y;function I(...k){return k.length>0&&k.every(y)}e.areFunctions=I;function c(k,R){const A=Math.min(k.length,R.length);for(let F=0;F<A;F++)o(k[F],R[F])}e.validateConstraints=c;function o(k,R){if(L(R)){if(typeof k!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(y(R)){try{if(k instanceof R)return}catch{}if(!S(k)&&k.constructor===R||R.length===1&&R.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function u(k){let R=[],A=Object.getPrototypeOf(k);for(;Object.prototype!==A;)R=R.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return R}e.getAllPropertyNames=u;function n(k){const R=[];for(const A of u(k))typeof k[A]=="function"&&R.push(A);return R}e.getAllMethodNames=n;function a(k,R){const A=H=>function(){const te=Array.prototype.slice.call(arguments,0);return R(H,te)};let F={};for(const H of k)F[H]=A(H);return F}e.createProxyObject=a;function s(k){return k===null?void 0:k}e.withNullAsUndefined=s;function r(k){return typeof k=="undefined"?null:k}e.withUndefinedAsNull=r;function l(k){return class{constructor(){return new Proxy({},{get(R,A){if(R[A])return R[A];throw new Error(`Not Implemented: ${k}->${String(A)}`)}})}}}e.NotImplementedProxy=l;function f(k,R="Unreachable"){throw new Error(R)}e.assertNever=f;function w(k){return!!k&&typeof k.then=="function"&&typeof k.catch=="function"}e.isPromise=w}),define(Z[33],x([0,1,8,3,25,14]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(s){return s===47||s===92}e.isPathSeparator=P;function b(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=b;function h(s){return s.indexOf("/")===-1&&(s=b(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=h;function d(s,r=v.posix.sep){if(!s)return"";const l=s.length,f=s.charCodeAt(0);if(P(f)){if(P(s.charCodeAt(1))&&!P(s.charCodeAt(2))){let k=3;const R=k;for(;k<l&&!P(s.charCodeAt(k));k++);if(R!==k&&!P(s.charCodeAt(k+1))){for(k+=1;k<l;k++)if(P(s.charCodeAt(k)))return s.slice(0,k+1).replace(/[\\/]/g,r)}}return r}else if(y(f)&&s.charCodeAt(1)===58)return P(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let w=s.indexOf("://");if(w!==-1){for(w+=3;w<l;w++)if(P(s.charCodeAt(w)))return s.slice(0,w+1)}return""}e.getRoot=d;function i(s){if(!L.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let l=2;const f=l;for(;l<s.length&&(r=s.charCodeAt(l),r!==92);l++);return!(f===l||(r=s.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=i;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,r=L.isWindows){const l=r?S:m;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||r&&p.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function g(s,r,l){const f=s===r;return!l||f?f:!s||!r?!1:(0,D.equalsIgnoreCase)(s,r)}e.isEqual=g;function E(s,r,l,f=v.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(l){if(!(0,D.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let k=r.length;return r.charAt(r.length-1)===f&&k--,s.charAt(k)===f}return r.charAt(r.length-1)!==f&&(r+=f),s.indexOf(r)===0}e.isEqualOrParent=E;function y(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=y;function I(s,r){return L.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(r,s)),s=(0,v.normalize)(s),L.isWindows?(s=(0,D.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,D.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=I;function c(s){const r=(0,v.normalize)(s);return L.isWindows?s.length>3?!1:o(r)&&(s.length===2||r.charCodeAt(2)===92):r===v.posix.sep}e.isRootOrDriveLetter=c;function o(s){return L.isWindows?y(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function u(s){return o(s)?s[0]:void 0}e.getDriveLetter=u;function n(s,r,l){return r.length>s.length?-1:s===r?0:(l&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=n;function a(s){const r=s.split(":");let l,f,w;if(r.forEach(k=>{const R=Number(k);(0,M.isNumber)(R)?f===void 0?f=R:w===void 0&&(w=R):l=l?[l,k].join(":"):k}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:f!==void 0?f:void 0,column:w!==void 0?w:f!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(Z[43],x([0,1,14]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const E=Array.isArray(g)?[]:{};return Object.keys(g).forEach(y=>{g[y]&&typeof g[y]=="object"?E[y]=L(g[y]):E[y]=g[y]}),E}e.deepClone=L;function D(g){if(!g||typeof g!="object")return g;const E=[g];for(;E.length>0;){const y=E.shift();Object.freeze(y);for(const I in y)if(M.call(y,I)){const c=y[I];typeof c=="object"&&!Object.isFrozen(c)&&E.push(c)}}return g}e.deepFreeze=D;const M=Object.prototype.hasOwnProperty;function P(g,E){return b(g,E,new Set)}e.cloneAndChange=P;function b(g,E,y){if((0,v.isUndefinedOrNull)(g))return g;const I=E(g);if(typeof I!="undefined")return I;if((0,v.isArray)(g)){const c=[];for(const o of g)c.push(b(o,E,y));return c}if((0,v.isObject)(g)){if(y.has(g))throw new Error("Cannot clone recursive data-structure");y.add(g);const c={};for(let o in g)M.call(g,o)&&(c[o]=b(g[o],E,y));return y.delete(g),c}return g}function h(g,E,y=!0){return(0,v.isObject)(g)?((0,v.isObject)(E)&&Object.keys(E).forEach(I=>{I in g?y&&((0,v.isObject)(g[I])&&(0,v.isObject)(E[I])?h(g[I],E[I],y):g[I]=E[I]):g[I]=E[I]}),g):E}e.mixin=h;function d(g,E){if(g===E)return!0;if(g==null||E===null||E===void 0||typeof g!=typeof E||typeof g!="object"||Array.isArray(g)!==Array.isArray(E))return!1;let y,I;if(Array.isArray(g)){if(g.length!==E.length)return!1;for(y=0;y<g.length;y++)if(!d(g[y],E[y]))return!1}else{const c=[];for(I in g)c.push(I);c.sort();const o=[];for(I in E)o.push(I);if(o.sort(),!d(c,o))return!1;for(y=0;y<c.length;y++)if(!d(g[c[y]],E[c[y]]))return!1}return!0}e.equals=d;function i(g){const E=new Set;return JSON.stringify(g,(y,I)=>{if((0,v.isObject)(I)||Array.isArray(I)){if(E.has(I))return"[Circular]";E.add(I)}return I})}e.safeStringify=i;function S(g,E,y){const I=E(g);return typeof I=="undefined"?y:I}e.getOrDefault=S;function m(g,E){const y=Object.create(null);return!g||!E||Object.keys(E).forEach(c=>{const o=g[c],u=E[c];d(o,u)||(y[c]=u)}),y}e.distinct=m;function p(g,E){const y=E.toLowerCase(),I=Object.keys(g).find(c=>c.toLowerCase()===y);return I?g[I]:g[E]}e.getCaseInsensitive=p;function t(g,E){const y=Object.create(null);for(const I of Object.keys(g))E(I,g[I])&&(y[I]=g[I]);return y}e.filter=t}),define(Z[7],x([0,1,8,3]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,M=/^\//,P=/^\/\//;function b(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!M.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(s,r){return!s&&!r?"file":s}function d(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==S&&(r=S+r):r=S;break}return r}const i="",S="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(r,l,f,w,k,R=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=h(r,R),this.authority=l||i,this.path=d(this.scheme,f||i),this.query=w||i,this.fragment=k||i,b(this,R))}static isUri(r){return r instanceof p?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return c(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:f,path:w,query:k,fragment:R}=r;return l===void 0?l=this.scheme:l===null&&(l=i),f===void 0?f=this.authority:f===null&&(f=i),w===void 0?w=this.path:w===null&&(w=i),k===void 0?k=this.query:k===null&&(k=i),R===void 0?R=this.fragment:R===null&&(R=i),l===this.scheme&&f===this.authority&&w===this.path&&k===this.query&&R===this.fragment?this:new g(l,f,w,k,R)}static parse(r,l=!1){const f=m.exec(r);return f?new g(f[2]||i,a(f[4]||i),a(f[5]||i),a(f[7]||i),a(f[9]||i),l):new g(i,i,i,i,i)}static file(r){let l=i;if(L.isWindows&&(r=r.replace(/\\/g,S)),r[0]===S&&r[1]===S){const f=r.indexOf(S,2);f===-1?(l=r.substring(2),r=S):(l=r.substring(2,f),r=r.substring(f)||S)}return new g("file",l,r,i,i)}static from(r){const l=new g(r.scheme,r.authority,r.path,r.query,r.fragment);return b(l,!0),l}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return L.isWindows&&r.scheme==="file"?f=p.file(v.win32.join(c(r,!0),...l)).path:f=v.posix.join(r.path,...l),r.with({path:f})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof p)return r;{const l=new g(r);return l._formatted=r.external,l._fsPath=r._sep===t?r.fsPath:null,l}}else return r}}e.URI=p;const t=L.isWindows?1:void 0;class g extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=t),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(s,r){let l,f=-1;for(let w=0;w<s.length;w++){const k=s.charCodeAt(w);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||r&&k===47)f!==-1&&(l+=encodeURIComponent(s.substring(f,w)),f=-1),l!==void 0&&(l+=s.charAt(w));else{l===void 0&&(l=s.substr(0,w));const R=E[k];R!==void 0?(f!==-1&&(l+=encodeURIComponent(s.substring(f,w)),f=-1),l+=R):f===-1&&(f=w)}}return f!==-1&&(l+=encodeURIComponent(s.substring(f))),l!==void 0?l:s}function I(s){let r;for(let l=0;l<s.length;l++){const f=s.charCodeAt(l);f===35||f===63?(r===void 0&&(r=s.substr(0,l)),r+=E[f]):r!==void 0&&(r+=s[l])}return r!==void 0?r:s}function c(s,r){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=c;function o(s,r){const l=r?I:y;let f="",{scheme:w,authority:k,path:R,query:A,fragment:F}=s;if(w&&(f+=w,f+=":"),(k||w==="file")&&(f+=S,f+=S),k){let H=k.indexOf("@");if(H!==-1){const te=k.substr(0,H);k=k.substr(H+1),H=te.indexOf(":"),H===-1?f+=l(te,!1):(f+=l(te.substr(0,H),!1),f+=":",f+=l(te.substr(H+1),!1)),f+="@"}k=k.toLowerCase(),H=k.indexOf(":"),H===-1?f+=l(k,!1):(f+=l(k.substr(0,H),!1),f+=k.substr(H))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const H=R.charCodeAt(1);H>=65&&H<=90&&(R=`/${String.fromCharCode(H+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const H=R.charCodeAt(0);H>=65&&H<=90&&(R=`${String.fromCharCode(H+32)}:${R.substr(2)}`)}f+=l(R,!0)}return A&&(f+="?",f+=l(A,!1)),F&&(f+="#",f+=r?F:y(F,!1)),f}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(s){return s.match(n)?s.replace(n,r=>u(r)):s}}),define(Z[110],x([0,1,7]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(d){const i=d;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function D(d){const i=[];let S;try{const m=JSON.parse(d.arguments),p=m[m.length-1];p&&p.__$stack&&(m.pop(),S=p.__$stack),i.push(...m)}catch(m){i.push("Unable to log remote console arguments",d.arguments)}return{args:i,stack:S}}e.parse=D;function M(d){if(typeof d!="string")return M(D(d).stack);const i=d;if(i){const S=P(i),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(m&&m.length===4)return{uri:v.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=M;function P(d){if(!d)return d;const i=d.indexOf(`
`);return i===-1?d:d.substring(0,i)}function b(d,i){const{args:S,stack:m}=D(d),p=typeof S[0]=="string"&&S.length===1;let t=P(m);t&&(t=`(${t.trim()})`);let g=[];if(typeof S[0]=="string"?t&&p?g=[`%c[${i}] %c${S[0]} %c${t}`,h("blue"),h(""),h("grey")]:g=[`%c[${i}] %c${S[0]}`,h("blue"),h(""),...S.slice(1)]:g=[`%c[${i}]%`,h("blue"),...S],t&&!p&&g.push(t),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,g)}e.log=b;function h(d){return`color: ${d}`}}),define(Z[111],x([0,1,17,25,7]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(i){return JSON.stringify(i,h)}e.stringify=M;function P(i){let S=JSON.parse(i);return S=d(S),S}e.parse=P;var b;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(b=e.MarshalledId||(e.MarshalledId={}));function h(i,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,L.regExpFlags)(S)}:S}function d(i,S=0){if(!i||S>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof v.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let m=0;m<i.length;++m)i[m]=d(i[m],S+1);else for(const m in i)Object.hasOwnProperty.call(i,m)&&(i[m]=d(i[m],S+1))}return i}e.revive=d}),define(Z[10],x([0,1,3,7]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.userData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}set(h,d,i){this._hosts[h]=d,this._ports[h]=i}setConnectionToken(h,d){this._connectionTokens[h]=d}rewrite(h){if(this._delegate)return this._delegate(h);const d=h.authority;let i=this._hosts[d];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const S=this._ports[d],m=this._connectionTokens[d];let p=`path=${encodeURIComponent(h.path)}`;return typeof m=="string"&&(p+=`&tkn=${encodeURIComponent(m)}`),L.URI.from({scheme:v.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${S}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new M;class P{asBrowserUri(h,d){const i=this.toUri(h,d);return i.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===D.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${D.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?i.with({scheme:D.vscodeFileResource,authority:i.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(h,d){const i=this.toUri(h,d);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==P.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(h,d){return L.URI.isUri(h)?h:L.URI.parse(d.toUrl(h))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(Z[15],x([0,1,33,10,8,3,25,7]),function(j,e,v,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(p){return(0,b.uriToFsPath)(p,!0)}e.originalFSPath=h;class d{constructor(t){this._ignorePathCasing=t}compare(t,g,E=!1){return t===g?0:(0,P.compare)(this.getComparisonKey(t,E),this.getComparisonKey(g,E))}isEqual(t,g,E=!1){return t===g?!0:!t||!g?!1:this.getComparisonKey(t,E)===this.getComparisonKey(g,E)}getComparisonKey(t,g=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,g,E=!1){if(t.scheme===g.scheme){if(t.scheme===L.Schemas.file)return v.isEqualOrParent(h(t),h(g),this._ignorePathCasing(t))&&t.query===g.query&&(E||t.fragment===g.fragment);if((0,e.isEqualAuthority)(t.authority,g.authority))return v.isEqualOrParent(t.path,g.path,this._ignorePathCasing(t),"/")&&t.query===g.query&&(E||t.fragment===g.fragment)}return!1}joinPath(t,...g){return b.URI.joinPath(t,...g)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let g;return t.scheme===L.Schemas.file?g=b.URI.file(D.dirname(h(t))).path:(g=D.posix.dirname(t.path),t.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),g="/")),t.with({path:g})}normalizePath(t){if(!t.path.length)return t;let g;return t.scheme===L.Schemas.file?g=b.URI.file(D.normalize(h(t))).path:g=D.posix.normalize(t.path),t.with({path:g})}relativePath(t,g){if(t.scheme!==g.scheme||!(0,e.isEqualAuthority)(t.authority,g.authority))return;if(t.scheme===L.Schemas.file){const I=D.relative(h(t),h(g));return M.isWindows?v.toSlashes(I):I}let E=t.path||"/",y=g.path||"/";if(this._ignorePathCasing(t)){let I=0;for(const c=Math.min(E.length,y.length);I<c&&!(E.charCodeAt(I)!==y.charCodeAt(I)&&E.charAt(I).toLowerCase()!==y.charAt(I).toLowerCase());I++);E=y.substr(0,I)+E.substr(I)}return D.posix.relative(E,y)}resolvePath(t,g){if(t.scheme===L.Schemas.file){const E=b.URI.file(D.resolve(h(t),g));return t.with({authority:E.authority,path:E.path})}return g=v.toPosixPath(g),t.with({path:D.posix.resolve(t.path,g)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,g){return t===g||(0,P.equalsIgnoreCase)(t,g)}hasTrailingPathSeparator(t,g=D.sep){if(t.scheme===L.Schemas.file){const E=h(t);return E.length>v.getRoot(E).length&&E[E.length-1]===g}else{const E=t.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,g=D.sep){return(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,g=D.sep){let E=!1;if(t.scheme===L.Schemas.file){const y=h(t);E=y!==void 0&&y.length===v.getRoot(y).length&&y[y.length-1]===g}else{g="/";const y=t.path;E=y.length===1&&y.charCodeAt(y.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path+"/"}):t}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(p=>p.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new d(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,t){const g=[];for(let E=0;E<p.length;E++){const y=t(p[E]);p.some((I,c)=>c===E?!1:(0,e.isEqualOrParent)(y,t(I)))||g.push(p[E])}return g}e.distinctParents=i;var S;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function t(g){const E=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[o,u]=c.split(":");o&&u&&E.set(o,u)});const I=g.path.substring(0,g.path.indexOf(";"));return I&&E.set(p.META_DATA_MIME,I),E}p.parseMetaData=t})(S=e.DataUri||(e.DataUri={}));function m(p,t,g){if(t){let E=p.path;return E&&E[0]!==D.posix.sep&&(E=D.posix.sep+E),p.with({scheme:g,authority:t,path:E})}return p.with({scheme:g})}e.toLocalResource=m}),define(Z[9],x([0,1,23,16,4,2,15]),function(j,e,v,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(V){return!!V&&typeof V.then=="function"}e.isThenable=b;function h(V){const _=new v.CancellationTokenSource,U=V(_.token),C=new Promise((X,W)=>{const z=_.token.onCancellationRequested(()=>{z.dispose(),_.dispose(),W((0,L.canceled)())});Promise.resolve(U).then(K=>{z.dispose(),_.dispose(),X(K)},K=>{z.dispose(),_.dispose(),W(K)})});return new class{cancel(){_.cancel()}then(X,W){return C.then(X,W)}catch(X){return this.then(void 0,X)}finally(X){return C.finally(X)}}}e.createCancelablePromise=h;function d(V,_,U){return Promise.race([V,new Promise(C=>_.onCancellationRequested(()=>C(U)))])}e.raceCancellation=d;async function i(V){let _=-1;const U=V.map((X,W)=>X.then(z=>(_=W,z))),C=await Promise.race(U);return V.forEach((X,W)=>{W!==_&&X.cancel()}),C}e.raceCancellablePromises=i;function S(V,_,U){let C;const X=setTimeout(()=>{C?.(void 0),U?.()},_);return Promise.race([V.finally(()=>clearTimeout(X)),new Promise(W=>C=W)])}e.raceTimeout=S;function m(V){return new Promise((_,U)=>{const C=V();b(C)?C.then(_,U):_(C)})}e.asPromise=m;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const C=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,C};this.queuedPromise=new Promise(C=>{this.activePromise.then(U,U).then(C)})}return new Promise((U,C)=>{this.queuedPromise.then(U,C)})}return this.activePromise=_(),new Promise((U,C)=>{this.activePromise.then(X=>{this.activePromise=null,U(X)},X=>{this.activePromise=null,C(X)})})}}e.Throttler=p;class t{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=t;class g{constructor(){this.promiseMap=new Map}queue(_,U){const X=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(_)===X&&this.promiseMap.delete(_)});return this.promiseMap.set(_,X),X}}e.SequencerByKey=g;class E{constructor(_){this.defaultDelay=_,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,U=this.defaultDelay){return this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((C,X)=>{this.doResolve=C,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const C=this.task;return this.task=null,C()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=E;class y{constructor(_){this.delayer=new E(_),this.throttler=new p}trigger(_,U){return this.delayer.trigger(()=>this.throttler.queue(_),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class I{constructor(){this._isOpen=!1,this._promise=new Promise((_,U)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class c extends I{constructor(_){super();this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function o(V,_){return _?new Promise((U,C)=>{const X=setTimeout(()=>{W.dispose(),U()},V),W=_.onCancellationRequested(()=>{clearTimeout(X),W.dispose(),C((0,L.canceled)())})}):h(U=>o(V,U))}e.timeout=o;function u(V,_=0){const U=setTimeout(V,_);return(0,M.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=u;function n(V){const _=[];let U=0;const C=V.length;function X(){return U<C?V[U++]():null}function W(z){z!=null&&_.push(z);const K=X();return K?K.then(W):Promise.resolve(_)}return Promise.resolve(null).then(W)}e.sequence=n;function a(V,_=C=>!!C,U=null){let C=0;const X=V.length,W=()=>{if(C>=X)return Promise.resolve(U);const z=V[C++];return Promise.resolve(z()).then(O=>_(O)?Promise.resolve(O):W())};return W()}e.first=a;function s(V,_=C=>!!C,U=null){if(V.length===0)return Promise.resolve(U);let C=V.length;const X=()=>{C=-1;for(const W of V)W.cancel?.()};return new Promise((W,z)=>{for(const K of V)K.then(O=>{--C>=0&&_(O)?(X(),W(O)):C===0&&W(U)}).catch(O=>{--C>=0&&(X(),z(O))})})}e.firstParallel=s;class r{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(_){return this._size++,new Promise((U,C)=>{this.outstandingPromises.push({factory:_,c:U,e:C}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const U=_.factory();U.then(_.c,_.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class l extends r{constructor(){super(1)}}e.Queue=l;class f{constructor(){this.queues=new Map}queueFor(_,U=P.extUri){const C=U.getComparisonKey(_);let X=this.queues.get(C);return X||(X=new l,D.Event.once(X.onFinished)(()=>{X?.dispose(),this.queues.delete(C)}),this.queues.set(C,X)),X}dispose(){this.queues.forEach(_=>_.dispose()),this.queues.clear()}}e.ResourceQueue=f;class w{constructor(_,U){this._token=-1,typeof _=="function"&&typeof U=="number"&&this.setIfNotSet(_,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},U)}setIfNotSet(_,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},U))}}e.TimeoutTimer=w;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setInterval(()=>{_()},U)}}e.IntervalTimer=k;class R{constructor(_,U){this.timeoutToken=-1,this.runner=_,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class A{constructor(_,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class F extends R{constructor(_,U){super(_,U);this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner&&this.runner(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class H extends M.Disposable{constructor(_,U,C,X){super();this.maxWorkChunkSize=_,this.maxPendingWork=U,this.throttleDelay=C,this.handler=X,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.maxPendingWork)return!1}else if(this.pending+_.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{const _=setTimeout(()=>{const C=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0,clearTimeout(_))}}}:e.runWhenIdle=(V,_)=>{const U=requestIdleCallback(V,typeof _=="number"?{timeout:_}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(U))}}}}();class te{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=te;async function se(V,_,U){let C;for(let X=0;X<U;X++)try{return await V()}catch(W){C=W,await o(_)}throw C}e.retry=se;class le{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(_,U,C){return this._pending={taskId:_,cancel:()=>C?.(),promise:U},U.then(()=>this.donePending(_),()=>this.donePending(_)),U}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let U,C;const X=new Promise((W,z)=>{U=W,C=z});this._next={run:_,promise:X,promiseResolve:U,promiseReject:C}}return this._next.promise}}e.TaskSequentializer=le;class Y{constructor(_){this.interval=_,this.lastIncrementTime=0,this.value=0}increment(){const _=Date.now();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;class T{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,U)=>{this.completeCallback=_,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(U=>{this.completeCallback(_),this.resolved=!0,U()})}error(_){return new Promise(U=>{this.errorCallback(_),this.rejected=!0,U()})}cancel(){new Promise(_=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,_()})}}e.DeferredPromise=T;var B;(function(V){async function _(C){let X;const W=await Promise.all(C.map(z=>z.then(K=>K,K=>{X||(X=K)})));if(typeof X!="undefined")throw X;return W}V.settled=_;function U(C){return new Promise(async(X,W)=>{try{await C(X,W)}catch(z){W(z)}})}V.withAsyncBody=U})(B=e.Promises||(e.Promises={}))}),define(Z[34],x([0,1,33,10,8,3,15,25,7]),function(j,e,v,L,D,M,P,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function d(r,l,f){if(typeof r=="string"&&(r=h.URI.file(r)),f){const k=f.getWorkspaceFolder(r);if(k){const R=f.getWorkspace().folders.length>1;let A;if((0,P.isEqual)(k.uri,r)?A="":A=(0,P.relativePath)(k.uri,r),R){const F=k.name?k.name:(0,P.basename)(k.uri);A=A?F+" \u2022 "+A:F}return A}}if(r.scheme!==L.Schemas.file&&r.scheme!==L.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(r.fsPath))return(0,D.normalize)(S(r.fsPath));let w=(0,D.normalize)(r.fsPath);return!M.isWindows&&l?.userHome&&(w=p(w,l.userHome.fsPath)),w}e.getPathLabel=d;function i(r){if(!r)return;typeof r=="string"&&(r=h.URI.file(r));const l=(0,P.basename)(r)||(r.scheme===L.Schemas.file?r.fsPath:r.path);return M.isWindows&&(0,v.isRootOrDriveLetter)(l)?S(l):l}e.getBaseLabel=i;function S(r){return(0,v.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=S;let m=Object.create(null);function p(r,l){if(M.isWindows||!r||!l)return r;let f=m.original===l?m.normalized:void 0;return f||(f=`${(0,b.rtrim)(l,D.posix.sep)}${D.posix.sep}`,m={original:l,normalized:f}),(M.isLinux?r.startsWith(f):(0,b.startsWithIgnoreCase)(r,f))&&(r=`~/${r.substr(f.length)}`),r}e.tildify=p;function t(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=t;const g="\u2026",E="\\\\",y="~";function I(r,l=D.sep){const f=new Array(r.length);let w=!1;for(let k=0;k<r.length;k++){let R=r[k];if(R===""){f[k]=`.${l}`;continue}if(!R){f[k]=R;continue}w=!0;let A="";R.indexOf(E)===0?(A=R.substr(0,R.indexOf(E)+E.length),R=R.substr(R.indexOf(E)+E.length)):R.indexOf(l)===0?(A=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(y)===0&&(A=R.substr(0,R.indexOf(y)+y.length),R=R.substr(R.indexOf(y)+y.length));const F=R.split(l);for(let H=1;w&&H<=F.length;H++)for(let te=F.length-H;w&&te>=0;te--){w=!1;let se=F.slice(te,te+H).join(l);for(let le=0;!w&&le<r.length;le++)if(le!==k&&r[le]&&r[le].indexOf(se)>-1){const Y=te+H===F.length,T=te>0&&r[le].indexOf(l)>-1?l+se:se,B=r[le].endsWith(T);w=!Y||B}if(!w){let le="";(F[0].endsWith(":")||A!=="")&&(te===1&&(te=0,H++,se=F[0]+l+se),te>0&&(le=F[0]+l),le=A+le),te>0&&(le=le+g+l),le=le+se,te+H<F.length&&(le=le+l+g),f[k]=le}}w&&(f[k]=R)}return f}e.shorten=I;var c;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function o(r,l=Object.create(null)){const f=[];let w=!1,k="";for(const R of r)if(R==="$"||w&&R==="{")k&&f.push({value:k,type:c.TEXT}),k="",w=!0;else if(R==="}"&&w){const A=l[k];if(typeof A=="string")A.length&&f.push({value:A,type:c.VARIABLE});else if(A){const F=f[f.length-1];(!F||F.type!==c.SEPARATOR)&&f.push({value:A.label,type:c.SEPARATOR})}k="",w=!1}else k+=R;return k&&!w&&f.push({value:k,type:c.TEXT}),f.filter((R,A)=>{if(R.type===c.SEPARATOR){const F=f[A-1],H=f[A+1];return[F,H].every(te=>te&&(te.type===c.VARIABLE||te.type===c.TEXT)&&te.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function u(r,l){return M.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function n(r,l){return M.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,f=>f==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function a(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=a;function s(r){const l=r.indexOf("/")!==-1?D.posix:D.win32,f=l.basename(r),w=l.dirname(r);return f.length?{name:f,parentPath:w}:{name:w,parentPath:""}}e.splitName=s}),define(Z[112],x([0,1,7]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class D{constructor(S){this._uriTransformer=S}transformIncoming(S){const m=this._uriTransformer.transformIncoming(S);return m===S?S:L(v.URI.from(m))}transformOutgoing(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:L(v.URI.from(m))}transformOutgoingURI(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:v.URI.from(m)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function M(i,S,m){if(!i||m>200)return null;if(typeof i=="object"){if(i instanceof v.URI)return S.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const t=M(i[p],S,m+1);t!==null&&(i[p]=t)}}return null}function P(i,S){const m=M(i,S,0);return m===null?i:m}e.transformOutgoingURIs=P;function b(i,S,m,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return m?v.URI.revive(S.transformIncoming(i)):S.transformIncoming(i);for(let t in i)if(Object.hasOwnProperty.call(i,t)){const g=b(i[t],S,m,p+1);g!==null&&(i[t]=g)}}return null}function h(i,S){const m=b(i,S,!1,0);return m===null?i:m}e.transformIncomingURIs=h;function d(i,S){const m=b(i,S,!0,0);return m===null?i:m}e.transformAndReviveIncomingURIs=d}),define(Z[28],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(h){return v.test(h)}e.isUUID=L;const D=new Uint8Array(16),M=[];for(let h=0;h<256;h++)M.push(h.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(h){for(let d=0;d<h.length;d++)h[d]=Math.floor(Math.random()*256);return h};function b(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let h=0,d="";return d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d+="-",d+=M[D[h++]],d+=M[D[h++]],d+="-",d+=M[D[h++]],d+=M[D[h++]],d+="-",d+=M[D[h++]],d+=M[D[h++]],d+="-",d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d}e.generateUuid=b}),define(Z[113],x([0,1,61,29,42]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(P,b){if(await new Promise((i,S)=>{const m=L.createReadStream(P),p=v.createHash("sha1");m.pipe(p);const t=(0,D.once)((g,E)=>{m.removeAllListeners(),p.removeAllListeners(),g?S(g):i(E)});m.once("error",t),m.once("end",t),p.once("error",t),p.once("data",g=>t(void 0,g.toString("hex")))})!==b)throw new Error("Hash mismatch")}e.checksum=M}),define(Z[114],x([0,1,243]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new v.StringDecoder(M),this.remaining=null}write(M){const P=[],b=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(b.length<1)return P;let h=0,d,i=h;for(;i<b.length;)if(d=b.charCodeAt(i),d===13||d===10){if(P.push(b.substring(h,i)),i++,i<b.length){const S=d;d=b.charCodeAt(i),(S===13&&d===10||S===10&&d===13)&&i++}h=i}else i++;return this.remaining=h<b.length?b.substr(h):null,P}end(){return this.remaining}}e.LineDecoder=L}),define(Z[115],x([0,1,26]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(b){const h=b.replace(/\-/g,":").toLowerCase();return!L.has(h)}function M(){return new Promise(async(b,h)=>{const d=setTimeout(()=>h("Unable to retrieve mac address (timeout after 10s)"),1e4);try{b(await P())}catch(i){h(i)}finally{clearTimeout(d)}})}e.getMac=M;function P(){return new Promise((b,h)=>{try{const d=(0,v.networkInterfaces)();for(let i in d){const S=d[i];if(S){for(const{mac:m}of S)if(D(m))return b(m)}}h("Unable to retrieve mac address (unexpected format)")}catch(d){h(d)}})}}),define(Z[71],x([0,1,26,16,40,28,115]),function(j,e,v,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,S=0;const m=(0,v.networkInterfaces)();for(let p in m){const t=m[p];if(t)for(const{mac:g,internal:E}of t)E||(S+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(i+=1))}this._value=S>0?i/S:0}return this._value}};let b;async function h(){return b||(b=(async()=>await d()||M.generateUuid())()),b}e.getMachineId=h;async function d(){try{const i=await new Promise((m,p)=>{j(["crypto"],m,p)}),S=await(0,P.getMac)();return i.createHash("sha256").update(S,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Z[20],x([0,1,29,26,116,9,33,70,8,3,15,7,28]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function t(T,B=p.UNLINK){if((0,P.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");return B===p.UNLINK?E(T):g(T)}async function g(T){try{const B=(0,h.join)((0,L.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(T,B)}catch(V){return E(T)}E(B).catch(V=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function E(T){return e.Promises.rmdir(T,{recursive:!0,maxRetries:3})}function y(T){if((0,P.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(T,{recursive:!0})}e.rimrafSync=y;async function I(T,B){return u(await(B?c(T):(0,D.promisify)(v.readdir)(T)))}async function c(T){try{return await(0,D.promisify)(v.readdir)(T,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const B=[],V=await I(T);for(const _ of V){let U=!1,C=!1,X=!1;try{const W=await e.Promises.lstat((0,h.join)(T,_));U=W.isFile(),C=W.isDirectory(),X=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}B.push({name:_,isFile:()=>U,isDirectory:()=>C,isSymbolicLink:()=>X})}return B}function o(T){return u(v.readdirSync(T))}e.readdirSync=o;function u(T){return T.map(B=>typeof B=="string"?d.isMacintosh?(0,b.normalizeNFC)(B):B:(B.name=d.isMacintosh?(0,b.normalizeNFC)(B.name):B.name,B))}async function n(T){const B=await I(T),V=[];for(const _ of B)await s.existsDirectory((0,h.join)(T,_))&&V.push(_);return V}function a(T,B=1e3){return new Promise(V=>{let _=!1;const U=setInterval(()=>{_||(_=!0,v.access(T,C=>{_=!1,C&&(clearInterval(U),V(void 0))}))},B)})}e.whenDeleted=a;var s;(function(T){async function B(U){let C;try{if(C=await e.Promises.lstat(U),!C.isSymbolicLink())return{stat:C}}catch(X){}try{return{stat:await e.Promises.stat(U),symbolicLink:C?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&C)return{stat:C,symbolicLink:{dangling:!0}};if(d.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&C)return{stat:C,symbolicLink:{dangling:!0}};throw W}throw X}}T.stat=B;async function V(U){try{const{stat:C,symbolicLink:X}=await T.stat(U);return C.isFile()&&X?.dangling!==!0}catch(C){}return!1}T.existsFile=V;async function _(U){try{const{stat:C,symbolicLink:X}=await T.stat(U);return C.isDirectory()&&X?.dangling!==!0}catch(C){}return!1}T.existsDirectory=_})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new M.ResourceQueue;function l(T,B,V){return r.queueFor(S.URI.file(T),i.extUriBiasedIgnorePathCase).queue(()=>{const _=R(V);return new Promise((U,C)=>w(T,B,_,X=>X?C(X):U()))})}let f=!0;function w(T,B,V,_){if(!f)return v.writeFile(T,B,{mode:V.mode,flag:V.flag},_);v.open(T,V.flag,V.mode,(U,C)=>{if(U)return _(U);v.writeFile(C,B,X=>{if(X)return v.close(C,()=>_(X));v.fdatasync(C,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),f=!1),v.close(C,z=>_(z))))})})}function k(T,B,V){const _=R(V);if(!f)return v.writeFileSync(T,B,{mode:_.mode,flag:_.flag});const U=v.openSync(T,_.flag,_.mode);try{v.writeFileSync(U,B);try{v.fdatasyncSync(U)}catch(C){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",C),f=!1}}finally{v.closeSync(U)}}e.writeFileSync=k;function R(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function A(T,B){if(T===B)return;async function V(_){try{const U=await e.Promises.lstat(_);if(U.isDirectory()||U.isSymbolicLink())return;await e.Promises.utimes(_,U.atime,new Date)}catch(U){}}try{await e.Promises.rename(T,B),await V(B)}catch(_){if(T.toLowerCase()!==B.toLowerCase()&&_.code==="EXDEV"||T.endsWith("."))await F(T,B,{preserveSymlinks:!1}),await t(T,p.MOVE),await V(B);else throw _}}async function F(T,B,V){return te(T,B,{root:{source:T,target:B},options:V,handledSourcePaths:new Set})}const H=511;async function te(T,B,V){if(V.handledSourcePaths.has(T))return;V.handledSourcePaths.add(T);const{stat:_,symbolicLink:U}=await s.stat(T);if(U){if(V.options.preserveSymlinks)try{return await Y(T,B,V)}catch(C){console.warn("[node.js fs] copy of symlink failed: ",C)}if(U.dangling)return}return _.isDirectory()?se(T,B,_.mode&H,V):le(T,B,_.mode&H)}async function se(T,B,V,_){await e.Promises.mkdir(B,{recursive:!0,mode:V});const U=await I(T);for(const C of U)await te((0,h.join)(T,C),(0,h.join)(B,C),_)}async function le(T,B,V){await e.Promises.copyFile(T,B),await e.Promises.chmod(B,V)}async function Y(T,B,V){let _=await e.Promises.readlink(T);(0,P.isEqualOrParent)(_,V.root.source,!d.isLinux)&&(_=(0,h.join)(V.root.target,_.substr(V.root.source.length+1))),await e.Promises.symlink(_,B)}e.Promises=new class{get access(){return(0,D.promisify)(v.access)}get stat(){return(0,D.promisify)(v.stat)}get lstat(){return(0,D.promisify)(v.lstat)}get utimes(){return(0,D.promisify)(v.utimes)}get read(){return(0,D.promisify)(v.read)}get readFile(){return(0,D.promisify)(v.readFile)}get write(){return(0,D.promisify)(v.write)}get appendFile(){return(0,D.promisify)(v.appendFile)}get fdatasync(){return(0,D.promisify)(v.fdatasync)}get truncate(){return(0,D.promisify)(v.truncate)}get rename(){return(0,D.promisify)(v.rename)}get copyFile(){return(0,D.promisify)(v.copyFile)}get open(){return(0,D.promisify)(v.open)}get close(){return(0,D.promisify)(v.close)}get symlink(){return(0,D.promisify)(v.symlink)}get readlink(){return(0,D.promisify)(v.readlink)}get chmod(){return(0,D.promisify)(v.chmod)}get mkdir(){return(0,D.promisify)(v.mkdir)}get unlink(){return(0,D.promisify)(v.unlink)}get rmdir(){return(0,D.promisify)(v.rmdir)}get realpath(){return(0,D.promisify)(v.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return n}get writeFile(){return l}get rm(){return t}get move(){return A}get copy(){return F}}}),define(Z[83],x([0,1,29,8,25,20]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(i){const S=(0,L.dirname)(i);if(i===S)return i;const m=((0,L.basename)(i)||i).toLowerCase();try{const t=(0,M.readdirSync)(S).filter(g=>g.toLowerCase()===m);if(t.length===1){const g=P(S);if(g)return(0,L.join)(g,t[0])}else if(t.length>1){const g=t.indexOf(m);if(g>=0){const E=P(S);if(E)return(0,L.join)(E,t[g])}}}catch(p){}return null}e.realcaseSync=P;async function b(i){try{return await M.Promises.realpath(i)}catch(S){const m=d(i);return await M.Promises.access(m,v.constants.R_OK),m}}e.realpath=b;function h(i){try{return v.realpathSync(i)}catch(S){const m=d(i);return v.accessSync(m,v.constants.R_OK),m}}e.realpathSync=h;function d(i){return(0,D.rtrim)((0,L.normalize)(i),L.sep)}}),define(Z[117],x([0,1,62]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(b,h,d,i=1){let S=!1;return new Promise(m=>{const p=setTimeout(()=>{if(!S)return S=!0,m(0)},d);D(b,h,i,t=>{if(!S)return S=!0,clearTimeout(p),m(t)})})}e.findFreePort=L;function D(b,h,d,i){if(h===0)return i(0);const S=new v.Socket;S.once("connect",()=>(P(S),D(b+d,h-1,d,i))),S.once("data",()=>{}),S.once("error",m=>(P(S),m.code!=="ECONNREFUSED"?D(b+d,h-1,d,i):i(b))),S.connect(b,"127.0.0.1")}function M(b,h,d){let i=!1,S,m=1;const p=v.createServer({pauseOnConnect:!0});function t(g,E){i||(i=!0,p.removeAllListeners(),p.close(),S&&clearTimeout(S),E(g))}return new Promise(g=>{S=setTimeout(()=>{t(0,g)},d),p.on("listening",()=>{t(b,g)}),p.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&m<h?(b++,m++,p.listen(b,"127.0.0.1")):t(0,g)}),p.on("close",()=>{t(0,g)}),p.listen(b,"127.0.0.1")})}e.findFreePortFaster=M;function P(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(h){console.error(h)}}}),define(Z[118],x([0,1,26,8,20]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,P=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var h;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(h||(h={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class S{constructor(u,n,a){this.exePath=u,this.displayName=n,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:o=!1,findPreview:u=!1}={}){const n=m({useAlternateBitness:o});if(!n)return null;const a=L.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(a))return null;let s=-1,r=null;for(const w of await D.Promises.readdir(a)){let k=-1;if(u){const A=w.indexOf("-");if(A<0)continue;const F=w.substring(0,A);if(!M.test(F)||w.substring(A+1)!=="preview")continue;k=parseInt(F,10)}else{if(!M.test(w))continue;k=parseInt(w,10)}if(k<=s)continue;const R=L.join(a,w,"pwsh.exe");!await D.SymlinkSupport.existsFile(R)||(r=R,s=k)}if(!r)return null;const l=n.includes("x86")?" (x86)":"",f=u?" Preview":"";return new S(r,`PowerShell${f}${l}`,!0)}async function t({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:n,pwshMsixName:a}=o?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(u))if(n.test(s)){const r=L.join(u,s,"pwsh.exe");return new S(r,a)}return null}function g(){const o=L.join(v.homedir(),".dotnet","tools","pwsh.exe");return new S(o,".NET Core PowerShell Global Tool")}function E(){const o=L.join(process.env.windir,d===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(o,"Windows PowerShell",!0)}async function*y(){let o=await p();o&&(yield o),o=await p({useAlternateBitness:!0}),o&&(yield o),o=await t(),o&&(yield o),o=g(),o&&(yield o),o=await p({findPreview:!0}),o&&(yield o),o=await t({findPreview:!0}),o&&(yield o),o=await p({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=E(),o&&(yield o)}async function*I(){for await(const o of y())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=I;async function c(){for await(const o of I())return o;return null}e.getFirstAvailablePowerShellInstallation=c}),define(Z[84],x([0,1,44,10]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(P){return new Promise((b,h)=>{let d;const i=new Map;function S(p,t,g,E,y){const I=i.get(t);if(p===P||I){const c={name:m(g),cmd:g,pid:p,ppid:t,load:E,mem:y};i.set(p,c),p===P&&(d=c),I&&(I.children||(I.children=[]),I.children.push(c),I.children.length>1&&(I.children=I.children.sort((o,u)=>o.pid-u.pid)))}}function m(p){const t=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,y=/\\pipe\\winpty-control/,I=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(g.exec(p))return"watcherService ";if(E.exec(p))return"electron-crash-reporter";if(y.exec(p))return"winpty-process";if(I.exec(p))return"console-window-host (Windows internal process)";let o=c.exec(p);if(o&&o.length===2)return o[1]==="renderer"?t.exec(p)?"shared-process":"window":o[1];const u=/[a-zA-Z-]+\.js/g;let n="";do o=u.exec(p),o&&(n+=o+" ");while(o);return n&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${n}`:p}if(process.platform==="win32"){const p=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,g)=>{j(["windows-process-tree"],t,g)}).then(t=>{t.getProcessList(P,g=>{t.getProcessCpuUsage(g,E=>{const y=new Map;E.forEach(I=>{const c=p(I.commandLine||"");y.set(I.pid,{name:m(c),cmd:c,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),d=y.get(P),d?(y.forEach(I=>{const c=y.get(I.ppid);c&&(c.children||(c.children=[]),c.children.push(I))}),y.forEach(I=>{I.children&&(I.children=I.children.sort((c,o)=>c.pid-o.pid))}),b(d)):h(new Error(`Root process ${P} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let p=function(){let t=[d];const g=[];for(;t.length;){const y=t.shift();y&&(g.push(y.pid),y.children&&(t=t.concat(y.children)))}let E=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);E+=" "+g.join(" "),(0,v.exec)(E,{},(y,I,c)=>{if(y||c)h(y||new Error(c.toString()));else{const o=I.toString().split(`
`);for(let u=0;u<g.length;u++){const n=i.get(g[u]);n.load=parseFloat(o[u])}if(!d){h(new Error(`Root process ${P} not found`));return}b(d)}})};(0,v.exec)("which ps",{},(t,g,E)=>{if(t||E)if(process.platform!=="linux")h(t||new Error(E.toString()));else{const y=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,v.exec)(y,{},(I,c,o)=>{I||o?h(I||new Error(o.toString())):(M(c,S),p())})}else{const y=g.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${y} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,o,u)=>{c||u&&!u.includes("screen size is bogus")?h(c||new Error(u.toString())):(M(o,S),process.platform==="linux"?p():d?b(d):h(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=D;function M(P,b){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=P.toString().split(`
`);for(const i of d){const S=h.exec(i.trim());S&&S.length===6&&b(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(Z[119],x([0,1,29,23,33,2,70,8,3,20]),function(j,e,v,L,D,M,P,b,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(t,g,E){return m({path:t,isDirectory:!1},g,E)}e.watchFile=i;function S(t,g,E){return m({path:t,isDirectory:!0},g,E)}e.watchFolder=S,e.CHANGE_BUFFER_DELAY=100;function m(t,g,E){if(h.isMacintosh&&(0,D.isEqualOrParent)(t.path,"/Volumes/"))return E(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const y=(0,b.basename)(t.path),I=new Map;let c=!1,o=[(0,M.toDisposable)(()=>{I.forEach(u=>(0,M.dispose)(u)),I.clear()})];try{const u=(0,v.watch)(t.path);o.push((0,M.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const n=new Set;t.isDirectory&&d.Promises.readdir(t.path).then(a=>a.forEach(s=>n.add(s))),u.on("error",(a,s)=>{c||E(`Failed to watch ${t.path} for changes using fs.watch() (${a}, ${s})`)}),u.on("change",(a,s)=>{if(c)return;let r="";if(s&&(r=s.toString(),h.isMacintosh&&(r=(0,P.normalizeNFC)(r))),!r||a!=="change"&&a!=="rename")return;const l=t.isDirectory?(0,b.join)(t.path,r):t.path;if(t.isDirectory)if(a==="rename"){const f=I.get(l);f&&(0,M.dispose)(f);const w=setTimeout(async()=>{I.delete(l);const k=await d.Promises.exists(l);if(c)return;let R;k?n.has(r)?R="changed":(R="added",n.add(r)):(n.delete(r),R="deleted"),g(R,l)},e.CHANGE_BUFFER_DELAY);I.set(l,(0,M.toDisposable)(()=>clearTimeout(w)))}else{let f;n.has(r)?f="changed":(f="added",n.add(r)),g(f,l)}else if(a==="rename"||r!==y){const f=setTimeout(async()=>{const w=await d.Promises.exists(l);c||(w?(g("changed",l),o=[m(t,g,E)]):g("deleted",l))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(o),o=[(0,M.toDisposable)(()=>clearTimeout(f))]}else g("changed",l)})}catch(u){d.Promises.exists(t.path).then(n=>{n&&!c&&E(`Failed to watch ${t.path} for changes using fs.watch() (${u.toString()})`)})}return(0,M.toDisposable)(()=>{c=!0,o=(0,M.dispose)(o)})}async function p(t,g,E,y=512){const I=await d.Promises.open(t,"r"),c=Buffer.allocUnsafe(y),o=new L.CancellationTokenSource(E);let u,n=!1;const a=i(t,async s=>{if(s==="changed"){if(n)return;n=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:r}=await d.Promises.read(I,c,0,y,null);if(!r||o.token.isCancellationRequested)break;g(c.slice(0,r))}}catch(r){u=new Error(r),o.dispose(!0)}finally{n=!1}}},s=>{u=new Error(s),o.dispose(!0)});return new Promise((s,r)=>{o.token.onCancellationRequested(async()=>{a.dispose(),await d.Promises.close(I),u?r(u):s()})})}e.watchFileContents=p}),define(Z[120],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[121],x([0,1,13,14,120]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){v.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(b,h,d,i,S)=>{const m=P(b,i,d);m.popup({window:(0,L.withNullAsUndefined)(v.BrowserWindow.fromWebContents(b.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{m&&b.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=M;function P(b,h,d){const i=new v.Menu;return d.forEach(S=>{let m;S.type==="separator"?m=new v.MenuItem({type:S.type}):Array.isArray(S.submenu)?m=new v.MenuItem({submenu:P(b,h,S.submenu),label:S.label}):m=new v.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(p,t,g)=>b.sender.send(h,S.id,g)}),i.append(m)}),i}});var he=this&&this.__decorate||function(j,e,v,L){var D=arguments.length,M=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,v):L,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(j,e,v,L);else for(var b=j.length-1;b>=0;b--)(P=j[b])&&(M=(D<3?P(M):D>3?P(e,v,M):P(e,v))||M);return D>3&&M&&Object.defineProperty(e,v,M),M};define(Z[35],x([0,1,31,9,17,23,47,16,4,2,111,25,14]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function t(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function E(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(y||(y={}));class I{constructor(C){this.buffer=C,this.pos=0}read(C){const X=this.buffer.slice(this.pos,this.pos+C);return this.pos+=X.byteLength,X}}class c{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(C){this.buffers.push(C)}}var o;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(o||(o={}));function u(U){const C=D.VSBuffer.alloc(4);return C.writeUInt32BE(U,0),C}function n(U){return U.read(4).readUInt32BE(0)}function a(U){const C=D.VSBuffer.alloc(1);return C.writeUInt8(U,0),C}const s={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object)},r=typeof Buffer!="undefined";function l(U,C){if(typeof C=="undefined")U.write(s.Undefined);else if(typeof C=="string"){const X=D.VSBuffer.fromString(C);U.write(s.String),U.write(u(X.byteLength)),U.write(X)}else if(r&&Buffer.isBuffer(C)){const X=D.VSBuffer.wrap(C);U.write(s.Buffer),U.write(u(X.byteLength)),U.write(X)}else if(C instanceof D.VSBuffer)U.write(s.VSBuffer),U.write(u(C.byteLength)),U.write(C);else if(Array.isArray(C)){U.write(s.Array),U.write(u(C.length));for(const X of C)l(U,X)}else{const X=D.VSBuffer.fromString(JSON.stringify(C));U.write(s.Object),U.write(u(X.byteLength)),U.write(X)}}function f(U){switch(U.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return U.read(n(U)).toString();case o.Buffer:return U.read(n(U)).buffer;case o.VSBuffer:return U.read(n(U));case o.Array:{const X=n(U),W=[];for(let z=0;z<X;z++)W.push(f(U));return W}case o.Object:return JSON.parse(U.read(n(U)).toString())}}class w{constructor(C,X,W=null,z=1e3){this.protocol=C,this.ctx=X,this.logger=W,this.timeoutDelay=z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(C,X){this.channels.set(C,X),setTimeout(()=>this.flushPendingRequests(C),0)}sendResponse(C){switch(C.type){case 200:{const X=this.send([C.type]);this.logger&&this.logger.logOutgoing(X,0,1,E(C.type));return}case 201:case 202:case 204:case 203:{const X=this.send([C.type,C.id],C.data);this.logger&&this.logger.logOutgoing(X,C.id,1,E(C.type),C.data);return}}}send(C,X=void 0){const W=new c;return l(W,C),l(W,X),this.sendBuffer(W.buffer)}sendBuffer(C){try{return this.protocol.send(C),C.byteLength}catch(X){return 0}}onRawMessage(C){const X=new I(C),W=f(X),z=f(X),K=W[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(C.byteLength,W[1],1,`${t(K)}: ${W[2]}.${W[3]}`,z),this.onPromise({type:K,id:W[1],channelName:W[2],name:W[3],arg:z});case 102:return this.logger&&this.logger.logIncoming(C.byteLength,W[1],1,`${t(K)}: ${W[2]}.${W[3]}`,z),this.onEventListen({type:K,id:W[1],channelName:W[2],name:W[3],arg:z});case 101:return this.logger&&this.logger.logIncoming(C.byteLength,W[1],1,`${t(K)}`),this.disposeActiveRequest({type:K,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(C.byteLength,W[1],1,`${t(K)}`),this.disposeActiveRequest({type:K,id:W[1]})}}onPromise(C){const X=this.channels.get(C.channelName);if(!X){this.collectPendingRequest(C);return}const W=new M.CancellationTokenSource;let z;try{z=X.call(this.ctx,C.name,C.arg,W.token)}catch(q){z=Promise.reject(q)}const K=C.id;z.then(q=>{this.sendResponse({id:K,data:q,type:201}),this.activeRequests.delete(C.id)},q=>{q instanceof Error?this.sendResponse({id:K,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:K,data:q,type:203}),this.activeRequests.delete(C.id)});const O=(0,d.toDisposable)(()=>W.cancel());this.activeRequests.set(C.id,O)}onEventListen(C){const X=this.channels.get(C.channelName);if(!X){this.collectPendingRequest(C);return}const W=C.id,K=X.listen(this.ctx,C.name,C.arg)(O=>this.sendResponse({id:W,data:O,type:204}));this.activeRequests.set(C.id,K)}disposeActiveRequest(C){const X=this.activeRequests.get(C.id);X&&(X.dispose(),this.activeRequests.delete(C.id))}collectPendingRequest(C){let X=this.pendingRequests.get(C.channelName);X||(X=[],this.pendingRequests.set(C.channelName,X));const W=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.sendResponse({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:C,timeoutTimer:W})}flushPendingRequests(C){const X=this.pendingRequests.get(C);if(X){for(const W of X)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(C)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(C=>C.dispose()),this.activeRequests.clear()}}e.ChannelServer=w;var k;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(C,X=null){this.protocol=C,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=X}getChannel(C){const X=this;return{call(W,z,K){return X.isDisposed?Promise.reject(b.canceled()):X.requestPromise(C,W,z,K)},listen(W,z){return X.isDisposed?Promise.reject(b.canceled()):X.requestEvent(C,W,z)}}}requestPromise(C,X,W,z=M.CancellationToken.None){const K=this.lastRequestId++,q={id:K,type:100,channelName:C,name:X,arg:W};if(z.isCancellationRequested)return Promise.reject(b.canceled());let N;return new Promise((J,Q)=>{if(z.isCancellationRequested)return Q(b.canceled());const ne=()=>{const ce=fe=>{switch(fe.type){case 201:this.handlers.delete(K),J(fe.data);break;case 202:this.handlers.delete(K);const de=new Error(fe.data.message);de.stack=fe.data.stack,de.name=fe.data.name,Q(de);break;case 203:this.handlers.delete(K),Q(fe.data);break}};this.handlers.set(K,ce),this.sendRequest(q)};let ae=null;this.state===y.Idle?ne():(ae=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),ae.then(()=>{ae=null,ne()}));const ie=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:K,type:101}),Q(b.canceled())},re=z.onCancellationRequested(ie);N=(0,d.combinedDisposable)((0,d.toDisposable)(ie),re),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(C,X,W){const z=this.lastRequestId++,O={id:z,type:102,channelName:C,name:X,arg:W};let q=null;const N=new h.Emitter({onFirstListenerAdd:()=>{q=(0,L.createCancelablePromise)(J=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(N),this.sendRequest(O)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(N),this.sendRequest({id:z,type:103}))}}),$=J=>N.fire(J.data);return this.handlers.set(z,$),N.event}sendRequest(C){switch(C.type){case 100:case 102:{const X=this.send([C.type,C.id,C.channelName,C.name],C.arg);this.logger&&this.logger.logOutgoing(X,C.id,0,`${t(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const X=this.send([C.type,C.id]);this.logger&&this.logger.logOutgoing(X,C.id,0,t(C.type));return}}}send(C,X=void 0){const W=new c;return l(W,C),l(W,X),this.sendBuffer(W.buffer)}sendBuffer(C){try{return this.protocol.send(C),C.byteLength}catch(X){return 0}}onBuffer(C){const X=new I(C),W=f(X),z=f(X),K=W[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(C.byteLength,0,0,E(K)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(C.byteLength,W[1],0,E(K),z),this.onResponse({type:W[0],id:W[1],data:z})}}onResponse(C){if(C.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(C.id);X&&X(C)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(C=>C.dispose()),this.activeRequests.clear()}}he([P.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class A{constructor(C){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,C(({protocol:X,onDidClientDisconnect:W})=>{h.Event.once(X.onMessage)(K=>{const O=new I(K),q=f(O),N=new w(X,q),$=new R(X);this.channels.forEach((Q,ne)=>N.registerChannel(ne,Q));const J={channelServer:N,channelClient:$,ctx:q};this._connections.add(J),this._onDidAddConnection.fire(J),W(()=>{N.dispose(),$.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const C=[];return this._connections.forEach(X=>C.push(X)),C}getChannel(C,X){const W=this;return{call(z,K,O){let q;if((0,m.isFunction)(X)){let $=(0,v.getRandomElement)(W.connections.filter(X));q=$?Promise.resolve($):h.Event.toPromise(h.Event.filter(W.onDidAddConnection,X))}else q=X.routeCall(W,z,K);const N=q.then($=>$.channelClient.getChannel(C));return H(N).call(z,K,O)},listen(z,K){if((0,m.isFunction)(X))return W.getMulticastEvent(C,X,z,K);const O=X.routeEvent(W,z,K).then(q=>q.channelClient.getChannel(C));return H(O).listen(z,K)}}}getMulticastEvent(C,X,W,z){const K=this;let O=new d.DisposableStore;const q=new h.Emitter({onFirstListenerAdd:()=>{O=new d.DisposableStore;const N=new h.EventMultiplexer,$=new Map,J=ne=>{const ie=ne.channelClient.getChannel(C).listen(W,z),re=N.add(ie);$.set(ne,re)},Q=ne=>{const ae=$.get(ne);!ae||(ae.dispose(),$.delete(ne))};K.connections.filter(X).forEach(J),h.Event.filter(K.onDidAddConnection,X)(J,void 0,O),K.onDidRemoveConnection(Q,void 0,O),N.event(q.fire,q,O),O.add(N)},onLastListenerRemove:()=>{O.dispose()}});return q.event}registerChannel(C,X){this.channels.set(C,X),this._connections.forEach(W=>{W.channelServer.registerChannel(C,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class F{constructor(C,X,W=null){const z=new c;l(z,X),C.send(z.buffer),this.channelClient=new R(C,W),this.channelServer=new w(C,X,W)}getChannel(C){return this.channelClient.getChannel(C)}registerChannel(C,X){this.channelServer.registerChannel(C,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function H(U){return{call(C,X,W){return U.then(z=>z.call(C,X,W))},listen(C,X){const W=new h.Relay;return U.then(z=>W.input=z.listen(C,X)),W.event}}}e.getDelayedChannel=H;function te(U){let C=!1;return{call(X,W,z){return C?U.call(X,W,z):(0,L.timeout)(0).then(()=>C=!0).then(()=>U.call(X,W,z))},listen(X,W){if(C)return U.listen(X,W);const z=new h.Relay;return(0,L.timeout)(0).then(()=>C=!0).then(()=>z.input=U.listen(X,W)),z.event}}}e.getNextTickChannel=te;class se{constructor(C){this.fn=C}routeCall(C){return this.route(C)}routeEvent(C){return this.route(C)}async route(C){for(const X of C.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await h.Event.toPromise(C.onDidAddConnection),await this.route(C)}}e.StaticRouter=se;var le;(function(U){function C(K,O){const q=K,N=O&&O.disableMarshalling,$=new Map;for(const J in q)W(J)&&$.set(J,h.Event.buffer(q[J],!0));return new class{listen(J,Q,ne){const ae=$.get(Q);if(ae)return ae;if(z(Q)){const ie=q[Q];if(typeof ie=="function")return ie.call(q,ne)}throw new Error(`Event not found: ${Q}`)}call(J,Q,ne){const ae=q[Q];if(typeof ae=="function"){if(!N&&Array.isArray(ne))for(let ie=0;ie<ne.length;ie++)ne[ie]=(0,i.revive)(ne[ie]);return ae.apply(q,ne)}throw new Error(`Method not found: ${Q}`)}}}U.fromService=C;function X(K,O){const q=O&&O.disableMarshalling;return new Proxy({},{get(N,$){if(typeof $=="string")return O?.properties?.has($)?O.properties.get($):z($)?function(J){return K.listen($,J)}:W($)?K.listen($):async function(...J){let Q;O&&!(0,m.isUndefinedOrNull)(O.context)?Q=[O.context,...J]:Q=J;const ne=await K.call($,Q);return q?ne:(0,i.revive)(ne)};throw new Error(`Property not found: ${String($)}`)}})}U.toService=X;function W(K){return K[0]==="o"&&K[1]==="n"&&S.isUpperAsciiLetter(K.charCodeAt(2))}function z(K){return/^onDynamic/.test(K)&&S.isUpperAsciiLetter(K.charCodeAt(9))}})(le=e.ProxyChannel||(e.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let C=U.toString();if(C!=="[object Object]")return C}return U}function B(U){return Array.isArray(U)?U.map(T):T(U)}function V(U,C,X,W,z,K,O){O=B(O);const q=Y[z],N=q[W%q.length];let $=[`%c[${U}]%c[${String(C).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(K)?($=$.concat(O),$.push(")")):$.push(O),console.log.apply(console,$)}e.logWithColors=V;class _{constructor(C,X){this._outgoingPrefix=C,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(C,X,W,z,K){this._totalOutgoing+=C,V(this._outgoingPrefix,this._totalOutgoing,C,X,W,z,K)}logIncoming(C,X,W,z,K){this._totalIncoming+=C,V(this._incomingPrefix,this._totalIncoming,C,X,W,z,K)}}e.IPCLogger=_}),define(Z[122],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(D,M){this.sender=D,this.onMessage=M}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Z[123],x([0,1,17,4,35]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(h){this.port=h,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",d=>v.VSBuffer.wrap(d.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class P extends D.IPCClient{constructor(h,d){const i=new M(h);super(i,d);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=P}),define(Z[85],x([0,1,17,4,2,3,32,35]),function(j,e,v,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var h;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let d=null;function i(){return d||(d=v.VSBuffer.alloc(0)),d}class S{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,l){if(r===0)return i();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return l&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let f=v.VSBuffer.alloc(r),w=0,k=0;for(;r>0;){const R=this._chunks[k];if(R.byteLength>r){const A=R.slice(0,r);f.set(A,w),w+=r,l&&(this._chunks[k]=R.slice(r),this._totalLength-=r),r-=r}else f.set(R,w),w+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):k++,r-=R.byteLength}return f}}e.ChunkStream=S;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(m||(m={}));var p;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class t{constructor(r,l,f,w){this.type=r,this.id=l,this.ack=f,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends D.Disposable{constructor(r){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const f=this._state.messageType,w=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new t(f,w,k,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class E{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=v.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this._writeSoon(l,r.data)}_bufferAdd(r,l){const f=this._totalLength===0;return this._data.push(r,l),this._totalLength+=r.byteLength+l.byteLength,f}_bufferTake(){const r=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,l){this._bufferAdd(r,l)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class y extends D.Disposable{constructor(r){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new E(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new t(1,0,0,r))}}e.Protocol=y;class I extends b.IPCClient{constructor(r,l,f=null){super(r,l,f);this.protocol=r}static fromSocket(r,l){return new I(new y(r),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=I;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class o{constructor(r){this.data=r,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],l=0,f=this._first;for(;f;)r[l++]=f.data,f=f.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const l=new o(r);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class n{constructor(){this.lastRuns=[];const r=Date.now();for(let l=0;l<n._HISTORY_LENGTH;l++)this.lastRuns[l]=r-1e3*l;setInterval(()=>{for(let l=n._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const r=Date.now(),l=(1+n._HISTORY_LENGTH)*1e3;let f=0;for(let w=0;w<n._HISTORY_LENGTH;w++)r-this.lastRuns[w]<=l&&f++;return 1-f/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class a{constructor(r,l=null,f=n.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=f,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new t(5,0,0,i());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const l=new t(4,0,0,i());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,l){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let l=0,f=r.length;l<f;l++)this._socketWriter.write(r[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new t(6,0,0,i())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const l=this._outgoingUnackMsg.toArray();for(let f=0,w=l.length;f<w;f++)this._socketWriter.write(l[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new t(1,l,this._incomingAckId,r);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(r){const l=new t(2,0,0,r);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),l=Date.now()-r.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new t(3,0,this._incomingAckId,i());this._socketWriter.write(r)}}e.PersistentProtocol=a}),define(Z[124],x([0,1,13,17,4,2,35,122]),function(j,e,v,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(i,S){const m=D.Event.fromNodeEventEmitter(v.ipcMain,S,(t,g)=>({event:t,message:g})),p=D.Event.filter(m,({event:t})=>t.sender.id===i);return D.Event.map(p,({message:t})=>t&&L.VSBuffer.wrap(t))}class d extends P.IPCServer{constructor(){super(d.getOnDidClientConnect())}static getOnDidClientConnect(){const S=D.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:m})=>m);return D.Event.map(S,m=>{const p=m.id,t=d.Clients.get(p);t&&t.dispose();const g=new D.Emitter;d.Clients.set(p,(0,M.toDisposable)(()=>g.fire()));const E=h(p,"vscode:message"),y=D.Event.any(D.Event.signal(h(p,"vscode:disconnect")),g.event);return{protocol:new b.Protocol(m,E),onDidClientDisconnect:y}})}}e.Server=d,d.Clients=new Map}),define(Z[86],x([0,1,13,4,28,123]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends M.Client{constructor(d,i){super({addEventListener:(S,m)=>d.addListener(S,m),removeEventListener:(S,m)=>d.removeListener(S,m),postMessage:S=>d.postMessage(S),start:()=>d.start(),close:()=>d.close()},i)}}e.Client=P;async function b(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const d=(0,D.generateUuid)();h.webContents.send("vscode:createMessageChannel",d);const i=L.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(m,p)=>({nonce:p,port:m.ports[0]})),{port:S}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,m=>m.nonce===d)));return S}e.connect=b}),define(Z[87],x([0,1,9,4,2,14]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));function b(S){const m=S;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var h;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(h||(h={}));class d extends D.Disposable{constructor(m,p=Object.create(null)){super();this.database=m,this.options=p,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((p,t)=>this.accept(t,p)),m.deleted?.forEach(p=>this.accept(p,void 0))}accept(m,p){if(this.state===h.Closed)return;let t=!1;(0,M.isUndefinedOrNull)(p)?t=this.cache.delete(m):this.cache.get(m)!==p&&(this.cache.set(m,p),t=!0),t&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,p){const t=this.cache.get(m);return(0,M.isUndefinedOrNull)(t)?p:t}getBoolean(m,p){const t=this.get(m);return(0,M.isUndefinedOrNull)(t)?p:t==="true"}getNumber(m,p){const t=this.get(m);return(0,M.isUndefinedOrNull)(t)?p:parseInt(t,10)}async set(m,p){if(this.state===h.Closed)return;if((0,M.isUndefinedOrNull)(p))return this.delete(m);const t=String(p);if(this.cache.get(m)!==t)return this.cache.set(m,t),this.pendingInserts.set(m,t),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async delete(m){if(!(this.state===h.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((p,t)=>this.items.set(t,p)),m.delete&&m.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[125],x([0,1,9,4,40,8,20]),function(j,e,v,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class b{constructor(i,S=Object.create(null)){this.path=i,this.options=S,this.name=(0,M.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const i=await this.whenConnected,S=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(p=>S.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${S.size} rows`),S}async updateItems(i){const S=await this.whenConnected;return this.doUpdateItems(S,i)}doUpdateItems(i,S){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${S.insert?(0,D.mapToString)(S.insert):"0"}), delete(${S.delete?(0,D.setToString)(S.delete):"0"})`),this.transaction(i,()=>{const m=S.insert,p=S.delete;if(m&&m.size>0){const t=[];t.push([]);let g=0;m.forEach((E,y)=>{let I=t[g];I.length>b.MAX_HOST_PARAMETERS&&(g++,I=[],t.push(I)),I.push(y,E)}),t.forEach(E=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,y=>y.run(E),()=>{const y=[];let I=0;return m.forEach((c,o)=>{y.push(o),I+=c.length}),`Keys: ${y.join(", ")} Length: ${I}`})})}if(p&&p.size){const t=[];t.push([]);let g=0;p.forEach(E=>{let y=t[g];y.length>b.MAX_HOST_PARAMETERS&&(g++,y=[],t.push(y)),y.push(E)}),t.forEach(E=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,y=>y.run(E),()=>{const y=[];return p.forEach(I=>{y.push(I)}),`Keys: ${y.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const S=await this.whenConnected;return this.doClose(S,i)}doClose(i,S){return new Promise((m,p)=>{i.db.close(t=>(t&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${t}`),this.path===b.IN_MEMORY_PATH?m():!i.isErroneous&&!i.isInMemory?this.backup().then(m,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),m())):typeof S=="function"?P.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const E=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:S()}).then(()=>E(),y=>(E(),Promise.reject(y)))})).then(m,p):p(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return P.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const S=await this.whenConnected,m=await this.get(S,i?"PRAGMA integrity_check":"PRAGMA quick_check"),p=i?m.integrity_check:m.quick_check;return S.isErroneous?`${p} (last error: ${S.lastError})`:S.isInMemory?`${p} (in-memory!)`:p}async connect(i,S=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${S})`);try{return await this.doConnect(i)}catch(m){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${m}`),m.code==="SQLITE_BUSY"&&S)return await(0,v.timeout)(b.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await P.Promises.unlink(i);try{await P.Promises.rename(this.toBackupPath(i),i)}catch(p){}return await this.doConnect(i)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(b.IN_MEMORY_PATH)}}}handleSQLiteError(i,S){i.isErroneous=!0,i.lastError=S,this.logger.error(S)}doConnect(i){return new Promise((S,m)=>{new Promise((p,t)=>{j(["@vscode/sqlite3"],p,t)}).then(p=>{const t={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(i,g=>g?t.db?t.db.close(()=>m(g)):m(g):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>S(t),E=>t.db.close(()=>m(E)))),isInMemory:i===b.IN_MEMORY_PATH};t.db.on("error",g=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&t.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},m)})}exec(i,S){return new Promise((m,p)=>{i.db.exec(S,t=>t?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${t}`),p(t)):m())})}get(i,S){return new Promise((m,p)=>{i.db.get(S,(t,g)=>t?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${t}`),p(t)):m(g))})}all(i,S){return new Promise((m,p)=>{i.db.all(S,(t,g)=>t?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${t}`),p(t)):m(g))})}transaction(i,S){return new Promise((m,p)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),S(),i.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${t}`),p(t)):m())})})}prepare(i,S,m,p){const t=i.db.prepare(S),g=E=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${E} (${S}). Details: ${p()}`)};t.on("error",g),m(t),t.finalize(E=>{E&&g(E),t.removeListener("error",g)})}}e.SQLiteStorageDatabase=b,b.IN_MEMORY_PATH=":memory:",b.BUSY_OPEN_TIMEOUT=2e3,b.MAX_HOST_PARAMETERS=256;class h{constructor(i){i&&typeof i.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[126],x([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(Z[127],x([0,1,126]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,M=D*24,P=M*7,b=M*30,h=M*365;function d(S,m){typeof S!="number"&&(S=S.getTime());const p=Math.round((new Date().getTime()-S)/1e3);if(p<-30)return(0,v.localize)(0,null,d(new Date().getTime()+p*1e3,!1));if(p<30)return(0,v.localize)(1,null);let t;return p<L?(t=p,m?t===1?(0,v.localize)(2,null,t):(0,v.localize)(3,null,t):t===1?(0,v.localize)(4,null,t):(0,v.localize)(5,null,t)):p<D?(t=Math.floor(p/L),m?t===1?(0,v.localize)(6,null,t):(0,v.localize)(7,null,t):t===1?(0,v.localize)(8,null,t):(0,v.localize)(9,null,t)):p<M?(t=Math.floor(p/D),m?t===1?(0,v.localize)(10,null,t):(0,v.localize)(11,null,t):t===1?(0,v.localize)(12,null,t):(0,v.localize)(13,null,t)):p<P?(t=Math.floor(p/M),m?t===1?(0,v.localize)(14,null,t):(0,v.localize)(15,null,t):t===1?(0,v.localize)(16,null,t):(0,v.localize)(17,null,t)):p<b?(t=Math.floor(p/P),m?t===1?(0,v.localize)(18,null,t):(0,v.localize)(19,null,t):t===1?(0,v.localize)(20,null,t):(0,v.localize)(21,null,t)):p<h?(t=Math.floor(p/b),m?t===1?(0,v.localize)(22,null,t):(0,v.localize)(23,null,t):t===1?(0,v.localize)(24,null,t):(0,v.localize)(25,null,t)):(t=Math.floor(p/h),m?t===1?(0,v.localize)(26,null,t):(0,v.localize)(27,null,t):t===1?(0,v.localize)(28,null,t):(0,v.localize)(29,null,t))}e.fromNow=d;function i(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[128],x([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Z[45],x([0,1,31,14,128]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(d,i){return i&&(d.stack||d.stacktrace)?D.localize(0,null,b(d),P(d.stack)||P(d.stacktrace)):b(d)}function P(d){return Array.isArray(d)?d.join(`
`):d}function b(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?D.localize(1,null,d.message):d.message||D.localize(2,null)}function h(d=null,i=!1){if(!d)return D.localize(3,null);if(Array.isArray(d)){const S=v.coalesce(d),m=h(S[0],i);return S.length>1?D.localize(4,null,m,S.length):m}if(L.isString(d))return d;if(d.detail){const S=d.detail;if(S.error)return M(S.error,i);if(S.exception)return M(S.exception,i)}return d.stack?M(d,i):d.message?d.message:D.localize(5,null)}e.toErrorMessage=h}),define(Z[129],x([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Z[130],x([0,1,129]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(P,b,h=b){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=b,this.modifierLabels[3]=h}toLabel(P,b,h){if(b.length===0)return null;const d=[];for(let i=0,S=b.length;i<S;i++){const m=b[i],p=h(m);if(p===null)return null;d[i]=D(m,p,this.modifierLabels[P])}return d.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(M,P,b){if(P===null)return"";const h=[];return M.ctrlKey&&h.push(b.ctrlKey),M.shiftKey&&h.push(b.shiftKey),M.altKey&&h.push(b.altKey),M.metaKey&&h.push(b.metaKey),P!==""&&h.push(P),h.join(b.separator)}}),define(Z[131],x([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Z[72],x([0,1,44,33,10,43,8,3,32,81,14,114,20,131]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function t(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(n,a){if(b.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};a&&(s.cwd=a);const r=v.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],s);return new Promise(l=>{r.once("error",f=>{l({success:!1,error:f})}),r.once("exit",(f,w)=>{l(f===0?{success:!0}:{success:!1,code:f!==null?f:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(b.isLinux||b.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(r=>{v.execFile(s,[n.pid.toString()],{encoding:"utf8",shell:!0},(l,f,w)=>{r(l?{success:!1,error:l}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function E(n){!n||(delete n.DEBUG,b.isMacintosh&&delete n.DYLD_LIBRARY_PATH,b.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function y(n=h.env){return n.comspec||"cmd.exe"}e.getWindowsShell=y;class I{constructor(a,s,r,l){if(s!==void 0&&r!==void 0&&l!==void 0)this.cmd=a,this.args=s,this.shell=r,this.options=l;else{const f=a;this.cmd=f.command,this.shell=f.isShellCommand,this.args=f.args.slice(0),this.options=f.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const f=Object.create(null);Object.keys(h.env).forEach(w=>{f[w]=h.env[w]}),Object.keys(this.options.env).forEach(w=>{f[w]=this.options.env[w]}),this.options.env=f}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const s=a.lastIndexOf(P.sep);return s!==-1&&(a=a.substring(s+1)),I.WellKnowCommands[a]?a:"other"}start(a){return b.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(h.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(s=>{let r,l;const f=new Promise((w,k)=>{r=w,l=k});if(s){let w=this.cmd;this.args&&(w=w+" "+this.args.join(" ")),this.childProcess=v.exec(w,this.options,(k,R,A)=>{this.childProcess=null;const F=k;F&&F.killed?l({killed:this.terminateRequested,stdout:R.toString(),stderr:A.toString()}):this.handleExec(r,a,k,R,A)})}else{let w=null;const k=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,r,a,l);const A={terminated:this.terminateRequested};i.isNumber(R)&&(A.cmdCode=R),r(A)};if(this.shell&&b.isWindows){const R=M.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let A=!1,F=!1;const H=[];let te=this.ensureQuotes(this.cmd);H.push(te.value),A=te.quoted,this.args&&this.args.forEach(le=>{te=this.ensureQuotes(le),H.push(te.value),F=F&&te.quoted});const se=["/s","/c"];A?F?se.push('"'+H.join(" ")+'"'):H.length>1?se.push('"'+H[0]+'" '+H.slice(1).join(" ")):se.push('"'+H[0]+'"'):se.push(H.join(" ")),w=v.spawn(y(),se,R)}else this.cmd&&(w=v.spawn(this.cmd,this.args,this.options));w&&(this.childProcess=w,this.childProcessPromise=Promise.resolve(w),this.pidResolve&&(this.pidResolve(i.isNumber(w.pid)?w.pid:-1),this.pidResolve=void 0),w.on("error",R=>{this.childProcess=null,l({terminated:this.terminateRequested,error:R})}),w.pid&&(this.childProcess.on("close",k),this.handleSpawn(w,r,a,l,!0)))}return f})}handleClose(a,s,r,l){}ensureQuotes(a){return I.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,g(a,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!b.isWindows)return a(!1);const s=v.spawn(y(),["/s","/c"]);s.on("error",r=>a(!0)),s.on("exit",r=>a(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class c extends I{constructor(a,s,r,l){super(a,s,r,l);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,s,r,l,f){[l,f].forEach((w,k)=>{const R=new S.LineDecoder;R.write(w).forEach(H=>{s({line:H,source:k===0?0:1})});const F=R.end();F&&s({line:F,source:k===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,s,r,l,f){const w=new S.LineDecoder,k=new S.LineDecoder;a.stdout.on("data",R=>{w.write(R).forEach(F=>r({line:F,source:0}))}),a.stderr.on("data",R=>{k.write(R).forEach(F=>r({line:F,source:1}))}),this.stdoutLineDecoder=w,this.stderrLineDecoder=k}handleClose(a,s,r,l){const f=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;f&&r({line:f,source:0});const w=this.stderrLineDecoder?this.stderrLineDecoder.end():null;w&&r({line:w,source:1})}}e.LineProcess=c;function o(n){let a=[],s=!1;const r=function(l){if(s){a.push(l);return}(!n.send(l,w=>{if(w&&console.error(w),s=!1,a.length>0){const k=a.slice(0);a=[],k.forEach(R=>r(R))}})||b.isWindows)&&(s=!0)};return{send:r}}e.createQueuedSender=o;var u;(function(n){async function a(s,r,l){if(P.isAbsolute(s))return s;if(r===void 0&&(r=h.cwd()),P.dirname(s)!=="."||(l===void 0&&i.isString(h.env.PATH)&&(l=h.env.PATH.split(P.delimiter)),l===void 0||l.length===0))return P.join(r,s);async function w(k){if(await m.Promises.exists(k)){let R;try{R=await m.Promises.stat(k)}catch(A){A.message.startsWith("EACCES")&&(R=await m.Promises.lstat(k))}return R?!R.isDirectory():!1}return!1}for(let k of l){let R;if(P.isAbsolute(k)?R=P.join(k,s):R=P.join(r,k,s),await w(R))return R;let A=R+".com";if(await w(A)||(A=R+".exe",await w(A)))return A}return P.join(r,s)}n.findExecutable=a})(u=e.win32||(e.win32={}))}),define(Z[132],x([0,1,26,3,118,72]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(p,t){return p===1?L.isWindows?S():M.getWindowsShell(t):d(p,t)}e.getSystemShell=P;function b(p,t){return p===1?L.isWindows?m(t):M.getWindowsShell(t):d(p,t)}e.getSystemShellSync=b;let h=null;function d(p,t){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!h){let g;if(L.isWindows)g="/bin/bash";else{if(g=t.SHELL,!g)try{g=(0,v.userInfo)().shell}catch(E){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}h=g}return h}let i=null;async function S(){return i||(i=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),i}function m(p){if(i)return i;const t=L.isWindows&&parseFloat((0,v.release)())>=10,g=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${p.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?E:M.getWindowsShell(p)}}),define(Z[73],x([0,1,44,9,17,23,110,16,4,2,43,72,35]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends m.ChannelServer{constructor(E){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(I){}},onMessage:h.Event.fromNodeEventEmitter(process,"message",y=>D.VSBuffer.wrap(Buffer.from(y,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=p;class t{constructor(E,y){this.modulePath=E,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const I=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new L.Delayer(I),this.child=null,this._client=null}getChannel(E){const y=this;return{call(I,c,o){return y.requestPromise(E,I,c,o)},listen(I,c){return y.requestEvent(E,I,c)}}}requestPromise(E,y,I,c=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(E),u=(0,L.createCancelablePromise)(s=>o.call(y,I,s)),n=c.onCancellationRequested(()=>u.cancel()),a=(0,d.toDisposable)(()=>u.cancel());return this.activeRequests.add(a),u.finally(()=>{n.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(E,y,I){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let c;const o=new h.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(E).listen(y,I)(o.fire,o),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,S.removeDangerousEnvVariables)(y.env),this.child=(0,v.fork)(this.modulePath,E,y);const I=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,P.isRemoteConsoleLog)(r)){(0,P.log)(r,`IPC Library: ${this.options.serverName}`);return}I.fire(D.VSBuffer.wrap(Buffer.from(r,"base64")))});const o=this.options.useQueue?(0,S.createQueuedSender)(this.child):this.child,u=r=>this.child&&this.child.connected&&o.send(r.buffer.toString("base64")),n=I.event,a={send:u,onMessage:n};this._client=new m.ChannelClient(a);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,l)=>{process.removeListener("exit",s),this.activeRequests.forEach(f=>(0,d.dispose)(f)),this.activeRequests.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:l})})}return this._client}getCachedChannel(E){let y=this.channels.get(E);return y||(y=this.client.getChannel(E),this.channels.set(E,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Z[133],x([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Z[134],x([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[135],x([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[136],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Z[137],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Z[138],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/shellEnv",e)}),define(Z[139],x([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[140],x([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[141],x([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[142],x([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Z[143],x([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Z[144],x([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Z[145],x([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Z[146],x([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[147],x([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[148],x([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[149],x([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[150],x([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Z[151],x([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[152],x([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[153],x([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Z[154],x([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[155],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[156],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[157],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[158],x([0,1,4,2]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(b,h,d){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:d[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:d[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:d[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:d[0],port:d[1],subId:d[2]}))}throw new Error("Method not implemented.")}listen(b,h,d){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(b){super();this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,h,d){this.channel.call("attach",[b,h,d])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,h){this.channel.call("terminate",[b,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,h){return this.channel.call("openExtensionDevelopmentHostWindow",[b,h])}}e.ExtensionHostDebugChannelClient=M}),define(Z[159],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(P){this.driver=P}listen(P,b){throw new Error(`No event found: ${b}`)}call(P,b,h){switch(b){case"click":return this.driver.click(h[0],h[1],h[2]);case"doubleClick":return this.driver.doubleClick(h);case"setValue":return this.driver.setValue(h[0],h[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(h);case"getElements":return this.driver.getElements(h[0],h[1]);case"getElementXY":return this.driver.getElementXY(h[0],h[1],h[2]);case"typeInEditor":return this.driver.typeInEditor(h[0],h[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(h);case"writeInTerminal":return this.driver.writeInTerminal(h[0],h[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${b}`)}}e.WindowDriverChannel=v;class L{constructor(P){this.channel=P}click(P,b,h){return this.channel.call("click",[P,b,h])}doubleClick(P){return this.channel.call("doubleClick",P)}setValue(P,b){return this.channel.call("setValue",[P,b])}getTitle(){return this.channel.call("getTitle")}isActiveElement(P){return this.channel.call("isActiveElement",P)}getElements(P,b){return this.channel.call("getElements",[P,b])}getElementXY(P,b,h){return this.channel.call("getElementXY",[P,b,h])}typeInEditor(P,b){return this.channel.call("typeInEditor",[P,b])}getTerminalBuffer(P){return this.channel.call("getTerminalBuffer",P)}writeInTerminal(P,b){return this.channel.call("writeInTerminal",[P,b])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class D{constructor(P){this.channel=P}registerWindowDriver(P){return this.channel.call("registerWindowDriver",P)}reloadWindowDriver(P){return this.channel.call("reloadWindowDriver",P)}}e.WindowDriverRegistryChannelClient=D}),define(Z[160],x([0,1,127,47,10,8,32,15,7]),function(j,e,v,L,D,M,P,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class d{constructor(g,E,y){this._args=g,this.paths=E,this.productService=y}get appRoot(){return(0,M.dirname)(D.FileAccess.asFileUri("",j).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(h.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return h.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return h.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=P.env.VSCODE_PORTABLE;return g?h.URI.file((0,M.join)(g,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,b.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,M.resolve)(g):(0,M.normalize)((0,M.join)(D.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,M.resolve)(g):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,M.resolve)(g);const E=P.env.VSCODE_EXTENSIONS;if(E)return E;const y=P.env.VSCODE_PORTABLE;return y?(0,M.join)(y,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(E=>/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,M.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?h.URI.parse(g):h.URI.file((0,M.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return h.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],d.prototype,"appRoot",null),he([L.memoize],d.prototype,"userHome",null),he([L.memoize],d.prototype,"userDataPath",null),he([L.memoize],d.prototype,"appSettingsHome",null),he([L.memoize],d.prototype,"tmpDir",null),he([L.memoize],d.prototype,"userRoamingDataHome",null),he([L.memoize],d.prototype,"settingsResource",null),he([L.memoize],d.prototype,"userDataSyncHome",null),he([L.memoize],d.prototype,"userDataSyncLogResource",null),he([L.memoize],d.prototype,"sync",null),he([L.memoize],d.prototype,"machineSettingsResource",null),he([L.memoize],d.prototype,"globalStorageHome",null),he([L.memoize],d.prototype,"workspaceStorageHome",null),he([L.memoize],d.prototype,"keybindingsResource",null),he([L.memoize],d.prototype,"keyboardLayoutResource",null),he([L.memoize],d.prototype,"argvResource",null),he([L.memoize],d.prototype,"snippetsHome",null),he([L.memoize],d.prototype,"isExtensionDevelopment",null),he([L.memoize],d.prototype,"untitledWorkspacesHome",null),he([L.memoize],d.prototype,"installSourcePath",null),he([L.memoize],d.prototype,"builtinExtensionsPath",null),he([L.memoize],d.prototype,"extensionsPath",null),he([L.memoize],d.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],d.prototype,"extensionDevelopmentKind",null),he([L.memoize],d.prototype,"extensionTestsLocationURI",null),he([L.memoize],d.prototype,"debugExtensionHost",null),he([L.memoize],d.prototype,"serviceMachineIdResource",null),he([L.memoize],d.prototype,"telemetryLogResource",null),he([L.memoize],d.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=d;function i(t,g){return p(t["inspect-extensions"],t["inspect-brk-extensions"],5870,g,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=i;function S(t,g){return p(t["inspect-search"],t["inspect-brk-search"],5876,g,t.extensionEnvironment)}e.parseSearchPort=S;function m(t,g){return p(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,g,t.extensionEnvironment)}e.parsePtyHostPort=m;function p(t,g,E,y,I,c){const u=Number(g||t)||(y?null:E),n=u?Boolean(!!g):!1;let a;if(c)try{a=JSON.parse(c)}catch{}return{port:u,break:n,debugId:I,env:a}}}),define(Z[88],x([0,1,244,3,136]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{}};function b(t,g,E=P){const y={},I=[],c=[];for(let a in g){const s=g[a];s.alias&&(y[a]=s.alias),s.type==="string"||s.type==="string[]"?(I.push(a),s.deprecates&&I.push(s.deprecates)):s.type==="boolean"&&(c.push(a),s.deprecates&&c.push(s.deprecates))}const o=v(t,{string:I,boolean:c,alias:y}),u={},n=o;u._=o._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(let a in g){const s=g[a];s.alias&&delete n[s.alias];let r=n[a];s.deprecates&&n.hasOwnProperty(s.deprecates)&&(r||(r=n[s.deprecates]),delete n[s.deprecates]),typeof r!="undefined"&&(s.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):s.type==="string"&&Array.isArray(r)&&(r=r.pop(),E.onMultipleValues(a,r)),u[a]=r),delete n[a]}for(let a in n)E.onUnknownOption(a);return u}e.parseArgs=b;function h(t,g){let E="";return g.args&&(Array.isArray(g.args)?E=` <${g.args.join("> <")}>`:E=` <${g.args}>`),g.alias?`-${g.alias} --${t}${E}`:`--${t}${E}`}function d(t,g){let E=0,y=[];for(const u in t){const n=t[u],a=h(u,n);E=Math.max(E,a.length),y.push([a,n.description])}let I=E+2+1;if(g-I<25)return y.reduce((u,n)=>u.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let c=g-I-1,o=[];for(const u of y){let n=u[0],a=S(u[1],c),s=i(I-n.length-2);o.push("  "+n+s+a[0]);for(let r=1;r<a.length;r++)o.push(i(I)+a[r])}return o}e.formatOptions=d;function i(t){return" ".repeat(t)}function S(t,g){let E=[];for(;t.length;){let y=t.length<g?t.length:t.lastIndexOf(" ",g),I=t.slice(0,y).trim();t=t.slice(y),E.push(I)}return E}function m(t,g,E,y,I=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${t} ${E}`];o.push(""),o.push(`${(0,D.localize)(32,null)}: ${g} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),o.push(""),I&&(L.isWindows?o.push((0,D.localize)(35,null,g)):o.push((0,D.localize)(36,null,g)),o.push(""));const u={};for(const n in y){const a=y[n];if(a.description&&a.cat){let s=u[a.cat];s||(u[a.cat]=s={}),s[n]=a}}for(let n in u){const a=n;let s=u[a];s&&(o.push(M[a]),o.push(...d(s,c)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=m;function p(t,g){return`${t||(0,D.localize)(37,null)}
${g||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(Z[161],x([0,1,62,158,88]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(b){super();this.windowsMainService=b}call(b,h,d){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(d[0],d[1]):super.call(b,h,d)}async openExtensionDevelopmentHostWindow(b,h){const d=(0,D.parseArgs)(b,D.OPTIONS);d.debugRenderer=h;const i=d.extensionDevelopmentPath;if(!i)return{success:!1};const[S]=this.windowsMainService.openExtensionDevelopmentHostWindow(i,{context:5,cli:d});if(!h)return{success:!0};const m=S.win;if(!m)return{success:!0};const p=m.webContents.debugger;let t=p.isAttached()?Infinity:0;const g=(0,v.createServer)(E=>{t++==0&&p.attach();let y=!1;const I=u=>{y||E.write(JSON.stringify(u)+"\0")},c=(u,n,a,s)=>I({method:n,params:a,sessionId:s});m.on("close",()=>{p.removeListener("message",c),E.end(),y=!0}),p.addListener("message",c);let o=Buffer.alloc(0);E.on("data",u=>{o=Buffer.concat([o,u]);for(let n=o.indexOf(0);n!==-1;n=o.indexOf(0)){let a;try{const s=o.slice(0,n).toString("utf8");o=o.slice(n+1),a=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}p.sendCommand(a.method,a.params,a.sessionId).then(s=>I({id:a.id,sessionId:a.sessionId,result:s})).catch(s=>I({id:a.id,sessionId:a.sessionId,error:{code:0,message:s.message}}))}}),E.on("error",u=>{console.error("error on cdp pipe:",u)}),E.on("close",()=>{y=!0,--t==0&&p.detach()})});return await new Promise(E=>g.listen(0,E)),m.on("close",()=>g.close()),{rendererDebugPort:g.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function j(e,v,L,D){function M(b){const h=P(b),d=[h];return e.isAbsolute(h)||d.unshift(D),e.resolve(...d)}function P(b){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,L);const i=b["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(S,"AppData","Roaming")}break;case"darwin":d=e.join(v.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,L)}return{getUserDataPath:M}}if(typeof define=="function")define(Z[162],x([0,245,26,10,15,32]),function(e,v,L,D,M,P){const b=M.dirname(D.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(M.joinPath(b,"package.json").fsPath);return j(v,L,h.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),L=require("os");module.exports=j(v,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[163],x([0,1,26,160,162]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(b,h){super(b,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,D.getUserDataPath)(b)},h)}}e.NativeEnvironmentService=M}),define(Z[164],x([0,1,29,26,8]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(P){const b=(0,D.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(b,""),P&&console.log(`Marker file for --wait created: ${b}`),b}catch(h){P&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=M}),define(Z[165],x([0,1,140]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function M(m){return m=m.trim(),m==="*"||L.test(m)}e.isValidVersionStr=M;function P(m){if(!M(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=m.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=P;function b(m){if(!m)return null;let p=m.majorBase,t=m.majorMustEqual,g=m.minorBase,E=m.minorMustEqual,y=m.patchBase,I=m.patchMustEqual;m.hasCaret&&(p===0||(E=!1),I=!1);let c=0;if(m.preRelease){const o=D.exec(m.preRelease);if(o){const[,u,n,a]=o;c=Date.UTC(Number(u),Number(n)-1,Number(a))}}return{majorBase:p,majorMustEqual:t,minorBase:g,minorMustEqual:E,patchBase:y,patchMustEqual:I,isMinimum:m.hasGreaterEquals,notBefore:c}}e.normalizeVersion=b;function h(m,p,t){let g;typeof m=="string"?g=b(P(m)):g=m;let E;p instanceof Date?E=p.getTime():typeof p=="string"&&(E=new Date(p).getTime());let y;if(typeof t=="string"?y=b(P(t)):y=t,!g||!y)return!1;let I=g.majorBase,c=g.minorBase,o=g.patchBase,u=y.majorBase,n=y.minorBase,a=y.patchBase,s=y.notBefore,r=y.majorMustEqual,l=y.minorMustEqual,f=y.patchMustEqual;return y.isMinimum?I>u?!0:I<u?!1:c>n?!0:c<n||E&&E<s?!1:o>=a:(I===1&&u===0&&(!r||!l||!f)&&(u=1,n=0,a=0,r=!0,l=!1,f=!1),I<u?!1:I>u?!r:c<n?!1:c>n?!l:o<a?!1:o>a?!f:!(E&&E<s))}e.isValidVersion=h;function d(m,p,t,g){return t.isBuiltin||typeof t.main=="undefined"?!0:S(m,p,t.engines.vscode,g)}e.isValidExtensionVersion=d;function i(m,p,t){return m==="*"||S(p,t,m)}e.isEngineValid=i;function S(m,p,t,g=[]){let E=b(P(t));if(!E)return g.push(v.localize(0,null,t)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return g.push(v.localize(1,null,t)),!1}else if(!E.majorMustEqual)return g.push(v.localize(2,null,t)),!1;return h(m,p,E)?!0:(g.push(v.localize(3,null,m,t)),!1)}}),define(Z[166],x([0,1,4,2,17,60,23]),function(j,e,v,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class b extends L.Disposable{constructor(d,i){super();this.provider=d,this.logService=i,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(d,i,S){const m=this.getUriTransformer(d);switch(i){case"stat":return this.stat(m,S[0]);case"readdir":return this.readdir(m,S[0]);case"open":return this.open(m,S[0],S[1]);case"close":return this.close(S[0]);case"read":return this.read(S[0],S[1],S[2]);case"readFile":return this.readFile(m,S[0]);case"write":return this.write(S[0],S[1],S[2],S[3],S[4]);case"writeFile":return this.writeFile(m,S[0],S[1],S[2]);case"rename":return this.rename(m,S[0],S[1],S[2]);case"copy":return this.copy(m,S[0],S[1],S[2]);case"mkdir":return this.mkdir(m,S[0]);case"delete":return this.delete(m,S[0],S[1]);case"watch":return this.watch(m,S[0],S[1],S[2],S[3]);case"unwatch":return this.unwatch(S[0],S[1])}throw new Error(`IPC Command ${i} not found`)}listen(d,i,S){const m=this.getUriTransformer(d);switch(i){case"fileChange":return this.onFileChange(m,S[0]);case"readFileStream":return this.onReadFileStream(m,S[0],S[1])}throw new Error(`Unknown event ${i}`)}stat(d,i){const S=this.transformIncoming(d,i,!0);return this.provider.stat(S)}readdir(d,i){const S=this.transformIncoming(d,i);return this.provider.readdir(S)}async readFile(d,i){const S=this.transformIncoming(d,i,!0),m=await this.provider.readFile(S);return D.VSBuffer.wrap(m)}onReadFileStream(d,i,S){const m=this.transformIncoming(d,i,!0),p=new P.CancellationTokenSource,t=new v.Emitter({onLastListenerRemove:()=>{p.cancel()}}),g=this.provider.readFileStream(m,S,p.token);return(0,M.listenStream)(g,{onData:E=>t.fire(D.VSBuffer.wrap(E)),onError:E=>t.fire(E),onEnd:()=>{t.fire("end"),t.dispose(),p.dispose()}}),t.event}writeFile(d,i,S,m){const p=this.transformIncoming(d,i);return this.provider.writeFile(p,S.buffer,m)}open(d,i,S){const m=this.transformIncoming(d,i,!0);return this.provider.open(m,S)}close(d){return this.provider.close(d)}async read(d,i,S){const m=D.VSBuffer.alloc(S),p=0,t=await this.provider.read(d,i,m.buffer,p,S);return[m,t]}write(d,i,S,m,p){return this.provider.write(d,i,S.buffer,m,p)}mkdir(d,i){const S=this.transformIncoming(d,i);return this.provider.mkdir(S)}delete(d,i,S){const m=this.transformIncoming(d,i);return this.provider.delete(m,S)}rename(d,i,S,m){const p=this.transformIncoming(d,i),t=this.transformIncoming(d,S);return this.provider.rename(p,t,m)}copy(d,i,S,m){const p=this.transformIncoming(d,i),t=this.transformIncoming(d,S);return this.provider.copy(p,t,m)}onFileChange(d,i){const S=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(i,this.createSessionFileWatcher(d,S))},onLastListenerRemove:()=>{(0,L.dispose)(this.sessionToWatcher.get(i)),this.sessionToWatcher.delete(i)}});return S.event}async watch(d,i,S,m,p){const t=this.sessionToWatcher.get(i);if(t){const g=this.transformIncoming(d,m),E=t.watch(S,g,p);this.watchRequests.set(i+S,E)}}async unwatch(d,i){const S=d+i,m=this.watchRequests.get(S);m&&((0,L.dispose)(m),this.watchRequests.delete(S))}dispose(){super.dispose(),this.watchRequests.forEach(d=>(0,L.dispose)(d)),this.watchRequests.clear(),this.sessionToWatcher.forEach(d=>(0,L.dispose)(d)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=b}),define(Z[74],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(D,M=[],P=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=v}),define(Z[167],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=v;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let P of this._nodes.values())P.outgoing.size===0&&M.push(P);return M}insertEdge(M,P){const b=this.lookupOrInsertNode(M),h=this.lookupOrInsertNode(P);b.outgoing.set(this._hashFn(P),h),h.incoming.set(this._hashFn(M),b)}removeNode(M){const P=this._hashFn(M);this._nodes.delete(P);for(let b of this._nodes.values())b.outgoing.delete(P),b.incoming.delete(P)}lookupOrInsertNode(M){const P=this._hashFn(M);let b=this._nodes.get(P);return b||(b=new v(M),this._nodes.set(P,b)),b}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[P,b]of this._nodes)M.push(`${P}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,P]of this._nodes){const b=new Set([M]),h=this._findCycle(P,b);if(h)return h}}_findCycle(M,P){for(let[b,h]of M.outgoing){if(P.has(b))return[...P,b].join(" -> ");P.add(b);const d=this._findCycle(h,P);if(d)return d;P.delete(b)}}}e.Graph=L}),define(Z[5],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(b){b.serviceIds=new Map,b.DI_TARGET="$di$target",b.DI_DEPENDENCIES="$di$dependencies";function h(d){return d[b.DI_DEPENDENCIES]||[]}b.getServiceDependencies=h})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(b,h,d,i){h[v.DI_TARGET]===h?h[v.DI_DEPENDENCIES].push({id:b,index:d,optional:i}):(h[v.DI_DEPENDENCIES]=[{id:b,index:d,optional:i}],h[v.DI_TARGET]=h)}function D(b){if(v.serviceIds.has(b))return v.serviceIds.get(b);const h=function(d,i,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(h,d,S,!1)};return h.toString=()=>b,v.serviceIds.set(b,h),h}e.createDecorator=D;function M(b){return b}e.refineServiceDecorator=M;function P(b){return function(h,d,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(b,h,i,!0)}}e.optional=P}),define(Z[75],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[89],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,P)=>j(["vscode-encrypt"],M,P))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(P){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(P){return M}}}e.EncryptionMainService=L}),define(Z[48],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[168],x([0,1,10,139,5]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function P(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function b(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=b;function h(c,o){switch(c){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=h;function d(c,o){return o==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=d;function i(c,o,u){return d(o,u)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===u?!0:S(u).includes(c)}e.isTargetPlatformCompatible=i;function S(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=m;var p;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var E;(function(c){c[c.None=0]="None",c[c.Install=1]="Install",c[c.Update=2]="Update"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var y;(function(c){c.Unsupported="Unsupported",c.Malicious="Malicious",c.Incompatible="Incompatible",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class I extends Error{constructor(o,u){super(o);this.code=u,this.name=u}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(Z[169],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Z[90],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Z[170],x([0,1,44,10,8,3,81,20,72,141,90]),function(j,e,v,L,D,M,P,b,h,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const S=d.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends m{openTerminal(o,u){return this.spawnTerminal(v,o,h.getWindowsShell(),u)}spawnTerminal(o,u,n,a){const s=u.windowsExec||p.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const r=D.basename(s).toLowerCase();if(r==="cmder"||r==="cmder.exe")return o.spawn(s,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),(r==="wt"||r==="wt.exe")&&l.push("-d ."),new Promise((f,w)=>{const k=E(process),R=o.spawn(n,l,{cwd:a,env:k});R.on("error",w),R.on("exit",()=>f())})}runInTerminal(o,u,n,a,s){const r="windowsExec"in s&&s.windowsExec?s.windowsExec:p.getDefaultTerminalWindows();return new Promise((l,f)=>{const w=`"${u} - ${S}"`,k=`""${n.join('" "')}" & pause"`,R=["/c","start",w,"/wait",r,"/c",k],A=Object.assign({},E(process),a);Object.keys(A).filter(te=>A[te]===null).forEach(te=>delete A[te]);const F={cwd:u,env:A,windowsVerbatimArguments:!0};v.spawn(p.CMD,R,F).on("error",te=>{f(y(te))}),l(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class t extends m{openTerminal(o,u){return this.spawnTerminal(v,o,u)}runInTerminal(o,u,n,a,s){const r=s.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((l,f)=>{if(r===i.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const w=r===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`,j).fsPath,"-t",o||S,"-w",u];for(let H of n)R.push("-a"),R.push(H);if(a){const H=Object.assign({},E(process),a);for(let te in H){const se=H[te];se===null?(R.push("-u"),R.push(te)):(R.push("-e"),R.push(`${te}=${se}`))}}let A="";const F=v.spawn(t.OSASCRIPT,R);F.on("error",H=>{f(y(H))}),F.stderr.on("data",H=>{A+=H.toString()}),F.on("exit",H=>{if(H===0)l(void 0);else if(A){const te=A.split(`
`,1);f(new Error(te[0]))}else f(new Error(d.localize(1,null,w,H)))})}else f(new Error(d.localize(2,null,r)))})}spawnTerminal(o,u,n){const a=u.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{const l=["-a",a];n&&l.push(n);const f=E(process),w=o.spawn("/usr/bin/open",l,{cwd:n,env:f});w.on("error",r),w.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class g extends m{openTerminal(o,u){return this.spawnTerminal(v,o,u)}runInTerminal(o,u,n,a,s){const r=s.linuxExec?Promise.resolve(s.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,f)=>{let w=[];r.then(k=>{k.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const R=`${I(n)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;w.push(`''${R}''`);const A=Object.assign({},E(process),a);Object.keys(A).filter(se=>A[se]===null).forEach(se=>delete A[se]);const F={cwd:u,env:A};let H="";const te=v.spawn(k,w,F);te.on("error",se=>{f(y(se))}),te.stderr.on("data",se=>{H+=se.toString()}),te.on("exit",se=>{if(se===0)l(void 0);else if(H){const le=H.split(`
`,1);f(new Error(le[0]))}else f(new Error(d.localize(4,null,k,se)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!M.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await b.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{o?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,u,n){const a=u.linuxExec?Promise.resolve(u.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{a.then(l=>{const f=E(process),w=o.spawn(l,[],{cwd:n,env:f});w.on("error",r),w.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=d.localize(3,null);function E(c){const o={...c.env};return(0,P.sanitizeProcessEnvironment)(o),o}function y(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(d.localize(5,null,c.path)):c}function I(c){let o="";for(let u of c)u.indexOf(" ")>=0?o+='"'+u+'"':o+=u,o+=" ";return o}}),define(Z[18],x([0,1,40,8,25,14,7,143,5]),function(j,e,v,L,D,M,P,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function d(T){return T.create===!0}e.isFileOpenForWriteOptions=d;var i;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var S;(function(T){T[T.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var m;(function(T){T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=p;function t(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=t;function g(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=E;var y;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(B,V){super(B);this.code=V}}e.FileSystemProviderError=I;function c(T,B){const V=new I(T.toString(),B);return u(V,B),V}e.createFileSystemProviderError=c;function o(T){return T||c((0,b.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=o;function u(T,B){return T.name=B?`${B} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=u;function n(T){if(!T)return y.Unknown;if(T instanceof I)return T.code;const B=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!B)return y.Unknown;switch(B[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=n;function a(T){if(T instanceof k)return T.fileOperationResult;switch(n(T)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(B,V,_){this.resource=B,this.operation=V,this.target=_}isOperation(B){return this.operation===B}}e.FileOperationEvent=r;var l;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class f{constructor(B,V){this.added=void 0,this.updated=void 0,this.deleted=void 0;const _=new Map;for(const U of B){const C=_.get(U.type);C?C.push([U.resource,U]):_.set(U.type,[[U.resource,U]])}for(const[U,C]of _)switch(U){case 1:this.added=v.TernarySearchTree.forUris(()=>V),this.added.fill(C);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>V),this.updated.fill(C);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>V),this.deleted.fill(C);break}}contains(B,...V){return this.doContains(B,{includeChildren:!1},...V)}affects(B,...V){return this.doContains(B,{includeChildren:!0},...V)}doContains(B,V,..._){if(!B)return!1;const U=_.length>0;return!!((!U||_.includes(1))&&(this.added?.get(B)||V.includeChildren&&this.added?.findSuperstr(B))||(!U||_.includes(0))&&(this.updated?.get(B)||V.includeChildren&&this.updated?.findSuperstr(B))||(!U||_.includes(2))&&(this.deleted?.findSubstr(B)||V.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function w(T,B,V){return!T||!B||T===B||B.length>T.length?!1:(B.charAt(B.length-1)!==L.sep&&(B+=L.sep),V?(0,D.startsWithIgnoreCase)(T,B):T.indexOf(B)===0)}e.isParent=w;class k extends Error{constructor(B,V,_){super(B);this.fileOperationResult=V,this.options=_}}e.FileOperationError=k;class R extends k{constructor(B,V,_){super(B,2,_);this.stat=V}}e.NotModifiedSinceFileOperationError=R;var A;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",T[T.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function H(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=H;async function te(T,B){if(!B.hasProvider(P.URI.from({scheme:T.scheme})))return new Promise(V=>{const _=B.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===T.scheme&&U.added&&(_.dispose(),V())})})}e.whenProviderRegistered=te,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(B){return(0,M.isNumber)(B)||(B=0),B<se.KB?(0,b.localize)(1,null,B.toFixed(0)):B<se.MB?(0,b.localize)(2,null,(B/se.KB).toFixed(2)):B<se.GB?(0,b.localize)(3,null,(B/se.MB).toFixed(2)):B<se.TB?(0,b.localize)(4,null,(B/se.GB).toFixed(2)):(0,b.localize)(5,null,(B/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var le;(function(T){T[T.IA32=0]="IA32",T[T.OTHER=1]="OTHER"})(le=e.Arch||(e.Arch={}));function Y(T){return{maxFileSize:T===0?300*se.MB:16*se.GB,maxHeapSize:T===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=Y}),define(Z[56],x([0,1,246,137,88,18]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(m,p){const t={onUnknownOption:E=>{console.warn((0,L.localize)(0,null,E))},onMultipleValues:(E,y)=>{console.warn((0,L.localize)(1,null,E,y))}},g=(0,D.parseArgs)(m,D.OPTIONS,p?t:void 0);return g.goto&&g._.forEach(E=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,L.localize)(2,null))),g["max-memory"]&&v(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function b(m){const p=m.findIndex(t=>!/^-/.test(t));if(p>-1)return[...m.slice(0,p),...m.slice(p+1)]}function h(m){let[,...p]=m;process.env.VSCODE_DEV&&(p=b(p)||[]);const t=!S(process.env);return P(p,t)}e.parseMainProcessArgv=h;function d(m){const[,,...p]=m;return P(p,!0)}e.parseCLIProcessArgv=d;function i(m,...p){const t=m.indexOf("--");return t===-1?m.push(...p):m.splice(t,0,...p),m}e.addArg=i;function S(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),define(Z[91],x([0,1,44,8,138,23,45,16,3,28,132,56,9]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let t;async function g(y,I,c){return I["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(c)&&!I["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(c)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=m.Promises.withAsyncBody(async(o,u)=>{const n=new M.CancellationTokenSource,a=setTimeout(()=>{n.dispose(!0),u(new Error((0,D.localize)(0,null)))},p);try{o(await E(y,n.token))}catch(s){!(0,b.isPromiseCanceledError)(s)&&!n.token.isCancellationRequested?u(new Error((0,D.localize)(1,null,(0,P.toErrorMessage)(s)))):o({})}finally{clearTimeout(a),n.dispose()}})),t)}e.resolveShellEnv=g;async function E(y,I){const c=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",c);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",o);const u=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(u+"(.*)"+u),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};y.trace("getUnixShellEnvironment#env",a);const s=await(0,i.getSystemShell)(h.OS,a);return y.trace("getUnixShellEnvironment#shell",s),new Promise((r,l)=>{if(I.isCancellationRequested)return l((0,b.canceled)());const f=(0,L.basename)(s);let w,k;/^pwsh(-preview)?$/.test(f)?(w=`& '${process.execPath}' -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,k=["-Login","-Command"]):(w=`'${process.execPath}' -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,k=["-ilc"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),w);const R=(0,v.spawn)(s,[...k,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});I.onCancellationRequested(()=>(R.kill(),l((0,b.canceled)()))),R.on("error",H=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,P.toErrorMessage)(H)),l(H)});const A=[];R.stdout.on("data",H=>A.push(H));const F=[];R.stderr.on("data",H=>F.push(H)),R.on("close",(H,te)=>{const se=Buffer.concat(A).toString("utf8");y.trace("getUnixShellEnvironment#raw",se);const le=Buffer.concat(F).toString("utf8");if(le.trim()&&y.trace("getUnixShellEnvironment#stderr",le),H||te)return l(new Error((0,D.localize)(2,null,H,te)));const Y=n.exec(se),T=Y?Y[1]:"{}";try{const B=JSON.parse(T);c?B.ELECTRON_RUN_AS_NODE=c:delete B.ELECTRON_RUN_AS_NODE,o?B.ELECTRON_NO_ATTACH_CONSOLE=o:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",B),r(B)}catch(B){y.error("getUnixShellEnvironment#errorCaught",(0,P.toErrorMessage)(B)),l(B)}})})}}),define(Z[92],x([0,1,17,16,144,18]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(i,S,m,p,t,g){let E;try{await b(i,S,m,p,t,g)}catch(y){E=y}finally{E&&t.errorTransformer&&(E=t.errorTransformer(E)),typeof E!="undefined"&&m.error(E),m.end()}}e.readFileIntoStream=P;async function b(i,S,m,p,t,g){h(g);const E=await i.open(S,{create:!1});try{h(g);let y=0,I=0,c=t&&typeof t.length=="number"?t.length:void 0,o=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),u=t&&typeof t.position=="number"?t.position:0,n=0;do I=await i.read(E,u,o.buffer,n,o.byteLength-n),u+=I,n+=I,y+=I,typeof c=="number"&&(c-=I),n===o.byteLength&&(await m.write(p(o)),o=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),n=0);while(I>0&&(typeof c!="number"||c>0)&&h(g)&&d(y,t));if(n>0){let a=n;typeof c=="number"&&(a=Math.min(n,c)),m.write(p(o.slice(0,a)))}}catch(y){throw(0,M.ensureFileSystemProviderError)(y)}finally{await i.close(E)}}function h(i){if(i.isCancellationRequested)throw(0,L.canceled)();return!0}function d(i,S){if(S?.limits){if(typeof S.limits.memory=="number"&&i>S.limits.memory)throw(0,M.createFileSystemProviderError)((0,D.localize)(0,null),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&i>S.limits.size)throw(0,M.createFileSystemProviderError)((0,D.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[49],x([0,1,2,3,7,18]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class P extends v.Disposable{constructor(m,p,t){super();this.onFileChanges=m,this.onLogMessage=p,this.verboseLogging=t,this.serviceDisposables=this._register(new v.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new v.DisposableStore;this.serviceDisposables.value=m,this.service=this.createService(m),this.service.setVerboseLogging(this.verboseLogging),m.add(this.service.onDidChangeFile(p=>this.onFileChanges(p))),m.add(this.service.onDidLogMessage(p=>this.onLogMessage(p))),m.add(this.service.onDidError(p=>this.onError(p)))}onError(m){this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.service?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.service?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${m}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=P,P.MAX_RESTARTS=5;class b extends v.Disposable{}e.WatcherService=b;function h(S){return S.map(m=>({type:m.type,resource:D.URI.file(m.path)}))}e.toFileChanges=h;function d(S){const m=new i;for(const p of S)m.processEvent(p);return m.normalize()}e.normalizeFileChanges=d;class i{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(m){return L.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const p=this.mapPathToChange.get(this.toKey(m));let t=!1;if(p){const g=p.type,E=m.type;p.path!==m.path&&m.type===2?t=!0:g===1&&E===2?(this.mapPathToChange.delete(this.toKey(m)),this.normalized.delete(p)):g===2&&E===1?p.type=0:g===1&&E===0||(p.type=E)}else t=!0;t&&(this.normalized.add(m),this.mapPathToChange.set(this.toKey(m),m))}normalize(){const m=[],p=[];return Array.from(this.normalized).filter(t=>t.type!==2?(m.push(t),!1):!0).sort((t,g)=>t.path.length-g.path.length).filter(t=>p.some(g=>(0,M.isParent)(t.path,g,!L.isLinux))?!1:(p.push(t.path),!0)).concat(m)}}}),define(Z[93],x([0,1,9,2,8,83,20,119,49]),function(j,e,v,L,D,M,P,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class d extends L.Disposable{constructor(S,m,p,t){super();this.path=S,this.onDidFilesChange=m,this.onLogMessage=p,this.verboseLogging=t,this.fileChangesDelayer=this._register(new v.ThrottledDelayer(b.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(S){this.verboseLogging=S}async startWatching(){try{const{stat:S,symbolicLink:m}=await P.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(m)try{p=await(0,M.realpath)(p)}catch(t){if(this.onError(t),m.dangling)return}S.isDirectory()?this._register((0,b.watchFolder)(p,(t,g)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(g))})},t=>this.onError(t))):this._register((0,b.watchFile)(p,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(S){S.code!=="ENOENT"&&this.onError(S)}}onFileChange(S){this.fileChangesBuffer.push(S),this.verboseLogging&&this.onVerbose(`${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,h.normalizeFileChanges)(m);if(this.verboseLogging)for(const t of p)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(S){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${S}`})}onVerbose(S){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${S}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=d}),define(Z[171],x([0,1,10,35,73,49]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends M.WatcherService{constructor(h,d,i){super();this.onDidFilesChange=h,this.onLogMessage=d,this.verboseLogging=i,this.isDisposed=!1,this.startWatching()}startWatching(){const h=this._register(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d)))}async setVerboseLogging(h){this.verboseLogging=h,this.isDisposed||await this.service?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}async watch(h){this.isDisposed||await this.service?.watch(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P}),define(Z[172],x([0,1,10,35,73,49]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends M.AbstractWatcherService{constructor(h,d,i){super(h,d,i);this.init()}createService(h){const d=h.add(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(d.onDidProcessExit(({code:i,signal:S})=>this.onError(`terminated by itself with code ${i}, signal: ${S}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(d.getChannel("watcher")))}}e.FileWatcher=P}),define(Z[173],x([0,1,10,35,73,49]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends M.WatcherService{constructor(h,d,i,S={}){super();this.onDidFilesChange=h,this.onLogMessage=d,this.verboseLogging=i,this.watcherOptions=S,this.isDisposed=!1,this.restartCounter=0,this.requests=void 0,this.startWatching()}startWatching(){const h=this._register(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching(),this.service?.watch(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(h.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d)))}async setVerboseLogging(h){this.verboseLogging=h,this.isDisposed||await this.service?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${h}`})}async watch(h){this.requests=h,await this.service?.watch(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Z[76],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[M,P]of D)this.set(M,P)}set(D,M){const P=this._entries.get(D);return this._entries.set(D,M),P}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(Z[174],x([0,1,9,16,74,167,5,76]),function(j,e,v,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const h=!1;class d extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class i{constructor(t=new b.ServiceCollection,g=!1,E){this._activeInstantiations=new Set,this._services=t,this._strict=g,this._parent=E,this._services.set(P.IInstantiationService,this)}createChild(t){return new i(t,this._strict,this)}invokeFunction(t,...g){let E=m.traceInvocation(t),y=!1;try{return t({get:(c,o)=>{if(y)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(c,E);if(!u&&o!==P.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return u}},...g)}finally{y=!0,E.stop()}}createInstance(t,...g){let E,y;return t instanceof D.SyncDescriptor?(E=m.traceCreation(t.ctor),y=this._createInstance(t.ctor,t.staticArguments.concat(g),E)):(E=m.traceCreation(t),y=this._createInstance(t,g,E)),E.stop(),y}_createInstance(t,g=[],E){let y=P._util.getServiceDependencies(t).sort((o,u)=>o.index-u.index),I=[];for(const o of y){let u=this._getOrCreateServiceInstance(o.id,E);if(!u&&this._strict&&!o.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${o.id}.`);I.push(u)}let c=y.length>0?y[0].index:g.length;if(g.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${g.length} static arguments`);let o=c-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,c)}return new t(...[...g,...I])}_setServiceInstance(t,g){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,g);else if(this._parent)this._parent._setServiceInstance(t,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let g=this._services.get(t);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):g}_getOrCreateServiceInstance(t,g){let E=this._getServiceInstanceOrDescriptor(t);return E instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,E,g.branch(t,!0)):(g.branch(t,!1),E)}_safeCreateAndCacheServiceInstance(t,g,E){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,g,E)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,g,E){const y=new M.Graph(o=>o.id.toString());let I=0;const c=[{id:t,desc:g,_trace:E}];for(;c.length;){const o=c.pop();if(y.lookupOrInsertNode(o),I++>1e3)throw new d(y);for(let u of P._util.getServiceDependencies(o.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(u.id);if(!n&&!u.optional&&console.warn(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`),n instanceof D.SyncDescriptor){const a={id:u.id,desc:n,_trace:o._trace.branch(u.id,!0)};y.insertEdge(o,a),c.push(a)}}}for(;;){const o=y.roots();if(o.length===0){if(!y.isEmpty())throw new d(y);break}for(const{data:u}of o){if(this._getServiceInstanceOrDescriptor(u.id)instanceof D.SyncDescriptor){const a=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,a)}y.removeNode(u)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,g,E=[],y,I){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(g,E,y,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,g,E,y,I);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(t,g=[],E,y){if(E){const I=new v.IdleValue(()=>this._createInstance(t,g,y));return new Proxy(Object.create(null),{get(c,o){if(o in c)return c[o];let u=I.value,n=u[o];return typeof n!="function"||(n=n.bind(u),c[o]=n),n},set(c,o,u){return I.value[o]=u,!0}})}else return this._createInstance(t,g,y)}}e.InstantiationService=i;var S;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(S||(S={}));class m{constructor(t,g){this.type=t,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return h?new m(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(t){return h?new m(0,t.name):m._None}branch(t,g){let E=new m(2,t.toString());return this._dep.push([t,g,E]),E}stop(){let t=Date.now()-this._start;m._totals+=t;let g=!1;function E(I,c){let o=[],u=new Array(I+1).join("	");for(const[n,a,s]of c._dep)if(a&&s){g=!0,o.push(`${u}CREATES -> ${n}`);let r=E(I+1,s);r&&o.push(r)}else o.push(`${u}uses -> ${n}`);return o.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(t>2||g)&&console.log(y.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Z[175],x([0,1,16,130,59]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends D.ResolvedKeybinding{constructor(b,h){super();if(h.length===0)throw(0,v.illegalArgument)("parts");this._os=b,this._parts=h}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,b=>this._getLabel(b))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,b=>this._getAriaLabel(b))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,b=>this._getElectronAccelerator(b))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,b=>this._getUserSettingsLabel(b))}isWYSIWYG(){return this._parts.every(b=>this._isWYSIWYG(b))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(b=>this._getPart(b))}_getPart(b){return new D.ResolvedKeybindingPart(b.ctrlKey,b.shiftKey,b.altKey,b.metaKey,this._getLabel(b),this._getAriaLabel(b))}getDispatchParts(){return this._parts.map(b=>this._getDispatchPart(b))}getSingleModifierDispatchParts(){return this._parts.map(b=>this._getSingleModifierDispatchPart(b))}}e.BaseResolvedKeybinding=M}),define(Z[176],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class v{constructor(M,P,b,h,d,i,S){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=M,this.keypressParts=M?L(M.getDispatchParts()):[],M&&this.keypressParts.length===0&&(this.keypressParts=L(M.getSingleModifierDispatchParts())),this.bubble=P?P.charCodeAt(0)===94:!1,this.command=this.bubble?P.substr(1):P,this.commandArgs=b,this.when=h,this.isDefault=d,this.extensionId=i,this.isBuiltinExtension=S}}e.ResolvedKeybindingItem=v;function L(D){let M=[];for(let P=0,b=D.length;P<b;P++){const h=D[P];if(!h)return M;M.push(h)}return M}e.removeElementsAfterNulls=L}),define(Z[177],x([0,1,80,59,175,176]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class P extends D.BaseResolvedKeybinding{constructor(h,d){super(d,h.parts)}_keyCodeToUILabel(h){if(this._os===2)switch(h){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(h)}_getLabel(h){return h.isDuplicateModifierCase()?"":this._keyCodeToUILabel(h.keyCode)}_getAriaLabel(h){return h.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(h.keyCode)}_getElectronAccelerator(h){return v.KeyCodeUtils.toElectronAccelerator(h.keyCode)}_getUserSettingsLabel(h){if(h.isDuplicateModifierCase())return"";const d=v.KeyCodeUtils.toUserSettingsUS(h.keyCode);return d&&d.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(h){return P.getDispatchStr(h)}static getDispatchStr(h){if(h.isModifierKey())return null;let d="";return h.ctrlKey&&(d+="ctrl+"),h.shiftKey&&(d+="shift+"),h.altKey&&(d+="alt+"),h.metaKey&&(d+="meta+"),d+=v.KeyCodeUtils.toString(h.keyCode),d}_getSingleModifierDispatchPart(h){return h.keyCode===5&&!h.shiftKey&&!h.altKey&&!h.metaKey?"ctrl":h.keyCode===4&&!h.ctrlKey&&!h.altKey&&!h.metaKey?"shift":h.keyCode===6&&!h.ctrlKey&&!h.shiftKey&&!h.metaKey?"alt":h.keyCode===57&&!h.ctrlKey&&!h.shiftKey&&!h.altKey?"meta":null}static _scanCodeToKeyCode(h){const d=v.IMMUTABLE_CODE_TO_KEY_CODE[h];if(d!==-1)return d;switch(h){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(h){if(!h)return null;if(h instanceof L.SimpleKeybinding)return h;const d=this._scanCodeToKeyCode(h.scanCode);return d===0?null:new L.SimpleKeybinding(h.ctrlKey,h.shiftKey,h.altKey,h.metaKey,d)}static resolveUserBinding(h,d){const i=(0,M.removeElementsAfterNulls)(h.map(S=>this._resolveSimpleUserBinding(S)));return i.length>0?[new P(new L.ChordKeybinding(i),d)]:[]}}e.USLayoutResolvedKeybinding=P}),define(Z[178],x([0,1,9]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(D,M){if(D.length===0)return Promise.resolve(!1);const P=[];let b=!1;for(let h of D){if(h===!0)return Promise.resolve(!0);(0,v.isThenable)(h)&&P.push(h.then(d=>{d&&(b=!0)},d=>{M(d),b=!0}))}return v.Promises.settled(P).then(()=>b)}e.handleVetos=L}),define(Z[6],x([0,1,45,4,2,3,5]),function(j,e,v,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function b(){return new Date().toISOString()}var h;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;class d extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=d;class i extends d{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...a){this.checkLogLevel(h.Trace)&&this.log(h.Trace,this.format([n,...a]))}debug(n,...a){this.checkLogLevel(h.Debug)&&this.log(h.Debug,this.format([n,...a]))}info(n,...a){this.checkLogLevel(h.Info)&&this.log(h.Info,this.format([n,...a]))}warn(n,...a){this.checkLogLevel(h.Warning)&&this.log(h.Warning,this.format([n,...a]))}error(n,...a){if(this.checkLogLevel(h.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(h.Error,this.format(s))}else this.log(h.Error,this.format([n,...a]))}critical(n,...a){this.checkLogLevel(h.Critical)&&this.log(h.Critical,this.format([n,...a]))}flush(){}format(n){let a="";for(let s=0;s<n.length;s++){let r=n[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}a+=(s>0?" ":"")+r}return a}}e.AbstractMessageLogger=i;class S extends d{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!M.isWindows}trace(n,...a){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,n,...a):console.log(`[main ${b()}]`,n,...a))}debug(n,...a){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,n,...a):console.log(`[main ${b()}]`,n,...a))}info(n,...a){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,n,...a):console.log(`[main ${b()}]`,n,...a))}warn(n,...a){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,n,...a):console.warn(`[main ${b()}]`,n,...a))}error(n,...a){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,n,...a):console.error(`[main ${b()}]`,n,...a))}critical(n,...a){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,n,...a):console.error(`[main ${b()}]`,n,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class m extends d{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...a){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",n,...a)}debug(n,...a){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...a)}info(n,...a){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",n,...a)}warn(n,...a){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",n,...a)}error(n,...a){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",n,...a)}critical(n,...a){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...a)}dispose(){}flush(){}}e.ConsoleLogger=m;class p extends d{constructor(n,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(a)}trace(n,...a){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(n),...a])}debug(n,...a){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(n),...a])}info(n,...a){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(n),...a])}warn(n,...a){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(n),...a])}error(n,...a){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(n),...a])}critical(n,...a){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(n),...a])}extractMessage(n){return typeof n=="string"?n:(0,v.toErrorMessage)(n,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class t extends d{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const a of this.logServices)a.setLevel(n);super.setLevel(n)}trace(n,...a){for(const s of this.logServices)s.trace(n,...a)}debug(n,...a){for(const s of this.logServices)s.debug(n,...a)}info(n,...a){for(const s of this.logServices)s.info(n,...a)}warn(n,...a){for(const s of this.logServices)s.warn(n,...a)}error(n,...a){for(const s of this.logServices)s.error(n,...a)}critical(n,...a){for(const s of this.logServices)s.critical(n,...a)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=t;class g extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...a){this.logger.trace(n,...a)}debug(n,...a){this.logger.debug(n,...a)}info(n,...a){this.logger.info(n,...a)}warn(n,...a){this.logger.warn(n,...a)}error(n,...a){this.logger.error(n,...a)}critical(n,...a){this.logger.critical(n,...a)}flush(){this.logger.flush()}}e.LogService=g;class E extends D.Disposable{constructor(n,a){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,a){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,a?.always?h.Trace:this.logLevel,a),this.loggers.set(n.toString(),s),a?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class y{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return h.Info}trace(n,...a){}debug(n,...a){}info(n,...a){}warn(n,...a){}error(n,...a){}critical(n,...a){}dispose(){}flush(){}}e.NullLogService=y;function I(u){if(u.verbose)return h.Trace;if(typeof u.logLevel=="string"){const n=c(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function c(u){switch(u){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=c;function o(u){switch(u){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=o});var ee=this&&this.__param||function(j,e){return function(v,L){e(v,L,j)}};define(Z[179],x([0,1,9,17,39,79,48,18,5,6]),function(j,e,v,L,D,M,P,b,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(m){m.ERROR_INVALID_FILE="ERROR_INVALID_FILE",m.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,h.createDecorator)(e.UserConfigurationFileServiceId);let S=class{constructor(p,t,g){this.environmentService=p,this.fileService=t,this.logService=g,this.queue=new v.Queue}async updateSettings(p,t){return this.queue.queue(()=>this.doWrite(p,t))}async doWrite(p,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),p);const{value:g,mtime:E,etag:y}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let I=g.toString();const c=[];if((0,D.parse)(I,c,{allowTrailingComma:!0,allowEmptyContent:!0}),c.length)throw new Error("ERROR_INVALID_FILE");const o=this.getEdits(p,I,t)[0];if(o){I=I.substring(0,o.offset)+o.content+I.substring(o.offset+o.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(I),{etag:y,mtime:E})}catch(u){if(u.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(p,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,p,t)})}getEdits({value:p,path:t},g,E){return t.length?(0,M.setProperty)(g,t,p,E):[{content:JSON.stringify(p,null,E.insertSpaces&&E.tabSize?" ".repeat(E.tabSize):"	"),length:g.length,offset:0}]}};S=he([ee(0,P.IEnvironmentService),ee(1,b.IFileService),ee(2,d.ILogService)],S),e.UserConfigurationFileService=S}),define(Z[180],x([0,1,31,9,16,4,2,8,49,6]),function(j,e,v,L,D,M,P,b,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class i extends P.Disposable{constructor(m){super();this.logService=m,this._onDidErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(m,p){return p.recursive?this.watchRecursive(m,p):this.watchNonRecursive(m)}watchRecursive(m,p){const t={path:this.toFilePath(m),excludes:p.excludes},g=(0,v.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{g(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(m,p){return m.watch(p)}watchNonRecursive(m){const p=this.createNonRecursiveWatcher(this.toFilePath(m),g=>this._onDidChangeFile.fire((0,h.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===d.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)});return(0,P.combinedDisposable)(p,t)}onWatcherLogMessage(m){m.type==="error"&&this._onDidErrorOccur.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,b.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=i}),define(Z[181],x([0,1,31,9,17,23,4,69,2,40,10,63,15,60,142,18,92,6]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class je extends h.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new P.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!0)))),this.watchedResources=d.TernarySearchTree.forUris(u=>{const n=this.getProvider(u.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,u){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:u});const n=new h.DisposableStore;return n.add(u.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(u)))),n.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:o}))),typeof u.onDidErrorOccur=="function"&&n.add(u.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:u}),this.provider.delete(o),(0,h.dispose)(n)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(n){u.push(n)}}),!this.provider.has(o)&&await L.Promises.settled(u)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,u){const n=this.provider.get(o.scheme);return!!(n&&n.capabilities&u)}listCapabilities(){return b.Iterable.map(this.provider,([o,u])=>({scheme:o,capabilities:u.capabilities}))}async withProvider(o){if(!(0,m.isAbsolutePath)(o))throw new g.FileOperationError((0,t.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const u=this.provider.get(o.scheme);if(!u){const n=new Error;throw n.name="ENOPRO",n.message=(0,t.localize)(1,null,o.toString()),n}return u}async withReadProvider(o){const u=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u)||(0,g.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const u=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,u){try{return await this.doResolveFile(o,u)}catch(n){throw(0,g.toFileSystemProviderErrorCode)(n)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,t.localize)(2,null,this.resourceForError(o)),1):(0,g.ensureFileSystemProviderError)(n)}}async doResolveFile(o,u){const n=await this.withProvider(o),a=this.isPathCaseSensitive(n),s=u?.resolveTo,r=u?.resolveSingleChildDescendants,l=u?.resolveMetadata,f=await n.stat(o);let w;return this.toFileStat(n,o,f,void 0,!!l,(k,R)=>(w||(w=d.TernarySearchTree.forUris(()=>!a),w.set(o,!0),s&&w.fill(!0,s)),w.get(k.resource)||w.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&r?R===1:!1))}async toFileStat(o,u,n,a,s,r){const{providerExtUri:l}=this.getExtUri(o),f={resource:u,name:l.basename(u),isFile:(n.type&g.FileType.File)!=0,isDirectory:(n.type&g.FileType.Directory)!=0,isSymbolicLink:(n.type&g.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&g.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,g.etag)({mtime:n.mtime,size:n.size})};if(f.isDirectory&&r(f,a)){try{const w=await o.readdir(u),k=await L.Promises.settled(w.map(async([R,A])=>{try{const F=l.joinPath(u,R),H=s?await o.stat(F):{type:A};return await this.toFileStat(o,F,H,w.length,s,r)}catch(F){return this.logService.trace(F),null}}));f.children=(0,v.coalesce)(k)}catch(w){this.logService.trace(w),f.children=[]}return f}return f}async resolveAll(o){return L.Promises.settled(o.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(o){const u=await this.withProvider(o);try{return!!await u.stat(o)}catch(n){return!1}}async canCreateFile(o,u){try{await this.doValidateCreateFile(o,u)}catch(n){return n}return!0}async doValidateCreateFile(o,u){if(!u?.overwrite&&await this.exists(o))throw new g.FileOperationError((0,t.localize)(3,null,this.resourceForError(o)),3,u)}async createFile(o,u=D.VSBuffer.fromString(""),n){await this.doValidateCreateFile(o,n);const a=await this.writeFile(o,u);return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,a)),a}async writeFile(o,u,n){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(a);try{await this.validateWriteFile(a,o,n)||await this.mkdirp(a,s.dirname(o));let l;if((0,g.hasReadWriteCapability)(a)&&!(u instanceof D.VSBuffer))if((0,p.isReadableStream)(u)){const f=await(0,p.peekStream)(u,3);f.ended?l=D.VSBuffer.concat(f.buffer):l=f}else l=(0,p.peekReadable)(u,f=>D.VSBuffer.concat(f),3);else l=u;!(0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a)&&l instanceof D.VSBuffer?await this.doWriteUnbuffered(a,o,n,l):await this.doWriteBuffered(a,o,n,l instanceof D.VSBuffer?(0,D.bufferToReadable)(l):l)}catch(r){throw new g.FileOperationError((0,t.localize)(4,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),n)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,u,n){if(!!n?.unlock&&!(o.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(u)));let s;try{s=await o.stat(u)}catch(r){return}if((s.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,t.localize)(6,null,this.resourceForError(u)),0,n);if(this.throwIfFileIsReadonly(u,s),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==g.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&n.mtime<s.mtime&&n.etag!==(0,g.etag)({mtime:n.mtime,size:s.size}))throw new g.FileOperationError((0,t.localize)(7,null),3,n);return s}async readFile(o,u){const n=await this.withReadProvider(o);return u?.atomic?this.doReadFileAtomic(n,o,u):this.doReadFile(n,o,u)}async doReadFileAtomic(o,u,n){return new Promise((a,s)=>{this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,u,n);a(r)}catch(r){s(r)}})})}async doReadFile(o,u,n){const a=await this.doReadFileStream(o,u,{...n,preferUnbuffered:!0});return{...a,value:await(0,D.streamToBuffer)(a.value)}}async readFileStream(o,u){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,u)}async doReadFileStream(o,u,n){const a=new M.CancellationTokenSource,s=this.validateReadFile(u,n).then(l=>l,l=>{throw a.cancel(),l});let r;try{return typeof n?.etag=="string"&&n.etag!==g.ETAG_DISABLED&&await s,!((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasFileReadStreamCapability)(o))||(0,g.hasReadWriteCapability)(o)&&n?.preferUnbuffered?r=this.readFileUnbuffered(o,u,n):(0,g.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,u,a.token,n):r=this.readFileBuffered(o,u,a.token,n),{...await s,value:r}}catch(l){r&&await(0,p.consumeStream)(r);const f=(0,t.localize)(8,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(f,l.stat,n):new g.FileOperationError(f,(0,g.toFileOperationResult)(l),n)}}readFileStreamed(o,u,n,a=Object.create(null)){const s=o.readFileStream(u,a,n);return(0,p.transform)(s,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new g.FileOperationError((0,t.localize)(9,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),a)},r=>D.VSBuffer.concat(r))}readFileBuffered(o,u,n,a=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,E.readFileIntoStream)(o,u,s,r=>r,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new g.FileOperationError((0,t.localize)(10,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),a)},n),s}readFileUnbuffered(o,u,n){const a=(0,p.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(u);typeof n?.position=="number"&&(s=s.slice(n.position)),typeof n?.length=="number"&&(s=s.slice(0,n.length)),this.validateReadFileLimits(u,s.byteLength,n),a.end(D.VSBuffer.wrap(s))}catch(s){a.error(s),a.end()}})(),a}async validateReadFile(o,u){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new g.FileOperationError((0,t.localize)(11,null,this.resourceForError(o)),0,u);if(typeof u?.etag=="string"&&u.etag!==g.ETAG_DISABLED&&u.etag===n.etag)throw new g.NotModifiedSinceFileOperationError((0,t.localize)(12,null),n,u);return this.validateReadFileLimits(o,n.size,u),n}validateReadFileLimits(o,u,n){if(n?.limits){let a;if(typeof n.limits.memory=="number"&&u>n.limits.memory&&(a=9),typeof n.limits.size=="number"&&u>n.limits.size&&(a=7),typeof a=="number")throw new g.FileOperationError((0,t.localize)(13,null,this.resourceForError(o)),a)}}async canMove(o,u,n){return this.doCanMoveCopy(o,u,"move",n)}async canCopy(o,u,n){return this.doCanMoveCopy(o,u,"copy",n)}async doCanMoveCopy(o,u,n,a){if(o.toString()!==u.toString())try{const s=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(s,o,r,u,n,a)}catch(s){return s}return!0}async move(o,u,n){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(a,o,s,u,"move",!!n),l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,r==="move"?2:3,l)),l}async copy(o,u,n){const a=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(a,o,s,u,"copy",!!n),l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,r==="copy"?3:2,l)),l}async doMoveCopy(o,u,n,a,s,r){if(u.toString()===a.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,u,n,a,s,r);if(l&&!f&&r&&await this.del(a,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(a)),s==="copy"){if(o===n&&(0,g.hasFileFolderCopyCapability)(o))await o.copy(u,a,{overwrite:r});else{const w=await this.resolve(u);w.isDirectory?await this.doCopyFolder(o,w,n,a):await this.doCopyFile(o,u,n,a)}return s}else return o===n?(await o.rename(u,a,{overwrite:r}),s):(await this.doMoveCopy(o,u,n,a,"copy",r),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(o,u,n,a){if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(o,u,n,a);if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(o,u,n,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(o,u,n,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasReadWriteCapability)(n))return this.doPipeUnbuffered(o,u,n,a)}async doCopyFolder(o,u,n,a){await n.mkdir(a),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async s=>{const r=this.getExtUri(n).providerExtUri.joinPath(a,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),n,r):this.doCopyFile(o,s.resource,n,r)}))}async doValidateMoveCopy(o,u,n,a,s,r){let l=!1;if(o===n){const{providerExtUri:w,isPathCaseSensitive:k}=this.getExtUri(o);if(k||(l=w.isEqual(u,a)),l&&s==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(u),this.resourceForError(a)));if(!l&&w.isEqualOrParent(a,u))throw new Error((0,t.localize)(15,null,this.resourceForError(u),this.resourceForError(a)))}const f=await this.exists(a);if(f&&!l){if(!r)throw new g.FileOperationError((0,t.localize)(16,null,this.resourceForError(u),this.resourceForError(a)),4);if(o===n){const{providerExtUri:w}=this.getExtUri(o);if(w.isEqualOrParent(u,a))throw new Error((0,t.localize)(17,null,this.resourceForError(u),this.resourceForError(a)))}}return{exists:f,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const u=this.isPathCaseSensitive(o);return{providerExtUri:u?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(u,o);const n=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,n)),n}async mkdirp(o,u){const n=[],{providerExtUri:a}=this.getExtUri(o);for(;!a.isEqual(u,a.dirname(u));)try{if(((await o.stat(u)).type&g.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(u)));break}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(a.basename(u)),u=a.dirname(u)}for(let s=n.length-1;s>=0;s--){u=a.joinPath(u,n[s]);try{await o.mkdir(u)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,u){try{await this.doValidateDelete(o,u)}catch(n){return n}return!0}async doValidateDelete(o,u){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!u?.useTrash&&!(n.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(o)));let s;try{s=await n.stat(o)}catch(l){}if(s)this.throwIfFileIsReadonly(o,s);else throw new g.FileOperationError((0,t.localize)(20,null,this.resourceForError(o)),1);if(!!!u?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(o)))}return n}async del(o,u){const n=await this.doValidateDelete(o,u),a=!!u?.useTrash,s=!!u?.recursive;await n.delete(o,{recursive:s,useTrash:a}),this._onDidRunOperation.fire(new g.FileOperationEvent(o,1))}onDidChangeFile(o,u){this._onDidChangeFilesRaw.fire({changes:o});let n,a;{for(const s of o)this.watchedResources.has(s.resource)?(n||(n=[]),n.push(s)):(a||(a=[]),a.push(s));n&&this._onDidFilesChange.fire(new g.FileChangesEvent(n,!u))}if(a){const s=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(a)&&je.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,u={recursive:!1,excludes:[]}){const n=new h.DisposableStore;let a=!1,s=()=>{a=!0};return n.add((0,h.toDisposable)(()=>s())),this.doWatch(o,u).then(r=>{a?(0,h.dispose)(r):s=()=>(0,h.dispose)(r)},r=>this.logService.error(r)),u.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),n.add((0,h.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),n}async doWatch(o,u){const n=await this.withProvider(o),a=this.toWatchKey(n,o,u);let s=this.activeWatchers.get(a);return s||(s={count:0,disposable:n.watch(o,u)},this.activeWatchers.set(a,s)),s.count+=1,(0,h.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,h.dispose)(s.disposable),this.activeWatchers.delete(a)))})}toWatchKey(o,u,n){const{providerExtUri:a}=this.getExtUri(o);return[a.getComparisonKey(u),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,h.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,u,n,a){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{const s=await o.open(u,{create:!0,unlock:n?.unlock??!1});try{(0,p.isReadableStream)(a)||(0,p.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(o,s,a):await this.doWriteReadableBufferedQueued(o,s,a)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,u,n){let a=0,s;if((0,p.isReadableBufferedStream)(n)){if(n.buffer.length>0){const r=D.VSBuffer.concat(n.buffer);await this.doWriteBuffer(o,u,r,r.byteLength,a,0),a+=r.byteLength}if(n.ended)return;s=n.stream}else s=n;return new Promise((r,l)=>{(0,p.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(o,u,f,f.byteLength,a,0)}catch(w){return l(w)}a+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>l(f),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,u,n){let a=0,s;for(;(s=n.read())!==null;)await this.doWriteBuffer(o,u,s,s.byteLength,a,0),a+=s.byteLength}async doWriteBuffer(o,u,n,a,s,r){let l=0;for(;l<a;)l+=await o.write(u,s+l,n.buffer,r+l,a-l)}async doWriteUnbuffered(o,u,n,a){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,u,n,a))}async doWriteUnbufferedQueued(o,u,n,a){let s;a instanceof D.VSBuffer?s=a:(0,p.isReadableStream)(a)?s=await(0,D.streamToBuffer)(a):(0,p.isReadableBufferedStream)(a)?s=await(0,D.bufferedStreamToBuffer)(a):s=(0,D.readableToBuffer)(a),await o.writeFile(u,s.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(o,u,n,a){return this.writeQueue.queueFor(a,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,u,n,a))}async doPipeBufferedQueued(o,u,n,a){let s,r;try{s=await o.open(u,{create:!1}),r=await n.open(a,{create:!0,unlock:!1});const l=D.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,w=0,k=0;do k=await o.read(s,f,l.buffer,w,l.byteLength-w),await this.doWriteBuffer(n,r,l,k,f,w),f+=k,w+=k,w===l.byteLength&&(w=0);while(k>0)}catch(l){throw(0,g.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,u,n,a){return this.writeQueue.queueFor(a,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,u,n,a))}async doPipeUnbufferedQueued(o,u,n,a){return n.writeFile(a,await o.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,u,n,a){return this.writeQueue.queueFor(a,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,u,n,a))}async doPipeUnbufferedToBufferedQueued(o,u,n,a){const s=await n.open(a,{create:!0,unlock:!1});try{const r=await o.readFile(u);await this.doWriteBuffer(n,s,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await n.close(s)}}async doPipeBufferedToUnbuffered(o,u,n,a){const s=await(0,D.streamToBuffer)(this.readFileBuffered(o,u,M.CancellationToken.None));await this.doWriteUnbuffered(n,a,void 0,s)}throwIfFileSystemIsReadonly(o,u){if(o.capabilities&2048)throw new g.FileOperationError((0,t.localize)(22,null,this.resourceForError(u)),6);return o}throwIfFileIsReadonly(o,u){if((u.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,t.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};I.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},I=he([ee(0,y.ILogService)],I),e.FileService=I}),define(Z[182],x([0,1,13,145,3,7,18,93,8,2,49,6,166,112]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends m.AbstractDiskFileSystemProviderChannel{constructor(y,I){super(y,I)}getUriTransformer(y){return p.DefaultURITransformer}transformIncoming(y,I){return M.URI.revive(I)}async delete(y,I,c){if(!c.useTrash)return super.delete(y,I,c);const o=this.transformIncoming(y,I),u=(0,h.normalize)(o.fsPath);try{await v.shell.trashItem(u)}catch(n){throw(0,P.createFileSystemProviderError)(D.isWindows?(0,L.localize)(0,null,(0,h.basename)(u)):(0,L.localize)(1,null,(0,h.basename)(u)),P.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(y,I){return new g(I,this.logService)}}e.DiskFileSystemProviderChannel=t;class g extends d.Disposable{constructor(y,I){super();this.sessionEmitter=y,this.logService=I,this.watcherRequests=new Map}watch(y,I,c){if(c.recursive)throw(0,P.createFileSystemProviderError)("Recursive watcher is not supported from main process",P.FileSystemProviderErrorCode.Unavailable);const o=new d.DisposableStore;this.watcherRequests.set(y,o),o.add((0,d.toDisposable)(()=>this.watcherRequests.delete(y)));const u=o.add(new b.FileWatcher((0,h.normalize)(I.fsPath),n=>this.sessionEmitter.fire((0,i.toFileChanges)(n)),n=>this.onWatcherLogMessage(n),this.logService.getLevel()===S.LogLevel.Trace));return o.add(this.logService.onDidChangeLogLevel(()=>{u.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})),o}onWatcherLogMessage(y){y.type==="error"&&this.sessionEmitter.fire(y.message),this.logService[y.type](y.message)}dispose(){super.dispose(),this.watcherRequests.forEach(y=>(0,d.dispose)(y)),this.watcherRequests.clear()}}}),define(Z[94],x([0,1,6]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,P){switch(P){case v.LogLevel.Trace:return M.trace;case v.LogLevel.Debug:return M.debug;case v.LogLevel.Info:return M.info;case v.LogLevel.Warning:return M.warn;case v.LogLevel.Error:return M.error;case v.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class D extends v.AbstractLogger{constructor(P=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}set logger(P){this._logger=P;for(const{level:b,args:h}of this.buffer)L(P,b).apply(P,h);this.buffer=[]}_log(P,...b){this._logger?L(this._logger,P).apply(this._logger,b):this.getLevel()<=P&&this.buffer.push({level:P,args:b})}trace(P,...b){this._log(v.LogLevel.Trace,P,...b)}debug(P,...b){this._log(v.LogLevel.Debug,P,...b)}info(P,...b){this._log(v.LogLevel.Info,P,...b)}warn(P,...b){this._log(v.LogLevel.Warning,P,...b)}error(P,...b){this._log(v.LogLevel.Error,P,...b)}critical(P,...b){this._log(v.LogLevel.Critical,P,...b)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Z[183],x([0,1,9,17,15,18,5,94,6]),function(j,e,v,L,D,M,P,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const d=5*M.ByteSize.MB;let i=class extends h.AbstractLogger{constructor(p,t,g,E,y){super();this.name=p,this.resource=t,this.donotUseFormatters=E,this.fileService=y,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=p.stack,this._log(h.LogLevel.Error,this.format(t))}else this._log(h.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,this.format(arguments))}flush(){}log(p,t){this._log(p,this.format(t))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,t){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>d&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=t:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${t}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const p=E=>E<10?`0${E}`:E,t=E=>E<10?`00${E}`:E<100?`0${E}`:E,g=new Date;return`${g.getFullYear()}-${p(g.getMonth()+1)}-${p(g.getDate())} ${p(g.getHours())}:${p(g.getMinutes())}:${p(g.getSeconds())}.${t(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}format(p){let t="";for(let g=0;g<p.length;g++){let E=p[g];if(typeof E=="object")try{E=JSON.stringify(E)}catch(y){}t+=(g>0?" ":"")+E}return t}};i=he([ee(4,M.IFileService)],i),e.FileLogger=i;let S=class extends h.AbstractLoggerService{constructor(p,t,g){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=t,this.fileService=g}doCreateLogger(p,t,g){const E=new b.BufferLogService(t);return(0,M.whenProviderRegistered)(p,this.fileService).then(()=>E.logger=this.instantiationService.createInstance(i,(0,D.basename)(p),p,E.getLevel(),!!g?.donotUseFormatters)),E}};S=he([ee(0,h.ILogService),ee(1,P.IInstantiationService),ee(2,M.IFileService)],S),e.FileLoggerService=S}),define(Z[184],x([0,1,4,7,6]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(m){this.service=m,this.onDidChangeLogLevel=v.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(m,p,t){switch(p){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=M;class P{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){P.setLevel(this.channel,m)}static setLevel(m,p){return m.call("setLevel",p)}}e.LogLevelChannelClient=P;class b{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,p){throw new Error(`Event not found: ${p}`)}async call(m,p,t){switch(p){case"createLogger":this.createLogger(L.URI.revive(t[0]),t[1]);return;case"log":return this.log(L.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${p}`)}createLogger(m,p){this.loggers.set(m.toString(),this.loggerService.createLogger(m,p))}consoleLog(m,p){let t=console.log;switch(m){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...p)}log(m,p){const t=this.loggers.get(m.toString());if(!t)throw new Error("Create the logger before logging");for(const[g,E]of p)switch(g){case D.LogLevel.Trace:t.trace(E);break;case D.LogLevel.Debug:t.debug(E);break;case D.LogLevel.Info:t.info(E);break;case D.LogLevel.Warning:t.warn(E);break;case D.LogLevel.Error:t.error(E);break;case D.LogLevel.Critical:t.critical(E);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=b;class h extends D.AbstractLoggerService{constructor(m,p,t){super(m,p);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(m,p)=>{this.channel.call("consoleLog",[m,p])}})}doCreateLogger(m,p,t){return new d(this.channel,m,p,t)}}e.LoggerChannelClient=h;class d extends D.AbstractMessageLogger{constructor(m,p,t,g){super(g?.always);this.channel=m,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[p,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,p){const t=[[m,p]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(m){this.channel.call("log",[this.file,m])}}class i extends D.LogService{constructor(m,p){super(p);this.parent=m,this._register(m.onDidChangeLogLevel(t=>p.setLevel(t)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=i}),define(Z[95],x([0,1,18,6]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(h,d,i,S){try{const m=await new Promise((p,t)=>{j(["spdlog"],p,t)});return m.setFlushOn(L.LogLevel.Trace),m.createAsyncRotatingLogger(h,d,i,S)}catch(m){console.error(m)}return null}function M(h,d,i,S){const m=j.__$__nodeRequire("spdlog");return m.setFlushOn(L.LogLevel.Trace),m.createRotatingLogger(h,d,i,S)}e.createRotatingLogger=M;function P(h,d,i){switch(d){case L.LogLevel.Trace:h.trace(i);break;case L.LogLevel.Debug:h.debug(i);break;case L.LogLevel.Info:h.info(i);break;case L.LogLevel.Warning:h.warn(i);break;case L.LogLevel.Error:h.error(i);break;case L.LogLevel.Critical:h.critical(i);break;default:throw new Error("Invalid log level")}}class b extends L.AbstractMessageLogger{constructor(d,i,S,m){super();this.name=d,this.filepath=i,this.rotating=S,this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const d=this.rotating?6:1,i=30/d*v.ByteSize.MB;return D(this.name,this.filepath,i,d).then(S=>{if(S){this._logger=S,this._logger.setLevel(this.getLevel());for(const{level:m,message:p}of this.buffer)P(this._logger,m,p);this.buffer=[]}})}log(d,i){this._logger?P(this._logger,d,i):this.getLevel()<=d&&this.buffer.push({level:d,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=b}),define(Z[185],x([0,1,10,15,28,18,183,6,95]),function(j,e,v,L,D,M,P,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let d=class extends b.AbstractLoggerService{constructor(S,m){super(S.getLevel(),S.onDidChangeLogLevel);this.fileService=m}doCreateLogger(S,m,p){if(S.scheme===v.Schemas.file){const t=new h.SpdLogLogger(p?.name||(0,D.generateUuid)(),S.fsPath,!p?.donotRotate,m);return p?.donotUseFormatters&&t.clearFormatters(),t}else return new P.FileLogger(p?.name??(0,L.basename)(S),S,m,!!p?.donotUseFormatters,this.fileService)}};d=he([ee(0,b.ILogService),ee(1,M.IFileService)],d),e.LoggerService=d}),define(Z[186],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function L(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function D(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function M(P){return!v(P)&&!L(P)&&!D(P)}e.isMenubarMenuItemAction=M}),define(Z[50],x([0,1,10,3,32,15]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const b=L.globals.vscode.context.configuration();if(b)P=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const b=(0,M.dirname)(v.FileAccess.asFileUri("",j));P=j.__$__nodeRequire((0,M.joinPath)(b,"product.json").fsPath);const h=j.__$__nodeRequire((0,M.joinPath)(b,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:h.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.62.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P}),define(Z[96],x([0,1,29,247,9,17,4,33,8,3,15,60,20,146,18,92,93,171,172,173,50,180,45]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(v)}catch(s){console.error(`Error enabling graceful-fs: ${(0,n.toErrorMessage)(s)}`)}})();class a extends u.AbstractDiskFileSystemProvider{constructor(r,l){super(r);this.options=l,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:l,symbolicLink:f}=await m.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(l,f),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(r){try{const l=await m.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),f=[];return await Promise.all(l.map(async w=>{try{let k;w.isSymbolicLink()?k=(await this.stat((0,i.joinPath)(r,w.name))).type:k=this.toType(w),f.push([w.name,k])}catch(k){this.logService.trace(k)}})),f}catch(l){throw this.toFileSystemProviderError(l)}}toType(r,l){let f;return l?.dangling?f=t.FileType.Unknown:r.isFile()?f=t.FileType.File:r.isDirectory()?f=t.FileType.Directory:f=t.FileType.Unknown,l&&(f|=t.FileType.SymbolicLink),f}async readFile(r){try{const l=this.toFilePath(r);return await m.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(r,l,f){const w=(0,S.newWriteableStream)(k=>M.VSBuffer.concat(k.map(R=>M.VSBuffer.wrap(R))).buffer);return(0,g.readFileIntoStream)(this,r,w,k=>k.buffer,{...l,bufferSize:256*1024},f),w}async writeFile(r,l,f){let w;try{const k=this.toFilePath(r);if(!f.create||!f.overwrite){if(await m.Promises.exists(k)){if(!f.overwrite)throw(0,t.createFileSystemProviderError)((0,p.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!f.create)throw(0,t.createFileSystemProviderError)((0,p.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:f.unlock}),await this.write(w,0,l,0,l.byteLength)}catch(k){throw await this.toFileSystemProviderWriteError(r,k)}finally{typeof w=="number"&&await this.close(w)}}async open(r,l){try{const f=this.toFilePath(r);if((0,t.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:R}=await m.SymlinkSupport.stat(f);R.mode&128||await m.Promises.chmod(f,R.mode|128)}catch(R){this.logService.trace(R)}let w;if((0,t.isFileOpenForWriteOptions)(l)){if(d.isWindows)try{await m.Promises.truncate(f,0),w="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}w||(w="w")}else w="r";const k=await m.Promises.open(f,w);return this.mapHandleToPos.set(k,0),(0,t.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(k,r),k}catch(f){throw(0,t.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(r,f):this.toFileSystemProviderError(f)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await m.Promises.fdatasync(r)}catch(l){this.canFlush=!1,this.logService.error(l)}return await m.Promises.close(r)}catch(l){throw this.toFileSystemProviderError(l)}}async read(r,l,f,w,k){const R=this.normalizePos(r,l);let A=null;try{const F=await m.Promises.read(r,f,w,k,R);return typeof F=="number"?A=F:A=F.bytesRead,A}catch(F){throw this.toFileSystemProviderError(F)}finally{this.updatePos(r,R,A)}}normalizePos(r,l){return l===this.mapHandleToPos.get(r)?null:l}updatePos(r,l,f){const w=this.mapHandleToPos.get(r);typeof w=="number"&&(typeof l=="number"||(typeof f=="number"?this.mapHandleToPos.set(r,w+f):this.mapHandleToPos.delete(r)))}async write(r,l,f,w,k){return(0,D.retry)(()=>this.doWrite(r,l,f,w,k),100,3)}async doWrite(r,l,f,w,k){const R=this.normalizePos(r,l);let A=null;try{const F=await m.Promises.write(r,f,w,k,R);return typeof F=="number"?A=F:A=F.bytesWritten,A}catch(F){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),F)}finally{this.updatePos(r,R,A)}}async mkdir(r){try{await m.Promises.mkdir(this.toFilePath(r))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(r,l){try{const f=this.toFilePath(r);await this.doDelete(f,l)}catch(f){throw this.toFileSystemProviderError(f)}}async doDelete(r,l){l.recursive?await m.Promises.rm(r,m.RimRafMode.MOVE):await m.Promises.unlink(r)}async rename(r,l,f){const w=this.toFilePath(r),k=this.toFilePath(l);if(w!==k)try{await this.validateTargetDeleted(r,l,"move",f.overwrite),await m.Promises.move(w,k)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,p.localize)(2,null,(0,h.basename)(w),(0,h.basename)((0,h.dirname)(k)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(r,l,f){const w=this.toFilePath(r),k=this.toFilePath(l);if(w!==k)try{await this.validateTargetDeleted(r,l,"copy",f.overwrite),await m.Promises.copy(w,k,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,p.localize)(3,null,(0,h.basename)(w),(0,h.basename)((0,h.dirname)(k)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(r,l,f,w){const k=this.toFilePath(r),R=this.toFilePath(l);let A=!1;if(!!(this.capabilities&1024)||(A=(0,b.isEqual)(k,R,!0)),A&&f==="copy")throw(0,t.createFileSystemProviderError)((0,p.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!A&&await m.Promises.exists(R)){if(!w)throw(0,t.createFileSystemProviderError)((0,p.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,l,f,w){let k,R=!1;return this.options?.watcher?.usePolling?R=!1:this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?R=this.options.legacyWatcher==="on":o.default.quality==="stable"&&(R=r===1),R?d.isLinux?k=c.FileWatcher:k=y.FileWatcher:k=I.FileWatcher,new k(A=>l(A),A=>f(A),w,this.options?.watcher)}doWatch(r,l){const f=this.options?.watcher?.usePolling;if(f===!0)for(const w of l)w.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(f))for(const w of l)f.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,l)}createNonRecursiveWatcher(r,l,f,w){return new E.FileWatcher(r,k=>l(k),k=>f(k),w)}toFileSystemProviderError(r){if(r instanceof t.FileSystemProviderError)return r;let l;switch(r.code){case"ENOENT":l=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=t.FileSystemProviderErrorCode.NoPermissions;break;default:l=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(r,l)}async toFileSystemProviderWriteError(r,l){let f=this.toFileSystemProviderError(l);if(r&&f.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await m.SymlinkSupport.stat(this.toFilePath(r));w.mode&128||(f=(0,t.createFileSystemProviderError)(l,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.logService.trace(w)}return f}}e.DiskFileSystemProvider=a}),define(Z[21],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Z[187],x([0,1,61,6,21]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(b,h){this.productService=b,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(b,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const d=/^(.*)#([^#]+)$/.exec(h);if(!d)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,i,S]=d;let m=this.trustedExtensionUrlPublicKeys.get(b);if(!m){if(m=this.productService.trustedExtensionUrlPublicKeys[b],!m||m.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",b),!1;this.trustedExtensionUrlPublicKeys.set(b,[...m])}const p=Buffer.from(decodeURIComponent(S),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const t=p.slice(0,6),g=p.readUIntBE(0,6),E=Date.now()-g;if(E<0||E>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const y=p.slice(6),I=v.createVerify("SHA256");I.write(t),I.write(Buffer.from(i)),I.end();for(let c=0;c<m.length;c++){let o=m[c];if(o!==null){if(typeof o=="string")try{o=v.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),m[c]=o}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${b}:`,u),m[c]=null;continue}if(I.verify(o,y))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};M=he([ee(0,D.IProductService),ee(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Z[57],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Z[188],x([0,1,13,2,40,10,3,15,7,28,48,6]),function(j,e,v,L,D,M,P,b,h,d,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends L.Disposable{constructor(t,g){super();this.logService=g,this.validRoots=D.TernarySearchTree.forUris(()=>!P.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(h.URI.file(t.appRoot)),this.addValidFileRoot(h.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=v.session;t.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,E)=>this.handleResourceRequest(g,E)),t.protocol.interceptFileProtocol(M.Schemas.file,(g,E)=>this.handleFileRequest(g,E)),this._register((0,L.toDisposable)(()=>{t.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?L.Disposable.None:(this.validRoots.set(t,!0),(0,L.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,g){const E=h.URI.parse(t.url);return this.logService.error(`Refused to load resource ${E.fsPath} from ${M.Schemas.file}: protocol (original URL: ${t.url})`),g({error:-3})}handleResourceRequest(t,g){const E=h.URI.parse(t.url),y=M.FileAccess.asFileUri(E);return this.validRoots.findSubstr(y)?g({path:y.fsPath}):this.validExtensions.has((0,b.extname)(y))?g({path:y.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${y.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),g({error:-3}))}createIPCObjectUrl(){let t;const g=h.URI.from({scheme:"vscode",path:(0,d.generateUuid)()}),E=g.toString(),y=async()=>t;return v.ipcMain.handle(E,y),this.logService.trace(`IPC Object URL: Registered new channel ${E}.`),{resource:g,update:I=>t=I,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${E}.`),v.ipcMain.removeHandler(E)}}}};m=he([ee(0,i.INativeEnvironmentService),ee(1,S.ILogService)],m),e.ProtocolMainService=m}),define(Z[37],x([0,1,104,14]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(P,b){v.ok(L.isString(P)),v.ok(L.isObject(b)),v.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,b)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new D}),define(Z[189],x([0,1,4,37]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class M{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,d){this.schemasById[D(h)]=d,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new M;L.Registry.add(e.Extensions.JSONContribution,P)}),define(Z[51],x([0,1,31,4,14,134,189,37]),function(j,e,v,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var d;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=b.Registry.as(P.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(c,o=!0){this.registerConfigurations([c],o)}registerConfigurations(c,o=!0){const u=this.doRegisterConfigurations(c,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(c){const o=this.doDeregisterConfigurations(c);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:c,remove:o}){const u=[];u.push(...this.doDeregisterConfigurations(o)),u.push(...this.doRegisterConfigurations(c,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,v.distinct)(u))}registerDefaultConfigurations(c){const o=[],u=[];for(const n of c)for(const a in n)if(o.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]={...this.defaultValues[a]||{},...n[a]};const s={type:"object",default:this.defaultValues[a],description:M.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};u.push(p(a)),this.configurationProperties[a]=s,this.defaultLanguageConfigurationOverridesNode.properties[a]=s}else{this.defaultValues[a]=n[a];const s=this.configurationProperties[a];s&&(this.updatePropertyDefaultValue(a,s),this.updateSchema(a,s))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(c){const o=[];for(const u of c)for(const n in u)if(o.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const a=this.configurationProperties[n];a&&(this.updatePropertyDefaultValue(n,a),this.updateSchema(n,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const o of c)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,o){const u=[];return c.forEach(n=>{u.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),u}doDeregisterConfigurations(c){const o=[],u=n=>{if(n.properties)for(const a in n.properties)o.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,n.properties[a]);n.allOf&&n.allOf.forEach(a=>u(a))};for(const n of c){u(n);const a=this.configurationContributors.indexOf(n);a!==-1&&this.configurationContributors.splice(a,1)}return o}validateAndRegisterProperties(c,o=!0,u,n=3){n=D.isUndefinedOrNull(c.scope)?n:c.scope;let a=[],s=c.properties;if(s)for(let l in s){if(o&&E(l)){delete s[l];continue}const f=s[l];if(this.updatePropertyDefaultValue(l,f),e.OVERRIDE_PROPERTY_PATTERN.test(l)?f.scope=void 0:(f.scope=D.isUndefinedOrNull(f.scope)?n:f.scope,f.restricted=D.isUndefinedOrNull(f.restricted)?!!u?.restrictedConfigurations?.includes(l):f.restricted),s[l].hasOwnProperty("included")&&!s[l].included){this.excludedConfigurationProperties[l]=s[l],delete s[l];continue}else this.configurationProperties[l]=s[l];!s[l].deprecationMessage&&s[l].markdownDeprecationMessage&&(s[l].deprecationMessage=s[l].markdownDeprecationMessage),a.push(l)}let r=c.allOf;if(r)for(let l of r)a.push(...this.validateAndRegisterProperties(l,o,u,n));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(c){const o=u=>{let n=u.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let a=u.allOf;a&&a.forEach(o)};o(c)}updateSchema(c,o){switch(e.allSettings.properties[c]=o,o.scope){case 1:e.applicationSettings.properties[c]=o;break;case 2:e.machineSettings.properties[c]=o;break;case 6:e.machineOverridableSettings.properties[c]=o;break;case 3:e.windowSettings.properties[c]=o;break;case 4:e.resourceSettings.properties[c]=o;break;case 5:e.resourceSettings.properties[c]=o,this.resourceLanguageSettingsSchema.properties[c]=o;break}}removeFromSchema(c,o){switch(delete e.allSettings.properties[c],o.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const o=`[${c}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,o){let u=this.defaultValues[c];D.isUndefined(u)&&(u=o.default),D.isUndefined(u)&&(u=t(o.type)),o.default=u}}const m="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(m);function p(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=p;function t(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=t;const g=new S;b.Registry.add(e.Extensions.Configuration,g);function E(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?M.localize(5,null,I):g.getConfigurationProperties()[I]!==void 0?M.localize(6,null,I):null:M.localize(4,null)}e.validateProperty=E;function y(){const I=[],c=g.getConfigurationProperties();for(const o of Object.keys(c))I.push([o,c[o].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=y}),define(Z[19],x([0,1,43,14,7,51,5,37]),function(j,e,v,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function h(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof D.URI)}e.isConfigurationOverrides=h;var d;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(d=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function S(a,s){const r=s?a?s.keys.filter(F=>a.keys.indexOf(F)===-1):[...s.keys]:[],l=a?s?a.keys.filter(F=>s.keys.indexOf(F)===-1):[...a.keys]:[],f=[];if(s&&a){for(const F of a.keys)if(s.keys.indexOf(F)!==-1){const H=y(a.contents,F),te=y(s.contents,F);v.equals(H,te)||f.push(F)}}const w=[],k=F=>{const H={};for(const te of F)for(const se of te.identifiers)H[u(se)]=te;return H},R=s?k(s.overrides):{},A=a?k(a.overrides):{};if(Object.keys(R).length)for(const F of r){const H=R[F];H&&w.push([(0,M.overrideIdentifierFromKey)(F),H.keys])}if(Object.keys(A).length)for(const F of l){const H=A[F];H&&w.push([(0,M.overrideIdentifierFromKey)(F),H.keys])}if(Object.keys(R).length&&Object.keys(A).length)for(const F of f){const H=A[F],te=R[F];if(H&&te){const se=S({contents:H.contents,keys:H.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});w.push([(0,M.overrideIdentifierFromKey)(F),[...se.added,...se.removed,...se.updated]])}}return{added:r,removed:l,updated:f,overrides:w}}e.compare=S;function m(a,s){const r=[];for(const l of Object.keys(a))if(M.OVERRIDE_PROPERTY_PATTERN.test(l)){const f={};for(const w in a[l])f[w]=a[l][w];r.push({identifiers:[(0,M.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(f),contents:p(f,s)})}return r}e.toOverrides=m;function p(a,s){const r=Object.create(null);for(let l in a)t(r,l,a[l],s);return r}e.toValuesTree=p;function t(a,s,r,l){const f=s.split("."),w=f.pop();let k=a;for(let R=0;R<f.length;R++){let A=f[R],F=k[A];switch(typeof F){case"undefined":F=k[A]=Object.create(null);break;case"object":break;default:l(`Ignoring ${s} as ${f.slice(0,R+1).join(".")} is ${JSON.stringify(F)}`);return}k=F}if(typeof k=="object"&&k!==null)try{k[w]=r}catch(R){l(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}else l(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=t;function g(a,s){const r=s.split(".");E(a,r)}e.removeFromValueTree=g;function E(a,s){const r=s.shift();if(s.length===0){delete a[r];return}if(Object.keys(a).indexOf(r)!==-1){const l=a[r];typeof l=="object"&&!Array.isArray(l)&&(E(l,s),Object.keys(l).length===0&&delete a[r])}}function y(a,s,r){function l(k,R){let A=k;for(const F of R){if(typeof A!="object"||A===null)return;A=A[F]}return A}const f=s.split("."),w=l(a,f);return typeof w=="undefined"?r:w}e.getConfigurationValue=y;function I(a,s,r){Object.keys(s).forEach(l=>{l!=="__proto__"&&(l in a?L.isObject(a[l])&&L.isObject(s[l])?I(a[l],s[l],r):r&&(a[l]=s[l]):a[l]=s[l])})}e.merge=I;function c(){const a=b.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=c;function o(){const a=Object.create(null),s=b.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let r in s){let l=s[r].default;t(a,r,l,f=>console.error(`Conflict in default settings: ${f}`))}return a}e.getDefaultValues=o;function u(a){return`[${a}]`}e.keyFromOverrideIdentifier=u;function n(a,s,r){const l=a.inspect(s),f=a.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=n}),define(Z[190],x([0,1,31,4,39,2,40,43,14,7,19,51,37]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},a=[],s=[]){this._contents=n,this._keys=a,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,a){const s=this.getContentsForOverrideIdentifer(a);return s?n?(0,i.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){for(const a of this.overrides)if(a.identifiers.indexOf(n)!==-1)return a.keys;return[]}override(n){let a=this.overrideConfigurations.get(n);return a||(a=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,a)),a}merge(...n){const a=b.deepClone(this.contents),s=b.deepClone(this.overrides),r=[...this.keys];for(const l of n){this.mergeContents(a,l.contents);for(const f of l.overrides){const[w]=s.filter(k=>v.equals(k.identifiers,f.identifiers));w?this.mergeContents(w.contents,f.contents):s.push(b.deepClone(f))}for(const f of l.keys)r.indexOf(f)===-1&&r.push(f)}return new p(a,r,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const a=this.getContentsForOverrideIdentifer(n);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let s={};for(const r of v.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[r],f=a[r];f&&(typeof l=="object"&&typeof f=="object"?(l=b.deepClone(l),this.mergeContents(l,f)):l=f),s[r]=l}return new p(s,this.keys,this.overrides)}mergeContents(n,a){for(const s of Object.keys(a)){if(s in n&&h.isObject(n[s])&&h.isObject(a[s])){this.mergeContents(n[s],a[s]);continue}n[s]=b.deepClone(a[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?b.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const a of this.overrides)if(a.identifiers.indexOf(n)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,a){this.addKey(n),(0,i.addToValueTree)(this.contents,n,a,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let a=this.keys.length;for(let s=0;s<a;s++)n.indexOf(this.keys[s])===0&&(a=s);this.keys.splice(a,1,n)}removeKey(n){let a=this.keys.indexOf(n);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=p;class t extends p{constructor(){const n=(0,i.getDefaultValues)(),a=(0,i.getConfigurationKeys)(),s=[];for(const r of Object.keys(n))S.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,S.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(n[r]),contents:(0,i.toValuesTree)(n[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(n,a,s)}}e.DefaultConfigurationModel=t;class g{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,a){if(!h.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,a)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,a){this._raw=n;const{contents:s,keys:r,overrides:l,restricted:f}=this.doParseRaw(n,a);this._configurationModel=new p(s,r,l),this._restrictedConfigurations=f||[]}doParseContent(n){let a={},s=null,r=[],l=[],f=[];function w(R){Array.isArray(r)?r.push(R):s!==null&&(r[s]=R)}let k={onObjectBegin:()=>{let R={};w(R),l.push(r),r=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let R=[];w(R),l.push(r),r=R,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:w,onError:(R,A,F)=>{f.push({error:R,offset:A,length:F})}};if(n)try{D.visit(n,k),a=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return a}doParseRaw(n,a){const s=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,s,!0,a);n=r.raw;const l=(0,i.toValuesTree)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),f=Object.keys(n),w=(0,i.toOverrides)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:l,keys:f,overrides:w,restricted:r.restricted}}filter(n,a,s,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:n,restricted:[]};const l={},f=[];for(let w in n)if(S.OVERRIDE_PROPERTY_PATTERN.test(w)&&s){const k=this.filter(n[w],a,!1,r);l[w]=k.raw,f.push(...k.restricted)}else{const k=a[w],R=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&f.push(w),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&k?.restricted||(l[w]=n[w]))}return{raw:l,restricted:f}}}e.ConfigurationModelParser=g;class E extends M.Disposable{constructor(n,a,s,r){super();this.userSettingsResource=n,this.scopes=a,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class y{constructor(n,a,s=new p,r=new p,l=new P.ResourceMap,f=new p,w=new P.ResourceMap,k=!0){this._defaultConfiguration=n,this._localUserConfiguration=a,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=w,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(n,a,s){return this.getConsolidateConfigurationModel(a,s).getValue(n)}updateValue(n,a,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new p,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,a===void 0?r.removeValue(n):r.setValue(n,a),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,a,s){const r=this.getConsolidateConfigurationModel(a,s),l=this.getFolderConfigurationModelForResource(a.resource,s),f=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,w=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),k=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),R=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),F=s?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,H=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(n):l.freeze().getValue(n):void 0,te=a.overrideIdentifier?f.override(a.overrideIdentifier).getValue(n):f.getValue(n),se=r.getValue(n),le=v.distinct(v.flatten(r.overrides.map(Y=>Y.identifiers))).filter(Y=>r.getOverrideValue(n,Y)!==void 0);return{defaultValue:w,userValue:k,userLocalValue:R,userRemoteValue:A,workspaceValue:F,workspaceFolderValue:H,memoryValue:te,value:se,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,workspaceFolder:H!==void 0?{value:l?.freeze().getValue(n),override:a.overrideIdentifier?l?.freeze().getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:f.getValue(n),override:a.overrideIdentifier?f.getOverrideValue(n,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:le.length?le:void 0}}keys(n){const a=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,a){this._folderConfigurations.set(n,a),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,a){const s=a.filter(r=>S.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,S.overrideIdentifierFromKey)(r),f=this._defaultConfiguration.getKeysForOverrideIdentifier(l),w=n.getKeysForOverrideIdentifier(l),k=[...w.filter(R=>f.indexOf(R)===-1),...f.filter(R=>w.indexOf(R)===-1),...f.filter(R=>!b.equals(this._defaultConfiguration.override(l).getValue(R),n.override(l).getValue(R)))];return[l,k]});return this.updateDefaultConfiguration(n),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:a,updated:s,removed:r,overrides:l}=(0,i.compare)(this.localUserConfiguration,n),f=[...a,...s,...r];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:a,updated:s,removed:r,overrides:l}=(0,i.compare)(this.remoteUserConfiguration,n);let f=[...a,...s,...r];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:a,updated:s,removed:r,overrides:l}=(0,i.compare)(this.workspaceConfiguration,n);let f=[...a,...s,...r];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(n,a){const s=this.folderConfigurations.get(n),{added:r,updated:l,removed:f,overrides:w}=(0,i.compare)(s,a);let k=[...r,...l,...f];return(k.length||!s)&&this.updateFolderConfiguration(n,a),{keys:k,overrides:w}}compareAndDeleteFolderConfiguration(n){const a=this.folderConfigurations.get(n);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:r,removed:l,overrides:f}=(0,i.compare)(a,void 0);return{keys:[...s,...r,...l],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,a){let s=this.getConsolidatedConfigurationModelForResource(n,a);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},a){let s=this.getWorkspaceConsolidatedConfiguration();if(a&&n){const r=a.getFolder(n);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const l=this._memoryConfigurationByResource.get(n);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let a=this._foldersConsolidatedConfigurations.get(n);if(!a){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(a=s.merge(r),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(n,a)):a=s}return a}getFolderConfigurationModelForResource(n,a){if(a&&n){const s=a.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,a)=>{const{contents:s,overrides:r,keys:l}=this._folderConfigurations.get(a);return n.push([a,{contents:s,overrides:r,keys:l}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>n.add(a)),this.userConfiguration.freeze().keys.forEach(a=>n.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>n.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>a.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>a.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>a.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(r=>a.add(r))),[...a.values()]}static parse(n){const a=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),r=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((f,w)=>(f.set(d.URI.revive(w[0]),this.parseConfigurationModel(w[1])),f),new P.ResourceMap);return new y(a,s,new p,r,l,new p,new P.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=y;function I(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const n=new Set,a=new Map;for(const r of u)r.keys.forEach(l=>n.add(l)),r.overrides.forEach(([l,f])=>{const w=(0,P.getOrSet)(a,l,new Set);f.forEach(k=>w.add(k))});const s=[];return a.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=I;class c{constructor(n,a,s,r){this.change=n,this.previous=a,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;n.keys.forEach(w=>l.add(w)),n.overrides.forEach(([,w])=>w.forEach(k=>l.add(k))),this.affectedKeys=[...l.values()];const f=new p;this.affectedKeys.forEach(w=>f.setValue(w,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(a){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,a,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(n,a,this.currentWorkspace);return!b.equals(s,r)}return!0}return!1}doesAffectedKeysTreeContains(n,a){let s=(0,i.toValuesTree)({[a]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(n=n[r],!n)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=c;class o extends c{constructor(n,a,s,r){super({keys:n.allKeys(),overrides:[]},void 0,n,a);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=o}),define(Z[191],x([0,1,9,4,2,15,19,190,51,37]),function(j,e,v,L,D,M,P,b,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends D.Disposable{constructor(m,p){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,p)),this.configuration=new b.Configuration(new b.DefaultConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(t=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new b.Configuration(new b.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,p){const t=typeof m=="string"?m:void 0,g=(0,P.isConfigurationOverrides)(m)?m:(0,P.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(t,g,void 0)}updateValue(m,p,t,g){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(t,p,1)}onDidDefaultConfigurationChange(m){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new b.DefaultConfigurationModel,m);this.trigger(t,p,6)}trigger(m,p,t){const g=new b.ConfigurationChangeEvent(m,{data:p},this.configuration);g.source=t,g.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[192],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(P,b=L.Unknown,h){super(P);this._message=P,this._code=b,this._detail=h,this.isHandled=b===L.NotAvailable&&h===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(P){return P instanceof D&&P._code===L.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof D&&P._code===L.NoResolverFound}static isHandled(P){return P instanceof D&&P.isHandled}}e.RemoteAuthorityResolverError=D}),define(Z[193],x([0,1,9,17,23,16,4,2,28,85,192]),function(j,e,v,L,D,M,P,b,h,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var m;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function p(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(W){const z=new D.CancellationTokenSource;return setTimeout(()=>z.cancel(),W),z.token}function g(W,z){if(W.isCancellationRequested||z.isCancellationRequested)return D.CancellationToken.Cancelled;const K=new D.CancellationTokenSource;return W.onCancellationRequested(()=>K.cancel()),z.onCancellationRequested(()=>K.cancel()),K.token}class E{constructor(z){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((K,O)=>{this._resolvePromise=K,this._rejectPromise=O}),z.isCancellationRequested?this._timeout():this._disposables.add(z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(z){this._state==="pending"?this._disposables.add(z):z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(z))}reject(z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(z))}}function y(W,z){const K=new E(z);return K.registerDisposable(W.onControlMessage(O=>{const q=JSON.parse(O.toString()),N=V(q);N?K.reject(N):K.resolve(q)})),K.promise}function I(W,z,K,O,q,N){const $=new E(N);return z.connect(K,O,q,(J,Q)=>{$.didTimeout?(J&&W.error(J),Q?.dispose()):J||!Q?$.reject(J):$.resolve(Q)}),$.promise}function c(W,z){const K=new E(z);return W.then(O=>{K.didTimeout||K.resolve(O)},O=>{K.didTimeout||K.reject(O)}),K.promise}async function o(W,z,K,O){const q=C(W,z);W.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let N;try{N=await I(W.logService,W.socketFactory,W.host,W.port,`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,O)}catch(ae){throw W.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),W.logService.error(ae),ae}W.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let $,J;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(N,null),$=W.reconnectionProtocol,J=!1):($=new d.PersistentProtocol(N,null),J=!0),W.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const Q=await c(W.signService.createNewMessage((0,h.generateUuid)()),O),ne={type:"auth",auth:W.connectionToken||"00000000000000000000",data:Q.data};$.sendControl(L.VSBuffer.fromString(JSON.stringify(ne)));try{const ae=await y($,g(O,t(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const fe=new Error("Unexpected handshake message");throw fe.code="VSCODE_CONNECTION_ERROR",fe}if(W.logService.trace(`${q} 4/6. received SignRequest control message.`),!await c(W.signService.validate(Q,ae.signedData),O)){const fe=new Error("Refused to connect to unsupported server");throw fe.code="VSCODE_CONNECTION_ERROR",fe}const re=await c(W.signService.sign(ae.data),O),ce={type:"connectionType",commit:W.commit,signedData:re,desiredConnectionType:z};return K&&(ce.args=K),W.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),$.sendControl(L.VSBuffer.fromString(JSON.stringify(ce))),{protocol:$,ownsProtocol:J}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(W.logService.error(`${q} the handshake timed out. Error:`),W.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${q} received error control message when negotiating connection. Error:`),W.logService.error(ae)),J&&B($),ae}}async function u(W,z,K,O){const q=Date.now(),N=C(W,z),{protocol:$,ownsProtocol:J}=await o(W,z,K,O),Q=new E(O);return Q.registerDisposable($.onControlMessage(ne=>{const ae=JSON.parse(ne.toString()),ie=V(ae);ie?(W.logService.error(`${N} received error control message when negotiating connection. Error:`),W.logService.error(ie),J&&B($),Q.reject(ie)):(W.reconnectionProtocol&&W.reconnectionProtocol.endAcceptReconnection(),W.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${X(q)}!`),Q.resolve({protocol:$,firstMessage:ae}))})),Q.promise}async function n(W,z){const{protocol:K}=await u(W,1,void 0,z);return{protocol:K}}async function a(W,z,K){const{protocol:O,firstMessage:q}=await u(W,2,z,K),N=q&&q.debugPort;return{protocol:O,debugPort:N}}async function s(W,z,K){const O=Date.now(),q=C(W,3),{protocol:N}=await o(W,3,z,K);return W.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${X(O)}!`),N}async function r(W,z,K){const{host:O,port:q,connectionToken:N}=await W.addressProvider.getAddress();return{commit:W.commit,host:O,port:q,connectionToken:N,reconnectionToken:z,reconnectionProtocol:K,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function l(W,z,K){try{const O=(0,h.generateUuid)(),q=await r(W,O,null),{protocol:N}=await n(q,D.CancellationToken.None);return new Y(W,z,K,O,N)}catch(O){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(O),le.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentManagement=l;async function f(W,z){try{const K=(0,h.generateUuid)(),O=await r(W,K,null),{protocol:q,debugPort:N}=await a(O,z,D.CancellationToken.None);return new T(W,z,K,q,N)}catch(K){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(K),le.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentExtensionHost=f;async function w(W,z,K){const O=await r(W,(0,h.generateUuid)(),null);return await s(O,{host:z,port:K},D.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function k(W){return(0,v.createCancelablePromise)(z=>new Promise((K,O)=>{const q=setTimeout(K,W*1e3);z.onCancellationRequested(()=>{clearTimeout(q),K()})}))}var R;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(z,K){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.type=0}}e.ConnectionLostEvent=A;class F{constructor(z,K,O,q){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.durationSeconds=O,this.cancellableTimer=q,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class H{constructor(z,K,O){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=H;class te{constructor(z,K,O){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=O,this.type=4}}e.ConnectionGainEvent=te;class se{constructor(z,K,O,q){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=O,this.handled=q,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class le extends b.Disposable{constructor(z,K,O,q){super();this._connectionType=z,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=K,this.reconnectionToken=O,this.protocol=q,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(q.onSocketClose(N=>{const $=U(this._connectionType,this.reconnectionToken,!0);N?N.type===0?(this._options.logService.info(`${$} received socket close event (hadError: ${N.hadError}).`),N.error&&this._options.logService.error(N.error)):(this._options.logService.info(`${$} received socket close event (wasClean: ${N.wasClean}, code: ${N.code}, reason: ${N.reason}).`),N.event&&this._options.logService.error(N.event)):this._options.logService.info(`${$} received socket close event.`),this._beginReconnecting()})),this._register(q.onSocketTimeout(()=>{const N=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${N} received socket timeout event.`),this._beginReconnecting()})),le._instances.push(this),le._permanentFailure&&this._gotoPermanentFailure(le._permanentFailureMillisSinceLastIncomingData,le._permanentFailureAttempt,le._permanentFailureHandled)}static triggerPermanentFailure(z,K,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=z,this._permanentFailureAttempt=K,this._permanentFailureHandled=O,this._instances.forEach(q=>q._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(le._permanentFailure)return;const z=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const q=O<K.length?K[O]:K[K.length-1];try{if(q>0){const $=k(q);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,$)),this._options.logService.info(`${z} waiting for ${q} seconds before reconnecting...`);try{await $}catch{}}if(le._permanentFailure){this._options.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${z} resolving connection...`);const N=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${z} connecting to ${N.host}:${N.port}...`),await this._reconnect(N,t(S)),this._options.logService.info(`${z} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(N){if(N.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(N),le.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(N),le.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(N)){this._options.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((N.code==="ETIMEDOUT"||N.code==="ENETUNREACH"||N.code==="ECONNREFUSED"||N.code==="ECONNRESET")&&N.syscall==="connect"){this._options.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((0,M.isPromiseCanceledError)(N)){this._options.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if(N instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(N),le.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,i.RemoteAuthorityResolverError.isHandled(N));break}this._options.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(N),le.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!le._permanentFailure)}_gotoPermanentFailure(z,K,O){this._onDidStateChange.fire(new se(this.reconnectionToken,z,K,O)),B(this.protocol)}}le._permanentFailure=!1,le._permanentFailureMillisSinceLastIncomingData=0,le._permanentFailureAttempt=0,le._permanentFailureHandled=!1,le._instances=[];class Y extends le{constructor(z,K,O,q,N){super(1,z,q,N);this.client=this._register(new d.Client(N,{remoteAuthority:K,clientId:O},z.ipcLogger))}async _reconnect(z,K){await n(z,K)}}e.ManagementPersistentConnection=Y;class T extends le{constructor(z,K,O,q,N){super(2,z,O,q);this._startArguments=K,this.debugPort=N}async _reconnect(z,K){await a(z,this._startArguments,K)}}e.ExtensionHostPersistentConnection=T;function B(W){try{W.acceptDisconnect();const z=W.getSocket();W.dispose(),z.dispose()}catch(z){(0,M.onUnexpectedError)(z)}}function V(W){if(W&&W.type==="error"){const z=new Error(`Connection error: ${W.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function _(W,z){for(;W.length<z;)W+=" ";return W}function U(W,z,K){return`[remote-connection][${_(p(W),13)}][${z.substr(0,5)}\u2026][${K?"reconnect":"initial"}]`}function C(W,z){return`${U(z,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function X(W){return`${Date.now()-W} ms`}}),define(Z[64],x([0,1,10]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(d){return d.scheme===v.Schemas.vscodeRemote?d.authority:void 0}e.getRemoteAuthority=L;function D(d){if(!d)return;const i=d.indexOf("+");return i<0?d:d.substr(0,i)}e.getRemoteName=D;function M(d){return d.scheme!==v.Schemas.file&&d.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=M;function P(d){if(d.folders.length)return d.folders.every(i=>M(i.uri))?d.folders[0].uri:void 0;if(d.configuration&&M(d.configuration))return d.configuration}e.getVirtualWorkspaceLocation=P;function b(d){return P(d)?.scheme}e.getVirtualWorkspaceScheme=b;function h(d){return P(d)!==void 0}e.isVirtualWorkspace=h}),define(Z[194],x([0,1,25,5,64]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=M;function P(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));class h{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,t){if(typeof p=="undefined"||p===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof p=="string"||typeof t=="string"){let g=typeof p=="string"?p:p.value,E=typeof t=="string"?t:t.value;return v.equalsIgnoreCase(g,E)}return p._lower===t._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=h;function d(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=d;function i(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function S(m,p){if(p&&m.enableProposedApi){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(p)}`;return m.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[195],x([0,1,25,194]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,g){return t.uuid&&g.uuid?t.uuid===g.uuid:t.id===g.id?!0:(0,v.compareIgnoreCase)(t.id,g.id)===0}e.areSameExtensions=D;class M{constructor(g,E){this.version=E,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?D(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function P(t,g){return`${t}.${g}`}e.getExtensionId=P;function b(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=b;function h(t,g){return b(P(t,g))}e.getGalleryExtensionId=h;function d(t,g){const E=[],y=I=>{for(const c of E)if(c.some(o=>D(g(o),g(I))))return c;return null};for(const I of t){const c=y(I);c?c.push(I):E.push([I])}return E}e.groupByExtension=d;function i(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function S(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function m(t){const g=new Set;for(const E of t)E.malicious&&g.add(E.id.id);return g}e.getMaliciousExtensionsSet=m;function p(t,g){const E=[],y=g.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const I=y.shift();if(I&&E.every(c=>!D(c.identifier,{id:I}))){const c=t.filter(o=>D(o.identifier,{id:I}));c.length===1&&(E.push(c[0]),y.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=p}),define(Z[97],x([0,1,4,3,5,6]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var P;(function(t){t.Http="http",t.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function d(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=d,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=S;function m(t,g){return g?g!==1&&t<1024:!L.isWindows&&t<1024}e.isPortPrivileged=m;let p=class{constructor(g){this.logService=g,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,E){return this._tunnelProvider=g,g?(this._canElevate=E.elevation,this._privacyOptions=E.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],E=Array.from(this._tunnels.values());for(let y of E){const I=Array.from(y.values());for(let c of I){const o=await c.value;o&&g.push(o)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:E}of g.values())await E.then(y=>y?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,E,y,I,c=!1,o=b.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${y} on local port ${I}.`),!g)return;E||(E="localhost");const n=this.retainOrCreateTunnel(g,E,y,I,c,o,u);return n?n.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(a);return(a.tunnelRemoteHost!==E||a.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const E=this._tunnels.get(g.tunnelRemoteHost);if(E){const y=E.get(g.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,y))}}}}async tryDisposeTunnel(g,E,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${E}.`);const I=y.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(E),I}}async closeTunnel(g,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${E} `);const y=this._tunnels.get(g);if(y&&y.has(E)){const I=y.get(E);I.refcount=0,await this.tryDisposeTunnel(g,E,I)}}addTunnelToMap(g,E,y){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(E,{refcount:1,value:y})}async removeEmptyTunnelFromMap(g,E){const y=this._tunnels.get(g);y&&(await y.get(E)||y.delete(E),y.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,E){let y=[g];i(g)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):S(g)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const I=y.map(c=>this._tunnels.get(c));for(const c of I){const o=c?.get(E);if(o)return o}}canTunnel(g){return!!d(g)}createWithProvider(g,E,y,I,c,o,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${y} on local port ${I}.`);const a={elevationRequired:c?m(I===void 0?y:I):!1},s={remoteAddress:{host:E,port:y},localAddressPort:I,privacy:o,public:o!==b.Private,protocol:u},r=g.forwardPort(s,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(E,y,r),r}};p=he([ee(0,M.ILogService)],p),e.AbstractTunnelService=p}),define(Z[52],x([0,1,17,150,51,5,37]),function(j,e,v,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function b(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=b;function h(t){return t.res.statusCode===204}async function d(t){if(!b(t))throw new Error("Server returned "+t.res.statusCode);return h(t)?null:(await(0,v.streamToBuffer)(t.stream)).toString()}e.asText=d;async function i(t){if(!b(t))throw new Error("Server returned "+t.res.statusCode);if(h(t))return null;const E=(await(0,v.streamToBuffer)(t.stream)).toString();try{return JSON.parse(E)}catch(y){throw y.message+=`:
`+E,y}}e.asJson=i;function S(t){p(t)}e.updateProxyConfigurationsScope=S;let m;function p(t){const g=P.Registry.as(D.Extensions.Configuration),E=m;m={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[m],remove:E?[E]:[]})}p(2)}),define(Z[196],x([0,1,197,14]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(P,b){return P.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:P.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function M(P,b,h={}){const d=(0,v.parse)(P),i=h.proxyUrl||D(d,b);if(!i)return null;const S=(0,v.parse)(i);if(!/^https?:$/.test(S.protocol||""))return null;const m={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((p,t)=>{j(["http-proxy-agent"],p,t)}))(m):new(await new Promise((p,t)=>{j(["https-proxy-agent"],p,t)}))(m)}e.getProxyAgent=M}),define(Z[198],x([0,1,17,28]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(M,P,b){let h=b&&b.get("storage.serviceMachineId",0)||null;if(h)return h;try{const i=(await P.readFile(M.serviceMachineIdResource)).value.toString();h=(0,L.isUUID)(i)?i:null}catch(d){h=null}if(!h){h=(0,L.generateUuid)();try{await P.writeFile(M.serviceMachineIdResource,v.VSBuffer.fromString(h))}catch(d){}}return b&&b.store("storage.serviceMachineId",h,0,1),h}e.getServiceMachineId=D}),define(Z[77],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[199],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((D,M)=>j(["vsda"],D,M))}async createNewMessage(D){try{const M=await this.vsda(),P=new M.validator;if(P){const b=String(v._nextId++);return this.validators.set(b,P),{id:b,data:P.createNewMessage(D)}}}catch(M){}return{id:"",data:D}}async validate(D,M){if(!D.id)return!0;const P=this.validators.get(D.id);if(!P)return!1;this.validators.delete(D.id);try{return P.validate(M)==="ok"}catch(b){return!1}}async sign(D){try{const M=await this.vsda(),P=new M.signer;if(P)return P.sign(D)}catch(M){}return D}}e.SignService=v,v._nextId=1}),define(Z[38],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Z[22],x([0,1,13,9,4,2,3,32,14,5,178,6,38]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,d.createDecorator)("lifecycleMainService");var p;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class ct extends M.Disposable{constructor(E,y){super();this.logService=E,this.stateMainService=y,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ct.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",E);const y=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",y),v.app.once("will-quit",I=>{this.logService.trace("Lifecycle#app.on(will-quit)"),I.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",E),v.app.removeListener("window-all-closed",y),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(y){E.push(y)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(E)}catch(y){this.logService.error(y)}try{await this.stateMainService.close()}catch(y){this.logService.error(y)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===E)return;this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const y=this.phaseWhen.get(this._phase);y&&(y.open(),this.phaseWhen.delete(this._phase))}async when(E){if(E<=this._phase)return;let y=this.phaseWhen.get(E);y||(y=new L.Barrier,this.phaseWhen.set(E,y)),await y.wait()}registerWindow(E){const y=new M.DisposableStore;this.windowCounter++,y.add(E.onWillLoad(c=>this._onWillLoadWindow.fire({window:E,workspace:c.workspace,reason:c.reason})));const I=(0,h.assertIsDefined)(E.win);I.on("close",c=>{const o=E.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),c.preventDefault(),this.unload(E,1).then(u=>{if(u){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(E),E.close()})}),I.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,y.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(E,y){await this.unload(E,3)||E.reload(y)}async unload(E,y){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const I=this._quitRequested?2:y;let c=await this.onBeforeUnloadWindowInRenderer(E,I);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(E,I),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${E.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${E.id})`),await this.onWillUnloadWindowInRenderer(E,I),!1))}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,y){return new Promise(I=>{const c=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${c}`,u=`vscode:cancel${c}`;v.ipcMain.once(o,()=>{I(!1)}),v.ipcMain.once(u,()=>{I(!0)}),E.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:u,reason:y})})}onBeforeUnloadWindowInMain(E,y){const I=[];return this._onBeforeUnloadWindow.fire({reason:y,window:E,veto(c){I.push(c)}}),(0,i.handleVetos)(I,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(E,y){return new Promise(I=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(o,()=>I()),E.send("vscode:onWillUnload",{replyChannel:o,reason:y})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(y=>{this.pendingQuitPromiseResolve=y,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const y=process.argv.slice(1);if(E?.addArgs&&y.push(...E.addArgs),E?.removeArgs)for(const o of E.removeArgs){const u=y.indexOf(o);u>=0&&y.splice(u,1)}const I=()=>{try{if(P.isWindows){const o=(0,b.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:y})};v.app.once("quit",I),await this.quit(!0)&&v.app.removeListener("quit",I)}async kill(E){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const y of v.BrowserWindow.getAllWindows())if(y&&!y.isDestroyed()){let I;y.webContents&&!y.webContents.isDestroyed()?I=new Promise(c=>y.once("closed",c)):I=Promise.resolve(),y.destroy(),await I}})()]),v.app.exit(E)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=he([ee(0,S.ILogService),ee(1,m.IStateMainService)],t),e.LifecycleMainService=t}),define(Z[200],x([0,1,4,2,5,22]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let P=class extends L.Disposable{constructor(d){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,d.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const d=await new Promise((i,S)=>{j(["native-keymap"],i,S)});this._keyboardLayoutData=b(d),d.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=b(d),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=he([ee(0,M.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function b(h){const d=h.getKeyMap(),i=h.getCurrentKeyboardLayout();return{keyboardMapping:d,keyboardLayoutInfo:i}}}),define(Z[98],x([0,1,9,4,2,63,14,87,5]),function(j,e,v,L,D,M,P,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";e.IStorageService=(0,h.createDecorator)("storageService");var i;(function(E){E[E.NONE=0]="NONE",E[E.SHUTDOWN=1]="SHUTDOWN"})(i=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(E){E[E.GLOBAL=0]="GLOBAL",E[E.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var m;(function(E){E[E.USER=0]="USER",E[E.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class p extends D.Disposable{constructor(y={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,M.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,I){I===d?(y===0?this._globalKeyTargets=void 0:y===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:y})):this._onDidChangeValue.fire({scope:y,key:I,target:this.getKeyTargets(y)[I]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,I,c){return this.getStorage(I)?.get(y,c)}getBoolean(y,I,c){return this.getStorage(I)?.getBoolean(y,c)}getNumber(y,I,c){return this.getStorage(I)?.getNumber(y,c)}store(y,I,c,o){if((0,P.isUndefinedOrNull)(I)){this.remove(y,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,c,o),this.getStorage(c)?.set(y,I)})}remove(y,I){this.withPausedEmitters(()=>{this.updateKeyTarget(y,I,void 0),this.getStorage(I)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,I){const c=[],o=this.getKeyTargets(y);for(const u of Object.keys(o))o[u]===I&&c.push(u);return c}updateKeyTarget(y,I,c){const o=this.getKeyTargets(I);typeof c=="number"?o[y]!==c&&(o[y]=c,this.getStorage(I)?.set(d,JSON.stringify(o))):typeof o[y]=="number"&&(delete o[y],this.getStorage(I)?.set(d,JSON.stringify(o)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(y){return y===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(y){const I=this.get(d,y);if(I)try{return JSON.parse(I)}catch(c){}return Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=i.NONE){this._onWillSaveState.fire({reason:y}),await v.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const y=this.getStorage(0)?.items??new Map,I=this.getStorage(1)?.items??new Map;return g(y,I,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends p{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.globalStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y)))}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(y){}}e.InMemoryStorageService=t;async function g(E,y,I,c){const o=f=>{try{return JSON.parse(f)}catch(w){return f}},u=new Map,n=new Map;E.forEach((f,w)=>{u.set(w,f),n.set(w,o(f))});const a=new Map,s=new Map;y.forEach((f,w)=>{a.set(w,f),s.set(w,o(f))}),console.group(`Storage: Global (path: ${I})`);let r=[];u.forEach((f,w)=>{r.push({key:w,value:f})}),console.table(r),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${c})`);let l=[];a.forEach((f,w)=>{l.push({key:w,value:f})}),console.table(l),console.groupEnd(),console.log(s)}e.logStorage=g}),define(Z[201],x([0,1,3,32,7,28]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(d){if(v.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function b(d,i,S,m,p,t,g,E,y,I){const c=Object.create(null);c["common.machineId"]=g,c.sessionID=(0,M.generateUuid)()+Date.now(),c.commitHash=p,c.version=t,c["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,v.PlatformToString)(v.platform),c["common.nodePlatform"]=L.platform,c["common.nodeArch"]=m,c["common.product"]=I||"desktop";const o=h(E||[]);o&&(c["common.msftInternal"]=o);let u=0;const n=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),v.isLinuxSnap&&(c["common.snap"]="true");const a=P(S);a&&(c["common.platformDetail"]=a);try{const s=await d.readFile(D.URI.file(y));c["common.source"]=s.value.toString().slice(0,30)}catch(s){}return c}e.resolveCommonProperties=b;function h(d){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const S=i.toLowerCase();return d.some(m=>S===m)}e.verifyMicrosoftInternalDomain=h}),define(Z[30],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[202],x([0,1,26,69,9,39,10,8,3,7,71,20,84,75,18,21,30]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function y(n,a){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,l=new Map,f=2e4;function w(A,F,H,te){const se=F.substring(A.length+1);return D.Promises.withAsyncBody(async le=>{let Y;try{Y=await S.Promises.readdir(F,{withFileTypes:!0})}catch(V){le();return}if(te.count>=f){te.count+=Y.length,te.maxReached=!0,le();return}let T=Y.length;if(T===0){le();return}let B=Y;te.count+Y.length>f&&(te.maxReached=!0,T=f-te.count,B=Y.slice(0,T)),te.count+=Y.length;for(const V of B)if(V.isDirectory()){if(H.includes(V.name)||await w(A,(0,b.join)(F,V.name),H,te),--T==0){le();return}}else{const _=V.name.lastIndexOf(".");if(_>=0){const U=V.name.substring(_+1);U&&r.set(U,(r.get(U)??0)+1)}for(const U of s)U.relativePathPattern?.test(se)!==!1&&U.filePattern.test(V.name)&&l.set(U.tag,(l.get(U.tag)??0)+1);if(--T==0){le();return}}})}const k={count:0,maxReached:!1};await w(n,n,a,k);const R=await o(n);return{configFiles:I(l),fileTypes:I(r),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:R}}e.collectWorkspaceStats=y;function I(n){return[...L.Iterable.map(n.entries(),([a,s])=>({name:a,count:s}))].sort((a,s)=>s.count-a.count)}function c(){const n={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(i.virtualMachineHint.value()*100)}%`},a=v.cpus();return a&&a.length>0&&(n.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),n}e.getMachineInfo=c;async function o(n){try{const a=new Map,s=(0,b.join)(n,".vscode","launch.json"),r=await S.Promises.readFile(s),l=[],f=(0,M.parse)(r.toString(),l);if(l.length)return console.log(`Unable to parse ${s}`),[];if((0,M.getNodeType)(f)==="object"&&f.configurations)for(const w of f.configurations){const k=w.type;k&&(a.has(k)?a.set(k,a.get(k)+1):a.set(k,1))}return I(a)}catch(a){return[]}}e.collectLaunchConfigs=o;let u=class{constructor(a,s){this.telemetryService=a,this.productService=s}formatMachineInfo(a){const s=[];return s.push(`OS Version:       ${a.os}`),s.push(`CPUs:             ${a.cpus}`),s.push(`Memory (System):  ${a.memory}`),s.push(`VM:               ${a.vmHint}`),s.join(`
`)}formatEnvironment(a){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const r=v.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||s.push(`Load (avg):       ${v.loadavg().map(l=>Math.round(l)).join(", ")}`),s.push(`VM:               ${Math.round(i.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${a.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(a,s){return Promise.all([(0,m.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async r=>{let[l,f]=r,w=this.formatProcessList(a,l);return s.forEach(k=>{if((0,p.isRemoteDiagnosticError)(k))w+=`
${k.errorMessage}`,f+=`
${k.errorMessage}`;else if(w+=`

Remote: ${k.hostName}`,k.processes&&(w+=`
${this.formatProcessList(a,k.processes)}`),k.workspaceMetadata){f+=`
|  Remote: ${k.hostName}`;for(const R of Object.keys(k.workspaceMetadata)){const A=k.workspaceMetadata[R];let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),f+=`|    Folder (${R}): ${F}`,f+=this.formatWorkspaceStats(A)}}}),{processInfo:w,workspaceInfo:f}})}async getSystemInfo(a,s){const{memory:r,vmHint:l,os:f,cpus:w}=c(),k={os:f,memory:r,cpus:w,vmHint:l,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:s};return h.isWindows||(k.load=`${v.loadavg().map(R=>Math.round(R)).join(", ")}`),h.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(a,s){const r=[];return(0,m.listProcesses)(a.mainPID).then(async l=>(r.push(""),r.push(this.formatEnvironment(a)),r.push(""),r.push(this.formatProcessList(a,l)),a.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(a))),s.forEach(f=>{if((0,p.isRemoteDiagnosticError)(f))r.push(`
${f.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${f.hostName}`),r.push(this.formatMachineInfo(f.machineInfo)),f.processes&&r.push(this.formatProcessList(a,f.processes)),f.workspaceMetadata)for(const w of Object.keys(f.workspaceMetadata)){const k=f.workspaceMetadata[w];let R=`${k.fileCount} files`;k.maxFilesReached&&(R=`more than ${R}`),r.push(`Folder (${w}): ${R}`),r.push(this.formatWorkspaceStats(k))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(a){const s=[],r=60;let l=0;const f=(A,F)=>{const H=` ${A}(${F})`;l+H.length>r?(s.push(w),w="|                 ",l=w.length):l+=H.length,w+=H};let w="|      File types:";const k=10;let R=a.fileTypes.length>k?k:a.fileTypes.length;for(let A=0;A<R;A++){const F=a.fileTypes[A];f(F.name,F.count)}if(s.push(w),a.configFiles.length>=0&&(w="|      Conf files:",l=0,a.configFiles.forEach(A=>{f(A.name,A.count)}),s.push(w)),a.launchConfigFiles.length>0){let A="|      Launch Configs:";a.launchConfigFiles.forEach(F=>{A+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),s.push(A)}return s.join(`
`)}expandGPUFeatures(a){const s=Math.max(...Object.keys(a).map(r=>r.length));return Object.keys(a).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${a[r]}`).join(`
                  `)}formatWorkspaceMetadata(a){const s=[],r=[];return a.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(s.push(`|  Window (${l.title})`),l.folderURIs.forEach(f=>{const w=d.URI.revive(f);if(w.scheme===P.Schemas.file){const k=w.fsPath;r.push(y(k,["node_modules",".git"]).then(R=>{let A=`${R.fileCount} files`;R.maxFilesReached&&(A=`more than ${A}`),s.push(`|    Folder (${(0,b.basename)(k)}): ${A}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${k} (${R.toString()})`)}))}else s.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(l=>s.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}formatProcessList(a,s){const r=new Map;a.windows.forEach(f=>r.set(f.pid,f.title));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(a.mainPID,r,l,s,0),l.join(`
`)}formatProcessItem(a,s,r,l,f){const w=f===0;let k;w?k=l.pid===a?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(f)} ${l.name}`,l.name==="window"&&(k=`${k} (${s.get(l.pid)})`));const R=process.platform==="win32"?l.mem:v.totalmem()*(l.mem/100);r.push(`${l.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(l.children)&&l.children.forEach(A=>this.formatProcessItem(a,s,r,A,f+1))}async reportWorkspaceStats(a){for(const{uri:s}of a.folders){const r=d.URI.revive(s);if(r.scheme!==P.Schemas.file)continue;const l=r.fsPath;try{const f=await y(l,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),f.fileTypes.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:w.name,count:w.count})}),f.launchConfigFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:w.name,count:w.count})}),f.configFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};u=he([ee(0,E.ITelemetryService),ee(1,g.IProductService)],u),e.DiagnosticsService=u}),define(Z[203],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(M){this.appenders=M}listen(M,P){throw new Error(`Event not found: ${P}`)}call(M,P,{eventName:b,data:h}){return this.appenders.forEach(d=>d.log(b,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class L{constructor(M){this.channel=M}log(M,P){return this.channel.call("log",{eventName:M,data:P}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[65],x([0,1,43,14,19,30]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(y,I){return Promise.resolve(void 0)}publicLog2(y,I){return this.publicLog(y,I)}publicLogError(y,I){return Promise.resolve(void 0)}publicLogError2(y,I){return this.publicLogError(y,I)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class b{async publicLog(y,I,c){}async publicLogError(y,I,c){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(E,y){return y.onDidChangeConfiguration(I=>{I.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(I.source),configurationKeys:t(I.sourceConfig)})})}e.configurationTelemetry=h;function d(E,y){return!(y.disableTelemetry||!E.enableTelemetry)}e.supportsTelemetry=d;function i(E){const y=E.getValue(M.TELEMETRY_SETTING_ID),I=E.getValue("telemetry.enableCrashReporter");if(E.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||I===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function S(E){const y=Object.create(null),I=Object.create(null),c=Object.create(null);p(E,c);for(let o in c){o=o.length>150?o.substr(o.length-149):o;const u=c[o];typeof u=="number"?I[o]=u:typeof u=="boolean"?I[o]=u?1:0:typeof u=="string"?y[o]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(y[o]=u)}return{properties:y,measurements:I}}e.validateTelemetryData=S;function m(E){if(!E)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{E.indexOf(`${c}+`)===0&&(y=c)}),y}e.cleanRemoteAuthority=m;function p(E,y,I=0,c){if(!!E)for(let o of Object.getOwnPropertyNames(E)){const u=E[o],n=c?c+o:o;Array.isArray(u)?y[n]=(0,v.safeStringify)(u):u instanceof Date?y[n]=u.toISOString():(0,L.isObject)(u)?I<2?p(u,y,I+1,n+"."):y[n]=(0,v.safeStringify)(u):y[n]=u}}function t(E){if(!E)return[];const y=[];return g(y,"",E),y}function g(E,y,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(c=>g(E,y?`${y}.${c}`:c,I[c])):E.push(y)}}),define(Z[204],x([0,1,31,23,16,43,3,32,7,19,48,168,195,165,18,6,21,52,198,98,30,65]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=P.isWeb?"web":(0,S.getTargetPlatform)(P.platform,b.arch);var a;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(a||(a={}));function s(...N){return String(N.reduce(($,J)=>$|J,0))}var r;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class R{constructor($=k){this.state=$}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage($,J=this.state.pageSize){return new R({...this.state,pageNumber:$,pageSize:J})}withFilter($,...J){const Q=[...this.state.criteria,...J.length?J.map(ne=>({filterType:$,value:ne})):[{filterType:$}]];return new R({...this.state,criteria:Q})}withSortBy($){return new R({...this.state,sortBy:$})}withSortOrder($){return new R({...this.state,sortOrder:$})}withFlags(...$){return new R({...this.state,flags:$.reduce((J,Q)=>J|Q,0)})}withAssetTypes(...$){return new R({...this.state,assetTypes:$})}get raw(){const{criteria:$,pageNumber:J,pageSize:Q,sortBy:ne,sortOrder:ae,flags:ie,assetTypes:re}=this.state;return{filters:[{criteria:$,pageNumber:J,pageSize:Q,sortBy:ne,sortOrder:ae}],assetTypes:re,flags:ie}}get searchText(){const $=this.state.criteria.filter(J=>J.filterType===r.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map($=>String($.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(N,$){const J=(N||[]).filter(Q=>Q.statisticName===$)[0];return J?J.value:0}function F(N){const $="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(Q=>Q.assetType.indexOf($)===0).reduce((Q,ne)=>{const ae=le(N,ne.assetType);return ae&&Q.push([ne.assetType.substring($.length),ae]),Q},[])}function H(N){if(N.properties){const $=N.properties.filter(ne=>ne.key===l.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=$.filter(ne=>J.test(ne.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return le(N,l.Repository)}function te(N){return{uri:`${N.fallbackAssetUri}/${l.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${l.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function se(N){const $=le(N,l.Icon);if($)return $;const J=S.DefaultIconPath;return{uri:J,fallbackUri:J}}function le(N,$){return N.files.filter(Q=>Q.assetType===$)[0]?{uri:`${N.assetUri}/${$}`,fallbackUri:`${N.fallbackAssetUri}/${$}`}:null}function Y(N,$){const J=N.properties?N.properties.filter(ne=>ne.key===$):[],Q=J.length>0&&J[0].value;return Q?Q.split(",").map(ne=>(0,m.adoptToGalleryExtensionId)(ne)):[]}function T(N){const $=N.properties?N.properties.filter(J=>J.key===f.Engine):[];return $.length>0&&$[0].value||""}function B(N){const $=N.properties?N.properties.filter(Q=>Q.key===f.LocalizedLanguages):[],J=$.length>0&&$[0].value||"";return J?J.split(","):[]}function V(N){return N.indexOf("preview")!==-1}function _(N){return N.targetPlatform?(0,S.toTargetPlatform)(N.targetPlatform):"undefined"}function U(N){const $=(0,v.distinct)(N.versions.map(_)),J=!!N.tags?.includes(S.WEB_EXTENSION_TAG),Q=$.indexOf("web");return J?Q===-1&&$.push("web"):Q!==-1&&$.splice(Q,1),$}function C(N,$){const J=(0,S.getFallbackTargetPlarforms)($);for(let Q=0;Q<N.length;Q++){const ne=N[Q];if(ne.version===N[Q-1]?.version){let ae=Q;const ie=_(ne);if(ie===$)for(;ae>0&&N[ae-1].version===ne.version;)ae--;else if(J.includes(ie))for(;ae>0&&N[ae-1].version===ne.version&&_(N[ae-1])!==$;)ae--;ae!==Q&&(N.splice(Q,1),N.splice(ae,0,ne))}}return N}e.sortExtensionVersions=C;function X(N,$,J,Q,ne){const ae=U(N);let ie=N.versions[0];return ie=N.versions.find(re=>re.version===ie.version&&(0,S.isTargetPlatformCompatible)(_(re),ae,ne))||ie,W(N,ie,ae,$,J,Q)}function W(N,$,J,Q,ne,ae){const ie={manifest:le($,l.Manifest),readme:le($,l.Details),changelog:le($,l.Changelog),license:le($,l.License),repository:H($),download:te($),icon:se($),coreTranslations:F($)};return{identifier:{id:(0,m.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:$.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:A(N.statistics,"install"),rating:A(N.statistics,"averagerating"),ratingCount:A(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:J,assets:ie,properties:{dependencies:Y($,f.Dependency),extensionPack:Y($,f.ExtensionPack),engine:T($),localizedLanguages:B($),targetPlatform:_($)},preview:V(N.flags),telemetryData:{index:(ne.pageNumber-1)*ne.pageSize+Q,querySource:ae}}}let z=class{constructor($,J,Q,ne,ae,ie,re,ce){this.requestService=J,this.logService=Q,this.environmentService=ne,this.telemetryService=ae,this.fileService=ie,this.productService=re,this.configurationService=ce;const fe=re.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=q(re.version,re,this.environmentService,this.configurationService,this.fileService,$)}api($=""){return`${this.extensionsGalleryUrl}${$}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions($,J){const Q=[];let ne=new R().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,$.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...$.map(({id:ie})=>ie.toLowerCase()));$.every(ie=>!ie.version)&&(ne=ne.withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties,a.IncludeLatestVersionOnly));const{galleryExtensions:ae}=await this.queryGallery(ne,n,L.CancellationToken.None);for(let ie=0;ie<ae.length;ie++){const re=ae[ie];if(!re.versions.length)continue;const ce=(0,m.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),fe=$.find(de=>(0,m.areSameExtensions)(de,{id:ce}))?.version;if(fe){const de=re.versions.find(Ee=>Ee.version===fe);de&&Q.push(W(re,de,U(re),ie,ne))}else Q.push(X(re,ie,ne,void 0,n))}return Q}async getCompatibleExtension($,J){const Q=(0,S.isIExtensionIdentifier)($)?null:$;if(Q){if((0,S.isNotWebExtensionInWebTargetPlatform)(Q.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(Q,J))return Q}const{id:ne,uuid:ae}=Q?Q.identifier:$;let ie=new R().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");ae?ie=ie.withFilter(r.ExtensionId,ae):ie=ie.withFilter(r.ExtensionName,ne);const{galleryExtensions:re}=await this.queryGallery(ie,J,L.CancellationToken.None),[ce]=re;if(!ce||!ce.versions.length)return null;const fe=U(ce);if((0,S.isNotWebExtensionInWebTargetPlatform)(fe,J))return null;for(let de of ce.versions){if(!T(de)){const Ee=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:f.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(de,fe,J))return W(ce,de,fe,0,ie)}return null}async isExtensionCompatible($,J){if(!(0,S.isTargetPlatformCompatible)($.properties.targetPlatform,$.allTargetPlatforms,J))return!1;let Q=$.properties.engine;if(!Q){const ne=await this.getManifest($,L.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");Q=ne.engines.vscode}return(0,p.isEngineValid)(Q,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible($,J,Q){if(!(0,S.isTargetPlatformCompatible)(_($),J,Q))return!1;const ne=await this.getEngine($);return(0,p.isEngineValid)(ne,this.productService.version,this.productService.date)}async query($,J){const Q=L.CancellationToken.isCancellationToken($)?{}:$,ne=L.CancellationToken.isCancellationToken($)?$:J;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ae=Q.text||"";const ie=(0,M.getOrDefault)(Q,Pe=>Pe.pageSize,50);let re=new R().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,ie).withFilter(r.Target,"Microsoft.VisualStudio.Code");ae?(ae=ae.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Ie,ve)=>(re=re.withFilter(r.Category,ve||Ie),"")),ae=ae.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Ie,ve)=>(re=re.withFilter(r.Tag,ve||Ie),"")),ae=ae.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),ae=ae.trim(),ae&&(ae=ae.length<200?ae:ae.substring(0,200),re=re.withFilter(r.SearchText,ae)),re=re.withSortBy(0)):Q.ids?re=re.withFilter(r.ExtensionId,...Q.ids):Q.names?re=re.withFilter(r.ExtensionName,...Q.names):re=re.withSortBy(4),typeof Q.sortBy=="number"&&(re=re.withSortBy(Q.sortBy)),typeof Q.sortOrder=="number"&&(re=re.withSortOrder(Q.sortOrder));const{galleryExtensions:ce,total:fe}=await this.queryGallery(re,n,ne),de=ce.map((Pe,Ie)=>X(Pe,Ie,re,Q.source,n)),Ee=async(Pe,Ie)=>{if(Ie.isCancellationRequested)throw(0,D.canceled)();const ve=re.withPage(Pe+1),{galleryExtensions:ye}=await this.queryGallery(ve,n,Ie);return ye.map((ke,We)=>X(ke,We,ve,Q.source,n))};return{firstPage:de,total:fe,pageSize:re.pageSize,getPage:Ee}}async queryGallery($,J,Q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,a.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(a.Unpublished));const ne=await this.commonHeadersPromise,ae=JSON.stringify($.raw),ie={...ne,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ae.length)},re=new Date().getTime();let ce,fe,de=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ae,headers:ie},Q),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:de};const Ee=await(0,y.asJson)(ce);if(Ee){const Pe=Ee.results[0],Ie=Pe.extensions;Ie.forEach(ye=>C(ye.versions,J));const ve=Pe.resultMetadata&&Pe.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return de=ve&&ve.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:Ie,total:de}}return{galleryExtensions:[],total:de}}catch(Ee){throw fe=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(ae.length),duration:new Date().getTime()-re,success:!!ce&&(0,y.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:fe?(0,D.isPromiseCanceledError)(fe)?"canceled":(0,D.getErrorMessage)(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic($,J,Q,ne){if(!this.isEnabled())return;const ae=P.isWeb?this.api(`/itemName/${$}.${J}/version/${Q}/statType/${ne==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${$}/extensions/${J}/${Q}/stats?statType=${ne}`),ie=P.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:ie};try{await this.requestService.request({type:"POST",url:ae,headers:ce},L.CancellationToken.None)}catch(fe){}}async download($,J,Q){this.logService.trace("ExtensionGalleryService#download",$.identifier.id);const ne=(0,m.getGalleryExtensionTelemetryData)($),ae=new Date().getTime(),ie=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ne,duration:de}),re=Q===1?"install":Q===2?"update":"",ce=re?{uri:`${$.assets.download.uri}${h.URI.parse($.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${$.assets.download.fallbackUri}${h.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:$.assets.download,fe=await this.getAsset(ce);await this.fileService.writeFile(J,fe.stream),ie(new Date().getTime()-ae)}async getReadme($,J){if($.assets.readme){const Q=await this.getAsset($.assets.readme,{},J);return await(0,y.asText)(Q)||""}return""}async getManifest($,J){if($.assets.manifest){const Q=await this.getAsset($.assets.manifest,{},J),ne=await(0,y.asText)(Q);return ne?JSON.parse(ne):null}return null}async getManifestFromRawExtensionVersion($,J){const Q=le($,l.Manifest);if(!Q)throw new Error("Manifest was not found");const ne={"Accept-Encoding":"gzip"},ae=await this.getAsset(Q,{headers:ne});return await(0,y.asJson)(ae)}async getCoreTranslation($,J){const Q=$.assets.coreTranslations.filter(ne=>ne[0]===J.toUpperCase())[0];if(Q){const ne=await this.getAsset(Q[1]),ae=await(0,y.asText)(ne);return ae?JSON.parse(ae):null}return null}async getChangelog($,J){if($.assets.changelog){const Q=await this.getAsset($.assets.changelog,{},J);return await(0,y.asText)(Q)||""}return""}async getAllCompatibleVersions($,J){let Q=new R().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");$.identifier.uuid?Q=Q.withFilter(r.ExtensionId,$.identifier.uuid):Q=Q.withFilter(r.ExtensionName,$.identifier.id);const{galleryExtensions:ne}=await this.queryGallery(Q,J,L.CancellationToken.None);if(!ne.length)return[];const ae=U(ne[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(ae,J))return[];const ie=[];for(const re of ne[0].versions)try{ie[ie.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,ae,J)&&ie.push({version:re.version,date:re.lastUpdated})}catch(ce){}return ie}async getAsset($,J={},Q=L.CancellationToken.None){const ne=await this.commonHeadersPromise,ae={type:"GET"},ie={...ne,...J.headers||{}};J={...J,...ae,headers:ie};const re=$.uri,ce=$.fallbackUri,fe={...J,url:re};try{const de=await this.requestService.request(fe,Q);if(de.res.statusCode===200)return de;const Ee=await(0,y.asText)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Ee}`)}catch(de){if((0,D.isPromiseCanceledError)(de))throw de;const Ee=(0,D.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:re,message:Ee});const Pe={...J,url:ce};return this.requestService.request(Pe,Q)}}async getEngine($){let J=T($);if(!J){const Q=await this.getManifestFromRawExtensionVersion($,L.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");J=Q.engines.vscode}return J}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const $=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,y.asJson)($),Q=new Map;if(J)for(const ne of J.malicious){const ae=Q.get(ne)||{id:{id:ne},malicious:!0,slow:!1};ae.malicious=!0,Q.set(ne,ae)}return[...Q.values()]}};z=he([ee(1,y.IRequestService),ee(2,g.ILogService),ee(3,i.IEnvironmentService),ee(4,o.ITelemetryService),ee(5,t.IFileService),ee(6,E.IProductService),ee(7,d.IConfigurationService)],z);let K=class extends z{constructor($,J,Q,ne,ae,ie,re,ce){super($,J,Q,ne,ae,ie,re,ce)}};K=he([ee(0,c.IStorageService),ee(1,y.IRequestService),ee(2,g.ILogService),ee(3,i.IEnvironmentService),ee(4,o.ITelemetryService),ee(5,t.IFileService),ee(6,E.IProductService),ee(7,d.IConfigurationService)],K),e.ExtensionGalleryService=K;let O=class extends z{constructor($,J,Q,ne,ae,ie,re){super(void 0,$,J,Q,ne,ae,ie,re)}};O=he([ee(0,y.IRequestService),ee(1,g.ILogService),ee(2,i.IEnvironmentService),ee(3,o.ITelemetryService),ee(4,t.IFileService),ee(5,E.IProductService),ee(6,d.IConfigurationService)],O),e.ExtensionGalleryServiceWithNoStorageService=O;async function q(N,$,J,Q,ne,ae){const ie={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},re=await(0,I.getServiceMachineId)(J,ne,ae);return(0,u.supportsTelemetry)($,J)&&(0,u.getTelemetryLevel)(Q)===3&&(ie["X-Market-User-Id"]=re),ie}e.resolveMarketplaceHeaders=q}),define(Z[205],x([0,1,2,43,3,25,151,19,51,50,37,30,65]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(E,y){this._configurationService=y,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=E.appenders,this._commonProperties=E.commonProperties||Promise.resolve({}),this._piiPaths=E.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!E.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(I),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(I=>{const c=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(E,y){this._experimentProperties[E]=y}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const E=await this._commonProperties;let y=E.sessionID,I=E["common.instanceId"],c=E["common.machineId"],o=E["common.firstSessionDate"],u=E["common.msftInternal"];return{sessionId:y,instanceId:I,machineId:c,firstSessionDate:o,msftInternal:u}}dispose(){this._disposables.dispose()}_log(E,y,I,c){return this.telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(o=>{I=(0,L.mixin)(I,o),I=(0,L.mixin)(I,this._experimentProperties),I=(0,L.cloneAndChange)(I,u=>{if(typeof u=="string")return this._cleanupInfo(u,c)}),this._appenders.forEach(u=>u.log(E,I))},o=>{console.error(o)})}publicLog(E,y,I){return this._log(E,3,y,I)}publicLog2(E,y,I){return this.publicLog(E,y,I)}publicLogError(E,y){return this.sendErrorTelemetry?this._log(E,2,y,!0):Promise.resolve(void 0)}publicLogError2(E,y){return this.publicLogError(E,y)}_anonymizeFilePaths(E){let y=E;const I=[];for(let n of this._cleanupPatterns)for(;;){const a=n.exec(E);if(!a)break;I.push([a.index,n.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(y="";;){const n=o.exec(E);if(!n)break;!c.test(n[0])&&I.every(([a,s])=>n.index<a||n.index>=s)&&(y+=E.substring(u,n.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<E.length&&(y+=E.substr(u)),y}_removePropertiesWithPossibleUserInfo(E){if(!E)return E;const y=E.toLowerCase(),I=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(y)?"<REDACTED: secret>":I.test(y)?"<REDACTED: email>":E}_cleanupInfo(E,y){let I=E;y&&(I=this._anonymizeFilePaths(I));for(let c of this._cleanupPatterns)I=I.replace(c,"");return I=this._removePropertiesWithPossibleUserInfo(I),I}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([ee(1,b.IConfigurationService)],p),e.TelemetryService=p;function t(){const g=(0,P.localize)(0,null,d.default.nameLong),E=d.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=D.isWeb?"":(0,P.localize)(3,null),I=(0,P.localize)(4,null),c=(0,P.localize)(5,null),o=(0,P.localize)(6,null),u=(0,P.localize)(7,null),n=`
|       | ${I} | ${c} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,P.localize)(8,null);return`
${g} ${E} ${y}

&nbsp;

${u}
${n}

&nbsp;

${a}
`}i.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,P.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,P.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[206],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Z[207],x([0,1,109,4,2,5,37,206]),function(j,e,v,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var h;(function(E){function y(I){return I&&typeof I=="object"&&typeof I.id=="string"}E.isThemeColor=y})(h=e.ThemeColor||(e.ThemeColor={}));function d(E){return{id:E}}e.themeColorFromId=d;var i;(function(E){function y(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||h.isThemeColor(a.color))}E.isThemeIcon=y;const I=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function c(a){const s=I.exec(a);if(!s)return;let[,r]=s;return{id:r}}E.fromString=c;function o(a,s){let r=a.id;const l=r.lastIndexOf("~");return l!==-1&&(r=r.substring(0,l)),s&&(r=`${r}~${s}`),{id:r}}E.modify=o;function u(a,s){return a.id===s.id&&a.color?.id===s.color?.id}E.isEqual=u;function n(a,s){return{id:a.id,color:s?d(s):void 0}}E.asThemeIcon=n,E.asClassNameArray=v.CSSIcon.asClassNameArray,E.asClassName=v.CSSIcon.asClassName,E.asCSSSelector=v.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function S(E){switch(E){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,D.toDisposable)(()=>{const I=this.themingParticipants.indexOf(y);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new m;P.Registry.add(e.Extensions.ThemingContribution,p);function t(E){return p.onColorThemeChange(E)}e.registerThemingParticipant=t;class g extends D.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,I){let c=this.theme.getColor(y);return c&&I&&(c=I(c,this.theme)),c?c.toString():null}}e.Themable=g}),define(Z[66],x([0,1,13,3,5,38]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",b="#1E1E1E",h="#000000",d="theme",i="themeBackground",S="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let m=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return h;let t=this.stateMainService.getItem(i,null);if(!t){let g;(L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(d,"vs-dark").split(" ")[0],t=g==="hc-black"?h:g==="vs"?P:b}return L.isMacintosh&&t.toUpperCase()===b&&(t="#171717"),t}saveWindowSplash(t,g){this.stateMainService.setItems([{key:d,data:g.baseTheme},{key:i,data:g.colorInfo.background},{key:S,data:g}]),typeof t=="number"&&this.updateBackgroundColor(t,g)}updateBackgroundColor(t,g){for(const E of v.BrowserWindow.getAllWindows())if(E.id===t){E.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(S)}};m=he([ee(0,M.IStateMainService)],m),e.ThemeMainService=m}),define(Z[41],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var D;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,P)=>({type:"idle",updateType:M,error:P}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Z[208],x([0,1,3,152,51,37]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[209],x([0,1,4,41]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(b){this.service=b}listen(b,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(b,h,d){switch(h){case"checkForUpdates":return this.service.checkForUpdates(d);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=D;class M{constructor(b){this.channel=b,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(b){this._state=b,this._onStateChange.fire(b)}checkForUpdates(b){return this.channel.call("checkForUpdates",b)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Z[99],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Z[210],x([0,1,7]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(b){this.handler=b}listen(b,h){throw new Error(`Event not found: ${h}`)}call(b,h,d){switch(h){case"handleURL":return this.handler.handleURL(v.URI.revive(d[0]),d[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=L;class D{constructor(b){this.channel=b}handleURL(b,h){return this.channel.call("handleURL",[b.toJSON(),h])}}e.URLHandlerChannelClient=D;class M{constructor(b){this.next=b}async routeCall(b,h,d,i){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(d){const S=v.URI.revive(d);if(S&&S.query){const m=/\bwindowId=(\d+)/.exec(S.query);if(m){const p=m[1],t=new RegExp(`window:${p}`),g=b.connections.find(E=>t.test(E.ctx));if(g)return g}}}return this.next.routeCall(b,h,d,i)}routeEvent(b,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=M}),define(Z[211],x([0,1,9,2,7,21]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(d,i){const S=[...this.handlers.values()];return(0,v.first)(S.map(m=>()=>m.handleURL(d,i)),void 0,!1).then(m=>m||!1)}registerHandler(d){return this.handlers.add(d),(0,L.toDisposable)(()=>this.handlers.delete(d))}}e.AbstractURLService=P;let b=class extends P{constructor(d){super();this.productService=d}create(d){let{authority:i,path:S,query:m,fragment:p}=d||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&S&&S.indexOf("/")!==0&&(S=`/${S}`),D.URI.from({scheme:this.productService.urlProtocol,authority:i,path:S,query:m,fragment:p})}};b=he([ee(0,M.IProductService)],b),e.NativeURLService=b}),define(Z[212],x([0,1,13,9,4,2,3,7]),function(j,e,v,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(i){try{return b.URI.parse(i)}catch(S){return null}}class d{constructor(S,m,p,t,g){if(this.urlService=m,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=S,P.isWindows){const I=t.isBuilt?[]:[`"${t.appRoot}"`];I.push("--open-url","--"),v.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,I)}const E=D.Event.map(D.Event.fromNodeEventEmitter(v.app,"open-url",(I,c)=>({event:I,url:c})),({event:I,url:c})=>(I.preventDefault(),c));this.disposables.add(E(I=>{const c=h(I);!c||this.urlService.open(c,{originalUrl:I})})),p.getWindows().filter(I=>I.isReady).length>0?this.flush():D.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const S=[];for(const m of this.uris)await this.urlService.open(m.uri,{originalUrl:m.url})||S.push(m);S.length!==0&&(this.uris=S,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=d}),define(Z[213],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Z[214],x([0,1,13,2,10,7]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class P extends L.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(D.Schemas.vscodeWebview,h)}handleWebviewRequest(h,d){try{const i=M.URI.parse(h.url),S=P.validWebviewFilePaths.get(i.path);if(typeof S=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${S}`,p=D.FileAccess.asFileUri(m,j);return d(decodeURIComponent(p.fsPath))}else return d({error:-10})}catch{}return d({error:-2})}}e.WebviewProtocolProvider=P,P.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[67],x([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(d){return!!d.workspaceUri}e.isWorkspaceToOpen=L;function D(d){return!!d.folderUri}e.isFolderToOpen=D;function M(d){return!!d.fileUri}e.isFileToOpen=M;function P(d){const i=b(d),S=d.getValue("window.menuBarVisibility");return S==="default"||i==="native"&&S==="compact"||v.isMacintosh&&v.isNative?"classic":S}e.getMenuBarVisibility=P;function b(d){if(v.isWeb)return"custom";const i=d.getValue("window");if(i){if(v.isMacintosh&&i.nativeTabs===!0||v.isMacintosh&&i.nativeFullScreen===!1)return"native";const p=d.getValue("workbench.colorCustomizations");if(p?.["window.activeBorder"]||p?.["window.inactiveBorder"])return"custom";const t=i.titleBarStyle;if(t==="native"||t==="custom")return t}return v.isLinux?"native":"custom"}e.getTitleBarStyle=b;function h(d=0){return Math.pow(1.2,d)}e.zoomLevelToZoomFactor=h}),define(Z[36],x([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(d){d[d.INITIAL=1]="INITIAL",d[d.LOAD=2]="LOAD",d[d.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var D;(function(d){d[d.CLOSE=1]="CLOSE",d[d.QUIT=2]="QUIT",d[d.RELOAD=3]="RELOAD",d[d.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var M;(function(d){d[d.CLI=0]="CLI",d[d.DOCK=1]="DOCK",d[d.MENU=2]="MENU",d[d.DIALOG=3]="DIALOG",d[d.DESKTOP=4]="DESKTOP",d[d.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const P=function(d=1){return{width:1024,height:768,mode:d}};e.defaultWindowState=P;var b;(function(d){d[d.Maximized=0]="Maximized",d[d.Normal=1]="Normal",d[d.Minimized=2]="Minimized",d[d.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var h;(function(d){d[d.UNRESPONSIVE=1]="UNRESPONSIVE",d[d.CRASHED=2]="CRASHED",d[d.LOAD=3]="LOAD"})(h=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(Z[215],x([0,1,13,4,2,214,36]),function(j,e,v,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let b=class extends D.Disposable{constructor(d){super();this.windowsMainService=d,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(d,i){let S;if(typeof d.windowId=="number"){const{windowId:m}=d,p=this.windowsMainService.getWindowById(m);if(!p?.win)throw new Error(`Invalid windowId: ${m}`);S=p.win.webContents}else{const{webContentsId:m}=d;if(S=v.webContents.fromId(m),!S)throw new Error(`Invalid webContentsId: ${m}`)}S.isDestroyed()||S.setIgnoreMenuShortcuts(i)}async findInFrame(d,i,S,m){const p=this.getFrameByName(d,i),t=p;if(typeof t.findInFrame=="function"){t.findInFrame(S,{findNext:m.findNext,forward:m.forward});const g=(E,y)=>{y.finalUpdate&&(this._onFoundInFrame.fire(y),p.removeListener("found-in-frame",g))};p.on("found-in-frame",g)}}async stopFindInFrame(d,i,S){const p=this.getFrameByName(d,i);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(S.keepSelection?"keepSelection":"clearSelection")}getFrameByName(d,i){const S=this.windowsMainService.getWindowById(d.windowId);if(!S?.win)throw new Error(`Invalid windowId: ${d}`);const m=S.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===i);if(!m)throw new Error(`Unknown frame: ${i}`);return m}};b=he([ee(0,P.IWindowsMainService)],b),e.WebviewMainService=b}),define(Z[216],x([0,1,9,4,2]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends D.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:h,getActiveWindowId:d}){super();this.disposables=this._register(new D.DisposableStore),L.Event.latch(L.Event.any(b,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>d()),(async()=>{try{const S=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:S}catch(S){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Z[217],x([0,1,40,15,7,5]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var P;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function b(m){const p=m;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=b;function h(m){const p=m;return!!(p&&typeof p=="object"&&D.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=h;class d{constructor(p,t,g,E,y){this._id=p,this._transient=g,this._configuration=E,this._ignorePathCasing=y,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class i{constructor(p,t){this.raw=t,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function S(m){return new i({uri:m,index:0,name:(0,L.basenameOrAuthority)(m)},{uri:m.toString()})}e.toWorkspaceFolder=S}),define(Z[27],x([0,1,33,39,79,34,10,8,3,15,7,155,5,64,217]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(T){return(typeof T=="string"?(0,b.extname)(T):(0,d.extname)(T))===g}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function y(T){return T.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function I(T){return T.hasOwnProperty("folderUri")}e.isRecentFolder=I;function c(T){return T.hasOwnProperty("fileUri")}e.isRecentFile=c;function o(T){const B=T;return typeof B?.id=="string"&&i.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=o;function u(T){if(T.configuration)return{id:T.id,configPath:T.configuration};if(T.folders.length===1)return{id:T.id,uri:T.folders[0].uri}}e.toWorkspaceIdentifier=u;function n(T){const B=T;return typeof B?.id=="string"&&i.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=n;function a(T){const B=T;if(B?.uri)return{id:B.id,uri:i.URI.revive(B.uri)};const V=T;if(V?.configPath)return{id:V.id,configPath:i.URI.revive(V.configPath)};if(T?.id)return{id:T.id}}e.reviveIdentifier=a;function s(T,B){return d.extUriBiasedIgnorePathCase.isEqualOrParent(T,B.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(T){return l(T)||f(T)}e.isStoredWorkspaceFolder=r;function l(T){const B=T;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=l;function f(T){const B=T;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=f;function w(T,B,V,_,U=!h.isWindows,C){if(T.scheme!==_.scheme)return{name:V,uri:T.toString(!0)};let X=B?void 0:C.relativePath(_,T);if(X!==void 0)X.length===0?X=".":h.isWindows&&T.scheme===P.Schemas.file&&!U&&(X=X.replace(/\//g,"\\"));else if(T.scheme===P.Schemas.file)X=T.fsPath,h.isWindows&&(X=(0,M.normalizeDriveLetter)(X),U&&(X=(0,v.toSlashes)(X)));else{if(!C.isEqualAuthority(T.authority,_.authority))return{name:V,uri:T.toString(!0)};X=T.path}return{name:V,path:X}}e.getStoredWorkspaceFolder=w;function k(T,B,V){let _=[],U=new Set;const C=V.dirname(B);for(let X of T){let W;if(l(X))X.path&&(W=V.resolvePath(C,X.path));else if(f(X))try{W=i.URI.parse(X.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(z){console.warn(z)}if(W){let z=V.getComparisonKey(W);if(!U.has(z)){U.add(z);const K=X.name||V.basenameOrAuthority(W);_.push(new t.WorkspaceFolder({uri:W,name:K,index:_.length},X))}}}return _}e.toWorkspaceFolders=k;function R(T,B,V,_,U){let C=A(B,T);const X=U.dirname(B),W=U.dirname(_),z=[],K=F(C.folders);for(const $ of C.folders){const J=l($)?U.resolvePath(X,$.path):i.URI.parse($.uri);let Q;V?Q=!1:Q=!l($)||(0,b.isAbsolute)($.path),z.push(w(J,Q,$.name,W,K,U))}const O={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},q=D.setProperty(T,["folders"],z,O);let N=D.applyEdits(T,q);return C.remoteAuthority===(0,p.getRemoteAuthority)(_)&&(N=D.applyEdits(N,D.removeProperty(N,["remoteAuthority"],O))),N}e.rewriteWorkspaceFileForNewLocation=R;function A(T,B){let V=L.parse(B);if(V&&Array.isArray(V.folders))V.folders=V.folders.filter(_=>r(_));else throw new Error(`${T} looks like an invalid workspace file.`);return V}function F(T){return h.isWindows?T.some(B=>l(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function H(T){return T.workspace&&typeof T.workspace=="object"&&typeof T.workspace.id=="string"&&typeof T.workspace.configPath=="string"}function te(T){return typeof T.folderUri=="string"}function se(T){return typeof T.fileUri=="string"}function le(T,B){const V={workspaces:[],files:[]};if(T){const _=function(C,X){for(let W=0;W<C.length;W++)try{X(C[W],W)}catch(z){B.warn(`Error restoring recent entry ${JSON.stringify(C[W])}: ${z.toString()}. Skip entry.`)}},U=T;if(Array.isArray(U.entries))_(U.entries,C=>{const X=C.label,W=C.remoteAuthority;H(C)?V.workspaces.push({label:X,remoteAuthority:W,workspace:{id:C.workspace.id,configPath:i.URI.parse(C.workspace.configPath)}}):te(C)?V.workspaces.push({label:X,remoteAuthority:W,folderUri:i.URI.parse(C.folderUri)}):se(C)&&V.files.push({label:X,remoteAuthority:W,fileUri:i.URI.parse(C.fileUri)})});else{const C=T;Array.isArray(C.workspaces3)&&_(C.workspaces3,(X,W)=>{const z=Array.isArray(C.workspaceLabels)&&C.workspaceLabels[W]||void 0;typeof X=="object"&&typeof X.id=="string"&&typeof X.configURIPath=="string"?V.workspaces.push({label:z,workspace:{id:X.id,configPath:i.URI.parse(X.configURIPath)}}):typeof X=="string"&&V.workspaces.push({label:z,folderUri:i.URI.parse(X)})}),Array.isArray(C.files2)&&_(C.files2,(X,W)=>{const z=Array.isArray(C.fileLabels)&&C.fileLabels[W]||void 0;typeof X=="string"&&V.files.push({label:z,fileUri:i.URI.parse(X)})})}}return V}e.restoreRecentlyOpened=le;function Y(T){const B={entries:[]};for(const V of T.workspaces)I(V)?B.entries.push({folderUri:V.folderUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority}):B.entries.push({workspace:{id:V.workspace.id,configPath:V.workspace.configPath.toString()},label:V.label,remoteAuthority:V.remoteAuthority});for(const V of T.files)B.entries.push({fileUri:V.fileUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority});return B}e.toStoreData=Y}),define(Z[53],x([0,1,5,27]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function D(M){const P=M;return P&&(0,L.isWorkspaceIdentifier)(P.workspace)}e.isWorkspaceBackupInfo=D}),define(Z[54],x([0,1,13,9,82,34,2,70,8,3,14,20,135,5,6,38,27]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let y=class mt{constructor(c,o){this.stateMainService=c,this.logService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(c,o){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},o)}pickFolder(c,o){return this.doPick({...c,pickFolders:!0,title:(0,m.localize)(1,null)},o)}pickFile(c,o){return this.doPick({...c,pickFiles:!0,title:(0,m.localize)(2,null)},o)}pickWorkspace(c,o){const u=(0,m.localize)(3,null),n=(0,M.mnemonicButtonLabel)((0,m.localize)(4,null)),a=E.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:u,filters:a,buttonLabel:n},o)}async doPick(c,o){const u={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};u.defaultPath=c.defaultPath||this.stateMainService.getItem(mt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(u.properties=void 0,c.pickFiles&&c.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),d.isMacintosh&&u.properties.push("treatPackageAsDirectory");const n=o||v.BrowserWindow.getFocusedWindow(),a=await this.showOpenDialog(u,(0,i.withNullAsUndefined)(n));if(a&&a.filePaths&&a.filePaths.length>0)return this.stateMainService.setItem(mt.workingDirPickerStorageKey,(0,h.dirname)(a.filePaths[0])),a.filePaths}getWindowDialogQueue(c){if(c){let o=this.windowDialogQueues.get(c.id);return o||(o=new L.Queue,this.windowDialogQueues.set(c.id,o)),o}else return this.noWindowDialogueQueue}showMessageBox(c,o){return this.getWindowDialogQueue(o).queue(async()=>o?v.dialog.showMessageBox(o,c):v.dialog.showMessageBox(c))}async showSaveDialog(c,o){const u=this.acquireFileDialogLock(c,o);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(o).queue(async()=>{let n;return o?n=await v.dialog.showSaveDialog(o,c):n=await v.dialog.showSaveDialog(c),n.filePath=this.normalizePath(n.filePath),n})}finally{(0,P.dispose)(u)}}normalizePath(c){return c&&d.isMacintosh&&(c=(0,b.normalizeNFC)(c)),c}normalizePaths(c){return c.map(o=>this.normalizePath(o))}async showOpenDialog(c,o){c.defaultPath&&(await S.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const u=this.acquireFileDialogLock(c,o);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(o).queue(async()=>{let n;return o?n=await v.dialog.showOpenDialog(o,c):n=await v.dialog.showOpenDialog(c),n.filePaths=this.normalizePaths(n.filePaths),n})}finally{(0,P.dispose)(u)}}acquireFileDialogLock(c,o){if(!o)return P.Disposable.None;let u=this.windowFileDialogLocks.get(o.id);u||(u=new Set,this.windowFileDialogLocks.set(o.id,u));const n=(0,D.hash)(c);if(!u.has(n))return u.add(n),(0,P.toDisposable)(()=>{u?.delete(n),u?.size===0&&this.windowFileDialogLocks.delete(o.id)})}};y.workingDirPickerStorageKey="pickerWorkingDir",y=he([ee(0,g.IStateMainService),ee(1,t.ILogService)],y),e.DialogMainService=y}),define(Z[218],x([0,1,4,2,27]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(b,h){super();this.logService=b,this.storageMainService=h,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(b,h)=>(b?b.push(h):b=[h],b),M.STORAGE_CHANGE_DEBOUNCE_TIME)(b=>{b.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(b))}))}serializeGlobalStorageEvents(b){const h=new Map,d=new Set;return b.forEach(i=>{const S=this.storageMainService.globalStorage.get(i.key);typeof S=="string"?h.set(i.key,S):d.add(i.key)}),{changed:Array.from(h.entries()),deleted:Array.from(d.values())}}listen(b,h){switch(h){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${h}`)}async call(b,h,d){const i=(0,D.reviveIdentifier)(d.workspace),S=await this.withStorageInitialized(i);switch(h){case"getItems":return Array.from(S.items.entries());case"updateItems":{const m=d;if(m.insert)for(const[p,t]of m.insert)S.set(p,t);m.delete&&m.delete.forEach(p=>S.delete(p));break}case"close":{if(i)return S.close();break}default:throw new Error(`Call not found: ${h}`)}}async withStorageInitialized(b){const h=b?this.storageMainService.workspaceStorage(b):this.storageMainService.globalStorage;try{await h.init()}catch(d){this.logService.error(`StorageIPC#init: Unable to init ${b?"workspace":"global"} storage due to ${d}`)}return h}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[219],x([0,1,4,2,8,28,20,87,125,6,98,30,27]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends L.Disposable{constructor(y){super();this.logService=y,this._onDidChangeStorage=this._register(new v.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new v.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new b.Storage(new b.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const y=await this.doCreate();this.storage.dispose(),this.storage=y,this._register(y.onDidChangeStorage(c=>this._onDidChangeStorage.fire({key:c}))),await this.doInit(y);const I=y.getBoolean(i.IS_NEW_KEY);I===void 0?y.set(i.IS_NEW_KEY,!0):I&&y.set(i.IS_NEW_KEY,!1)}catch(y){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${y}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===d.LogLevel.Trace?y=>this.logService.trace(y):void 0,logError:y=>this.logService.error(y)}}doInit(y){return y.init()}get items(){return this.storage.items}get(y,I){return this.storage.get(y,I)}set(y,I){return this.storage.set(y,I)}delete(y){return this.storage.delete(y)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class t extends p{constructor(y,I,c){super(I);this.options=y,this.environmentService=c}async doCreate(){let y;return this.options.useInMemoryStorage?y=h.SQLiteStorageDatabase.IN_MEMORY_PATH:y=(0,D.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new b.Storage(new h.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}))}async doInit(y){await super.doInit(y),this.updateTelemetryState(y)}updateTelemetryState(y){y.get(S.instanceStorageKey,void 0)===void 0&&y.set(S.instanceStorageKey,(0,M.generateUuid)()),y.get(S.firstSessionDateStorageKey,void 0)===void 0&&y.set(S.firstSessionDateStorageKey,new Date().toUTCString());const o=y.get(S.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();y.set(S.lastSessionDateStorageKey,typeof o=="undefined"?null:o),y.set(S.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class g extends p{constructor(y,I,c,o){super(c);this.workspace=y,this.options=I,this.environmentService=o}async doCreate(){const{storageFilePath:y,wasCreated:I}=await this.prepareWorkspaceStorageFolder();return new b.Storage(new h.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}),{hint:I?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:h.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const y=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),I=(0,D.join)(y,g.WORKSPACE_STORAGE_NAME);return await P.Promises.exists(y)?{storageFilePath:I,wasCreated:!1}:(await P.Promises.mkdir(y,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(y),{storageFilePath:I,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(y){let I;if((0,m.isSingleFolderWorkspaceIdentifier)(this.workspace)?I={folder:this.workspace.uri.toString()}:(0,m.isWorkspaceIdentifier)(this.workspace)&&(I={workspace:this.workspace.configPath.toString()}),I)try{const c=(0,D.join)(y,g.WORKSPACE_META_NAME);await P.Promises.exists(c)||await P.Promises.writeFile(c,JSON.stringify(I,void 0,2))}catch(c){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[100],x([0,1,42,2,48,5,22,6,219]),function(j,e,v,L,D,M,P,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let d=class extends L.Disposable{constructor(S,m,p){super();this.logService=S,this.environmentService=m,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async S=>{S.workspace&&this.workspaceStorage(S.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(S=>{S.join(this.globalStorage.close());for(const[,m]of this.mapWorkspaceToStorage)S.join(m.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const S=new h.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(S.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),S}createWorkspaceStorage(S){return new h.WorkspaceStorageMain(S,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(S){let m=this.mapWorkspaceToStorage.get(S.id);return m||(this.logService.trace(`StorageMainService: creating workspace storage (${S.id})`),m=this.createWorkspaceStorage(S),this.mapWorkspaceToStorage.set(S.id,m),(0,v.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${S.id})`),this.mapWorkspaceToStorage.delete(S.id)})),m}};d=he([ee(0,b.ILogService),ee(1,D.IEnvironmentService),ee(2,P.ILifecycleMainService)],d),e.StorageMainService=d}),define(Z[101],x([0,1,15,7,27]),function(j,e,v,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(h,d,i){for(const m of h){const p=m.openedWorkspace;if((0,D.isWorkspaceIdentifier)(p)){const t=i(p);if(t){if(t.folders.some(g=>v.extUriBiasedIgnorePathCase.isEqualOrParent(d,g.uri)))return m}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(d,p.configPath))return m}}const S=h.filter(m=>(0,D.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(d,m.openedWorkspace.uri));if(S.length)return S.sort((m,p)=>-(m.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function P(h,d){for(const i of h)if((0,D.isWorkspaceIdentifier)(i.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,d)||(0,D.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,d))return i}e.findWindowOnWorkspaceOrFolder=P;function b(h,d){const i=S=>d.some(m=>v.extUriBiasedIgnorePathCase.isEqual(L.URI.file(m),L.URI.file(S)));for(const S of h)if(S.config?.extensionDevelopmentPath?.some(m=>i(m)))return S}e.findWindowOnExtensionDevelopmentPath=b}),define(Z[220],x([0,1,13,2,3,15,7,19,22,6,38,36,27]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class wt extends L.Disposable{constructor(c,o,u,n,a){super();this.windowsMainService=c,this.stateMainService=o,this.lifecycleMainService=u,this.logService=n,this.configurationService=a,this._state=t(this.stateMainService.getItem(wt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),n&&(c.lastActiveWindow=this.toWindowState(n))}const o=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);o&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>this.toWindowState(n)));const u=E(c);this.stateMainService.setItem(wt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(u=>{const n=(0,m.isWorkspaceIdentifier)(c.openedWorkspace)&&u.workspace?.id===c.openedWorkspace.id,a=(0,m.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&u.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(u.folderUri,c.openedWorkspace.uri);(n||a)&&(u.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(c){return{workspace:(0,m.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,m.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const o=this.doGetNewWindowState(c),u=this.configurationService.getValue("window");let n;return o.hasDefaultState?n=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(n=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),n&&D.isMacintosh&&this.windowsMainService.getWindows().some(a=>a.isFullScreen)&&(n=!1)),o.mode===3&&!n&&(o.mode=1),o}doGetNewWindowState(c){const o=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=c.workspace;if((0,m.isWorkspaceIdentifier)(l)){const w=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===l.id).map(k=>k.uiState);if(w.length)return w[0]}if((0,m.isSingleFolderWorkspaceIdentifier)(l)){const w=this.state.openedWindows.filter(k=>k.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(k.folderUri,l.uri)).map(k=>k.uiState);if(w.length)return w[0]}else if(c.backupPath){const w=this.state.openedWindows.filter(k=>k.backupPath===c.backupPath).map(k=>k.uiState);if(w.length)return w[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!o&&f)return f.uiState}let u;const n=v.screen.getAllDisplays();if(n.length===1)u=n[0];else{if(D.isMacintosh){const l=v.screen.getCursorScreenPoint();u=v.screen.getDisplayNearestPoint(l)}!u&&o&&(u=v.screen.getDisplayMatching(o.getBounds())),u||(u=v.screen.getPrimaryDisplay()||n[0])}let a=(0,S.defaultWindowState)();a.x=Math.round(u.bounds.x+u.bounds.width/2-a.width/2),a.y=Math.round(u.bounds.y+u.bounds.height/2-a.height/2);const s=this.configurationService.getValue("window");let r=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")a.mode=0,r=!1;else if(s.newWindowDimensions==="fullscreen")a.mode=3,r=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const l=o.serializeWindowState();l.mode===3?a.mode=3:a=l,r=a.mode!==3&&s.newWindowDimensions==="offset"}}return r&&(a=this.ensureNoOverlap(a)),a.hasDefaultState=!0,a}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const o=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;o.some(u=>u.x===c.x||u.y===c.y);)c.x+=30,c.y+=30;return c}};p.windowsStateStorageKey="windowsState",p=he([ee(0,S.IWindowsMainService),ee(1,i.IStateMainService),ee(2,h.ILifecycleMainService),ee(3,d.ILogService),ee(4,b.IConfigurationService)],p),e.WindowsStateHandler=p;function t(I){const c={openedWindows:[]},o=I||{openedWindows:[]};return o.lastActiveWindow&&(c.lastActiveWindow=g(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=g(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(c.openedWindows=o.openedWindows.map(u=>g(u))),c}e.restoreWindowsState=t;function g(I){const c={uiState:I.uiState};return I.backupPath&&(c.backupPath=I.backupPath),I.remoteAuthority&&(c.remoteAuthority=I.remoteAuthority),I.folder&&(c.folderUri=P.URI.parse(I.folder)),I.workspaceIdentifier&&(c.workspace={id:I.workspaceIdentifier.id,configPath:P.URI.parse(I.workspaceIdentifier.configURIPath)}),c}function E(I){return{lastActiveWindow:I.lastActiveWindow&&y(I.lastActiveWindow),lastPluginDevelopmentHostWindow:I.lastPluginDevelopmentHostWindow&&y(I.lastPluginDevelopmentHostWindow),openedWindows:I.openedWindows.map(c=>y(c))}}e.getWindowsStateStoreData=E;function y(I){return{workspaceIdentifier:I.workspace&&{id:I.workspace.id,configURIPath:I.workspace.configPath.toString()},folder:I.folderUri&&I.folderUri.toString(),backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.uiState}}}),define(Z[102],x([0,1,61,29,10,3,15]),function(j,e,v,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function b(d){function i(){let S=d.scheme===D.Schemas.file?(0,P.originalFSPath)(d):d.toString();return M.isLinux||(S=S.toLowerCase()),(0,v.createHash)("md5").update(S).digest("hex")}return{id:i(),configPath:d}}e.getWorkspaceIdentifier=b;function h(d,i){function S(){if(d.scheme!==D.Schemas.file)return(0,v.createHash)("md5").update(d.toString()).digest("hex");if(!i)try{i=(0,L.statSync)(d.fsPath)}catch(t){return}let p;return M.isLinux?p=i.ino:M.isMacintosh?p=i.birthtime.getTime():M.isWindows&&(typeof i.birthtimeMs=="number"?p=Math.floor(i.birthtimeMs):p=i.birthtime.getTime()),(0,v.createHash)("md5").update(d.fsPath).update(p?String(p):"").digest("hex")}const m=S();if(typeof m=="string")return{id:m,uri:d}}e.getSingleFolderWorkspaceIdentifier=h}),define(Z[58],x([0,1,61,62,26,17,16,4,2,8,3,28,35,85,221]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(w){this.socket=w,this._errorListener=k=>{if(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const k=R=>w(M.VSBuffer.wrap(R));return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(w){const k=R=>{w({type:0,hadError:R,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(w){return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(w){if(!this.socket.destroyed)try{this.socket.write(w.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}}end(){this.socket.end()}drain(){return new Promise((w,k)=>{if(this.socket.bufferSize===0){w();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),w()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=g;var E;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var y;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(y||(y={}));class I extends h.Disposable{constructor(w,k,R,A){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=k,this._recordInflateBytes=A,k?(this._zlibInflate=t.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",F=>{console.error(F),(0,P.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})}),this._zlibInflate.on("data",F=>{this._pendingInflateData.push(F)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{console.error(F),(0,P.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})}),this._zlibDeflate.on("data",F=>{this._pendingDeflateData.push(F)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(F=>this._onClose.fire(F)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._totalOutgoingDataBytes+=w.byteLength,this._zlibDeflate?(this._zlibDeflate.write(w.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let k=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.length-4),this._isEnded||this._write(M.VSBuffer.wrap(k),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(w,!1)}_write(w,k){let R=2;w.byteLength<126?R+=0:w.byteLength<2**16?R+=2:R+=8;const A=M.VSBuffer.alloc(R);if(k?A.writeUInt8(194,0):A.writeUInt8(130,0),w.byteLength<126)A.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){A.writeUInt8(126,1);let F=1;A.writeUInt8(w.byteLength>>>8&255,++F),A.writeUInt8(w.byteLength>>>0&255,++F)}else{A.writeUInt8(127,1);let F=1;A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(w.byteLength>>>24&255,++F),A.writeUInt8(w.byteLength>>>16&255,++F),A.writeUInt8(w.byteLength>>>8&255,++F),A.writeUInt8(w.byteLength>>>0&255,++F)}this._totalOutgoingWireBytes+=A.byteLength+w.byteLength,this.socket.write(M.VSBuffer.concat([A,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._totalIncomingWireBytes+=w.byteLength,this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),R=k.readUInt8(0),A=(R&128)>>>7,F=(R&64)>>>6,H=k.readUInt8(1),te=(H&128)>>>7,se=H&127;this._state.state=2,this._state.readLen=2+(te?4:0)+(se===126?2:0)+(se===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(F)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),R=k.readUInt8(1),A=(R&128)>>>7;let F=R&127,H=1;F===126?F=k.readUInt8(++H)*2**8+k.readUInt8(++H):F===127&&(F=k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*2**24+k.readUInt8(++H)*2**16+k.readUInt8(++H)*2**8+k.readUInt8(++H));let te=0;A&&(te=k.readUInt8(++H)*2**24+k.readUInt8(++H)*2**16+k.readUInt8(++H)*2**8+k.readUInt8(++H)),this._state.state=3,this._state.readLen=F,this._state.mask=te}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);c(k,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(k.buffer)),this._zlibInflate.write(k.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(M.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=k.byteLength,this._onData.fire(k))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=I;function c(f,w){if(w===0)return;let k=f.byteLength>>>2;for(let se=0;se<k;se++){const le=f.readUInt32BE(se*4);f.writeUInt32BE(le^w,se*4)}let R=k*4,A=f.byteLength-R;const F=w>>>24&255,H=w>>>16&255,te=w>>>8&255;A>=1&&f.writeUInt8(f.readUInt8(R)^F,R),A>=2&&f.writeUInt8(f.readUInt8(R+1)^H,R+1),A>=3&&f.writeUInt8(f.readUInt8(R+2)^te,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function u(){const f=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,d.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):w=(0,d.join)((0,D.tmpdir)(),`vscode-ipc-${f}.sock`),a(w),w}e.createRandomIPCHandle=u;function n(f,w,k){const R=(0,v.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${k}-${w}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,d.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${k}-${w}.sock`):A=(0,d.join)(f,`${k}-${w}.sock`),a(A),A}e.createStaticIPCHandle=n;function a(f){const w=o[i.platform];typeof w=="number"&&f.length>=w&&console.warn(`WARNING: IPC handle "${f}" is longer than ${w} chars, try a shorter --user-data-dir`)}class s extends m.IPCServer{constructor(w){super(s.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const k=b.Event.fromNodeEventEmitter(w,"connection");return b.Event.map(k,R=>({protocol:new p.Protocol(new g(R)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(f){return new Promise((w,k)=>{const R=(0,L.createServer)();R.on("error",k),R.listen(f,()=>{R.removeListener("error",k),w(new s(R))})})}e.serve=r;function l(f,w){return new Promise((k,R)=>{const A=(0,L.createConnection)(f,()=>{A.removeListener("error",R),k(p.Client.fromSocket(new g(A),w))});A.once("error",R)})}e.connect=l}),define(Z[222],x([0,1,58]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(h){this.driver=h}listen(h,d){throw new Error("No event found")}call(h,d,i){switch(d){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(i);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${d}`)}}e.DriverChannel=L;class D{constructor(h){this.channel=h}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(h){return this.channel.call("capturePage",h)}reloadWindow(h){return this.channel.call("reloadWindow",h)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(h,d){return this.channel.call("dispatchKeybinding",[h,d])}click(h,d,i,S){return this.channel.call("click",[h,d,i,S])}doubleClick(h,d){return this.channel.call("doubleClick",[h,d])}setValue(h,d,i){return this.channel.call("setValue",[h,d,i])}getTitle(h){return this.channel.call("getTitle",[h])}isActiveElement(h,d){return this.channel.call("isActiveElement",[h,d])}getElements(h,d,i){return this.channel.call("getElements",[h,d,i])}getElementXY(h,d,i,S){return this.channel.call("getElementXY",[h,d,i,S])}typeInEditor(h,d,i){return this.channel.call("typeInEditor",[h,d,i])}getTerminalBuffer(h,d){return this.channel.call("getTerminalBuffer",[h,d])}writeInTerminal(h,d,i){return this.channel.call("writeInTerminal",[h,d,i])}getLocaleInfo(h){return this.channel.call("getLocaleInfo",h)}getLocalizedStrings(h){return this.channel.call("getLocalizedStrings",h)}}e.DriverChannelClient=D;class M{constructor(h){this.registry=h}listen(h,d){throw new Error(`Event not found: ${d}`)}call(h,d,i){switch(d){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${d}`)}}e.WindowDriverRegistryChannel=M;async function P(b){const h=await(0,v.connect)(b,"driverClient"),d=h.getChannel("driver"),i=new D(d);return{client:h,driver:i}}e.connect=P}),define(Z[223],x([0,1,9,4,106,59,2,3,35,58,159,222,177,22,36]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function g(I){return I<21}let E=class{constructor(c,o,u,n){this.windowServer=c,this.options=o,this.windowsMainService=u,this.lifecycleMainService=n,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(c){return this.registeredWindowIds.add(c),this.reloadingWindowIds.delete(c),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(c){this.reloadingWindowIds.add(c)}async getWindowIds(){return this.windowsMainService.getWindows().map(c=>c.id).filter(c=>this.registeredWindowIds.has(c)&&!this.reloadingWindowIds.has(c))}async capturePage(c){await this.whenUnfrozen(c);const o=this.windowsMainService.getWindowById(c);if(!o?.win)throw new Error("Invalid window");return(await o.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(c){await this.whenUnfrozen(c);const o=this.windowsMainService.getWindowById(c);if(!o)throw new Error("Invalid window");this.reloadingWindowIds.add(c),this.lifecycleMainService.reload(o)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(c,o){await this.whenUnfrozen(c);const u=D.KeybindingParser.parseUserBinding(o);for(let n of u)await this._dispatchKeybinding(c,n)}async _dispatchKeybinding(c,o){if(o instanceof M.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const u=this.windowsMainService.getWindowById(c);if(!u?.win)throw new Error("Invalid window");const n=u.win.webContents,a=new M.SimpleKeybinding(!1,!1,!1,!1,o.keyCode),r=new m.USLayoutResolvedKeybinding(a.toChord(),b.OS).getElectronAccelerator(),l=[];o.ctrlKey&&l.push("ctrl"),o.metaKey&&l.push("meta"),o.shiftKey&&l.push("shift"),o.altKey&&l.push("alt"),n.sendInputEvent({type:"keyDown",keyCode:r,modifiers:l}),g(o.keyCode)||n.sendInputEvent({type:"char",keyCode:r,modifiers:l}),n.sendInputEvent({type:"keyUp",keyCode:r,modifiers:l}),await(0,v.timeout)(100)}async click(c,o,u,n){await(await this.getWindowDriver(c)).click(o,u,n)}async doubleClick(c,o){await(await this.getWindowDriver(c)).doubleClick(o)}async setValue(c,o,u){await(await this.getWindowDriver(c)).setValue(o,u)}async getTitle(c){return await(await this.getWindowDriver(c)).getTitle()}async isActiveElement(c,o){return await(await this.getWindowDriver(c)).isActiveElement(o)}async getElements(c,o,u){return await(await this.getWindowDriver(c)).getElements(o,u)}async getElementXY(c,o,u,n){return await(await this.getWindowDriver(c)).getElementXY(o,u,n)}async typeInEditor(c,o,u){await(await this.getWindowDriver(c)).typeInEditor(o,u)}async getTerminalBuffer(c,o){return await(await this.getWindowDriver(c)).getTerminalBuffer(o)}async writeInTerminal(c,o,u){await(await this.getWindowDriver(c)).writeInTerminal(o,u)}async getLocaleInfo(c){return await(await this.getWindowDriver(c)).getLocaleInfo()}async getLocalizedStrings(c){return await(await this.getWindowDriver(c)).getLocalizedStrings()}async getWindowDriver(c){await this.whenUnfrozen(c);const o=`window:${c}`,u=new h.StaticRouter(a=>a===o),n=this.windowServer.getChannel("windowDriver",u);return new i.WindowDriverChannelClient(n)}async whenUnfrozen(c){for(;this.reloadingWindowIds.has(c);)await L.Event.toPromise(this.onDidReloadingChange.event)}};E=he([ee(2,t.IWindowsMainService),ee(3,p.ILifecycleMainService)],E),e.Driver=E;async function y(I,c,o,u){const n=o.driverVerbose,a=u.createInstance(E,I,{verbose:n}),s=new S.WindowDriverRegistryChannel(a);I.registerChannel("windowDriverRegistry",s);const r=await(0,d.serve)(c),l=new S.DriverChannel(a);return r.registerChannel("driver",l),(0,P.combinedDisposable)(r,I)}e.serve=y}),define(Z[24],x([0,1,47,8,58,48,163,5]),function(j,e,v,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(M.IEnvironmentService);class h extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([v.memoize],h.prototype,"cachedLanguagesPath",null),he([v.memoize],h.prototype,"backupHome",null),he([v.memoize],h.prototype,"backupWorkspacesPath",null),he([v.memoize],h.prototype,"mainIPCHandle",null),he([v.memoize],h.prototype,"mainLockfile",null),he([v.memoize],h.prototype,"sandbox",null),he([v.memoize],h.prototype,"driverVerbose",null),he([v.memoize],h.prototype,"disableUpdates",null),he([v.memoize],h.prototype,"disableKeytar",null),he([v.memoize],h.prototype,"codeCachePath",null),he([v.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(Z[224],x([0,1,61,29,33,10,8,3,15,7,20,53,19,24,18,6,27]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let y=class{constructor(c,o,u){this.configurationService=o,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,a)=>(0,D.isEqual)(n,a,!b.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await i.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(n){c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let o=[];try{Array.isArray(c.rootURIWorkspaces)&&(o=c.rootURIWorkspaces.map(n=>({workspace:{id:n.id,configPath:d.URI.parse(n.configURIPath)},remoteAuthority:n.remoteAuthority})))}catch(n){}this.workspaces=await this.validateWorkspaces(o);let u=[];try{Array.isArray(c.folderURIWorkspaces)&&(u=c.folderURIWorkspaces.map(n=>d.URI.parse(n)))}catch(n){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,o){this.workspaces.some(n=>c.workspace.id===n.workspace.id)||(this.workspaces.push(c),this.saveSync());const u=this.getBackupPath(c.workspace.id);return o&&this.moveBackupFolderSync(u,o),u}moveBackupFolderSync(c,o){if(L.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),L.existsSync(o))try{L.renameSync(o,c)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(c){const o=c.id,u=this.workspaces.findIndex(n=>n.workspace.id===o);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(o=>this.backupUriComparer.isEqual(c,o))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const o=this.folders.findIndex(u=>this.backupUriComparer.isEqual(c,u));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(c,o){const u=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:o}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(c){const o=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,c));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(c){return(0,P.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const o=new Set,u=[];for(let n of c){const a=n.workspace;if(!(0,E.isWorkspaceIdentifier)(a))return[];if(!o.has(a.id)){o.add(a.id);const s=this.getBackupPath(a.id);await this.doHasBackups(s)?a.configPath.scheme!==M.Schemas.file||await i.Promises.exists(a.configPath.fsPath)?u.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return u}async validateFolders(c){if(!Array.isArray(c))return[];const o=[],u=new Set;for(let n of c){const a=this.backupUriComparer.getComparisonKey(n);if(!u.has(a)){u.add(a);const s=this.getBackupPath(this.getFolderHash(n));await this.doHasBackups(s)?n.scheme!==M.Schemas.file||await i.Promises.exists(n.fsPath)?o.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const o=[],u=new Set;for(let n of c){const a=n.backupFolder;if(typeof a!="string")return[];if(!u.has(a)){u.add(a);const s=this.getBackupPath(a);await this.doHasBackups(s)?o.push(n):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(c){try{await i.Promises.exists(c)&&await i.Promises.rm(c,i.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(c){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{await i.Promises.rename(c,u)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(c){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{L.renameSync(c,u)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const c=[];for(const o of this.workspaces)await this.hasBackups(o)&&c.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&c.push(o);return c}hasBackups(c){let o;return d.URI.isUri(c)?o=this.getBackupPath(this.getFolderHash(c)):(0,S.isWorkspaceBackupInfo)(c)?o=this.getBackupPath(c.workspace.id):o=c.backupFolder,this.doHasBackups(o)}async doHasBackups(c){try{const o=await i.Promises.readdir(c);for(const u of o)try{if((await i.Promises.readdir((0,P.join)(c,u))).length>0)return!0}catch(n){}}catch(o){}return!1}saveSync(){try{(0,i.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await i.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let o;return c.scheme===M.Schemas.file?o=b.isLinux?c.fsPath:c.fsPath.toLowerCase():o=c.toString().toLowerCase(),(0,v.createHash)("md5").update(o).digest("hex")}};y=he([ee(0,p.IEnvironmentMainService),ee(1,m.IConfigurationService),ee(2,g.ILogService)],y),e.BackupMainService=y}),define(Z[225],x([0,1,62,58]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,M,P,b){const h=i=>b(i,void 0),d=v.createConnection({host:D,port:M},()=>{d.removeListener("error",h);const i=Buffer.alloc(16);for(let t=0;t<16;t++)i[t]=Math.round(Math.random()*256);const S=i.toString("base64");let m=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${M}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`];d.write(m.join(`\r
`)+`\r
\r
`);const p=t=>{t.toString().indexOf(`\r
\r
`)>=0&&(d.off("data",p),b(void 0,new L.NodeSocket(d)))};d.on("data",p)});d.once("error",h)}}}),define(Z[226],x([0,1,62,117,225,9,2,19,6,21,193,97,77]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(I,c,o,u,n){return new t(I,c,o,u,n).waitForReady()}class t extends P.Disposable{constructor(c,o,u,n,a){super();this.defaultTunnelHost=o,this.suggestedLocalPort=a,this.privacy=S.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=v.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){let c=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),o=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address(),o||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async _onConnection(c){c.pause();const o=(0,S.isLocalhost)(this.tunnelRemoteHost)||(0,S.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,i.connectRemoteAgentTunnel)(this._options,o,this.tunnelRemotePort),n=u.getSocket().socket,a=u.readEntireBuffer();u.dispose(),a.byteLength>0&&c.write(a.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),n.end()}),c.on("close",()=>n.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),n.destroy()}),n.on("end",()=>c.end()),n.on("close",()=>c.end()),n.on("error",()=>{c.destroy()}),c.pipe(n),n.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),n.end()})}}let g=class extends S.AbstractTunnelService{constructor(c,o,u,n,a){super(o);this.socketFactory=c,this.signService=u,this.productService=n,this.configurationService=a}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,o,u,n,a,s,r){const l=this.getTunnelFromMap(o,u);if(l)return++l.refcount,l.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,o,u,n,a,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${u} on local port ${n}.`);const f={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},w=p(f,this.defaultTunnelHost,o,u,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,u,w),w}}};g=he([ee(1,h.ILogService),ee(2,m.ISignService),ee(3,d.IProductService),ee(4,b.IConfigurationService)],g),e.BaseTunnelService=g;let E=class extends g{constructor(c,o,u,n){super(D.nodeSocketFactory,c,o,u,n)}};E=he([ee(0,h.ILogService),ee(1,m.ISignService),ee(2,d.IProductService),ee(3,b.IConfigurationService)],E),e.TunnelService=E;let y=class extends P.Disposable{constructor(c,o,u,n){super();this.logService=c,this.productService=o,this.signService=u,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(c,o,u,n,a,s,r,l){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${n} on local port ${a}.`),!this._tunnelServices.has(c)){const f=new E(this.logService,this.signService,this.productService,this.configurationService);this._register(f),this._tunnelServices.set(c,f),f.onTunnelClosed(async()=>{(await f.tunnels).length===0&&(f.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(o,u,n,a,s,r,l)}};y=he([ee(0,h.ILogService),ee(1,d.IProductService),ee(2,m.ISignService),ee(3,b.IConfigurationService)],y),e.SharedTunnelsService=y}),define(Z[227],x([0,1,197,9,17,16,2,14,19,48,91,6,196,221]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends P.Disposable{constructor(E,y,I){super();this.environmentService=y,this.logService=I,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,y){this.logService.trace("RequestService#request",E.url);const{proxyUrl:I,strictSSL:c}=this;let o;try{o=await(0,i.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(a){this.logService.error("RequestService#request resolving shell environment failed",a)}const u={...process.env,...o},n=E.agent?E.agent:await(0,m.getProxyAgent)(E.url||"",u,{proxyUrl:I,strictSSL:c});return E.agent=n,E.strictSSL=c,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization}),this._request(E,y)}async getNodeRequest(E){return((0,v.parse)(E.url).protocol==="https:"?await new Promise((c,o)=>{j(["https"],c,o)}):await new Promise((c,o)=>{j(["http"],c,o)})).request}_request(E,y){return L.Promises.withAsyncBody(async(I,c)=>{let o;const u=(0,v.parse)(E.url),n=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),a={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,b.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(a.auth=E.user+":"+E.password),o=n(a,s=>{const r=(0,b.isNumber)(E.followRedirects)?E.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&r>0&&s.headers.location)this._request({...E,url:s.headers.location,followRedirects:r-1},y).then(I,c);else{let l=s;s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,p.createGunzip)())),I({res:s,stream:(0,D.streamToBufferReadableStream)(l)})}}),o.on("error",c),E.timeout&&o.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&o.write(E.data),o.end(),y.onCancellationRequested(()=>{o.abort(),c((0,M.canceled)())})})}async resolveProxy(E){}};t=he([ee(0,h.IConfigurationService),ee(1,d.INativeEnvironmentService),ee(2,S.ILogService)],t),e.RequestService=t}),define(Z[228],x([0,1,13,227]),function(j,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(P){return v.net.request}class M extends L.RequestService{request(b,h){return super.request({...b||{},getRawRequest:D},h)}}e.RequestMainService=M}),define(Z[229],x([0,1,13,9,4,2,10,14,86,24,22,6,50,57,66,45]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let E=class extends M.Disposable{constructor(I,c,o,u,n,a,s){super();this.machineId=I,this.userEnv=c,this.environmentMainService=o,this.lifecycleMainService=u,this.logService=n,this.themeMainService=a,this.protocolMainService=s,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:createSharedProcessMessageChannel",(I,c)=>this.onWindowConnection(I,c)),v.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(I,c)=>this.onWorkerConnection(I,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(I,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(I.sender.isDestroyed())return o.close();I.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[o])}onWorkerConnection(I,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const o=new M.DisposableStore,u=a=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${a}')`,c),o.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},n=v.BrowserWindow.fromId(c.reply.windowId);if(!n||n.isDestroyed()||n.webContents.isDestroyed()||!c.reply.channel){u("unavailable");return}o.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,a=>a.window.win===n)(()=>u("load"))),o.add(D.Event.fromNodeEventEmitter(n,"closed")(()=>u("closed"))),n.webContents.postMessage(c.reply.channel,c.reply.nonce,I.ports)}onWillShutdown(){const I=this.window;!I||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(I.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{I.close()}catch(c){}this.window=void 0},0))}send(I,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${I}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(I,...c)}catch(o){this.logService.warn(`Error sending IPC message to channel '${I}' of shared process: ${(0,g.toErrorMessage)(o)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(I=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),I()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(I=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),I()}))})()),this._whenIpcReady}createWindow(){const I=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${I.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),I.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=I=>{this.logService.trace("SharedProcess#close prevented"),I.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(I,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(I,c,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:c}})))}async connect(){await this.whenIpcReady;const I=(0,b.assertIsDefined)(this.window);return(0,h.connect)(I)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const I=this.window;return I?!I.isDestroyed()&&!I.webContents.isDestroyed():!1}};E=he([ee(2,d.IEnvironmentMainService),ee(3,i.ILifecycleMainService),ee(4,S.ILogService),ee(5,t.IThemeMainService),ee(6,p.IProtocolMainService)],E),e.SharedProcess=E}),define(Z[230],x([0,1,9,17,8,14,7,24,18,6]),function(j,e,v,L,D,M,P,b,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(p,t,g){this.storagePath=p,this.logService=t,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,t){const g=this.storage[p];return(0,M.isUndefinedOrNull)(g)?t:g}setItem(p,t){this.setItems([{key:p,data:t}])}setItems(p){let t=!1;for(const{key:g,data:E}of p)this.storage[g]!==E&&((0,M.isUndefinedOrNull)(E)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,t=!0):(this.storage[g]=E,t=!0));t&&this.save()}removeItem(p){(0,M.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let S=class St{constructor(p,t,g){this.fileStorage=new i(P.URI.file((0,D.join)(p.userDataPath,St.STATE_FILE)),t,g)}async init(){return this.fileStorage.init()}getItem(p,t){return this.fileStorage.getItem(p,t)}setItem(p,t){this.fileStorage.setItem(p,t)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};S.STATE_FILE="storage.json",S=he([ee(0,b.IEnvironmentMainService),ee(1,d.ILogService),ee(2,h.IFileService)],S),e.StateMainService=S}),define(Z[78],x([0,1,9,23,4,19,24,22,6,21,52,41]),function(j,e,v,L,D,M,P,b,h,d,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function m(t,g,E){return`${E.updateUrl}/api/update/${t}/${g}/${E.commit}`}e.createUpdateURL=m;let p=class{constructor(g,E,y,I,c,o){this.lifecycleMainService=g,this.configurationService=E,this.environmentMainService=y,this.requestService=I,this.logService=c,this.productService=o,this._state=S.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.getUpdateMode(),E=this.getProductQuality(g);if(!E){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(S.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}getUpdateMode(){return(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,v.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};p=he([ee(0,b.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,P.IEnvironmentMainService),ee(3,i.IRequestService),ee(4,h.ILogService),ee(5,d.IProductService)],p),e.AbstractUpdateService=p}),define(Z[231],x([0,1,13,47,4,2,19,24,22,6,21,52,30,41,78]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends t.AbstractUpdateService{constructor(y,I,c,o,u,n,a){super(y,I,o,u,n,a);this.telemetryService=c,this.disposables=new M.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"error",(y,I)=>I)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(y,I,c)=>({url:I,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(y,I,c,o)=>({releaseNotes:I,version:c,productVersion:c,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(y){this.logService.error("UpdateService error:",y);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?y:void 0;this.setState(p.State.Idle(1,c))}buildUpdateFeedUrl(y){let I;this.productService.darwinUniversalAssetId?I=this.productService.darwinUniversalAssetId:I=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(I,y,this.productService);try{v.autoUpdater.setFeedURL({url:c})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return c}doCheckForUpdates(y){this.setState(p.State.CheckingForUpdates(y)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(y){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(y))}onUpdateDownloaded(y){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:y.version}),this.setState(p.State.Ready(y)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],g.prototype,"onRawError",null),he([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],g.prototype,"onRawUpdateAvailable",null),he([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=he([ee(0,h.ILifecycleMainService),ee(1,P.IConfigurationService),ee(2,m.ITelemetryService),ee(3,b.IEnvironmentMainService),ee(4,S.IRequestService),ee(5,d.ILogService),ee(6,i.IProductService)],g),e.DarwinUpdateService=g}),define(Z[232],x([0,1,44,29,9,4,8,24,22,6,30,41]),function(j,e,v,L,D,M,P,b,h,d,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let m=class{constructor(g,E,y){if(this.lifecycleMainService=g,this.logService=y,this._state=S.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,D.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};m=he([ee(0,h.ILifecycleMainService),ee(1,b.IEnvironmentMainService),ee(2,d.ILogService)],m);let p=class extends m{constructor(g,E,y,I,c,o){super(y,I,c);this.snap=g,this.snapRevision=E,this.telemetryService=o;const u=(0,L.watch)(P.dirname(this.snap)),n=M.Event.fromNodeEventEmitter(u,"change",(l,f)=>f),a=M.Event.filter(n,l=>l==="current"),r=M.Event.debounce(a,(l,f)=>f,2e3)(()=>this.checkForUpdates(!1));y.onWillShutdown(()=>{r.dispose(),u.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+P.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((y,I)=>(0,L.realpath)(`${P.dirname(this.snap)}/current`,(c,o)=>c?I(c):y(o))),E=P.basename(g);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=he([ee(2,h.ILifecycleMainService),ee(3,b.IEnvironmentMainService),ee(4,d.ILogService),ee(5,i.ITelemetryService)],p),e.SnapUpdateService=p}),define(Z[46],x([0,1,13,29,4,39,34,2,10,8,3,15,14,20,157,53,54,24,5,6,21,101,27,102]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o,u,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,I.createDecorator)("workspacesManagementMainService");let s=class extends b.Disposable{constructor(l,f,w,k,R){super();this.environmentMainService=l,this.logService=f,this.backupMainService=w,this.dialogMainService=k,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,f=>(0,L.readFileSync)(f,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,f=>p.Promises.readFile(f,"utf8"))}doResolveLocalWorkspace(l,f){if(!!this.isWorkspacePath(l)&&l.scheme===h.Schemas.file)try{const w=f(l.fsPath);return w instanceof Promise?w.then(k=>this.doResolveWorkspace(l,k),k=>{}):this.doResolveWorkspace(l,w)}catch{return}}isWorkspacePath(l){return(0,n.isUntitledWorkspace)(l,this.environmentMainService)||(0,n.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,f){try{const w=this.doParseStoredWorkspace(l,f),k=(0,a.getWorkspaceIdentifier)(l);return{id:k.id,configPath:k.configPath,folders:(0,n.toWorkspaceFolders)(w.folders,k.configPath,S.extUriBiasedIgnorePathCase),remoteAuthority:w.remoteAuthority,transient:w.transient}}catch(w){this.logService.warn(w.toString())}}doParseStoredWorkspace(l,f){const w=(0,M.parse)(f);if(w&&Array.isArray(w.folders))w.folders=w.folders.filter(k=>(0,n.isStoredWorkspaceFolder)(k));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return w}async createUntitledWorkspace(l,f){const{workspace:w,storedWorkspace:k}=this.newUntitledWorkspace(l,f),R=w.configPath.fsPath;return await p.Promises.mkdir((0,d.dirname)(R),{recursive:!0}),await p.Promises.writeFile(R,JSON.stringify(k,null,"	")),w}createUntitledWorkspaceSync(l,f){const{workspace:w,storedWorkspace:k}=this.newUntitledWorkspace(l,f),R=w.configPath.fsPath;return(0,L.mkdirSync)((0,d.dirname)(R),{recursive:!0}),(0,p.writeFileSync)(R,JSON.stringify(k,null,"	")),w}newUntitledWorkspace(l=[],f){const w=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,S.joinPath)(this.untitledWorkspacesHome,w),R=(0,S.joinPath)(k,n.UNTITLED_WORKSPACE_NAME),A=[];for(const F of l)A.push((0,n.getStoredWorkspaceFolder)(F.uri,!0,F.name,k,!i.isWindows,S.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(R),storedWorkspace:{folders:A,remoteAuthority:f}}}async getWorkspaceIdentifier(l){return(0,a.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,n.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const f=(0,S.originalFSPath)(l.configPath);try{(0,p.rimrafSync)((0,d.dirname)(f));const w=(0,d.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,L.existsSync)(w)&&(0,p.writeFileSync)((0,d.join)(w,"obsolete"),"")}catch(w){this.logService.warn(`Unable to delete untitled workspace ${f} (${w}).`)}}getUntitledWorkspacesSync(){const l=[];try{const f=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(w=>(0,S.joinPath)(this.untitledWorkspacesHome,w,n.UNTITLED_WORKSPACE_NAME));for(const w of f){const k=(0,a.getWorkspaceIdentifier)(w),R=this.resolveLocalWorkspaceSync(w);R?l.push({workspace:k,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(f){f.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${f}).`)}return l}async enterWorkspace(l,f,w){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,f,w))return;const R=this.doEnterWorkspace(l,(0,a.getWorkspaceIdentifier)(w));if(!!R)return this._onDidEnterWorkspace.fire({window:l,workspace:R.workspace}),R}async isValidTargetWorkspacePath(l,f,w){if(!w)return!0;if((0,n.isWorkspaceIdentifier)(l.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,w))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(f,w)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,S.basename)(w)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,m.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,f){if(!l.config)return;l.focus();let w;return l.config.extensionDevelopmentPath||(w=this.backupMainService.registerWorkspaceBackupSync({workspace:f,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,n.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=f,l.config.backupPath=w,{workspace:f,backupPath:w}}};s=he([ee(0,y.IEnvironmentMainService),ee(1,c.ILogService),ee(2,g.IBackupMainService),ee(3,E.IDialogMainService),ee(4,o.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Z[103],x([0,1,13,31,23,3,14,7,20,19,56,5,6,99,36,27,46]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let y=class{constructor(c,o,u,n,a){this.logService=c,this.windowsMainService=o,this.urlService=u,this.workspacesManagementMainService=n,this.configurationService=a}async start(c,o){this.logService.trace("Received data from other instance: ",c,o),M.isMacintosh&&v.app.focus({steal:!0});const u=this.parseOpenUrl(c);if(u.length){let n=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(n=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),n.then(()=>{for(const{uri:a,url:s}of u)this.urlService.open(a,{originalUrl:s})})}else return this.startOpenWindow(c,o)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,L.coalesce)(c._urls.map(o=>{try{return{uri:b.URI.parse(o),url:o}}catch(u){return null}})):[]}async startOpenWindow(c,o){const u=(0,i.isLaunchedFromCli)(o)?0:4;let n=[];const a=c.wait&&c.waitMarkerFilePath?b.URI.file(c.waitMarkerFilePath):void 0,s=c.remote||void 0,r={context:u,cli:c,userEnv:o,waitMarkerFileURI:a,remoteAuthority:s};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,r);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let l=!1;if(c["new-window"]||c["unity-launch"])l=!0;else if(c["reuse-window"])l=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":l=!0;break;case"off":l=!1;break;default:l=!M.isMacintosh}if(l)n=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const f=this.windowsMainService.getLastActiveWindow();f?(this.windowsMainService.openExistingWindow(f,r),n=[f]):n=this.windowsMainService.open({...r,forceEmpty:!0})}}else n=this.windowsMainService.open({...r,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(a&&n.length===1&&n[0])return Promise.race([n[0].whenClosedOrLoaded,(0,h.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return v.BrowserWindow.getAllWindows().forEach(o=>{const u=this.windowsMainService.getWindowById(o.id);u?c.push(this.codeWindowToInfo(u)):c.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(n=>new Promise(a=>{const s=n.remoteAuthority;if(s){const r=`vscode:getDiagnosticInfoResponse${n.id}`,l={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(n):void 0};n.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:r,args:l}),v.ipcMain.once(r,(f,w)=>{w||a({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),a(w)}),setTimeout(()=>{a({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else a(void 0)})))).filter(n=>!!n)}getFolderURIs(c){const o=[],u=c.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(u))o.push(u.uri);else if((0,g.isWorkspaceIdentifier)(u)){const n=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);n&&n.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(c){const o=this.getFolderURIs(c),u=(0,P.assertIsDefined)(c.win);return this.browserWindowToInfo(u,o,c.remoteAuthority)}browserWindowToInfo(c,o=[],u){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:o,remoteAuthority:u}}};y=he([ee(0,m.ILogService),ee(1,t.IWindowsMainService),ee(2,p.IURLService),ee(3,E.IWorkspacesManagementMainService),ee(4,d.IConfigurationService)],y),e.LaunchMainService=y}),define(Z[55],x([0,1,44,13,26,116,47,4,34,2,10,8,3,7,83,71,20,149,54,24,5,22,6,21,30,66,36,27,46]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o,u,n,a,s,r,l,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let k=class ut extends d.Disposable{constructor(A,F,H,te,se,le,Y,T,B,V){super();this.sharedProcess=A,this.windowsMainService=F,this.dialogMainService=H,this.lifecycleMainService=te,this.environmentMainService=se,this.telemetryService=le,this.logService=Y,this.productService=T,this.themeMainService=B,this.workspacesManagementMainService=V,this.onDidOpenWindow=b.Event.map(this.windowsMainService.onDidOpenWindow,_=>_.id),this.onDidMaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidUnmaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidBlurWindow=b.Event.filter(b.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidFocusWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),_=>!!_),_=>_.id),b.Event.filter(b.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_))),this.onDidResumeOS=b.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new b.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new b.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(_,U,C)=>C),_=>!(Array.isArray(_)&&_.length===1&&_[0]==="workArea")),b.Event.fromNodeEventEmitter(L.screen,"display-added"),b.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace,title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(A){return this.windowsMainService.getWindowCount()}async getActiveWindowId(A){const F=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(A,F,H){return Array.isArray(F)?this.doOpenWindow(A,F,H):this.doOpenEmptyWindow(A,F)}async doOpenWindow(A,F,H=Object.create(null)){F.length>0&&this.windowsMainService.open({context:5,contextWindowId:A,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:H.forceNewWindow,forceReuseWindow:H.forceReuseWindow,preferNewWindow:H.preferNewWindow,diffMode:H.diffMode,addMode:H.addMode,gotoLineMode:H.gotoLineMode,noRecentEntry:H.noRecentEntry,waitMarkerFileURI:H.waitMarkerFileURI,remoteAuthority:H.remoteAuthority||void 0})}async doOpenEmptyWindow(A,F){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:A},F)}async toggleFullScreen(A){const F=this.windowById(A);F&&F.toggleFullScreen()}async handleTitleDoubleClick(A){const F=this.windowById(A);F&&F.handleTitleDoubleClick()}async isMaximized(A){const F=this.windowById(A);return F?.win?F.win.isMaximized():!1}async maximizeWindow(A){const F=this.windowById(A);F?.win&&F.win.maximize()}async unmaximizeWindow(A){const F=this.windowById(A);F?.win&&F.win.unmaximize()}async minimizeWindow(A){const F=this.windowById(A);F?.win&&F.win.minimize()}async focusWindow(A,F){F&&typeof F.windowId=="number"&&(A=F.windowId);const H=this.windowById(A);H&&H.focus({force:F?.force??!1})}async setMinimumSize(A,F,H){const te=this.windowById(A);if(te?.win){const[se,le]=te.win.getSize(),[Y,T]=te.win.getMinimumSize(),[B,V]=[F??Y,H??T],[_,U]=[Math.max(se,B),Math.max(le,V)];(Y!==B||T!==V)&&te.win.setMinimumSize(B,V),(se!==_||le!==U)&&te.win.setSize(_,U)}}async saveWindowSplash(A,F){this.themeMainService.saveWindowSplash(A,F)}async installShellCommand(A){const{source:F,target:H}=await this.getShellCommandLink();try{const{symbolicLink:te}=await E.SymlinkSupport.stat(F);if(te&&!te.dangling){const se=await(0,t.realpath)(F);if(H===se)return}await E.Promises.unlink(F)}catch(te){if(te.code!=="ENOENT")throw te}try{await E.Promises.symlink(H,F)}catch(te){if(te.code!=="EACCES"&&te.code!=="ENOENT")throw te;const{response:se}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,y.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const le=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${H}' '${F}'\\" with administrator privileges"`;await(0,M.promisify)(v.exec)(le)}catch(le){throw new Error((0,y.localize)(3,null,F))}}}async uninstallShellCommand(A){const{source:F}=await this.getShellCommandLink();try{await E.Promises.unlink(F)}catch(H){switch(H.code){case"EACCES":const{response:te}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,y.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(te===0)try{const se=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,M.promisify)(v.exec)(se)}catch(se){throw new Error((0,y.localize)(7,null,F))}break;case"ENOENT":break;default:throw H}}}async getShellCommandLink(){const A=(0,S.resolve)(this.environmentMainService.appRoot,"bin","code"),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await E.Promises.exists(A))throw new Error((0,y.localize)(8,null,A));return{source:F,target:A}}async showMessageBox(A,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(A))}async showSaveDialog(A,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(A))}async showOpenDialog(A,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(A))}toBrowserWindow(A){const F=this.windowById(A);if(F?.win)return F.win}async pickFileFolderAndOpen(A,F){const H=await this.dialogMainService.pickFileFolder(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openFileFolder",F.telemetryExtraData),this.doOpenPicked(await Promise.all(H.map(async te=>await E.SymlinkSupport.existsDirectory(te)?{folderUri:p.URI.file(te)}:{fileUri:p.URI.file(te)})),F,A))}async pickFolderAndOpen(A,F){const H=await this.dialogMainService.pickFolder(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openFolder",F.telemetryExtraData),this.doOpenPicked(H.map(te=>({folderUri:p.URI.file(te)})),F,A))}async pickFileAndOpen(A,F){const H=await this.dialogMainService.pickFile(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openFile",F.telemetryExtraData),this.doOpenPicked(H.map(te=>({fileUri:p.URI.file(te)})),F,A))}async pickWorkspaceAndOpen(A,F){const H=await this.dialogMainService.pickWorkspace(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openWorkspace",F.telemetryExtraData),this.doOpenPicked(H.map(te=>({workspaceUri:p.URI.file(te)})),F,A))}doOpenPicked(A,F,H){this.windowsMainService.open({context:3,contextWindowId:H,cli:this.environmentMainService.args,urisToOpen:A,forceNewWindow:F.forceNewWindow})}sendPickerTelemetry(A,F,H){const te=A?A.length:0;this.telemetryService.publicLog(F,{...H,outcome:te?"success":"canceled",numberOfPaths:te})}async showItemInFolder(A,F){L.shell.showItemInFolder(F)}async setRepresentedFilename(A,F){const H=this.windowById(A);H&&H.setRepresentedFilename(F)}async setDocumentEdited(A,F){const H=this.windowById(A);H&&H.setDocumentEdited(F)}async openExternal(A,F){return m.isLinuxSnap?this.safeSnapOpenExternal(F):L.shell.openExternal(F),!0}safeSnapOpenExternal(A){const F=process.env.GDK_PIXBUF_MODULE_FILE,H=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(A),process.env.GDK_PIXBUF_MODULE_FILE=F,process.env.GDK_PIXBUF_MODULEDIR=H}moveItemToTrash(A,F){return L.shell.trashItem(F)}async isAdmin(){let A;return m.isWindows?A=(await new Promise((F,H)=>{j(["native-is-elevated"],F,H)}))():A=process.getuid()===0,A}async writeElevated(A,F,H,te){const se=await new Promise((le,Y)=>{j(["sudo-prompt"],le,Y)});return new Promise((le,Y)=>{const T=[`"${this.cliPath}"`];te?.unlock&&T.push("--file-chmod"),T.push("--file-write",`"${F.fsPath}"`,`"${H.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:m.isMacintosh&&this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(T.join(" "),B,(V,_,U)=>{_&&this.logService.trace(`[sudo-prompt] received stdout: ${_}`),U&&this.logService.trace(`[sudo-prompt] received stderr: ${U}`),V?Y(V):le(void 0)})})}get cliPath(){return m.isWindows?this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):m.isLinux?this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,S.join)(this.environmentMainService.appRoot,"bin","code"):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}get osColorScheme(){return{highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(A,F,H){process.kill(F,H)}async readClipboardText(A,F){return L.clipboard.readText(F)}async writeClipboardText(A,F,H){return L.clipboard.writeText(F,H)}async readClipboardFindText(A){return L.clipboard.readFindText()}async writeClipboardFindText(A,F){return L.clipboard.writeFindText(F)}async writeClipboardBuffer(A,F,H,te){return L.clipboard.writeBuffer(F,Buffer.from(H),te)}async readClipboardBuffer(A,F){return L.clipboard.readBuffer(F)}async hasClipboard(A,F,H){return L.clipboard.has(F,H)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(A,F){const H=this.windowById(A);H&&H.updateTouchBar(F)}async notifyReady(A){const F=this.windowById(A);F&&F.setReady()}async relaunch(A,F){return this.lifecycleMainService.relaunch(F)}async reload(A,F){const H=this.windowById(A);if(H){if((0,f.isWorkspaceIdentifier)(H.openedWorkspace)){const te=H.openedWorkspace.configPath;if(te.scheme===i.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(te))?.transient)return this.openWindow(H.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(H,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(A){this.closeWindowById(A,A)}async closeWindowById(A,F){const H=this.windowById(F);if(H?.win)return H.win.close()}async quit(A){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(A,F){await this.lifecycleMainService.kill(F)}async resolveProxy(A,F){const te=this.windowById(A)?.win?.webContents?.session;if(te)return te.resolveProxy(F)}async openDevTools(A,F){const H=this.windowById(A);H?.win&&H.win.webContents.openDevTools(F)}async toggleDevTools(A){const F=this.windowById(A);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(A,F){const H=this.windowById(A);H?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&H.win.webContents.sendInputEvent(F)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(A,F,H,te){if(!m.isWindows)return;const se=await new Promise((le,Y)=>{j(["vscode-windows-registry"],le,Y)});try{return se.GetStringRegKey(F,H,te)}catch{return}}async getPassword(A,F,H){const te=await this.withKeytar(),se=await te.getPassword(F,H);if(se)try{let{content:le,hasNextChunk:Y}=JSON.parse(se);if(!le||!Y)return se;let T=1;for(;Y;){const B=await te.getPassword(F,`${H}-${T}`),V=JSON.parse(B);le+=V.content,Y=V.hasNextChunk,T++}return le}catch{return se}return se}async setPassword(A,F,H,te){const se=await this.withKeytar(),le=3,Y=async(T,B,V)=>{let _=0,U;for(;_<le;)try{await se.setPassword(T,B,V);return}catch(C){U=C,this.logService.warn("Error attempting to set a password: ",C),_++,await new Promise(X=>setTimeout(X,200))}throw U};if(m.isWindows&&te.length>ut.MAX_PASSWORD_LENGTH){let T=0,B=0,V=!0;for(;V;){const _=te.substring(T,T+ut.PASSWORD_CHUNK_SIZE);T+=ut.PASSWORD_CHUNK_SIZE,V=te.length-T>0;const U={content:_,hasNextChunk:V};await Y(F,B?`${H}-${B}`:H,JSON.stringify(U)),B++}}else await Y(F,H,te);this._onDidChangePassword.fire({service:F,account:H})}async deletePassword(A,F,H){const se=await(await this.withKeytar()).deletePassword(F,H);return se&&this._onDidChangePassword.fire({service:F,account:H}),se}async findPassword(A,F){return(await this.withKeytar()).findPassword(F)}async findCredentials(A,F){return(await this.withKeytar()).findCredentials(F)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((A,F)=>{j(["keytar"],A,F)})}windowById(A){if(typeof A=="number")return this.windowsMainService.getWindowById(A)}};k.MAX_PASSWORD_LENGTH=2500,k.PASSWORD_CHUNK_SIZE=k.MAX_PASSWORD_LENGTH-100,he([P.memoize],k.prototype,"cliPath",null),k=he([ee(1,l.IWindowsMainService),ee(2,I.IDialogMainService),ee(3,u.ILifecycleMainService),ee(4,c.IEnvironmentMainService),ee(5,s.ITelemetryService),ee(6,n.ILogService),ee(7,a.IProductService),ee(8,r.IThemeMainService),ee(9,w.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(Z[233],x([0,1,13,23,4,82,2,28,89,6,55,21,36]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let t=class extends P.Disposable{constructor(E,y,I,c,o){super();this.logService=E,this.windowsMainService=y,this.nativeHostMainService=I,this.encryptionMainService=c,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const E=D.Event.fromNodeEventEmitter(v.app,"login",(y,I,c,o,u)=>({event:y,webContents:I,req:c,authInfo:o,callback:u}));this._register(E(this.onLogin,this))}async onLogin({event:E,authInfo:y,req:I,callback:c}){if(!y.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&I.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}E.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(y);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(o?.username,o?.password)}async resolveProxyCredentials(E){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const y=await this.doResolveProxyCredentials(E);if(y)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),y;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(E){this.logService.trace("auth#doResolveProxyCredentials - enter",E);const y=String((0,M.hash)({scheme:E.scheme,host:E.host,port:E.port}));let I,c;try{const a=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y);if(a){const s=JSON.parse(await this.encryptionMainService.decrypt(a));I=s.username,c=s.password}}catch(a){this.logService.error(a)}if(this.state!==p.StoredCredentialsUsed&&typeof I=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:I,password:c};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const u={authInfo:E,username:this.sessionCredentials?.username??I,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,b.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,u),this.state=p.LoginDialogShown;const n=await new Promise(a=>{const s=async(r,l,f)=>{if(l===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",s),f){const w={username:f.username,password:f.password};try{if(f.remember){const k=await this.encryptionMainService.encrypt(JSON.stringify(w));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y,k)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y)}catch(k){this.logService.error(k)}a({username:w.username,password:w.password})}else a(void 0)};o.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=n,n}};t=he([ee(0,d.ILogService),ee(1,m.IWindowsMainService),ee(2,i.INativeHostMainService),ee(3,h.IEncryptionMainService),ee(4,S.IProductService)],t),e.ProxyAuthHandler=t}),define(Z[234],x([0,1,13,26,34,2,10,3,84,147,75,54,24,5,103,6,55,50,21,57,67]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let u=class bt{constructor(a,s,r,l,f,w,k,R,A){this.userEnv=a,this.environmentMainService=s,this.launchMainService=r,this.logService=l,this.diagnosticsService=f,this.dialogMainService=w,this.nativeHostMainService=k,this.protocolMainService=R,this.productService=A,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(s,r);this.safeSend(a,"vscode:issueSystemInfoResponse",l)}),v.ipcMain.on("vscode:listProcesses",async a=>{const s=[];try{const r=await this.launchMainService.getMainProcessId();s.push({name:(0,d.localize)(0,null),rootProcess:await(0,h.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(f=>{(0,i.isRemoteDiagnosticError)(f)?s.push({name:f.hostName,rootProcess:f}):f.processes&&s.push({name:f.hostName,rootProcess:f.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(a,"vscode:listProcessesResponse",s)}),v.ipcMain.on("vscode:issueReporterClipboard",async a=>{const s={title:this.productService.nameLong,message:(0,d.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,d.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,d.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",r.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const s=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",s)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={title:this.productService.nameLong,message:(0,d.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,d.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,d.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(a,s)=>{const{id:r,from:l,args:f}=s;let w;switch(l){case"issueReporter":w=this.issueReporterParentWindow;break;case"processExplorer":w=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}w&&w.webContents.send("vscode:runAction",{id:r,from:l,args:f})}),v.ipcMain.on("vscode:openExternal",(a,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),v.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async a=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",s.windows)})}safeSend(a,s,...r){a.sender.isDestroyed()||a.sender.send(s,...r)}async openReporter(a){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new M.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,r,{backgroundColor:a.styles.backgroundColor,title:(0,d.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:y.default}),this.issueReporterWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(a){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new M.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,r,{backgroundColor:a.styles.backgroundColor,title:(0,d.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:y.default}),this.processExplorerWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(a,s,r){const l=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:r.title,backgroundColor:r.backgroundColor||bt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[a,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,s)}getWindowPosition(a,s,r){let l;const f=v.screen.getAllDisplays();if(f.length===1)l=f[0];else{if(b.isMacintosh){const R=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(R)}!l&&a&&(l=v.screen.getDisplayMatching(a.getBounds())),l||(l=v.screen.getPrimaryDisplay()||f[0])}const w={width:s,height:r},k=l.bounds;return w.x=k.x+k.width/2-w.width/2,w.y=k.y+k.height/2-w.height/2,k.width>0&&k.height>0&&(w.x<k.x&&(w.x=k.x),w.y<k.y&&(w.y=k.y),w.x>k.x+k.width&&(w.x=k.x),w.y>k.y+k.height&&(w.y=k.y),w.width>k.width&&(w.width=k.width),w.height>k.height&&(w.height=k.height)),w}async getPerformanceInfo(){try{const[a,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,s)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([ee(1,m.IEnvironmentMainService),ee(2,t.ILaunchMainService),ee(3,g.ILogService),ee(4,i.IDiagnosticsService),ee(5,S.IDialogMainService),ee(6,E.INativeHostMainService),ee(7,c.IProtocolMainService),ee(8,I.IProductService)],u),e.IssueMainService=u}),define(Z[235],x([0,1,23,19,24,22,6,55,21,52,30,41,78]),function(j,e,v,L,D,M,P,b,h,d,i,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends m.AbstractUpdateService{constructor(g,E,y,I,c,o,u,n){super(g,E,I,c,o,n);this.telemetryService=y,this.nativeHostMainService=u}buildUpdateFeedUrl(g){return(0,m.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(S.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},v.CancellationToken.None).then(d.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const y=g?E.message||E:void 0;this.setState(S.State.Idle(1,y))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(S.State.Idle(1))}};p=he([ee(0,M.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,i.ITelemetryService),ee(3,D.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,P.ILogService),ee(6,b.INativeHostMainService),ee(7,h.IProductService)],p),e.LinuxUpdateService=p}),define(Z[236],x([0,1,44,29,26,9,23,47,8,7,113,20,19,24,18,22,6,55,21,52,30,41,78]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(f,w=1e3){for(;!f();)await(0,M.timeout)(w)}let s;function r(){return typeof s=="undefined"&&(s=L.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),s}let l=class extends n.AbstractUpdateService{constructor(w,k,R,A,F,H,te,se,le){super(w,k,A,F,H,le);this.telemetryService=R,this.fileService=te,this.nativeHostMainService=se}get cachePath(){const w=h.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return S.Promises.mkdir(w,{recursive:!0}).then(()=>w)}initialize(){super.initialize(),r()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(w){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),r()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,n.createUpdateURL)(k,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(u.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},P.CancellationToken.None).then(c.asJson).then(k=>{const R=r();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(u.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(u.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(u.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(A=>S.Promises.exists(A).then(F=>{if(F)return Promise.resolve(A);const H=k.url,te=k.hash,se=`${A}.tmp`;return this.requestService.request({url:H},P.CancellationToken.None).then(le=>this.fileService.writeFile(d.URI.file(se),le.stream)).then(te?()=>(0,i.checksum)(se,k.hash):()=>{}).then(()=>S.Promises.rename(se,A)).then(()=>A)})).then(A=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},F&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(k)):this.setState(u.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const R=w?k.message||k:void 0;this.setState(u.State.Idle(r(),R))}))}async doDownloadUpdate(w){w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(u.State.Idle(r()))}async getUpdatePackagePath(w){const k=await this.cachePath;return h.join(k,`CodeSetup-${this.productService.quality}-${w}.exe`)}async cleanup(w=null){const k=w?H=>!new RegExp(`${this.productService.quality}-${w}\\.exe$`).test(H):()=>!0,R=await this.cachePath,F=(await S.Promises.readdir(R)).filter(k).map(async H=>{try{await S.Promises.unlink(h.join(R,H))}catch(te){}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const w=this.state.update;this.setState(u.State.Updating(w));const k=await this.cachePath;this.availableUpdate.updateFilePath=h.join(k,`CodeSetup-${this.productService.quality}-${w.version}.flag`),await S.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(r()))});const A=`${this.productService.win32MutexName}-ready`,F=await new Promise((H,te)=>{j(["windows-mutex"],H,te)});a(()=>F.isActive(A)).then(()=>this.setState(u.State.Ready(w)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}};he([b.memoize],l.prototype,"cachePath",null),l=he([ee(0,g.ILifecycleMainService),ee(1,m.IConfigurationService),ee(2,o.ITelemetryService),ee(3,p.IEnvironmentMainService),ee(4,c.IRequestService),ee(5,E.ILogService),ee(6,t.IFileService),ee(7,y.INativeHostMainService),ee(8,I.IProductService)],l),e.Win32UpdateService=l}),define(Z[237],x([0,1,13,9,23,45,4,34,2,10,8,63,3,7,153,53,19,54,24,56,204,18,22,6,21,57,100,30,207,66,67,36,27,46]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o,u,n,a,s,r,l,f,w,k,R,A,F,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var te;(function(le){le[le.NONE=0]="NONE",le[le.LOADING=1]="LOADING",le[le.NAVIGATING=2]="NAVIGATING",le[le.READY=3]="READY"})(te||(te={}));let se=class extends h.Disposable{constructor(Y,T,B,V,_,U,C,X,W,z,K,O,q,N,$){super();this.logService=T,this.environmentMainService=B,this.fileService=V,this.configurationService=U,this.themeMainService=C,this.workspacesManagementMainService=X,this.backupMainService=W,this.telemetryService=z,this.dialogMainService=K,this.lifecycleMainService=O,this.productService=q,this.protocolMainService=N,this.windowsMainService=$,this._onWillLoad=this._register(new P.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new P.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new P.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new P.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[J,Q]=this.restoreWindowState(Y.state);this.windowState=J,this.logService.trace("window#ctor: using window state",J);const ne=this.windowState.mode===0||this.windowState.mode===3,ae=this.configurationService.getValue("window"),ie={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:R.WindowMinimumSize.WIDTH,minHeight:R.WindowMinimumSize.HEIGHT,show:!ne,title:this.productService.nameLong,webPreferences:{preload:d.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,R.zoomLevelToZoomFactor)(ae?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};m.isLinux?ie.icon=(0,i.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):m.isWindows&&!this.environmentMainService.isBuilt&&(ie.icon=(0,i.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.useNativeFullScreen()&&(ie.fullscreenable=!1),m.isMacintosh&&(ie.acceptFirstMouse=!0,ae?.clickThroughInactive===!1&&(ie.acceptFirstMouse=!1));const re=m.isMacintosh&&ae?.nativeTabs===!0;re&&(ie.tabbingIdentifier=this.productService.nameShort);const ce=(0,R.getTitleBarStyle)(this.configurationService)==="custom";if(ce&&(ie.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,m.isMacintosh||(ie.frame=!1)),(0,S.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(ie),(0,S.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),m.isMacintosh&&ce&&this._win.setSheetOffset(22),m.isMacintosh&&Q&&(!re||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(fe=>typeof fe=="number")){const fe=this.windowState;this._win.setBounds({width:fe.width,height:fe.height,x:fe.x,y:fe.y})}ne&&((0,S.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,S.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,o.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:J=>_.globalStorage.get(J),store:(J,Q)=>_.globalStorage.set(J,Q)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(Y){m.isMacintosh?this._win.setRepresentedFilename(Y):this.representedFilename=Y}getRepresentedFilename(){return m.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(Y){m.isMacintosh&&this._win.setDocumentEdited(Y),this.documentEdited=Y}isDocumentEdited(){return m.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(Y){m.isMacintosh&&Y?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(Y=>{if(this.isReady)return Y(this);this.whenReadyCallbacks.push(Y)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(Y=>{function T(){B.dispose(),V.dispose(),Y()}const B=this.onDidClose(()=>T()),V=this.onWillLoad(()=>T())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(_,U)=>this.onWindowError(2,U)),this._win.webContents.on("did-fail-load",(_,U,C)=>this.onWindowError(3,{reason:C,exitCode:U})),this._win.webContents.on("will-prevent-unload",_=>{_.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const Y=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),T=_=>{for(let U=_;U;U=U.parent)if(U.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},B=_=>_.resourceType==="xhr"||T(_.frame);this._win.webContents.session.webRequest.onBeforeRequest((_,U)=>{const C=p.URI.parse(_.url);return C.path.endsWith(".svg")&&!Y.has(C.scheme)?U({cancel:!B(_)}):U({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((_,U)=>{const C=_.responseHeaders,X=C["content-type"]||C["Content-Type"];if(X&&Array.isArray(X)){const W=p.URI.parse(_.url);if(W.path.endsWith(".svg")&&Y.has(W.scheme))return C["Content-Type"]=["image/svg+xml"],U({cancel:!1,responseHeaders:C});if(!W.path.includes(d.Schemas.vscodeRemoteResource)&&X.some(z=>z.toLowerCase().includes("image/svg")))return U({cancel:!B(_)})}return U({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",_=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",_,this._win)}),this._win.on("unmaximize",_=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",_,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(_=>this.onDidDeleteUntitledWorkspace(_)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(_,U)=>{const C=await this.marketplaceHeadersPromise;U({cancel:!1,requestHeaders:Object.assign(_.requestHeaders,C)})})}async onWindowError(Y,T){switch(Y){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:Y,reason:T?.reason,code:T?.exitCode}),Y){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(Y===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const B=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(B.response!==1){const V=B.response===0;this.destroyWindow(V)}}else if(Y===2){let B;T?B=(0,t.localize)(6,null,T.reason,T.exitCode??"<unknown>"):B=(0,t.localize)(5,null);const _=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(8,null))],message:B,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(_)}break}}destroyWindow(Y){if(this._onDidDestroy.fire(),this._win?.destroy(),Y&&this.config){let T,B;(0,F.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?T={folderUri:this.openedWorkspace.uri}:(0,F.isWorkspaceIdentifier)(this.openedWorkspace)?T={workspaceUri:this.openedWorkspace.configPath}:B=!0;const[V]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:T?[T]:void 0,forceEmpty:B,forceNewWindow:!0});V.focus()}}onDidDeleteUntitledWorkspace(Y){this.openedWorkspace?.id===Y.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const Y=this.getMenuBarVisibility();Y!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=Y,this.setMenuBarVisibility(Y));let T=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=T,this.currentNoProxy=B;const V=T||"",_=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${_}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:_,pacScript:""})}}addTabbedWindow(Y){m.isMacintosh&&Y.win&&this._win.addTabbedWindow(Y.win)}load(Y,T=Object.create(null)){this.isDocumentEdited()&&(!T.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(Y,T),this.readyState===0?this.currentConfig=Y:(this.pendingLoadConfig=Y,this.readyState=2),this._win.loadURL(d.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const B=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:Y.workspace,reason:T.isReload?3:B?2:1})}updateConfiguration(Y,T){const B=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(B){const V=(0,c.isLaunchedFromCli)(B)&&!(0,c.isLaunchedFromCli)(Y.userEnv),_=this.isExtensionDevelopmentHost;(V||_)&&(Y.userEnv={...B,...Y.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(Y.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(Y["disable-extensions"]=T.disableExtensions),Y.fullscreen=this.isFullScreen,Y.maximized=this._win.isMaximized(),Y.partsSplash=this.themeMainService.getWindowSplash(),(0,S.mark)("code/willOpenNewWindow"),Y.perfMarks=(0,S.getMarks)(),this.configObjectUrl.update(Y)}async reload(Y){const T=Object.assign({},this.currentConfig);T.workspace=await this.validateWorkspaceBeforeReload(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToWait,this.isExtensionDevelopmentHost&&Y&&(T.verbose=Y.verbose,T.debugId=Y.debugId,T.extensionEnvironment=Y.extensionEnvironment,T["inspect-extensions"]=Y["inspect-extensions"],T["inspect-brk-extensions"]=Y["inspect-brk-extensions"],T["extensions-dir"]=Y["extensions-dir"]),T.isInitialStartup=!1,this.load(T,{isReload:!0,disableExtensions:Y?.["disable-extensions"]})}async validateWorkspaceBeforeReload(Y){if((0,F.isWorkspaceIdentifier)(Y.workspace)){const T=Y.workspace.configPath;if(T.scheme===d.Schemas.file&&!await this.fileService.exists(T))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(Y.workspace)){const T=Y.workspace.uri;if(T.scheme===d.Schemas.file&&!await this.fileService.exists(T))return}return Y.workspace}serializeWindowState(){if(!this._win)return(0,A.defaultWindowState)();if(this.isFullScreen){let B;try{B=v.screen.getDisplayMatching(this.getBounds())}catch(U){}const V=(0,A.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const Y=Object.create(null);let T;if(!m.isMacintosh&&this._win.isMaximized()?T=0:T=1,T===0?Y.mode=0:Y.mode=1,T===1||T===0){let B;T===1?B=this.getBounds():B=this._win.getNormalBounds(),Y.x=B.x,Y.y=B.y,Y.width=B.width,Y.height=B.height}return Y}restoreWindowState(Y){(0,S.mark)("code/willRestoreCodeWindowState");let T=!1;if(Y)try{const B=v.screen.getAllDisplays();T=B.length>1,Y=this.validateWindowState(Y,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,S.mark)("code/didRestoreCodeWindowState"),[Y||(0,A.defaultWindowState)(),T]}validateWindowState(Y,T){if(this.logService.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,Y),typeof Y.x!="number"||typeof Y.y!="number"||typeof Y.width!="number"||typeof Y.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(Y.width<=0||Y.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const _=this.getWorkingArea(T[0]);if(_){let U=function(){!Y||typeof Y.x!="number"||typeof Y.y!="number"||!_||(Y.x<_.x&&(Y.x=_.x),Y.y<_.y&&(Y.y=_.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",_),U(),Y.width>_.width&&(Y.width=_.width),Y.height>_.height&&(Y.height=_.height),Y.x>_.x+_.width-128&&(Y.x=_.x+_.width-Y.width),Y.y>_.y+_.height-128&&(Y.y=_.y+_.height-Y.height),U()}return Y}if(Y.display&&Y.mode===3){const _=T.find(U=>U.id===Y.display);if(_&&typeof _.bounds?.x=="number"&&typeof _.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const U=(0,A.defaultWindowState)(3);return U.x=_.bounds.x,U.y=_.bounds.y,U}}let B,V;try{B=v.screen.getDisplayMatching({x:Y.x,y:Y.y,width:Y.width,height:Y.height}),V=this.getWorkingArea(B)}catch(_){}if(B&&V&&Y.x+Y.width>V.x&&Y.y+Y.height>V.y&&Y.x<V.x+V.width&&Y.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),Y}getWorkingArea(Y){if(Y.workArea.width>0&&Y.workArea.height>0)return Y.workArea;if(Y.bounds.width>0&&Y.bounds.height>0)return Y.bounds}getBounds(){const[Y,T]=this._win.getPosition(),[B,V]=this._win.getSize();return{x:Y,y:T,width:B,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(Y){this.useNativeFullScreen()?this.setNativeFullScreen(Y):this.setSimpleFullScreen(Y),this.sendWhenReady(Y?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(Y){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(Y)}setSimpleFullScreen(Y){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(Y),this._win.webContents.focus()}useNativeFullScreen(){const Y=this.configurationService.getValue("window");return!Y||typeof Y.nativeFullScreen!="boolean"||Y.nativeTabs?!0:Y.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let Y=(0,R.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(Y)<0&&(Y="classic"),Y}setMenuBarVisibility(Y,T=!0){m.isMacintosh||(Y==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),Y==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(Y)}):this.doSetMenuBarVisibility(Y))}doSetMenuBarVisibility(Y){const T=this.isFullScreen;switch(Y){case"classic":this._win.setMenuBarVisibility(!T),this._win.autoHideMenuBar=T;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(Y,T,...B){this.isReady?this.send(Y,...B):this.ready().then(()=>{T.isCancellationRequested||this.send(Y,...B)})}send(Y,...T){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${Y}' for window that is destroyed`);return}try{this._win.webContents.send(Y,...T)}catch(B){this.logService.warn(`Error sending IPC message to channel '${Y}' of window ${this._id}: ${(0,M.toErrorMessage)(B)}`)}}}updateTouchBar(Y){!m.isMacintosh||this.touchBarGroups.forEach((T,B)=>{const V=Y[B];T.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!m.isMacintosh){for(let Y=0;Y<10;Y++){const T=this.createTouchBarGroup();this.touchBarGroups.push(T)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(Y=[]){const T=this.createTouchBarGroupSegments(Y),B=new v.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:B.segments[V].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(Y=[]){return Y.map(B=>{let V;B.icon&&!w.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===d.Schemas.file&&(V=v.nativeImage.createFromPath(p.URI.revive(B.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let _;return typeof B.title=="string"?_=B.title:_=B.title.value,{id:B.id,label:V?void 0:_,icon:V}})}dispose(){super.dispose(),this._win=null}};se=he([ee(1,a.ILogService),ee(2,I.IEnvironmentMainService),ee(3,u.IFileService),ee(4,l.IStorageMainService),ee(5,E.IConfigurationService),ee(6,k.IThemeMainService),ee(7,H.IWorkspacesManagementMainService),ee(8,g.IBackupMainService),ee(9,f.ITelemetryService),ee(10,y.IDialogMainService),ee(11,n.ILifecycleMainService),ee(12,s.IProductService),ee(13,r.IProtocolMainService),ee(14,A.IWindowsMainService)],se),e.CodeWindow=se}),define(Z[68],x([0,1,13,31,9,4,34,2,10,3,15,7,20,156,5,22,6,38,27,46]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let o=class $e extends b.Disposable{constructor(f,w,k,R){super();this.stateMainService=f,this.logService=w,this.workspacesManagementMainService=k,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!d.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const w=[],k=[];for(let R of f)if((0,I.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&a(w,R.workspace)===-1&&w.push(R);else if((0,I.isRecentFolder)(R))s(w,R.folderUri)===-1&&w.push(R);else{const A=r(k,R.fileUri)>=0,F=R.fileUri.scheme===h.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,i.basename)(R.fileUri))>=0;!A&&!F&&(k.push(R),d.isWindows&&R.fileUri.scheme===h.Schemas.file&&v.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(w,k),w.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(w.length=$e.MAX_TOTAL_RECENT_ENTRIES),k.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(k.length=$e.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:w,files:k}),this._onDidChangeRecentlyOpened.fire(),d.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const w=F=>{const H=n(F);for(const te of f)if(i.extUriBiasedIgnorePathCase.isEqual(te,H))return!1;return!0},k=this.getRecentlyOpened(),R=k.workspaces.filter(w),A=k.files.filter(w);(R.length!==k.workspaces.length||A.length!==k.files.length)&&(this.saveRecentlyOpened({files:A,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),d.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!d.isMacintosh)return;v.app.clearRecentDocuments();const f=this.getRecentlyOpened(),w=[];let k=0;for(let A=0;A<f.workspaces.length&&k<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;A++){const F=n(f.workspaces[A]);if(F.scheme===h.Schemas.file){const H=(0,i.originalFSPath)(F);await m.Promises.exists(H)&&(w.push(H),k++)}}const R=[];for(let A=0;A<f.files.length&&k<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;A++){const F=n(f.files[A]);if(F.scheme===h.Schemas.file){const H=(0,i.originalFSPath)(F);if($e.COMMON_FILES_FILTER.includes((0,i.basename)(F))||w.includes(H))continue;await m.Promises.exists(H)&&(R.push(H),k++)}}R.reverse().forEach(A=>v.app.addRecentDocument(A)),w.reverse().forEach(A=>v.app.addRecentDocument(A))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){const w=[],k=[],R=f?.config?.workspace;(0,I.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?w.push({workspace:R}):(0,I.isSingleFolderWorkspaceIdentifier)(R)&&w.push({folderUri:R.uri});const A=f?.config?.filesToOpenOrCreate;if(A)for(let F of A){const H=F.fileUri;H&&r(k,H)===-1&&k.push({fileUri:H})}return this.addEntriesFromStorage(w,k),{workspaces:w,files:k}}addEntriesFromStorage(f,w){let k=this.getRecentlyOpenedFromStorage();for(let R of k.workspaces){let A=(0,I.isRecentFolder)(R)?s(f,R.folderUri):a(f,R.workspace);A>=0?f[A].label=f[A].label||R.label:f.push(R)}for(let R of k.files){let A=r(w,R.fileUri);A>=0?w[A].label=w[A].label||R.label:w.push(R)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem($e.recentlyOpenedStorageKey);return(0,I.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const w=(0,I.toStoreData)(f);this.stateMainService.setItem($e.recentlyOpenedStorageKey,w)}updateWindowsJumpList(){if(!d.isWindows)return;const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let w=[];for(let A of v.app.getJumpListSettings().removedItems){const F=A.args;if(F){const H=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(F);H&&w.push(S.URI.parse(H[2]))}}this.removeRecentlyOpened(w);let k=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(A=>{const F=(0,I.isRecentWorkspace)(A)?A.workspace:A.folderUri,{title:H,description:te}=this.getWindowsJumpListLabel(F,A.label);let se;return S.URI.isUri(F)?se=`--folder-uri "${F.toString()}"`:(k=!0,se=`--file-uri "${F.configPath.toString()}"`),{type:"task",title:H.substr(0,255),description:te.substr(0,255),program:process.execPath,args:se,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&f.push({type:"custom",name:k?(0,p.localize)(2,null):(0,p.localize)(3,null),items:R})}f.push({type:"recent"});try{v.app.setJumpList(f)}catch(w){this.logService.warn("updateWindowsJumpList#setJumpList",w)}}getWindowsJumpListLabel(f,w){if(w)return{title:(0,P.splitName)(w).name,description:w};if(S.URI.isUri(f))return{title:(0,i.basename)(f),description:u(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,p.localize)(4,null),description:""};let k=(0,i.basename)(f.configPath);return k.endsWith(I.WORKSPACE_EXTENSION)&&(k=k.substr(0,k.length-I.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,k),description:u(f.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([ee(0,y.IStateMainService),ee(1,E.ILogService),ee(2,c.IWorkspacesManagementMainService),ee(3,g.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function u(l){return l.scheme==="file"?(0,P.normalizeDriveLetter)(l.fsPath):l.toString()}function n(l){return(0,I.isRecentFolder)(l)?l.folderUri:(0,I.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function a(l,f){return l.findIndex(w=>(0,I.isRecentWorkspace)(w)&&w.workspace.id===f.id)}function s(l,f){return l.findIndex(w=>(0,I.isRecentFolder)(w)&&i.extUriBiasedIgnorePathCase.isEqual(w.folderUri,f))}function r(l,f){return l.findIndex(w=>i.extUriBiasedIgnorePathCase.isEqual(w.fileUri,f))}}),define(Z[238],x([0,1,13,9,23,34,3,7,148,19,24,22,6,186,55,21,38,30,41,67,36,68]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let a=class pt{constructor(l,f,w,k,R,A,F,H,te,se,le){this.updateService=l,this.configurationService=f,this.windowsMainService=w,this.environmentMainService=k,this.telemetryService=R,this.workspacesHistoryMainService=A,this.stateMainService=F,this.lifecycleMainService=H,this.logService=te,this.nativeHostMainService=se,this.productService=le,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(P.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(pt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,F,H)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,F,H)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,F,H)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(H),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,F,H)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(H),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const w=this.productService.reportIssueUrl;w&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(w,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(P.language){const A=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${A}lang=${P.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!P.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,f){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(pt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!P.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!P.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=v.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(P.isMacintosh?new v.Menu:null);return}const f=new v.Menu;let w;if(P.isMacintosh){const R=new v.Menu;w=new v.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),f.append(w)}if(P.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new v.Menu;R.append(new v.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:R});this.setMenuById(R,"File"),f.append(A)}if(this.shouldDrawMenu("Edit")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),f.append(A)}if(this.shouldDrawMenu("Selection")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),f.append(A)}if(this.shouldDrawMenu("View")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:R});this.setMenuById(R,"View"),f.append(A)}if(this.shouldDrawMenu("Go")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),f.append(A)}if(this.shouldDrawMenu("Run")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),f.append(A)}if(this.shouldDrawMenu("Terminal")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),f.append(A)}let k;if(this.shouldDrawMenu("Window")){const R=new v.Menu;k=new v.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(k&&f.append(k),this.shouldDrawMenu("Help")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),f.append(A)}f.items&&f.items.length>0?v.Menu.setApplicationMenu(f):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const f=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),w=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const Y=new v.Menu;this.setMenuById(Y,"Preferences"),k=new v.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:Y})}const R=new v.Menu,A=new v.MenuItem({label:h.localize(12,null),role:"services",submenu:R}),F=new v.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),H=new v.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),te=new v.MenuItem({label:h.localize(15,null),role:"unhide"}),se=new v.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:()=>{const Y=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||Y?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),le=[f];le.push(...w),k&&le.push(s(),k),le.push(s(),A,s(),F,H,te,s(),se),le.forEach(Y=>l.append(Y))}shouldDrawMenu(l){if(!P.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,f){f.forEach(w=>{if((0,p.isMenubarMenuItemSeparator)(w))l.append(s());else if((0,p.isMenubarMenuItemSubmenu)(w)){const k=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(w.label),submenu:k});this.setMenu(k,w.submenu.items),l.append(R)}else(0,p.isMenubarMenuItemRecentAction)(w)?l.append(this.createOpenRecentMenuItem(w)):(0,p.isMenubarMenuItemAction)(w)&&(w.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),P.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[w.id]?l.append(new v.MenuItem(this.likeAction(w.id,{label:this.mnemonicLabel(w.label),click:this.fallbackMenuHandlers[w.id]}))):l.append(this.createMenuItem(w.label,w.id,!1,w.checked)):l.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)):l.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)))})}setMenuById(l,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(l,this.menubarMenus[f].items)}insertCheckForUpdatesItems(l){const f=this.getUpdateMenuItems();f.length&&(f.forEach(w=>l.append(w)),l.append(s()))}createOpenRecentMenuItem(l){const f=b.URI.revive(l.uri),w=l.id,k=w==="openRecentFile"?{fileUri:f}:w==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new v.MenuItem(this.likeAction(w,{label:l.label,click:(R,A,F)=>{const H=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:H,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(l){return!!(l&&(!P.isMacintosh&&(l.ctrlKey||l.shiftKey)||P.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,f,w){const k={label:this.mnemonicLabel(l),role:w,enabled:!0};return new v.MenuItem(this.withKeybinding(f,k))}setMacWindowMenu(l){const f=new v.MenuItem({label:h.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),w=new v.MenuItem({label:h.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new v.MenuItem({label:h.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(h.localize(20,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(s()),A.push(this.createMenuItem(h.localize(21,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(h.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(h.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(h.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,w,s(),R,...A,s(),k].forEach(F=>l.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:h.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:h.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:h.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,f,w,k){const R=this.mnemonicLabel(l),A=typeof f=="function"?f:(le,Y,T)=>{const B=le?le.userSettingsLabel:null;let V=f;Array.isArray(f)&&(V=this.isOptionClick(T)?f[1]:f[0]),B&&T.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:B}):this.runActionInRenderer({type:"commandId",commandId:V})},F=typeof w=="boolean"?w:this.windowsMainService.getWindowCount()>0,H=typeof k=="boolean"?k:!1,te={label:R,click:A,enabled:F};H&&(te.type="checkbox",te.checked=H);let se;return typeof f=="string"?se=f:Array.isArray(f)&&(se=f[0]),P.isMacintosh&&(se==="editor.action.clipboardCutAction"?te.role="cut":se==="editor.action.clipboardCopyAction"?te.role="copy":se==="editor.action.clipboardPasteAction"&&(te.role="paste"),se==="undo"?te.click=this.makeContextAwareClickHandler(A,{inDevTools:le=>le.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?te.click=this.makeContextAwareClickHandler(A,{inDevTools:le=>le.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(te.click=this.makeContextAwareClickHandler(A,{inDevTools:le=>le.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(se,te))}makeContextAwareClickHandler(l,f){return(w,k,R)=>{const A=v.BrowserWindow.getFocusedWindow();if(!A)return f.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return f.inDevTools(A.webContents.devToolsWebContents);l(w,k||A,R)}}runActionInRenderer(l){let f=v.BrowserWindow.getFocusedWindow();if(!f){const k=this.windowsMainService.getLastActiveWindow();k?.isMinimized()&&(f=k.win)}const w=f?this.windowsMainService.getWindowById(f.id):void 0;if(w){if(this.logService.trace("menubar#runActionInRenderer",l),P.isMacintosh&&!this.environmentMainService.isBuilt&&!w.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const k={id:l.commandId,from:"menu"};w.sendWhenReady("vscode:runAction",D.CancellationToken.None,k)}else{const k={userSettingsLabel:l.userSettingsLabel};w.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,f){const w=typeof l=="string"?this.keybindings[l]:void 0;if(w?.label){if(w.isNative!==!1)f.accelerator=w.label,f.userSettingsLabel=w.userSettingsLabel;else if(typeof f.label=="string"){const k=f.label.indexOf("[");k>=0?f.label=`${f.label.substr(0,k)} [${w.label}]`:f.label=`${f.label} [${w.label}]`}}else f.accelerator=void 0;return f}likeAction(l,f,w=!f.accelerator){w&&(f=this.withKeybinding(l,f));const k=f.click;return f.click=(R,A,F)=>{this.reportMenuActionTelemetry(l),k&&k(R,A,F)},f}openUrl(l,f){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:n})}mnemonicLabel(l){return(0,M.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=he([ee(0,I.IUpdateService),ee(1,d.IConfigurationService),ee(2,o.IWindowsMainService),ee(3,i.IEnvironmentMainService),ee(4,y.ITelemetryService),ee(5,u.IWorkspacesHistoryMainService),ee(6,E.IStateMainService),ee(7,S.ILifecycleMainService),ee(8,m.ILogService),ee(9,t.INativeHostMainService),ee(10,g.IProductService)],a),e.Menubar=a;function s(){return new v.MenuItem({type:"separator"})}}),define(Z[239],x([0,1,5,22,6,238]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let P=class{constructor(h,d,i){this.instantiationService=h,this.lifecycleMainService=d,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(h,d){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(d,h)}};P=he([ee(0,v.IInstantiationService),ee(1,L.ILifecycleMainService),ee(2,D.ILogService)],P),e.MenubarMainService=P}),define(Z[240],x([0,1,13,29,26,31,23,4,33,42,34,2,10,8,63,3,32,15,25,14,7,154,53,19,54,24,18,5,22,6,50,21,57,64,38,67,237,101,220,27,102,68,46]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o,u,n,a,s,r,l,f,w,k,R,A,F,H,te,se,le,Y,T,B,V,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function C(K){return(0,B.isWorkspaceIdentifier)(K?.workspace)}function X(K){return(0,B.isSingleFolderWorkspaceIdentifier)(K?.workspace)}let W=class Ze extends S.Disposable{constructor(O,q,N,$,J,Q,ne,ae,ie,re,ce,fe,de,Ee,Pe){super();this.machineId=O,this.initialUserEnv=q,this.logService=N,this.stateMainService=$,this.environmentMainService=J,this.lifecycleMainService=Q,this.backupMainService=ne,this.configurationService=ae,this.workspacesHistoryMainService=ie,this.workspacesManagementMainService=re,this.instantiationService=ce,this.dialogMainService=fe,this.fileService=de,this.productService=Ee,this.protocolMainService=Pe,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new T.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(O=>this._onDidSignalReadyWindow.fire(O.window))),this._register(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const q=new S.DisposableStore;if(q.add(b.Event.any(O.onDidClose,O.onDidDestroy)(()=>q.dispose())),O.config.extensionDevelopmentPath)for(const N of O.config.extensionDevelopmentPath)q.add(this.protocolMainService.addValidFileRoot(o.URI.file(N)));O.config.extensionTestsPath&&q.add(this.protocolMainService.addValidFileRoot(o.URI.file(O.config.extensionTestsPath)))}}))}openEmptyWindow(O,q){let N=this.environmentMainService.args;const $=q?.remoteAuthority||void 0,J=!0,Q=q?.forceReuseWindow,ne=!Q;return this.open({...O,cli:N,forceEmpty:J,forceNewWindow:ne,forceReuseWindow:Q,remoteAuthority:$})}openExistingWindow(O,q){O.focus(),this.handleWaitMarkerFile(q,[O])}open(O){this.logService.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const q=[],N=[],$=[],J=[],Q=[];let ne,ae=0;const ie=this.getPathsToOpen(O);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const de of ie)X(de)?O.addMode?q.push(de):N.push(de):C(de)?$.push(de):de.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:de.remoteAuthority}),ne.filesToOpenOrCreate.push(de)):de.backupPath?Q.push({backupFolder:(0,p.basename)(de.backupPath),remoteAuthority:de.remoteAuthority}):ae++;O.diffMode&&ne&&ne.filesToOpenOrCreate.length>=2&&(ne.filesToDiff=ne.filesToOpenOrCreate.slice(0,2),ne.filesToOpenOrCreate=[]),ne&&O.waitMarkerFileURI&&(ne.filesToWait={paths:[...ne.filesToDiff,...ne.filesToOpenOrCreate],waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(J.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),$.push(...J),Q.push(...this.backupMainService.getEmptyWindowBackupPaths())):Q.length=0;const{windows:re,filesOpenedInWindow:ce}=this.doOpen(O,$,N,Q,ae,ne,q);if(this.logService.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${$.length}, foldersToOpen: ${N.length}, emptyToRestore: ${Q.length}, emptyToOpen: ${ae})`),re.length>1)if(ce)ce.focus();else{const de=this.windowsStateHandler.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Ee=!0,Pe=!0;if(de){const Ie=re.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),Ee=!1,Pe=!1)}if(Ee)for(let Ie=re.length-1;Ie>=0;Ie--){const ve=re[Ie];if(!(ve.openedWorkspace&&J.some(ye=>ve.openedWorkspace&&ye.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&Q.some(ye=>ve.backupPath&&ye.backupFolder===(0,p.basename)(ve.backupPath)))){ve.focus(),Pe=!1;break}}Pe&&re[re.length-1].focus()}const fe=ne&&ne.filesToDiff.length>0;if(!re.some(de=>de.isExtensionDevelopmentHost)&&!fe&&!O.noRecentEntry){const de=[];for(const Ee of ie)C(Ee)&&!Ee.transient?de.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):X(Ee)?de.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&de.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(de)}return this.handleWaitMarkerFile(O,re),re}handleWaitMarkerFile(O,q){const N=O.waitMarkerFileURI;O.context===0&&N&&q.length===1&&q[0]&&(async()=>{await q[0].whenClosedOrLoaded;try{await this.fileService.del(N)}catch($){}})()}doOpen(O,q,N,$,J,Q,ne){const ae=[];let ie;function re(ve,ye){ae.push(ve),ye&&(ie=ve,Q=void 0)}let{openFolderInNewWindow:ce,openFilesInNewWindow:fe}=this.shouldOpenNewWindow(O);if(!O.initialStartup&&ne.length>0){const ve=ne[0].remoteAuthority,ye=this.getLastActiveWindowForAuthority(ve);ye&&re(this.doAddFoldersToExistingWindow(ye,ne.map(ke=>ke.workspace.uri)))}const de=N.length+q.length+$.length;if(Q&&de===0){const ve=Q.filesToOpenOrCreate[0]||Q.filesToDiff[0],ye=this.getWindows().filter(We=>Q&&z(We.remoteAuthority,Q.remoteAuthority));let ke;ve?.fileUri&&!fe&&((O.context===4||O.context===0||O.context===1)&&(ke=(0,Y.findWindowOnFile)(ye,ve.fileUri,We=>We.configPath.scheme===m.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(We.configPath):void 0)),ke||(ke=this.doGetLastActiveWindow(ye))),ke?(0,B.isWorkspaceIdentifier)(ke.openedWorkspace)?q.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):(0,B.isSingleFolderWorkspaceIdentifier)(ke.openedWorkspace)?N.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):re(this.doOpenFilesInExistingWindow(O,ke,Q),!0):re(this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:Q,forceNewWindow:!0,remoteAuthority:Q.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow}),!0)}const Ee=(0,M.distinct)(q,ve=>ve.workspace.id);if(Ee.length>0){const ve=(0,M.coalesce)(Ee.map(ye=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(ve.length>0){const ye=ve[0],ke=z(Q?.remoteAuthority,ye.remoteAuthority)?Q:void 0;re(this.doOpenFilesInExistingWindow(O,ye,ke),!!ke),ce=!0}Ee.forEach(ye=>{if(ve.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===ye.workspace.id))return;const ke=ye.remoteAuthority,We=z(Q?.remoteAuthority,ke)?Q:void 0;re(this.doOpenFolderOrWorkspace(O,ye,ce,We),!!We),ce=!0})}const Pe=(0,M.distinct)(N,ve=>y.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Pe.length>0){const ve=(0,M.coalesce)(Pe.map(ye=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(ve.length>0){const ye=ve[0],ke=z(Q?.remoteAuthority,ye.remoteAuthority)?Q:void 0;re(this.doOpenFilesInExistingWindow(O,ye,ke),!!ke),ce=!0}Pe.forEach(ye=>{if(ve.some(Ae=>(0,B.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,ye.workspace.uri)))return;const ke=ye.remoteAuthority,We=z(Q?.remoteAuthority,ke)?Q:void 0;re(this.doOpenFolderOrWorkspace(O,ye,ce,We),!!We),ce=!0})}const Ie=(0,M.distinct)($,ve=>ve.backupFolder);if(Ie.length>0&&Ie.forEach(ve=>{const ye=ve.remoteAuthority,ke=z(Q?.remoteAuthority,ye)?Q:void 0;re(this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:ke,remoteAuthority:ye,forceNewWindow:!0,forceNewTabbedWindow:O.forceNewTabbedWindow,emptyWindowBackupInfo:ve}),!!ke),ce=!0}),ae.length===0||Q){Q&&!J&&J++;const ve=Q?Q.remoteAuthority:O.remoteAuthority;for(let ye=0;ye<J;ye++)re(this.doOpenEmpty(O,ce,ve,Q),!!Q),ce=!0}return{windows:(0,M.distinct)(ae),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(O,q,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),q.focus();const $={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToWait:N?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return q.sendWhenReady("vscode:openFiles",P.CancellationToken.None,$),q}doAddFoldersToExistingWindow(O,q){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),O.focus();const N={foldersToAdd:q};return O.sendWhenReady("vscode:addFolders",P.CancellationToken.None,N),O}doOpenEmpty(O,q,N,$,J){return!q&&!J&&typeof O.contextWindowId=="number"&&(J=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:N,forceNewWindow:q,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:$,windowToUse:J})}doOpenFolderOrWorkspace(O,q,N,$,J){return!N&&!J&&typeof O.contextWindowId=="number"&&(J=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({workspace:q.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:q.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:$,windowToUse:J})}getPathsToOpen(O){let q,N=!1,$=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(q=this.doExtractPathsFromAPI(O),N=!0):O.forceEmpty?q=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(q=this.doExtractPathsFromCLI(O.cli),q.length===0&&q.push(Object.create(null)),N=!0):(q=this.doGetPathsFromLastSession(),q.length===0&&q.push(Object.create(null)),$=!0),!O.addMode&&N){const J=q.filter(Q=>X(Q));if(J.length>1){const Q=J[0].remoteAuthority;if(J.every(ne=>z(ne.remoteAuthority,Q))){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(J.map(ae=>({uri:ae.workspace.uri})));q.push({workspace:ne,remoteAuthority:Q}),q=q.filter(ae=>!X(ae))}}}return O.initialStartup&&!$&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&q.unshift(...this.doGetPathsFromLastSession().filter(J=>C(J)||X(J)||J.backupPath)),q}doExtractPathsFromAPI(O){const q=[],N={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority};for(const $ of(0,M.coalesce)(O.urisToOpen||[])){const J=this.resolveOpenable($,N);if(J)J.label=$.label,q.push(J);else{const Q=this.resourceFromOpenable($),ne={title:this.productService.nameLong,type:"info",buttons:[(0,i.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:Q.scheme===m.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:Q.scheme===m.Schemas.file?(0,u.localize)(3,null,(0,i.getPathLabel)(Q.fsPath,this.environmentMainService)):(0,u.localize)(4,null,Q.toString()),noLink:!0};this.dialogMainService.showMessageBox(ne,(0,c.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return q}doExtractPathsFromCLI(O){const q=[],N={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:!1},$=O["folder-uri"];if($)for(const ne of $){const ae=this.cliArgToUri(ne);if(ae){const ie=this.resolveOpenable({folderUri:ae},N);ie&&q.push(ie)}}const J=O["file-uri"];if(J)for(const ne of J){const ae=this.cliArgToUri(ne);if(ae){const ie=this.resolveOpenable((0,B.hasWorkspaceFileExtension)(ne)?{workspaceUri:ae}:{fileUri:ae},N);ie&&q.push(ie)}}const Q=O._;for(const ne of Q){const ae=N.remoteAuthority?this.doResolvePathRemote(ne,N):this.doResolveFilePath(ne,N);ae&&q.push(ae)}return q}cliArgToUri(O){try{const q=o.URI.parse(O);if(!q.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${O}`);return}return q}catch(q){this.logService.error(`Invalid URI input string: ${O}, ${q.message}`)}}doGetPathsFromLastSession(){const O=this.getRestoreWindowsSetting();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":const q=[];O!=="one"&&q.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&q.push(this.windowsStateHandler.state.lastActiveWindow);const N=[];for(const $ of q)if($.workspace){const J=this.resolveOpenable({workspaceUri:$.workspace.configPath},{remoteAuthority:$.remoteAuthority,rejectTransientWorkspaces:!0});C(J)&&N.push(J)}else if($.folderUri){const J=this.resolveOpenable({folderUri:$.folderUri},{remoteAuthority:$.remoteAuthority});X(J)&&N.push(J)}else O!=="folders"&&$.backupPath&&N.push({backupPath:$.backupPath,remoteAuthority:$.remoteAuthority});return N}}getRestoreWindowsSetting(){let O;return this.lifecycleMainService.wasRestarted?O="all":(O=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}resolveOpenable(O,q=Object.create(null)){let N=this.resourceFromOpenable(O);return N.scheme===m.Schemas.file?((0,se.isFileToOpen)(O)&&(q={...q,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,q)):this.doResolveRemoteOpenable(O,q)}doResolveRemoteOpenable(O,q){let N=this.resourceFromOpenable(O);const $=(0,H.getRemoteAuthority)(N)||q.remoteAuthority;if(N=(0,y.removeTrailingPathSeparator)((0,y.normalizePath)(N)),(0,se.isFileToOpen)(O)){if(q.gotoLineMode){const{path:J,line:Q,column:ne}=(0,h.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:J}),selection:Q?{startLineNumber:Q,startColumn:ne||1}:void 0,remoteAuthority:$}}return{fileUri:N,remoteAuthority:$}}else if((0,se.isWorkspaceToOpen)(O))return{workspace:(0,V.getWorkspaceIdentifier)(N),remoteAuthority:$};return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:$}}resourceFromOpenable(O){return(0,se.isWorkspaceToOpen)(O)?O.workspaceUri:(0,se.isFolderToOpen)(O)?O.folderUri:O.fileUri}doResolveFilePath(O,q){let N,$;q.gotoLineMode&&({path:O,line:N,column:$}=(0,h.parseLineAndColumnAware)(O)),O=(0,h.sanitizeFilePath)((0,p.normalize)(O),(0,E.cwd)());try{const J=(0,L.statSync)(O);if(J.isFile()){if(!q.forceOpenWorkspaceAsFile){const Q=this.workspacesManagementMainService.resolveLocalWorkspaceSync(o.URI.file(O));if(Q)return Q.transient&&q.rejectTransientWorkspaces?void 0:{workspace:{id:Q.id,configPath:Q.configPath},remoteAuthority:Q.remoteAuthority,exists:!0,transient:Q.transient}}return{fileUri:o.URI.file(O),selection:N?{startLineNumber:N,startColumn:$||1}:void 0,exists:!0}}else{if(J.isDirectory())return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(o.URI.file(O),J),exists:!0};if(!g.isWindows&&O==="/dev/null")return{fileUri:o.URI.file(O),exists:!0}}}catch(J){const Q=o.URI.file(O);if(this.workspacesHistoryMainService.removeRecentlyOpened([Q]),q.ignoreFileNotFound)return{fileUri:Q,exists:!1}}}doResolvePathRemote(O,q){const N=O.charCodeAt(0),$=q.remoteAuthority;let J,Q;q.gotoLineMode&&({path:O,line:J,column:Q}=(0,h.parseLineAndColumnAware)(O)),N!==47&&((0,h.isWindowsDriveLetter)(N)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,h.toSlashes)(O)),O=`/${O}`);const ne=o.URI.from({scheme:m.Schemas.vscodeRemote,authority:$,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,B.hasWorkspaceFileExtension)(O))return q.forceOpenWorkspaceAsFile?{fileUri:ne,selection:J?{startLineNumber:J,startColumn:Q||1}:void 0,remoteAuthority:q.remoteAuthority}:{workspace:(0,V.getWorkspaceIdentifier)(ne),remoteAuthority:$};if(q.gotoLineMode||p.posix.basename(O).indexOf(".")!==-1)return{fileUri:ne,selection:J?{startLineNumber:J,startColumn:Q||1}:void 0,remoteAuthority:$}}return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(ne),remoteAuthority:$}}shouldOpenNewWindow(O){const q=this.configurationService.getValue("window"),N=q?.openFoldersInNewWindow||"default",$=q?.openFilesInNewWindow||"off";let J=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(N==="on"||N==="off")&&(J=N==="on");let Q=!1;return O.forceNewWindow||O.forceReuseWindow?Q=!!O.forceNewWindow&&!O.forceReuseWindow:(g.isMacintosh?O.context===1&&(Q=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(Q=!0),!O.cli.extensionDevelopmentPath&&($==="on"||$==="off")&&(Q=$==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:Q}}openExtensionDevelopmentHostWindow(O,q){const N=(0,Y.findWindowOnExtensionDevelopmentPath)(this.getWindows(),O);if(N)return this.lifecycleMainService.reload(N,q.cli),N.focus(),[N];let $=q.cli["folder-uri"]||[],J=q.cli["file-uri"]||[],Q=q.cli._;if(!Q.length&&!$.length&&!J.length&&!q.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=re&&(re.workspace||re.folderUri);ce&&(o.URI.isUri(ce)?ce.scheme===m.Schemas.file?Q=[ce.fsPath]:$=[ce.toString()]:ce.configPath.scheme===m.Schemas.file?Q=[(0,y.originalFSPath)(ce.configPath)]:J=[ce.configPath.toString()])}let ne=q.remoteAuthority;for(const re of O)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=o.URI.parse(re),fe=(0,H.getRemoteAuthority)(ce);fe&&(ne?fe!==ne&&this.logService.error("more than one extension development path authority"):ne=fe)}Q=Q.filter(re=>{const ce=o.URI.file(re);return(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,H.getRemoteAuthority)(ce)===ne}),$=$.filter(re=>{const ce=this.cliArgToUri(re);return ce&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,H.getRemoteAuthority)(ce)===ne:!1}),J=J.filter(re=>{const ce=this.cliArgToUri(re);return ce&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,H.getRemoteAuthority)(ce)===ne:!1}),q.cli._=Q,q.cli["folder-uri"]=$,q.cli["file-uri"]=J;const ae=!Q.length&&!$.length&&!J.length,ie={context:q.context,cli:q.cli,forceNewWindow:!0,forceEmpty:ae,userEnv:q.userEnv,noRecentEntry:!0,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:ne};return this.open(ie)}openInBrowserWindow(O){const q=this.configurationService.getValue("window"),N={...this.environmentMainService.args,...O.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.initialUserEnv,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:R.default,isInitialStartup:O.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof q?.zoomLevel=="number"?q.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:q?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let $;if(!O.forceNewWindow&&!O.forceNewTabbedWindow&&($=O.windowToUse||this.getLastActiveWindow(),$&&$.focus()),$){const J=$.config;!N.extensionDevelopmentPath&&J&&!!J.extensionDevelopmentPath&&(N.extensionDevelopmentPath=J.extensionDevelopmentPath,N.verbose=J.verbose,N["inspect-brk-extensions"]=J["inspect-brk-extensions"],N.debugId=J.debugId,N.extensionEnvironment=J.extensionEnvironment,N["inspect-extensions"]=J["inspect-extensions"],N["extensions-dir"]=J["extensions-dir"])}else{const J=this.windowsStateHandler.getNewWindowState(N);(0,t.mark)("code/willCreateCodeWindow");const Q=$=this.instantiationService.createInstance(le.CodeWindow,{state:J,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow){const ae=this.getLastActiveWindow();ae&&ae.addTabbedWindow(Q)}Ze.WINDOWS.push(Q),this._onDidOpenWindow.fire(Q),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,d.once)(Q.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(Q)),(0,d.once)(Q.onDidClose)(()=>this.onWindowClosed(Q)),(0,d.once)(Q.onDidDestroy)(()=>this._onDidDestroyWindow.fire(Q));const ne=(0,c.assertIsDefined)(Q.win?.webContents);ne.removeAllListeners("devtools-reload-page"),ne.on("devtools-reload-page",()=>this.lifecycleMainService.reload(Q)),this.lifecycleMainService.registerWindow(Q)}return N.windowId=$.id,$.isReady?this.lifecycleMainService.unload($,4).then(J=>{J||this.doOpenInBrowserWindow($,N,O)}):this.doOpenInBrowserWindow($,N,O),$}doOpenInBrowserWindow(O,q,N){if(!q.extensionDevelopmentPath)if((0,B.isWorkspaceIdentifier)(q.workspace))q.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:q.workspace,remoteAuthority:q.remoteAuthority});else if((0,B.isSingleFolderWorkspaceIdentifier)(q.workspace))q.backupPath=this.backupMainService.registerFolderBackupSync(q.workspace.uri);else{const $=N.emptyWindowBackupInfo&&N.emptyWindowBackupInfo.backupFolder;q.backupPath=this.backupMainService.registerEmptyWindowBackupSync($,q.remoteAuthority)}O.load(q)}onWindowClosed(O){const q=Ze.WINDOWS.indexOf(O);Ze.WINDOWS.splice(q,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const O=v.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(O){return this.doGetLastActiveWindow(this.getWindows().filter(q=>z(q.remoteAuthority,O)))}doGetLastActiveWindow(O){const q=Math.max.apply(Math,O.map(N=>N.lastFocusTime));return O.find(N=>N.lastFocusTime===q)}sendToFocused(O,...q){const N=this.getFocusedWindow()||this.getLastActiveWindow();N&&N.sendWhenReady(O,P.CancellationToken.None,...q)}sendToAll(O,q,N){for(const $ of this.getWindows())N&&N.indexOf($.id)>=0||$.sendWhenReady(O,P.CancellationToken.None,q)}getWindows(){return Ze.WINDOWS}getWindowCount(){return Ze.WINDOWS.length}getWindowById(O){const q=this.getWindows().filter(N=>N.id===O);return(0,M.firstOrDefault)(q)}getWindowByWebContents(O){const q=v.BrowserWindow.fromWebContents(O);if(!!q)return this.getWindowById(q.id)}};W.WINDOWS=[],W=he([ee(2,k.ILogService),ee(3,te.IStateMainService),ee(4,r.IEnvironmentMainService),ee(5,w.ILifecycleMainService),ee(6,n.IBackupMainService),ee(7,a.IConfigurationService),ee(8,_.IWorkspacesHistoryMainService),ee(9,U.IWorkspacesManagementMainService),ee(10,f.IInstantiationService),ee(11,s.IDialogMainService),ee(12,l.IFileService),ee(13,A.IProductService),ee(14,F.IProtocolMainService)],W),e.WindowsMainService=W;function z(K,O){return K===O||K!==void 0&&O!==void 0&&(0,I.equalsIgnoreCase)(K,O)}}),define(Z[241],x([0,1,53,36,68,46]),function(j,e,v,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(h,d,i,S){this.workspacesManagementMainService=h,this.windowsMainService=d,this.workspacesHistoryMainService=i,this.backupMainService=S,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,d){const i=this.windowsMainService.getWindowById(h);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),d)}createUntitledWorkspace(h,d,i){return this.workspacesManagementMainService.createUntitledWorkspace(d,i)}deleteUntitledWorkspace(h,d){return this.workspacesManagementMainService.deleteUntitledWorkspace(d)}getWorkspaceIdentifier(h,d){return this.workspacesManagementMainService.getWorkspaceIdentifier(d)}async getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(h))}async addRecentlyOpened(h,d){return this.workspacesHistoryMainService.addRecentlyOpened(d)}async removeRecentlyOpened(h,d){return this.workspacesHistoryMainService.removeRecentlyOpened(d)}async clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=he([ee(0,M.IWorkspacesManagementMainService),ee(1,L.IWindowsMainService),ee(2,D.IWorkspacesHistoryMainService),ee(3,v.IBackupMainService)],P),e.WorkspacesMainService=P}),define(Z[242],x([0,1,13,29,26,17,45,16,33,42,39,34,2,10,8,3,15,14,7,28,71,121,35,124,86,233,133,53,224,19,179,161,75,54,223,89,24,56,91,169,187,90,170,18,182,96,74,5,76,234,200,103,22,6,184,239,55,21,64,229,77,38,218,100,201,30,203,205,65,41,209,231,235,232,236,99,210,211,212,213,215,36,240,216,27,68,241,46]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o,u,n,a,s,r,l,f,w,k,R,A,F,H,te,se,le,Y,T,B,V,_,U,C,X,W,z,K,O,q,N,$,J,Q,ne,ae,ie,re,ce,fe,de,Ee,Pe,Ie,ve,ye,ke,We,Ae,Ve,xe,st,Ke,ht,et,G,oe,ue,me,be,Te,_e,Ue,Be,Ce,ze,It,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let dt=class extends m.Disposable{constructor(ge,pe,Se,we,Me,Le,De,Fe,Oe,qe){super();this.mainProcessNodeIpcServer=ge,this.userEnv=pe,this.mainInstantiationService=Se,this.logService=we,this.environmentMainService=Me,this.lifecycleMainService=Le,this.configurationService=De,this.stateMainService=Fe,this.fileService=Oe,this.productService=qe,this.configureSession(),this.registerListeners()}configureSession(){const ge=we=>we?.startsWith(`${p.Schemas.vscodeWebview}://`),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((we,Me,Le,De)=>ge(De.requestingUrl)?Le(pe.has(Me)):Le(!1)),v.session.defaultSession.setPermissionCheckHandler((we,Me,Le,De)=>ge(De.requestingUrl)?pe.has(Me):!1);const Se=v.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,b.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,b.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,b.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Se,we)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",we)}),v.app.on("activate",(Se,we)=>{this.logService.trace("app#activate"),we||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Se,we)=>{we.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),we.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let ge=[],pe;v.app.on("open-file",(Se,we)=>{this.logService.trace("app#open-file: ",we),Se.preventDefault(),ge.push(this.getWindowOpenableFromPathSync(we)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ge,gotoLineMode:!1,preferNewWindow:!0}),ge=[],pe=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",Se=>{const we=this.windowsMainService?.getWindowByWebContents(Se.sender);let Me,Le;return we?.config?(Me=we.config,Le={...process.env,...we.config.userEnv}):(Me=this.environmentMainService.args,Le=process.env),this.resolveShellEnvironment(Me,Le)}),v.ipcMain.handle("vscode:writeNlsFile",(Se,we,Me)=>{const Le=this.validateNlsPath([we]);if(!Le||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,M.VSBuffer.fromString(Me))}),v.ipcMain.handle("vscode:readNlsFile",async(Se,...we)=>{const Me=this.validateNlsPath(we);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(ge){let pe;for(const Se of ge)typeof Se=="string"&&(typeof pe!="string"?pe=Se:pe=(0,t.join)(pe,Se));if(!(typeof pe!="string"||!(0,t.isAbsolute)(pe)||!(0,h.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return I.URI.file(pe)}onUnexpectedError(ge){if(ge){const pe={message:`[uncaught exception in main]: ${ge.message}`,stack:ge.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(pe))}this.logService.error(`[uncaught exception in main]: ${ge}`),ge.stack&&this.logService.error(ge.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ge=this.productService.win32AppUserModelId;g.isWindows&&ge&&v.app.setAppUserModelId(ge);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Oe){this.logService.error(Oe)}const pe=new a.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:we,sharedProcessReady:Me,sharedProcessClient:Le}=this.setupSharedProcess(Se),De=await this.initServices(Se,we,Me);if(this.environmentMainService.driverHandle){const Oe=await(0,te.serve)(pe,this.environmentMainService.driverHandle,this.environmentMainService,De);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Oe)}this._register(De.createInstance(r.ProxyAuthHandler)),De.invokeFunction(Oe=>this.initChannels(Oe,pe,Le));const Fe=De.invokeFunction(Oe=>this.openFirstWindow(Oe,pe));De.invokeFunction(Oe=>this.afterWindowOpen(Oe,we)),this.environmentMainService.args.trace&&De.invokeFunction(Oe=>this.stopTracingEventually(Oe,Fe))}async resolveMachineId(){let ge=this.stateMainService.getItem(ye.machineIdKey);return(!ge||g.isMacintosh&&ge==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(ge=await(0,o.getMachineId)(),this.stateMainService.setItem(ye.machineIdKey,ge)),ge}setupSharedProcess(ge){const pe=this._register(this.mainInstantiationService.createInstance(fe.SharedProcess,ge,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Me,"main")})(),we=(async()=>(await pe.whenReady(),Se))();return{sharedProcess:pe,sharedProcessReady:we,sharedProcessClient:Se}}async initServices(ge,pe,Se){const we=new O.ServiceCollection;switch(process.platform){case"win32":we.set(Ve.IUpdateService,new z.SyncDescriptor(et.Win32UpdateService));break;case"linux":g.isLinuxSnap?we.set(Ve.IUpdateService,new z.SyncDescriptor(ht.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(Ve.IUpdateService,new z.SyncDescriptor(Ke.LinuxUpdateService));break;case"darwin":we.set(Ve.IUpdateService,new z.SyncDescriptor(st.DarwinUpdateService));break}we.set(_e.IWindowsMainService,new z.SyncDescriptor(Ue.WindowsMainService,[ge,this.userEnv])),we.set(H.IDialogMainService,new z.SyncDescriptor(H.DialogMainService)),we.set($.ILaunchMainService,new z.SyncDescriptor($.LaunchMainService)),we.set(F.IDiagnosticsService,n.ProxyChannel.toService((0,n.getDelayedChannel)(Se.then(Le=>Le.getChannel("diagnostics"))))),we.set(q.IIssueMainService,new z.SyncDescriptor(q.IssueMainService,[this.userEnv])),we.set(se.IEncryptionMainService,new z.SyncDescriptor(se.EncryptionMainService,[ge])),we.set(N.IKeyboardLayoutMainService,new z.SyncDescriptor(N.KeyboardLayoutMainService)),we.set(ie.INativeHostMainService,new z.SyncDescriptor(ie.NativeHostMainService,[pe])),we.set(be.IWebviewManagerService,new z.SyncDescriptor(Te.WebviewMainService)),we.set(Ce.IWorkspacesService,new z.SyncDescriptor(It.WorkspacesMainService)),we.set(vt.IWorkspacesManagementMainService,new z.SyncDescriptor(vt.WorkspacesManagementMainService)),we.set(ze.IWorkspacesHistoryMainService,new z.SyncDescriptor(ze.WorkspacesHistoryMainService)),we.set(ae.IMenubarMainService,new z.SyncDescriptor(ae.MenubarMainService)),we.set(B.IExtensionUrlTrustService,new z.SyncDescriptor(V.ExtensionUrlTrustService)),we.set(Ie.IStorageMainService,new z.SyncDescriptor(Ie.StorageMainService)),g.isWindows?we.set(_.IExternalTerminalMainService,new z.SyncDescriptor(U.WindowsExternalTerminalService)):g.isMacintosh?we.set(_.IExternalTerminalMainService,new z.SyncDescriptor(U.MacExternalTerminalService)):g.isLinux&&we.set(_.IExternalTerminalMainService,new z.SyncDescriptor(U.LinuxExternalTerminalService));const Me=new w.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(we.set(f.IBackupMainService,Me),we.set(G.IURLService,new z.SyncDescriptor(ue.NativeURLService)),(0,Ae.supportsTelemetry)(this.productService,this.environmentMainService)){const Le=(0,n.getDelayedChannel)(Se.then(Ge=>Ge.getChannel("telemetryAppender"))),De=new ke.TelemetryAppenderClient(Le),Fe=(0,ve.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,ge,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Oe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],qe={appenders:[De],commonProperties:Fe,piiPaths:Oe,sendErrorTelemetry:!0};we.set(ye.ITelemetryService,new z.SyncDescriptor(We.TelemetryService,[qe]))}else we.set(ye.ITelemetryService,Ae.NullTelemetryService);return await Me.initialize(),this.mainInstantiationService.createChild(we)}initChannels(ge,pe,Se){const we=n.ProxyChannel.fromService(ge.get($.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",we);const Me=this.fileService.getProvider(p.Schemas.file);(0,y.assertType)(Me instanceof W.DiskFileSystemProvider);const Le=new X.DiskFileSystemProviderChannel(Me,this.logService);pe.registerChannel("localFilesystem",Le);const De=new R.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);pe.registerChannel(R.UserConfigurationFileServiceId,n.ProxyChannel.fromService(De)),Se.then(Re=>Re.registerChannel(R.UserConfigurationFileServiceId,n.ProxyChannel.fromService(De)));const Fe=new xe.UpdateChannel(ge.get(Ve.IUpdateService));pe.registerChannel("update",Fe);const Oe=n.ProxyChannel.fromService(ge.get(q.IIssueMainService));pe.registerChannel("issue",Oe);const qe=n.ProxyChannel.fromService(ge.get(se.IEncryptionMainService));pe.registerChannel("encryption",qe);const Ge=n.ProxyChannel.fromService(ge.get(de.ISignService));pe.registerChannel("sign",Ge);const tt=n.ProxyChannel.fromService(ge.get(N.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",tt),this.nativeHostMainService=ge.get(ie.INativeHostMainService);const Ye=n.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ye),Se.then(Re=>Re.registerChannel("nativeHost",Ye));const ft=n.ProxyChannel.fromService(ge.get(Ce.IWorkspacesService));pe.registerChannel("workspaces",ft);const Ne=n.ProxyChannel.fromService(ge.get(ae.IMenubarMainService));pe.registerChannel("menubar",Ne);const ot=n.ProxyChannel.fromService(ge.get(G.IURLService));pe.registerChannel("url",ot);const it=n.ProxyChannel.fromService(ge.get(B.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",it);const nt=n.ProxyChannel.fromService(ge.get(be.IWebviewManagerService));pe.registerChannel("webview",nt);const rt=this._register(new Pe.StorageDatabaseChannel(this.logService,ge.get(Ie.IStorageMainService)));pe.registerChannel("storage",rt),Se.then(Re=>Re.registerChannel("storage",rt));const at=n.ProxyChannel.fromService(ge.get(_.IExternalTerminalMainService));pe.registerChannel("externalTerminal",at);const Xe=new ne.LogLevelChannel(ge.get(Q.ILogService));pe.registerChannel("logLevel",Xe),Se.then(Re=>Re.registerChannel("logLevel",Xe));const Qe=new ne.LoggerChannel(ge.get(Q.ILoggerService));pe.registerChannel("logger",Qe),Se.then(Re=>Re.registerChannel("logger",Qe));const lt=new A.ElectronExtensionHostDebugBroadcastChannel(ge.get(_e.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",lt)}openFirstWindow(ge,pe){const Se=this.windowsMainService=ge.get(_e.IWindowsMainService),we=ge.get(G.IURLService),Me=ge.get(ie.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],De=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Re=>{try{return{uri:I.URI.parse(Re),url:Re}}catch{return}}).filter(Re=>{if(!Re||this.shouldBlockURI(Re.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(Re.uri);return Je?(Le.push(Je),!1):!0}),Fe=this,Oe=this.environmentMainService,qe=this.productService;we.registerHandler({async handleURL(Re,Je){if(Re.scheme===qe.urlProtocol&&Re.path==="workspace"&&(Re=Re.with({authority:"file",path:I.URI.parse(Re.query).path,query:""})),Fe.shouldBlockURI(Re))return!0;const yt=Fe.getWindowOpenableFromProtocolLink(Re);if(yt){const[gt]=Se.open({context:5,cli:{...Oe.args},urisToOpen:[yt],gotoLineMode:!0});return gt.focus(),!0}if(g.isMacintosh&&Se.getWindowCount()===0){const[gt]=Se.open({context:5,cli:{...Oe.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ce.getRemoteAuthority)(Re)});return await gt.ready(),we.open(Re,Je)}return!1}});const Ge=this._register(new Be.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),tt=new n.StaticRouter(Re=>Ge.getActiveClientId().then(Je=>Re===Je)),Ye=new oe.URLHandlerRouter(tt),ft=pe.getChannel("urlHandler",Ye);we.registerHandler(new oe.URLHandlerChannelClient(ft)),this._register(new me.ElectronURLListener(De,we,Se,this.environmentMainService,this.productService));const Ne=this.environmentMainService.args,ot=global.macOpenFiles,it=(0,Y.isLaunchedFromCli)(process.env)?0:4,nt=Ne._.length,rt=!!Ne["folder-uri"],at=!!Ne["file-uri"],Xe=Ne["skip-add-to-recently-opened"]===!0,Qe=Ne.wait&&Ne.waitMarkerFilePath?I.URI.file(Ne.waitMarkerFilePath):void 0,lt=Ne.remote||void 0;return Le.length>0?Se.open({context:it,cli:Ne,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):Ne["new-window"]&&!nt&&!rt&&!at?Se.open({context:it,cli:Ne,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Xe,waitMarkerFileURI:Qe,initialStartup:!0,remoteAuthority:lt}):ot.length&&!nt&&!rt&&!at?Se.open({context:1,cli:Ne,urisToOpen:ot.map(Re=>this.getWindowOpenableFromPathSync(Re)),noRecentEntry:Xe,waitMarkerFileURI:Qe,initialStartup:!0}):Se.open({context:it,cli:Ne,forceNewWindow:Ne["new-window"]||!nt&&Ne["unity-launch"],diffMode:Ne.diff,noRecentEntry:Xe,waitMarkerFileURI:Qe,gotoLineMode:Ne.goto,initialStartup:!0,remoteAuthority:lt})}shouldBlockURI(ge){return!!(ge.authority===p.Schemas.file&&g.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,l.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,l.localize)(1,null))],defaultId:0,cancelId:1,message:(0,l.localize)(2,null,(0,S.getPathLabel)(ge.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,l.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(ge){if(!!ge.path){if(ge.authority===p.Schemas.file){const pe=I.URI.file(ge.fsPath);return(0,Ce.hasWorkspaceFileExtension)(pe)?{workspaceUri:pe}:{fileUri:pe}}else if(ge.authority===p.Schemas.vscodeRemote){const pe=ge.path.indexOf(t.posix.sep,1);if(pe!==-1){const Se=ge.path.substring(1,pe),we=ge.path.substring(pe),Me=I.URI.from({scheme:p.Schemas.vscodeRemote,authority:Se,path:we,query:ge.query,fragment:ge.fragment});return(0,Ce.hasWorkspaceFileExtension)(we)?{workspaceUri:Me}:/:[\d]+$/.test(we)?{fileUri:Me}:{folderUri:Me}}}}}getWindowOpenableFromPathSync(ge){try{if((0,L.statSync)(ge).isDirectory())return{folderUri:I.URI.file(ge)};if((0,Ce.hasWorkspaceFileExtension)(ge))return{workspaceUri:I.URI.file(ge)}}catch(pe){}return{fileUri:I.URI.file(ge)}}async afterWindowOpen(ge,pe){this.lifecycleMainService.phase=3;let Se=!1;(0,d.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const we=ge.get(ye.ITelemetryService);this._register(pe.onDidError(({type:De,details:Fe})=>{let Oe;switch(De){case 1:Oe="SharedProcess: detected unresponsive window";break;case 2:Oe=`SharedProcess: crashed (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:Oe=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,b.onUnexpectedError)(new Error(Oe)),we.publicLog2("sharedprocesserror",{type:De,reason:Fe?.reason,code:Fe?.exitCode,visible:pe.isVisible(),shuttingdown:Se})}));const Me=this.productService.win32MutexName;if(g.isWindows&&Me)try{const De=j.__$__nodeRequire("windows-mutex").Mutex,Fe=new De(Me);(0,d.once)(this.lifecycleMainService.onWillShutdown)(()=>Fe.release())}catch(De){this.logService.error(De)}v.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(De,Fe)=>{Fe({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const Le=ge.get(Ve.IUpdateService);(Le instanceof et.Win32UpdateService||Le instanceof Ke.LinuxUpdateService||Le instanceof st.DarwinUpdateService)&&Le.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env);try{const Fe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,i.stripComments)(Fe))["enable-crash-reporter"]===void 0){const Ge=(0,Ae.getTelemetryLevel)(this.configurationService)>=1,tt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ge},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],Ye=Fe.substring(0,Fe.length-2).concat(`,
`,tt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Ye))}}catch(De){this.logService.error(De)}}async resolveShellEnvironment(ge,pe){try{return await(0,T.resolveShellEnv)(this.logService,ge,pe)}catch(Se){this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",(0,P.toErrorMessage)(Se))}return{}}stopTracingEventually(ge,pe){this.logService.info("Tracing: waiting for windows to get ready...");const Se=ge.get(H.IDialogMainService);let we=!1;const Me=async De=>{if(we)return;we=!0;const Fe=await v.contentTracing.stopRecording((0,E.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);De?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Fe}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,l.localize)(4,null),detail:(0,l.localize)(5,null,Fe),buttons:[(0,S.mnemonicButtonLabel)((0,l.localize)(6,null))],defaultId:0,noLink:!0},(0,y.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Me(!0),3e4);Promise.all(pe.map(De=>De.ready())).then(()=>{clearTimeout(Le),Me(!1)})}};dt=he([ee(2,K.IInstantiationService),ee(3,Q.ILogService),ee(4,le.IEnvironmentMainService),ee(5,J.ILifecycleMainService),ee(6,k.IConfigurationService),ee(7,Ee.IStateMainService),ee(8,C.IFileService),ee(9,re.IProductService)],dt),e.CodeApplication=dt}),define(Z[248],x([0,1,13,29,31,9,45,16,33,42,34,10,8,63,3,32,25,20,35,58,242,11,19,191,202,24,56,164,18,181,96,74,174,76,22,94,6,185,95,50,21,57,188,97,226,52,228,77,199,38,230,65,66,208]),function(j,e,v,L,D,M,P,b,h,d,i,S,m,p,t,g,E,y,I,c,o,u,n,a,s,r,l,f,w,k,R,A,F,H,te,se,le,Y,T,B,V,_,U,C,X,W,z,K,O,q,N,$,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Q{main(){try{this.startup()}catch(ie){console.error(ie.message),v.app.exit(1)}}async startup(){(0,b.setUnexpectedErrorHandler)(Ie=>console.error(Ie));const[ie,re,ce,fe,de,Ee,Pe]=this.createServices();try{try{await this.initServices(ce,fe,de)}catch(Ie){throw this.handleStartupDataDirError(ce,Pe.nameLong,Ie),Ie}await ie.invokeFunction(async Ie=>{const ve=Ie.get(le.ILogService),ye=Ie.get(te.ILifecycleMainService),ke=Ie.get(w.IFileService),We=await this.claimInstance(ve,ce,ye,ie,Pe,!0);return y.Promises.writeFile(ce.mainLockfile,String(process.pid)).catch(Ae=>{ve.warn(`Error writing main lockfile: ${Ae.stack}`)}),Ee.logger=new T.SpdLogLogger("main",(0,m.join)(ce.logsPath,"main.log"),!0,Ee.getLevel()),(0,d.once)(ye.onWillShutdown)(Ae=>{ke.dispose(),fe.dispose(),Ae.join(y.Promises.unlink(ce.mainLockfile).catch(()=>{}))}),ie.createInstance(o.CodeApplication,We,re).startup()})}catch(Ie){ie.invokeFunction(this.quit,Ie)}}createServices(){const ie=new H.ServiceCollection,re={_serviceBrand:void 0,...B.default};ie.set(V.IProductService,re);const ce=new r.EnvironmentMainService(this.resolveArgs(),re),fe=this.patchEnvironment(ce);ie.set(r.IEnvironmentMainService,ce);const de=new se.BufferLogService,Ee=new le.MultiplexLogService([new le.ConsoleMainLogger((0,le.getLogLevel)(ce)),de]);process.once("exit",()=>Ee.dispose()),ie.set(le.ILogService,Ee);const Pe=new k.FileService(Ee);ie.set(w.IFileService,Pe);const Ie=new R.DiskFileSystemProvider(Ee);Pe.registerProvider(S.Schemas.file,Ie),ie.set(le.ILoggerService,new Y.LoggerService(Ee,Pe));const ve=new a.ConfigurationService(ce.settingsResource,Pe);ie.set(n.IConfigurationService,ve),ie.set(te.ILifecycleMainService,new A.SyncDescriptor(te.LifecycleMainService));const ye=new N.StateMainService(ce,Ee,Pe);return ie.set(q.IStateMainService,ye),ie.set(W.IRequestService,new A.SyncDescriptor(z.RequestMainService)),ie.set(J.IThemeMainService,new A.SyncDescriptor(J.ThemeMainService)),ie.set(K.ISignService,new A.SyncDescriptor(O.SignService)),ie.set(C.ITunnelService,new A.SyncDescriptor(X.TunnelService)),ie.set(_.IProtocolMainService,new A.SyncDescriptor(U.ProtocolMainService)),[new F.InstantiationService(ie,!0),fe,ce,ve,ye,de,re]}patchEnvironment(ie){const re={VSCODE_IPC_HOOK:ie.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ce=>{const fe=process.env[ce];typeof fe=="string"&&(re[ce]=fe)}),Object.assign(process.env,re),re}initServices(ie,re,ce){return M.Promises.settled([Promise.all([ie.extensionsPath,ie.codeCachePath,ie.logsPath,ie.globalStorageHome.fsPath,ie.workspaceStorageHome.fsPath,ie.backupHome].map(fe=>fe?y.Promises.mkdir(fe,{recursive:!0}):void 0)),re.initialize(),ce.init()])}async claimInstance(ie,re,ce,fe,de,Ee){let Pe;try{(0,p.mark)("code/willStartMainServer"),Pe=await(0,c.serve)(re.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,d.once)(ce.onWillShutdown)(()=>Pe.dispose())}catch(Ie){if(Ie.code!=="EADDRINUSE")throw this.handleStartupDataDirError(re,de.nameLong,Ie),Ie;let ve;try{ve=await(0,c.connect)(re.mainIPCHandle,"main")}catch(We){if(!Ee||t.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,de.nameShort),(0,u.localize)(1,null),de.nameLong),We;try{(0,L.unlinkSync)(re.mainIPCHandle)}catch(Ae){throw ie.warn("Could not delete obsolete instance handle",Ae),Ae}return this.claimInstance(ie,re,ce,fe,de,!1)}if(re.extensionTestsLocationURI&&!re.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ie.error(We),ve.dispose(),new Error(We)}let ye;!re.args.wait&&!re.args.status&&(ye=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,de.nameShort),(0,u.localize)(3,null),de.nameLong)},1e4));const ke=I.ProxyChannel.toService(ve.getChannel("launch"),{disableMarshalling:!0});if(re.args.status)return fe.invokeFunction(async()=>{const We=new s.DiagnosticsService($.NullTelemetryService,de),Ae=await ke.getMainProcessInfo(),Ve=await ke.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),xe=await We.getDiagnostics(Ae,Ve);throw console.log(xe),new b.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(ke,ie),ie.trace("Sending env to running instance..."),await ke.start(re.args,process.env),ve.dispose(),ye&&clearTimeout(ye),new b.ExpectedError("Sent env to running instance. Terminating...")}if(re.args.status)throw ie.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new b.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Pe}handleStartupDataDirError(ie,re,ce){if(ce.code==="EACCES"||ce.code==="EPERM"){const fe=(0,D.coalesce)([ie.userDataPath,ie.extensionsPath,c.XDG_RUNTIME_DIR]).map(de=>(0,i.getPathLabel)(de,ie));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,P.toErrorMessage)(ce),fe.join(`
`)),re)}}showStartupWarningDialog(ie,re,ce){v.dialog.showMessageBoxSync({title:ce,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,u.localize)(6,null))],message:ie,detail:re,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ie,re){if(t.isWindows){const ce=await ie.getMainProcessId();re.trace("Sending some foreground love to the running instance:",ce);try{(await new Promise((fe,de)=>{j(["windows-foreground-love"],fe,de)})).allowSetForegroundWindow(ce)}catch(fe){re.error(fe)}}}quit(ie,re){const ce=ie.get(le.ILogService),fe=ie.get(te.ILifecycleMainService);let de=0;re&&(re.isExpected?re.message&&ce.trace(re.message):(de=1,re.stack?ce.error(re.stack):ce.error(`Startup error: ${re.toString()}`))),fe.kill(de)}resolveArgs(){const ie=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(ie.wait&&!ie.waitMarkerFilePath){const re=(0,f.createWaitMarkerFile)(ie.verbose);re&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",re),ie.waitMarkerFilePath=re)}return ie}validatePaths(ie){if(ie["open-url"]&&(ie._urls=ie._,ie._=[]),!ie.remote){const re=this.doValidatePaths(ie._,ie.goto);ie._=re}return ie}doValidatePaths(ie,re){const ce=(0,g.cwd)(),fe=ie.map(Pe=>{let Ie=String(Pe),ve;re&&(ve=(0,h.parseLineAndColumnAware)(Ie),Ie=ve.path),Ie&&(Ie=this.preparePath(ce,Ie));const ye=(0,h.sanitizeFilePath)(Ie,ce),ke=(0,m.basename)(ye);return ke&&!(0,h.isValidBasename)(ke)?null:re&&ve?(ve.path=ye,this.toPath(ve)):ye}),de=t.isWindows||t.isMacintosh,Ee=(0,D.distinct)(fe,Pe=>Pe&&de?Pe.toLowerCase():Pe||"");return(0,D.coalesce)(Ee)}preparePath(ie,re){return t.isWindows&&(re=(0,E.rtrim)(re,'"')),re=(0,E.trim)((0,E.trim)(re," "),"	"),t.isWindows&&(re=(0,m.resolve)(ie,re),re=(0,E.rtrim)(re,".")),re}toPath(ie){const re=[ie.path];return typeof ie.line=="number"&&re.push(String(ie.line)),typeof ie.column=="number"&&re.push(String(ie.column)),re.join(":")}}new Q().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4bbec283c36a51cf80f9b77c7a81c140a76a363b/core/vs/code/electron-main/main.js.map
