/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(oe){for(var e=[],d=0,M=oe.length;d<M;d++)e[d]=be[oe[d]];return e};define(be[42],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=d}),define(be[52],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function M(t){const _=[];for(let n in t)d.call(t,n)&&_.push(t[n]);return _}e.values=M;function E(t,_){for(let n in t)if(d.call(t,n)&&_({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=E;function A(t,_){const n=Object.create(null);for(const m of t){const s=_(m);let u=n[s];u||(u=n[s]=[]),u.push(m)}return n}e.groupBy=A;function F(t){const _=Object.create(null);return t&&t.forEach((n,m)=>{_[m]=n}),_}e.fromMap=F;function P(t,_){const n=[],m=[];for(let s of t)_.has(s)||n.push(s);for(let s of _)t.has(s)||m.push(s);return{removed:n,added:m}}e.diffSets=P;function D(t,_){const n=[],m=[];for(let[s,u]of t)_.has(s)||n.push(u);for(let[s,u]of _)t.has(s)||m.push(u);return{removed:n,added:m}}e.diffMaps=D;class T{constructor(){this.map=new Map}add(_,n){let m=this.map.get(_);m||(m=new Set,this.map.set(_,m)),m.add(n)}delete(_,n){const m=this.map.get(_);!m||(m.delete(n),m.size===0&&this.map.delete(_))}forEach(_,n){const m=this.map.get(_);!m||m.forEach(n)}}e.SetMap=T}),define(be[53],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(F){return(P,D,T)=>{let t=null,_=null;if(typeof T.value=="function"?(t="value",_=T.value):typeof T.get=="function"&&(t="get",_=T.get),!_)throw new Error("not supported");T[t]=F(_,D)}}e.createDecorator=d;function M(F,P,D){let T=null,t=null;if(typeof D.value=="function"?(T="value",t=D.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(T="get",t=D.get),!t)throw new Error("not supported");const _=`$memoize$${P}`;D[T]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[_]}}e.memoize=M;function E(F,P,D){return d((T,t)=>{const _=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...m){this[n]||(this[n]=D?D():void 0),clearTimeout(this[_]),P&&(this[n]=P(this[n],...m),m=[this[n]]),this[_]=setTimeout(()=>{T.apply(this,m),this[n]=D?D():void 0},F)}})}e.debounce=E;function A(F,P,D){return d((T,t)=>{const _=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,m=`$throttle$lastRun$${t}`,s=`$throttle$pending$${t}`;return function(...u){if(this[n]||(this[n]=D?D():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[n]=P(this[n],...u)),this[s])return;const p=this[m]+F;p<=Date.now()?(this[m]=Date.now(),T.apply(this,[this[n]]),this[n]=D?D():void 0):(this[s]=!0,this[_]=setTimeout(()=>{this[s]=!1,this[m]=Date.now(),T.apply(this,[this[n]]),this[n]=D?D():void 0},p-Date.now()))}})}e.throttle=A}),define(be[14],Ee([0,1,16]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(j,le=0){return j[j.length-(1+le)]}e.tail=M;function E(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=E;function A(j,le,re=(ve,Fe)=>ve===Fe){if(j===le)return!0;if(!j||!le||j.length!==le.length)return!1;for(let ve=0,Fe=j.length;ve<Fe;ve++)if(!re(j[ve],le[ve]))return!1;return!0}e.equals=A;function F(j,le,re){let ve=0,Fe=j.length-1;for(;ve<=Fe;){const Me=(ve+Fe)/2|0,Oe=re(j[Me],le);if(Oe<0)ve=Me+1;else if(Oe>0)Fe=Me-1;else return Me}return-(ve+1)}e.binarySearch=F;function P(j,le){let re=0,ve=j.length;if(ve===0)return 0;for(;re<ve;){const Fe=Math.floor((re+ve)/2);le(j[Fe])?ve=Fe:re=Fe+1}return re}e.findFirstInSorted=P;function D(j,le,re){if(j=j|0,j>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Fe=[],Me=[],Oe=[];for(let Ke of le){const qe=re(Ke,ve);qe<0?Fe.push(Ke):qe>0?Me.push(Ke):Oe.push(Ke)}return j<Fe.length?D(j,Fe,re):j<Fe.length+Oe.length?Oe[0]:D(j-(Fe.length+Oe.length),Me,re)}e.quickSelect=D;function T(j,le){const re=[];let ve;for(const Fe of j.slice(0).sort(le))!ve||le(ve[0],Fe)!==0?(ve=[Fe],re.push(ve)):ve.push(Fe);return re}e.groupBy=T;function t(j,le,re){const ve=[];function Fe(Ke,qe,Ve){if(qe===0&&Ve.length===0)return;const $=ve[ve.length-1];$&&$.start+$.deleteCount===Ke?($.deleteCount+=qe,$.toInsert.push(...Ve)):ve.push({start:Ke,deleteCount:qe,toInsert:Ve})}let Me=0,Oe=0;for(;;){if(Me===j.length){Fe(Me,0,le.slice(Oe));break}if(Oe===le.length){Fe(Me,j.length-Me,[]);break}const Ke=j[Me],qe=le[Oe],Ve=re(Ke,qe);Ve===0?(Me+=1,Oe+=1):Ve<0?(Fe(Me,1,[]),Me+=1):Ve>0&&(Fe(Me,0,[qe]),Oe+=1)}return ve}e.sortedDiff=t;function _(j,le,re){const ve=t(j,le,re),Fe=[],Me=[];for(const Oe of ve)Fe.push(...j.slice(Oe.start,Oe.start+Oe.deleteCount)),Me.push(...Oe.toInsert);return{removed:Fe,added:Me}}e.delta=_;function n(j,le,re){if(re===0)return[];const ve=j.slice(0,re).sort(le);return s(j,le,ve,re,j.length),ve}e.top=n;function m(j,le,re,ve,Fe){return re===0?Promise.resolve([]):new Promise((Me,Oe)=>{(async()=>{const Ke=j.length,qe=j.slice(0,re).sort(le);for(let Ve=re,$=Math.min(re+ve,Ke);Ve<Ke;Ve=$,$=Math.min($+ve,Ke)){if(Ve>re&&await new Promise(Q=>setTimeout(Q)),Fe&&Fe.isCancellationRequested)throw(0,d.canceled)();s(j,le,qe,Ve,$)}return qe})().then(Me,Oe)})}e.topAsync=m;function s(j,le,re,ve,Fe){for(const Me=re.length;ve<Fe;ve++){const Oe=j[ve];if(le(Oe,re[Me-1])<0){re.pop();const Ke=P(re,qe=>le(Oe,qe)<0);re.splice(Ke,0,Oe)}}}function u(j){return j.filter(le=>!!le)}e.coalesce=u;function p(j){let le=0;for(let re=0;re<j.length;re++)j[re]&&(j[le]=j[re],le+=1);j.length=le}e.coalesceInPlace=p;function C(j,le,re){j.splice(re,0,j.splice(le,1)[0])}e.move=C;function w(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=w;function o(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=o;function f(j,le=re=>re){const re=new Set;return j.filter(ve=>{const Fe=le(ve);return re.has(Fe)?!1:(re.add(Fe),!0)})}e.distinct=f;function S(j){const le=Object.create(null);return re=>{const ve=j(re);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=S;function i(j,le){const re=g(j,le);if(re!==-1)return j[re]}e.findLast=i;function g(j,le){for(let re=j.length-1;re>=0;re--){const ve=j[re];if(le(ve))return re}return-1}e.lastIndex=g;function a(j,le){return j.length>0?j[0]:le}e.firstOrDefault=a;function r(j,le,re=(ve,Fe)=>ve===Fe){let ve=0;for(let Fe=0,Me=Math.min(j.length,le.length);Fe<Me&&re(j[Fe],le[Fe]);Fe++)ve++;return ve}e.commonPrefixLength=r;function v(j){return[].concat(...j)}e.flatten=v;function l(j,le){let re=typeof le=="number"?j:0;typeof le=="number"?re=j:(re=0,le=j);const ve=[];if(re<=le)for(let Fe=re;Fe<le;Fe++)ve.push(Fe);else for(let Fe=re;Fe>le;Fe--)ve.push(Fe);return ve}e.range=l;function c(j,le,re){return j.reduce((ve,Fe)=>(ve[le(Fe)]=re?re(Fe):Fe,ve),Object.create(null))}e.index=c;function b(j,le){return j.push(le),()=>h(j,le)}e.insert=b;function h(j,le){const re=j.indexOf(le);if(re>-1)return j.splice(re,1),le}e.remove=h;function y(j,le,re){const ve=j.slice(0,le),Fe=j.slice(le);return ve.concat(re,Fe)}e.arrayInsert=y;function R(j,le){let re;if(typeof le=="number"){let ve=le;re=()=>{const Fe=Math.sin(ve++)*179426549;return Fe-Math.floor(Fe)}}else re=Math.random;for(let ve=j.length-1;ve>0;ve-=1){const Fe=Math.floor(re()*(ve+1)),Me=j[ve];j[ve]=j[Fe],j[Fe]=Me}}e.shuffle=R;function k(j,le){const re=j.indexOf(le);re>-1&&(j.splice(re,1),j.unshift(le))}e.pushToStart=k;function O(j,le){const re=j.indexOf(le);re>-1&&(j.splice(re,1),j.push(le))}e.pushToEnd=O;function N(j,le){return Array.isArray(j)?j.map(le):le(j)}e.mapArrayOrNot=N;function I(j){return Array.isArray(j)?j:[j]}e.asArray=I;function B(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=B;function x(j,le){for(const re of j){const ve=le(re);if(ve!==void 0)return ve}}e.mapFind=x;function V(j,le,re){const ve=W(j,le),Fe=j.length,Me=re.length;j.length=Fe+Me;for(let Oe=Fe-1;Oe>=ve;Oe--)j[Oe+Me]=j[Oe];for(let Oe=0;Oe<Me;Oe++)j[Oe+ve]=re[Oe]}e.insertInto=V;function H(j,le,re,ve){const Fe=W(j,le),Me=j.splice(Fe,re);return V(j,Fe,ve),Me}e.splice=H;function W(j,le){return le<0?Math.max(le+j.length,0):Math.min(le,j.length)}function ee(j,le){let re=Number.MAX_SAFE_INTEGER,ve=0;return j.forEach((Fe,Me)=>{const Oe=le(Fe);Oe<re&&(re=Oe,ve=Me)}),ve}e.minIndex=ee;function q(j,le){let re=Number.MIN_SAFE_INTEGER,ve=0;return j.forEach((Fe,Me)=>{const Oe=le(Fe);Oe>re&&(re=Oe,ve=Me)}),ve}e.maxIndex=q;class Y{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let re=this.firstIdx;for(;re<this.items.length&&le(this.items[re]);)re++;const ve=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,ve}takeFromEndWhile(le){let re=this.lastIdx;for(;re>=0&&le(this.items[re]);)re--;const ve=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,ve}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=Y}),define(be[54],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(be[102],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function F(i,g=!1){let a=0,r=i.length,v="",l=0,c=16,b=0;function h(B){let x=0,V=0;for(;x<B;){const H=i.charCodeAt(a);if(H>=48&&H<=57)V=V*16+H-48;else if(H>=65&&H<=70)V=V*16+H-65+10;else if(H>=97&&H<=102)V=V*16+H-97+10;else break;a++,x++}return x<B&&(V=-1),V}function y(B){a=B,v="",l=0,c=16,b=0}function R(){const B=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&T(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&T(i.charCodeAt(a)))for(a++;a<i.length&&T(i.charCodeAt(a));)a++;else return b=3,i.substring(B,a);let x=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&T(i.charCodeAt(a))){for(a++;a<i.length&&T(i.charCodeAt(a));)a++;x=a}else b=3;return i.substring(B,x)}function k(){let B="",x=a;for(;;){if(a>=r){B+=i.substring(x,a),b=2;break}const V=i.charCodeAt(a);if(V===34){B+=i.substring(x,a),a++;break}if(V===92){if(B+=i.substring(x,a),a++,a>=r){b=2;break}switch(i.charCodeAt(a++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const W=h(4);W>=0?B+=String.fromCharCode(W):b=4;break;default:b=5}x=a;continue}if(V>=0&&V<=31)if(D(V)){B+=i.substring(x,a),b=2;break}else b=6;a++}return B}function O(){if(v="",b=0,l=a,a>=r)return l=r,c=17;let B=i.charCodeAt(a);if(P(B)){do a++,v+=String.fromCharCode(B),B=i.charCodeAt(a);while(P(B));return c=15}if(D(B))return a++,v+=String.fromCharCode(B),B===13&&i.charCodeAt(a)===10&&(a++,v+=`
`),c=14;switch(B){case 123:return a++,c=1;case 125:return a++,c=2;case 91:return a++,c=3;case 93:return a++,c=4;case 58:return a++,c=6;case 44:return a++,c=5;case 34:return a++,v=k(),c=10;case 47:const x=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<r&&!D(i.charCodeAt(a));)a++;return v=i.substring(x,a),c=12}if(i.charCodeAt(a+1)===42){a+=2;const V=r-1;let H=!1;for(;a<V;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,H=!0;break}a++}return H||(a++,b=1),v=i.substring(x,a),c=13}return v+=String.fromCharCode(B),a++,c=16;case 45:if(v+=String.fromCharCode(B),a++,a===r||!T(i.charCodeAt(a)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=R(),c=11;default:for(;a<r&&N(B);)a++,B=i.charCodeAt(a);if(l!==a){switch(v=i.substring(l,a),v){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return v+=String.fromCharCode(B),a++,c=16}}function N(B){if(P(B)||D(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function I(){let B;do B=O();while(B>=12&&B<=15);return B}return{setPosition:y,getPosition:()=>a,scan:g?I:O,getToken:()=>c,getTokenValue:()=>v,getTokenOffset:()=>l,getTokenLength:()=>a-l,getTokenError:()=>b}}e.createScanner=F;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function D(i){return i===10||i===13||i===8232||i===8233}function T(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function _(i,g){const a=[],r=new Object;let v;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function b(h,y,R,k){l.value=h,l.offset=y,l.length=R,l.type=k,l.colonOffset=void 0,v=l}try{o(i,{onObjectBegin:(h,y)=>{if(g<=h)throw r;v=void 0,c=g>h,a.push("")},onObjectProperty:(h,y,R)=>{if(g<y||(b(h,y,R,"property"),a[a.length-1]=h,g<=y+R))throw r},onObjectEnd:(h,y)=>{if(g<=h)throw r;v=void 0,a.pop()},onArrayBegin:(h,y)=>{if(g<=h)throw r;v=void 0,a.push(0)},onArrayEnd:(h,y)=>{if(g<=h)throw r;v=void 0,a.pop()},onLiteralValue:(h,y,R)=>{if(g<y||(b(h,y,R,S(h)),g<=y+R))throw r},onSeparator:(h,y,R)=>{if(g<=y)throw r;if(h===":"&&v&&v.type==="property")v.colonOffset=y,c=!1,v=void 0;else if(h===","){const k=a[a.length-1];typeof k=="number"?a[a.length-1]=k+1:(c=!0,a[a.length-1]=""),v=void 0}}})}catch(h){if(h!==r)throw h}return{path:a,previousNode:v,isAtPropertyKey:c,matches:h=>{let y=0;for(let R=0;y<h.length&&R<a.length;R++)if(h[y]===a[R]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}e.getLocation=_;function n(i,g=[],a=A.DEFAULT){let r=null,v=[];const l=[];function c(h){Array.isArray(v)?v.push(h):r!==null&&(v[r]=h)}return o(i,{onObjectBegin:()=>{const h={};c(h),l.push(v),v=h,r=null},onObjectProperty:h=>{r=h},onObjectEnd:()=>{v=l.pop()},onArrayBegin:()=>{const h=[];c(h),l.push(v),v=h,r=null},onArrayEnd:()=>{v=l.pop()},onLiteralValue:c,onError:(h,y,R)=>{g.push({error:h,offset:y,length:R})}},a),v[0]}e.parse=n;function m(i,g=[],a=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(h){r.type==="property"&&(r.length=h-r.offset,r=r.parent)}function l(h){return r.children.push(h),h}o(i,{onObjectBegin:h=>{r=l({type:"object",offset:h,length:-1,parent:r,children:[]})},onObjectProperty:(h,y,R)=>{r=l({type:"property",offset:y,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:h,offset:y,length:R,parent:r})},onObjectEnd:(h,y)=>{r.length=h+y-r.offset,r=r.parent,v(h+y)},onArrayBegin:(h,y)=>{r=l({type:"array",offset:h,length:-1,parent:r,children:[]})},onArrayEnd:(h,y)=>{r.length=h+y-r.offset,r=r.parent,v(h+y)},onLiteralValue:(h,y,R)=>{l({type:S(h),offset:y,length:R,parent:r,value:h}),v(y+R)},onSeparator:(h,y,R)=>{r.type==="property"&&(h===":"?r.colonOffset=y:h===","&&v(y))},onError:(h,y,R)=>{g.push({error:h,offset:y,length:R})}},a);const b=r.children[0];return b&&delete b.parent,b}e.parseTree=m;function s(i,g){if(!i)return;let a=i;for(let r of g)if(typeof r=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let v=!1;for(const l of a.children)if(Array.isArray(l.children)&&l.children[0].value===r){a=l.children[1],v=!0;break}if(!v)return}else{const v=r;if(a.type!=="array"||v<0||!Array.isArray(a.children)||v>=a.children.length)return;a=a.children[v]}return a}e.findNodeAtLocation=s;function u(i){if(!i.parent||!i.parent.children)return[];const g=u(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;g.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&g.push(a)}return g}e.getNodePath=u;function p(i){switch(i.type){case"array":return i.children.map(p);case"object":const g=Object.create(null);for(let a of i.children){const r=a.children[1];r&&(g[a.children[0].value]=p(r))}return g;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=p;function C(i,g,a=!1){return g>=i.offset&&g<i.offset+i.length||a&&g===i.offset+i.length}e.contains=C;function w(i,g,a=!1){if(C(i,g,a)){const r=i.children;if(Array.isArray(r))for(let v=0;v<r.length&&r[v].offset<=g;v++){const l=w(r[v],g,a);if(l)return l}return i}}e.findNodeAtOffset=w;function o(i,g,a=A.DEFAULT){const r=F(i,!1);function v(re){return re?()=>re(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(re){return re?ve=>re(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const c=v(g.onObjectBegin),b=l(g.onObjectProperty),h=v(g.onObjectEnd),y=v(g.onArrayBegin),R=v(g.onArrayEnd),k=l(g.onLiteralValue),O=l(g.onSeparator),N=v(g.onComment),I=l(g.onError),B=a&&a.disallowComments,x=a&&a.allowTrailingComma;function V(){for(;;){const re=r.scan();switch(r.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:B||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(re){case 12:case 13:B?H(10):N();break;case 16:H(1);break;case 15:case 14:break;default:return re}}}function H(re,ve=[],Fe=[]){if(I(re),ve.length+Fe.length>0){let Me=r.getToken();for(;Me!==17;){if(ve.indexOf(Me)!==-1){V();break}else if(Fe.indexOf(Me)!==-1)break;Me=V()}}}function W(re){const ve=r.getTokenValue();return re?k(ve):b(ve),V(),!0}function ee(){switch(r.getToken()){case 11:let re=0;try{re=JSON.parse(r.getTokenValue()),typeof re!="number"&&(H(2),re=0)}catch(ve){H(2)}k(re);break;case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return V(),!0}function q(){return r.getToken()!==10?(H(3,[],[2,5]),!1):(W(!1),r.getToken()===6?(O(":"),V(),le()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){c(),V();let re=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(re||H(4,[],[]),O(","),V(),r.getToken()===2&&x)break}else re&&H(6,[],[]);q()||H(4,[],[2,5]),re=!0}return h(),r.getToken()!==2?H(7,[2],[]):V(),!0}function j(){y(),V();let re=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(re||H(4,[],[]),O(","),V(),r.getToken()===4&&x)break}else re&&H(6,[],[]);le()||H(4,[],[4,5]),re=!0}return R(),r.getToken()!==4?H(8,[4],[]):V(),!0}function le(){switch(r.getToken()){case 3:return j();case 1:return Y();case 10:return W(!0);default:return ee()}}return V(),r.getToken()===17?a.allowEmptyContent?!0:(H(4,[],[]),!1):le()?(r.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=o;function f(i,g){let a=F(i),r=[],v,l=0,c;do switch(c=a.getPosition(),v=a.scan(),v){case 12:case 13:case 17:l!==c&&r.push(i.substring(l,c)),g!==void 0&&r.push(a.getTokenValue().replace(/[^\r\n]/g,g)),l=a.getPosition();break}while(v!==17);return r.join("")}e.stripComments=f;function S(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),define(be[103],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new d(()=>E(this.getValue()))}}e.Lazy=d}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,oe.marked=e())}(this,function(){"use strict";function oe(Pe,Se){for(var Ce=0;Ce<Se.length;Ce++){var ie=Se[Ce];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Pe,ie.key,ie)}}function e(Pe,Se,Ce){return Se&&oe(Pe.prototype,Se),Ce&&oe(Pe,Ce),Pe}function d(Pe,Se){if(!!Pe){if(typeof Pe=="string")return M(Pe,Se);var Ce=Object.prototype.toString.call(Pe).slice(8,-1);if(Ce==="Object"&&Pe.constructor&&(Ce=Pe.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Pe);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Pe,Se)}}function M(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var Ce=0,ie=new Array(Se);Ce<Se;Ce++)ie[Ce]=Pe[Ce];return ie}function E(Pe,Se){var Ce=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Ce)return(Ce=Ce.call(Pe)).next.bind(Ce);if(Array.isArray(Pe)||(Ce=d(Pe))||Se&&Pe&&typeof Pe.length=="number"){Ce&&(Pe=Ce);var ie=0;return function(){return ie>=Pe.length?{done:!0}:{done:!1,value:Pe[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function P(Pe){A.exports.defaults=Pe}A.exports={defaults:F(),getDefaults:F,changeDefaults:P};var D=/[&<>"']/,T=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(Se){return n[Se]};function s(Pe,Se){if(Se){if(D.test(Pe))return Pe.replace(T,m)}else if(t.test(Pe))return Pe.replace(_,m);return Pe}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Pe){return Pe.replace(u,function(Se,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var C=/(^|[^\[])\^/g;function w(Pe,Se){Pe=Pe.source||Pe,Se=Se||"";var Ce={replace:function(ue,me){return me=me.source||me,me=me.replace(C,"$1"),Pe=Pe.replace(ue,me),Ce},getRegex:function(){return new RegExp(Pe,Se)}};return Ce}var o=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(Pe,Se,Ce){if(Pe){var ie;try{ie=decodeURIComponent(p(Ce)).replace(o,"").toLowerCase()}catch(ue){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}Se&&!f.test(Ce)&&(Ce=v(Se,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ue){return null}return Ce}var i={},g=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Pe,Se){i[" "+Pe]||(g.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=h(Pe,"/",!0)),Pe=i[" "+Pe];var Ce=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ce?Se:Pe.replace(a,"$1")+Se:Se.charAt(0)==="/"?Ce?Se:Pe.replace(r,"$1")+Se:Pe+Se}var l={exec:function(){}};function c(Pe){for(var Se=1,Ce,ie;Se<arguments.length;Se++){Ce=arguments[Se];for(ie in Ce)Object.prototype.hasOwnProperty.call(Ce,ie)&&(Pe[ie]=Ce[ie])}return Pe}function b(Pe,Se){var Ce=Pe.replace(/\|/g,function(me,fe,Ie){for(var Be=!1,Ne=fe;--Ne>=0&&Ie[Ne]==="\\";)Be=!Be;return Be?"|":" |"}),ie=Ce.split(/ \|/),ue=0;if(ie[0].trim()||ie.shift(),ie[ie.length-1].trim()||ie.pop(),ie.length>Se)ie.splice(Se);else for(;ie.length<Se;)ie.push("");for(;ue<ie.length;ue++)ie[ue]=ie[ue].trim().replace(/\\\|/g,"|");return ie}function h(Pe,Se,Ce){var ie=Pe.length;if(ie===0)return"";for(var ue=0;ue<ie;){var me=Pe.charAt(ie-ue-1);if(me===Se&&!Ce)ue++;else if(me!==Se&&Ce)ue++;else break}return Pe.substr(0,ie-ue)}function y(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var Ce=Pe.length,ie=0,ue=0;ue<Ce;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===Se[0])ie++;else if(Pe[ue]===Se[1]&&(ie--,ie<0))return ue;return-1}function R(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Pe,Se){if(Se<1)return"";for(var Ce="";Se>1;)Se&1&&(Ce+=Pe),Se>>=1,Pe+=Pe;return Ce+Pe}var O={escape:s,unescape:p,edit:w,cleanUrl:S,resolveUrl:v,noopTest:l,merge:c,splitCells:b,rtrim:h,findClosingBracket:y,checkSanitizeDeprecation:R,repeatString:k},N=A.exports.defaults,I=O.rtrim,B=O.splitCells,x=O.escape,V=O.findClosingBracket;function H(Pe,Se,Ce,ie){var ue=Se.href,me=Se.title?x(Se.title):null,fe=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){ie.state.inLink=!0;var Ie={type:"link",raw:Ce,href:ue,title:me,text:fe,tokens:ie.inlineTokens(fe,[])};return ie.state.inLink=!1,Ie}else return{type:"image",raw:Ce,href:ue,title:me,text:x(fe)}}function W(Pe,Se){var Ce=Pe.match(/^(\s+)(?:```)/);if(Ce===null)return Se;var ie=Ce[1];return Se.split(`
`).map(function(ue){var me=ue.match(/^\s+/);if(me===null)return ue;var fe=me[0];return fe.length>=ie.length?ue.slice(ie.length):ue}).join(`
`)}var ee=function(){function Pe(Ce){this.options=Ce||N}var Se=Pe.prototype;return Se.space=function(ie){var ue=this.rules.block.newline.exec(ie);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},Se.code=function(ie){var ue=this.rules.block.code.exec(ie);if(ue){var me=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?me:I(me,`
`)}}},Se.fences=function(ie){var ue=this.rules.block.fences.exec(ie);if(ue){var me=ue[0],fe=W(me,ue[3]||"");return{type:"code",raw:me,lang:ue[2]?ue[2].trim():ue[2],text:fe}}},Se.heading=function(ie){var ue=this.rules.block.heading.exec(ie);if(ue){var me=ue[2].trim();if(/#$/.test(me)){var fe=I(me,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(me=fe.trim())}var Ie={type:"heading",raw:ue[0],depth:ue[1].length,text:me,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},Se.hr=function(ie){var ue=this.rules.block.hr.exec(ie);if(ue)return{type:"hr",raw:ue[0]}},Se.blockquote=function(ie){var ue=this.rules.block.blockquote.exec(ie);if(ue){var me=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},Se.list=function(ie){var ue=this.rules.block.list.exec(ie);if(ue){var me,fe,Ie,Be,Ne,je,it,Le,de,ge,X=ue[1].trim(),z=X.length>1,we={type:"list",raw:"",ordered:z,start:z?+X.slice(0,-1):"",loose:!1,items:[]};X=z?"\\d{1,9}\\"+X.slice(-1):"\\"+X,this.options.pedantic&&(X=z?X:"[*+-]");for(var ke=new RegExp("^( {0,3}"+X+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ie&&!(this.rules.block.hr.test(ie)||!(ue=ke.exec(ie)));){de=ue[2].split(`
`),this.options.pedantic?(Be=2,ge=de[0].trimLeft()):(Be=ue[2].search(/[^ ]/),Be=ue[1].length+(Be>4?1:Be),ge=de[0].slice(Be-ue[1].length)),je=!1,me=ue[0],!de[0]&&/^ *$/.test(de[1])&&(me=ue[1]+de.slice(0,2).join(`
`)+`
`,we.loose=!0,de=[]);var Je=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Ne=1;Ne<de.length;Ne++){if(Le=de[Ne],this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Je.test(Le)){me=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}if(!je){Le.trim()||(je=!0),Le.search(/[^ ]/)>=Be?ge+=`
`+Le.slice(Be):ge+=`
`+Le;continue}if(Le.search(/[^ ]/)>=Be||!Le.trim()){ge+=`
`+Le.slice(Be);continue}else{me=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}}we.loose||(it?we.loose=!0:/\n *\n *$/.test(me)&&(it=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(ge),fe&&(Ie=fe[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:me,task:!!fe,checked:Ie,loose:!1,text:ge}),we.raw+=me,ie=ie.slice(me.length)}we.items[we.items.length-1].raw=me.trimRight(),we.items[we.items.length-1].text=ge.trimRight(),we.raw=we.raw.trimRight();var xe=we.items.length;for(Ne=0;Ne<xe;Ne++)this.lexer.state.top=!1,we.items[Ne].tokens=this.lexer.blockTokens(we.items[Ne].text,[]),we.items[Ne].tokens.some(function(ct){return ct.type==="space"})&&(we.loose=!0,we.items[Ne].loose=!0);return we}},Se.html=function(ie){var ue=this.rules.block.html.exec(ie);if(ue){var me={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(me.type="paragraph",me.text=this.options.sanitizer?this.options.sanitizer(ue[0]):x(ue[0]),me.tokens=[],this.lexer.inline(me.text,me.tokens)),me}},Se.def=function(ie){var ue=this.rules.block.def.exec(ie);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var me=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ue[0],href:ue[2],title:ue[3]}}},Se.table=function(ie){var ue=this.rules.block.table.exec(ie);if(ue){var me={type:"table",header:B(ue[1]).map(function(it){return{text:it}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ue[0];var fe=me.align.length,Ie,Be,Ne,je;for(Ie=0;Ie<fe;Ie++)/^ *-+: *$/.test(me.align[Ie])?me.align[Ie]="right":/^ *:-+: *$/.test(me.align[Ie])?me.align[Ie]="center":/^ *:-+ *$/.test(me.align[Ie])?me.align[Ie]="left":me.align[Ie]=null;for(fe=me.rows.length,Ie=0;Ie<fe;Ie++)me.rows[Ie]=B(me.rows[Ie],me.header.length).map(function(it){return{text:it}});for(fe=me.header.length,Be=0;Be<fe;Be++)me.header[Be].tokens=[],this.lexer.inlineTokens(me.header[Be].text,me.header[Be].tokens);for(fe=me.rows.length,Be=0;Be<fe;Be++)for(je=me.rows[Be],Ne=0;Ne<je.length;Ne++)je[Ne].tokens=[],this.lexer.inlineTokens(je[Ne].text,je[Ne].tokens);return me}}},Se.lheading=function(ie){var ue=this.rules.block.lheading.exec(ie);if(ue){var me={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.paragraph=function(ie){var ue=this.rules.block.paragraph.exec(ie);if(ue){var me={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.text=function(ie){var ue=this.rules.block.text.exec(ie);if(ue){var me={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.escape=function(ie){var ue=this.rules.inline.escape.exec(ie);if(ue)return{type:"escape",raw:ue[0],text:x(ue[1])}},Se.tag=function(ie){var ue=this.rules.inline.tag.exec(ie);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):x(ue[0]):ue[0]}},Se.link=function(ie){var ue=this.rules.inline.link.exec(ie);if(ue){var me=ue[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var fe=I(me.slice(0,-1),"\\");if((me.length-fe.length)%2==0)return}else{var Ie=V(ue[2],"()");if(Ie>-1){var Be=ue[0].indexOf("!")===0?5:4,Ne=Be+ue[1].length+Ie;ue[2]=ue[2].substring(0,Ie),ue[0]=ue[0].substring(0,Ne).trim(),ue[3]=""}}var je=ue[2],it="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);Le&&(je=Le[1],it=Le[3])}else it=ue[3]?ue[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(me)?je=je.slice(1):je=je.slice(1,-1)),H(ue,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Se.reflink=function(ie,ue){var me;if((me=this.rules.inline.reflink.exec(ie))||(me=this.rules.inline.nolink.exec(ie))){var fe=(me[2]||me[1]).replace(/\s+/g," ");if(fe=ue[fe.toLowerCase()],!fe||!fe.href){var Ie=me[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return H(me,fe,me[0],this.lexer)}},Se.emStrong=function(ie,ue,me){me===void 0&&(me="");var fe=this.rules.inline.emStrong.lDelim.exec(ie);if(!!fe&&!(fe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=fe[1]||fe[2]||"";if(!Ie||Ie&&(me===""||this.rules.inline.punctuation.exec(me))){var Be=fe[0].length-1,Ne,je,it=Be,Le=0,de=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,ue=ue.slice(-1*ie.length+Be);(fe=de.exec(ue))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(je=Ne.length,fe[3]||fe[4]){it+=je;continue}else if((fe[5]||fe[6])&&Be%3&&!((Be+je)%3)){Le+=je;continue}if(it-=je,!(it>0)){if(je=Math.min(je,je+it+Le),Math.min(Be,je)%2){var ge=ie.slice(1,Be+fe.index+je);return{type:"em",raw:ie.slice(0,Be+fe.index+je+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var X=ie.slice(2,Be+fe.index+je-1);return{type:"strong",raw:ie.slice(0,Be+fe.index+je+1),text:X,tokens:this.lexer.inlineTokens(X,[])}}}}}},Se.codespan=function(ie){var ue=this.rules.inline.code.exec(ie);if(ue){var me=ue[2].replace(/\n/g," "),fe=/[^ ]/.test(me),Ie=/^ /.test(me)&&/ $/.test(me);return fe&&Ie&&(me=me.substring(1,me.length-1)),me=x(me,!0),{type:"codespan",raw:ue[0],text:me}}},Se.br=function(ie){var ue=this.rules.inline.br.exec(ie);if(ue)return{type:"br",raw:ue[0]}},Se.del=function(ie){var ue=this.rules.inline.del.exec(ie);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Se.autolink=function(ie,ue){var me=this.rules.inline.autolink.exec(ie);if(me){var fe,Ie;return me[2]==="@"?(fe=x(this.options.mangle?ue(me[1]):me[1]),Ie="mailto:"+fe):(fe=x(me[1]),Ie=fe),{type:"link",raw:me[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},Se.url=function(ie,ue){var me;if(me=this.rules.inline.url.exec(ie)){var fe,Ie;if(me[2]==="@")fe=x(this.options.mangle?ue(me[0]):me[0]),Ie="mailto:"+fe;else{var Be;do Be=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(Be!==me[0]);fe=x(me[0]),me[1]==="www."?Ie="http://"+fe:Ie=fe}return{type:"link",raw:me[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},Se.inlineText=function(ie,ue){var me=this.rules.inline.text.exec(ie);if(me){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):x(me[0]):me[0]:fe=x(this.options.smartypants?ue(me[0]):me[0]),{type:"text",raw:me[0],text:fe}}},Pe}(),q=O.noopTest,Y=O.edit,j=O.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=Y(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=Y(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=Y(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=Y(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=Y(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=Y(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=j({},le),le.gfm=j({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=Y(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=j({},le.normal,{html:Y(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:q,paragraph:Y(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=Y(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=Y(le._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=Y(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=Y(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=Y(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=Y(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=Y(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=Y(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=Y(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=Y(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=j({},re),re.pedantic=j({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Y(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:Y(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=j({},re.normal,{escape:Y(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=Y(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=j({},re.gfm,{br:Y(re.br).replace("{2,}","*").getRegex(),text:Y(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:re},Fe=ee,Me=A.exports.defaults,Oe=ve.block,Ke=ve.inline,qe=O.repeatString;function Ve(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(Pe){var Se="",Ce,ie,ue=Pe.length;for(Ce=0;Ce<ue;Ce++)ie=Pe.charCodeAt(Ce),Math.random()>.5&&(ie="x"+ie.toString(16)),Se+="&#"+ie+";";return Se}var Q=function(){function Pe(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Me,this.options.tokenizer=this.options.tokenizer||new Fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ie={block:Oe.normal,inline:Ke.normal};this.options.pedantic?(ie.block=Oe.pedantic,ie.inline=Ke.pedantic):this.options.gfm&&(ie.block=Oe.gfm,this.options.breaks?ie.inline=Ke.breaks:ie.inline=Ke.gfm),this.tokenizer.rules=ie}Pe.lex=function(ie,ue){var me=new Pe(ue);return me.lex(ie)},Pe.lexInline=function(ie,ue){var me=new Pe(ue);return me.inlineTokens(ie)};var Se=Pe.prototype;return Se.lex=function(ie){ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Se.blockTokens=function(ie,ue){var me=this;ue===void 0&&(ue=[]),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var fe,Ie,Be,Ne;ie;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(fe=it.call({lexer:me},ie,ue))?(ie=ie.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.space(ie)){ie=ie.substring(fe.raw.length),fe.type&&ue.push(fe);continue}if(fe=this.tokenizer.code(ie)){ie=ie.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(fe=this.tokenizer.fences(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.heading(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.hr(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.blockquote(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.list(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.html(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.def(ie)){ie=ie.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.lheading(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(Be=ie,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,Le=ie.slice(1),de=void 0;me.options.extensions.startBlock.forEach(function(ge){de=ge.call({lexer:this},Le),typeof de=="number"&&de>=0&&(it=Math.min(it,de))}),it<Infinity&&it>=0&&(Be=ie.substring(0,it+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(Be))){Ie=ue[ue.length-1],Ne&&Ie.type==="paragraph"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe),Ne=Be.length!==ie.length,ie=ie.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(ie)){ie=ie.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(ie){var je="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,ue},Se.inline=function(ie,ue){this.inlineQueue.push({src:ie,tokens:ue})},Se.inlineTokens=function(ie,ue){var me=this;ue===void 0&&(ue=[]);var fe,Ie,Be,Ne=ie,je,it,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)de.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,je.index)+"["+qe("a",je[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,je.index)+"["+qe("a",je[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,je.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;)if(it||(Le=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(fe=X.call({lexer:me},ie,ue))?(ie=ie.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.tag(ie)){ie=ie.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.link(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.emStrong(ie,Ne,Le)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.codespan(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.br(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.del(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.autolink(ie,$)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(ie,$))){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(Be=ie,this.options.extensions&&this.options.extensions.startInline&&function(){var X=Infinity,z=ie.slice(1),we=void 0;me.options.extensions.startInline.forEach(function(ke){we=ke.call({lexer:this},z),typeof we=="number"&&we>=0&&(X=Math.min(X,we))}),X<Infinity&&X>=0&&(Be=ie.substring(0,X+1))}(),fe=this.tokenizer.inlineText(Be,Ve)){ie=ie.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(Le=fe.raw.slice(-1)),it=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(ie){var ge="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ue},e(Pe,null,[{key:"rules",get:function(){return{block:Oe,inline:Ke}}}]),Pe}(),te=A.exports.defaults,ae=O.cleanUrl,K=O.escape,se=function(){function Pe(Ce){this.options=Ce||te}var Se=Pe.prototype;return Se.code=function(ie,ue,me){var fe=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(ie,fe);Ie!=null&&Ie!==ie&&(me=!0,ie=Ie)}return ie=ie.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+K(fe,!0)+'">'+(me?ie:K(ie,!0))+`</code></pre>
`:"<pre><code>"+(me?ie:K(ie,!0))+`</code></pre>
`},Se.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},Se.html=function(ie){return ie},Se.heading=function(ie,ue,me,fe){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+fe.slug(me)+'">'+ie+"</h"+ue+`>
`:"<h"+ue+">"+ie+"</h"+ue+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ie,ue,me){var fe=ue?"ol":"ul",Ie=ue&&me!==1?' start="'+me+'"':"";return"<"+fe+Ie+`>
`+ie+"</"+fe+`>
`},Se.listitem=function(ie){return"<li>"+ie+`</li>
`},Se.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ie){return"<p>"+ie+`</p>
`},Se.table=function(ie,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+ue+`</table>
`},Se.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},Se.tablecell=function(ie,ue){var me=ue.header?"th":"td",fe=ue.align?"<"+me+' align="'+ue.align+'">':"<"+me+">";return fe+ie+"</"+me+`>
`},Se.strong=function(ie){return"<strong>"+ie+"</strong>"},Se.em=function(ie){return"<em>"+ie+"</em>"},Se.codespan=function(ie){return"<code>"+ie+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ie){return"<del>"+ie+"</del>"},Se.link=function(ie,ue,me){if(ie=ae(this.options.sanitize,this.options.baseUrl,ie),ie===null)return me;var fe='<a href="'+K(ie)+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=">"+me+"</a>",fe},Se.image=function(ie,ue,me){if(ie=ae(this.options.sanitize,this.options.baseUrl,ie),ie===null)return me;var fe='<img src="'+ie+'" alt="'+me+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=this.options.xhtml?"/>":">",fe},Se.text=function(ie){return ie},Pe}(),he=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(ie){return ie},Se.em=function(ie){return ie},Se.codespan=function(ie){return ie},Se.del=function(ie){return ie},Se.html=function(ie){return ie},Se.text=function(ie){return ie},Se.link=function(ie,ue,me){return""+me},Se.image=function(ie,ue,me){return""+me},Se.br=function(){return""},Pe}(),Ae=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ie,ue){var me=ie,fe=0;if(this.seen.hasOwnProperty(me)){fe=this.seen[ie];do fe++,me=ie+"-"+fe;while(this.seen.hasOwnProperty(me))}return ue||(this.seen[ie]=fe,this.seen[me]=0),me},Se.slug=function(ie,ue){ue===void 0&&(ue={});var me=this.serialize(ie);return this.getNextSafeSlug(me,ue.dryrun)},Pe}(),Ue=se,He=he,Qe=Ae,et=A.exports.defaults,st=O.unescape,ye=function(){function Pe(Ce){this.options=Ce||et,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Qe}Pe.parse=function(ie,ue){var me=new Pe(ue);return me.parse(ie)},Pe.parseInline=function(ie,ue){var me=new Pe(ue);return me.parseInline(ie)};var Se=Pe.prototype;return Se.parse=function(ie,ue){ue===void 0&&(ue=!0);var me="",fe,Ie,Be,Ne,je,it,Le,de,ge,X,z,we,ke,Je,xe,ct,pt,dt,ht,ft=ie.length;for(fe=0;fe<ft;fe++){if(X=ie[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(ht=this.options.extensions.renderers[X.type].call({parser:this},X),ht!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){me+=ht||"";continue}switch(X.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(X.tokens),X.depth,st(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(de="",Le="",Ne=X.header.length,Ie=0;Ie<Ne;Ie++)Le+=this.renderer.tablecell(this.parseInline(X.header[Ie].tokens),{header:!0,align:X.align[Ie]});for(de+=this.renderer.tablerow(Le),ge="",Ne=X.rows.length,Ie=0;Ie<Ne;Ie++){for(it=X.rows[Ie],Le="",je=it.length,Be=0;Be<je;Be++)Le+=this.renderer.tablecell(this.parseInline(it[Be].tokens),{header:!1,align:X.align[Be]});ge+=this.renderer.tablerow(Le)}me+=this.renderer.table(de,ge);continue}case"blockquote":{ge=this.parse(X.tokens),me+=this.renderer.blockquote(ge);continue}case"list":{for(z=X.ordered,we=X.start,ke=X.loose,Ne=X.items.length,ge="",Ie=0;Ie<Ne;Ie++)xe=X.items[Ie],ct=xe.checked,pt=xe.task,Je="",xe.task&&(dt=this.renderer.checkbox(ct),ke?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=dt+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=dt+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:dt}):Je+=dt),Je+=this.parse(xe.tokens,ke),ge+=this.renderer.listitem(Je,pt,ct);me+=this.renderer.list(ge,z,we);continue}case"html":{me+=this.renderer.html(X.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(ge=X.tokens?this.parseInline(X.tokens):X.text;fe+1<ft&&ie[fe+1].type==="text";)X=ie[++fe],ge+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);me+=ue?this.renderer.paragraph(ge):ge;continue}default:{var _t='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(_t);return}else throw new Error(_t)}}}return me},Se.parseInline=function(ie,ue){ue=ue||this.renderer;var me="",fe,Ie,Be,Ne=ie.length;for(fe=0;fe<Ne;fe++){if(Ie=ie[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){me+=Be||"";continue}switch(Ie.type){case"escape":{me+=ue.text(Ie.text);break}case"html":{me+=ue.html(Ie.text);break}case"link":{me+=ue.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ue));break}case"image":{me+=ue.image(Ie.href,Ie.title,Ie.text);break}case"strong":{me+=ue.strong(this.parseInline(Ie.tokens,ue));break}case"em":{me+=ue.em(this.parseInline(Ie.tokens,ue));break}case"codespan":{me+=ue.codespan(Ie.text);break}case"br":{me+=ue.br();break}case"del":{me+=ue.del(this.parseInline(Ie.tokens,ue));break}case"text":{me+=ue.text(Ie.text);break}default:{var je='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return me},Pe}(),nt=Q,G=ye,Z=ee,pe=se,We=he,Ye=Ae,rt=O.merge,mt=O.checkSanitizeDeprecation,ut=O.escape,St=A.exports.getDefaults,Tt=A.exports.changeDefaults,It=A.exports.defaults;function Xe(Pe,Se,Ce){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(Ce=Se,Se=null),Se=rt({},Xe.defaults,Se||{}),mt(Se),Ce){var ie=Se.highlight,ue;try{ue=nt.lex(Pe,Se)}catch(Be){return Ce(Be)}var me=function(Ne){var je;if(!Ne)try{Se.walkTokens&&Xe.walkTokens(ue,Se.walkTokens),je=G.parse(ue,Se)}catch(it){Ne=it}return Se.highlight=ie,Ne?Ce(Ne):Ce(null,je)};if(!ie||ie.length<3||(delete Se.highlight,!ue.length))return me();var fe=0;Xe.walkTokens(ue,function(Be){Be.type==="code"&&(fe++,setTimeout(function(){ie(Be.text,Be.lang,function(Ne,je){if(Ne)return me(Ne);je!=null&&je!==Be.text&&(Be.text=je,Be.escaped=!0),fe--,fe===0&&me()})},0))}),fe===0&&me();return}try{var Ie=nt.lex(Pe,Se);return Se.walkTokens&&Xe.walkTokens(Ie,Se.walkTokens),G.parse(Ie,Se)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ut(Be.message+"",!0)+"</pre>";throw Be}}Xe.options=Xe.setOptions=function(Pe){return rt(Xe.defaults,Pe),Tt(Xe.defaults),Xe},Xe.getDefaults=St,Xe.defaults=It,Xe.use=function(){for(var Pe=this,Se=arguments.length,Ce=new Array(Se),ie=0;ie<Se;ie++)Ce[ie]=arguments[ie];var ue=rt.apply(void 0,[{}].concat(Ce)),me=Xe.defaults.extensions||{renderers:{},childTokens:{}},fe;Ce.forEach(function(Ie){if(Ie.extensions&&(fe=!0,Ie.extensions.forEach(function(Ne){if(!Ne.name)throw new Error("extension name required");if(Ne.renderer){var je=me.renderers?me.renderers[Ne.name]:null;je?me.renderers[Ne.name]=function(){for(var it=arguments.length,Le=new Array(it),de=0;de<it;de++)Le[de]=arguments[de];var ge=Ne.renderer.apply(this,Le);return ge===!1&&(ge=je.apply(this,Le)),ge}:me.renderers[Ne.name]=Ne.renderer}if(Ne.tokenizer){if(!Ne.level||Ne.level!=="block"&&Ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");me[Ne.level]?me[Ne.level].unshift(Ne.tokenizer):me[Ne.level]=[Ne.tokenizer],Ne.start&&(Ne.level==="block"?me.startBlock?me.startBlock.push(Ne.start):me.startBlock=[Ne.start]:Ne.level==="inline"&&(me.startInline?me.startInline.push(Ne.start):me.startInline=[Ne.start]))}Ne.childTokens&&(me.childTokens[Ne.name]=Ne.childTokens)})),Ie.renderer&&function(){var Ne=Xe.defaults.renderer||new pe,je=function(de){var ge=Ne[de];Ne[de]=function(){for(var X=arguments.length,z=new Array(X),we=0;we<X;we++)z[we]=arguments[we];var ke=Ie.renderer[de].apply(Ne,z);return ke===!1&&(ke=ge.apply(Ne,z)),ke}};for(var it in Ie.renderer)je(it);ue.renderer=Ne}(),Ie.tokenizer&&function(){var Ne=Xe.defaults.tokenizer||new Z,je=function(de){var ge=Ne[de];Ne[de]=function(){for(var X=arguments.length,z=new Array(X),we=0;we<X;we++)z[we]=arguments[we];var ke=Ie.tokenizer[de].apply(Ne,z);return ke===!1&&(ke=ge.apply(Ne,z)),ke}};for(var it in Ie.tokenizer)je(it);ue.tokenizer=Ne}(),Ie.walkTokens){var Be=Xe.defaults.walkTokens;ue.walkTokens=function(Ne){Ie.walkTokens.call(Pe,Ne),Be&&Be(Ne)}}fe&&(ue.extensions=me),Xe.setOptions(ue)})},Xe.walkTokens=function(Pe,Se){for(var Ce=function(){var fe=ue.value;switch(Se(fe),fe.type){case"table":{for(var Ie=E(fe.header),Be;!(Be=Ie()).done;){var Ne=Be.value;Xe.walkTokens(Ne.tokens,Se)}for(var je=E(fe.rows),it;!(it=je()).done;)for(var Le=it.value,de=E(Le),ge;!(ge=de()).done;){var X=ge.value;Xe.walkTokens(X.tokens,Se)}break}case"list":{Xe.walkTokens(fe.items,Se);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[fe.type]?Xe.defaults.extensions.childTokens[fe.type].forEach(function(z){Xe.walkTokens(fe[z],Se)}):fe.tokens&&Xe.walkTokens(fe.tokens,Se)}},ie=E(Pe),ue;!(ue=ie()).done;)Ce()},Xe.parseInline=function(Pe,Se){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=rt({},Xe.defaults,Se||{}),mt(Se);try{var Ce=nt.lexInline(Pe,Se);return Se.walkTokens&&Xe.walkTokens(Ce,Se.walkTokens),G.parseInline(Ce,Se)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ut(ie.message+"",!0)+"</pre>";throw ie}},Xe.Parser=G,Xe.parser=G.parse,Xe.Renderer=pe,Xe.TextRenderer=We,Xe.Lexer=nt,Xe.lexer=nt.lex,Xe.Tokenizer=Z,Xe.Slugger=Ye,Xe.parse=Xe;var vt=Xe;return vt}),define(be[76],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(F,P,D){return Math.min(Math.max(F,P),D)}e.clamp=d;function M(F,P){return(P+F%P)%P}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function oe(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function F(D){A.push(D,Date.now())}function P(){const D=[];for(let T=0;T<A.length;T+=2)D.push({name:A[T],startTime:A[T+1]});return D}return{mark:F,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const F of performance.getEntriesByType("mark"))A.push({name:F.name,startTime:Math.round(E+F.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function d(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=d(M))}(),define(be[34],Ee([0,1,3]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(_){const n=this._icons.get(_.id);n?_.description?n.description=_.description:console.error(`Duplicate registration of codicon ${_.id}`):(this._icons.set(_.id,_),this._onDidRegister.fire(_))}get(_){return this._icons.get(_)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function A(t,_){return new P(t,_)}e.registerCodicon=A;function F(t){return t?t.replace(/\$\((.*?)\)/g,(_,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class P{constructor(_,n,m){this.id=_,this.definition=n,this.description=m,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function D(t,_){const n=["codicon","codicon-"+t];return _&&n.push("codicon-modifier-"+_),n}e.getClassNamesArray=D;var T;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const _=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(u){if(u instanceof P)return["codicon","codicon-"+u.id];const p=_.exec(u.id);if(!p)return n(P.error);let[,C,w]=p;const o=["codicon","codicon-"+C];return w&&o.push("codicon-modifier-"+w.substr(1)),o}t.asClassNameArray=n;function m(u){return n(u).join(" ")}t.asClassName=m;function s(u){return"."+n(u).join(".")}t.asCSSSelector=s})(T=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"})}(P=e.Codicon||(e.Codicon={}))}),define(be[104],Ee([0,1,16,6]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(o){const f=o;return f?[f.on,f.pause,f.resume,f.destroy].every(S=>typeof S=="function"):!1}e.isReadableStream=E;function A(o){const f=o;return f?E(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=A;function F(o,f){return new P(o,f)}e.newWriteableStream=F;class P{constructor(f,S){this.reducer=f,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(S=>S(f))}emitError(f){this.listeners.error.length===0?(0,d.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(S=>S(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,S){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(f,S){if(this.state.destroyed)return;let i;switch(f){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const g=i.indexOf(S);g>=0&&i.splice(g,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(o,f){const S=[];let i;for(;(i=o.read())!==null;)S.push(i);return f(S)}e.consumeReadable=D;function T(o,f,S){const i=[];let g;for(;(g=o.read())!==null&&i.length<S;)i.push(g);return g===null&&i.length>0?f(i):{read:()=>{if(i.length>0)return i.shift();if(typeof g!="undefined"){const a=g;return g=void 0,a}return o.read()}}}e.peekReadable=T;function t(o,f){return new Promise((S,i)=>{const g=[];_(o,{onData:a=>{f&&g.push(a)},onError:a=>{f?i(a):S(void 0)},onEnd:()=>{S(f?f(g):void 0)}})})}e.consumeStream=t;function _(o,f){o.on("error",S=>f.onError(S)),o.on("end",()=>f.onEnd()),o.on("data",S=>f.onData(S))}e.listenStream=_;function n(o,f){return new Promise((S,i)=>{const g=new M.DisposableStore,a=[],r=c=>{if(a.push(c),a.length>f)return g.dispose(),o.pause(),S({stream:o,buffer:a,ended:!1})},v=c=>i(c),l=()=>S({stream:o,buffer:a,ended:!0});g.add((0,M.toDisposable)(()=>o.removeListener("error",v))),o.on("error",v),g.add((0,M.toDisposable)(()=>o.removeListener("end",l))),o.on("end",l),g.add((0,M.toDisposable)(()=>o.removeListener("data",r))),o.on("data",r)})}e.peekStream=n;function m(o,f){const S=F(f);return S.end(o),S}e.toStream=m;function s(){const o=F(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=s;function u(o){let f=!1;return{read:()=>f?null:(f=!0,o)}}e.toReadable=u;function p(o,f,S){const i=F(S);return _(o,{onData:g=>i.write(f.data(g)),onError:g=>i.error(f.error?f.error(g):g),onEnd:()=>i.end()}),i}e.transform=p;function C(o,f,S){let i=!1;return{read:()=>{const g=f.read();return i?g:(i=!0,g!==null?S([o,g]):o)}}}e.prefixedReadable=C;function w(o,f,S){let i=!1;const g=F(S);return _(f,{onData:a=>i?g.write(a):(i=!0,g.write(S([o,a]))),onError:a=>g.error(a),onEnd:()=>{i||(i=!0,g.write(o)),g.end()}}),g}e.prefixedStream=w}),define(be[22],Ee([0,1,104]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,A;class F{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return M?new F(Buffer.allocUnsafe(r)):new F(new Uint8Array(r))}static wrap(r){return M&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new F(r)}static fromString(r,v){return!(v?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(r)):(E||(E=new TextEncoder),new F(E.encode(r)))}static concat(r,v){if(typeof v=="undefined"){v=0;for(let b=0,h=r.length;b<h;b++)v+=r[b].byteLength}const l=F.alloc(v);let c=0;for(let b=0,h=r.length;b<h;b++){const y=r[b];l.set(y,c),c+=y.byteLength}return l}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,v){return new F(this.buffer.subarray(r,v))}set(r,v){r instanceof F?this.buffer.set(r.buffer,v):this.buffer.set(r,v)}readUInt32BE(r){return T(this.buffer,r)}writeUInt32BE(r,v){t(this.buffer,r,v)}readUInt32LE(r){return _(this.buffer,r)}writeUInt32LE(r,v){n(this.buffer,r,v)}readUInt8(r){return m(this.buffer,r)}writeUInt8(r,v){s(this.buffer,r,v)}}e.VSBuffer=F;function P(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0}e.readUInt16LE=P;function D(a,r,v){a[v+0]=r&255,r=r>>>8,a[v+1]=r&255}e.writeUInt16LE=D;function T(a,r){return a[r]*2**24+a[r+1]*2**16+a[r+2]*2**8+a[r+3]}e.readUInt32BE=T;function t(a,r,v){a[v+3]=r,r=r>>>8,a[v+2]=r,r=r>>>8,a[v+1]=r,r=r>>>8,a[v]=r}e.writeUInt32BE=t;function _(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0|a[r+2]<<16>>>0|a[r+3]<<24>>>0}e.readUInt32LE=_;function n(a,r,v){a[v+0]=r&255,r=r>>>8,a[v+1]=r&255,r=r>>>8,a[v+2]=r&255,r=r>>>8,a[v+3]=r&255}e.writeUInt32LE=n;function m(a,r){return a[r]}e.readUInt8=m;function s(a,r,v){a[v]=r}e.writeUInt8=s;function u(a){return d.consumeReadable(a,r=>F.concat(r))}e.readableToBuffer=u;function p(a){return d.toReadable(a)}e.bufferToReadable=p;function C(a){return d.consumeStream(a,r=>F.concat(r))}e.streamToBuffer=C;async function w(a){return a.ended?F.concat(a.buffer):F.concat([...a.buffer,await C(a.stream)])}e.bufferedStreamToBuffer=w;function o(a){return d.toStream(a,r=>F.concat(r))}e.bufferToStream=o;function f(a){return d.transform(a,{data:r=>typeof r=="string"?F.fromString(r):F.wrap(r)},r=>F.concat(r))}e.streamToBufferReadableStream=f;function S(a){return d.newWriteableStream(r=>F.concat(r),a)}e.newWriteableBufferStream=S;function i(a,r){return d.prefixedReadable(a,r,v=>F.concat(v))}e.prefixedBufferReadable=i;function g(a,r){return d.prefixedStream(a,r,v=>F.concat(v))}e.prefixedBufferStream=g});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[20],Ee([0,1,14,9]),function(oe,e,d,M){"use strict";var E,A,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(a,r,v){let l=a.get(r);return l===void 0&&(l=v,a.set(r,l)),l}e.getOrSet=P;function D(a){const r=[];return a.forEach((v,l)=>{r.push(`${l} => ${v}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=D;function T(a){const r=[];return a.forEach(v=>{r.push(v)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=T;class t{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const v=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return v-l}value(){return this._value[this._pos]}}e.StringIterator=t;class _{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(r=!0,v=!0){this._splitOnBackslash=r,this._caseSensitive=v}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const v=this._value.charCodeAt(this._to);if(v===47||this._splitOnBackslash&&v===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var m;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(m||(m={}));class s{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=s;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(p||(p={}));class C{constructor(r){this._iter=r}static forUris(r=()=>!1){return new C(new s(r))}static forPaths(){return new C(new n)}static forStrings(){return new C(new t)}static forConfigKeys(){return new C(new _)}clear(){this._root=void 0}fill(r,v){if(v){const l=v.slice(0);(0,d.shuffle)(l);for(let c of l)this.set(c,r)}else{const l=r.slice(0);(0,d.shuffle)(l);for(let c of l)this.set(c[0],c[1])}}set(r,v){const l=this._iter.reset(r);let c;this._root||(this._root=new u,this._root.segment=l.value());const b=[];for(c=this._root;;){const y=l.cmp(c.segment);if(y>0)c.left||(c.left=new u,c.left.segment=l.value()),b.push([-1,c]),c=c.left;else if(y<0)c.right||(c.right=new u,c.right.segment=l.value()),b.push([1,c]),c=c.right;else if(l.hasNext())l.next(),c.mid||(c.mid=new u,c.mid.segment=l.value()),b.push([0,c]),c=c.mid;else break}const h=c.value;c.value=v,c.key=r;for(let y=b.length-1;y>=0;y--){const R=b[y][1];R.updateHeight();const k=R.balanceFactor();if(k<-1||k>1){const O=b[y][0],N=b[y+1][0];if(O===1&&N===1)b[y][1]=R.rotateLeft();else if(O===-1&&N===-1)b[y][1]=R.rotateRight();else if(O===1&&N===-1)R.right=b[y+1][1]=b[y+1][1].rotateRight(),b[y][1]=R.rotateLeft();else if(O===-1&&N===1)R.left=b[y+1][1]=b[y+1][1].rotateLeft(),b[y][1]=R.rotateRight();else throw new Error;if(y>0)switch(b[y-1][0]){case-1:b[y-1][1].left=b[y][1];break;case 1:b[y-1][1].right=b[y][1];break;case 0:b[y-1][1].mid=b[y][1];break}else this._root=b[0][1]}}return h}get(r){return this._getNode(r)?.value}_getNode(r){const v=this._iter.reset(r);let l=this._root;for(;l;){const c=v.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else break}return l}has(r){const v=this._getNode(r);return!(v?.value===void 0&&v?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,v){const l=this._iter.reset(r),c=[];let b=this._root;for(;b;){const h=l.cmp(b.segment);if(h>0)c.push([-1,b]),b=b.left;else if(h<0)c.push([1,b]),b=b.right;else if(l.hasNext())l.next(),c.push([0,b]),b=b.mid;else break}if(!!b){if(v?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const h=this._min(b.right),{key:y,value:R,segment:k}=h;this._delete(h.key,!1),b.key=y,b.value=R,b.segment=k}else{const h=b.left??b.right;if(c.length>0){const[y,R]=c[c.length-1];switch(y){case-1:R.left=h;break;case 0:R.mid=h;break;case 1:R.right=h;break}}else this._root=h}for(let h=c.length-1;h>=0;h--){const y=c[h][1];y.updateHeight();const R=y.balanceFactor();if(R>1?(y.right.balanceFactor()>=0||(y.right=c[h+1][1]=c[h+1][1].rotateRight()),c[h][1]=y.rotateLeft()):R<-1&&(y.left.balanceFactor()<=0||(y.left=c[h+1][1]=c[h+1][1].rotateLeft()),c[h][1]=y.rotateRight()),h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this._root=c[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const v=this._iter.reset(r);let l=this._root,c;for(;l;){const b=v.cmp(l.segment);if(b>0)l=l.left;else if(b<0)l=l.right;else if(v.hasNext())v.next(),c=l.value||c,l=l.mid;else break}return l&&l.value||c}findSuperstr(r){const v=this._iter.reset(r);let l=this._root;for(;l;){const c=v.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[v,l]of this)r(l,v)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=v=>{if(!v)return!0;const l=v.balanceFactor();return l<-1||l>1?!1:r(v.left)&&r(v.right)};return r(this._root)}}e.TernarySearchTree=C;class w{constructor(r,v){this.uri=r,this.value=v}}class o{constructor(r,v){this[E]="ResourceMap",r instanceof o?(this.map=new Map(r.map),this.toKey=v??o.defaultToKey):(this.map=new Map,this.toKey=r??o.defaultToKey)}set(r,v){return this.map.set(this.toKey(r),new w(r,v)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,v){typeof v!="undefined"&&(r=r.bind(v));for(let[l,c]of this.map)r(c.value,c.uri,this)}*values(){for(let r of this.map.values())yield r.value}*keys(){for(let r of this.map.values())yield r.uri}*entries(){for(let r of this.map.values())yield[r.uri,r.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=o,o.defaultToKey=a=>a.toString();var f;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class S{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,v=0){const l=this._map.get(r);if(!!l)return v!==0&&this.touch(l,v),l.value}set(r,v,l=0){let c=this._map.get(r);if(c)c.value=v,l!==0&&this.touch(c,l);else{switch(c={key:r,value:v,next:void 0,previous:void 0},l){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const v=this._map.get(r);if(!!v)return this._map.delete(r),this.removeItem(v),this._size--,v.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,v){const l=this._state;let c=this._head;for(;c;){if(v?r.bind(v)(c.value,c.key,this):r(c.value,c.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}values(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}entries(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let v=this._head,l=this.size;for(;v&&l>r;)this._map.delete(v.key),v=v.next,l--;this._head=v,this._size=l,v&&(v.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const v=r.next,l=r.previous;if(!v||!l)throw new Error("Invalid list");v.previous=l,l.next=v}r.next=void 0,r.previous=void 0,this._state++}touch(r,v){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(r===this._head)return;const l=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(l.previous=c,c.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(v===2){if(r===this._tail)return;const l=r.next,c=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=c,c.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((v,l)=>{r.push([l,v])}),r}fromJSON(r){this.clear();for(const[v,l]of r)this.set(v,l)}}e.LinkedMap=S;class i extends S{constructor(r,v=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,v),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,v=2){return super.get(r,v)}peek(r){return super.get(r,0)}set(r,v){return super.set(r,v,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class g{constructor(r){F.set(this,void 0),Ze(this,F,r,"f")}get size(){return Re(this,F,"f").size}forEach(r,v){Re(this,F,"f").forEach(r,v)}get(r){return Re(this,F,"f").get(r)}has(r){return Re(this,F,"f").has(r)}entries(){return Re(this,F,"f").entries()}keys(){return Re(this,F,"f").keys()}values(){return Re(this,F,"f").values()}[(F=new WeakMap,Symbol.iterator)](){return Re(this,F,"f").entries()}}e.ReadonlyMapView=g}),define(be[105],Ee([0,1,20,9]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...K){return function(se,he){for(let Ae=0,Ue=K.length;Ae<Ue;Ae++){const He=K[Ae](se,he);if(He)return He}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(K,se,he){if(!he||he.length<se.length)return null;let Ae;return K?Ae=M.startsWithIgnoreCase(he,se):Ae=he.indexOf(se)===0,Ae?se.length>0?[{start:0,end:se.length}]:[]:null}function F(K,se){const he=se.toLowerCase().indexOf(K.toLowerCase());return he===-1?null:[{start:he,end:he+K.length}]}e.matchesContiguousSubString=F;function P(K,se){return D(K.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=P;function D(K,se,he,Ae){if(he===K.length)return[];if(Ae===se.length)return null;if(K[he]===se[Ae]){let Ue=null;return(Ue=D(K,se,he+1,Ae+1))?C({start:Ae,end:Ae+1},Ue):null}return D(K,se,he,Ae+1)}function T(K){return 97<=K&&K<=122}function t(K){return 65<=K&&K<=90}e.isUpper=t;function _(K){return 48<=K&&K<=57}function n(K){return K===32||K===9||K===10||K===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(K=>m.add(K.charCodeAt(0)));function s(K){return n(K)||m.has(K)}function u(K,se){return K===se||s(K)&&s(se)}function p(K){return T(K)||t(K)||_(K)}function C(K,se){return se.length===0?se=[K]:K.end===se[0].start?se[0].start=K.start:se.unshift(K),se}function w(K,se){for(let he=se;he<K.length;he++){const Ae=K.charCodeAt(he);if(t(Ae)||_(Ae)||he>0&&!p(K.charCodeAt(he-1)))return he}return K.length}function o(K,se,he,Ae){if(he===K.length)return[];if(Ae===se.length)return null;if(K[he]!==se[Ae].toLowerCase())return null;{let Ue=null,He=Ae+1;for(Ue=o(K,se,he+1,Ae+1);!Ue&&(He=w(se,He))<se.length;)Ue=o(K,se,he+1,He),He++;return Ue===null?null:C({start:Ae,end:Ae+1},Ue)}}function f(K){let se=0,he=0,Ae=0,Ue=0,He=0;for(let nt=0;nt<K.length;nt++)He=K.charCodeAt(nt),t(He)&&se++,T(He)&&he++,p(He)&&Ae++,_(He)&&Ue++;const Qe=se/K.length,et=he/K.length,st=Ae/K.length,ye=Ue/K.length;return{upperPercent:Qe,lowerPercent:et,alphaPercent:st,numericPercent:ye}}function S(K){const{upperPercent:se,lowerPercent:he}=K;return he===0&&se>.6}function i(K){const{upperPercent:se,lowerPercent:he,alphaPercent:Ae,numericPercent:Ue}=K;return he>.2&&se<.8&&Ae>.6&&Ue<.2}function g(K){let se=0,he=0,Ae=0,Ue=0;for(let He=0;He<K.length;He++)Ae=K.charCodeAt(He),t(Ae)&&se++,T(Ae)&&he++,n(Ae)&&Ue++;return(se===0||he===0)&&Ue===0?K.length<=30:se<=5}function a(K,se){if(!se||(se=se.trim(),se.length===0)||!g(K)||se.length>60)return null;const he=f(se);if(!i(he)){if(!S(he))return null;se=se.toLowerCase()}let Ae=null,Ue=0;for(K=K.toLowerCase();Ue<se.length&&(Ae=o(K,se,0,Ue))===null;)Ue=w(se,Ue+1);return Ae}e.matchesCamelCase=a;function r(K,se,he=!1){if(!se||se.length===0)return null;let Ae=null,Ue=0;for(K=K.toLowerCase(),se=se.toLowerCase();Ue<se.length&&(Ae=v(K,se,0,Ue,he))===null;)Ue=l(se,Ue+1);return Ae}e.matchesWords=r;function v(K,se,he,Ae,Ue){if(he===K.length)return[];if(Ae===se.length)return null;if(u(K.charCodeAt(he),se.charCodeAt(Ae))){let He=null,Qe=Ae+1;if(He=v(K,se,he+1,Ae+1,Ue),!Ue)for(;!He&&(Qe=l(se,Qe))<se.length;)He=v(K,se,he+1,Qe,Ue),Qe++;return He===null?null:C({start:Ae,end:Ae+1},He)}else return null}function l(K,se){for(let he=se;he<K.length;he++)if(s(K.charCodeAt(he))||he>0&&s(K.charCodeAt(he-1)))return he;return K.length}const c=E(e.matchesPrefix,a,F),b=E(e.matchesPrefix,a,P),h=new d.LRUCache(1e4);function y(K,se,he=!1){if(typeof K!="string"||typeof se!="string")return null;let Ae=h.get(K);Ae||(Ae=new RegExp(M.convertSimple2RegExpPattern(K),"i"),h.set(K,Ae));const Ue=Ae.exec(se);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:he?b(K,se):c(K,se)}e.matchesFuzzy=y;function R(K,se){const he=Ke(K,K.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?O(he):null}e.matchesFuzzy2=R;function k(K,se,he,Ae,Ue,He){const Qe=Math.min(13,K.length);for(;he<Qe;he++){const et=Ke(K,se,he,Ae,Ue,He,!1);if(et)return et}return[0,He]}e.anyScore=k;function O(K){if(typeof K=="undefined")return[];const se=[],he=K[1];for(let Ae=K.length-1;Ae>1;Ae--){const Ue=K[Ae]+he,He=se[se.length-1];He&&He.end===Ue?He.end=Ue+1:se.push({start:Ue,end:Ue+1})}return se}e.createMatches=O;const N=128;function I(){const K=[],se=[];for(let he=0;he<=N;he++)se[he]=0;for(let he=0;he<=N;he++)K.push(se.slice(0));return K}function B(K){const se=[];for(let he=0;he<=K;he++)se[he]=0;return se}const x=B(2*N),V=B(2*N),H=I(),W=I(),ee=I(),q=!1;function Y(K,se,he,Ae,Ue){function He(et,st,ye=" "){for(;et.length<st;)et=ye+et;return et}let Qe=` |   |${Ae.split("").map(et=>He(et,3)).join("|")}
`;for(let et=0;et<=he;et++)et===0?Qe+=" |":Qe+=`${se[et-1]}|`,Qe+=K[et].slice(0,Ue+1).map(st=>He(st.toString(),3)).join("|")+`
`;return Qe}function j(K,se,he,Ae){K=K.substr(se),he=he.substr(Ae),console.log(Y(W,K,K.length,he,he.length)),console.log(Y(ee,K,K.length,he,he.length)),console.log(Y(H,K,K.length,he,he.length))}function le(K,se){if(se<0||se>=K.length)return!1;const he=K.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function re(K,se){if(se<0||se>=K.length)return!1;switch(K.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function ve(K,se,he){return se[K]!==he[K]}function Fe(K,se,he,Ae,Ue,He,Qe=!1){for(;se<he&&Ue<He;)K[se]===Ae[Ue]&&(Qe&&(x[se]=Ue),se+=1),Ue+=1;return se===he}e.isPatternInWord=Fe;var Me;(function(K){K[K.Diag=1]="Diag",K[K.Left=2]="Left",K[K.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Oe;(function(K){K.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}K.isDefault=se})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function Ke(K,se,he,Ae,Ue,He,Qe){const et=K.length>N?N:K.length,st=Ae.length>N?N:Ae.length;if(he>=et||He>=st||et-he>st-He||!Fe(se,he,et,Ue,He,st,!0))return;qe(et,st,he,He,se,Ue);let ye=1,nt=1,G=he,Z=He;const pe=[!1];for(ye=1,G=he;G<et;ye++,G++){const ut=x[G],St=V[G],Tt=G+1<et?V[G+1]:st;for(nt=ut-He+1,Z=ut;Z<Tt;nt++,Z++){let It=Number.MIN_SAFE_INTEGER,Xe=!1;Z<=St&&(It=Ve(K,se,G,he,Ae,Ue,Z,st,He,H[ye-1][nt-1]===0,pe));let vt=0;It!==Number.MAX_SAFE_INTEGER&&(Xe=!0,vt=It+W[ye-1][nt-1]);const Pe=Z>ut,Se=Pe?W[ye][nt-1]+(H[ye][nt-1]>0?-5:0):0,Ce=Z>ut+1&&H[ye][nt-1]>0,ie=Ce?W[ye][nt-2]+(H[ye][nt-2]>0?-5:0):0;if(Ce&&(!Pe||ie>=Se)&&(!Xe||ie>=vt))W[ye][nt]=ie,ee[ye][nt]=3,H[ye][nt]=0;else if(Pe&&(!Xe||Se>=vt))W[ye][nt]=Se,ee[ye][nt]=2,H[ye][nt]=0;else if(Xe)W[ye][nt]=vt,ee[ye][nt]=1,H[ye][nt]=H[ye-1][nt-1]+1;else throw new Error("not possible")}}if(q&&j(K,he,Ae,He),!pe[0]&&!Qe)return;ye--,nt--;const We=[W[ye][nt],He];let Ye=0,rt=0;for(;ye>=1;){let ut=nt;do{const St=ee[ye][ut];if(St===3)ut=ut-2;else if(St===2)ut=ut-1;else break}while(ut>=1);Ye>1&&se[he+ye-1]===Ue[He+nt-1]&&!ve(ut+He-1,Ae,Ue)&&Ye+1>H[ye][ut]&&(ut=nt),ut===nt?Ye++:Ye=1,rt||(rt=ut),ye--,nt=ut-1,We.push(nt)}st===et&&(We[0]+=2);const mt=rt-et;return We[0]-=mt,We}e.fuzzyScore=Ke;function qe(K,se,he,Ae,Ue,He){let Qe=K-1,et=se-1;for(;Qe>=he&&et>=Ae;)Ue[Qe]===He[et]&&(V[Qe]=et,Qe--),et--}function Ve(K,se,he,Ae,Ue,He,Qe,et,st,ye,nt){if(se[he]!==He[Qe])return Number.MIN_SAFE_INTEGER;let G=1,Z=!1;return Qe===he-Ae?G=K[he]===Ue[Qe]?7:5:ve(Qe,Ue,He)&&(Qe===0||!ve(Qe-1,Ue,He))?(G=K[he]===Ue[Qe]?7:5,Z=!0):le(He,Qe)&&(Qe===0||!le(He,Qe-1))?G=5:(le(He,Qe-1)||re(He,Qe-1))&&(G=5,Z=!0),G>1&&he===Ae&&(nt[0]=!0),Z||(Z=ve(Qe,Ue,He)||le(He,Qe-1)||re(He,Qe-1)),he===Ae?Qe>st&&(G-=Z?3:5):ye?G+=Z?2:0:G+=Z?0:1,Qe+1===et&&(G-=Z?3:5),G}function $(K,se,he,Ae,Ue,He,Qe){return te(K,se,he,Ae,Ue,He,!0,Qe)}e.fuzzyScoreGracefulAggressive=$;function Q(K,se,he,Ae,Ue,He,Qe){return te(K,se,he,Ae,Ue,He,!1,Qe)}e.fuzzyScoreGraceful=Q;function te(K,se,he,Ae,Ue,He,Qe,et){let st=Ke(K,se,he,Ae,Ue,He,et);if(st&&!Qe)return st;if(K.length>=3){const ye=Math.min(7,K.length-1);for(let nt=he+1;nt<ye;nt++){const G=ae(K,nt);if(G){const Z=Ke(G,G.toLowerCase(),he,Ae,Ue,He,et);Z&&(Z[0]-=3,(!st||Z[0]>st[0])&&(st=Z))}}}return st}function ae(K,se){if(se+1>=K.length)return;const he=K[se],Ae=K[se+1];if(he!==Ae)return K.slice(0,se)+Ae+he+K.slice(se+2)}}),define(be[106],Ee([0,1,34,105,9]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${A.source}`,"g");function P(u){return u.replace(F,(p,C)=>C?p:`\\${p}`)}e.escapeIcons=P;const D=new RegExp(`\\\\${A.source}`,"g");function T(u){return u.replace(D,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=T;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function _(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(t,(p,C,w,o)=>w?p:C||o||"")}e.stripIcons=_;function n(u){const p=u.indexOf(e.iconStartMarker);return p===-1?{text:u}:m(u,p)}e.parseLabelWithIcons=n;function m(u,p){const C=[];let w="";function o(l){if(l){w+=l;for(const c of l)C.push(i)}}let f=-1,S="",i=0,g,a,r=p;const v=u.length;for(o(u.substr(0,p));r<v;)g=u[r],a=u[r+1],g===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(f=r,o(S),S=e.iconStartMarker,r++):g===")"&&f!==-1?(i+=r-f+1,f=-1,S=""):f!==-1?/^[a-z0-9\-]$/i.test(g)?S+=g:(o(S),f=-1,S=""):o(g),r++;return o(S),{text:w,iconOffsets:C}}function s(u,p,C=!1){const{text:w,iconOffsets:o}=p;if(!o||o.length===0)return(0,M.matchesFuzzy)(u,w,C);const f=(0,E.ltrim)(w," "),S=w.length-f.length,i=(0,M.matchesFuzzy)(u,f,C);if(i)for(const g of i){const a=o[g.start+S]+S;g.start+=a,g.end+=a}return i}e.matchesFuzzyIconAware=s}),define(be[77],Ee([0,1,16,106]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(m="",s=!1){if(this.value=m,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(m,s=0){return this.value+=T(this.supportThemeIcons?(0,M.escapeIcons)(m):m).replace(/([ \t]+)/g,(u,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,s){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=A;function F(n){return P(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function P(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function D(n,m){return n===m?!0:!n||!m?!1:n.value===m.value&&n.isTrusted===m.isTrusted&&n.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=D;function T(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function _(n){const m=[],s=n.split("|").map(p=>p.trim());n=s[0];const u=s[1];if(u){const p=/height=(\d+)/.exec(u),C=/width=(\d+)/.exec(u),w=p?p[1]:"",o=C?C[1]:"",f=isFinite(parseInt(o)),S=isFinite(parseInt(w));f&&m.push(`width="${o}"`),S&&m.push(`height="${w}"`)}return{href:n,dimensions:m}}e.parseHrefAndDimensions=_}),define(be[35],Ee([0,1,9]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const A="error",F="warning",P="warn",D="info",T="ignore";function t(n){return n?d.equalsIgnoreCase(A,n)?E.Error:d.equalsIgnoreCase(F,n)||d.equalsIgnoreCase(P,n)?E.Warning:d.equalsIgnoreCase(D,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function _(n){switch(n){case E.Error:return A;case E.Warning:return F;case E.Info:return D;default:return T}}E.toString=_}(M||(M={})),e.default=M}),define(be[43],Ee([0,1,17,25,9,10]),function(oe,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(a){return a===47||a===92}e.isPathSeparator=F;function P(a){return a.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=P;function D(a){return a.indexOf("/")===-1&&(a=P(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=D;function T(a,r=d.posix.sep){if(!a)return"";const v=a.length,l=a.charCodeAt(0);if(F(l)){if(F(a.charCodeAt(1))&&!F(a.charCodeAt(2))){let b=3;const h=b;for(;b<v&&!F(a.charCodeAt(b));b++);if(h!==b&&!F(a.charCodeAt(b+1))){for(b+=1;b<v;b++)if(F(a.charCodeAt(b)))return a.slice(0,b+1).replace(/[\\/]/g,r)}}return r}else if(C(l)&&a.charCodeAt(1)===58)return F(a.charCodeAt(2))?a.slice(0,2)+r:a.slice(0,2);let c=a.indexOf("://");if(c!==-1){for(c+=3;c<v;c++)if(F(a.charCodeAt(c)))return a.slice(0,c+1)}return""}e.getRoot=T;function t(a){if(!M.isWindows||!a||a.length<5)return!1;let r=a.charCodeAt(0);if(r!==92||(r=a.charCodeAt(1),r!==92))return!1;let v=2;const l=v;for(;v<a.length&&(r=a.charCodeAt(v),r!==92);v++);return!(l===v||(r=a.charCodeAt(v+1),isNaN(r)||r===92))}e.isUNC=t;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(a,r=M.isWindows){const v=r?_:n;return!(!a||a.length===0||/^\s+$/.test(a)||(v.lastIndex=0,v.test(a))||r&&m.test(a)||a==="."||a===".."||r&&a[a.length-1]==="."||r&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=s;function u(a,r,v){const l=a===r;return!v||l?l:!a||!r?!1:(0,E.equalsIgnoreCase)(a,r)}e.isEqual=u;function p(a,r,v,l=d.sep){if(a===r)return!0;if(!a||!r||r.length>a.length)return!1;if(v){if(!(0,E.startsWithIgnoreCase)(a,r))return!1;if(r.length===a.length)return!0;let b=r.length;return r.charAt(r.length-1)===l&&b--,a.charAt(b)===l}return r.charAt(r.length-1)!==l&&(r+=l),a.indexOf(r)===0}e.isEqualOrParent=p;function C(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=C;function w(a,r){return M.isWindows&&a.endsWith(":")&&(a+=d.sep),(0,d.isAbsolute)(a)||(a=(0,d.join)(r,a)),a=(0,d.normalize)(a),M.isWindows?(a=(0,E.rtrim)(a,d.sep),a.endsWith(":")&&(a+=d.sep)):(a=(0,E.rtrim)(a,d.sep),a||(a=d.sep)),a}e.sanitizeFilePath=w;function o(a){const r=(0,d.normalize)(a);return M.isWindows?a.length>3?!1:f(r)&&(a.length===2||r.charCodeAt(2)===92):r===d.posix.sep}e.isRootOrDriveLetter=o;function f(a){return M.isWindows?C(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function S(a){return f(a)?a[0]:void 0}e.getDriveLetter=S;function i(a,r,v){return r.length>a.length?-1:a===r?0:(v&&(a=a.toLowerCase(),r=r.toLowerCase()),a.indexOf(r))}e.indexOfPath=i;function g(a){const r=a.split(":");let v,l,c;if(r.forEach(b=>{const h=Number(b);(0,A.isNumber)(h)?l===void 0?l=h:c===void 0&&(c=h):v=v?[v,b].join(":"):b}),!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:l!==void 0?l:void 0,column:c!==void 0?c:l!==void 0?1:void 0}}e.parseLineAndColumnAware=g}),define(be[23],Ee([0,1,10]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.keys(u).forEach(C=>{u[C]&&typeof u[C]=="object"?p[C]=M(u[C]):p[C]=u[C]}),p}e.deepClone=M;function E(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const C=p.shift();Object.freeze(C);for(const w in C)if(A.call(C,w)){const o=C[w];typeof o=="object"&&!Object.isFrozen(o)&&p.push(o)}}return u}e.deepFreeze=E;const A=Object.prototype.hasOwnProperty;function F(u,p){return P(u,p,new Set)}e.cloneAndChange=F;function P(u,p,C){if((0,d.isUndefinedOrNull)(u))return u;const w=p(u);if(typeof w!="undefined")return w;if((0,d.isArray)(u)){const o=[];for(const f of u)o.push(P(f,p,C));return o}if((0,d.isObject)(u)){if(C.has(u))throw new Error("Cannot clone recursive data-structure");C.add(u);const o={};for(let f in u)A.call(u,f)&&(o[f]=P(u[f],p,C));return C.delete(u),o}return u}function D(u,p,C=!0){return(0,d.isObject)(u)?((0,d.isObject)(p)&&Object.keys(p).forEach(w=>{w in u?C&&((0,d.isObject)(u[w])&&(0,d.isObject)(p[w])?D(u[w],p[w],C):u[w]=p[w]):u[w]=p[w]}),u):p}e.mixin=D;function T(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let C,w;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(C=0;C<u.length;C++)if(!T(u[C],p[C]))return!1}else{const o=[];for(w in u)o.push(w);o.sort();const f=[];for(w in p)f.push(w);if(f.sort(),!T(o,f))return!1;for(C=0;C<o.length;C++)if(!T(u[o[C]],p[o[C]]))return!1}return!0}e.equals=T;function t(u){const p=new Set;return JSON.stringify(u,(C,w)=>{if((0,d.isObject)(w)||Array.isArray(w)){if(p.has(w))return"[Circular]";p.add(w)}return w})}e.safeStringify=t;function _(u,p,C){const w=p(u);return typeof w=="undefined"?C:w}e.getOrDefault=_;function n(u,p){const C=Object.create(null);return!u||!p||Object.keys(p).forEach(o=>{const f=u[o],S=p[o];T(f,S)||(C[o]=S)}),C}e.distinct=n;function m(u,p){const C=p.toLowerCase(),w=Object.keys(u).find(o=>o.toLowerCase()===C);return w?u[w]:u[p]}e.getCaseInsensitive=m;function s(u,p){const C=Object.create(null);for(const w of Object.keys(u))p(w,u[w])&&(C[w]=u[w]);return C}e.filter=s}),define(be[55],Ee([0,1,22,9,2]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,D)}e.stringify=A;function F(t){let _=JSON.parse(t);return _=T(_),_}e.parse=F;var P;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function D(t,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,M.regExpFlags)(_)}:_}function T(t,_=0){if(!t||_>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof d.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=T(t[n],_+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=T(t[n],_+1))}return t}e.revive=T}),define(be[11],Ee([0,1,25,2]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,T,t){this._hosts[D]=T,this._ports[D]=t}setConnectionToken(D,T){this._connectionTokens[D]=T}rewrite(D){if(this._delegate)return this._delegate(D);const T=D.authority;let t=this._hosts[T];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const _=this._ports[T],n=this._connectionTokens[T];let m=`path=${encodeURIComponent(D.path)}`;return typeof n=="string"&&(m+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:d.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${_}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class F{asBrowserUri(D,T){const t=this.toUri(D,T);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${E.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(D,T){const t=this.toUri(D,T);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(D,T){return M.URI.isUri(D)?D:M.URI.parse(T.toUrl(D))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(be[24],Ee([0,1,43,11,17,25,9,2]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(m){return(0,P.uriToFsPath)(m,!0)}e.originalFSPath=D;class T{constructor(s){this._ignorePathCasing=s}compare(s,u,p=!1){return s===u?0:(0,F.compare)(this.getComparisonKey(s,p),this.getComparisonKey(u,p))}isEqual(s,u,p=!1){return s===u?!0:!s||!u?!1:this.getComparisonKey(s,p)===this.getComparisonKey(u,p)}getComparisonKey(s,u=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,u,p=!1){if(s.scheme===u.scheme){if(s.scheme===M.Schemas.file)return d.isEqualOrParent(D(s),D(u),this._ignorePathCasing(s))&&s.query===u.query&&(p||s.fragment===u.fragment);if((0,e.isEqualAuthority)(s.authority,u.authority))return d.isEqualOrParent(s.path,u.path,this._ignorePathCasing(s),"/")&&s.query===u.query&&(p||s.fragment===u.fragment)}return!1}joinPath(s,...u){return P.URI.joinPath(s,...u)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return E.posix.basename(s.path)}extname(s){return E.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let u;return s.scheme===M.Schemas.file?u=P.URI.file(E.dirname(D(s))).path:(u=E.posix.dirname(s.path),s.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),u="/")),s.with({path:u})}normalizePath(s){if(!s.path.length)return s;let u;return s.scheme===M.Schemas.file?u=P.URI.file(E.normalize(D(s))).path:u=E.posix.normalize(s.path),s.with({path:u})}relativePath(s,u){if(s.scheme!==u.scheme||!(0,e.isEqualAuthority)(s.authority,u.authority))return;if(s.scheme===M.Schemas.file){const w=E.relative(D(s),D(u));return A.isWindows?d.toSlashes(w):w}let p=s.path||"/",C=u.path||"/";if(this._ignorePathCasing(s)){let w=0;for(const o=Math.min(p.length,C.length);w<o&&!(p.charCodeAt(w)!==C.charCodeAt(w)&&p.charAt(w).toLowerCase()!==C.charAt(w).toLowerCase());w++);p=C.substr(0,w)+p.substr(w)}return E.posix.relative(p,C)}resolvePath(s,u){if(s.scheme===M.Schemas.file){const p=P.URI.file(E.resolve(D(s),u));return s.with({authority:p.authority,path:p.path})}return u=d.toPosixPath(u),s.with({path:E.posix.resolve(s.path,u)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,u){return s===u||(0,F.equalsIgnoreCase)(s,u)}hasTrailingPathSeparator(s,u=E.sep){if(s.scheme===M.Schemas.file){const p=D(s);return p.length>d.getRoot(p).length&&p[p.length-1]===u}else{const p=s.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,u=E.sep){return(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,u=E.sep){let p=!1;if(s.scheme===M.Schemas.file){const C=D(s);p=C!==void 0&&C.length===d.getRoot(C).length&&C[C.length-1]===u}else{u="/";const C=s.path;p=C.length===1&&C.charCodeAt(C.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path+"/"}):s}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(m=>m.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(m,s){const u=[];for(let p=0;p<m.length;p++){const C=s(m[p]);m.some((w,o)=>o===p?!1:(0,e.isEqualOrParent)(C,s(w)))||u.push(m[p])}return u}e.distinctParents=t;var _;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function s(u){const p=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(o=>{const[f,S]=o.split(":");f&&S&&p.set(f,S)});const w=u.path.substring(0,u.path.indexOf(";"));return w&&p.set(m.META_DATA_MIME,w),p}m.parseMetaData=s})(_=e.DataUri||(e.DataUri={}));function n(m,s,u){if(s){let p=m.path;return p&&p[0]!==E.posix.sep&&(p=E.posix.sep+p),m.with({scheme:u,authority:s,path:p})}return m.with({scheme:u})}e.toLocalResource=n}),define(be[12],Ee([0,1,21,16,3,6,24]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(H){return!!H&&typeof H.then=="function"}e.isThenable=P;function D(H){const W=new d.CancellationTokenSource,ee=H(W.token),q=new Promise((Y,j)=>{const le=W.token.onCancellationRequested(()=>{le.dispose(),W.dispose(),j((0,M.canceled)())});Promise.resolve(ee).then(re=>{le.dispose(),W.dispose(),Y(re)},re=>{le.dispose(),W.dispose(),j(re)})});return new class{cancel(){W.cancel()}then(Y,j){return q.then(Y,j)}catch(Y){return this.then(void 0,Y)}finally(Y){return q.finally(Y)}}}e.createCancelablePromise=D;function T(H,W,ee){return Promise.race([H,new Promise(q=>W.onCancellationRequested(()=>q(ee)))])}e.raceCancellation=T;async function t(H){let W=-1;const ee=H.map((Y,j)=>Y.then(le=>(W=j,le))),q=await Promise.race(ee);return H.forEach((Y,j)=>{j!==W&&Y.cancel()}),q}e.raceCancellablePromises=t;function _(H,W,ee){let q;const Y=setTimeout(()=>{q?.(void 0),ee?.()},W);return Promise.race([H.finally(()=>clearTimeout(Y)),new Promise(j=>q=j)])}e.raceTimeout=_;function n(H){return new Promise((W,ee)=>{const q=H();P(q)?q.then(W,ee):W(q)})}e.asPromise=n;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const ee=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(ee,ee).then(q)})}return new Promise((ee,q)=>{this.queuedPromise.then(ee,q)})}return this.activePromise=W(),new Promise((ee,q)=>{this.activePromise.then(Y=>{this.activePromise=null,ee(Y)},Y=>{this.activePromise=null,q(Y)})})}}e.Throttler=m;class s{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=s;class u{constructor(){this.promiseMap=new Map}queue(W,ee){const Y=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get(W)===Y&&this.promiseMap.delete(W)});return this.promiseMap.set(W,Y),Y}}e.SequencerByKey=u;class p{constructor(W){this.defaultDelay=W,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,ee=this.defaultDelay){return this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,Y)=>{this.doResolve=q,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ee),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class C{constructor(W){this.delayer=new p(W),this.throttler=new m}trigger(W,ee){return this.delayer.trigger(()=>this.throttler.queue(W),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=C;class w{constructor(){this._isOpen=!1,this._promise=new Promise((W,ee)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class o extends w{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function f(H,W){return W?new Promise((ee,q)=>{const Y=setTimeout(()=>{j.dispose(),ee()},H),j=W.onCancellationRequested(()=>{clearTimeout(Y),j.dispose(),q((0,M.canceled)())})}):D(ee=>f(H,ee))}e.timeout=f;function S(H,W=0){const ee=setTimeout(H,W);return(0,A.toDisposable)(()=>clearTimeout(ee))}e.disposableTimeout=S;function i(H){const W=[];let ee=0;const q=H.length;function Y(){return ee<q?H[ee++]():null}function j(le){le!=null&&W.push(le);const re=Y();return re?re.then(j):Promise.resolve(W)}return Promise.resolve(null).then(j)}e.sequence=i;function g(H,W=q=>!!q,ee=null){let q=0;const Y=H.length,j=()=>{if(q>=Y)return Promise.resolve(ee);const le=H[q++];return Promise.resolve(le()).then(ve=>W(ve)?Promise.resolve(ve):j())};return j()}e.first=g;function a(H,W=q=>!!q,ee=null){if(H.length===0)return Promise.resolve(ee);let q=H.length;const Y=()=>{q=-1;for(const j of H)j.cancel?.()};return new Promise((j,le)=>{for(const re of H)re.then(ve=>{--q>=0&&W(ve)?(Y(),j(ve)):q===0&&j(ee)}).catch(ve=>{--q>=0&&(Y(),le(ve))})})}e.firstParallel=a;class r{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(W){return this._size++,new Promise((ee,q)=>{this.outstandingPromises.push({factory:W,c:ee,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const ee=W.factory();ee.then(W.c,W.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class v extends r{constructor(){super(1)}}e.Queue=v;class l{constructor(){this.queues=new Map}queueFor(W,ee=F.extUri){const q=ee.getComparisonKey(W);let Y=this.queues.get(q);return Y||(Y=new v,E.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(q)}),this.queues.set(q,Y)),Y}dispose(){this.queues.forEach(W=>W.dispose()),this.queues.clear()}}e.ResourceQueue=l;class c{constructor(W,ee){this._token=-1,typeof W=="function"&&typeof ee=="number"&&this.setIfNotSet(W,ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},ee)}setIfNotSet(W,ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},ee))}}e.TimeoutTimer=c;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,ee){this.cancel(),this._token=setInterval(()=>{W()},ee)}}e.IntervalTimer=b;class h{constructor(W,ee){this.timeoutToken=-1,this.runner=W,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=h;class y{constructor(W,ee){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class R extends h{constructor(W,ee){super(W,ee);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class k extends A.Disposable{constructor(W,ee,q,Y){super();this.maxWorkChunkSize=W,this.maxPendingWork=ee,this.throttleDelay=q,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.maxPendingWork)return!1}else if(this.pending+W.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new h(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=k,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{const W=setTimeout(()=>{const q=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0,clearTimeout(W))}}}:e.runWhenIdle=(H,W)=>{const ee=requestIdleCallback(H,typeof W=="number"?{timeout:W}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(ee))}}}}();class O{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function N(H,W,ee){let q;for(let Y=0;Y<ee;Y++)try{return await H()}catch(j){q=j,await f(W)}throw q}e.retry=N;class I{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,ee,q){return this._pending={taskId:W,cancel:()=>q?.(),promise:ee},ee.then(()=>this.donePending(W),()=>this.donePending(W)),ee}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let ee,q;const Y=new Promise((j,le)=>{ee=j,q=le});this._next={run:W,promise:Y,promiseResolve:ee,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=I;class B{constructor(W){this.interval=W,this.lastIncrementTime=0,this.value=0}increment(){const W=Date.now();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,ee)=>{this.completeCallback=W,this.errorCallback=ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(ee=>{this.completeCallback(W),this.resolved=!0,ee()})}error(W){return new Promise(ee=>{this.errorCallback(W),this.rejected=!0,ee()})}cancel(){new Promise(W=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,W()})}}e.DeferredPromise=x;var V;(function(H){async function W(q){let Y;const j=await Promise.all(q.map(le=>le.then(re=>re,re=>{Y||(Y=re)})));if(typeof Y!="undefined")throw Y;return j}H.settled=W;function ee(q){return new Promise(async(Y,j)=>{try{await q(Y,j)}catch(le){j(le)}})}H.withAsyncBody=ee})(V=e.Promises||(e.Promises={}))}),define(be[107],Ee([0,1,12,17]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new d.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(h,y,R=!1){const k=h||"",O=y||"",N=E.value.collator.compare(k,O);return E.value.collatorIsNumeric&&N===0&&k!==O?k<O?-1:1:N}e.compareFileNames=P;function D(h,y){const R=A.value.collator;return h=h||"",y=y||"",S(R,h,y)}e.compareFileNamesDefault=D;function T(h,y){const R=A.value.collator;return h=h||"",y=y||"",r(h,y)||S(R,h,y)}e.compareFileNamesUpper=T;function t(h,y){const R=A.value.collator;return h=h||"",y=y||"",a(h,y)||S(R,h,y)}e.compareFileNamesLower=t;function _(h,y){return h=h||"",y=y||"",h===y?0:h<y?-1:1}e.compareFileNamesUnicode=_;function n(h,y,R=!1){R||(h=h&&h.toLowerCase(),y=y&&y.toLowerCase());const[k,O]=o(h),[N,I]=o(y);return k!==N?k<N?-1:1:O===I?0:O<I?-1:1}e.noIntlCompareFileNames=n;function m(h,y){const[R,k]=o(h),[O,N]=o(y);let I=E.value.collator.compare(k,N);if(I===0){if(E.value.collatorIsNumeric&&k!==N)return k<N?-1:1;if(I=E.value.collator.compare(R,O),E.value.collatorIsNumeric&&I===0&&R!==O)return R<O?-1:1}return I}e.compareFileExtensions=m;function s(h,y){h=h||"",y=y||"";const R=f(h),k=f(y),O=A.value.collator,N=F.value.collator;return S(N,R,k)||S(O,h,y)}e.compareFileExtensionsDefault=s;function u(h,y){h=h||"",y=y||"";const R=f(h),k=f(y),O=A.value.collator,N=F.value.collator;return S(N,R,k)||r(h,y)||S(O,h,y)}e.compareFileExtensionsUpper=u;function p(h,y){h=h||"",y=y||"";const R=f(h),k=f(y),O=A.value.collator,N=F.value.collator;return S(N,R,k)||a(h,y)||S(O,h,y)}e.compareFileExtensionsLower=p;function C(h,y){h=h||"",y=y||"";const R=f(h).toLowerCase(),k=f(y).toLowerCase();return R!==k?R<k?-1:1:h!==y?h<y?-1:1:0}e.compareFileExtensionsUnicode=C;const w=/^(.*?)(\.([^.]*))?$/;function o(h,y=!1){const R=h?w.exec(h):[];let k=[R&&R[1]||"",R&&R[3]||""];return y&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function f(h){const y=h?w.exec(h):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function S(h,y,R){let k=h.compare(y,R);return k!==0?k:y.length!==R.length?y.length<R.length?-1:1:0}function i(h){const y=h.charAt(0);return y.toLocaleUpperCase()!==y}function g(h){const y=h.charAt(0);return y.toLocaleLowerCase()!==y}function a(h,y){return i(h)&&g(y)?-1:g(h)&&i(y)?1:0}function r(h,y){return g(h)&&i(y)?-1:i(h)&&g(y)?1:0}function v(h,y,R=!1){return R||(h=h&&h.toLowerCase(),y=y&&y.toLowerCase()),h===y?0:h<y?-1:1}function l(h,y,R=!1){const k=h.split(M.sep),O=y.split(M.sep),N=k.length-1,I=O.length-1;let B,x;for(let V=0;;V++){if(B=N===V,x=I===V,B&&x)return P(k[V],O[V],R);if(B)return-1;if(x)return 1;const H=v(k[V],O[V],R);if(H!==0)return H}}e.comparePaths=l;function c(h,y,R){const k=h.toLowerCase(),O=y.toLowerCase(),N=b(h,y,R);if(N)return N;const I=k.endsWith(R),B=O.endsWith(R);if(I!==B)return I?-1:1;const x=P(k,O);return x!==0?x:k.localeCompare(O)}e.compareAnything=c;function b(h,y,R){const k=h.toLowerCase(),O=y.toLowerCase(),N=k.startsWith(R),I=O.startsWith(R);if(N!==I)return N?-1:1;if(N&&I){if(k.length<O.length)return-1;if(k.length>O.length)return 1}return 0}e.compareByPrefix=b}),define(be[27],Ee([0,1,12,43,20,17,9]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const D="**",T="/",t="[/\\\\]",_="[^/\\\\]",n=/\//g;function m(q){switch(q){case 0:return"";case 1:return`${_}*?`;default:return`(?:${t}|${_}+${t}|${t}${_}+)*?`}}function s(q,Y){if(!q)return[];const j=[];let le=!1,re=!1,ve="";for(const Fe of q){switch(Fe){case Y:if(!le&&!re){j.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":re=!0;break;case"]":re=!1;break}ve+=Fe}return ve&&j.push(ve),j}e.splitGlobAware=s;function u(q){if(!q)return"";let Y="";const j=s(q,T);if(j.every(le=>le===D))Y=".*";else{let le=!1;j.forEach((re,ve)=>{if(re===D){le||(Y+=m(2),le=!0);return}let Fe=!1,Me="",Oe=!1,Ke="";for(const qe of re){if(qe!=="}"&&Fe){Me+=qe;continue}if(Oe&&(qe!=="]"||!Ke)){let Ve;qe==="-"?Ve=qe:(qe==="^"||qe==="!")&&!Ke?Ve="^":qe===T?Ve="":Ve=F.escapeRegExpCharacters(qe),Ke+=Ve;continue}switch(qe){case"{":Fe=!0;continue;case"[":Oe=!0;continue;case"}":Y+=`(?:${s(Me,",").map(Q=>u(Q)).join("|")})`,Fe=!1,Me="";break;case"]":Y+="["+Ke+"]",Oe=!1,Ke="";break;case"?":Y+=_;continue;case"*":Y+=m(1);continue;default:Y+=F.escapeRegExpCharacters(qe)}}ve<j.length-1&&(j[ve+1]!==D||ve+2<j.length)&&(Y+=t),le=!1})}return Y}const p=/^\*\*\/\*\.[\w\.-]+$/,C=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),g=function(){return!1},a=function(){return null};function r(q,Y){if(!q)return a;let j;typeof q!="string"?j=q.pattern:j=q,j=j.trim();const le=`${j}_${!!Y.trimForExclusions}`;let re=i.get(le);if(re)return v(re,q);let ve;if(p.test(j)){const Fe=j.substr(4);re=function(Me,Oe){return typeof Me=="string"&&Me.endsWith(Fe)?j:null}}else(ve=C.exec(l(j,Y)))?re=c(ve[1],j):(Y.trimForExclusions?o:w).test(j)?re=b(j,Y):(ve=f.exec(l(j,Y)))?re=h(ve[1].substr(1),j,!0):(ve=S.exec(l(j,Y)))?re=h(ve[1],j,!1):re=y(j);return i.set(le,re),v(re,q)}function v(q,Y){return typeof Y=="string"?q:function(j,le){return M.isEqualOrParent(j,Y.base)?q(A.relative(Y.base,j),le):null}}function l(q,Y){return Y.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function c(q,Y){const j=`/${q}`,le=`\\${q}`,re=function(Fe,Me){return typeof Fe!="string"?null:Me?Me===q?Y:null:Fe===q||Fe.endsWith(j)||Fe.endsWith(le)?Y:null},ve=[q];return re.basenames=ve,re.patterns=[Y],re.allBasenames=ve,re}function b(q,Y){const j=ee(q.slice(1,-1).split(",").map(Me=>r(Me,Y)).filter(Me=>Me!==a),q),le=j.length;if(!le)return a;if(le===1)return j[0];const re=function(Me,Oe){for(let Ke=0,qe=j.length;Ke<qe;Ke++)if(j[Ke](Me,Oe))return q;return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(re.allBasenames=ve.allBasenames);const Fe=j.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Fe.length&&(re.allPaths=Fe),re}function h(q,Y,j){const le=A.sep===A.posix.sep,re=le?q:q.replace(n,A.sep),ve=A.sep+re,Fe=A.posix.sep+q,Me=j?function(Oe,Ke){return typeof Oe=="string"&&(Oe===re||Oe.endsWith(ve)||!le&&(Oe===q||Oe.endsWith(Fe)))?Y:null}:function(Oe,Ke){return typeof Oe=="string"&&(Oe===re||!le&&Oe===q)?Y:null};return Me.allPaths=[(j?"*/":"./")+q],Me}function y(q){try{const Y=new RegExp(`^${u(q)}$`);return function(j){return Y.lastIndex=0,typeof j=="string"&&Y.test(j)?q:null}}catch(Y){return a}}function R(q,Y,j){return!q||typeof Y!="string"?!1:k(q)(Y,void 0,j)}e.match=R;function k(q,Y={}){if(!q)return g;if(typeof q=="string"||B(q)){const j=r(q,Y);if(j===a)return g;const le=function(re,ve){return!!j(re,ve)};return j.allBasenames&&(le.allBasenames=j.allBasenames),j.allPaths&&(le.allPaths=j.allPaths),le}return H(q,Y)}e.parse=k;function O(q){if(!q)return;let Y;return j=>(Y||(Y=(q()||Promise.resolve([])).then(le=>le?I(le):{})),Y.then(le=>!!le[j]))}e.hasSiblingPromiseFn=O;function N(q){if(!q)return;let Y;return j=>{if(!Y){const le=q();Y=le?I(le):{}}return!!Y[j]}}e.hasSiblingFn=N;function I(q){const Y={};for(const j of q)Y[j]=!0;return Y}function B(q){const Y=q;return Y&&typeof Y.base=="string"&&typeof Y.pattern=="string"}e.isRelativePattern=B;function x(q){return q.allBasenames||[]}e.getBasenameTerms=x;function V(q){return q.allPaths||[]}e.getPathTerms=V;function H(q,Y){const j=ee(Object.getOwnPropertyNames(q).map(Me=>W(Me,q[Me],Y)).filter(Me=>Me!==a)),le=j.length;if(!le)return a;if(!j.some(Me=>!!Me.requiresSiblings)){if(le===1)return j[0];const Me=function(qe,Ve){for(let $=0,Q=j.length;$<Q;$++){const te=j[$](qe,Ve);if(te)return te}return null},Oe=j.find(qe=>!!qe.allBasenames);Oe&&(Me.allBasenames=Oe.allBasenames);const Ke=j.reduce((qe,Ve)=>Ve.allPaths?qe.concat(Ve.allPaths):qe,[]);return Ke.length&&(Me.allPaths=Ke),Me}const re=function(Me,Oe,Ke){let qe;for(let Ve=0,$=j.length;Ve<$;Ve++){const Q=j[Ve];Q.requiresSiblings&&Ke&&(Oe||(Oe=A.basename(Me)),qe||(qe=Oe.substr(0,Oe.length-A.extname(Me).length)));const te=Q(Me,Oe,qe,Ke);if(te)return te}return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(re.allBasenames=ve.allBasenames);const Fe=j.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Fe.length&&(re.allPaths=Fe),re}function W(q,Y,j){if(Y===!1)return a;const le=r(q,j);if(le===a)return a;if(typeof Y=="boolean")return le;if(Y){const re=Y.when;if(typeof re=="string"){const ve=(Fe,Me,Oe,Ke)=>{if(!Ke||!le(Fe,Me))return null;const qe=re.replace("$(basename)",Oe),Ve=Ke(qe);return(0,d.isThenable)(Ve)?Ve.then($=>$?q:null):Ve?q:null};return ve.requiresSiblings=!0,ve}}return le}function ee(q,Y){const j=q.filter(Me=>!!Me.basenames);if(j.length<2)return q;const le=j.reduce((Me,Oe)=>{const Ke=Oe.basenames;return Ke?Me.concat(Ke):Me},[]);let re;if(Y){re=[];for(let Me=0,Oe=le.length;Me<Oe;Me++)re.push(Y)}else re=j.reduce((Me,Oe)=>{const Ke=Oe.patterns;return Ke?Me.concat(Ke):Me},[]);const ve=function(Me,Oe){if(typeof Me!="string")return null;if(!Oe){let qe;for(qe=Me.length;qe>0;qe--){const Ve=Me.charCodeAt(qe-1);if(Ve===47||Ve===92)break}Oe=Me.substr(qe)}const Ke=le.indexOf(Oe);return Ke!==-1?re[Ke]:null};ve.basenames=le,ve.patterns=re,ve.allBasenames=le;const Fe=q.filter(Me=>!Me.basenames);return Fe.push(ve),Fe}}),define(be[78],Ee([0,1,43,11,17,25,24,9,2]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(r,v,l){if(typeof r=="string"&&(r=D.URI.file(r)),l){const b=l.getWorkspaceFolder(r);if(b){const h=l.getWorkspace().folders.length>1;let y;if((0,F.isEqual)(b.uri,r)?y="":y=(0,F.relativePath)(b.uri,r),h){const R=b.name?b.name:(0,F.basename)(b.uri);y=y?R+" \u2022 "+y:R}return y}}if(r.scheme!==M.Schemas.file&&r.scheme!==M.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(r.fsPath))return(0,E.normalize)(_(r.fsPath));let c=(0,E.normalize)(r.fsPath);return!A.isWindows&&v?.userHome&&(c=m(c,v.userHome.fsPath)),c}e.getPathLabel=T;function t(r){if(!r)return;typeof r=="string"&&(r=D.URI.file(r));const v=(0,F.basename)(r)||(r.scheme===M.Schemas.file?r.fsPath:r.path);return A.isWindows&&(0,d.isRootOrDriveLetter)(v)?_(v):v}e.getBaseLabel=t;function _(r){return(0,d.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=_;let n=Object.create(null);function m(r,v){if(A.isWindows||!r||!v)return r;let l=n.original===v?n.normalized:void 0;return l||(l=`${(0,P.rtrim)(v,E.posix.sep)}${E.posix.sep}`,n={original:v,normalized:l}),(A.isLinux?r.startsWith(l):(0,P.startsWithIgnoreCase)(r,l))&&(r=`~/${r.substr(l.length)}`),r}e.tildify=m;function s(r,v){return r.replace(/^~($|\/|\\)/,`${v}$1`)}e.untildify=s;const u="\u2026",p="\\\\",C="~";function w(r,v=E.sep){const l=new Array(r.length);let c=!1;for(let b=0;b<r.length;b++){let h=r[b];if(h===""){l[b]=`.${v}`;continue}if(!h){l[b]=h;continue}c=!0;let y="";h.indexOf(p)===0?(y=h.substr(0,h.indexOf(p)+p.length),h=h.substr(h.indexOf(p)+p.length)):h.indexOf(v)===0?(y=h.substr(0,h.indexOf(v)+v.length),h=h.substr(h.indexOf(v)+v.length)):h.indexOf(C)===0&&(y=h.substr(0,h.indexOf(C)+C.length),h=h.substr(h.indexOf(C)+C.length));const R=h.split(v);for(let k=1;c&&k<=R.length;k++)for(let O=R.length-k;c&&O>=0;O--){c=!1;let N=R.slice(O,O+k).join(v);for(let I=0;!c&&I<r.length;I++)if(I!==b&&r[I]&&r[I].indexOf(N)>-1){const B=O+k===R.length,x=O>0&&r[I].indexOf(v)>-1?v+N:N,V=r[I].endsWith(x);c=!B||V}if(!c){let I="";(R[0].endsWith(":")||y!=="")&&(O===1&&(O=0,k++,N=R[0]+v+N),O>0&&(I=R[0]+v),I=y+I),O>0&&(I=I+u+v),I=I+N,O+k<R.length&&(I=I+v+u),l[b]=I}}c&&(l[b]=h)}return l}e.shorten=w;var o;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function f(r,v=Object.create(null)){const l=[];let c=!1,b="";for(const h of r)if(h==="$"||c&&h==="{")b&&l.push({value:b,type:o.TEXT}),b="",c=!0;else if(h==="}"&&c){const y=v[b];if(typeof y=="string")y.length&&l.push({value:y,type:o.VARIABLE});else if(y){const R=l[l.length-1];(!R||R.type!==o.SEPARATOR)&&l.push({value:y.label,type:o.SEPARATOR})}b="",c=!1}else b+=h;return b&&!c&&l.push({value:b,type:o.TEXT}),l.filter((h,y)=>{if(h.type===o.SEPARATOR){const R=l[y-1],k=l[y+1];return[R,k].every(O=>O&&(O.type===o.VARIABLE||O.type===o.TEXT)&&O.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=f;function S(r,v){return A.isMacintosh||v?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function i(r,v){return A.isMacintosh||v?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,l=>l==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function g(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=g;function a(r){const v=r.indexOf("/")!==-1?E.posix:E.win32,l=v.basename(r),c=v.dirname(r);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=a}),define(be[79],Ee([0,1,27,11,17,24,9]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown",r.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let D=[],T=[],t=[];function _(r,v=!1){const l=n(r);D.push(l),l.userConfigured?t.push(l):T.push(l),v&&!l.userConfigured&&D.forEach(c=>{c.mime===l.mime||c.userConfigured||(l.extension&&c.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&c.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&c.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&c.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=_;function n(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,d.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(E.posix.sep)>=0:!1}}function m(r){r?(D=D.filter(v=>!v.userConfigured),t=[]):(D=[],T=[],t=[])}e.clearTextMimes=m;function s(r,v){let l;if(r)switch(r.scheme){case M.Schemas.file:l=r.fsPath;break;case M.Schemas.data:l=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[P.unknown];l=l.toLowerCase();const c=(0,E.basename)(l),b=u(l,c,t);if(b)return[b,P.text];const h=u(l,c,T);if(h)return[h,P.text];if(v){const y=p(v);if(y)return[y,P.text]}return[P.unknown]}e.guessMimeTypes=s;function u(r,v,l){let c=null,b=null,h=null;for(let y=l.length-1;y>=0;y--){const R=l[y];if(v===R.filenameLowercase){c=R;break}if(R.filepattern&&(!b||R.filepattern.length>b.filepattern.length)){const k=R.filepatternOnPath?r:v;R.filepatternLowercase?.(k)&&(b=R)}R.extension&&(!h||R.extension.length>h.extension.length)&&v.endsWith(R.extensionLowercase)&&(h=R)}return c?c.mime:b?b.mime:h?h.mime:null}function p(r){if((0,F.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let v=D.length-1;v>=0;v--){const l=D[v];if(!l.firstline)continue;const c=r.match(l.firstline);if(c&&c.length>0)return l.mime}return null}function C(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&C(r[0]):!0}e.isUnspecific=C;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(r){const v=(0,E.extname)(r),l=w[v.toLowerCase()];return l!==void 0?l:S(r)}e.getMediaOrTextMime=f;function S(r){const v=(0,E.extname)(r);return o[v.toLowerCase()]}e.getMediaMime=S;function i(r){for(const v in o)if(o[v]===r)return v}e.getExtensionForMimeType=i;const g=/^(.+)\/(.+?)(;.+)?$/;function a(r,v){const l=g.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:v?void 0:r}e.normalizeMimeType=a}),define(be[108],Ee([0,1,2]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:M(d.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:M(d.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:d.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,_,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof d.URI)return _.transformOutgoing(t);for(let m in t)if(Object.hasOwnProperty.call(t,m)){const s=A(t[m],_,n+1);s!==null&&(t[m]=s)}}return null}function F(t,_){const n=A(t,_,0);return n===null?t:n}e.transformOutgoingURIs=F;function P(t,_,n,m){if(!t||m>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?d.URI.revive(_.transformIncoming(t)):_.transformIncoming(t);for(let s in t)if(Object.hasOwnProperty.call(t,s)){const u=P(t[s],_,n,m+1);u!==null&&(t[s]=u)}}return null}function D(t,_){const n=P(t,_,!1,0);return n===null?t:n}e.transformIncomingURIs=D;function T(t,_){const n=P(t,_,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=T}),define(be[36],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(D){return d.test(D)}e.isUUID=M;const E=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(D){for(let T=0;T<D.length;T++)D[T]=Math.floor(Math.random()*256);return D};function P(){F(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let D=0,T="";return T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T+="-",T+=A[E[D++]],T+=A[E[D++]],T+="-",T+=A[E[D++]],T+=A[E[D++]],T+="-",T+=A[E[D++]],T+=A[E[D++]],T+="-",T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T}e.generateUuid=P}),define(be[109],Ee([0,1,227]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends d.CharacterClassifier{constructor(P){super(0);for(let D=0,T=P.length;D<T;D++)this.set(P.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function A(F){let P={};return D=>(P.hasOwnProperty(D)||(P[D]=F(D)),P[D])}e.getMapForWordSeparators=A(F=>new E(F))}),define(be[80],Ee([0,1,23]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var P;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(P=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class T{constructor(o,f){this._findMatchBrand=void 0,this.range=o,this.matches=f}}e.FindMatch=T;var t;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(w){w[w.Disabled=0]="Disabled",w[w.EnabledForActive=1]="EnabledForActive",w[w.Enabled=2]="Enabled"})(_=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class n{constructor(o,f,S){this.visibleColumn=o,this.className=f,this.horizontalLine=S}}e.IndentGuide=n;class m{constructor(o,f){this.top=o,this.endColumn=f}}e.IndentGuideHorizontalLine=m;var s;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None"})(s=e.PositionAffinity||(e.PositionAffinity={}));var u;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u=e.ModelConstants||(e.ModelConstants={}));class p{constructor(o,f,S,i,g,a){this.identifier=o,this.range=f,this.text=S,this.forceMoveMarkers=i,this.isAutoWhitespaceEdit=g,this._isTracked=a}}e.ValidAnnotatedEditOperation=p;class C{constructor(o,f,S){this.reverseEdits=o,this.changes=f,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=C}),define(be[110],Ee([0,1,9,109,111,44,80]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class D{constructor(o,f,S,i){this.searchString=o,this.isRegex=f,this.matchCase=S,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=T(this.searchString):o=this.searchString.indexOf(`
`)>=0;let f=null;try{f=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(i){return null}if(!f)return null;let S=!this.isRegex&&!o;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new t(f,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}e.SearchParams=D;function T(w){if(!w||w.length===0)return!1;for(let o=0,f=w.length;o<f;o++)if(w.charCodeAt(o)===92){if(o++,o>=f)break;const i=w.charCodeAt(o);if(i===110||i===114||i===87)return!0}return!1}e.isMultilineRegexSource=T;class t{constructor(o,f,S){this.regex=o,this.wordSeparators=f,this.simpleSearch=S}}e.SearchData=t;function _(w,o,f){if(!f)return new F.FindMatch(w,null);let S=[];for(let i=0,g=o.length;i<g;i++)S[i]=o[i];return new F.FindMatch(w,S)}e.createFindMatch=_;class n{constructor(o){let f=[],S=0;for(let i=0,g=o.length;i<g;i++)o.charCodeAt(i)===10&&(f[S++]=i);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(o){const f=this._lineFeedsOffsets;let S=0,i=f.length-1;if(i===-1||o<=f[0])return 0;for(;S<i;){const g=S+((i-S)/2>>0);f[g]>=o?i=g-1:f[g+1]>=o?(S=g,i=g):S=g+1}return S+1}}class m{static findMatches(o,f,S,i,g){const a=f.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(o,S,new C(a.wordSeparators,a.regex),i,g):this._doFindMatchesLineByLine(o,S,a,i,g):[]}static _getMultilineMatchRange(o,f,S,i,g,a){let r,v=0;i?(v=i.findLineFeedCountBeforeOffset(g),r=f+g+v):r=f+g;let l;if(i){let y=i.findLineFeedCountBeforeOffset(g+a.length)-v;l=r+a.length+y}else l=r+a.length;const c=o.getPositionAt(r),b=o.getPositionAt(l);return new A.Range(c.lineNumber,c.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(o,f,S,i,g){const a=o.getOffsetAt(f.getStartPosition()),r=o.getValueInRange(f,1),v=o.getEOL()===`\r
`?new n(r):null,l=[];let c=0,b;for(S.reset(0);b=S.next(r);)if(l[c++]=_(this._getMultilineMatchRange(o,a,r,v,b.index,b[0]),b,i),c>=g)return l;return l}static _doFindMatchesLineByLine(o,f,S,i,g){const a=[];let r=0;if(f.startLineNumber===f.endLineNumber){const l=o.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(S,l,f.startLineNumber,f.startColumn-1,r,a,i,g),a}const v=o.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(S,v,f.startLineNumber,f.startColumn-1,r,a,i,g);for(let l=f.startLineNumber+1;l<f.endLineNumber&&r<g;l++)r=this._findMatchesInLine(S,o.getLineContent(l),l,0,r,a,i,g);if(r<g){const l=o.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(S,l,f.endLineNumber,0,r,a,i,g)}return a}static _findMatchesInLine(o,f,S,i,g,a,r,v){const l=o.wordSeparators;if(!r&&o.simpleSearch){const h=o.simpleSearch,y=h.length,R=f.length;let k=-y;for(;(k=f.indexOf(h,k+y))!==-1;)if((!l||p(l,f,R,k,y))&&(a[g++]=new F.FindMatch(new A.Range(S,k+1+i,S,k+1+y+i),null),g>=v))return g;return g}const c=new C(o.wordSeparators,o.regex);let b;c.reset(0);do if(b=c.next(f),b&&(a[g++]=_(new A.Range(S,b.index+1+i,S,b.index+1+b[0].length+i),b,r),g>=v))return g;while(b);return g}static findNextMatch(o,f,S,i){const g=f.parseSearchRequest();if(!g)return null;const a=new C(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindNextMatchMultiline(o,S,a,i):this._doFindNextMatchLineByLine(o,S,a,i)}static _doFindNextMatchMultiline(o,f,S,i){const g=new E.Position(f.lineNumber,1),a=o.getOffsetAt(g),r=o.getLineCount(),v=o.getValueInRange(new A.Range(g.lineNumber,g.column,r,o.getLineMaxColumn(r)),1),l=o.getEOL()===`\r
`?new n(v):null;S.reset(f.column-1);let c=S.next(v);return c?_(this._getMultilineMatchRange(o,a,v,l,c.index,c[0]),c,i):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(o,new E.Position(1,1),S,i):null}static _doFindNextMatchLineByLine(o,f,S,i){const g=o.getLineCount(),a=f.lineNumber,r=o.getLineContent(a),v=this._findFirstMatchInLine(S,r,a,f.column,i);if(v)return v;for(let l=1;l<=g;l++){const c=(a+l-1)%g,b=o.getLineContent(c+1),h=this._findFirstMatchInLine(S,b,c+1,1,i);if(h)return h}return null}static _findFirstMatchInLine(o,f,S,i,g){o.reset(i-1);const a=o.next(f);return a?_(new A.Range(S,a.index+1,S,a.index+1+a[0].length),a,g):null}static findPreviousMatch(o,f,S,i){const g=f.parseSearchRequest();if(!g)return null;const a=new C(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindPreviousMatchMultiline(o,S,a,i):this._doFindPreviousMatchLineByLine(o,S,a,i)}static _doFindPreviousMatchMultiline(o,f,S,i){const g=this._doFindMatchesMultiline(o,new A.Range(1,1,f.lineNumber,f.column),S,i,10*P);if(g.length>0)return g[g.length-1];const a=o.getLineCount();return f.lineNumber!==a||f.column!==o.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(o,new E.Position(a,o.getLineMaxColumn(a)),S,i):null}static _doFindPreviousMatchLineByLine(o,f,S,i){const g=o.getLineCount(),a=f.lineNumber,r=o.getLineContent(a).substring(0,f.column-1),v=this._findLastMatchInLine(S,r,a,i);if(v)return v;for(let l=1;l<=g;l++){const c=(g+a-l-1)%g,b=o.getLineContent(c+1),h=this._findLastMatchInLine(S,b,c+1,i);if(h)return h}return null}static _findLastMatchInLine(o,f,S,i){let g=null,a;for(o.reset(0);a=o.next(f);)g=_(new A.Range(S,a.index+1,S,a.index+1+a[0].length),a,i);return g}}e.TextModelSearch=m;function s(w,o,f,S,i){if(S===0)return!0;const g=o.charCodeAt(S-1);if(w.get(g)!==0||g===13||g===10)return!0;if(i>0){const a=o.charCodeAt(S);if(w.get(a)!==0)return!0}return!1}function u(w,o,f,S,i){if(S+i===f)return!0;const g=o.charCodeAt(S+i);if(w.get(g)!==0||g===13||g===10)return!0;if(i>0){const a=o.charCodeAt(S+i-1);if(w.get(a)!==0)return!0}return!1}function p(w,o,f,S,i){return s(w,o,f,S,i)&&u(w,o,f,S,i)}e.isValidMatch=p;class C{constructor(o,f){this._wordSeparators=o,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const f=o.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(S=this._searchRegex.exec(o),!S))return null;const i=S.index,g=S[0].length;if(i===this._prevMatchStartIndex&&g===this._prevMatchLength){if(g===0){d.getNextCodePoint(o,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=g,!this._wordSeparators||p(this._wordSeparators,o,f,i,g))return S}while(S);return null}}e.Searcher=C}),define(be[112],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class M{constructor(P){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let D=0,T=P.notIn.length;D<T;D++)switch(P.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of P)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=E;function A(F,P,D){F.has(P)?F.get(P).push(D):F.set(P,[D])}}),define(be[56],Ee([0,1,27,17]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,F,P,D){if(Array.isArray(A)){let T=0;for(const t of A){const _=E(t,F,P,D);if(_===10)return _;_>T&&(T=_)}return T}else{if(typeof A=="string")return D?A==="*"?5:A===P?10:0:0;if(A){const{language:T,pattern:t,scheme:_,hasAccessToAllModels:n}=A;if(!D&&!n)return 0;let m=0;if(_)if(_===F.scheme)m=10;else if(_==="*")m=5;else return 0;if(T)if(T===P)m=10;else if(T==="*")m=Math.max(m,5);else return 0;if(t){let s;if(typeof t=="string"?s=t:s={...t,base:(0,M.normalize)(t.base)},s===F.fsPath||(0,d.match)(s,F.fsPath))m=10;else return 0}return m}else return 0}}e.score=E}),define(be[113],Ee([0,1,3,6]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,P){return this._map.set(F,P),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===P&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,P){let D=null,T=!1;return this._promises.set(F,P.then(t=>{this._promises.delete(F),!(T||!t)&&(D=this.register(F,t))})),(0,M.toDisposable)(()=>{T=!0,D&&D.dispose()})}getPromise(F){const P=this.get(F);if(P)return Promise.resolve(P);const D=this._promises.get(F);return D?D.then(T=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(be[81],Ee([0,1,22,25]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(E||(E={}));function A(_){for(let n=0,m=_.length;n<m;n+=4){const s=_[n+0],u=_[n+1],p=_[n+2],C=_[n+3];_[n+0]=C,_[n+1]=p,_[n+2]=u,_[n+3]=s}}function F(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return M.isLittleEndian()||A(n),d.VSBuffer.wrap(n)}function P(_){const n=_.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const m=new Uint8Array(n.byteLength);return m.set(n),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function D(_){const n=new Uint32Array(T(_));let m=0;if(n[m++]=_.id,_.type==="full")n[m++]=1,n[m++]=_.data.length,n.set(_.data,m),m+=_.data.length;else{n[m++]=2,n[m++]=_.deltas.length;for(const s of _.deltas)n[m++]=s.start,n[m++]=s.deleteCount,s.data?(n[m++]=s.data.length,n.set(s.data,m),m+=s.data.length):n[m++]=0}return F(n)}e.encodeSemanticTokensDto=D;function T(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const m of _.deltas)m.data&&(n+=m.data.length)}return n}function t(_){const n=P(_);let m=0;const s=n[m++];if(n[m++]===1){const w=n[m++],o=n.subarray(m,m+w);return m+=w,{id:s,type:"full",data:o}}const p=n[m++];let C=[];for(let w=0;w<p;w++){const o=n[m++],f=n[m++],S=n[m++];let i;S>0&&(i=n.subarray(m,m+S),m+=S),C[w]={start:o,deleteCount:f,data:i}}return{id:s,type:"delta",deltas:C}}e.decodeSemanticTokensDto=t}),define(be[114],Ee([18,19]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(be[45],Ee([0,1,14,10,114]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,t){return t&&(T.stack||T.stacktrace)?E.localize(0,null,P(T),F(T.stack)||F(T.stacktrace)):P(T)}function F(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?E.localize(1,null,T.message):T.message||E.localize(2,null)}function D(T=null,t=!1){if(!T)return E.localize(3,null);if(Array.isArray(T)){const _=d.coalesce(T),n=D(_[0],t);return _.length>1?E.localize(4,null,n,_.length):n}if(M.isString(T))return T;if(T.detail){const _=T.detail;if(_.error)return A(_.error,t);if(_.exception)return A(_.exception,t)}return T.stack?A(T,t):T.message?T.message:E.localize(5,null)}e.toErrorMessage=D}),define(be[115],Ee([18,19]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(be[116],Ee([0,1,115,25,117]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=F;class P{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,pe){this._values[Z]=pe}}e.ValidatedEditorOptions=P;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class T{constructor(Z,pe,We,Ye){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ye}compute(Z,pe,We){return We}}class t{constructor(Z,pe=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(Z){return this.defaultValue}}class _{constructor(Z,pe,We,Ye){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ye}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,pe,We){return We}}function n(G,Z){return typeof G=="undefined"?Z:G==="false"?!1:Boolean(G)}e.boolean=n;class m extends _{constructor(Z,pe,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=We),super(Z,pe,We,Ye)}validate(Z){return n(Z,this.defaultValue)}}function s(G,Z,pe,We){if(typeof G=="undefined")return Z;let Ye=parseInt(G,10);return isNaN(Ye)?Z:(Ye=Math.max(pe,Ye),Ye=Math.min(We,Ye),Ye|0)}e.clampedInt=s;class u extends _{constructor(Z,pe,We,Ye,rt,mt=void 0){typeof mt!="undefined"&&(mt.type="integer",mt.default=We,mt.minimum=Ye,mt.maximum=rt),super(Z,pe,We,mt),this.minimum=Ye,this.maximum=rt}static clampedInt(Z,pe,We,Ye){return s(Z,pe,We,Ye)}validate(Z){return u.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class p extends _{constructor(Z,pe,We,Ye,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=We),super(Z,pe,We,rt),this.validationFn=Ye}static clamp(Z,pe,We){return Z<pe?pe:Z>We?We:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return pe;const We=parseFloat(Z);return isNaN(We)?pe:We}validate(Z){return this.validationFn(p.float(Z,this.defaultValue))}}class C extends _{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=We),super(Z,pe,We,Ye)}validate(Z){return C.string(Z,this.defaultValue)}}function w(G,Z,pe){return typeof G!="string"||pe.indexOf(G)===-1?Z:G}e.stringSet=w;class o extends _{constructor(Z,pe,We,Ye,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Ye,rt.default=We),super(Z,pe,We,rt),this._allowedValues=Ye}validate(Z){return w(Z,this.defaultValue,this._allowedValues)}}class f extends T{constructor(Z,pe,We,Ye,rt,mt,ut=void 0){typeof ut!="undefined"&&(ut.type="string",ut.enum=rt,ut.default=Ye),super(Z,pe,We,ut),this._allowedValues=rt,this._convert=mt}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function S(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,We){return We===0?Z.accessibilitySupport:We}}class g extends T{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:d.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:n(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(G){switch(G){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function c(G){switch(G){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class b extends t{constructor(){super(126,[65,33])}compute(Z,pe,We){const Ye=["monaco-editor"];return pe.get(33)&&Ye.push(pe.get(33)),Z.extraEditorClassName&&Ye.push(Z.extraEditorClassName),pe.get(65)==="default"?Ye.push("mouse-default"):pe.get(65)==="copy"&&Ye.push("mouse-copy"),pe.get(99)&&Ye.push("showUnused"),pe.get(124)&&Ye.push("showDeprecated"),Ye.join(" ")}}class h extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(Z,pe,We){return We&&Z.emptySelectionClipboard}}class y extends T{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:d.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:d.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:n(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":w(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":w(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(pe.loop,this.defaultValue.loop)}}}class R extends T{constructor(){super(44,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?R.OFF:Z==="true"?R.ON:Z:Boolean(Z)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class k extends t{constructor(){super(43)}compute(Z,pe,We){return Z.fontInfo}}class O extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(Z){let pe=p.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(pe,6,100)}compute(Z,pe,We){return Z.fontInfo.fontSize}}class N extends T{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:N.MINIMUM_VALUE,maximum:N.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:N.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(u.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,N.MINIMUM_VALUE,N.MAXIMUM_VALUE))}}N.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],N.MINIMUM_VALUE=1,N.MAXIMUM_VALUE=1e3;class I extends T{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:We,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:We,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:We,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:We,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:We,description:d.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:w(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??w(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??w(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??w(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??w(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??w(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:C.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:C.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:C.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:C.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:C.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class B extends T{constructor(){const Z={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:d.localize(41,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:d.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),delay:u.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:n(pe.sticky,this.defaultValue.sticky),above:n(pe.above,this.defaultValue.above)}}}var x;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class V extends t{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(Z,pe,We){return V.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,We=Z.scrollBeyondLastLine?pe-1:0,Ye=(Z.viewLineCount+We)/(Z.pixelRatio*Z.height),rt=Math.floor(Z.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:We,desiredRatio:Ye,minimapLineCount:rt}}static _computeMinimapLayout(Z,pe){const We=Z.outerWidth,Ye=Z.outerHeight,rt=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const mt=pe.stableMinimapLayoutInput,ut=mt&&Z.outerHeight===mt.outerHeight&&Z.lineHeight===mt.lineHeight&&Z.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===mt.pixelRatio&&Z.scrollBeyondLastLine===mt.scrollBeyondLastLine&&Z.minimap.enabled===mt.minimap.enabled&&Z.minimap.side===mt.minimap.side&&Z.minimap.size===mt.minimap.size&&Z.minimap.showSlider===mt.minimap.showSlider&&Z.minimap.renderCharacters===mt.minimap.renderCharacters&&Z.minimap.maxColumn===mt.minimap.maxColumn&&Z.minimap.scale===mt.minimap.scale&&Z.verticalScrollbarWidth===mt.verticalScrollbarWidth&&Z.isViewportWrapping===mt.isViewportWrapping,St=Z.lineHeight,Tt=Z.typicalHalfwidthCharacterWidth,It=Z.scrollBeyondLastLine,Xe=Z.minimap.renderCharacters;let vt=rt>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Pe=Z.minimap.maxColumn,Se=Z.minimap.size,Ce=Z.minimap.side,ie=Z.verticalScrollbarWidth,ue=Z.viewLineCount,me=Z.remainingWidth,fe=Z.isViewportWrapping,Ie=Xe?2:3;let Be=Math.floor(rt*Ye);const Ne=Be/rt;let je=!1,it=!1,Le=Ie*vt,de=vt/rt,ge=1;if(Se==="fill"||Se==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:pt,desiredRatio:dt,minimapLineCount:ht}=V.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:It,height:Ye,lineHeight:St,pixelRatio:rt});if(ue/ht>1)je=!0,it=!0,vt=1,Le=1,de=vt/rt;else{let _t=!1,yt=vt+1;if(Se==="fit"){const Pt=Math.ceil((ue+pt)*Le);fe&&ut&&me<=pe.stableFitRemainingWidth?(_t=!0,yt=pe.stableFitMaxMinimapScale):_t=Pt>Be}if(Se==="fill"||_t){je=!0;const Pt=vt;Le=Math.min(St*rt,Math.max(1,Math.floor(1/dt))),fe&&ut&&me<=pe.stableFitRemainingWidth&&(yt=pe.stableFitMaxMinimapScale),vt=Math.min(yt,Math.max(1,Math.floor(Le/Ie))),vt>Pt&&(ge=Math.min(2,vt/Pt)),de=vt/rt/ge,Be=Math.ceil(Math.max(ct,ue+pt)*Le),fe?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=me,pe.stableFitMaxMinimapScale=vt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const X=Math.floor(Pe*de),z=Math.min(X,Math.max(0,Math.floor((me-ie-2)*de/(Tt+de)))+e.MINIMAP_GUTTER_WIDTH);let we=Math.floor(rt*z);const ke=we/rt;we=Math.floor(we*ge);const Je=Xe?1:2,xe=Ce==="left"?0:We-z-ie;return{renderMinimap:Je,minimapLeft:xe,minimapWidth:z,minimapHeightIsEditorHeight:je,minimapIsSampling:it,minimapScale:vt,minimapLineHeight:Le,minimapCanvasInnerWidth:we,minimapCanvasInnerHeight:Be,minimapCanvasOuterWidth:ke,minimapCanvasOuterHeight:Ne}}static computeLayout(Z,pe){const We=pe.outerWidth|0,Ye=pe.outerHeight|0,rt=pe.lineHeight|0,mt=pe.lineNumbersDigitCount|0,ut=pe.typicalHalfwidthCharacterWidth,St=pe.maxDigitWidth,Tt=pe.pixelRatio,It=pe.viewLineCount,Xe=Z.get(121),vt=Xe==="inherit"?Z.get(120):Xe,Pe=vt==="inherit"?Z.get(116):vt,Se=Z.get(119),Ce=Z.get(2),ie=pe.isDominatedByLongLines,ue=Z.get(49),me=Z.get(59).renderType!==0,fe=Z.get(60),Ie=Z.get(93),Be=Z.get(64),Ne=Z.get(91),je=Ne.verticalScrollbarSize,it=Ne.verticalHasArrows,Le=Ne.arrowSize,de=Ne.horizontalScrollbarSize,ge=Z.get(57),X=Z.get(37);let z;if(typeof ge=="string"&&/^\d+(\.\d+)?ch$/.test(ge)){const xt=parseFloat(ge.substr(0,ge.length-2));z=u.clampedInt(xt*ut,0,0,1e3)}else z=u.clampedInt(ge,0,0,1e3);X&&(z+=16);let we=0;if(me){const xt=Math.max(mt,fe);we=Math.round(xt*St)}let ke=0;ue&&(ke=rt);let Je=0,xe=Je+ke,ct=xe+we,pt=ct+z;const dt=We-ke-we-z;let ht=!1,ft=!1,_t=-1;Ce!==2&&(vt==="inherit"&&ie?(ht=!0,ft=!0):Pe==="on"||Pe==="bounded"?ft=!0:Pe==="wordWrapColumn"&&(_t=Se));const yt=V._computeMinimapLayout({outerWidth:We,outerHeight:Ye,lineHeight:rt,typicalHalfwidthCharacterWidth:ut,pixelRatio:Tt,scrollBeyondLastLine:Ie,minimap:Be,verticalScrollbarWidth:je,viewLineCount:It,remainingWidth:dt,isViewportWrapping:ft},pe.memory||new D);yt.renderMinimap!==0&&yt.minimapLeft===0&&(Je+=yt.minimapWidth,xe+=yt.minimapWidth,ct+=yt.minimapWidth,pt+=yt.minimapWidth);const Pt=dt-yt.minimapWidth,Nt=Math.max(1,Math.floor((Pt-je-2)/ut)),Ct=it?Le:0;return ft&&(_t=Math.max(1,Nt),Pe==="bounded"&&(_t=Math.min(_t,Se))),{width:We,height:Ye,glyphMarginLeft:Je,glyphMarginWidth:ke,lineNumbersLeft:xe,lineNumbersWidth:we,decorationsLeft:ct,decorationsWidth:z,contentLeft:pt,contentWidth:Pt,minimap:yt,viewportColumn:Nt,isWordWrapMinified:ht,isViewportWrapping:ft,wrappingColumn:_t,verticalScrollbarWidth:je,horizontalScrollbarHeight:de,overviewRuler:{top:Ct,width:je,height:Ye-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=V;class H extends T{constructor(){const Z={enabled:!0};super(56,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:d.localize(43,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:n(Z.enabled,this.defaultValue.enabled)}}}class W extends T{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:d.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:d.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:d.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:C.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class ee extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>p.clamp(Z,0,150),{markdownDescription:d.localize(47,null)})}compute(Z,pe,We){return Z.fontInfo.lineHeight}}class q extends T{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:d.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(49,null),d.localize(50,null),d.localize(51,null)],default:Z.size,description:d.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:d.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:d.localize(54,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:d.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:d.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),size:w(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(pe.side,this.defaultValue.side,["right","left"]),showSlider:w(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(pe.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(pe.scale,1,1,3),maxColumn:u.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(G){return G==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(59,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:u.clampedInt(pe.top,0,0,1e3),bottom:u.clampedInt(pe.bottom,0,0,1e3)}}}class le extends T{constructor(){const Z={enabled:!0,cycle:!1};super(75,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:d.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:d.localize(61,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),cycle:n(pe.cycle,this.defaultValue.cycle)}}}class re extends t{constructor(){super(127)}compute(Z,pe,We){return Z.pixelRatio}}class ve extends T{constructor(){const Z={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:d.localize(62,null)},comments:{type:"boolean",default:Z.comments,description:d.localize(63,null)},other:{type:"boolean",default:Z.other,description:d.localize(64,null)}}}],default:Z,description:d.localize(65,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const pe=Z,We={other:n(pe.other,this.defaultValue.other),comments:n(pe.comments,this.defaultValue.comments),strings:n(pe.strings,this.defaultValue.strings)};return We.other&&We.comments&&We.strings?!0:!We.other&&!We.comments&&!We.strings?!1:We}return this.defaultValue}}var Fe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(66,null),d.localize(67,null),d.localize(68,null),d.localize(69,null)],default:"on",description:d.localize(70,null)})}validate(Z){let pe=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(pe=4,We=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:We}}}function Oe(G){const Z=G.get(86);return Z==="editable"?G.get(80):Z!=="on"}e.filterValidationDecorations=Oe;class Ke extends T{constructor(){const Z=[],pe={type:"number",description:d.localize(71,null)};super(90,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:d.localize(72,null),format:"color-hex"}}}]},default:Z,description:d.localize(73,null)})}validate(Z){if(Array.isArray(Z)){let pe=[];for(let We of Z)if(typeof We=="number")pe.push({column:u.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Ye=We;pe.push({column:u.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((We,Ye)=>We.column-Ye.column),pe}return this.defaultValue}}function qe(G,Z){if(typeof G!="string")return Z;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ve extends T{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(74,null),d.localize(75,null),d.localize(76,null)],default:"auto",description:d.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(78,null),d.localize(79,null),d.localize(80,null)],default:"auto",description:d.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:d.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:d.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,We=u.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=u.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:qe(pe.vertical,this.defaultValue.vertical),horizontal:qe(pe.horizontal,this.defaultValue.horizontal),useShadows:n(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:u.clampedInt(pe.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:u.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:n(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class $ extends T{constructor(){const Z={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:d.localize(85,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),mode:w(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends T{constructor(){const Z={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,description:d.localize(86,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:n(Z.enabled,this.defaultValue.enabled)}}}class te extends T{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(87,null),d.localize(88,null),d.localize(89,null)],default:Z.bracketPairs,description:d.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(91,null),d.localize(92,null),d.localize(93,null)],default:Z.bracketPairsHorizontal,description:d.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:d.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:d.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Z.highlightActiveIndentation,description:d.localize(97,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:ae(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ae(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ae(G,Z,pe){const We=pe.indexOf(G);return We===-1?Z:pe[We]}class K extends T{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(98,null),d.localize(99,null)],default:Z.insertMode,description:d.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:d.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:d.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:d.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:d.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:d.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:d.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:d.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:d.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(139,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:w(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(pe.showIcons,this.defaultValue.showIcons),showStatusBar:n(pe.showStatusBar,this.defaultValue.showStatusBar),preview:n(pe.preview,this.defaultValue.preview),previewMode:w(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(pe.showMethods,this.defaultValue.showMethods),showFunctions:n(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:n(pe.showFields,this.defaultValue.showFields),showVariables:n(pe.showVariables,this.defaultValue.showVariables),showClasses:n(pe.showClasses,this.defaultValue.showClasses),showStructs:n(pe.showStructs,this.defaultValue.showStructs),showInterfaces:n(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(pe.showModules,this.defaultValue.showModules),showProperties:n(pe.showProperties,this.defaultValue.showProperties),showEvents:n(pe.showEvents,this.defaultValue.showEvents),showOperators:n(pe.showOperators,this.defaultValue.showOperators),showUnits:n(pe.showUnits,this.defaultValue.showUnits),showValues:n(pe.showValues,this.defaultValue.showValues),showConstants:n(pe.showConstants,this.defaultValue.showConstants),showEnums:n(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(pe.showKeywords,this.defaultValue.showKeywords),showWords:n(pe.showWords,this.defaultValue.showWords),showColors:n(pe.showColors,this.defaultValue.showColors),showFiles:n(pe.showFiles,this.defaultValue.showFiles),showReferences:n(pe.showReferences,this.defaultValue.showReferences),showFolders:n(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(pe.showSnippets,this.defaultValue.showSnippets),showUsers:n(pe.showUsers,this.defaultValue.showUsers),showIssues:n(pe.showIssues,this.defaultValue.showIssues)}}}class se extends T{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(140,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends t{constructor(){super(128,[80])}compute(Z,pe,We){return pe.get(80)?!0:Z.tabFocusMode}}var Ae;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Ae=e.WrappingIndent||(e.WrappingIndent={}));function Ue(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class He extends t{constructor(){super(130,[129])}compute(Z,pe,We){const Ye=pe.get(129);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const Qe="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?et:M.isLinux?st:Qe,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(G){return e.editorOptionsRegistry[G.id]=G,G}var nt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=42]="fontFamily",G[G.fontInfo=43]="fontInfo",G[G.fontLigatures=44]="fontLigatures",G[G.fontSize=45]="fontSize",G[G.fontWeight=46]="fontWeight",G[G.formatOnPaste=47]="formatOnPaste",G[G.formatOnType=48]="formatOnType",G[G.glyphMargin=49]="glyphMargin",G[G.gotoLocation=50]="gotoLocation",G[G.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",G[G.hover=52]="hover",G[G.inDiffEditor=53]="inDiffEditor",G[G.inlineSuggest=54]="inlineSuggest",G[G.letterSpacing=55]="letterSpacing",G[G.lightbulb=56]="lightbulb",G[G.lineDecorationsWidth=57]="lineDecorationsWidth",G[G.lineHeight=58]="lineHeight",G[G.lineNumbers=59]="lineNumbers",G[G.lineNumbersMinChars=60]="lineNumbersMinChars",G[G.linkedEditing=61]="linkedEditing",G[G.links=62]="links",G[G.matchBrackets=63]="matchBrackets",G[G.minimap=64]="minimap",G[G.mouseStyle=65]="mouseStyle",G[G.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=67]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",G[G.multiCursorModifier=69]="multiCursorModifier",G[G.multiCursorPaste=70]="multiCursorPaste",G[G.occurrencesHighlight=71]="occurrencesHighlight",G[G.overviewRulerBorder=72]="overviewRulerBorder",G[G.overviewRulerLanes=73]="overviewRulerLanes",G[G.padding=74]="padding",G[G.parameterHints=75]="parameterHints",G[G.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",G[G.quickSuggestions=78]="quickSuggestions",G[G.quickSuggestionsDelay=79]="quickSuggestionsDelay",G[G.readOnly=80]="readOnly",G[G.renameOnType=81]="renameOnType",G[G.renderControlCharacters=82]="renderControlCharacters",G[G.renderFinalNewline=83]="renderFinalNewline",G[G.renderLineHighlight=84]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=86]="renderValidationDecorations",G[G.renderWhitespace=87]="renderWhitespace",G[G.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",G[G.roundedSelection=89]="roundedSelection",G[G.rulers=90]="rulers",G[G.scrollbar=91]="scrollbar",G[G.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=93]="scrollBeyondLastLine",G[G.scrollPredominantAxis=94]="scrollPredominantAxis",G[G.selectionClipboard=95]="selectionClipboard",G[G.selectionHighlight=96]="selectionHighlight",G[G.selectOnLineNumbers=97]="selectOnLineNumbers",G[G.showFoldingControls=98]="showFoldingControls",G[G.showUnused=99]="showUnused",G[G.snippetSuggestions=100]="snippetSuggestions",G[G.smartSelect=101]="smartSelect",G[G.smoothScrolling=102]="smoothScrolling",G[G.stickyTabStops=103]="stickyTabStops",G[G.stopRenderingLineAfter=104]="stopRenderingLineAfter",G[G.suggest=105]="suggest",G[G.suggestFontSize=106]="suggestFontSize",G[G.suggestLineHeight=107]="suggestLineHeight",G[G.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",G[G.suggestSelection=109]="suggestSelection",G[G.tabCompletion=110]="tabCompletion",G[G.tabIndex=111]="tabIndex",G[G.unusualLineTerminators=112]="unusualLineTerminators",G[G.useShadowDOM=113]="useShadowDOM",G[G.useTabStops=114]="useTabStops",G[G.wordSeparators=115]="wordSeparators",G[G.wordWrap=116]="wordWrap",G[G.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=119]="wordWrapColumn",G[G.wordWrapOverride1=120]="wordWrapOverride1",G[G.wordWrapOverride2=121]="wordWrapOverride2",G[G.wrappingIndent=122]="wrappingIndent",G[G.wrappingStrategy=123]="wrappingStrategy",G[G.showDeprecated=124]="showDeprecated",G[G.inlayHints=125]="inlayHints",G[G.editorClassName=126]="editorClassName",G[G.pixelRatio=127]="pixelRatio",G[G.tabFocusMode=128]="tabFocusMode",G[G.layoutInfo=129]="layoutInfo",G[G.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(141,null)})),acceptSuggestionOnEnter:ye(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(142,null),""],markdownDescription:d.localize(143,null)})),accessibilitySupport:ye(new i),accessibilityPageSize:ye(new u(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(144,null)})),ariaLabel:ye(new C(4,"ariaLabel",d.localize(145,null))),autoClosingBrackets:ye(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(146,null),d.localize(147,null),""],description:d.localize(148,null)})),autoClosingDelete:ye(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(149,null),""],description:d.localize(150,null)})),autoClosingOvertype:ye(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(151,null),""],description:d.localize(152,null)})),autoClosingQuotes:ye(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(153,null),d.localize(154,null),""],description:d.localize(155,null)})),autoIndent:ye(new f(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[d.localize(156,null),d.localize(157,null),d.localize(158,null),d.localize(159,null),d.localize(160,null)],description:d.localize(161,null)})),automaticLayout:ye(new m(10,"automaticLayout",!1)),autoSurround:ye(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(162,null),d.localize(163,null),d.localize(164,null),""],description:d.localize(165,null)})),bracketPairColorization:ye(new Q),bracketPairGuides:ye(new te),stickyTabStops:ye(new m(103,"stickyTabStops",!1,{description:d.localize(166,null)})),codeLens:ye(new m(14,"codeLens",!0,{description:d.localize(167,null)})),codeLensFontFamily:ye(new C(15,"codeLensFontFamily","",{description:d.localize(168,null)})),codeLensFontSize:ye(new u(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(169,null)})),colorDecorators:ye(new m(17,"colorDecorators",!0,{description:d.localize(170,null)})),columnSelection:ye(new m(18,"columnSelection",!1,{description:d.localize(171,null)})),comments:ye(new g),contextmenu:ye(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new m(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(172,null)})),cursorBlinking:ye(new f(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:d.localize(173,null)})),cursorSmoothCaretAnimation:ye(new m(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(174,null)})),cursorStyle:ye(new f(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:d.localize(175,null)})),cursorSurroundingLines:ye(new u(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(176,null)})),cursorSurroundingLinesStyle:ye(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(177,null),d.localize(178,null)],description:d.localize(179,null)})),cursorWidth:ye(new u(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(180,null)})),disableLayerHinting:ye(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new m(30,"domReadOnly",!1)),dragAndDrop:ye(new m(31,"dragAndDrop",!0,{description:d.localize(181,null)})),emptySelectionClipboard:ye(new h),extraEditorClassName:ye(new C(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new p(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:d.localize(182,null)})),find:ye(new y),fixedOverflowWidgets:ye(new m(36,"fixedOverflowWidgets",!1)),folding:ye(new m(37,"folding",!0,{description:d.localize(183,null)})),foldingStrategy:ye(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(184,null),d.localize(185,null)],description:d.localize(186,null)})),foldingHighlight:ye(new m(39,"foldingHighlight",!0,{description:d.localize(187,null)})),foldingImportsByDefault:ye(new m(40,"foldingImportsByDefault",!1,{description:d.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new m(41,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(189,null)})),fontFamily:ye(new C(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(190,null)})),fontInfo:ye(new k),fontLigatures2:ye(new R),fontSize:ye(new O),fontWeight:ye(new N),formatOnPaste:ye(new m(47,"formatOnPaste",!1,{description:d.localize(191,null)})),formatOnType:ye(new m(48,"formatOnType",!1,{description:d.localize(192,null)})),glyphMargin:ye(new m(49,"glyphMargin",!0,{description:d.localize(193,null)})),gotoLocation:ye(new I),hideCursorInOverviewRuler:ye(new m(51,"hideCursorInOverviewRuler",!1,{description:d.localize(194,null)})),hover:ye(new B),inDiffEditor:ye(new m(53,"inDiffEditor",!1)),letterSpacing:ye(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>p.clamp(G,-5,20),{description:d.localize(195,null)})),lightbulb:ye(new H),lineDecorationsWidth:ye(new _(57,"lineDecorationsWidth",10)),lineHeight:ye(new ee),lineNumbers:ye(new Me),lineNumbersMinChars:ye(new u(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new m(61,"linkedEditing",!1,{description:d.localize(196,null)})),links:ye(new m(62,"links",!0,{description:d.localize(197,null)})),matchBrackets:ye(new o(63,"matchBrackets","always",["always","near","never"],{description:d.localize(198,null)})),minimap:ye(new q),mouseStyle:ye(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new p(66,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:d.localize(199,null)})),mouseWheelZoom:ye(new m(67,"mouseWheelZoom",!1,{markdownDescription:d.localize(200,null)})),multiCursorMergeOverlapping:ye(new m(68,"multiCursorMergeOverlapping",!0,{description:d.localize(201,null)})),multiCursorModifier:ye(new f(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[d.localize(202,null),d.localize(203,null)],markdownDescription:d.localize(204,null)})),multiCursorPaste:ye(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(205,null),d.localize(206,null)],markdownDescription:d.localize(207,null)})),occurrencesHighlight:ye(new m(71,"occurrencesHighlight",!0,{description:d.localize(208,null)})),overviewRulerBorder:ye(new m(72,"overviewRulerBorder",!0,{description:d.localize(209,null)})),overviewRulerLanes:ye(new u(73,"overviewRulerLanes",3,0,3)),padding:ye(new j),parameterHints:ye(new le),peekWidgetDefaultFocus:ye(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(210,null),d.localize(211,null)],description:d.localize(212,null)})),definitionLinkOpensInPeek:ye(new m(77,"definitionLinkOpensInPeek",!1,{description:d.localize(213,null)})),quickSuggestions:ye(new ve),quickSuggestionsDelay:ye(new u(79,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(214,null)})),readOnly:ye(new m(80,"readOnly",!1)),renameOnType:ye(new m(81,"renameOnType",!1,{description:d.localize(215,null),markdownDeprecationMessage:d.localize(216,null)})),renderControlCharacters:ye(new m(82,"renderControlCharacters",!1,{description:d.localize(217,null)})),renderFinalNewline:ye(new m(83,"renderFinalNewline",!0,{description:d.localize(218,null)})),renderLineHighlight:ye(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(219,null)],description:d.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(221,null)})),renderValidationDecorations:ye(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(222,null),d.localize(223,null),d.localize(224,null),""],description:d.localize(225,null)})),revealHorizontalRightPadding:ye(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new m(89,"roundedSelection",!0,{description:d.localize(226,null)})),rulers:ye(new Ke),scrollbar:ye(new Ve),scrollBeyondLastColumn:ye(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(227,null)})),scrollBeyondLastLine:ye(new m(93,"scrollBeyondLastLine",!0,{description:d.localize(228,null)})),scrollPredominantAxis:ye(new m(94,"scrollPredominantAxis",!0,{description:d.localize(229,null)})),selectionClipboard:ye(new m(95,"selectionClipboard",!0,{description:d.localize(230,null),included:M.isLinux})),selectionHighlight:ye(new m(96,"selectionHighlight",!0,{description:d.localize(231,null)})),selectOnLineNumbers:ye(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(232,null),d.localize(233,null)],description:d.localize(234,null)})),showUnused:ye(new m(99,"showUnused",!0,{description:d.localize(235,null)})),showDeprecated:ye(new m(124,"showDeprecated",!0,{description:d.localize(236,null)})),inlayHints:ye(new W),snippetSuggestions:ye(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(237,null),d.localize(238,null),d.localize(239,null),d.localize(240,null)],description:d.localize(241,null)})),smartSelect:ye(new se),smoothScrolling:ye(new m(102,"smoothScrolling",!1,{description:d.localize(242,null)})),stopRenderingLineAfter:ye(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new K),inlineSuggest:ye(new $),suggestFontSize:ye(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(243,null)})),suggestLineHeight:ye(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(244,null)})),suggestOnTriggerCharacters:ye(new m(108,"suggestOnTriggerCharacters",!0,{description:d.localize(245,null)})),suggestSelection:ye(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(246,null),d.localize(247,null),d.localize(248,null)],description:d.localize(249,null)})),tabCompletion:ye(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(250,null),d.localize(251,null),d.localize(252,null)],description:d.localize(253,null)})),tabIndex:ye(new u(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new o(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(254,null),d.localize(255,null),d.localize(256,null)],description:d.localize(257,null)})),useShadowDOM:ye(new m(113,"useShadowDOM",!0)),useTabStops:ye(new m(114,"useTabStops",!0,{description:d.localize(258,null)})),wordSeparators:ye(new C(115,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:d.localize(259,null)})),wordWrap:ye(new o(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(260,null),d.localize(261,null),d.localize(262,null),d.localize(263,null)],description:d.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new C(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new C(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new u(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(265,null)})),wordWrapOverride1:ye(new o(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new o(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new f(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ue,{enumDescriptions:[d.localize(266,null),d.localize(267,null),d.localize(268,null),d.localize(269,null)],description:d.localize(270,null)})),wrappingStrategy:ye(new o(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(271,null),d.localize(272,null)],description:d.localize(273,null)})),editorClassName:ye(new b),pixelRatio:ye(new re),tabFocusMode:ye(new he),layoutInfo:ye(new V),wrappingInfo:ye(new He)}}),define(be[118],Ee([18,19]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[119],Ee([18,19]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[120],Ee([18,19]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(be[121],Ee([18,19]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(be[122],Ee([18,19]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(be[123],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[124],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[125],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostProgress",e)}),define(be[126],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[127],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[128],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[129],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[130],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(be[131],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(be[132],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[133],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[134],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[135],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[136],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[137],Ee([0,1,119]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function F(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=n.match(M);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=F;function P(n){if(!n)return null;let m=n.majorBase,s=n.majorMustEqual,u=n.minorBase,p=n.minorMustEqual,C=n.patchBase,w=n.patchMustEqual;n.hasCaret&&(m===0||(p=!1),w=!1);let o=0;if(n.preRelease){const f=E.exec(n.preRelease);if(f){const[,S,i,g]=f;o=Date.UTC(Number(S),Number(i)-1,Number(g))}}return{majorBase:m,majorMustEqual:s,minorBase:u,minorMustEqual:p,patchBase:C,patchMustEqual:w,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=P;function D(n,m,s){let u;typeof n=="string"?u=P(F(n)):u=n;let p;m instanceof Date?p=m.getTime():typeof m=="string"&&(p=new Date(m).getTime());let C;if(typeof s=="string"?C=P(F(s)):C=s,!u||!C)return!1;let w=u.majorBase,o=u.minorBase,f=u.patchBase,S=C.majorBase,i=C.minorBase,g=C.patchBase,a=C.notBefore,r=C.majorMustEqual,v=C.minorMustEqual,l=C.patchMustEqual;return C.isMinimum?w>S?!0:w<S?!1:o>i?!0:o<i||p&&p<a?!1:f>=g:(w===1&&S===0&&(!r||!v||!l)&&(S=1,i=0,g=0,r=!0,v=!1,l=!1),w<S?!1:w>S?!r:o<i?!1:o>i?!v:f<g?!1:f>g?!l:!(p&&p<a))}e.isValidVersion=D;function T(n,m,s,u){return s.isBuiltin||typeof s.main=="undefined"?!0:_(n,m,s.engines.vscode,u)}e.isValidExtensionVersion=T;function t(n,m,s){return n==="*"||_(m,s,n)}e.isEngineValid=t;function _(n,m,s,u=[]){let p=P(F(s));if(!p)return u.push(d.localize(0,null,s)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return u.push(d.localize(1,null,s)),!1}else if(!p.majorMustEqual)return u.push(d.localize(2,null,s)),!1;return D(n,m,p)?!0:(u.push(d.localize(3,null,n,s)),!1)}}),define(be[82],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(E,A=[],F=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=d}),define(be[57],Ee([0,1,82]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(F,P,D){P instanceof d.SyncDescriptor||(P=new d.SyncDescriptor(P,[],D)),M.push([F,P])}e.registerSingleton=E;function A(){return M}e.getSingletonServiceDescriptors=A}),define(be[138],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=d;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let F of this._nodes.values())F.outgoing.size===0&&A.push(F);return A}insertEdge(A,F){const P=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(F);P.outgoing.set(this._hashFn(F),D),D.incoming.set(this._hashFn(A),P)}removeNode(A){const F=this._hashFn(A);this._nodes.delete(F);for(let P of this._nodes.values())P.outgoing.delete(F),P.incoming.delete(F)}lookupOrInsertNode(A){const F=this._hashFn(A);let P=this._nodes.get(F);return P||(P=new d(A),this._nodes.set(F,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[F,P]of this._nodes)A.push(`${F}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,F]of this._nodes){const P=new Set([A]),D=this._findCycle(F,P);if(D)return D}}_findCycle(A,F){for(let[P,D]of A.outgoing){if(F.has(P))return[...F,P].join(" -> ");F.add(P);const T=this._findCycle(D,F);if(T)return T;F.delete(P)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function D(T){return T[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=D})(d=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(P,D,T,t){D[d.DI_TARGET]===D?D[d.DI_DEPENDENCIES].push({id:P,index:T,optional:t}):(D[d.DI_DEPENDENCIES]=[{id:P,index:T,optional:t}],D[d.DI_TARGET]=D)}function E(P){if(d.serviceIds.has(P))return d.serviceIds.get(P);const D=function(T,t,_){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(D,T,_,!1)};return D.toString=()=>P,d.serviceIds.set(P,D),D}e.createDecorator=E;function A(P){return P}e.refineServiceDecorator=A;function F(P){return function(D,T,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(P,D,t,!0)}}e.optional=F}),define(be[139],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[140],Ee([0,1,3,58,6,20,76,56,139]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(T):!!u.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(p,C){let w={selector:p,provider:C,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(w){let o=this._entries.indexOf(w);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const C=[];for(let w of this._entries)w._score>0&&C.push(w.provider);return C}ordered(p){const C=[];return this._orderedForEach(p,w=>C.push(w.provider)),C}orderedGroups(p){const C=[];let w,o;return this._orderedForEach(p,f=>{w&&o===f._score?w.push(f.provider):(o=f._score,w=[f.provider],C.push(w))}),C}_orderedForEach(p,C){if(!!p){this._updateScores(p);for(const w of this._entries)w._score>0&&C(w)}}_updateScores(p){let C={uri:p.uri.toString(),language:p.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===C.language&&this._lastCandidate.uri===C.uri)){this._lastCandidate=C;for(let w of this._entries)if(w._score=(0,P.score)(w.selector,p.uri,p.getLanguageId(),(0,D.shouldSynchronizeModel)(p)),T(w.selector)&&w._score>0){for(let o of this._entries)o._score=0;w._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(p,C){return p._score<C._score?1:p._score>C._score?-1:p._time<C._time?1:p._time>C._time?-1:0}}e.LanguageFeatureRegistry=t;const _=new WeakMap;let n=0;function m(u){let p=_.get(u);return p===void 0&&(p=++n,_.set(u,p)),p}class s{constructor(p,C,w=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=C,this.max=w,this._cache=new A.LRUCache(50,.7)}_key(p){return p.id+this._registry.all(p).reduce((C,w)=>(0,M.doHash)(m(w),C),0)}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const C=this._key(p),w=this._cache.get(C);return this._clamp(w?.value)}update(p,C){const w=this._key(p);let o=this._cache.get(w);return o||(o=new F.MovingAverage,this._cache.set(w,o)),o.update(C),this.get(p)}}e.LanguageFeatureRequestDelays=s}),define(be[59],Ee([0,1,2,44,140,113,34]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));var D;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(D=e.FontStyle||(e.FontStyle={}));var T;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var t;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(t=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&1792)>>>8}static getFontStyle(y){return(y&14336)>>>11}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){let R=this.getForeground(y),k="mtk"+R,O=this.getFontStyle(y);return O&1&&(k+=" mtki"),O&2&&(k+=" mtkb"),O&4&&(k+=" mtku"),k}static getInlineStyleFromMetadata(y,R){const k=this.getForeground(y),O=this.getFontStyle(y);let N=`color: ${R[k]};`;return O&1&&(N+="font-style: italic;"),O&2&&(N+="font-weight: bold;"),O&4&&(N+="text-decoration: underline;"),N}}e.TokenMetadata=n;var m;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(y){const R=h[y];let k=R&&F.iconRegistry.get(R);return k||(console.info("No codicon found for CompletionItemKind "+y),k=F.Codicon.symbolProperty),k.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(y,R){let k=h[y];return typeof k=="undefined"&&!R&&(k=9),k}}();var s;(function(h){h[h.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var u;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(u=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(h){h[h.Automatic=0]="Automatic",h[h.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function S(h){return h&&d.URI.isUri(h.uri)&&M.Range.isIRange(h.range)&&(M.Range.isIRange(h.originSelectionRange)||M.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=S;var i;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var g;(function(h){h[h.Deprecated=1]="Deprecated"})(g=e.SymbolTag||(e.SymbolTag={}));var a;(function(h){const y=new Map;y.set("file",0),y.set("module",1),y.set("namespace",2),y.set("package",3),y.set("class",4),y.set("method",5),y.set("property",6),y.set("field",7),y.set("constructor",8),y.set("enum",9),y.set("interface",10),y.set("function",11),y.set("variable",12),y.set("constant",13),y.set("string",14),y.set("number",15),y.set("boolean",16),y.set("array",17),y.set("object",18),y.set("key",19),y.set("null",20),y.set("enum-member",21),y.set("struct",22),y.set("event",23),y.set("operator",24),y.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function k(I){return y.get(I)}h.fromString=k;function O(I){return R.get(I)}h.toString=O;function N(I,B){const x=R.get(I);let V=x&&F.iconRegistry.get("symbol-"+x);return V||(console.info("No codicon found for SymbolKind "+I),V=F.Codicon.symbolProperty),`${B?"inline":"block"} ${V.classNames}`}h.toCssClassName=N})(a=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(y){this.value=y}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var v;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var b;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[46],Ee([0,1,25,9,4]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=d.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",d.isMacintosh),F.set("isLinux",d.isLinux),F.set("isWindows",d.isWindows),F.set("isWeb",d.isWeb),F.set("isMacNative",d.isMacintosh&&!d.isWeb),F.set("isEdge",A.indexOf("Edg/")>=0),F.set("isFirefox",A.indexOf("Firefox")>=0),F.set("isChrome",A.indexOf("Chrome")>=0),F.set("isSafari",A.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var D;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return n.INSTANCE}static true(){return m.INSTANCE}static has(I){return s.create(I)}static equals(I,B){return u.create(I,B)}static notEquals(I,B){return w.create(I,B)}static regex(I,B){return r.create(I,B)}static in(I,B){return p.create(I,B)}static not(I){return o.create(I)}static and(...I){return c.create(I,null)}static or(...I){return b.create(I,null,!0)}static greater(I,B){return S.create(I,B)}static greaterEquals(I,B){return i.create(I,B)}static smaller(I,B){return g.create(I,B)}static smallerEquals(I,B){return a.create(I,B)}static deserialize(I,B=!1){if(!!I)return this._deserializeOrExpression(I,B)}static _deserializeOrExpression(I,B){let x=I.split("||");return b.create(x.map(V=>this._deserializeAndExpression(V,B)),null,!0)}static _deserializeAndExpression(I,B){let x=I.split("&&");return c.create(x.map(V=>this._deserializeOne(V,B)),null)}static _deserializeOne(I,B){if(I=I.trim(),I.indexOf("!=")>=0){let x=I.split("!=");return w.create(x[0].trim(),this._deserializeValue(x[1],B))}if(I.indexOf("==")>=0){let x=I.split("==");return u.create(x[0].trim(),this._deserializeValue(x[1],B))}if(I.indexOf("=~")>=0){let x=I.split("=~");return r.create(x[0].trim(),this._deserializeRegexValue(x[1],B))}if(I.indexOf(" in ")>=0){let x=I.split(" in ");return p.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(I)){const x=I.split(">=");return i.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(I)){const x=I.split(">");return S.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(I)){const x=I.split("<=");return a.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(I)){const x=I.split("<");return g.create(x[0].trim(),x[1].trim())}return/^\!\s*/.test(I)?o.create(I.substr(1).trim()):s.create(I)}static _deserializeValue(I,B){if(I=I.trim(),I==="true")return!0;if(I==="false")return!1;let x=/^'([^']*)'$/.exec(I);return x?x[1].trim():I}static _deserializeRegexValue(I,B){if((0,M.isFalsyOrWhitespace)(I)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let x=I.indexOf("/"),V=I.lastIndexOf("/");if(x===V||x<0){if(B)throw new Error(`bad regexp-value '${I}', missing /-enclosure`);return console.warn(`bad regexp-value '${I}', missing /-enclosure`),null}let H=I.slice(x+1,V),W=I[V+1]==="i"?"i":"";try{return new RegExp(H,W)}catch(ee){if(B)throw new Error(`bad regexp-value '${I}', parse error: ${ee}`);return console.warn(`bad regexp-value '${I}', parse error: ${ee}`),null}}}e.ContextKeyExpr=T;function t(N,I){const B=N?N.substituteConstants():void 0,x=I?I.substituteConstants():void 0;return!B&&!x?!0:!B||!x?!1:B.equals(x)}e.expressionsAreEqualWithConstantSubstitution=t;function _(N,I){return N.cmp(I)}class n{constructor(){this.type=0}cmp(I){return this.type-I.type}equals(I){return I.type===this.type}substituteConstants(){return this}evaluate(I){return!1}serialize(){return"false"}keys(){return[]}map(I){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class m{constructor(){this.type=1}cmp(I){return this.type-I.type}equals(I){return I.type===this.type}substituteConstants(){return this}evaluate(I){return!0}serialize(){return"true"}keys(){return[]}map(I){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class s{constructor(I,B){this.key=I,this.negated=B,this.type=2}static create(I,B=null){const x=F.get(I);return typeof x=="boolean"?x?m.INSTANCE:n.INSTANCE:new s(I,B)}cmp(I){return I.type!==this.type?this.type-I.type:y(this.key,I.key)}equals(I){return I.type===this.type?this.key===I.key:!1}substituteConstants(){const I=F.get(this.key);return typeof I=="boolean"?I?m.INSTANCE:n.INSTANCE:this}evaluate(I){return!!I.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(I){return I.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=s;class u{constructor(I,B,x){this.key=I,this.value=B,this.negated=x,this.type=4}static create(I,B,x=null){if(typeof B=="boolean")return B?s.create(I,x):o.create(I,x);const V=F.get(I);return typeof V=="boolean"?B===(V?"true":"false")?m.INSTANCE:n.INSTANCE:new u(I,B,x)}cmp(I){return I.type!==this.type?this.type-I.type:R(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){const I=F.get(this.key);if(typeof I=="boolean"){const B=I?"true":"false";return this.value===B?m.INSTANCE:n.INSTANCE}return this}evaluate(I){return I.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(I){return I.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class p{constructor(I,B){this.key=I,this.valueKey=B,this.type=10,this.negated=null}static create(I,B){return new p(I,B)}cmp(I){return I.type!==this.type?this.type-I.type:R(this.key,this.valueKey,I.key,I.valueKey)}equals(I){return I.type===this.type?this.key===I.key&&this.valueKey===I.valueKey:!1}substituteConstants(){return this}evaluate(I){const B=I.getValue(this.valueKey),x=I.getValue(this.key);return Array.isArray(B)?B.indexOf(x)>=0:typeof x=="string"&&typeof B=="object"&&B!==null?P.call(B,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(I){return I.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this)),this.negated}}e.ContextKeyInExpr=p;class C{constructor(I){this._actual=I,this.type=11}static create(I){return new C(I)}cmp(I){return I.type!==this.type?this.type-I.type:this._actual.cmp(I._actual)}equals(I){return I.type===this.type?this._actual.equals(I._actual):!1}substituteConstants(){return this}evaluate(I){return!this._actual.evaluate(I)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(I){return new C(this._actual.map(I))}negate(){return this._actual}}e.ContextKeyNotInExpr=C;class w{constructor(I,B,x){this.key=I,this.value=B,this.negated=x,this.type=5}static create(I,B,x=null){if(typeof B=="boolean")return B?o.create(I,x):s.create(I,x);const V=F.get(I);return typeof V=="boolean"?B===(V?"true":"false")?n.INSTANCE:m.INSTANCE:new w(I,B,x)}cmp(I){return I.type!==this.type?this.type-I.type:R(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){const I=F.get(this.key);if(typeof I=="boolean"){const B=I?"true":"false";return this.value===B?n.INSTANCE:m.INSTANCE}return this}evaluate(I){return I.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(I){return I.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class o{constructor(I,B){this.key=I,this.negated=B,this.type=3}static create(I,B=null){const x=F.get(I);return typeof x=="boolean"?x?n.INSTANCE:m.INSTANCE:new o(I,B)}cmp(I){return I.type!==this.type?this.type-I.type:y(this.key,I.key)}equals(I){return I.type===this.type?this.key===I.key:!1}substituteConstants(){const I=F.get(this.key);return typeof I=="boolean"?I?n.INSTANCE:m.INSTANCE:this}evaluate(I){return!I.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(I){return I.mapNot(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function f(N,I){if(typeof N=="string"){const B=parseFloat(N);isNaN(B)||(N=B)}return typeof N=="string"||typeof N=="number"?I(N):n.INSTANCE}class S{constructor(I,B,x){this.key=I,this.value=B,this.negated=x,this.type=12}static create(I,B,x=null){return f(B,V=>new S(I,V,x))}cmp(I){return I.type!==this.type?this.type-I.type:R(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(I){return I.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=S;class i{constructor(I,B,x){this.key=I,this.value=B,this.negated=x,this.type=13}static create(I,B,x=null){return f(B,V=>new i(I,V,x))}cmp(I){return I.type!==this.type?this.type-I.type:R(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(I){return I.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=i;class g{constructor(I,B,x){this.key=I,this.value=B,this.negated=x,this.type=14}static create(I,B,x=null){return f(B,V=>new g(I,V,x))}cmp(I){return I.type!==this.type?this.type-I.type:R(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(I){return I.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=g;class a{constructor(I,B,x){this.key=I,this.value=B,this.negated=x,this.type=15}static create(I,B,x=null){return f(B,V=>new a(I,V,x))}cmp(I){return I.type!==this.type?this.type-I.type:R(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(I){return I.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=a;class r{constructor(I,B){this.key=I,this.regexp=B,this.type=7,this.negated=null}static create(I,B){return new r(I,B)}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.key<I.key)return-1;if(this.key>I.key)return 1;const B=this.regexp?this.regexp.source:"",x=I.regexp?I.regexp.source:"";return B<x?-1:B>x?1:0}equals(I){if(I.type===this.type){const B=this.regexp?this.regexp.source:"",x=I.regexp?I.regexp.source:"";return this.key===I.key&&B===x}return!1}substituteConstants(){return this}evaluate(I){let B=I.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const I=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${I}`}keys(){return[this.key]}map(I){return I.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class v{constructor(I){this._actual=I,this.type=8}static create(I){return new v(I)}cmp(I){return I.type!==this.type?this.type-I.type:this._actual.cmp(I._actual)}equals(I){return I.type===this.type?this._actual.equals(I._actual):!1}substituteConstants(){return this}evaluate(I){return!this._actual.evaluate(I)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(I){return new v(this._actual.map(I))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=v;function l(N){let I=null;for(let B=0,x=N.length;B<x;B++){const V=N[B].substituteConstants();if(N[B]!==V&&I===null){I=[];for(let H=0;H<B;H++)I[H]=N[H]}I!==null&&(I[B]=V)}return I===null?N:I}class c{constructor(I,B){this.expr=I,this.negated=B,this.type=6}static create(I,B){return c._normalizeArr(I,B)}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.expr.length<I.expr.length)return-1;if(this.expr.length>I.expr.length)return 1;for(let B=0,x=this.expr.length;B<x;B++){const V=_(this.expr[B],I.expr[B]);if(V!==0)return V}return 0}equals(I){if(I.type===this.type){if(this.expr.length!==I.expr.length)return!1;for(let B=0,x=this.expr.length;B<x;B++)if(!this.expr[B].equals(I.expr[B]))return!1;return!0}return!1}substituteConstants(){const I=l(this.expr);return I===this.expr?this:c.create(I,this.negated)}evaluate(I){for(let B=0,x=this.expr.length;B<x;B++)if(!this.expr[B].evaluate(I))return!1;return!0}static _normalizeArr(I,B){const x=[];let V=!1;for(const H of I)if(!!H){if(H.type===1){V=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){x.push(...H.expr);continue}x.push(H)}if(x.length===0&&V)return m.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(_);for(let H=1;H<x.length;H++)x[H-1].equals(x[H])&&(x.splice(H,1),H--);if(x.length===1)return x[0];for(;x.length>1;){const H=x[x.length-1];if(H.type!==9)break;x.pop();const W=x.pop(),ee=x.length===0,q=b.create(H.expr.map(Y=>c.create([Y,W],null)),null,ee);q&&(x.push(q),x.sort(_))}return x.length===1?x[0]:new c(x,B)}}serialize(){return this.expr.map(I=>I.serialize()).join(" && ")}keys(){const I=[];for(let B of this.expr)I.push(...B.keys());return I}map(I){return new c(this.expr.map(B=>B.map(I)),null)}negate(){if(!this.negated){const I=[];for(let B of this.expr)I.push(B.negate());this.negated=b.create(I,this,!0)}return this.negated}}class b{constructor(I,B){this.expr=I,this.negated=B,this.type=9}static create(I,B,x){return b._normalizeArr(I,B,x)}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.expr.length<I.expr.length)return-1;if(this.expr.length>I.expr.length)return 1;for(let B=0,x=this.expr.length;B<x;B++){const V=_(this.expr[B],I.expr[B]);if(V!==0)return V}return 0}equals(I){if(I.type===this.type){if(this.expr.length!==I.expr.length)return!1;for(let B=0,x=this.expr.length;B<x;B++)if(!this.expr[B].equals(I.expr[B]))return!1;return!0}return!1}substituteConstants(){const I=l(this.expr);return I===this.expr?this:b.create(I,this.negated,!1)}evaluate(I){for(let B=0,x=this.expr.length;B<x;B++)if(this.expr[B].evaluate(I))return!0;return!1}static _normalizeArr(I,B,x){let V=[],H=!1;if(I){for(let W=0,ee=I.length;W<ee;W++){const q=I[W];if(!!q){if(q.type===0){H=!0;continue}if(q.type===1)return m.INSTANCE;if(q.type===9){V=V.concat(q.expr);continue}V.push(q)}}if(V.length===0&&H)return n.INSTANCE;V.sort(_)}if(V.length!==0){if(V.length===1)return V[0];for(let W=1;W<V.length;W++)V[W-1].equals(V[W])&&(V.splice(W,1),W--);if(V.length===1)return V[0];if(x){for(let W=0;W<V.length;W++)for(let ee=W+1;ee<V.length;ee++)k(V[W],V[ee])&&(V.splice(ee,1),ee--);if(V.length===1)return V[0]}return new b(V,B)}}serialize(){return this.expr.map(I=>I.serialize()).join(" || ")}keys(){const I=[];for(let B of this.expr)I.push(...B.keys());return I}map(I){return new b(this.expr.map(B=>B.map(I)),null)}negate(){if(!this.negated){let I=[];for(let B of this.expr)I.push(B.negate());for(;I.length>1;){const B=I.shift(),x=I.shift(),V=[];for(const W of O(B))for(const ee of O(x))V.push(c.create([W,ee],null));const H=I.length===0;I.unshift(b.create(V,null,H))}this.negated=I[0]}return this.negated}}class h extends s{constructor(I,B,x){super(I,null);this._defaultValue=B,typeof x=="object"?h._info.push({...x,key:I}):x!==!0&&h._info.push({key:I,description:x,type:B!=null?typeof B:void 0})}static all(){return h._info.values()}bindTo(I){return I.createKey(this.key,this._defaultValue)}getValue(I){return I.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(I){return u.create(this.key,I)}notEqualsTo(I){return w.create(this.key,I)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(N,I){return N<I?-1:N>I?1:0}function R(N,I,B,x){return N<B?-1:N>B?1:I<x?-1:I>x?1:0}function k(N,I){if(I.type===6&&N.type!==9&&N.type!==6){for(const V of I.expr)if(N.equals(V))return!0}const B=N.negate(),x=O(B).concat(O(I));x.sort(_);for(let V=0;V<x.length;V++){const W=x[V].negate();for(let ee=V+1;ee<x.length;ee++){const q=x[ee];if(W.equals(q))return!0}}return!1}e.implies=k;function O(N){return N.type===9?N.expr:[N]}}),define(be[141],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(be[60],Ee([0,1,20,17,9,10,2,120,4]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function T(x){return x.create===!0}e.isFileOpenForWriteOptions=T;var t;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var _;(function(x){x[x.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=m;function s(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=s;function u(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function p(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=p;var C;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(V,H){super(V);this.code=H}}e.FileSystemProviderError=w;function o(x,V){const H=new w(x.toString(),V);return S(H,V),H}e.createFileSystemProviderError=o;function f(x){return x||o((0,P.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=f;function S(x,V){return x.name=V?`${V} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=S;function i(x){if(!x)return C.Unknown;if(x instanceof w)return x.code;const V=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!V)return C.Unknown;switch(V[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=i;function g(x){if(x instanceof b)return x.fileOperationResult;switch(i(x)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=g;var a;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(a=e.FileOperation||(e.FileOperation={}));class r{constructor(V,H,W){this.resource=V,this.operation=H,this.target=W}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var v;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class l{constructor(V,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const ee of V){const q=W.get(ee.type);q?q.push([ee.resource,ee]):W.set(ee.type,[[ee.resource,ee]])}for(const[ee,q]of W)switch(ee){case 1:this.added=d.TernarySearchTree.forUris(()=>H),this.added.fill(q);break;case 0:this.updated=d.TernarySearchTree.forUris(()=>H),this.updated.fill(q);break;case 2:this.deleted=d.TernarySearchTree.forUris(()=>H),this.deleted.fill(q);break}}contains(V,...H){return this.doContains(V,{includeChildren:!1},...H)}affects(V,...H){return this.doContains(V,{includeChildren:!0},...H)}doContains(V,H,...W){if(!V)return!1;const ee=W.length>0;return!!((!ee||W.includes(1))&&(this.added?.get(V)||H.includeChildren&&this.added?.findSuperstr(V))||(!ee||W.includes(0))&&(this.updated?.get(V)||H.includeChildren&&this.updated?.findSuperstr(V))||(!ee||W.includes(2))&&(this.deleted?.findSubstr(V)||H.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function c(x,V,H){return!x||!V||x===V||V.length>x.length?!1:(V.charAt(V.length-1)!==M.sep&&(V+=M.sep),H?(0,E.startsWithIgnoreCase)(x,V):x.indexOf(V)===0)}e.isParent=c;class b extends Error{constructor(V,H,W){super(V);this.fileOperationResult=H,this.options=W}}e.FileOperationError=b;class h extends b{constructor(V,H,W){super(V,2,W);this.stat=H}}e.NotModifiedSinceFileOperationError=h;var y;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=k;async function O(x,V){if(!V.hasProvider(F.URI.from({scheme:x.scheme})))return new Promise(H=>{const W=V.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===x.scheme&&ee.added&&(W.dispose(),H())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(V){return(0,A.isNumber)(V)||(V=0),V<N.KB?(0,P.localize)(1,null,V.toFixed(0)):V<N.MB?(0,P.localize)(2,null,(V/N.KB).toFixed(2)):V<N.GB?(0,P.localize)(3,null,(V/N.MB).toFixed(2)):V<N.TB?(0,P.localize)(4,null,(V/N.GB).toFixed(2)):(0,P.localize)(5,null,(V/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var I;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(I=e.Arch||(e.Arch={}));function B(x){return{maxFileSize:x===0?300*N.MB:16*N.GB,maxHeapSize:x===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=B}),define(be[61],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...E){this._entries=new Map;for(let[A,F]of E)this.set(A,F)}set(E,A){const F=this._entries.get(E);return this._entries.set(E,A),F}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=d}),define(be[142],Ee([0,1,12,16,82,138,4,61]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class T extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class t{constructor(s=new P.ServiceCollection,u=!1,p){this._activeInstantiations=new Set,this._services=s,this._strict=u,this._parent=p,this._services.set(F.IInstantiationService,this)}createChild(s){return new t(s,this._strict,this)}invokeFunction(s,...u){let p=n.traceInvocation(s),C=!1;try{return s({get:(o,f)=>{if(C)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(o,p);if(!S&&f!==F.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return S}},...u)}finally{C=!0,p.stop()}}createInstance(s,...u){let p,C;return s instanceof E.SyncDescriptor?(p=n.traceCreation(s.ctor),C=this._createInstance(s.ctor,s.staticArguments.concat(u),p)):(p=n.traceCreation(s),C=this._createInstance(s,u,p)),p.stop(),C}_createInstance(s,u=[],p){let C=F._util.getServiceDependencies(s).sort((f,S)=>f.index-S.index),w=[];for(const f of C){let S=this._getOrCreateServiceInstance(f.id,p);if(!S&&this._strict&&!f.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${f.id}.`);w.push(S)}let o=C.length>0?C[0].index:u.length;if(u.length!==o){console.warn(`[createInstance] First service dependency of ${s.name} at position ${o+1} conflicts with ${u.length} static arguments`);let f=o-u.length;f>0?u=u.concat(new Array(f)):u=u.slice(0,o)}return new s(...[...u,...w])}_setServiceInstance(s,u){if(this._services.get(s)instanceof E.SyncDescriptor)this._services.set(s,u);else if(this._parent)this._parent._setServiceInstance(s,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let u=this._services.get(s);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):u}_getOrCreateServiceInstance(s,u){let p=this._getServiceInstanceOrDescriptor(s);return p instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,p,u.branch(s,!0)):(u.branch(s,!1),p)}_safeCreateAndCacheServiceInstance(s,u,p){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,u,p)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,u,p){const C=new A.Graph(f=>f.id.toString());let w=0;const o=[{id:s,desc:u,_trace:p}];for(;o.length;){const f=o.pop();if(C.lookupOrInsertNode(f),w++>1e3)throw new T(C);for(let S of F._util.getServiceDependencies(f.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(S.id);if(!i&&!S.optional&&console.warn(`[createInstance] ${s} depends on ${S.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const g={id:S.id,desc:i,_trace:f._trace.branch(S.id,!0)};C.insertEdge(f,g),o.push(g)}}}for(;;){const f=C.roots();if(f.length===0){if(!C.isEmpty())throw new T(C);break}for(const{data:S}of f){if(this._getServiceInstanceOrDescriptor(S.id)instanceof E.SyncDescriptor){const g=this._createServiceInstanceWithOwner(S.id,S.desc.ctor,S.desc.staticArguments,S.desc.supportsDelayedInstantiation,S._trace);this._setServiceInstance(S.id,g)}C.removeNode(S)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,u,p=[],C,w){if(this._services.get(s)instanceof E.SyncDescriptor)return this._createServiceInstance(u,p,C,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,u,p,C,w);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(s,u=[],p,C){if(p){const w=new d.IdleValue(()=>this._createInstance(s,u,C));return new Proxy(Object.create(null),{get(o,f){if(f in o)return o[f];let S=w.value,i=S[f];return typeof i!="function"||(i=i.bind(S),o[f]=i),i},set(o,f,S){return w.value[f]=S,!0}})}else return this._createInstance(s,u,C)}}e.InstantiationService=t;var _;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(_||(_={}));class n{constructor(s,u){this.type=s,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return D?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return D?new n(0,s.name):n._None}branch(s,u){let p=new n(2,s.toString());return this._dep.push([s,u,p]),p}stop(){let s=Date.now()-this._start;n._totals+=s;let u=!1;function p(w,o){let f=[],S=new Array(w+1).join("	");for(const[i,g,a]of o._dep)if(g&&a){u=!0,f.push(`${S}CREATES -> ${i}`);let r=p(w+1,a);r&&f.push(r)}else f.push(`${S}uses -> ${i}`);return f.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||u)&&console.log(C.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,45,3,6,25,4]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function P(){return new Date().toISOString()}var D;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class T extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class t extends T{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...g){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([i,...g]))}debug(i,...g){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([i,...g]))}info(i,...g){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([i,...g]))}warn(i,...g){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([i,...g]))}error(i,...g){if(this.checkLogLevel(D.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(D.Error,this.format(a))}else this.log(D.Error,this.format([i,...g]))}critical(i,...g){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([i,...g]))}flush(){}format(i){let g="";for(let a=0;a<i.length;a++){let r=i[a];if(typeof r=="object")try{r=JSON.stringify(r)}catch(v){}g+=(a>0?" ":"")+r}return g}}e.AbstractMessageLogger=t;class _ extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...g){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...g):console.log(`[main ${P()}]`,i,...g))}debug(i,...g){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...g):console.log(`[main ${P()}]`,i,...g))}info(i,...g){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...g):console.log(`[main ${P()}]`,i,...g))}warn(i,...g){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...g):console.warn(`[main ${P()}]`,i,...g))}error(i,...g){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...g):console.error(`[main ${P()}]`,i,...g))}critical(i,...g){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...g):console.error(`[main ${P()}]`,i,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class n extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...g){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",i,...g)}debug(i,...g){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...g)}info(i,...g){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",i,...g)}warn(i,...g){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",i,...g)}error(i,...g){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",i,...g)}critical(i,...g){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...g)}dispose(){}flush(){}}e.ConsoleLogger=n;class m extends T{constructor(i,g=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(g)}trace(i,...g){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(i),...g])}debug(i,...g){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(i),...g])}info(i,...g){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(i),...g])}warn(i,...g){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(i),...g])}error(i,...g){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(i),...g])}critical(i,...g){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(i),...g])}extractMessage(i){return typeof i=="string"?i:(0,d.toErrorMessage)(i,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class s extends T{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const g of this.logServices)g.setLevel(i);super.setLevel(i)}trace(i,...g){for(const a of this.logServices)a.trace(i,...g)}debug(i,...g){for(const a of this.logServices)a.debug(i,...g)}info(i,...g){for(const a of this.logServices)a.info(i,...g)}warn(i,...g){for(const a of this.logServices)a.warn(i,...g)}error(i,...g){for(const a of this.logServices)a.error(i,...g)}critical(i,...g){for(const a of this.logServices)a.critical(i,...g)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=s;class u extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...g){this.logger.trace(i,...g)}debug(i,...g){this.logger.debug(i,...g)}info(i,...g){this.logger.info(i,...g)}warn(i,...g){this.logger.warn(i,...g)}error(i,...g){this.logger.error(i,...g)}critical(i,...g){this.logger.critical(i,...g)}flush(){this.logger.flush()}}e.LogService=u;class p extends E.Disposable{constructor(i,g){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(g(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,g){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,g?.always?D.Trace:this.logLevel,g),this.loggers.set(i.toString(),a),g?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class C{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return D.Info}trace(i,...g){}debug(i,...g){}info(i,...g){}warn(i,...g){}error(i,...g){}critical(i,...g){}dispose(){}flush(){}}e.NullLogService=C;function w(S){if(S.verbose)return D.Trace;if(typeof S.logLevel=="string"){const i=o(S.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function o(S){switch(S){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=o;function f(S){switch(S){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=f}),define(be[83],Ee([0,1,35,121,4]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var F;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function T(s,u){return u-s}D.compare=T;const t=Object.create(null);t[D.Error]=(0,M.localize)(0,null),t[D.Warning]=(0,M.localize)(1,null),t[D.Info]=(0,M.localize)(2,null);function _(s){return t[s]||""}D.toString=_;function n(s){switch(s){case d.default.Error:return D.Error;case d.default.Warning:return D.Warning;case d.default.Info:return D.Info;case d.default.Ignore:return D.Hint}}D.fromSeverity=n;function m(s){switch(s){case D.Error:return d.default.Error;case D.Warning:return d.default.Warning;case D.Info:return d.default.Info;case D.Hint:return d.default.Ignore}}D.toSeverity=m}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(D){const T="";function t(n){return _(n,!0)}D.makeKey=t;function _(n,m){let s=[T];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(T),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(T),n.severity!==void 0&&n.severity!==null?s.push(F.toString(n.severity)):s.push(T),n.message&&m?s.push(n.message.replace("\xA6","\\\xA6")):s.push(T),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(T),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(T),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(T),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(T),s.push(T),s.join("\xA6")}D.makeKeyOptionalMessage=_})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[143],Ee([0,1,3,35,4]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new D,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=P;class D{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=D}),define(be[144],Ee([0,1,6,9,2,4]),function(oe,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(P){return{resolved:P,dispose(){}}}});function F(P,D){return E.URI.isUri(P)?(0,M.equalsIgnoreCase)(P.scheme,D):(0,M.startsWithIgnoreCase)(P,D+":")}e.matchesScheme=F});var $e=this&&this.__decorate||function(oe,e,d,M){var E=arguments.length,A=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,d):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(oe,e,d,M);else for(var P=oe.length-1;P>=0;P--)(F=oe[P])&&(A=(E<3?F(A):E>3?F(e,d,A):F(e,d))||A);return E>3&&A&&Object.defineProperty(e,d,A),A},ze=this&&this.__param||function(oe,e){return function(d,M){e(d,M,oe)}};define(be[145],Ee([0,1,12,21,6,4]),function(oe,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let D=class extends E.Disposable{constructor(_,n){super();this.deferred=new d.DeferredPromise,n.withProgress(_,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};D=$e([ze(1,e.IProgressService)],D),e.UnmanagedProgress=D;class T extends E.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,m=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:m.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,42,10]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(F,P){d.ok(M.isString(F)),d.ok(M.isObject(P)),d.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,P)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new E}),define(be[84],Ee([0,1,3,28]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,T){this.schemasById[E(D)]=T,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new A;M.Registry.add(e.Extensions.JSONContribution,F)}),define(be[62],Ee([0,1,14,3,10,118,84,28]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=P.Registry.as(F.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,f=!0){this.registerConfigurations([o],f)}registerConfigurations(o,f=!0){const S=this.doRegisterConfigurations(o,f);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterConfigurations(o){const f=this.doDeregisterConfigurations(o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}updateConfigurations({add:o,remove:f}){const S=[];S.push(...this.doDeregisterConfigurations(f)),S.push(...this.doRegisterConfigurations(o,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,d.distinct)(S))}registerDefaultConfigurations(o){const f=[],S=[];for(const i of o)for(const g in i)if(f.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]={...this.defaultValues[g]||{},...i[g]};const a={type:"object",default:this.defaultValues[g],description:A.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};S.push(m(g)),this.configurationProperties[g]=a,this.defaultLanguageConfigurationOverridesNode.properties[g]=a}else{this.defaultValues[g]=i[g];const a=this.configurationProperties[g];a&&(this.updatePropertyDefaultValue(g,a),this.updateSchema(g,a))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(o){const f=[];for(const S of o)for(const i in S)if(f.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const g=this.configurationProperties[i];g&&(this.updatePropertyDefaultValue(i,g),this.updateSchema(i,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const f of o)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,f){const S=[];return o.forEach(i=>{S.push(...this.validateAndRegisterProperties(i,f,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),S}doDeregisterConfigurations(o){const f=[],S=i=>{if(i.properties)for(const g in i.properties)f.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,i.properties[g]);i.allOf&&i.allOf.forEach(g=>S(g))};for(const i of o){S(i);const g=this.configurationContributors.indexOf(i);g!==-1&&this.configurationContributors.splice(g,1)}return f}validateAndRegisterProperties(o,f=!0,S,i=3){i=E.isUndefinedOrNull(o.scope)?i:o.scope;let g=[],a=o.properties;if(a)for(let v in a){if(f&&p(v)){delete a[v];continue}const l=a[v];if(this.updatePropertyDefaultValue(v,l),e.OVERRIDE_PROPERTY_PATTERN.test(v)?l.scope=void 0:(l.scope=E.isUndefinedOrNull(l.scope)?i:l.scope,l.restricted=E.isUndefinedOrNull(l.restricted)?!!S?.restrictedConfigurations?.includes(v):l.restricted),a[v].hasOwnProperty("included")&&!a[v].included){this.excludedConfigurationProperties[v]=a[v],delete a[v];continue}else this.configurationProperties[v]=a[v];!a[v].deprecationMessage&&a[v].markdownDeprecationMessage&&(a[v].deprecationMessage=a[v].markdownDeprecationMessage),g.push(v)}let r=o.allOf;if(r)for(let v of r)g.push(...this.validateAndRegisterProperties(v,f,S,i));return g}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const f=S=>{let i=S.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);let g=S.allOf;g&&g.forEach(f)};f(o)}updateSchema(o,f){switch(e.allSettings.properties[o]=f,f.scope){case 1:e.applicationSettings.properties[o]=f;break;case 2:e.machineSettings.properties[o]=f;break;case 6:e.machineOverridableSettings.properties[o]=f;break;case 3:e.windowSettings.properties[o]=f;break;case 4:e.resourceSettings.properties[o]=f;break;case 5:e.resourceSettings.properties[o]=f,this.resourceLanguageSettingsSchema.properties[o]=f;break}}removeFromSchema(o,f){switch(delete e.allSettings.properties[o],f.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const f=`[${o}]`,S={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,S),e.allSettings.properties[f]=S,e.applicationSettings.properties[f]=S,e.machineSettings.properties[f]=S,e.machineOverridableSettings.properties[f]=S,e.windowSettings.properties[f]=S,e.resourceSettings.properties[f]=S}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,f){let S=this.defaultValues[o];E.isUndefined(S)&&(S=f.default),E.isUndefined(S)&&(S=s(f.type)),f.default=S}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function m(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=m;function s(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=s;const u=new _;P.Registry.add(e.Extensions.Configuration,u);function p(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?A.localize(5,null,w):u.getConfigurationProperties()[w]!==void 0?A.localize(6,null,w):null:A.localize(4,null)}e.validateProperty=p;function C(){const w=[],o=u.getConfigurationProperties();for(const f of Object.keys(o))w.push([f,o[f].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=C}),define(be[85],Ee([0,1,23,10,2,62,4,28]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof E.URI)}e.isConfigurationOverrides=D;var T;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function _(g,a){const r=a?g?a.keys.filter(R=>g.keys.indexOf(R)===-1):[...a.keys]:[],v=g?a?g.keys.filter(R=>a.keys.indexOf(R)===-1):[...g.keys]:[],l=[];if(a&&g){for(const R of g.keys)if(a.keys.indexOf(R)!==-1){const k=C(g.contents,R),O=C(a.contents,R);d.equals(k,O)||l.push(R)}}const c=[],b=R=>{const k={};for(const O of R)for(const N of O.identifiers)k[S(N)]=O;return k},h=a?b(a.overrides):{},y=g?b(g.overrides):{};if(Object.keys(h).length)for(const R of r){const k=h[R];k&&c.push([(0,A.overrideIdentifierFromKey)(R),k.keys])}if(Object.keys(y).length)for(const R of v){const k=y[R];k&&c.push([(0,A.overrideIdentifierFromKey)(R),k.keys])}if(Object.keys(h).length&&Object.keys(y).length)for(const R of l){const k=y[R],O=h[R];if(k&&O){const N=_({contents:k.contents,keys:k.keys,overrides:[]},{contents:O.contents,keys:O.keys,overrides:[]});c.push([(0,A.overrideIdentifierFromKey)(R),[...N.added,...N.removed,...N.updated]])}}return{added:r,removed:v,updated:l,overrides:c}}e.compare=_;function n(g,a){const r=[];for(const v of Object.keys(g))if(A.OVERRIDE_PROPERTY_PATTERN.test(v)){const l={};for(const c in g[v])l[c]=g[v][c];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(v).trim()],keys:Object.keys(l),contents:m(l,a)})}return r}e.toOverrides=n;function m(g,a){const r=Object.create(null);for(let v in g)s(r,v,g[v],a);return r}e.toValuesTree=m;function s(g,a,r,v){const l=a.split("."),c=l.pop();let b=g;for(let h=0;h<l.length;h++){let y=l[h],R=b[y];switch(typeof R){case"undefined":R=b[y]=Object.create(null);break;case"object":break;default:v(`Ignoring ${a} as ${l.slice(0,h+1).join(".")} is ${JSON.stringify(R)}`);return}b=R}if(typeof b=="object"&&b!==null)try{b[c]=r}catch(h){v(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(b)}`)}else v(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=s;function u(g,a){const r=a.split(".");p(g,r)}e.removeFromValueTree=u;function p(g,a){const r=a.shift();if(a.length===0){delete g[r];return}if(Object.keys(g).indexOf(r)!==-1){const v=g[r];typeof v=="object"&&!Array.isArray(v)&&(p(v,a),Object.keys(v).length===0&&delete g[r])}}function C(g,a,r){function v(b,h){let y=b;for(const R of h){if(typeof y!="object"||y===null)return;y=y[R]}return y}const l=a.split("."),c=v(g,l);return typeof c=="undefined"?r:c}e.getConfigurationValue=C;function w(g,a,r){Object.keys(a).forEach(v=>{v!=="__proto__"&&(v in g?M.isObject(g[v])&&M.isObject(a[v])?w(g[v],a[v],r):r&&(g[v]=a[v]):g[v]=a[v])})}e.merge=w;function o(){const g=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(g)}e.getConfigurationKeys=o;function f(){const g=Object.create(null),a=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in a){let v=a[r].default;s(g,r,v,l=>console.error(`Conflict in default settings: ${l}`))}return g}e.getDefaultValues=f;function S(g){return`[${g}]`}e.keyFromOverrideIdentifier=S;function i(g,a,r){const v=g.inspect(a),l=g.inspect(r);return typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:v.defaultValue}e.getMigratedSettingValue=i}),define(be[146],Ee([0,1,14,3,102,6,20,23,10,2,85,62,28]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(i={},g=[],a=[]){this._contents=i,this._keys=g,this._overrides=a,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,g){const a=this.getContentsForOverrideIdentifer(g);return a?i?(0,t.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){for(const g of this.overrides)if(g.identifiers.indexOf(i)!==-1)return g.keys;return[]}override(i){let g=this.overrideConfigurations.get(i);return g||(g=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,g)),g}merge(...i){const g=P.deepClone(this.contents),a=P.deepClone(this.overrides),r=[...this.keys];for(const v of i){this.mergeContents(g,v.contents);for(const l of v.overrides){const[c]=a.filter(b=>d.equals(b.identifiers,l.identifiers));c?this.mergeContents(c.contents,l.contents):a.push(P.deepClone(l))}for(const l of v.keys)r.indexOf(l)===-1&&r.push(l)}return new m(g,r,a)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const g=this.getContentsForOverrideIdentifer(i);if(!g||typeof g!="object"||!Object.keys(g).length)return this;let a={};for(const r of d.distinct([...Object.keys(this.contents),...Object.keys(g)])){let v=this.contents[r],l=g[r];l&&(typeof v=="object"&&typeof l=="object"?(v=P.deepClone(v),this.mergeContents(v,l)):v=l),a[r]=v}return new m(a,this.keys,this.overrides)}mergeContents(i,g){for(const a of Object.keys(g)){if(a in i&&D.isObject(i[a])&&D.isObject(g[a])){this.mergeContents(i[a],g[a]);continue}i[a]=P.deepClone(g[a])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const g of this.overrides)if(g.identifiers.indexOf(i)!==-1)return g.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,g){this.addKey(i),(0,t.addToValueTree)(this.contents,i,g,a=>{throw new Error(a)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let g=this.keys.length;for(let a=0;a<g;a++)i.indexOf(this.keys[a])===0&&(g=a);this.keys.splice(g,1,i)}removeKey(i){let g=this.keys.indexOf(i);return g!==-1?(this.keys.splice(g,1),!0):!1}}e.ConfigurationModel=m;class s extends m{constructor(){const i=(0,t.getDefaultValues)(),g=(0,t.getConfigurationKeys)(),a=[];for(const r of Object.keys(i))_.OVERRIDE_PROPERTY_PATTERN.test(r)&&a.push({identifiers:[(0,_.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(i[r]),contents:(0,t.toValuesTree)(i[r],v=>console.error(`Conflict in default settings file: ${v}`))});super(i,g,a)}}e.DefaultConfigurationModel=s;class u{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,g){if(!D.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,g)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,g){this._raw=i;const{contents:a,keys:r,overrides:v,restricted:l}=this.doParseRaw(i,g);this._configurationModel=new m(a,r,v),this._restrictedConfigurations=l||[]}doParseContent(i){let g={},a=null,r=[],v=[],l=[];function c(h){Array.isArray(r)?r.push(h):a!==null&&(r[a]=h)}let b={onObjectBegin:()=>{let h={};c(h),v.push(r),r=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{r=v.pop()},onArrayBegin:()=>{let h=[];c(h),v.push(r),r=h,a=null},onArrayEnd:()=>{r=v.pop()},onLiteralValue:c,onError:(h,y,R)=>{l.push({error:h,offset:y,length:R})}};if(i)try{E.visit(i,b),g=r[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return g}doParseRaw(i,g){const a=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,a,!0,g);i=r.raw;const v=(0,t.toValuesTree)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),l=Object.keys(i),c=(0,t.toOverrides)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:v,keys:l,overrides:c,restricted:r.restricted}}filter(i,g,a,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const v={},l=[];for(let c in i)if(_.OVERRIDE_PROPERTY_PATTERN.test(c)&&a){const b=this.filter(i[c],g,!1,r);v[c]=b.raw,l.push(...b.restricted)}else{const b=g[c],h=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&l.push(c),(h===void 0||r.scopes===void 0||r.scopes.includes(h))&&(r.skipRestricted&&b?.restricted||(v[c]=i[c]))}return{raw:v,restricted:l}}}e.ConfigurationModelParser=u;class p extends A.Disposable{constructor(i,g,a,r){super();this.userSettingsResource=i,this.scopes=g,this.fileService=r,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class C{constructor(i,g,a=new m,r=new m,v=new F.ResourceMap,l=new m,c=new F.ResourceMap,b=!0){this._defaultConfiguration=i,this._localUserConfiguration=g,this._remoteUserConfiguration=a,this._workspaceConfiguration=r,this._folderConfigurations=v,this._memoryConfiguration=l,this._memoryConfigurationByResource=c,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,g,a){return this.getConsolidateConfigurationModel(g,a).getValue(i)}updateValue(i,g,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new m,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,g===void 0?r.removeValue(i):r.setValue(i,g),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,g,a){const r=this.getConsolidateConfigurationModel(g,a),v=this.getFolderConfigurationModelForResource(g.resource,a),l=g.resource?this._memoryConfigurationByResource.get(g.resource)||this._memoryConfiguration:this._memoryConfiguration,c=g.overrideIdentifier?this._defaultConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),b=g.overrideIdentifier?this.userConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),h=g.overrideIdentifier?this.localUserConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),y=g.overrideIdentifier?this.remoteUserConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),R=a?g.overrideIdentifier?this._workspaceConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,k=v?g.overrideIdentifier?v.freeze().override(g.overrideIdentifier).getValue(i):v.freeze().getValue(i):void 0,O=g.overrideIdentifier?l.override(g.overrideIdentifier).getValue(i):l.getValue(i),N=r.getValue(i),I=d.distinct(d.flatten(r.overrides.map(B=>B.identifiers))).filter(B=>r.getOverrideValue(i,B)!==void 0);return{defaultValue:c,userValue:b,userLocalValue:h,userRemoteValue:y,workspaceValue:R,workspaceFolderValue:k,memoryValue:O,value:N,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,userRemote:y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:v?.freeze().getValue(i),override:g.overrideIdentifier?v?.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,memory:O!==void 0?{value:l.getValue(i),override:g.overrideIdentifier?l.getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,overrideIdentifiers:I.length?I:void 0}}keys(i){const g=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:g?g.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,g){this._folderConfigurations.set(i,g),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,g){const a=g.filter(r=>_.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const v=(0,_.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(v),c=i.getKeysForOverrideIdentifier(v),b=[...c.filter(h=>l.indexOf(h)===-1),...l.filter(h=>c.indexOf(h)===-1),...l.filter(h=>!P.equals(this._defaultConfiguration.override(v).getValue(h),i.override(v).getValue(h)))];return[v,b]});return this.updateDefaultConfiguration(i),{keys:g,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.localUserConfiguration,i),l=[...g,...a,...r];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:v}}compareAndUpdateRemoteUserConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.remoteUserConfiguration,i);let l=[...g,...a,...r];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:v}}compareAndUpdateWorkspaceConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.workspaceConfiguration,i);let l=[...g,...a,...r];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:v}}compareAndUpdateFolderConfiguration(i,g){const a=this.folderConfigurations.get(i),{added:r,updated:v,removed:l,overrides:c}=(0,t.compare)(a,g);let b=[...r,...v,...l];return(b.length||!a)&&this.updateFolderConfiguration(i,g),{keys:b,overrides:c}}compareAndDeleteFolderConfiguration(i){const g=this.folderConfigurations.get(i);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:r,removed:v,overrides:l}=(0,t.compare)(g,void 0);return{keys:[...a,...r,...v],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,g){let a=this.getConsolidatedConfigurationModelForResource(i,g);return i.overrideIdentifier?a.override(i.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:i},g){let a=this.getWorkspaceConsolidatedConfiguration();if(g&&i){const r=g.getFolder(i);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const v=this._memoryConfigurationByResource.get(i);v&&(a=a.merge(v))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let g=this._foldersConsolidatedConfigurations.get(i);if(!g){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(g=a.merge(r),this._freeze&&(g=g.freeze()),this._foldersConsolidatedConfigurations.set(i,g)):g=a}return g}getFolderConfigurationModelForResource(i,g){if(g&&i){const a=g.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,g)=>{const{contents:a,overrides:r,keys:v}=this._folderConfigurations.get(g);return i.push([g,{contents:a,overrides:r,keys:v}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(g=>i.add(g)),this.userConfiguration.freeze().keys.forEach(g=>i.add(g)),this._workspaceConfiguration.freeze().keys.forEach(g=>i.add(g)),this._folderConfigurations.forEach(g=>g.freeze().keys.forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const g=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(r=>g.add(r))),[...g.values()]}static parse(i){const g=this.parseConfigurationModel(i.defaults),a=this.parseConfigurationModel(i.user),r=this.parseConfigurationModel(i.workspace),v=i.folders.reduce((l,c)=>(l.set(T.URI.revive(c[0]),this.parseConfigurationModel(c[1])),l),new F.ResourceMap);return new C(g,a,new m,r,v,new m,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new m(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=C;function w(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const i=new Set,g=new Map;for(const r of S)r.keys.forEach(v=>i.add(v)),r.overrides.forEach(([v,l])=>{const c=(0,F.getOrSet)(g,v,new Set);l.forEach(b=>c.add(b))});const a=[];return g.forEach((r,v)=>a.push([v,[...r.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=w;class o{constructor(i,g,a,r){this.change=i,this.previous=g,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const v=new Set;i.keys.forEach(c=>v.add(c)),i.overrides.forEach(([,c])=>c.forEach(b=>v.add(b))),this.affectedKeys=[...v.values()];const l=new m;this.affectedKeys.forEach(c=>l.setValue(c,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,g){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(g){const a=this.previousConfiguration?this.previousConfiguration.getValue(i,g,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,g,this.currentWorkspace);return!P.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(i,g){let a=(0,t.toValuesTree)({[g]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(i=i[r],!i)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=o;class f extends o{constructor(i,g,a,r){super({keys:i.allKeys(),overrides:[]},void 0,i,g);this.source=a,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=f}),define(be[86],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(F,P=M.Unknown,D){super(F);this._message=F,this._code=P,this._detail=D,this.isHandled=P===M.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(F){return F instanceof E&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof E&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof E&&F.isHandled}}e.RemoteAuthorityResolverError=E}),define(be[63],Ee([0,1,11]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(T){return T.scheme===d.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=M;function E(T){if(!T)return;const t=T.indexOf("+");return t<0?T:T.substr(0,t)}e.getRemoteName=E;function A(T){return T.scheme!==d.Schemas.file&&T.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=A;function F(T){if(T.folders.length)return T.folders.every(t=>A(t.uri))?T.folders[0].uri:void 0;if(T.configuration&&A(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=F;function P(T){return F(T)?.scheme}e.getVirtualWorkspaceScheme=P;function D(T){return F(T)!==void 0}e.isVirtualWorkspace=D}),define(be[26],Ee([0,1,9,4,63]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=A;function F(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class D{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,s){if(typeof m=="undefined"||m===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof m=="string"||typeof s=="string"){let u=typeof m=="string"?m:m.value,p=typeof s=="string"?s:s.value;return d.equalsIgnoreCase(u,p)}return m._lower===s._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=D;function T(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function t(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=t;function _(n,m){if(m&&n.enableProposedApi){const s=`onResolveRemoteAuthority:${(0,E.getRemoteName)(m)}`;return n.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[147],Ee([0,1,9,26]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(s,u){return s.uuid&&u.uuid?s.uuid===u.uuid:s.id===u.id?!0:(0,d.compareIgnoreCase)(s.id,u.id)===0}e.areSameExtensions=E;class A{constructor(u,p){this.version=p,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof A?E(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=A;function F(s,u){return`${s}.${u}`}e.getExtensionId=F;function P(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function D(s,u){return P(F(s,u))}e.getGalleryExtensionId=D;function T(s,u){const p=[],C=w=>{for(const o of p)if(o.some(f=>E(u(f),u(w))))return o;return null};for(const w of s){const o=C(w);o?o.push(w):p.push([w])}return p}e.groupByExtension=T;function t(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function _(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(s){const u=new Set;for(const p of s)p.malicious&&u.add(p.id.id);return u}e.getMaliciousExtensionsSet=n;function m(s,u){const p=[],C=u.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const w=C.shift();if(w&&p.every(o=>!E(o.identifier,{id:w}))){const o=s.filter(f=>E(f.identifier,{id:w}));o.length===1&&(p.push(o[0]),C.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=m}),define(be[148],Ee([0,1,3,25,4,15]),function(oe,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,E.createDecorator)("sharedTunnelsService");var F;(function(s){s.Http="http",s.Https="https"})(F=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=_;function n(s,u){return u?u!==1&&s<1024:!M.isWindows&&s<1024}e.isPortPrivileged=n;let m=class{constructor(u){this.logService=u,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,p){return this._tunnelProvider=u,u?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],p=Array.from(this._tunnels.values());for(let C of p){const w=Array.from(C.values());for(let o of w){const f=await o.value;f&&u.push(f)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:p}of u.values())await p.then(C=>C?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,p,C,w,o=!1,f=P.Private,S){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${C} on local port ${w}.`),!u)return;p||(p="localhost");const i=this.retainOrCreateTunnel(u,p,C,w,o,f,S);return i?i.then(g=>{if(!g){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,C);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(g);return(g.tunnelRemoteHost!==p||g.tunnelRemotePort!==C)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const p=this._tunnels.get(u.tunnelRemoteHost);if(p){const C=p.get(u.tunnelRemotePort);C&&(C.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,C))}}}}async tryDisposeTunnel(u,p,C){if(C.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${p}.`);const w=C.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(p),w}}async closeTunnel(u,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${p} `);const C=this._tunnels.get(u);if(C&&C.has(p)){const w=C.get(p);w.refcount=0,await this.tryDisposeTunnel(u,p,w)}}addTunnelToMap(u,p,C){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(p,{refcount:1,value:C})}async removeEmptyTunnelFromMap(u,p){const C=this._tunnels.get(u);C&&(await C.get(p)||C.delete(p),C.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,p){let C=[u];t(u)?(C.push(...e.LOCALHOST_ADDRESSES),C.push(...e.ALL_INTERFACES_ADDRESSES)):_(u)&&C.push(...e.ALL_INTERFACES_ADDRESSES);const w=C.map(o=>this._tunnels.get(o));for(const o of w){const f=o?.get(p);if(f)return f}}canTunnel(u){return!!T(u)}createWithProvider(u,p,C,w,o,f,S){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${C} on local port ${w}.`);const g={elevationRequired:o?n(w===void 0?C:w):!1},a={remoteAddress:{host:p,port:C},localAddressPort:w,privacy:f,public:f!==P.Private,protocol:S},r=u.forwardPort(a,g);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(p,C,r),r}};m=$e([ze(0,A.ILogService)],m),e.AbstractTunnelService=m}),define(be[149],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,F=5){let P;return P=A(D=>{const T=typeof D=="string"?D:D.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(T);return}const _=setTimeout(()=>this.flushBuffer(E),F);t={data:[T],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(E),P.dispose()}},this._terminalBufferMap.set(E,t)}),P}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=d}),define(be[150],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(be[47],Ee([0,1,34,3,6,4,28,150]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var D;(function(p){function C(w){return w&&typeof w=="object"&&typeof w.id=="string"}p.isThemeColor=C})(D=e.ThemeColor||(e.ThemeColor={}));function T(p){return{id:p}}e.themeColorFromId=T;var t;(function(p){function C(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color=="undefined"||D.isThemeColor(g.color))}p.isThemeIcon=C;const w=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function o(g){const a=w.exec(g);if(!a)return;let[,r]=a;return{id:r}}p.fromString=o;function f(g,a){let r=g.id;const v=r.lastIndexOf("~");return v!==-1&&(r=r.substring(0,v)),a&&(r=`${r}~${a}`),{id:r}}p.modify=f;function S(g,a){return g.id===a.id&&g.color?.id===a.color?.id}p.isEqual=S;function i(g,a){return{id:g.id,color:a?T(a):void 0}}p.asThemeIcon=i,p.asClassNameArray=d.CSSIcon.asClassNameArray,p.asClassName=d.CSSIcon.asClassName,p.asCSSSelector=d.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function _(p){switch(p){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(C){return this.themingParticipants.push(C),this.onThemingParticipantAddedEmitter.fire(C),(0,E.toDisposable)(()=>{const w=this.themingParticipants.indexOf(C);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new n;F.Registry.add(e.Extensions.ThemingContribution,m);function s(p){return m.onColorThemeChange(p)}e.registerThemingParticipant=s;class u extends E.Disposable{constructor(C){super();this.themeService=C,this.theme=C.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(C){this.theme=C,this.updateStyles()}updateStyles(){}getColor(C,w){let o=this.theme.getColor(C);return o&&w&&(o=w(o,this.theme)),o?o.toString():null}}e.Themable=u}),define(be[151],Ee([0,1,12,34,3,122,84,28,47]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(C,w,o,f){const S=this.iconsById[C];if(S){if(o&&!S.description){S.description=o,this.iconSchema.properties[C].markdownDescription=`${o} $(${C})`;const a=this.iconReferenceSchema.enum.indexOf(C);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=o),this._onDidChange.fire()}return S}let i={id:C,description:o,defaults:w,deprecationMessage:f};this.iconsById[C]=i;let g={$ref:"#/definitions/icons"};return f&&(g.deprecationMessage=f),o&&(g.markdownDescription=`${o}: $(${C})`),this.iconSchema.properties[C]=g,this.iconReferenceSchema.enum.push(C),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:C}}deregisterIcon(C){delete this.iconsById[C],delete this.iconSchema.properties[C];const w=this.iconReferenceSchema.enum.indexOf(C);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(C=>this.iconsById[C])}getIcon(C){return this.iconsById[C]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(C,w){const o=this.iconFontsById[C];if(o)return o;let f={id:C,definition:w};return this.iconFontsById[C]=f,this._onDidChange.fire(),f}deregisterIconFont(C){delete this.iconFontsById[C]}getIconFonts(){return Object.keys(this.iconFontsById).map(C=>this.iconFontsById[C])}getIconFont(C){return this.iconFontsById[C]}toString(){const C=(S,i)=>S.id.localeCompare(i.id),w=S=>{for(;D.ThemeIcon.isThemeIcon(S.defaults);)S=this.iconsById[S.defaults.id];return`codicon codicon-${S?S.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(S=>this.iconsById[S]);for(const S of f.filter(i=>!!i.description).sort(C))o.push(`|<i class="${w(S)}"></i>|${S.id}|${D.ThemeIcon.isThemeIcon(S.defaults)?S.defaults.id:S.id}|${S.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const S of f.filter(i=>!D.ThemeIcon.isThemeIcon(i.defaults)).sort(C))o.push(`|<i class="${w(S)}"></i>|${S.id}|`);return o.join(`
`)}}const t=new T;P.Registry.add(e.Extensions.IconContribution,t);function _(p,C,w,o){return t.registerIcon(p,C,w,o)}e.registerIcon=_;function n(){return t}e.getIconRegistry=n;function m(){for(const p of M.iconRegistry.all)t.registerIcon(p.id,p.definition,p.description);M.iconRegistry.onDidRegister(p=>t.registerIcon(p.id,p.definition,p.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let s=P.Registry.as(F.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,t.getIconSchema());const u=new d.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=_("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=_("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=_("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=D.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[48],Ee([0,1,20,24,2,4]),function(oe,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function P(n){const m=n;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=P;function D(n){const m=n;return!!(m&&typeof m=="object"&&E.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=D;class T{constructor(m,s,u,p,C){this._id=m,this._transient=u,this._configuration=p,this._ignorePathCasing=C,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class t{constructor(m,s){this.raw=s,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function _(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(be[64],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(P=>{const D=this._providerInfo.get(P.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(P,D){D===null?this._providerInfo.delete(P):this._providerInfo.set(P,D)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(be[152],Ee([0,1,12]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,P,D){this._deferredPromises=new Map,this._id=F,this._shared=P,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of T.values())t.complete()}catch(t){for(const _ of T.values())_.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,P){let D=this._value[F];return typeof D=="undefined"&&(D=P),D}update(F,P){this._value[F]=P;let D=this._deferredPromises.get(F);if(D!==void 0)return D.p;const T=new d.DeferredPromise;return this._deferredPromises.set(F,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(F,P){super(F.identifier.value,!0,P);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=E}),define(be[153],Ee([0,1,3,2,15]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(P,D){this._logService=P,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,D,T){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P)).acceptModelChanged(D.value,T)}$acceptDirtyStateChanged(P,D){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P)).acceptDirty(D)}$acceptModelSaved(P){const D=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(P,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,D);const T=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P));T.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=$e([ze(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[13],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[154],Ee([0,1,26,3]),function(oe,e,d,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,D){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(P.identifier),Ze(this,E,D,"f"),Re(this,E,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(P){return Re(this,E,"f").get(this._id,P)}store(P,D){return Re(this,E,"f").store(this._id,P,D)}delete(P){return Re(this,E,"f").delete(this._id,P)}}e.ExtensionSecrets=A,E=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(be[49],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(w,o)=>{const f={controllerId:o};return M.set(w,f),f};e.createPrivateApiFor=E;const A=w=>M.get(w);e.getPrivateApiFor=A;const F=(w,o,f,S)=>{let i=f;return{enumerable:!0,configurable:!1,get(){return i},set(g){if(!S(i,g)){const a=i;i=g,w.listener?.({op:3,key:o,value:g,previous:a})}}}},P=(w,o)=>w===o,D={range:(w,o)=>w===o?!0:!w||!o?!1:w.isEqual(o),label:P,description:P,busy:P,error:P,canResolveChildren:P,tags:(w,o)=>!(w.length!==o.length||w.some(f=>!o.find(S=>f.id===S.id)))},T=Object.keys(D),t=(w,o)=>({range:F(w,"range",void 0,D.range),label:F(w,"label",o,D.label),description:F(w,"description",void 0,D.description),canResolveChildren:F(w,"canResolveChildren",!1,D.canResolveChildren),busy:F(w,"busy",!1,D.busy),error:F(w,"error",void 0,D.error),tags:F(w,"tags",[],D.tags)}),_=(w,o)=>{const f=new Map;for(const S of T)D[S](w[S],o[S])||f.set(S,o[S]);return f};e.diffTestItems=_;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class m extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class s extends Error{constructor(o,f,S){super(`TestItem with ID "${o}" is from controller "${f}" and cannot be added as a child of an item from controller "${S}".`)}}e.MixedTestItemController=s;const u=w=>{const o=(0,e.getPrivateApiFor)(w);let f=new Map;return{get size(){return f.size},forEach(S,i){for(const g of f.values())S.call(i,g,this)},replace(S){const i=new Map,g=new Set(f.keys()),a={op:4,ops:[]};for(const r of S){if(!(r instanceof p))throw new m(r.id);const v=(0,e.getPrivateApiFor)(r).controllerId;if(v!==o.controllerId)throw new s(r.id,v,o.controllerId);if(i.has(r.id))throw new n(r.id);i.set(r.id,r),g.delete(r.id),a.ops.push({op:0,item:r})}for(const r of g.keys())a.ops.push({op:1,id:r});o.listener?.(a),f=i},add(S){if(!(S instanceof p))throw new m(S.id);f.set(S.id,S),o.listener?.({op:0,item:S})},delete(S){f.delete(S)&&o.listener?.({op:1,id:S})},get(S){return f.get(S)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class p{constructor(o,f,S,i){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const g=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof C?void 0:g.parent}},children:{value:u(this),enumerable:!0,writable:!1},...t(g,S)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class C extends p{constructor(o,f){super(o,o,f,void 0)}}e.TestItemRootImpl=C}),define(be[65],Ee([0,1,4,148,3,13]),function(oe,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var F;(function(D){function T(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:_.protocol}}D.fromApiTunnel=T;function t(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==M.TunnelPrivacyId.ConstantPrivate&&_.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}D.fromServiceTunnel=t})(F=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let P=class{constructor(T){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,t){return{dispose:()=>{}}}async $providePortAttributes(T,t,_,n,m){return[]}async $forwardPort(T,t){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=$e([ze(0,A.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[7],Ee([0,1,14,16,77,20,79,9,10,2,36,60,86]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n){"use strict";var m,s,u,p,C,w,o,f,S,i,g,a,r,v,l,c,b,h,y,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(U){function L(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(L,U),Object.setPrototypeOf(L.prototype,U.prototype),L}let O=C=class{constructor(L){m.set(this,void 0),Ze(this,m,L,"f")}static from(...L){let ne=L;return new C(function(){if(ne){for(const _e of ne)_e&&typeof _e.dispose=="function"&&_e.dispose();ne=void 0}})}dispose(){typeof Re(this,m,"f")=="function"&&(Re(this,m,"f").call(this),Ze(this,m,void 0,"f"))}};m=new WeakMap,O=C=$e([k],O),e.Disposable=O;let N=w=class{constructor(L,ne){if(L<0)throw(0,M.illegalArgument)("line must be non-negative");if(ne<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=L,this._character=ne}static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let _e=1;_e<L.length;_e++){const Ge=L[_e];Ge.isBefore(ne)&&(ne=Ge)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let _e=1;_e<L.length;_e++){const Ge=L[_e];Ge.isAfter(ne)&&(ne=Ge)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof w)return!0;let{line:ne,character:_e}=L;return typeof ne=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ne=0){if(L===null||ne===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&ne===0?this:new w(this.line+_e,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),_e===this.line&&ne===this.character?this:new w(_e,ne)}toJSON(){return{line:this.line,character:this.character}}};N=w=$e([k],N),e.Position=N;let I=o=class{constructor(L,ne,_e,Ge){let tt,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new N(L,ne),ot=new N(_e,Ge)):L instanceof N&&ne instanceof N&&(tt=L,ot=ne),!tt||!ot)throw new Error("Invalid arguments");tt.isBefore(ot)?(this._start=tt,this._end=ot):(this._start=ot,this._end=tt)}static isRange(L){return L instanceof o?!0:L?N.isPosition(L.start)&&N.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof o?this.contains(L._start)&&this.contains(L._end):L instanceof N?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ne=N.Max(L.start,this._start),_e=N.Min(L.end,this._end);if(!ne.isAfter(_e))return new o(ne,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=N.Min(L.start,this._start),_e=N.Max(L.end,this.end);return new o(ne,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ne=this.end){if(L===null||ne===null)throw(0,M.illegalArgument)();let _e;return L?N.isPosition(L)?_e=L:(_e=L.start||this.start,ne=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&ne.isEqual(this.end)?this:new o(_e,ne)}toJSON(){return[this.start,this.end]}};I=o=$e([k],I),e.Range=I;let B=f=class extends I{constructor(L,ne,_e,Ge){let tt,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new N(L,ne),ot=new N(_e,Ge)):L instanceof N&&ne instanceof N&&(tt=L,ot=ne),!tt||!ot)throw new Error("Invalid arguments");super(tt,ot);this._anchor=tt,this._active=ot}static isSelection(L){return L instanceof f?!0:L?I.isRange(L)&&N.isPosition(L.anchor)&&N.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};B=f=$e([k],B),e.Selection=B;class x{constructor(L,ne,_e){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ne),this.connectionToken=_e}}e.ResolvedAuthority=x;class V extends Error{constructor(L,ne=n.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=ne,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(L,ne){return new V(L,n.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new V(L,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var H;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var W;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=S=class{constructor(L,ne){this._range=L,this._newText=ne}static isTextEdit(L){return L instanceof S?!0:L?I.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new S(L,ne)}static insert(L,ne){return S.replace(new I(L,L),ne)}static delete(L){return S.replace(L,"")}static setEndOfLine(L){const ne=new S(new I(new N(0,0),new N(0,0)),"");return ne.newEol=L,ne}get range(){return this._range}set range(L){if(L&&!I.isRange(L))throw(0,M.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,M.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,M.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=S=$e([k],ee),e.TextEdit=ee;var q;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(q=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ne,_e,Ge){this._edits.push({_type:1,from:L,to:ne,options:_e,metadata:Ge})}createFile(L,ne,_e){this._edits.push({_type:1,from:void 0,to:L,options:ne,metadata:_e})}deleteFile(L,ne,_e){this._edits.push({_type:1,from:L,to:void 0,options:ne,metadata:_e})}replaceNotebookMetadata(L,ne,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(L,ne,_e,Ge,tt){let ot,lt,Dt=[],Rt;if(Ht.isNotebookRange(ne)&&Te.isNotebookCellDataArray(_e)&&!Te.isNotebookCellDataArray(Ge)?(ot=ne.start,lt=ne.end,Dt=_e,Rt=Ge):typeof ne=="number"&&typeof _e=="number"&&Te.isNotebookCellDataArray(Ge)&&(ot=ne,lt=_e,Dt=Ge,Rt=tt),ot===void 0||lt===void 0)throw new Error("Invalid arguments");(ot!==lt||Dt.length>0)&&this._edits.push({_type:5,uri:L,index:ot,count:lt-ot,cells:Dt,metadata:Rt})}replaceNotebookCellMetadata(L,ne,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:L,edit:{editType:8,index:ne,metadata:_e}})}replace(L,ne,_e,Ge){this._edits.push({_type:2,uri:L,edit:new ee(ne,_e),metadata:Ge})}insert(L,ne,_e,Ge){this.replace(L,new I(ne,ne),_e,Ge)}delete(L,ne,_e){this.replace(L,ne,"",_e)}has(L){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const _e of ne)_e&&this._edits.push({_type:2,uri:L,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(L){const ne=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&ne.push(_e.edit);return ne}entries(){const L=new A.ResourceMap;for(let ne of this._edits)if(ne._type===2){let _e=L.get(ne.uri);_e||(_e=[ne.uri,[]],L.set(ne.uri,_e)),_e[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=$e([k],Y),e.WorkspaceEdit=Y;let j=i=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof i?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=i._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this._tabstop++){if(typeof L=="function"){const _e=new i;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=i._escape(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this._tabstop++){const _e=L.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const _e=new i;_e._tabstop=this._tabstop,ne(_e),this._tabstop=_e._tabstop,ne=_e.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};j=i=$e([k],j),e.SnippetString=j;var le;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(le=e.DiagnosticTag||(e.DiagnosticTag={}));var re;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(re=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ve=g=class{constructor(L,ne){if(this.uri=L,ne)if(ne instanceof I)this.range=ne;else if(ne instanceof N)this.range=new I(ne,ne);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof g?!0:L?I.isRange(L.range)&&T.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ve=g=$e([k],ve),e.Location=ve;let Fe=class{constructor(L,ne){this.location=L,this.message=ne}static is(L){return L?typeof L.message=="string"&&L.location&&I.isRange(L.location.range)&&T.URI.isUri(L.location.uri):!1}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};Fe=$e([k],Fe),e.DiagnosticRelatedInformation=Fe;let Me=class{constructor(L,ne,_e=re.Error){if(!I.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=_e}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&(0,d.equals)(L.tags,ne.tags)&&(0,d.equals)(L.relatedInformation,ne.relatedInformation,Fe.isEqual)}};Me=$e([k],Me),e.Diagnostic=Me;let Oe=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};Oe=$e([k],Oe),e.Hover=Oe;var Ke;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let qe=class{constructor(L,ne=Ke.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:Ke[this.kind]}}};qe=$e([k],qe),e.DocumentHighlight=qe;var Ve;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var $;(function(U){U[U.Deprecated=1]="Deprecated"})($=e.SymbolTag||(e.SymbolTag={}));let Q=a=class{constructor(L,ne,_e,Ge,tt){this.name=L,this.kind=ne,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof ve?this.location=Ge:_e instanceof I&&(this.location=new ve(Ge,_e)),a.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};Q=a=$e([k],Q),e.SymbolInformation=Q;let te=r=class{constructor(L,ne,_e,Ge,tt){this.name=L,this.detail=ne,this.kind=_e,this.range=Ge,this.selectionRange=tt,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};te=r=$e([k],te),e.DocumentSymbol=te;var ae;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let K=class{constructor(L,ne){this.title=L,this.kind=ne}};K=$e([k],K),e.CodeAction=K;let se=v=class{constructor(L){this.value=L}append(L){return new v(this.value?this.value+v.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+v.sep)}};se.sep=".",se=v=$e([k],se),e.CodeActionKind=se,se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll");let he=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};he=$e([k],he),e.SelectionRange=he;class Ae{constructor(L,ne,_e,Ge,tt,ot){this.kind=L,this.name=ne,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=ot}}e.CallHierarchyItem=Ae;class Ue{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.CallHierarchyIncomingCall=Ue;class He{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.CallHierarchyOutgoingCall=He;var Qe;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};et=$e([k],et),e.CodeLens=et;let st=l=class{constructor(L,ne=!1){s.set(this,void 0),Ze(this,s,new E.MarkdownString(L,{supportThemeIcons:ne}),"f")}static isMarkdownString(L){return L instanceof l?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Re(this,s,"f").value}set value(L){Re(this,s,"f").value=L}get isTrusted(){return Re(this,s,"f").isTrusted}set isTrusted(L){Re(this,s,"f").isTrusted=L}get supportThemeIcons(){return Re(this,s,"f").supportThemeIcons}set supportThemeIcons(L){Re(this,s,"f").supportThemeIcons=L}get supportHtml(){return Re(this,s,"f").supportHtml}set supportHtml(L){Re(this,s,"f").supportHtml=L}appendText(L){return Re(this,s,"f").appendText(L),this}appendMarkdown(L){return Re(this,s,"f").appendMarkdown(L),this}appendCodeblock(L,ne){return Re(this,s,"f").appendCodeblock(ne??"",L),this}};s=new WeakMap,st=l=$e([k],st),e.MarkdownString=st;let ye=class{constructor(L,ne){this.label=L,this.documentation=ne}};ye=$e([k],ye),e.ParameterInformation=ye;let nt=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};nt=$e([k],nt),e.SignatureInformation=nt;let G=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};G=$e([k],G),e.SignatureHelp=G;var Z;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(Z=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(pe=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor(L,ne,_e){this.text=L,this.position=ne,this.kind=_e}};We=$e([k],We),e.InlayHint=We;var Ye;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var rt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(rt=e.CompletionItemKind||(e.CompletionItemKind={}));var mt;(function(U){U[U.Deprecated=1]="Deprecated"})(mt=e.CompletionItemTag||(e.CompletionItemTag={}));let ut=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ut=$e([k],ut),e.CompletionItem=ut;let St=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};St=$e([k],St),e.CompletionList=St;let Tt=class{constructor(L,ne,_e){this.text=L,this.range=ne,this.command=_e}};Tt=$e([k],Tt),e.InlineSuggestion=Tt;let It=class{constructor(L){this.items=L}};It=$e([k],It),e.InlineSuggestions=It;var Xe;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Xe=e.ViewColumn||(e.ViewColumn={}));var vt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(vt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Se;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ce;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ie;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var me;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(me=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function L(ne){switch(ne){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let fe=class{constructor(L,ne){if(ne&&!T.URI.isUri(ne))throw(0,M.illegalArgument)("target");if(!I.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.target=ne}};fe=$e([k],fe),e.DocumentLink=fe;let Ie=class{constructor(L,ne,_e,Ge){this.red=L,this.green=ne,this.blue=_e,this.alpha=Ge}};Ie=$e([k],Ie),e.Color=Ie;let Be=class{constructor(L,ne){if(ne&&!(ne instanceof Ie))throw(0,M.illegalArgument)("color");if(!I.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.color=ne}};Be=$e([k],Be),e.ColorInformation=Be;let Ne=class{constructor(L){if(!L||typeof L!="string")throw(0,M.illegalArgument)("label");this.label=L}};Ne=$e([k],Ne),e.ColorPresentation=Ne;var je;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(je=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Le{constructor(L,ne,_e){if(this.startIndex=L,this.length=ne,this.tooltip=_e,typeof L!="number"||L<0)throw(0,M.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Le;var de;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(de=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(L){this.options=L,typeof L!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=ge;var X;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(X=e.TaskRevealKind||(e.TaskRevealKind={}));var z;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(z=e.TaskPanelKind||(e.TaskPanelKind={}));let we=c=class{constructor(L,ne){if(this.label=ne,typeof L!="string"||typeof ne!="string")throw(0,M.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};we.Clean=new c("clean","Clean"),we.Build=new c("build","Build"),we.Rebuild=new c("rebuild","Rebuild"),we.Test=new c("test","Test"),we=c=$e([k],we),e.TaskGroup=we;function ke(U){let L="";for(let ne=0;ne<U.length;ne++)L+=U[ne].replace(/,/g,",,")+",";return L}let Je=class{constructor(L,ne,_e){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=L,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=_e):this._options=ne)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)L.push(ne);return ke(L)}};Je=$e([k],Je),e.ProcessExecution=Je;let xe=class{constructor(L,ne,_e){if(this._args=[],Array.isArray(ne)){if(!L)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L,this._args=ne,this._options=_e}else{if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)L.push(typeof ne=="string"?ne:ne.value);return ke(L)}};xe=$e([k],xe),e.ShellExecution=xe;var ct;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ct=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class dt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,t.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=dt;let ht=b=class{constructor(L,ne,_e,Ge,tt,ot){this.__deprecated=!1,this._definition=this.definition=L;let lt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=_e,this.execution=Ge,lt=tt,this.__deprecated=!0):ne===pt.Global||ne===pt.Workspace?(this.target=ne,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,lt=ot):(this.target=ne,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,lt=ot),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Je?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof dt?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,t.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ne=this._definition.type;(b.EmptyType===ne||b.ProcessType===ne||b.ShellType===ne||b.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=b=$e([k],ht),e.Task=ht;var ft;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(L,ne=yt.None){this.collapsibleState=ne,T.URI.isUri(L)?this.resourceUri=L:this.label=L}};_t=$e([k],_t),e.TreeItem=_t;var yt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(yt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Pt=class{constructor(L,ne){this.id=L,this.color=ne}};Pt=$e([k],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let Nt=class{constructor(L){this.id=L}};Nt=$e([k],Nt),e.ThemeColor=Nt;var Ct;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Ct=e.ConfigurationTarget||(e.ConfigurationTarget={}));let xt=class{constructor(L,ne){if(typeof L!="string"&&(!L||!T.URI.isUri(L)&&!T.URI.isUri(L.uri)))throw(0,M.illegalArgument)("base");if(typeof ne!="string")throw(0,M.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=T.URI.file(L),this.base=L):T.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ne}};xt=$e([k],xt),e.RelativePattern=xt;let $t=class{constructor(L,ne,_e,Ge){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,t.generateUuid)()),this._id}};$t=$e([k],$t),e.Breakpoint=$t;let bt=class extends $t{constructor(L,ne,_e,Ge,tt){super(ne,_e,Ge,tt);if(L===null)throw(0,M.illegalArgument)("location");this.location=L}};bt=$e([k],bt),e.SourceBreakpoint=bt;let Qt=class extends $t{constructor(L,ne,_e,Ge,tt){super(ne,_e,Ge,tt);this.functionName=L}};Qt=$e([k],Qt),e.FunctionBreakpoint=Qt;let zt=class extends $t{constructor(L,ne,_e,Ge,tt,ot,lt){super(Ge,tt,ot,lt);if(!ne)throw(0,M.illegalArgument)("dataId");this.label=L,this.dataId=ne,this.canPersist=_e}};zt=$e([k],zt),e.DataBreakpoint=zt;let ii=class{constructor(L,ne,_e){this.command=L,this.args=ne||[],this.options=_e}};ii=$e([k],ii),e.DebugAdapterExecutable=ii;let ni=class{constructor(L,ne){this.port=L,this.host=ne}};ni=$e([k],ni),e.DebugAdapterServer=ni;let At=class{constructor(L){this.path=L}};At=$e([k],At),e.DebugAdapterNamedPipeServer=At;let Yt=class{constructor(L){this.implementation=L}};Yt=$e([k],Yt),e.DebugAdapterInlineImplementation=Yt;let ri=class{constructor(L,ne){this.range=L,this.expression=ne}};ri=$e([k],ri),e.EvaluatableExpression=ri;var Jt;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(Jt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(L,ne){this.range=L,this.text=ne}};Wt=$e([k],Wt),e.InlineValueText=Wt;let gt=class{constructor(L,ne,_e=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=_e}};gt=$e([k],gt),e.InlineValueVariableLookup=gt;let si=class{constructor(L,ne){this.range=L,this.expression=ne}};si=$e([k],si),e.InlineValueEvaluatableExpression=si;let Mt=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};Mt=$e([k],Mt),e.InlineValueContext=Mt;var Vt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Xt=h=class extends Error{constructor(L,ne=_.FileSystemProviderErrorCode.Unknown,_e){super(T.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new h(L,_.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(L){return new h(L,_.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(L){return new h(L,_.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(L){return new h(L,_.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(L){return new h(L,_.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(L){return new h(L,_.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};Xt=h=$e([k],Xt),e.FileSystemError=Xt;let oi=class{constructor(L,ne,_e){this.start=L,this.end=ne,this.kind=_e}};oi=$e([k],oi),e.FoldingRange=oi;var di;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(di=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var hi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(hi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.SemanticTokensLegend=Zt;function bi(U){return typeof U=="undefined"||(0,D.isStringArray)(U)}class qt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ne=0,_e=L.tokenTypes.length;ne<_e;ne++)this._tokenTypeStrToInt.set(L.tokenTypes[ne],ne);for(let ne=0,_e=L.tokenModifiers.length;ne<_e;ne++)this._tokenModifierStrToInt.set(L.tokenModifiers[ne],ne)}}push(L,ne,_e,Ge,tt){if(typeof L=="number"&&typeof ne=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,ne,_e,Ge,tt);if(I.isRange(L)&&typeof ne=="string"&&bi(_e))return this._push(L,ne,_e);throw(0,M.illegalArgument)()}_push(L,ne,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ge=L.start.line,tt=L.start.character,ot=L.end.character-L.start.character,lt=this._tokenTypeStrToInt.get(ne);let Dt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(Rt);Dt|=1<<Lt>>>0}this._pushEncoded(Ge,tt,ot,lt,Dt)}_pushEncoded(L,ne,_e,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Rt=0,Lt=0;for(let Ot=0;Ot<Dt;Ot++){let Bt=this._data[5*Ot],ui=this._data[5*Ot+1];Bt===0?(Bt=Rt,ui+=Lt):Bt+=Rt,this._data[5*Ot]=Bt,this._data[5*Ot+1]=ui,Rt=Bt,Lt=ui}}let ot=L,lt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=ne}static _sortAndDeltaEncode(L){let ne=[];const _e=L.length/5|0;for(let lt=0;lt<_e;lt++)ne[lt]=lt;ne.sort((lt,Dt)=>{const Rt=L[5*lt],Lt=L[5*Dt];if(Rt===Lt){const Ot=L[5*lt+1],Bt=L[5*Dt+1];return Ot-Bt}return Rt-Lt});const Ge=new Uint32Array(L.length);let tt=0,ot=0;for(let lt=0;lt<_e;lt++){const Dt=5*ne[lt],Rt=L[Dt+0],Lt=L[Dt+1],Ot=L[Dt+2],Bt=L[Dt+3],ui=L[Dt+4],Bi=Rt-tt,Gi=Bi===0?Lt-ot:Lt,ci=5*lt;Ge[ci+0]=Bi,Ge[ci+1]=Gi,Ge[ci+2]=Ot,Ge[ci+3]=Bt,Ge[ci+4]=ui,tt=Rt,ot=Lt}return Ge}build(L){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),L):new jt(qt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=qt;class jt{constructor(L,ne){this.resultId=ne,this.data=L}}e.SemanticTokens=jt;class Ei{constructor(L,ne,_e){this.start=L,this.deleteCount=ne,this.data=_e}}e.SemanticTokensEdit=Ei;class _i{constructor(L,ne){this.resultId=ne,this.edits=L}}e.SemanticTokensEdits=_i;var Gt;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Pt("arrow-left")},ei=$e([k],ei),e.QuickInputButtons=ei;var Si;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(L,ne,_e){this.badge=L,this.tooltip=ne,this.color=_e}static validate(L){if(L.badge){let ne=(0,P.nextCharLength)(L.badge,0);if(ne<L.badge.length&&(ne+=(0,P.nextCharLength)(L.badge,ne)),L.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Di;let Kt=class{constructor(L){this.kind=L}};Kt=$e([k],Kt),e.ColorTheme=Kt;var fi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(fi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(L,ne){if(L<0)throw(0,M.illegalArgument)("start must be positive");if(ne<0)throw(0,M.illegalArgument)("end must be positive");L<=ne?(this._start=L,this._end=ne):(this._start=ne,this._end=L)}static isNotebookRange(L){return L instanceof Ht?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ne=this._start,_e=this._end;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(_e=L.end),ne===this._start&&_e===this._end?this:new Ht(ne,_e)}}e.NotebookRange=Ht;class Te{constructor(L,ne,_e,Ge,tt,ot,lt){this.kind=L,this.value=ne,this.languageId=_e,this.mime=Ge,this.outputs=tt??[],this.metadata=ot,this.executionSummary=lt,Te.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>Te.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Te;class ai{constructor(L){this.cells=L}}e.NotebookData=ai;class Ft{constructor(L,ne){this.data=L,this.mime=ne;const _e=(0,F.normalizeMimeType)(ne,!0);if(!_e)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof Ft?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return Ft.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return Ft.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Ft.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new Ft(L,ne)}static text(L,ne=F.Mimes.text){const _e=Re(Ft,u,"f",p).encode(String(L));return new Ft(_e,ne)}static json(L,ne="application/json"){const _e=JSON.stringify(L,void 0,"	");return Ft.text(_e,ne)}}e.NotebookCellOutputItem=Ft,u=Ft,p={value:new TextEncoder};class wt{constructor(L,ne,_e){this.items=wt.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=_e):(this.id=(0,t.generateUuid)(),this.metadata=ne??_e)}static isNotebookCellOutput(L){return L instanceof wt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,D.isArray)(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const _e=new Set,Ge=new Set;for(let tt=0;tt<L.length;tt++){const ot=L[tt],lt=(0,F.normalizeMimeType)(ot.mime);if(!_e.has(lt)){_e.add(lt);continue}Ge.add(tt),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ge.size===0?L:L.filter((tt,ot)=>!Ge.has(ot))}}e.NotebookCellOutput=wt;var Ci;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ci=e.NotebookCellKind||(e.NotebookCellKind={}));var ki;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(mi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ii{constructor(L,ne){this.text=L,this.alignment=ne}}e.NotebookCellStatusBarItem=Ii;var Pi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Pi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ti{constructor(L,ne=[]){this.uri=L,this.provides=(0,d.asArray)(ne)}}e.NotebookRendererScript=Ti;let li=class{constructor(L,ne){this.label=L,this.timestamp=ne}};li=$e([k],li),e.TimelineItem=li;var pi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(pi=e.ExtensionMode||(e.ExtensionMode={}));var Ai;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Ai=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ri;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Ri=e.StandardTokenType||(e.StandardTokenType={}));class Fi{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.LinkedEditingRanges=Fi;class Mi{constructor(L,ne){this._port=L,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var Li;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Li=e.TestResultState||(e.TestResultState={}));var J;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(J=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ce=class{constructor(L=void 0,ne=void 0,_e=void 0){this.include=L,this.exclude=ne,this.profile=_e}};ce=$e([k],ce),e.TestRunRequest=ce;let De=y=class{constructor(L){this.message=L}static diff(L,ne,_e){const Ge=new y(L);return Ge.expectedOutput=ne,Ge.actualOutput=_e,Ge}};De=y=$e([k],De),e.TestMessage=De;let at=class{constructor(L){this.id=L}};at=$e([k],at),e.TestTag=at;let Et=class{constructor(L,ne){this.covered=L,this.total=ne}};Et=$e([k],Et),e.CoveredCount=Et;let kt=R=class{constructor(L,ne,_e,Ge){this.uri=L,this.statementCoverage=ne,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(L,ne){const _e=new Et(0,0),Ge=new Et(0,0),tt=new Et(0,0);for(const lt of ne)if("branches"in lt){_e.total+=1,_e.covered+=lt.executionCount>0?1:0;for(const Dt of lt.branches)Ge.total+=1,Ge.covered+=Dt.executionCount>0?1:0}else tt.total+=1,tt.covered+=lt.executionCount>0?1:0;const ot=new R(L,_e,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return ot.detailedCoverage=ne,ot}};kt=R=$e([k],kt),e.FileCoverage=kt;let Oi=class{constructor(L,ne,_e=[]){this.executionCount=L,this.location=ne,this.branches=_e}};Oi=$e([k],Oi),e.StatementCoverage=Oi;let Ni=class{constructor(L,ne){this.executionCount=L,this.location=ne}};Ni=$e([k],Ni),e.BranchCoverage=Ni;let xi=class{constructor(L,ne){this.executionCount=L,this.location=ne}};xi=$e([k],xi),e.FunctionCoverage=xi;var zi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vi;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Vi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qi;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(L,ne,_e,Ge,tt,ot){this.kind=L,this.name=ne,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=ot}}e.TypeHierarchyItem=ji}),define(be[88],Ee([0,1,42,11,9,228,117,7,14]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function t(s,u){u?T.set(s,u):T.delete(s)}e.setWordDefinitionFor=t;function _(s){return T.get(s)}e.getWordDefinitionFor=_;class n extends A.MirrorTextModel{constructor(u,p,C,w,o,f,S,i){super(p,C,w,o);this._proxy=u,this._languageId=f,this._isDirty=S,this._notebook=i,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,D.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===M.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(p){return p?u._getTextInRange(p):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(p){return u._lineAt(p)},offsetAt(p){return u._offsetAt(p)},positionAt(p){return u._positionAt(p)},validateRange(p){return u._validateRange(p)},validatePosition(p){return u._validatePosition(p)},getWordRangeAtPosition(p,C){return u._getWordRangeAtPosition(p,C)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,d.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,d.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const p=this._validateRange(u);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const C=this._eol,w=p.start.line,o=p.end.line,f=[];f.push(this._lines[w].substring(p.start.character));for(let S=w+1;S<o;S++)f.push(this._lines[S]);return f.push(this._lines[o].substring(0,p.end.character)),f.join(C)}_lineAt(u){let p;if(u instanceof P.Position?p=u.line:typeof u=="number"&&(p=u),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new m(p,this._lines[p],p===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(u),C=this._lines[p.index].length;return new P.Position(p.index,Math.min(p.remainder,C))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const p=this._validatePosition(u.start),C=this._validatePosition(u.end);return p===u.start&&C===u.end?u:new P.Range(p.line,p.character,C.line,C.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:p,character:C}=u,w=!1;if(p<0)p=0,C=0,w=!0;else if(p>=this._lines.length)p=this._lines.length-1,C=this._lines[p].length,w=!0;else{const o=this._lines[p].length;C<0?(C=0,w=!0):C>o&&(C=o,w=!0)}return w?new P.Position(p,C):u}_getWordRangeAtPosition(u,p){const C=this._validatePosition(u);if(!p)p=_(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const w=(0,F.getWordAtText)(C.character+1,(0,F.ensureValidWordDefinition)(p),this._lines[C.line],0);if(w)return new P.Range(C.line,w.startColumn-1,C.line,w.endColumn-1)}}e.ExtHostDocumentData=n;class m{constructor(u,p,C){this._line=u,this._text=p,this._isLastLine=C}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(be[155],Ee([0,1,7,3,229,6,56,20,2,36]),function(oe,e,d,M,E,A,F,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,m,s,u){this._notebook=s,this._selector=u,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(C=>{const w=this._cellUris.get(C.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=C=>{C===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(C=>p(C.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const n=[],m=[];for(const s of this._notebook.getCells())s.kind===d.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),m.push(s.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(n){if(!n){let w="";for(const o of this._cells)w+=o.document.getText()+`
`;return w=w.slice(0,-1),w}if(n.isEmpty)return"";const m=this.locationAt(n.start),s=this.locationAt(n.end),u=this._cellUris.get(m.uri),p=this._cellUris.get(s.uri);if(u===void 0||p===void 0)return"";if(u===p)return this._cells[u].document.getText(new d.Range(m.range.start,s.range.end));const C=[this._cells[u].document.getText(new d.Range(m.range.start,new d.Position(this._cells[u].document.lineCount,0)))];for(let w=u+1;w<p;w++)C.push(this._cells[w].document.getText());return C.push(this._cells[p].document.getText(new d.Range(new d.Position(0,0),s.range.end))),C.join(`
`)}offsetAt(n){const m=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(m.index-1),u=this._cells[m.index].document.offsetAt(n.with(m.remainder));return s+u}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),u=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(u)}const m=this._cellUris.get(n.uri);if(m!==void 0){const s=this._cellLines.getPrefixSum(m-1);return new d.Position(s+n.range.start.line,n.range.start.character)}return new d.Position(0,0)}locationAt(n){d.Range.isRange(n)||(n=new d.Range(n,n));const m=this._cellLines.getIndexOf(n.start.line);let s=m;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const u=new d.Position(m.remainder,n.start.character),p=new d.Position(s.remainder,n.end.character),C=new d.Range(u,p),w=this._cells[m.index];return new d.Location(w.document.uri,w.document.validateRange(C))}contains(n){return this._cellUris.has(n)}validateRange(n){const m=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(m,s)}validatePosition(n){const m=this._cellLines.getIndexOf(n.line),s=new d.Position(m.remainder,n.character),u=this._cells[m.index].document.validatePosition(s),p=this._cellLines.getPrefixSum(m.index-1);return new d.Position(p+u.line,u.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[156],Ee([0,1,7,13,3]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let D=P==="light"?d.ColorThemeKind.Light:P==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=$e([ze(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[66],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(be[157],Ee([0,1,22]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(D){let T=this.buffers.indexOf(D);return T<0&&(T=this.buffers.length,this.buffers.push(D)),T}}function E(P,D){if(D.serializeBuffersForPostMessage){const T=new M,t=(m,s)=>{if(s instanceof ArrayBuffer){const u=T.add(s);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(s)){const u=A(s);if(u){const p=T.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:u,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},_=JSON.stringify(P,t),n=T.buffers.map(m=>{const s=new Uint8Array(m);return d.VSBuffer.wrap(s)});return{message:_,buffers:n}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=E;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(P,D){const T=D.map(n=>{const m=new ArrayBuffer(n.byteLength);return new Uint8Array(m).set(n.buffer),m}),t=D.length?(n,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const s=m,{index:u}=s,p=T[u];if(s.view)switch(s.view.type){case 1:return new Int8Array(p,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return m}:void 0;return{message:JSON.parse(P,t),arrayBuffers:T}}e.deserializeWebviewMessage=F}),define(be[158],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(M){function E(F){const P={items:new Map};return F.types.forEach((D,T)=>{P.items.set(D,{asString:async()=>F.items[T].asString})}),P}M.toITreeDataTransfer=E;async function A(F){const P={types:[],items:[]},D=Array.from(F.items.entries());for(const T of D)P.types.push(T[0]),P.items.push({asString:await T[1].asString()});return P}M.toTreeDataTransferDTO=A})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[67],Ee([0,1,11,2]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(P,D){return P.scheme===d.Schemas.http||P.scheme===d.Schemas.https?P:(D&&D.authority&&D.isRemote&&P.scheme===d.Schemas.file&&(P=M.URI.from({scheme:d.Schemas.vscodeRemote,authority:D.authority,path:P.path})),M.URI.from({scheme:d.Schemas.https,authority:`${P.scheme}+${A(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=E;function A(P){return P.replace(/./g,D=>{const T=D.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?D:"-"+T.toString(16).padStart(4,"0")})}function F(P){return P.replace(/-([0-9a-f]{4})/g,(D,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=F}),define(be[159],Ee([0,1,3,6,67]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(P,D,T){this._proxy=P,this._editors=D,this._initData=T,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const t=D.getVisibleTextEditors();for(const _ of this._insets.values())t.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,D,T,t,_){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===P){n=o;break}if(!n)throw new Error("not a visible editor");const m=this,s=this._handlePool++,u=new d.Emitter,p=new d.Emitter,C=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,E.asWebviewUri)(o,m._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(o){this._options=o,m._proxy.$setOptions(s,o)}get options(){return this._options}set html(o){this._html=o,m._proxy.$setHtml(s,o)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(o){return m._proxy.$postMessage(s,o)}},w=new class{constructor(){this.editor=P,this.line=D,this.height=T,this.webview=C,this.onDidDispose=p.event}dispose(){m._insets.has(s)&&(m._insets.delete(s),m._proxy.$disposeEditorInset(s),p.fire(),p.dispose(),u.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,D+1,T,t||{},_.identifier,_.extensionLocation),this._insets.set(s,{editor:P,inset:w,onDidReceiveMessage:u}),w}$onDidDispose(P){const D=this._insets.get(P);D&&D.inset.dispose()}$onDidReceiveMessage(P,D){const T=this._insets.get(P);T&&T.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=A}),define(be[160],Ee([0,1,130,10,2,6,4,46,28,14,11]),function(oe,e,d,M,E,A,F,P,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new P.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.SideBySideEditorActiveContext=new P.RawContextKey("sideBySideEditorActive",!1,(0,d.localize)(11,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,(0,d.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(13,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(14,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(15,null)),e.ActiveEditorGroupLockedContext=new P.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(16,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,(0,d.localize)(18,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,(0,d.localize)(19,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,(0,d.localize)(20,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(21,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,(0,d.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function _(O,N,I){for(const B of I.visibleEditorPanes)if(B.group.id===N&&O.matches(B.input))return B.getViewState()}e.findViewStateForEditor=_;function n(O){if(f(O))return!1;const N=O;return E.URI.isUri(N?.resource)}e.isResourceEditorInput=n;function m(O){if(f(O))return!1;const N=O;return N?.original!==void 0&&N.modified!==void 0}e.isResourceDiffEditorInput=m;function s(O){if(f(O)||m(O))return!1;const N=O;return N?.primary!==void 0&&N.secondary!==void 0}e.isResourceSideBySideEditorInput=s;function u(O){if(f(O))return!1;const N=O;return N?N.resource===void 0||N.resource.scheme===t.Schemas.untitled||N.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var p;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(p=e.Verbosity||(e.Verbosity={}));var C;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(C=e.SaveReason||(e.SaveReason={}));var w;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends A.Disposable{}e.AbstractEditorInput=o;function f(O){return O instanceof o}e.isEditorInput=f;function S(O){const N=O;return E.URI.isUri(N?.preferredResource)}function i(O){const N=O;return f(N?.primary)&&f(N?.secondary)}e.isSideBySideEditorInput=i;function g(O){const N=O;return f(N?.modified)&&f(N?.original)}e.isDiffEditorInput=g;function a(O){return f(O?.editor)}e.isEditorInputWithOptions=a;function r(O){const N=O;return a(O)&&N?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function v(O){const N=O;return typeof N?.groupId=="number"&&f(N.editor)}e.isEditorIdentifier=v;var l;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(l=e.EditorCloseContext||(e.EditorCloseContext={}));var c;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(c=e.SideBySideEditor||(e.SideBySideEditor={}));class b{getOriginalUri(N,I){if(!N)return;if(I?.supportSideBySide){const{primary:x,secondary:V}=this.getSideEditors(N);if(x&&V){if(I?.supportSideBySide===c.BOTH)return{primary:this.getOriginalUri(x,{filterByScheme:I.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:I.filterByScheme})};if(I?.supportSideBySide===c.ANY)return this.getOriginalUri(x,{filterByScheme:I.filterByScheme})??this.getOriginalUri(V,{filterByScheme:I.filterByScheme});N=I.supportSideBySide===c.PRIMARY?x:V}}if(m(N)||s(N))return;const B=S(N)?N.preferredResource:N.resource;return!B||!I||!I.filterByScheme?B:this.filterUri(B,I.filterByScheme)}getSideEditors(N){return i(N)||s(N)?{primary:N.primary,secondary:N.secondary}:g(N)||m(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,I){if(!N)return;if(I?.supportSideBySide){const{primary:x,secondary:V}=this.getSideEditors(N);if(x&&V){if(I?.supportSideBySide===c.BOTH)return{primary:this.getCanonicalUri(x,{filterByScheme:I.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:I.filterByScheme})};if(I?.supportSideBySide===c.ANY)return this.getCanonicalUri(x,{filterByScheme:I.filterByScheme})??this.getCanonicalUri(V,{filterByScheme:I.filterByScheme});N=I.supportSideBySide===c.PRIMARY?x:V}}if(m(N)||s(N))return;const B=N.resource;return!B||!I||!I.filterByScheme?B:this.filterUri(B,I.filterByScheme)}filterUri(N,I){if(Array.isArray(I)){if(I.some(B=>N.scheme===B))return N}else if(I===N.scheme)return N}}e.EditorResourceAccessor=new b;var h;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(h=e.CloseDirection||(e.CloseDirection={}));class y{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(N){const I=this.instantiationService=N.get(F.IInstantiationService);for(const[B,x]of this.editorSerializerConstructors)this.createEditorSerializer(B,x,I);this.editorSerializerConstructors.clear()}createEditorSerializer(N,I,B){const x=B.createInstance(I);this.editorSerializerInstances.set(N,x)}registerFileEditorFactory(N){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=N}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(N,I){if(this.editorSerializerConstructors.has(N)||this.editorSerializerInstances.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.instantiationService?this.createEditorSerializer(N,I,this.instantiationService):this.editorSerializerConstructors.set(N,I),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(N),this.editorSerializerInstances.delete(N)})}getEditorSerializer(N){return this.editorSerializerInstances.get(typeof N=="string"?N:N.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new y);async function R(O,N){if(!O||!O.length)return[];const I=await Promise.all(O.map(async B=>{const x=E.URI.revive(B.fileUri);if(!x||!await N.canHandleResource(x))return;const H=typeof B.exists=="boolean"?B.exists:await N.exists(x);if(!H&&B.openOnlyIfExists)return;const W={selection:H?B.selection:void 0,pinned:!0,override:B.editorOverrideId};let ee;return H?ee={resource:x,options:W}:ee={resource:x,options:W,forceUntitled:!0},ee}));return(0,T.coalesce)(I)}e.pathsToEditors=R;var k;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(k=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[161],Ee([0,1,3,46,131,4,6,20,28,14,52,23,34,151]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var s;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var u;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function p(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=p;function C(v){return`viewContainer.${v}.enabled`}e.getEnabledViewContainerContextKey=C;class w extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(l,c,b){const h=this.get(l.id);if(h)return h;const y=l;return y.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,P.getOrSet)(this.viewContainers,c,[]).push(y),b?.isDefault&&this.defaultViewContainers.push(y),this._onDidRegister.fire({viewContainer:y,viewContainerLocation:c}),y}deregisterViewContainer(l){for(const c of this.viewContainers.keys()){const b=this.viewContainers.get(c),h=b?.indexOf(l);if(h!==-1){b?.splice(h,1),b.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(b=>b?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===l)}}D.Registry.add(s.ViewContainersRegistry,new w);var o;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function f(v,l){const c=v.group??o.More,b=l.group??o.More;return c!==b?c.localeCompare(b):(v.order??5)-(l.order??5)}class S extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:b})=>this.addViews(c,b)),this._onViewsRegistered.fire(l)}deregisterViews(l,c){const b=this.removeViews(l,c);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:c})}moveViews(l,c){for(const b of this._views.keys())if(b!==c){const h=this.removeViews(l,b);h.length&&(this.addViews(h,c),this._onDidChangeContainer.fire({views:h,from:b,to:c}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const c of this._viewContainers){const b=(this._views.get(c)||[]).filter(h=>h.id===l)[0];if(b)return b}return null}getViewContainer(l){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(h=>h.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this._viewWelcomeContents.add(l,c),this._onDidChangeViewWelcomeContent.fire(l),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,c),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,c){const b=new Map;for(const[h,y]of c)this._viewWelcomeContents.add(l,y),b.set(h,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,y),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),b}getViewWelcomeContent(l){const c=[];return this._viewWelcomeContents.forEach(l,b=>c.push(b)),c.sort(f)}addViews(l,c){let b=this._views.get(c);b||(b=[],this._views.set(c,b),this._viewContainers.push(c));for(const h of l){if(this.getView(h.id)!==null)throw new Error((0,E.localize)(1,null,h.id));b.push(h)}}removeViews(l,c){const b=this._views.get(c);if(!b)return[];const h=[],y=[];for(const R of b)l.includes(R)?h.push(R):y.push(R);return h.length&&(y.length?this._views.set(c,y):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),h}}D.Registry.add(s.ViewsRegistry,new S),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(v){return`view.${v}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var g;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(g=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(l,c){this.resolved=!1,this._hasResolve=!1,(0,_.mixin)(this,l),this._hasResolve=!!c,this.resolve=async b=>{if(c&&!this.resolved){const h=await c(b);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[162],Ee([0,1,3,12,132]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,D,T,t){const _={command:P};if(D&&Object.keys(D).length>0&&(_.arguments=D),this.internalSend("request",_),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const m=this.pendingRequests.get(_.seq);if(m){this.pendingRequests.delete(_.seq);const s={type:"response",seq:0,request_seq:_.seq,success:!1,command:P,message:(0,E.localize)(0,null,t,P)};m(s)}},t)}return T&&this.pendingRequests.set(_.seq,T),_.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,D){return P.type!=="event"||D.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,M.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const D=P,T=this.pendingRequests.get(D.request_seq);T&&(this.pendingRequests.delete(D.request_seq),T(D));break}}}internalSend(P,D){D.type=P,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((D,T)=>P.set(T,D)),await(0,M.timeout)(500),P.forEach((D,T)=>{D({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[163],Ee([0,1,9,2,17,23,11]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function D(a,r,v){return a.replace(P,function(l,c){return r&&c.length>0&&c[0]!=="_"?l:v&&v.hasOwnProperty(c)?v[c]:l})}e.formatPII=D;function T(a){const r={};for(const v of Object.keys(a))v.startsWith("!")||(r[v]=a[v]);return r}e.filterExceptionsFromTelemetry=T;function t(a){return a.configuration.request==="attach"&&!_(a)&&(!a.parentSession||t(a.parentSession))}e.isSessionAttach=t;function _(a){let r=a.configuration.type;if(!!r)return r==="vslsShare"&&(r=a.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(r,"extensionhost")||(0,d.equalsIgnoreCase)(r,"pwa-extensionhost")?a:a.parentSession?_(a.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=n;function m(a,r,v){let l,c=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,h=null;for(;h=b.exec(a);){let y=h.index+1,R=y+h[0].length;if(y<=r&&R>=v){l=h[0],c=y;break}}if(l){let y=/\w+/g,R=null;for(;(R=y.exec(l))&&!(R.index+1+c+R[0].length>=v););R&&(l=l.substring(0,y.lastIndex))}return l?{start:c,end:c+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(a){return!!(a&&a.match(s))}e.isUri=u;function p(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(u(a.path))return M.URI.parse(a.path);if((0,E.isAbsolute)(a.path))return M.URI.file(a.path)}return a.path}function C(a){if(typeof a.path=="object"){const r=M.URI.revive(a.path);if(r)return r.scheme===F.Schemas.file?r.fsPath:r.toString()}return a.path}function w(a,r){const v=r?p:C,l=(0,A.deepClone)(a);return f(l,(c,b)=>{c&&b&&(b.path=v(b))}),l}e.convertToDAPaths=w;function o(a,r){const v=r?p:C,l=(0,A.deepClone)(a);return f(l,(c,b)=>{!c&&b&&(b.path=v(b))}),l}e.convertToVSCPaths=o;function f(a,r){switch(a.type){case"event":const v=a;switch(v.event){case"output":r(!1,v.body.source);break;case"loadedSource":r(!1,v.body.source);break;case"breakpoint":r(!1,v.body.breakpoint.source);break;default:break}break;case"request":const l=a;switch(l.command){case"setBreakpoints":r(!0,l.arguments.source);break;case"breakpointLocations":r(!0,l.arguments.source);break;case"source":r(!0,l.arguments.source);break;case"gotoTargets":r(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(b=>r(!1,b));break;default:break}break;case"response":const c=a;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(b=>r(!1,b.source));break;case"loadedSources":c.body.sources.forEach(b=>r(!1,b));break;case"scopes":c.body.scopes.forEach(b=>r(!1,b.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(b=>r(!1,b.source));break;case"setBreakpoints":c.body.breakpoints.forEach(b=>r(!1,b.source));break;default:break}break}}function S(a){return a.filter(r=>!r.presentation?.hidden).sort((r,v)=>r.presentation?v.presentation?r.presentation.group?v.presentation.group?r.presentation.group!==v.presentation.group?r.presentation.group.localeCompare(v.presentation.group):i(r.presentation.order,v.presentation.order):-1:v.presentation.group?1:i(r.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=S;function i(a,r){return typeof a!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:a-r}async function g(a,r){const v=a.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorMode});if(v!=="none"&&(await r.saveAll(),v==="allEditorsInActiveGroup")){const l=r.activeEditorPane;l&&await r.save({editor:l.input,groupId:l.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=g}),define(be[89],Ee([0,1,27,164,79,11,17,25,46]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var T;(function(y){y[y.Markup=1]="Markup",y[y.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",E.Mimes.latex,E.Mimes.markdown,"image/png","image/jpeg",E.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[E.Mimes.latex,E.Mimes.markdown,"application/json",E.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var t;(function(y){y[y.Running=1]="Running",y[y.Idle=2]="Idle"})(t=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(y){y[y.Pending=2]="Pending",y[y.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(y){y[y.WithHardKernelDependency=0]="WithHardKernelDependency",y[y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",y[y.Pure=2]="Pure",y[y.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(y){y.Always="always",y.Never="never",y.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(y){y[y.ModelChange=1]="ModelChange",y[y.Move=2]="Move",y[y.ChangeLanguage=5]="ChangeLanguage",y[y.Initialize=6]="Initialize",y[y.ChangeCellMetadata=7]="ChangeCellMetadata",y[y.Output=8]="Output",y[y.OutputItem=9]="OutputItem",y[y.ChangeCellContent=10]="ChangeCellContent",y[y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",y[y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",y[y.ChangeCellMime=13]="ChangeCellMime",y[y.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(y){y[y.Handle=0]="Handle",y[y.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(y){y[y.Replace=1]="Replace",y[y.Output=2]="Output",y[y.Metadata=3]="Metadata",y[y.CellLanguage=4]="CellLanguage",y[y.DocumentMetadata=5]="DocumentMetadata",y[y.Move=6]="Move",y[y.OutputItems=7]="OutputItems",y[y.PartialMetadata=8]="PartialMetadata",y[y.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var C;(function(y){y.scheme=A.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function k(x,V){return x.with({scheme:y.scheme,fragment:`ch${V.toString().padStart(7,"0")}${x.scheme!==A.Schemas.file?x.scheme:""}`})}y.generate=k;function O(x){if(x.scheme!==y.scheme)return;const V=R.exec(x.fragment);return V?{handle:Number(V[1]),notebook:x.with({scheme:x.fragment.substr(V[0].length)||A.Schemas.file,fragment:null})}:void 0}y.parse=O;function N(x){if(x.scheme!==A.Schemas.vscodeNotebookCellMetadata)return;const V=R.exec(x.fragment);return V?{handle:Number(V[1]),notebook:x.with({scheme:x.fragment.substr(V[0].length)||A.Schemas.file,fragment:null})}:void 0}y.parseCellMetadataUri=N;function I(x,V,H){return x.with({scheme:H,fragment:`ch${V.toString().padStart(7,"0")}${x.scheme!==A.Schemas.file?x.scheme:""}`})}y.generateCellUri=I;function B(x,V){if(x.scheme!==V)return;const H=R.exec(x.fragment);return H?{handle:Number(H[1]),notebook:x.with({scheme:x.fragment.substr(H[0].length)||A.Schemas.file,fragment:null})}:void 0}y.parseCellUri=B})(C=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(y){return w.get(y)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function f(y){return w.get(y)?.supportedByCore??!1}e.mimeTypeSupportedByCore=f;function S(y){return w.get(y)?.mergeable??!1}e.mimeTypeIsMergeable=S;const i=y=>P.isWindows?y.replace(/\//g,"\\"):y;class g{constructor(R=[],k=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=k,this.order=[...new Set(R)].map(O=>({pattern:O,matches:d.parse(i(O))}))}sort(R){const k=new Map(M.Iterable.map(R,N=>[N,i(N)]));let O=[];for(const{matches:N}of this.order)for(const[I,B]of k)if(N(B)){O.push(I),k.delete(I);break}return k.size&&(O=O.concat([...k.keys()].sort((N,I)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(I)))),O}prioritize(R,k){const O=this.findIndex(R);if(O===-1){this.order.unshift({pattern:R,matches:d.parse(i(R))});return}const N=new Set(k.map(B=>this.findIndex(B,O)));N.delete(-1);const I=Array.from(N).sort();this.order.splice(O+1,0,...I.map(B=>this.order[B]));for(let B=I.length-1;B>=0;B--)this.order.splice(I[B],1)}toArray(){return this.order.map(R=>R.pattern)}findIndex(R,k=this.order.length){const O=i(R);for(let N=0;N<k;N++)if(this.order[N].matches(O))return N;return-1}}e.MimeTypeDisplayOrder=g;function a(y,R,k,O=(N,I)=>N===I){const N=[];function I(V,H,W){if(H===0&&W.length===0)return;const ee=N[N.length-1];ee&&ee.start+ee.deleteCount===V?(ee.deleteCount+=H,ee.toInsert.push(...W)):N.push({start:V,deleteCount:H,toInsert:W})}let B=0,x=0;for(;;){if(B===y.length){I(B,0,R.slice(x));break}if(x===R.length){I(B,y.length-B,[]);break}const V=y[B],H=R[x];if(O(V,H)){B+=1,x+=1;continue}k(H)?(I(B,1,[]),B+=1):(I(B,0,[H]),x+=1)}return N}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(y){y.default="default",y.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function v(y){const R=y;return!!((typeof R.include=="string"||d.isRelativePattern(R.include))&&(typeof R.exclude=="string"||d.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=v;function l(y,R,k){if(Array.isArray(y.viewType)&&y.viewType.indexOf(R)>=0||y.viewType===R)return!0;if(y.filenamePattern){let O=v(y.filenamePattern)?y.filenamePattern.include:y.filenamePattern,N=v(y.filenamePattern)?y.filenamePattern.exclude:void 0;if(d.match(O,(0,F.basename)(k.fsPath).toLowerCase()))return!(N&&d.match(N,(0,F.basename)(k.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class c{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let k=0;k<this.textModel.cells.length;k++)R[k]=this.textModel.cells[k].getHashValue();return R}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(y){y[y.Left=1]="Left",y[y.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class h{static create(R){return`${h._prefix}${R}`}static parse(R){if(R.startsWith(h._prefix))return R.substr(h._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=h,h._prefix="notebook/"}),define(be[165],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(be[166],Ee([0,1,134,4,46]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=d;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var M;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=F;var P;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var D;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(n){}update(n){}remove(n,m){}complete(){}}e.IncrementalChangeCollector=T;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const m=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const u=s[1];if(u.parent){if(this.items.has(u.parent)){const p=this.items.get(u.parent);p.children.add(u.item.extId);const C=this.createItem(u,p);this.items.set(u.item.extId,C),m.add(C)}}else{const p=this.createItem(u);this.roots.add(p),this.items.set(u.item.extId,p),m.add(p)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=s[1],p=this.items.get(u.extId);if(!p)break;u.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,u),m.update(p);break}case 2:{const u=this.items.get(s[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const p=[[s[1]]];for(;p.length;)for(const C of p.pop()){const w=this.items.get(C);w&&(p.push(w.children),this.items.delete(C),m.remove(w,w!==u),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}m.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=t}),define(be[68],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(A){A.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(F,P=F.length){if(this.path=F,this.viewEnd=P,F.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,P,D=F.parent){if(F.id===P)return new E([P]);let T=[F.id];for(let t=D;t&&t.id!==P;t=t.parent)T.push(t.id);return T.push(P),new E(T.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new E(F.split("\0"))}static join(F,P){return new E([...F.path,P])}static joinToString(F,P){return F.toString()+"\0"+P}static compare(F,P){return F===P?0:P.startsWith(F+"\0")?2:F.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new E(this.path,F)}compare(F){if(typeof F=="string")return E.compare(this.toString(),F);for(let P=0;P<F.viewEnd&&P<this.viewEnd;P++)if(F.path[P]!==this.path[P])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=E}),define(be[168],Ee([0,1,17,91,10,23,25,78,135]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(_,n,m){this._contributedVariables=new Map,this._context=_,this._labelService=n,m&&(this._envVariablesPromise=m.then(s=>this.prepareEnv(s)))}prepareEnv(_){if(F.isWindows){const n=Object.create(null);return Object.keys(_).forEach(m=>{n[m.toLowerCase()]=_[m]}),n}return _}resolveWithEnvironment(_,n,m){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,m)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,m,s){const u=A.deepClone(n);return F.isWindows&&u.windows?Object.keys(u.windows).forEach(p=>u[p]=u.windows[p]):F.isMacintosh&&u.osx?Object.keys(u.osx).forEach(p=>u[p]=u.osx[p]):F.isLinux&&u.linux&&Object.keys(u.linux).forEach(p=>u[p]=u.linux[p]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,u,m,s)}async resolveAnyAsync(_,n,m){return this.resolveAnyBase(_,n,m)}async resolveAnyMap(_,n,m){const s=new Map;return{newConfig:await this.resolveAnyBase(_,n,m,s),resolvedVariables:s}}resolveWithInteractionReplace(_,n,m,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,m,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,m,s,u){if(E.isString(m))return this.resolveString(_,n,m,s,u);if(E.isArray(m))return m.map(p=>this.recursiveResolve(_,n,p,s,u));if(E.isObject(m)){let p=Object.create(null);return Object.keys(m).forEach(C=>{const w=this.resolveString(_,n,C,s,u);p[w]=this.recursiveResolve(_,n,m[C],s,u)}),p}return m}resolveString(_,n,m,s,u){return m.replace(T.VARIABLE_REGEXP,(C,w)=>{if(w.includes(T.VARIABLE_LHS))return C;let o=this.evaluateSingleVariable(_,C,w,n,s);return u&&u.set(w,o),o!==C&&E.isString(o)&&o.match(T.VARIABLE_REGEXP)&&(o=this.resolveString(_,n,o,s,u)),o})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,m,s,u){let p;const C=m.split(":");C.length>1&&(m=C[0],p=C[1]);const w=()=>{const S=this._context.getFilePath();if(S)return S;throw new Error((0,D.localize)(0,null,n))},o=()=>{const S=w();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,D.localize)(1,null,n,d.basename(S)))},f=()=>{if(p){const S=this._context.getFolderUri(p);if(S)return S;throw new Error((0,D.localize)(2,null,n,p))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,n)):new Error((0,D.localize)(4,null,n))};switch(m){case"env":if(p){if(_){const S=_[F.isWindows?p.toLowerCase():p];if(E.isString(S))return S}return""}throw new Error((0,D.localize)(5,null,n));case"config":if(p){const S=this._context.getConfigurationValue(s,p);if(E.isUndefinedOrNull(S))throw new Error((0,D.localize)(6,null,n,p));if(E.isObject(S))throw new Error((0,D.localize)(7,null,n,p));return S}throw new Error((0,D.localize)(8,null,n));case"command":return this.resolveFromMap(n,p,u,"command");case"input":return this.resolveFromMap(n,p,u,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return s||p?(0,P.normalizeDriveLetter)(this.fsPath(f())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(f()));case"lineNumber":const S=this._context.getLineNumber();if(S)return S;throw new Error((0,D.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,D.localize)(10,null,n));case"file":return w();case"fileWorkspaceFolder":return o();case"relativeFile":return s||p?d.relative(this.fsPath(f()),w()):w();case"relativeFileDirname":const g=d.dirname(w());if(s||p){const l=d.relative(this.fsPath(f()),g);return l.length===0?".":l}return g;case"fileDirname":return d.dirname(w());case"fileExtname":return d.extname(w());case"fileBasename":return d.basename(w());case"fileBasenameNoExtension":const a=d.basename(w());return a.slice(0,a.length-d.extname(a).length);case"fileDirnameBasename":return d.basename(d.dirname(w()));case"execPath":const r=this._context.getExecPath();return r||n;case"execInstallFolder":const v=this._context.getAppRoot();return v||n;case"pathSeparator":return d.sep;default:try{const l=p?`${m}:${p}`:m;return this.resolveFromMap(n,l,u,void 0)}catch(l){return n}}}}resolveFromMap(_,n,m,s){if(n&&m){const u=s===void 0?m[n]:m[s+":"+n];if(typeof u=="string")return u;throw new Error((0,D.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,160]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var E;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var P;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function T(u){const p=u;return(0,M.isEditorInput)(p?.editor)&&(0,M.isEditorInput)(p?.replacement)}e.isEditorReplacement=T;var t;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(u){u[u.GROUP_ACTIVE=0]="GROUP_ACTIVE",u[u.GROUP_INDEX=1]="GROUP_INDEX",u[u.GROUP_LOCKED=2]="GROUP_LOCKED",u[u.EDITOR_OPEN=3]="EDITOR_OPEN",u[u.EDITOR_CLOSE=4]="EDITOR_CLOSE",u[u.EDITOR_MOVE=5]="EDITOR_MOVE",u[u.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",u[u.EDITOR_LABEL=7]="EDITOR_LABEL",u[u.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",u[u.EDITOR_PIN=9]="EDITOR_PIN",u[u.EDITOR_STICKY=10]="EDITOR_STICKY",u[u.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function m(u){const p=u;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=m;function s(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=s}),define(be[169],Ee([0,1,4,92]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const F=A;return typeof A=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=E}),define(be[8],Ee([0,1,14,22,77,230,55,23,10,2,44,59,136,83,49,89,68,169,7]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(de){function ge(z){const{selectionStartLineNumber:we,selectionStartColumn:ke,positionLineNumber:Je,positionColumn:xe}=z,ct=new w.Position(we-1,ke-1),pt=new w.Position(Je-1,xe-1);return new w.Selection(ct,pt)}de.to=ge;function X(z){const{anchor:we,active:ke}=z;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}de.from=X})(o=e.Selection||(e.Selection={}));var f;(function(de){function ge(z){if(!z)return;const{start:we,end:ke}=z;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}de.from=ge;function X(z){if(!z)return;const{startLineNumber:we,startColumn:ke,endLineNumber:Je,endColumn:xe}=z;return new w.Range(we-1,ke-1,Je-1,xe-1)}de.to=X})(f=e.Range||(e.Range={}));var S;(function(de){function ge(X){switch(X){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}de.to=ge})(S=e.TokenType||(e.TokenType={}));var i;(function(de){function ge(z){return new w.Position(z.lineNumber-1,z.column-1)}de.to=ge;function X(z){return{lineNumber:z.line+1,column:z.character+1}}de.from=X})(i=e.Position||(e.Position={}));var g;(function(de){function ge(we,ke){return(0,d.coalesce)((0,d.asArray)(we).map(Je=>X(Je,ke)))}de.from=ge;function X(we,ke){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:z(we.scheme,ke),pattern:typeof we.pattern=="undefined"?void 0:rt.from(we.pattern),exclusive:we.exclusive}}function z(we,ke){return ke&&typeof we=="string"?ke.transformOutgoingScheme(we):we}})(g=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(de){function ge(z){switch(z){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}de.from=ge;function X(z){switch(z){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}de.to=X})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(de){function ge(z){let we;return z.code&&((0,D.isString)(z.code)||(0,D.isNumber)(z.code)?we=String(z.code):we={value:String(z.code.value),target:z.code.target}),{...f.from(z.range),message:z.message,source:z.source,code:we,severity:l.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(v.from),tags:Array.isArray(z.tags)?(0,d.coalesce)(z.tags.map(a.from)):void 0}}de.from=ge;function X(z){const we=new w.Diagnostic(f.to(z),z.message,l.to(z.severity));return we.source=z.source,we.code=(0,D.isString)(z.code)?z.code:z.code?.value,we.relatedInformation=z.relatedInformation&&z.relatedInformation.map(v.to),we.tags=z.tags&&(0,d.coalesce)(z.tags.map(a.to)),we}de.to=X})(r=e.Diagnostic||(e.Diagnostic={}));var v;(function(de){function ge(z){return{...f.from(z.location.range),message:z.message,resource:z.location.uri}}de.from=ge;function X(z){return new w.DiagnosticRelatedInformation(new w.Location(z.resource,f.to(z)),z.message)}de.to=X})(v=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(de){function ge(z){switch(z){case w.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}de.from=ge;function X(z){switch(z){case m.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}de.to=X})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(de){function ge(z){return typeof z=="number"&&z>=w.ViewColumn.One?z-1:z===w.ViewColumn.Beside?C.SIDE_GROUP:C.ACTIVE_GROUP}de.from=ge;function X(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=X})(c=e.ViewColumn||(e.ViewColumn={}));function b(de){return typeof de.range!="undefined"}function h(de){return de.length===0?!0:!!b(de[0])}e.isDecorationOptionsArr=h;var y;(function(de){function ge(xe){return xe.map(de.from)}de.fromMany=ge;function X(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function z(xe){let ct;if(X(xe)){const{language:ft,value:_t}=xe;ct={value:"```"+ft+`
`+_t+"\n```\n"}}else w.MarkdownString.isMarkdownString(xe)?ct={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ct={value:xe}:ct={value:""};const pt=Object.create(null);ct.uris=pt;const dt=ft=>{try{let _t=T.URI.parse(ft,!0);_t=_t.with({query:we(_t.query,pt)}),pt[ft]=_t}catch(_t){}return""},ht=new A.Renderer;return ht.link=dt,ht.image=ft=>dt(E.parseHrefAndDimensions(ft).href),A(ct.value,{renderer:ht}),ct}de.from=z;function we(xe,ct){if(!xe)return xe;let pt;try{pt=(0,F.parse)(xe)}catch(ht){}if(!pt)return xe;let dt=!1;return pt=(0,P.cloneAndChange)(pt,ht=>{if(T.URI.isUri(ht)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=ht,dt=!0,ft}else return}),dt?JSON.stringify(pt):xe}function ke(xe){const ct=new w.MarkdownString(xe.value,xe.supportThemeIcons);return ct.isTrusted=xe.isTrusted,ct.supportHtml=xe.supportHtml,ct}de.to=ke;function Je(xe){if(!!xe)return typeof xe=="string"?xe:de.from(xe)}de.fromStrict=Je})(y=e.MarkdownString||(e.MarkdownString={}));function R(de){return h(de)?de.map(ge=>({range:f.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?y.fromMany(ge.hoverMessage):ge.hoverMessage?y.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):de.map(ge=>({range:f.from(ge)}))}e.fromRangeOrRangeWithMessage=R;function k(de){return typeof de=="undefined"?de:typeof de=="string"?T.URI.file(de):de}e.pathOrURIToURI=k;var O;(function(de){function ge(X){return typeof X=="undefined"?X:{contentText:X.contentText,contentIconPath:X.contentIconPath?k(X.contentIconPath):void 0,border:X.border,borderColor:X.borderColor,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,color:X.color,backgroundColor:X.backgroundColor,margin:X.margin,width:X.width,height:X.height}}de.from=ge})(O=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(de){function ge(X){return typeof X=="undefined"?X:{backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?k(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?O.from(X.before):void 0,after:X.after?O.from(X.after):void 0}}de.from=ge})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var I;(function(de){function ge(X){if(typeof X=="undefined")return X;switch(X){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=ge})(I=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(de){function ge(X){return{isWholeLine:X.isWholeLine,rangeBehavior:X.rangeBehavior?I.from(X.rangeBehavior):void 0,overviewRulerLane:X.overviewRulerLane,light:X.light?N.from(X.light):void 0,dark:X.dark?N.from(X.dark):void 0,backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?k(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?O.from(X.before):void 0,after:X.after?O.from(X.after):void 0}}de.from=ge})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(de){function ge(z){return{text:z.newText,eol:z.newEol&&G.from(z.newEol),range:f.from(z.range)}}de.from=ge;function X(z){const we=new w.TextEdit(f.to(z.range),z.text);return we.newEol=typeof z.eol=="undefined"?void 0:G.to(z.eol),we}de.to=X})(x=e.TextEdit||(e.TextEdit={}));var V;(function(de){function ge(z,we,ke){const Je={edits:[]};if(z instanceof w.WorkspaceEdit)for(let xe of z._allEntries())if(xe._type===1)Je.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ct=we?.getDocument(xe.uri);Je.edits.push({_type:2,resource:xe.uri,edit:x.from(xe.edit),modelVersionId:ct?.version,metadata:xe.metadata})}else xe._type===3?Je.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:ke?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&Je.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:ke?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Xe.from)}});return Je}de.from=ge;function X(z){const we=new w.WorkspaceEdit;for(const ke of z.edits)ke.edit?we.replace(T.URI.revive(ke.resource),f.to(ke.edit.range),ke.edit.text):we.renameFile(T.URI.revive(ke.oldUri),T.URI.revive(ke.newUri),ke.options);return we}de.to=X})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(de){const ge=Object.create(null);ge[w.SymbolKind.File]=0,ge[w.SymbolKind.Module]=1,ge[w.SymbolKind.Namespace]=2,ge[w.SymbolKind.Package]=3,ge[w.SymbolKind.Class]=4,ge[w.SymbolKind.Method]=5,ge[w.SymbolKind.Property]=6,ge[w.SymbolKind.Field]=7,ge[w.SymbolKind.Constructor]=8,ge[w.SymbolKind.Enum]=9,ge[w.SymbolKind.Interface]=10,ge[w.SymbolKind.Function]=11,ge[w.SymbolKind.Variable]=12,ge[w.SymbolKind.Constant]=13,ge[w.SymbolKind.String]=14,ge[w.SymbolKind.Number]=15,ge[w.SymbolKind.Boolean]=16,ge[w.SymbolKind.Array]=17,ge[w.SymbolKind.Object]=18,ge[w.SymbolKind.Key]=19,ge[w.SymbolKind.Null]=20,ge[w.SymbolKind.EnumMember]=21,ge[w.SymbolKind.Struct]=22,ge[w.SymbolKind.Event]=23,ge[w.SymbolKind.Operator]=24,ge[w.SymbolKind.TypeParameter]=25;function X(we){return typeof ge[we]=="number"?ge[we]:6}de.from=X;function z(we){for(const ke in ge)if(ge[ke]===we)return Number(ke);return w.SymbolKind.Property}de.to=z})(H=e.SymbolKind||(e.SymbolKind={}));var W;(function(de){function ge(z){switch(z){case w.SymbolTag.Deprecated:return 1}}de.from=ge;function X(z){switch(z){case 1:return w.SymbolTag.Deprecated}}de.to=X})(W=e.SymbolTag||(e.SymbolTag={}));var ee;(function(de){function ge(z){return{name:z.name,kind:H.from(z.kind),tags:z.tags&&z.tags.map(W.from),containerName:z.containerName,location:re.from(z.location)}}de.from=ge;function X(z){const we=new w.SymbolInformation(z.name,H.to(z.kind),z.containerName,re.to(z.location));return we.tags=z.tags&&z.tags.map(W.to),we}de.to=X})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var q;(function(de){function ge(z){const we={name:z.name||"!!MISSING: name!!",detail:z.detail,range:f.from(z.range),selectionRange:f.from(z.selectionRange),kind:H.from(z.kind),tags:z.tags?.map(W.from)??[]};return z.children&&(we.children=z.children.map(ge)),we}de.from=ge;function X(z){const we=new w.DocumentSymbol(z.name,z.detail,H.to(z.kind),f.to(z.range),f.to(z.selectionRange));return(0,d.isNonEmptyArray)(z.tags)&&(we.tags=z.tags.map(W.to)),z.children&&(we.children=z.children.map(X)),we}de.to=X})(q=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(de){function ge(z){const we=new w.CallHierarchyItem(H.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),f.to(z.range),f.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=ge;function X(z,we,ke){if(we=we??z._sessionId,ke=ke??z._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,name:z.name,detail:z.detail,kind:H.from(z.kind),uri:z.uri,range:f.from(z.range),selectionRange:f.from(z.selectionRange),tags:z.tags?.map(W.from)}}de.from=X})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(de){function ge(X){return new w.CallHierarchyIncomingCall(Y.to(X.from),X.fromRanges.map(z=>f.to(z)))}de.to=ge})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var le;(function(de){function ge(X){return new w.CallHierarchyOutgoingCall(Y.to(X.to),X.fromRanges.map(z=>f.to(z)))}de.to=ge})(le=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var re;(function(de){function ge(z){return{range:z.range&&f.from(z.range),uri:z.uri}}de.from=ge;function X(z){return new w.Location(T.URI.revive(z.uri),f.to(z.range))}de.to=X})(re=e.location||(e.location={}));var ve;(function(de){function ge(z){const we=z,ke=z;return{originSelectionRange:we.originSelectionRange?f.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:ke.uri,range:f.from(we.targetRange?we.targetRange:ke.range),targetSelectionRange:we.targetSelectionRange?f.from(we.targetSelectionRange):void 0}}de.from=ge;function X(z){return{targetUri:T.URI.revive(z.uri),targetRange:f.to(z.range),targetSelectionRange:z.targetSelectionRange?f.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?f.to(z.originSelectionRange):void 0}}de.to=X})(ve=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(de){function ge(z){return{range:f.from(z.range),contents:y.fromMany(z.contents)}}de.from=ge;function X(z){return new w.Hover(z.contents.map(y.to),f.to(z.range))}de.to=X})(Fe=e.Hover||(e.Hover={}));var Me;(function(de){function ge(z){return{range:f.from(z.range),expression:z.expression}}de.from=ge;function X(z){return new w.EvaluatableExpression(f.to(z.range),z.expression)}de.to=X})(Me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Oe;(function(de){function ge(z){if(z instanceof w.InlineValueText)return{type:"text",range:f.from(z.range),text:z.text};if(z instanceof w.InlineValueVariableLookup)return{type:"variable",range:f.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:f.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}de.from=ge;function X(z){switch(z.type){case"text":return{range:f.to(z.range),text:z.text};case"variable":return{range:f.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:f.to(z.range),expression:z.expression}}}de.to=X})(Oe=e.InlineValue||(e.InlineValue={}));var Ke;(function(de){function ge(z){return{frameId:z.frameId,stoppedLocation:f.from(z.stoppedLocation)}}de.from=ge;function X(z){return new w.InlineValueContext(z.frameId,f.to(z.stoppedLocation))}de.to=X})(Ke=e.InlineValueContext||(e.InlineValueContext={}));var qe;(function(de){function ge(z){return{range:f.from(z.range),kind:z.kind}}de.from=ge;function X(z){return new w.DocumentHighlight(f.to(z.range),z.kind)}de.to=X})(qe=e.DocumentHighlight||(e.DocumentHighlight={}));var Ve;(function(de){function ge(X){switch(X){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}de.to=ge})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $;(function(de){function ge(X){return{triggerKind:Ve.to(X.triggerKind),triggerCharacter:X.triggerCharacter}}de.to=ge})($=e.CompletionContext||(e.CompletionContext={}));var Q;(function(de){function ge(z){switch(z){case w.CompletionItemTag.Deprecated:return 1}}de.from=ge;function X(z){switch(z){case 1:return w.CompletionItemTag.Deprecated}}de.to=X})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));var te;(function(de){const ge=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function X(ke){return ge.get(ke)??9}de.from=X;const z=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function we(ke){return z.get(ke)??w.CompletionItemKind.Property}de.to=we})(te=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(de){function ge(X,z){const we=new w.CompletionItem(X.label);return we.insertText=X.insertText,we.kind=te.to(X.kind),we.tags=X.tags?.map(Q.to),we.detail=X.detail,we.documentation=E.isMarkdownString(X.documentation)?y.to(X.documentation):X.documentation,we.sortText=X.sortText,we.filterText=X.filterText,we.preselect=X.preselect,we.commitCharacters=X.commitCharacters,t.Range.isIRange(X.range)?we.range=f.to(X.range):typeof X.range=="object"&&(we.range={inserting:f.to(X.range.insert),replacing:f.to(X.range.replace)}),we.keepWhitespace=typeof X.insertTextRules=="undefined"?!1:Boolean(X.insertTextRules&1),typeof X.insertTextRules!="undefined"&&X.insertTextRules&4?we.insertText=new w.SnippetString(X.insertText):(we.insertText=X.insertText,we.textEdit=we.range instanceof w.Range?new w.TextEdit(we.range,we.insertText):void 0),X.additionalTextEdits&&X.additionalTextEdits.length>0&&(we.additionalTextEdits=X.additionalTextEdits.map(ke=>x.to(ke))),we.command=z&&X.command?z.fromInternal(X.command):void 0,we}de.to=ge})(ae=e.CompletionItem||(e.CompletionItem={}));var K;(function(de){function ge(z){return{label:z.label,documentation:z.documentation?y.fromStrict(z.documentation):void 0}}de.from=ge;function X(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?y.to(z.documentation):z.documentation}}de.to=X})(K=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(de){function ge(z){return{label:z.label,documentation:z.documentation?y.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map(K.from):[],activeParameter:z.activeParameter}}de.from=ge;function X(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?y.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map(K.to):[],activeParameter:z.activeParameter}}de.to=X})(se=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(de){function ge(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(se.from):[]}}de.from=ge;function X(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(se.to):[]}}de.to=X})(he=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(de){function ge(z){return{text:z.text,position:i.from(z.position),kind:Ue.from(z.kind??w.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}de.from=ge;function X(z){const we=new w.InlayHint(z.text,i.to(z.position),Ue.to(z.kind));return we.whitespaceAfter=z.whitespaceAfter,we.whitespaceBefore=z.whitespaceBefore,we}de.to=X})(Ae=e.InlayHint||(e.InlayHint={}));var Ue;(function(de){function ge(z){return z}de.from=ge;function X(z){return z}de.to=X})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(de){function ge(z){return{range:f.from(z.range),url:z.target,tooltip:z.tooltip}}de.from=ge;function X(z){let we;if(z.url)try{we=typeof z.url=="string"?T.URI.parse(z.url,!0):T.URI.revive(z.url)}catch(ke){}return new w.DocumentLink(f.to(z.range),we)}de.to=X})(He=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(de){function ge(z){const we=new w.ColorPresentation(z.label);return z.textEdit&&(we.textEdit=x.to(z.textEdit)),z.additionalTextEdits&&(we.additionalTextEdits=z.additionalTextEdits.map(ke=>x.to(ke))),we}de.to=ge;function X(z){return{label:z.label,textEdit:z.textEdit?x.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(we=>x.from(we)):void 0}}de.from=X})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(de){function ge(z){return new w.Color(z[0],z[1],z[2],z[3])}de.to=ge;function X(z){return[z.red,z.green,z.blue,z.alpha]}de.from=X})(et=e.Color||(e.Color={}));var st;(function(de){function ge(z){return{range:f.from(z.range)}}de.from=ge;function X(z){return new w.SelectionRange(f.to(z.range))}de.to=X})(st=e.SelectionRange||(e.SelectionRange={}));var ye;(function(de){function ge(X){switch(X){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}de.to=ge})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(de){function ge(z){switch(z){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}de.from=ge;function X(z){switch(z){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}de.to=X})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var G;(function(de){function ge(z){if(z===w.EndOfLine.CRLF)return 1;if(z===w.EndOfLine.LF)return 0}de.from=ge;function X(z){if(z===1)return w.EndOfLine.CRLF;if(z===0)return w.EndOfLine.LF}de.to=X})(G=e.EndOfLine||(e.EndOfLine={}));var Z;(function(de){function ge(X){if(typeof X=="object")return X.viewId;switch(X){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=ge})(Z=e.ProgressLocation||(e.ProgressLocation={}));var pe;(function(de){function ge(X){const z={start:X.start+1,end:X.end+1};return X.kind&&(z.kind=We.from(X.kind)),z}de.from=ge})(pe=e.FoldingRange||(e.FoldingRange={}));var We;(function(de){function ge(X){if(X)switch(X){case w.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}de.from=ge})(We=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ye;(function(de){function ge(X){if(X)return{pinned:typeof X.preview=="boolean"?!X.preview:void 0,inactive:X.background,preserveFocus:X.preserveFocus,selection:typeof X.selection=="object"?f.from(X.selection):void 0,override:typeof X.override=="boolean"?n.EditorResolution.DISABLED:void 0}}de.from=ge})(Ye=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(de){function ge(z){return z instanceof w.RelativePattern||typeof z=="string"?z:X(z)?new w.RelativePattern(z.base,z.pattern):z}de.from=ge;function X(z){const we=z;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var mt;(function(de){function ge(X){if(X){if(Array.isArray(X))return X.map(ge);if(typeof X=="string")return X;{const z=X;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:rt.from(z.pattern),exclusive:z.exclusive}}}else return}de.from=ge})(mt=e.LanguageSelector||(e.LanguageSelector={}));var ut;(function(de){function ge(z){return{start:z.start,end:z.end}}de.from=ge;function X(z){return new w.NotebookRange(z.start,z.end)}de.to=X})(ut=e.NotebookRange||(e.NotebookRange={}));var St;(function(de){function ge(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}de.to=ge;function X(z){return{lastRunSuccess:z.success,runStartTime:z.timing?.startTime,runEndTime:z.timing?.endTime,executionOrder:z.executionOrder}}de.from=X})(St=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Tt;(function(de){function ge(z){switch(z){case w.NotebookCellKind.Markup:return u.CellKind.Markup;case w.NotebookCellKind.Code:default:return u.CellKind.Code}}de.from=ge;function X(z){switch(z){case u.CellKind.Markup:return w.NotebookCellKind.Markup;case u.CellKind.Code:default:return w.NotebookCellKind.Code}}de.to=X})(Tt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(de){function ge(z){const we={metadata:z.metadata??Object.create(null),cells:[]};for(let ke of z.cells)w.NotebookCellData.validate(ke),we.cells.push(Xe.from(ke));return we}de.from=ge;function X(z){const we=new w.NotebookData(z.cells.map(Xe.to));return(0,D.isEmptyObject)(z.metadata)||(we.metadata=z.metadata),we}de.to=X})(It=e.NotebookData||(e.NotebookData={}));var Xe;(function(de){function ge(z){return{cellKind:Tt.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:St.from(z.executionSummary??{}),outputs:z.outputs?z.outputs.map(Pe.from):[]}}de.from=ge;function X(z){return new w.NotebookCellData(Tt.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map(Pe.to):void 0,z.metadata,z.internalMetadata?St.to(z.internalMetadata):void 0)}de.to=X})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var vt;(function(de){function ge(z){return{mime:z.mime,valueBytes:M.VSBuffer.wrap(z.data)}}de.from=ge;function X(z){return new w.NotebookCellOutputItem(z.valueBytes.buffer,z.mime)}de.to=X})(vt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(de){function ge(z){return{outputId:z.id,items:z.items.map(vt.from),metadata:z.metadata}}de.from=ge;function X(z){const we=z.items.map(vt.to);return new w.NotebookCellOutput(we,z.outputId,z.metadata)}de.to=X})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(de){function ge(ke){if(ke!=null){if(ke instanceof w.RelativePattern||typeof ke=="string")return ke;if(we(ke))return new w.RelativePattern(ke.base,ke.pattern);if(z(ke))return{include:rt.from(ke.include)||void 0,exclude:rt.from(ke.exclude)||void 0}}}de.from=ge;function X(ke){return typeof ke=="string"?ke:we(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}de.to=X;function z(ke){const Je=ke,xe=rt.from(Je.include);if(!(xe&&xe instanceof w.RelativePattern||typeof xe=="string"))return!1;const ct=rt.from(Je.exclude);return!!(ct&&ct instanceof w.RelativePattern||typeof ct=="string")}function we(ke){const Je=ke;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ce;(function(de){function ge(X){return{backgroundColor:X.backgroundColor,borderColor:X.borderColor,top:X.top?O.from(X.top):void 0}}de.from=ge})(Ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ie;(function(de){function ge(X,z,we){const ke=typeof X.command=="string"?{title:"",command:X.command}:X.command;return{alignment:X.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(ke,we),text:X.text,tooltip:X.tooltip,accessibilityInformation:X.accessibilityInformation,priority:X.priority}}de.from=ge})(ie=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(de){function ge(X){return{transientOutputs:X?.transientOutputs??!1,transientCellMetadata:X?.transientCellMetadata??{},transientDocumentMetadata:X?.transientDocumentMetadata??{}}}de.from=ge})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var me;(function(de){function ge(z){return{uri:z.uri,provides:z.provides}}de.from=ge;function X(z){return new w.NotebookRendererScript(T.URI.revive(z.uri),z.provides)}de.to=X})(me=e.NotebookRendererScript||(e.NotebookRendererScript={}));var fe;(function(de){function ge(z){return{message:y.fromStrict(z.message)||"",type:0,expected:z.expectedOutput,actual:z.actualOutput,location:z.location?re.from(z.location):void 0}}de.from=ge;function X(z){const we=new w.TestMessage(typeof z.message=="string"?z.message:y.to(z.message));return we.actualOutput=z.actual,we.expectedOutput=z.expected,we.location=z.location?re.to(z.location):void 0,we}de.to=X})(fe=e.TestMessage||(e.TestMessage={}));var Ie;(function(de){let ge;(function(X){X.Delimiter="\0"})(ge||(ge={})),de.namespace=(X,z)=>X+"\0"+z,de.denamespace=X=>{const z=X.indexOf("\0");return{ctrlId:X.slice(0,z),tagId:X.slice(z+1)}}})(Ie=e.TestTag||(e.TestTag={}));var Be;(function(de){function ge(ke){const Je=(0,s.getPrivateApiFor)(ke).controllerId;return{extId:p.TestId.fromExtHostTestItem(ke,Je).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map(xe=>Ie.namespace(Je,xe.id)),range:f.from(ke.range)||null,description:ke.description||null,error:ke.error&&y.fromStrict(ke.error)||null}}de.from=ge;function X(ke){return{parent:void 0,error:void 0,id:p.TestId.fromString(ke.extId).localId,label:ke.label,uri:T.URI.revive(ke.uri),tags:(ke.tags||[]).map(Je=>{const{tagId:xe}=Ie.denamespace(Je);return new w.TestTag(xe)}),range:f.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}de.toPlain=X;function z(ke){const Je=p.TestId.fromString(ke.extId),xe=new s.TestItemImpl(Je.controllerId,Je.localId,ke.label,T.URI.revive(ke.uri));return xe.range=f.to(ke.range||void 0),xe.description=ke.description||void 0,xe}function we(ke){let Je;for(const xe of ke.tests){const ct=z(xe.item);(0,s.getPrivateApiFor)(ct).parent=Je,Je=ct}return Je}de.toItemFromContext=we})(Be=e.TestItem||(e.TestItem={})),function(de){function ge(z){return{id:z.id}}de.from=ge;function X(z){return new w.TestTag(z.id)}de.to=X}(Ie=e.TestTag||(e.TestTag={}));var Ne;(function(de){const ge=(z,we)=>{const ke={...Be.toPlain(z.item),parent:void 0,taskStates:z.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(xe=>xe.type===0).map(fe.to)})),children:z.children.map(Je=>we.get(Je)).filter(D.isDefined).map(Je=>ge(Je,we))};for(const Je of ke.children)Je.parent=ke;return ke};function X(z){const we=[],ke=new Map;for(const Je of z.items)ke.set(Je.item.extId,Je),z.request.targets.some(xe=>xe.controllerId===Je.controllerId&&xe.testIds.includes(Je.item.extId))&&we.push(Je);return{completedAt:z.completedAt,results:we.map(Je=>ge(Je,ke))}}de.to=X})(Ne=e.TestResults||(e.TestResults={}));var je;(function(de){function ge(ke){return{covered:ke.covered,total:ke.covered}}function X(ke){return"line"in ke?i.from(ke):f.from(ke)}function z(ke){return"branches"in ke?{count:ke.executionCount,location:X(ke.location),type:1,branches:ke.branches.length?ke.branches.map(Je=>({count:Je.executionCount,location:Je.location&&X(Je.location)})):void 0}:{type:0,count:ke.executionCount,location:X(ke.location)}}de.fromDetailed=z;function we(ke){return{uri:ke.uri,statement:ge(ke.statementCoverage),branch:ke.branchCoverage&&ge(ke.branchCoverage),function:ke.functionCoverage&&ge(ke.functionCoverage),details:ke.detailedCoverage?.map(z)}}de.fromFile=we})(je=e.TestCoverage||(e.TestCoverage={}));var it;(function(de){function ge(X){switch(X){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}de.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Le;(function(de){function ge(z){const we=new w.TypeHierarchyItem(H.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),f.to(z.range),f.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=ge;function X(z,we,ke){if(we=we??z._sessionId,ke=ke??z._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,kind:H.from(z.kind),name:z.name,detail:z.detail??"",uri:z.uri,range:f.from(z.range),selectionRange:f.from(z.selectionRange),tags:z.tags?.map(W.from)}}de.from=X})(Le=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Ee([0,1,2,16,7,8,231]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(T,t,_,n={timeout:1500,errors:3}){this._logService=T,this._documents=t,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(t,_,n)=>{const s={dispose:this._callbacks.push([t,_,T])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(T,t){const _=d.URI.revive(T);let n=!1;const m=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let u of[...this._callbacks]){if(n)break;const p=this._documents.getDocument(_),C=await this._deliverEventAsyncAndBlameBadListeners(u,{document:p,reason:A.TextDocumentSaveReason.to(t)});s.push(C)}}finally{clearTimeout(m)}return s}_deliverEventAsyncAndBlameBadListeners([T,t,_],n){const m=this._badListeners.get(T);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,T,t,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const u=this._badListeners.get(T);this._badListeners.set(T,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,t,_,n){const m=[],s=Date.now(),{document:u,reason:p}=n,{version:C}=u,w=Object.freeze({document:u,reason:p,waitUntil(o){if(Object.isFrozen(m))throw(0,M.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(o))}});try{t.apply(_,[w])}catch(o){return Promise.reject(o)}return Object.freeze(m),new Promise((o,f)=>{const S=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(S),o(i)}).catch(i=>{clearTimeout(S),f(i)})}).then(o=>{const f={edits:[]};for(const S of o)if(Array.isArray(S)&&S.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:g,range:a}of S)f.edits.push({_type:2,resource:u.uri,edit:{range:a&&A.Range.from(a),text:i,eol:g&&A.EndOfLine.from(g)}});if(f.edits.length!==0)return C===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(be[171],Ee([0,1,3,27,2,8,7]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(t,_,n,m,s){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,n&&(this._config+=1),m&&(this._config+=2),s&&(this._config+=4);const u=(0,M.parse)(_),p=t(C=>{if(!n)for(let w of C.created){const o=E.URI.revive(w);u(o.fsPath)&&this._onDidCreate.fire(o)}if(!m)for(let w of C.changed){const o=E.URI.revive(w);u(o.fsPath)&&this._onDidChange.fire(o)}if(!s)for(let w of C.deleted){const o=E.URI.revive(w);u(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(t,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,_,n,m){return new P(this._onFileSystemEvent.event,t,_,n,m)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,_){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,_){return(n,m,s)=>{const u=function(C){n.call(m,C)};return u.extension=t,_.event(u,void 0,s)}}async $onWillRunFileOperation(t,_,n,m){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(s=>({oldUri:E.URI.revive(s.source),newUri:E.URI.revive(s.target)}))},n,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(s=>E.URI.revive(s.target))},n,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(s=>E.URI.revive(s.target))},n,m)}}async _fireWillEvent(t,_,n,m){const s=new Set,u=[];if(await t.fireAsync(_,m,async(C,w)=>{const o=Date.now(),f=await Promise.resolve(C);f instanceof F.WorkspaceEdit&&(u.push(f),s.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),m.isCancellationRequested||u.length===0)return;const p={edits:[]};for(let C of u){let{edits:w}=A.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(w)}return{edit:p,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=D}),define(be[172],Ee([0,1,11,23,2,8,7,89]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(n,m,s,u){this.start=n,this.deletedCount=m,this.deletedItems=s,this.items=u}static asApiEvents(n){return n.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(s=>s.apiCell)}))}}class T{constructor(n,m,s){this.notebook=n,this._extHostDocument=m,this._cellData=s,this.handle=s.handle,this.uri=E.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(n,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return n._mime},set mime(s){n._mime=s},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,m,s){const u=s.map(A.NotebookCellOutputItem.to),p=this._outputs.find(C=>C.id===n);p&&(m||(p.items.length=0),p.items.push(...u))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=T;class t{constructor(n,m,s,u,p,C){this._proxy=n,this._textDocumentsAndEditors=m,this._textDocuments=s,this._emitter=u,this.uri=p,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=C.viewType,this._metadata=Object.freeze(C.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,C.cells]],!0),this._versionId=C.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===d.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(m){return m=n._validateIndex(m),n._cells[m].apiCell},getCells(m){return(m?n._getCells(m):n._cells).map(u=>u.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,m){this._versionId=n.versionId,this._isDirty=m;for(const s of n.rawEvents)s.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===P.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===P.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(s.index,s.metadata):s.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(s.index,s.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let m=n.start|0,s=n.end|0;return m<0&&(m=0),s>this._cells.length&&(s=this._cells.length),n.with({start:m,end:s})}_getCells(n){n=this._validateRange(n);const m=[];for(let s=n.start;s<n.end;s++)m.push(this._cells[s]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,m){if(this._disposed)return;const s=[],u=[],p=[];n.reverse().forEach(C=>{const o=C[2].map(i=>{const g=new T(this,this._textDocumentsAndEditors,i);return m||u.push(T.asModelAddData(this.apiNotebook,i)),g}),f=new D(C[0],C[1],[],o),S=this._cells.splice(C[0],C[1],...o);for(const i of S)p.push(i.uri),f.deletedItems.push(i.apiCell);s.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:p}),m||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(s)}))}_moveCell(n,m){const s=this._cells.splice(n,1);this._cells.splice(m,0,...s);const u=[new D(n,1,s.map(p=>p.apiCell),[]),new D(m,0,[],s)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(u)}))}_setCellOutputs(n,m){const s=this._cells[n];s.setOutputs(m),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(n,m,s,u){const p=this._cells[n];p.setOutputItems(m,s,u),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(n,m){const s=this._cells[n];s.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(s.uri,m)}_changeCellMime(n,m){const s=this._cells[n];s.apiCell.mime=m}_changeCellMetadata(n,m){const s=this._cells[n],u=s.apiCell.metadata;s.setMetadata(m);const p=s.apiCell.metadata;(0,M.equals)(u,p)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(n,m){const s=this._cells[n],u=s.internalMetadata;if(s.setInternalMetadata(m),u.runState!==m.runState){const p=m.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell,state:p}))}}getCellFromApiCell(n){return this._cells.find(m=>m.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(m=>m.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:T})}replaceCells(D,T,t){this._throwIfFinalized(),!(D===T&&t.length===0)&&this._collectedEdits.push({editType:1,index:D,count:T-D,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(D,T,t,_,n,m){this.id=D,this._proxy=T,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=m}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(T){if(!Array.isArray(T)||!T.every(d.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");D._selections=T,D._trySetSelections(T)},get visibleRanges(){return D._visibleRanges},revealRange(T,t){D._proxy.$tryRevealRange(D.id,M.NotebookRange.from(T),t??d.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(T){const t=new A(this.document.version);return T(t),D._applyEdit(t.finalize())},setDecorations(T,t){return D.setDecorations(T,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(M.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const T=[];let t=-1;for(let _=0;_<D.cellEdits.length;_++){if(t<0){T.push(D.cellEdits[_]),t++;continue}const m=T[t],s=D.cellEdits[_];if(m.editType===1&&s.editType===1&&m.index===s.index){m.cells.push(...D.cellEdits[_].cells),m.count+=D.cellEdits[_].count;continue}T.push(D.cellEdits[_]),t++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,T)}setDecorations(D,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return T.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(T),D.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(be[173],Ee([0,1,8,145,125,21,53,16]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,m,s){const u=this._handles++,{title:p,location:C,cancellable:w}=m,o={label:(0,E.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(u,{location:d.ProgressLocation.from(C),title:p,source:o,cancellable:w},n).catch(P.onUnexpectedExternalError),this._withProgress(u,s,!!w)}_withProgress(n,m,s){let u;s&&(u=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,u));const p=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),u&&u.dispose()};let C;try{C=m(new t(this._proxy,n),s&&u?u.token:A.CancellationToken.None)}catch(w){throw p(n),w}return C.then(w=>p(n),w=>p(n)),C}$acceptProgressCanceled(n){const m=this._mapHandleToCancellationSource.get(n);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=D;function T(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class t extends M.Progress{constructor(n,m){super(s=>this.throttledReport(s));this._proxy=n,this._handle=m}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}$e([(0,F.throttle)(100,(_,n)=>T(_,n),()=>Object.create(null))],t.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,42,16,54,8,7]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(n,m,s){const u=P._Keys.nextId();n.$registerTextEditorDecorationType(m.identifier,u,A.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:u,dispose(){n.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new E.IdGenerator("TextEditorDecorationType");class D{constructor(n,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,m){this._throwIfFinalized();let s=null;if(n instanceof F.Position)s=new F.Range(n,n);else if(n instanceof F.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,m,!1)}insert(n,m){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),m,!0)}delete(n){this._throwIfFinalized();let m=null;if(n instanceof F.Range)m=n;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(n,m,s){const u=this._document.validateRange(n);this._collectedEdits.push({range:u,text:m,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=D;class T{constructor(n,m,s,u){this._proxy=n,this._id=m,this._accept(s),this._logService=u;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(C){p._setTabSize(C)},get insertSpaces(){return p._insertSpaces},set insertSpaces(C){p._setInsertSpaces(C)},get cursorStyle(){return p._cursorStyle},set cursorStyle(C){p._setCursorStyle(C)},get lineNumbers(){return p._lineNumbers},set lineNumbers(C){p._setLineNumbers(C)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const m=Math.floor(n);return m>0?m:null}if(typeof n=="string"){const m=parseInt(n,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(n){const m=this._validateTabSize(n);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const m=this._validateInsertSpaces(n);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const m={};let s=!1;if(typeof n.tabSize!="undefined"){const u=this._validateTabSize(n.tabSize);u==="auto"?(s=!0,m.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,s=!0,m.tabSize=u)}if(typeof n.insertSpaces!="undefined"){const u=this._validateInsertSpaces(n.insertSpaces);u==="auto"?(s=!0,m.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,s=!0,m.insertSpaces=u)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,m.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(n){n.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=T;class t{constructor(n,m,s,u,p,C,w,o){this.id=n,this._proxy=m,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new T(this._proxy,this.id,C,s),this._visibleRanges=w,this._viewColumn=o;const f=this;this.value=Object.freeze({get document(){return u.getValue()},set document(S){throw(0,M.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(S){if(!(S instanceof F.Selection))throw(0,M.illegalArgument)("selection");f._selections=[S],f._trySetSelection()},get selections(){return f._selections},set selections(S){if(!Array.isArray(S)||S.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");f._selections=S,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(S){throw(0,M.readonly)("visibleRanges")},get options(){return f._options.value},set options(S){f._disposed||f._options.assign(S)},get viewColumn(){return f._viewColumn},set viewColumn(S){throw(0,M.readonly)("viewColumn")},edit(S,i={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new D(u.getValue(),i);return S(g),f._applyEdit(g)},insertSnippet(S,i,g={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=f._selections.map(r=>A.Range.from(r));else if(i instanceof F.Position){const{lineNumber:r,column:v}=A.Position.from(i);a=[{startLineNumber:r,startColumn:v,endLineNumber:r,endColumn:v}]}else if(i instanceof F.Range)a=[A.Range.from(i)];else{a=[];for(const r of i)if(r instanceof F.Range)a.push(A.Range.from(r));else{const{lineNumber:v,column:l}=A.Position.from(r);a.push({startLineNumber:v,startColumn:l,endLineNumber:v,endColumn:l})}}return m.$tryInsertSnippet(n,S.value,a,g)},setDecorations(S,i){const g=i.length===0;g&&!f._hasDecorationsForKey.has(S.key)||(g?f._hasDecorationsForKey.delete(S.key):f._hasDecorationsForKey.add(S.key),f._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return m.$trySetDecorations(n,S.key,A.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let r=0,v=i.length;r<v;r++){const l=i[r];a[4*r]=l.start.line+1,a[4*r+1]=l.start.character+1,a[4*r+2]=l.end.line+1,a[4*r+3]=l.end.character+1}return m.$trySetDecorationsFast(n,S.key,a)}}))},revealRange(S,i){f._runOnProxy(()=>m.$tryRevealRange(n,A.Range.from(S),i||F.TextEditorRevealType.Default))},show(S){m.$tryShowEditor(n,A.ViewColumn.from(S))},hide(){m.$tryHideEditor(n)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,d.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,d.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,d.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,d.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const m=n.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const s=m.edits.map(p=>p.range);s.sort((p,C)=>p.end.line===C.end.line?p.end.character===C.end.character?p.start.line===C.start.line?p.start.character-C.start.character:p.start.line-C.start.line:p.end.character-C.end.character:p.end.line-C.end.line);for(let p=0,C=s.length-1;p<C;p++){const w=s[p].end;if(s[p+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=m.edits.map(p=>({range:A.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,u,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=t}),define(be[174],Ee([0,1,128,24,2,3,6,161,12,7,10,14,8,21,158]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(w,o){if((0,t.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let f;return Array.isArray(w.highlights)&&(f=w.highlights.filter(S=>S.length===2&&typeof S[0]=="number"&&typeof S[1]=="number"),f=f.length?f:void 0),{label:w.label,highlights:f}}}class p{constructor(o,f,S){this._proxy=o,this.commands=f,this.logService=S,this.treeViews=new Map;function i(g){return g&&g.$treeViewId&&g.$treeItemHandle}f.registerArgumentProcessor({processArgument:g=>i(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(a=>i(a)?this.convertArgument(a):a):g})}registerTreeDataProvider(o,f,S){const i=this.createTreeView(o,{treeDataProvider:f},S);return{dispose:()=>i.dispose()}}createTreeView(o,f,S){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=f.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,canDragAndDrop:i}),a=this.createExtHostTreeView(o,f,S);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(r){a.message=r},get title(){return a.title},set title(r){a.title=r},get description(){return a.description},set description(r){a.description=r},reveal:(r,v)=>a.reveal(r,v),dispose:async()=>{await g,this.treeViews.delete(o),a.dispose()}}}$getChildren(o,f){const S=this.treeViews.get(o);return S?S.getChildren(f):Promise.reject(new Error((0,d.localize)(0,null,o)))}async $onDrop(o,f,S){const i=this.treeViews.get(o);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,o)));const g=s.TreeDataTransferConverter.toITreeDataTransfer(f);if(g.items.has(P.TREE_ITEM_DATA_TRANSFER_TYPE)){const r=JSON.parse(await g.items.get(P.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(v=>i.getExtensionElement(v)).filter(v=>!!v);r.length>0?g.items.set(P.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(r)}):g.items.delete(P.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(g,S)}async $hasResolve(o){const f=this.treeViews.get(o);if(!f)throw new Error((0,d.localize)(2,null,o));return f.hasResolve}$resolve(o,f,S){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(3,null,o));return i.resolveTreeItem(f,S)}$setExpanded(o,f,S){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(4,null,o));i.setExpanded(f,S)}$setSelection(o,f){const S=this.treeViews.get(o);if(!S)throw new Error((0,d.localize)(5,null,o));S.setSelection(f)}$setVisible(o,f){const S=this.treeViews.get(o);if(!S)throw new Error((0,d.localize)(6,null,o));S.setVisible(f)}createExtHostTreeView(o,f,S){const i=new C(o,f,this._proxy,this.commands.converter,this.logService,S);return this.treeViews.set(o,i),i}convertArgument(o){const f=this.treeViews.get(o.$treeViewId);return f?f.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=p;class C extends F.Disposable{constructor(o,f,S,i,g,a){super();if(this.viewId=o,this.proxy=S,this.commands=i,this.logService=g,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,a.contributes&&a.contributes.views)for(const l in a.contributes.views)for(const c of a.contributes.views[l])c.id===o&&(this._title=c.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let r,v;this._register(A.Event.debounce(this._onDidChangeData.event,(l,c)=>(l||(l={message:!1,elements:[]}),c.element!==!1&&(r||(r=new Promise(b=>v=b),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(c.element)?l.elements.push(...c.element):l.elements.push(c.element)),c.message&&(l.message=!0),l),200,!0)(({message:l,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=v;return r=null,this.refresh(c).then(()=>b())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const f=o?this.getExtensionElement(o):void 0;if(o&&!f)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let S=this.getChildrenNodes(o);return S||(S=await this.fetchChildrenNodes(f)),S?S.map(i=>i.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,f){f=f||{select:!0,focus:!1};const S=(0,t.isUndefinedOrNull)(f.select)?!0:f.select,i=(0,t.isUndefinedOrNull)(f.focus)?!1:f.focus,g=(0,t.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(a=>this.resolveTreeNode(o,a[a.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:a.map(v=>v.item)},{select:S,focus:i,expand:g})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:S,focus:i,expand:g})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,f){const S=this.getExtensionElement(o);S&&(f?this._onDidExpandElement.fire(Object.freeze({element:S})):this._onDidCollapseElement.fire(Object.freeze({element:S})))}setSelection(o){(0,_.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,f){const S=this.getExtensionElement(f);if(!!S)return(0,D.asPromise)(()=>this.dndController?.onDrop(o,S))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,f){if(!this.dataProvider.resolveTreeItem)return;const S=this.elements.get(o);if(S){const i=this.nodes.get(S);if(i){const g=await this.dataProvider.resolveTreeItem(i.extensionItem,S,f)??i.extensionItem;return i.item.tooltip=this.getTooltip(g.tooltip),i.item.command=this.getCommand(i.disposableStore,g.command),i.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(f=>f?this.resolveUnknownParentChain(f).then(S=>this.resolveTreeNode(f,S[S.length-1]).then(i=>(S.push(i),S))):Promise.resolve([]))}resolveParent(o){const f=this.nodes.get(o);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,f){const S=this.nodes.get(o);return S?Promise.resolve(S):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(i=>this.createHandle(o,i,f,!0)).then(i=>this.getChildren(f?f.item.handle:void 0).then(()=>{const g=this.getExtensionElement(i);if(g){const a=this.nodes.get(g);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(o){if(o){let f;if(typeof o=="string"){const S=this.getExtensionElement(o);f=S?this.nodes.get(S):void 0}else f=o;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const f=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const S=o?this.nodes.get(o):void 0,i=await this.dataProvider.getChildren(o);if(f.token.isCancellationRequested)return;const g=await Promise.all((0,_.coalesce)(i||[]).map(async a=>{const r=await this.dataProvider.getTreeItem(a);return r&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(a,r,S):null}));return f.token.isCancellationRequested?void 0:(0,_.coalesce)(g)}finally{f.dispose()}}refresh(o){if(o.some(S=>!S))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const S=this.getHandlesToRefresh(o);if(S.length)return this.refreshHandles(S)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const f=new Set,S=o.map(g=>this.nodes.get(g));for(const g of S)if(g&&!f.has(g.item.handle)){let a=g;for(;a&&a.parent&&S.findIndex(r=>a&&a.parent&&r&&r.item.handle===a.parent.item.handle)===-1;){const r=this.elements.get(a.parent.item.handle);a=r?this.nodes.get(r):void 0}a&&!a.parent&&f.add(g.item.handle)}const i=[];return f.forEach(g=>{const a=this.elements.get(g);if(a){const r=this.nodes.get(a);r&&(!r.parent||!f.has(r.parent.item.handle))&&i.push(g)}}),i}refreshHandles(o){const f={};return Promise.all(o.map(S=>this.refreshNode(S).then(i=>{i&&(f[S]=i.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(o){const f=this.getExtensionElement(o);if(f){const S=this.nodes.get(f);if(S)return this.clearChildren(f),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(i=>{if(i){const g=this.createTreeNode(f,i,S.parent);return this.updateNodeCache(f,g,S,S.parent),S.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,f,S){const i=this.createTreeNode(o,f,S);if(f.id&&this.elements.has(i.item.handle))throw new Error((0,d.localize)(7,null,f.id));return this.addNodeToCache(o,i),this.addNodeToParentCache(i,S),i}getTooltip(o){return T.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,f){return f?this.commands.toInternal(f,o):void 0}createTreeNode(o,f,S){const i=new F.DisposableStore,g=this.createHandle(o,f,S),a=this.getLightIconPath(f);return{item:{handle:g,parentHandle:S?S.item.handle:void 0,label:u(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(i,f.command),contextValue:f.contextValue,icon:a,iconDark:this.getDarkIconPath(f)||a,themeIcon:this.getThemeIcon(f),collapsibleState:(0,t.isUndefinedOrNull)(f.collapsibleState)?T.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:S,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(o){return o.iconPath instanceof T.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:f,label:S,resourceUri:i},g,a){if(f)return`${C.ID_HANDLE_PREFIX}/${f}`;const r=u(S,this.extension),v=g?g.item.handle:C.LABEL_HANDLE_PREFIX;let l=r?r.label:i?(0,M.basename)(i):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const c=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,b=this.getChildrenNodes(g)||[];let h,y=0;do{if(h=`${v}/${y}:${l}`,a||!this.elements.has(h)||c===h)break;y++}while(y<=b.length);return h}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon))return typeof o.iconPath=="string"||E.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return E.URI.isUri(o)?o:E.URI.file(o)}addNodeToCache(o,f){this.elements.set(f.item.handle,o),this.nodes.set(o,f)}updateNodeCache(o,f,S,i){this.elements.delete(f.item.handle),this.nodes.delete(o),f.item.handle!==S.item.handle&&this.elements.delete(S.item.handle),this.addNodeToCache(o,f);const g=this.getChildrenNodes(i)||[],a=g.filter(r=>r.item.handle===S.item.handle)[0];a&&g.splice(g.indexOf(a),1,f)}addNodeToParentCache(o,f){f?(f.children||(f.children=[]),f.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const f=this.nodes.get(o);if(f){if(f.children)for(const S of f.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}f.children=void 0}}else this.clearAll()}clear(o){const f=this.nodes.get(o);if(f){if(f.children)for(const S of f.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}this.nodes.delete(o),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}C.LABEL_HANDLE_PREFIX="0",C.ID_HANDLE_PREFIX="1"}),define(be[175],Ee([0,1,12,3,6,10,49,8,90,68]),function(oe,e,d,M,E,A,F,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const m=this.diff[this.diff.length-1];if(m&&n[0]===1){if(m[0]===1&&m[1].extId===n[1].extId){(0,D.applyTestItemUpdate)(m[1],n[1]);return}if(m[0]===0&&m[1].item.extId===n[1].extId){(0,D.applyTestItemUpdate)(m[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,m){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||m>s.expandLevels)&&(s.expandLevels=m),s.expand===1){const u=this.resolveChildren(s);return u.isOpen()?this.expandChildren(s,m-1):u.wait().then(()=>this.expandChildren(s,m-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,m-1)):this.expandChildren(s,m-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,m){switch(m.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(n.fullId,m.id));break;case 0:this.upsertItem(m.item,n);break;case 4:for(const w of m.ops)this.onTestItemEvent(n,w);break;case 3:const{key:s,value:u,previous:p}=m,C=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(u,p,C);break;case"range":this.pushDiff([1,{extId:C,item:{range:P.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:C,item:{error:P.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:C,item:{[s]:u??null}}]);break}break;default:(0,A.assertNever)(m)}}upsertItem(n,m){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=T.TestId.fromExtHostTestItem(n,this.root.id,m?.actual),u=(0,F.getPrivateApiFor)(n);u.parent&&u.parent!==m?.actual&&u.parent.children.delete(n.id);let p=this.tree.get(s.toString());if(!p){p={fullId:s,actual:n,parent:m?s.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(n,m),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:P.TestItem.from(n)}]),this.connectItemAndChildren(n,p,m);return}if(p.actual===n){this.connectItem(n,p,m);return}const C=p.actual.children,w=p.actual,o=(0,F.diffTestItems)(w,n);(0,F.getPrivateApiFor)(w).listener=void 0,p.actual=n,p.expand=0;for(const[f,S]of o)this.onTestItemEvent(p,{op:3,key:f,value:S,previous:w[f]});this.connectItemAndChildren(n,p,m);for(const f of C)n.children.get(f.id)||this.removeItem(T.TestId.joinToString(s,f.id))}diffTagRefs(n,m,s){const u=new Set(m.map(p=>p.id));for(const p of n)u.delete(p.id)||this.incrementTagRefs(p);this.pushDiff([1,{extId:s,item:{tags:n.map(p=>P.TestTag.namespace(this.controllerId,p.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const m=this.tags.get(n.id);m?m.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const m=this.tags.get(n);m&&!--m.refCount&&(this.tags.delete(n),this.pushDiff([6,P.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,m){(0,F.getPrivateApiFor)(n).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(n,m,s){this.setItemParent(n,s);const u=(0,F.getPrivateApiFor)(n);u.parent=s?.actual,u.listener=p=>this.onTestItemEvent(m,p),this.updateExpandability(m)}connectItemAndChildren(n,m,s){this.connectItem(n,m,s);for(const u of n.children)this.upsertItem(u,m)}updateExpandability(n){let m;this._resolveHandler?n.resolveBarrier?m=n.resolveBarrier.isOpen()?3:2:m=n.actual.canResolveChildren?1:0:m=0,m!==n.expand&&(n.expand=m,this.pushDiff([1,{extId:n.fullId.toString(),expand:m}]),m===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,m){if(m<0)return;const s=[];for(const u of n.actual.children){const p=this.expand(T.TestId.joinToString(n.fullId,u.id),m);(0,d.isThenable)(p)&&s.push(p)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const p=new d.Barrier;return p.open(),p}n.expand=2,this.pushExpandStateUpdate(n);const m=n.resolveBarrier=new d.Barrier,s=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=p.stack||p.message||String(p))};let u;try{u=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(p){s(p)}return(0,d.isThenable)(u)?u.catch(s).then(()=>{m.open(),this.updateExpandability(n)}):(m.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const m=this.tree.get(n);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[m];for(;s.length;){const u=s.pop();if(!!u){(0,F.getPrivateApiFor)(u.actual).listener=void 0;for(const p of u.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(u.fullId.toString());for(const p of u.actual.children)s.push(this.tree.get(T.TestId.joinToString(u.fullId,p.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[176],Ee([0,1,4,141]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(M.IEnvironmentService)}),define(be[177],Ee([0,1,26,3,17]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let _ of t.activationEvents)_==="onUri"&&(_=`onUri:${d.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(t)}}keepOnly(t){const _=new Set;t.forEach(n=>_.add(d.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(d.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,_){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(m=>m.identifier)),_.length>0){const m=new Set;_.forEach(s=>m.add(d.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!m.has(d.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,C){this.addNode(p),this.addNode(C),this._arcs.has(p)?this._arcs.get(p).push(C):this._arcs.set(p,[C])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,C){const w=_.getArcs(p);for(let o=0;o<w.length;o++)if(!C.has(w[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let p of t){const C=d.ExtensionIdentifier.toKey(p.identifier);if(n.set(C,p),p.extensionDependencies)for(let w of p.extensionDependencies){const o=d.ExtensionIdentifier.toKey(w);_.addArc(C,o)}}let m=new Set;_.getNodes().filter(p=>_.getArcs(p).length===0).forEach(p=>m.add(p));let s=_.getNodes().filter(p=>!m.has(p)),u;do{u=!1;for(let p=0;p<s.length;p++){const C=s[p];_.hasOnlyGoodArcs(C,m)&&(s.splice(p,1),p--,m.add(C),u=!0)}}while(u);return s.map(p=>n.get(p))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const _=this._activationMap.get(t);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const _=this._extensionsMap.get(d.ExtensionIdentifier.toKey(t));return _||void 0}}e.ExtensionDescriptionRegistry=F;var P;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(P||(P={}));function D(T,t){const _=T.isBuiltin?0:T.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(_!==n)return _-n;const m=E.posix.basename(T.extensionLocation.path),s=E.posix.basename(t.extensionLocation.path);return m<s?-1:m>s?1:0}}),define(be[178],Ee([0,1,22]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(P){const D=d.VSBuffer.alloc(1);switch(P){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function F(P,D){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=F}),define(be[30],Ee([0,1,3,2,4,26,147]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var P;(function(f){f[f.None=0]="None",f[f.LocalProcess=1]="LocalProcess",f[f.LocalWebWorker=2]="LocalWebWorker",f[f.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(f){switch(f){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class T{constructor(S){this.dependency=S}}e.MissingExtensionDependency=T;var t;(function(f){f[f.LocalProcess=0]="LocalProcess",f[f.LocalWebWorker=1]="LocalWebWorker",f[f.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(f){switch(f){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;class n{constructor(S,i,g,a){this.codeLoadingTime=S,this.activateCallTime=i,this.activateResolvedTime=g,this.activationReason=a}}e.ActivationTimes=n;class m{constructor(S,i){this.description=S,this.value=i}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var s;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(f){f.enableProposedApi||p(f)}e.checkProposedApiEnabled=u;function p(f){throw new Error(`[${f.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.throwProposedApiError=p;function C(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation}}e.toExtension=C;function w(f,S){return{identifier:new A.ExtensionIdentifier(f.identifier.id),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!S,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid}}e.toExtensionDescription=w;class o{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,i){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,i,g,a,r){}_onDidActivateExtensionError(S,i){}_onExtensionRuntimeError(S,i){}_onExtensionHostExit(S){}}e.NullExtensionService=o}),define(be[179],Ee([0,1,26,30,15]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class F{constructor(s,u,p,C){this.startup=s,this.codeLoadingTime=u,this.activateCallTime=p,this.activateResolvedTime=C}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class P{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,u){return s===-1||u===-1?-1:u-s}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class D{constructor(s,u,p,C,w,o){this.activationFailed=s,this.activationFailedError=u,this.activationTimes=p,this.module=C,this.exports=w,this.subscriptions=o}}e.ActivatedExtension=D;class T extends D{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class t extends D{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class _ extends D{constructor(s){super(!0,s,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let n=class{constructor(s,u,p,C,w){this._logService=w,this._registry=s,this._resolvedExtensionsSet=new Set,u.forEach(o=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,p.forEach(o=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(o),o)),this._host=C,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const u=d.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(u)}getActivatedExtension(s){const u=d.ExtensionIdentifier.toKey(s),p=this._activatedExtensions.get(u);if(!p)throw new Error("Extension `"+s.value+"` is not known or not activated");return p}activateByEvent(s,u){if(this._alreadyActivatedEvents[s])return A;const p=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(p.map(C=>({id:C.identifier,reason:{startup:u,extensionId:C.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,u){const p=this._registry.getExtensionDescription(s);if(!p)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:p.identifier,reason:u}])}_handleActivateRequest(s,u,p){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(s.id))){u[d.ExtensionIdentifier.toKey(s.id)]=s;return}const C=this._registry.getExtensionDescription(s.id);if(!C){const f=new Error(`Cannot activate unknown extension '${s.id.value}'`);this._host.onExtensionActivationError(s.id,f,new M.MissingExtensionDependency(s.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(s.id),new _(f));return}const w=typeof C.extensionDependencies=="undefined"?[]:C.extensionDependencies;let o=!0;for(let f=0,S=w.length;f<S;f++){const i=w[f];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(i)))continue;const g=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(i));if(g&&!g.activationFailed)continue;if(g&&g.activationFailed){const l=C.displayName||C.identifier.value,c=this._registry.getExtensionDescription(i),b=c&&c.displayName||i,h=new Error(`Cannot activate the '${l}' extension because its dependency '${b}' failed to activate`);h.detail=g.activationFailedError,this._host.onExtensionActivationError(C.identifier,h,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(C.identifier),new _(h));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(i))){o=!1,u[d.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){if(!a.main&&!a.browser)continue;o=!1,u[d.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:s.reason};continue}const r=C.displayName||C.identifier.value,v=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(C.identifier,v,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(C.identifier),new _(v));return}o?u[d.ExtensionIdentifier.toKey(C.identifier)]=s:p.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(w=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(w.id))),s.length===0))return Promise.resolve(void 0);const u=Object.create(null),p=[];for(let w=0,o=s.length;w<o;w++)this._handleActivateRequest(s[w],u,p);for(let w=0,o=p.length;w<o;w++){const f=d.ExtensionIdentifier.toKey(p[w].id);u[f]&&delete u[f]}const C=Object.keys(u).map(w=>u[w]);return p.length===0?Promise.all(C.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(C).then(w=>this._activateExtensions(p))}_activateExtension(s,u){const p=d.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const C=this._activatingExtensions.get(p);if(C)return C;const w=this._host.actualActivateExtension(s,u).then(void 0,o=>{const f=new Error;return o&&o.name&&(f.name=o.name),o&&o.message?f.message=`Activating extension '${s.value}' failed: ${o.message}.`:f.message=`Activating extension '${s.value}' failed: ${o}.`,o&&o.stack&&(f.stack=o.stack),this._host.onExtensionActivationError(s,f,null),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(o),new _(o)}).then(o=>{this._activatedExtensions.set(p,o),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,w),w}};n=$e([ze(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(be[180],Ee([0,1,16]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,F)=>{this._actualOk=A,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,d.onUnexpectedError)(A))}then(A,F){return this._ensureActual().then(A,F)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(be[38],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(T,t){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=t,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const M=[];function E(D){const T=new d(!0,D);return M[T.nid]=T,T}e.createMainContextProxyIdentifier=E;function A(D){const T=new d(!1,D);return M[T.nid]=T,T}e.createExtHostContextProxyIdentifier=A;function F(D){return M[D].sid}e.getStringIdentifierForProxy=F;class P{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=P}),define(be[5],Ee([0,1,55,2,38]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function f(i,g){return Object.defineProperty(i,o.name,{value:g,enumerable:!0}),i}o.mixin=f;function S(i){return i[o.name]}o.of=S})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(f){return f._id=m._n++,f}}e.IdObject=m,m._n=0;var s;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function C(o){if(o&&o.edits)for(const f of o.edits)typeof f.resource=="object"?f.resource=M.URI.revive(f.resource):(f.newUri=M.URI.revive(f.newUri),f.oldUri=M.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,d.revive)(f.metadata));return o}e.reviveWorkspaceEditDto=C;var w;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[69],Ee([0,1,5,3,4]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,D){return this._proxy.$getPassword(P,D)}store(P,D,T){return this._proxy.$setPassword(P,D,T)}delete(P,D){return this._proxy.$deletePassword(P,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(be[70],Ee([0,1,4,15,5,13]),function(oe,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(D,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(E.MainContext.MainThreadTelemetry)}report(D,T,t){const _=this.getUsageKey(D,T);this._reportedUsages.has(_)||(this._reportedUsages.add(_),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:D}))}getUsageKey(D,T){return`${D}-${T.identifier.value}`}};F=$e([ze(0,A.IExtHostRpcService),ze(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(P,D,T){}})}),define(be[181],Ee([0,1,3,5,7,26]),function(oe,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,T,t,_={}){const n=A.ExtensionIdentifier.toKey(D.identifier),m=this._inFlightRequests.get(n)||[],s=[...t].sort().join(" ");let u=m.find(p=>p.scopes===s);if(u)return u.result;{const p=this._getSession(D,n,T,t,_);u={scopes:s,result:p},m.push(u),this._inFlightRequests.set(n,m);try{await p}finally{const C=m.findIndex(w=>w.scopes===s);C>-1&&(m.splice(C),this._inFlightRequests.set(n,m))}return p}}async _getSession(D,T,t,_,n={}){await this._proxy.$ensureProvider(t);const m=D.displayName||D.name;return this._proxy.$getSession(t,_,T,m,n)}async removeSession(D,T){const t=this._authenticationProviders.get(D);return t?t.provider.removeSession(T):this._proxy.$removeSession(D,T)}registerAuthenticationProvider(D,T,t,_){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:T,provider:t,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===D)||this._providers.push({id:D,label:T});const n=t.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(D,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,T,_?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(D);const m=this._providers.findIndex(s=>s.id===D);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,T){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,T){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,T){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,T){return this._onDidChangeSessions.fire({provider:{id:D,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(be[182],Ee([0,1,5,13,8]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,D){this._extHostDocumentsAndEditors=D,this._proxy=P.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const D=E.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=$e([ze(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[183],Ee([0,1,5]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const F=A.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(P){return F.$writeText(P)}})}}e.ExtHostClipboard=M}),define(be[39],Ee([0,1,10,7,8,23,5,14,15,55,44,111,2,6,4,13,49,22,38,45]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(v,l){this._commands=new Map,this._apiCommands=new Map,this._proxy=v.getProxy(F.MainContext.MainThreadCommands),this._logService=l,this.converter=new S(this,c=>{const b=this._apiCommands.get(c);return b?.result===g.Void?b:void 0},l),this._argumentProcessors=[{processArgument(c){return(0,T.revive)(c)}},{processArgument(c){return(0,A.cloneAndChange)(c,function(b){if(t.Range.isIRange(b))return E.Range.to(b);if(_.Position.isIPosition(b))return E.Position.to(b);if(t.Range.isIRange(b.range)&&n.URI.isUri(b.uri))return E.location.to(b);if(b instanceof C.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(v){this._argumentProcessors.push(v)}registerApiCommand(v){const l=this.registerCommand(!1,v.id,async(...c)=>{const b=v.args.map((y,R)=>{if(!y.validate(c[R]))throw new Error(`Invalid argument '${y.name}' when running '${v.id}', received: ${c[R]}`);return y.convert(c[R])}),h=await this.executeCommand(v.internalId,...b);return v.result.convert(h,c,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this._apiCommands.set(v.id,v),new M.Disposable(()=>{l.dispose(),this._apiCommands.delete(v.id)})}registerCommand(v,l,c,b,h,y){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:c,thisArg:b,description:h,extension:y}),v&&this._proxy.$registerCommand(l),new M.Disposable(()=>{this._commands.delete(l)&&v&&this._proxy.$unregisterCommand(l)})}executeCommand(v,...l){return this._logService.trace("ExtHostCommands#executeCommand",v),this._doExecuteCommand(v,l,!0)}async _doExecuteCommand(v,l,c){if(this._commands.has(v))return this._executeContributedCommand(v,l,!1);{let b=!1;const h=(0,A.cloneAndChange)(l,function(y){if(y instanceof M.Position)return E.Position.from(y);if(y instanceof M.Range)return E.Range.from(y);if(y instanceof M.Location)return E.location.from(y);if(M.NotebookRange.isNotebookRange(y))return E.NotebookRange.from(y);if(y instanceof ArrayBuffer)return b=!0,C.VSBuffer.wrap(new Uint8Array(y));if(y instanceof Uint8Array)return b=!0,C.VSBuffer.wrap(y);if(!Array.isArray(y))return y});try{const y=await this._proxy.$executeCommand(v,b?new w.SerializableObjectWithBuffers(h):h,c);return(0,T.revive)(y)}catch(y){if(y instanceof Error&&y.message==="$executeCommand:retry")return this._doExecuteCommand(v,l,!1);throw y}}}async _executeContributedCommand(v,l,c){const b=this._commands.get(v);if(!b)throw new Error("Unknown command");let{callback:h,thisArg:y,description:R}=b;if(R)for(let k=0;k<R.args.length;k++)try{(0,d.validateConstraint)(l[k],R.args[k].constraint)}catch(O){throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${R.args[k].name}' - ${R.args[k].description}`)}try{return await h.apply(y,l)}catch(k){if(v===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...l);O&&(v=O.command)}throw this._logService.error(k,v,b.extension?.identifier),c?new class extends Error{constructor(){super((0,o.toErrorMessage)(k));this.id=v,this.source=b.extension?.displayName??b.extension?.name}}:k}}$executeContributedCommand(v,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",v),this._commands.has(v)?(l=l.map(c=>this._argumentProcessors.reduce((b,h)=>h.processArgument(b),c)),this._executeContributedCommand(v,l,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this._logService.trace("ExtHostCommands#getCommands",v),this._proxy.$getCommands().then(l=>(v&&(l=l.filter(c=>c[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const v=Object.create(null);for(let[l,c]of this._commands){let{description:b}=c;b&&(v[l]=b)}return Promise.resolve(v)}};f=$e([ze(0,u.IExtHostRpcService),ze(1,D.ILogService)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class S{constructor(v,l,c){this._commands=v,this._lookupApiCommand=l,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(v,l){if(!v)return;const c={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return c;const b=this._lookupApiCommand(v.command);if(b)c.id=b.internalId,c.arguments=b.args.map((h,y)=>h.convert(v.arguments&&v.arguments[y]));else if((0,P.isNonEmptyArray)(v.arguments)){const h=++this._cachIdPool;this._cache.set(h,v),l.add((0,m.toDisposable)(()=>{this._cache.delete(h),this._logService.trace("CommandsConverter#DISPOSE",h)})),c.$ident=h,c.id=this.delegatingCommandId,c.arguments=[h],this._logService.trace("CommandsConverter#CREATE",v.command,h)}return c}fromInternal(v){const l=F.ObjectIdentifier.of(v);return typeof l=="number"?this._cache.get(l):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this._cache.get(v[0])}_executeConvertedCommand(...v){const l=this.getActualCommand(...v);return this._logService.trace("CommandsConverter#EXECUTE",v[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=S;class i{constructor(v,l,c,b){this.name=v,this.description=l,this.validate=c,this.convert=b}optional(){return new i(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,l){return new i(v??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),i.Position=new i("position","A position in a text document",r=>M.Position.isPosition(r),E.Position.from),i.Range=new i("range","A range in a text document",r=>M.Range.isRange(r),E.Range.from),i.Selection=new i("selection","A selection in a text document",r=>M.Selection.isSelection(r),E.Selection.from),i.Number=new i("number","",r=>typeof r=="number",r=>r),i.String=new i("string","",r=>typeof r=="string",r=>r),i.CallHierarchyItem=new i("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",r=>r instanceof p.TestItemImpl,E.TestItem.from);class g{constructor(v,l){this.description=v,this.convert=l}}e.ApiCommandResult=g,g.Void=new g("no result",r=>r);class a{constructor(v,l,c,b,h){this.id=v,this.internalId=l,this.description=c,this.args=b,this.result=h}}e.ApiCommand=a}),define(be[184],Ee([0,1,8,7,59,39,14,81]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(d.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,m)=>{if((0,F.isFalsyOrEmpty)(n))return;class s extends M.SymbolInformation{static to(p){const C=new s(p.name,d.SymbolKind.to(p.kind),p.containerName||"",new M.Location(m[0],d.Range.to(p.range)));return C.detail=p.detail,C.range=C.location.range,C.selectionRange=d.Range.to(p.selectionRange),C.children=p.children?p.children.map(s.to):[],C}}return n.map(s.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(d.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(d.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(m=>M.Position.isPosition(m)),n=>n.map(d.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(m=>{let s;for(const u of m.reverse())s=new M.SelectionRange(d.Range.to(u),s);return s}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const m=[];if(Array.isArray(n))for(let s of n)m.push(...s[1].map(d.WorkspaceSymbol.to));return m})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:d.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return d.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(d.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,P.decodeSemanticTokensDto)(n);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range.optional()],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,P.decodeSemanticTokensDto)(n);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,m,s)=>{if(!n)return new M.CompletionList([]);const u=n.suggestions.map(p=>d.CompletionItem.to(p,s));return new M.CompletionList(u,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return d.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,m,s)=>t(u=>new M.CodeLens(d.Range.to(u.range),u.command&&s.fromInternal(u.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?d.Selection.from(n):d.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,m,s)=>t(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(u.command)}else{const p=new M.CodeAction(u.title,u.kind?new M.CodeActionKind(u.kind):void 0);return u.edit&&(p.edit=d.WorkspaceEdit.to(u.edit)),u.command&&(p.command=s.fromInternal(u.command)),p.isPreferred=u.isPreferred,p}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(m=>new M.ColorInformation(d.Range.to(m.range),d.Color.to(m.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,d.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:d.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(d.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(d.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(m=>d.NotebookExclusiveDocumentPattern.to(m))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(d.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class T{static register(m){D.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=T;function t(n){return m=>{if(Array.isArray(m))return m.map(n)}}function _(n){if(!Array.isArray(n))return;const m=[];for(const s of n)E.isLocationLink(s)?m.push(d.DefinitionLink.to(s)):m.push(d.location.to(s));return m}}),define(be[185],Ee([0,1,12,53,3,6,2,59,26,8,7,5]),function(oe,e,d,M,E,A,F,P,D,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(m,s,u){const p=m.getProxy(_.MainContext.MainThreadComments);class C{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const v=this._commentControllers.get(r.handle);return v||r}else if(r&&r.$mid===7){const v=this._commentControllers.get(r.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.commentThreadHandle);return l||r}else if(r&&r.$mid===8){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);return l?{thread:l,text:r.text}:r}else if(r&&r.$mid===9){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let c=r.commentUniqueId,b=l.getCommentByUniqueId(c);return b||r}else if(r&&r.$mid===10){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let c=r.text,b=r.commentUniqueId,h=l.getCommentByUniqueId(b);return h?(h.body=c,h):r}return r}})}createCommentController(r,v,l){const c=C.handlePool++,b=new o(r,c,v,l);this._commentControllers.set(b.handle,b);const h=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(r.identifier))||[];return h.push(b),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(r.identifier),h),b.value}$createCommentThreadTemplate(r,v,l){const c=this._commentControllers.get(r);!c||c.$createCommentThreadTemplate(v,l)}async $updateCommentThreadTemplate(r,v,l){const c=this._commentControllers.get(r);!c||c.$updateCommentThreadTemplate(v,l)}$deleteCommentThread(r,v){const l=this._commentControllers.get(r);l&&l.$deleteCommentThread(v)}$provideCommentingRanges(r,v,l){const c=this._commentControllers.get(r);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const b=u.getDocument(F.URI.revive(v));return(0,d.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(b,l)).then(h=>h?h.map(y=>T.Range.from(y)):void 0)}$toggleReaction(r,v,l,c,b){const h=this._commentControllers.get(r);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const y=h.getCommentThread(v);if(y){const R=y.getCommentByUniqueId(c.uniqueIdInThread);if(h!==void 0&&R&&h.reactionHandler)return h.reactionHandler(R,i(b))}return Promise.resolve(void 0)})}dispose(){}}C.handlePool=0;class w{constructor(r,v,l,c,b,h,y){this._commentControllerHandle=v,this._id=l,this._uri=c,this._range=b,this._comments=h,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),p.$createCommentThread(v,this.handle,this._id,this._uri,T.Range.from(this._range),y),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(v,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(k){R.range=k},get comments(){return R.comments},set comments(k){R.comments=k},get collapsibleState(){return R.collapsibleState},set collapsibleState(k){R.collapsibleState=k},get canReply(){return R.canReply},set canReply(k){R.canReply=k},get contextValue(){return R.contextValue},set contextValue(k){R.contextValue=k},get label(){return R.label},set label(k){R.label=k},dispose:()=>{R.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const r=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),v={};r("range")&&(v.range=T.Range.from(this._range)),r("label")&&(v.label=this.label),r("contextValue")&&(v.contextValue=this.contextValue),r("comments")&&(v.comments=this._comments.map(l=>f(this,l,this._commentsMap))),r("collapsibleState")&&(v.collapseState=g(this._collapseState)),r("canReply")&&(v.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,v)}getCommentByUniqueId(r){for(let v of this._commentsMap){let l=v[0],c=v[1];if(r===c)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}w._handlePool=0,$e([(0,M.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(r,v,l,c){this._extension=r,this._handle=v,this._id=l,this._label=c,this._threads=new Map,p.$registerCommentController(this.handle,l,c);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(h){b.options=h},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(h){b.commentingRangeProvider=h},get reactionHandler(){return b.reactionHandler},set reactionHandler(h){b.reactionHandler=h},createCommentThread(h,y,R){return b.createCommentThread(h,y,R).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(r){this._commentingRangeProvider=r,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,v,l,c){if(typeof r=="string"){const b=new w(this.id,this.handle,r,v,l,c,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new w(this.id,this.handle,void 0,r,v,l,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(r,v){const l=new w(this.id,this.handle,void 0,F.URI.revive(r),T.Range.to(v),[],this._extension.identifier);return l.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(r,v){let l=this._threads.get(r);l&&(l.range=T.Range.to(v))}$deleteCommentThread(r){let v=this._threads.get(r);v&&v.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function f(a,r,v){let l=v.get(r);l||(l=++a.commentHandle,v.set(r,l));const c=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:l,body:T.MarkdownString.from(r.body),userName:r.author.name,userIconPath:c,label:r.label,commentReactions:r.reactions?r.reactions.map(b=>S(b)):void 0}}function S(a){return{label:a.label,iconPath:a.iconPath?T.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function i(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?F.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function g(a){if(a!==void 0)switch(a){case t.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new C}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,13,15,14,9,17]),function(oe,e,d,M,E,A,F,P,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class vi{constructor(m,s){this._logService=s,this._provider=new Map,this._proxy=m.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,s){const u=vi._handlePool++;this._provider.set(u,{provider:m,extensionId:s}),this._proxy.$registerDecorationProvider(u,s.value);const p=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(C=>{if(!C){this._proxy.$onDidChange(u,null);return}let w=(0,D.asArray)(C);if(w.length<=vi._maxEventSize){this._proxy.$onDidChange(u,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,w.length);const o=w.map(i=>({uri:i,rank:(0,T.count)(i.path,"/")})),f=(0,D.groupBy)(o,(i,g)=>i.rank-g.rank||(0,T.compare)(i.uri.path,g.uri.path));let S=[];e:for(let i of f){let g;for(let a of i){let r=(0,t.dirname)(a.uri.path);if(g!==r&&(g=r,S.push(a.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(u,S)});return new E.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(m,s,u){if(!this._provider.has(m))return Object.create(null);const p=Object.create(null),{provider:C,extensionId:w}=this._provider.get(m);return await Promise.all(s.map(async o=>{try{const{uri:f,id:S}=o,i=await Promise.resolve(C.provideFileDecoration(d.URI.revive(f),u));if(!i)return;try{E.FileDecoration.validate(i),p[S]=[i.propagate,i.tooltip,i.badge,i.color]}catch(g){this._logService.warn(`INVALID decoration from extension '${w.value}': ${g}`)}}catch(f){this._logService.error(f)}})),p}};_._handlePool=0,_._maxEventSize=250,_=$e([ze(0,F.IExtHostRpcService),ze(1,P.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[186],Ee([0,1,123,83,2,5,7,8,3,15,20,37]),function(oe,e,d,M,E,A,F,P,D,T,t,_){"use strict";var n,m,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(w,o,f,S,i,g){this._name=w,this._owner=o,this._maxDiagnosticsPerFile=f,n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Ze(this,s,new t.ResourceMap(a=>S.getComparisonKey(a)),"f"),Ze(this,n,i,"f"),Ze(this,m,g,"f")}dispose(){this._isDisposed||(Re(this,m,"f").fire([...Re(this,s,"f").keys()]),Re(this,n,"f")&&Re(this,n,"f").$clear(this._owner),Re(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,o){if(!w){this.clear();return}this._checkDisposed();let f=[];if(E.URI.isUri(w)){if(!o){this.delete(w);return}Re(this,s,"f").set(w,o.slice()),f=[w]}else if(Array.isArray(w)){f=[];let i;w=[...w].sort(u._compareIndexedTuplesByUri);for(const g of w){const[a,r]=g;if((!i||a.toString()!==i.toString())&&(i&&Re(this,s,"f").get(i).length===0&&Re(this,s,"f").delete(i),i=a,f.push(a),Re(this,s,"f").set(a,[])),r){const v=Re(this,s,"f").get(a);v&&v.push(...r)}else{const v=Re(this,s,"f").get(a);v&&(v.length=0)}}}if(Re(this,m,"f").fire(f),!Re(this,n,"f"))return;const S=[];for(let i of f){let g=[];const a=Re(this,s,"f").get(i);if(a)if(a.length>this._maxDiagnosticsPerFile){g=[];const r=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(let l of a)if(l.severity===r[v]&&g.push(P.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;g.push({severity:M.MarkerSeverity.Info,message:(0,d.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=a.map(r=>P.Diagnostic.from(r));S.push([i,g])}Re(this,n,"f").$changeMany(this._owner,S)}delete(w){this._checkDisposed(),Re(this,m,"f").fire([w]),Re(this,s,"f").delete(w),Re(this,n,"f")&&Re(this,n,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),Re(this,m,"f").fire([...Re(this,s,"f").keys()]),Re(this,s,"f").clear(),Re(this,n,"f")&&Re(this,n,"f").$clear(this._owner)}forEach(w,o){this._checkDisposed();for(let f of Re(this,s,"f").keys())w.apply(o,[f,this.get(f),this])}get(w){this._checkDisposed();const o=Re(this,s,"f").get(w);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(Re(this,s,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,o){return w[0].toString()<o[0].toString()?-1:w[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=u,n=new WeakMap,m=new WeakMap,s=new WeakMap;let p=class ti{constructor(w,o,f){this._logService=o,this._fileSystemInfoService=f,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:S=>S.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,ti._mapper),this._proxy=w.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(w){const o=new t.ResourceMap;for(const f of w)o.set(f,f);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(w,o){const{_collections:f,_proxy:S,_onDidChangeDiagnostics:i,_logService:g,_fileSystemInfoService:a}=this,r=new class{$changeMany(c,b){S.$changeMany(c,b),g.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,c,b.length===0?"CLEARING":b)}$clear(c){S.$clear(c),g.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,c)}dispose(){S.dispose()}};let v;if(!o)o="_generated_diagnostic_collection_name_#"+ti._idPool++,v=o;else if(!f.has(o))v=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do v=o+ti._idPool++;while(f.has(v))}return new class extends u{constructor(){super(o,v,ti._maxDiagnosticsPerFile,a.extUri,r,i);f.set(v,this)}dispose(){super.dispose(),f.delete(v)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const o=new Map,f=[];for(const S of this._collections.values())S.forEach((i,g)=>{let a=o.get(i.toString());typeof a=="undefined"&&(a=f.length,o.set(i.toString(),a),f.push([i,[]])),f[a][1]=f[a][1].concat(...g)});return f}}_getDiagnostics(w){let o=[];for(let f of this._collections.values())f.has(w)&&(o=o.concat(f.get(w)));return o}$acceptMarkersChange(w){if(!this._mirrorCollection){const o="_generated_mirror",f=new u(o,o,ti._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,f),this._mirrorCollection=f}for(const[o,f]of w)this._mirrorCollection.set(E.URI.revive(o),f.map(P.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=$e([ze(1,T.ILogService),ze(2,_.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(be[187],Ee([0,1,2,5]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(P=>P?P.map(D=>d.URI.revive(D)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(P=>P?d.URI.revive(P):void 0)}}e.ExtHostDialogs=E}),define(be[188],Ee([0,1,16,2,7,5,11,21,9]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(_,n,m){this._documentsAndEditors=n,this._logService=m,this._documentContentProviders=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(F.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const m=T._handlePool++;this._documentContentProviders.set(m,n),this._proxy.$registerTextContentProvider(m,_);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(u=>{if(u.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(m,u).then(p=>{if(!p&&typeof p!="string")return;const C=this._documentsAndEditors.getDocument(u);if(!C)return;const w=(0,D.splitLines)(p);if(!C.equalLines(w))return this._proxy.$onVirtualDocumentChange(u,p)},d.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(_,n){const m=this._documentContentProviders.get(_);return m?Promise.resolve(m.provideTextDocumentContent(M.URI.revive(n),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(be[189],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(oe,e,d,M,E,A,F,P,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(m,s){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const p of u)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const p of u)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const s=this._documentsAndEditors.getDocument(m);if(s)return s}getDocument(m){const s=this.getDocumentData(m);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return s.document}ensureDocumentData(m){const s=this._documentsAndEditors.getDocument(m);if(s)return Promise.resolve(s);let u=this._documentLoader.get(m.toString());return u||(u=this._proxy.$tryOpenDocument(m).then(p=>{this._documentLoader.delete(m.toString());const C=E.URI.revive(p);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(C))},p=>(this._documentLoader.delete(m.toString()),Promise.reject(p))),this._documentLoader.set(m.toString(),u)),u}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(s=>E.URI.revive(s))}$acceptModelModeChanged(m,s){const u=E.URI.revive(m),p=this._documentsAndEditors.getDocument(u);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(s),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(m){const s=E.URI.revive(m),u=this._documentsAndEditors.getDocument(s);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(m,s){const u=E.URI.revive(m),p=this._documentsAndEditors.getDocument(u);if(!p)throw new Error("unknown document");p._acceptIsDirty(s),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,s,u){const p=E.URI.revive(m),C=this._documentsAndEditors.getDocument(p);if(!C)throw new Error("unknown document");C._acceptIsDirty(u),C.onEvents(s);let w;s.isUndoing?w=t.TextDocumentChangeReason.Undo:s.isRedoing&&(w=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:C.document,contentChanges:s.changes.map(o=>({range:P.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:w}))}setWordDefinitionFor(m,s){(0,F.setWordDefinitionFor)(m,s)}}e.ExtHostDocuments=_}),define(be[50],Ee([0,1,42,3,6,2,4,5,88,13,94,8,15,20,11,164,103]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class C{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(f,S){this._extHostRpc=f,this._logService=S,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const S=[],i=[],g=[];if(f.removedDocuments)for(const a of f.removedDocuments){const r=A.URI.revive(a),v=this._documents.get(r);v?.unref()&&(this._documents.delete(r),S.push(v.value))}if(f.addedDocuments)for(const a of f.addedDocuments){const r=A.URI.revive(a.uri);let v=this._documents.get(r);if(v&&r.scheme!==s.Schemas.vscodeNotebookCell&&r.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);v||(v=new C(new D.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),r,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this._documents.set(r,v),i.push(v.value)),v.ref()}if(f.removedEditors)for(const a of f.removedEditors){const r=this._editors.get(a);this._editors.delete(a),r&&g.push(r)}if(f.addedEditors)for(const a of f.addedEditors){const r=A.URI.revive(a.documentUri);d.ok(this._documents.has(r),`document '${r}' does not exist`),d.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const v=this._documents.get(r).value,l=new t.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>v.document),a.selections.map(_.Selection.to),a.options,a.visibleRanges.map(c=>_.Range.to(c)),typeof a.editorPosition=="number"?_.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,l)}f.newActiveEditor!==void 0&&(d.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,E.dispose)(S),(0,E.dispose)(g),f.removedDocuments&&this._onDidRemoveDocuments.fire(S),f.addedDocuments&&this._onDidAddDocuments.fire(i),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const S=this._editors.get(this._activeEditorId);return f?S:S?.value}allEditors(){return[...this._editors.values()]}};w=$e([ze(0,T.IExtHostRpcService),ze(1,n.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[71],Ee([0,1,8,5,2,3,4,13,12]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");let T=class{constructor(_){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((s,u)=>(s.isActive&&(n=u),Object.freeze({label:s.label,viewColumn:d.ViewColumn.to(s.viewColumn),index:u,resource:E.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:p,viewId:C})=>({resource:E.URI.revive(p),viewId:C})),viewId:s.editorId,isActive:s.isActive,move:async(p,C)=>{this._proxy.$moveTab(s,p,d.ViewColumn.from(C)),await(0,D.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,D.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,u)=>s.viewColumn===u.viewColumn?s.index-u.index:s.viewColumn-u.viewColumn);const m=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=$e([ze(0,P.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(be[190],Ee([0,1,2,5,6,7,8,232,9,22]),function(oe,e,d,M,E,A,F,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const s=this._schemes.indexOf(m);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),s=[];let u,p,C=14,w=14;for(const o of m){let f=u?(0,D.commonPrefixLength)(u,o):0;for(f===0?p=1:p=w;f<o.length;f++)f+1===o.length?(C=w,w=9):w+=1,s.push([p,o.toUpperCase().charCodeAt(f),w]),s.push([p,o.toLowerCase().charCodeAt(f),w]),p=w;u=o,w=C}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new P.StateMachine(s)}}provideDocumentLinks(m){this._initStateMachine();const s=[],u=P.LinkComputer.computeLinks({getLineContent(p){return m.lineAt(p-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const p of u){const C=F.DocumentLink.to(p);C.target&&s.push(C)}return s}}class _{constructor(m,s){this._extHostLanguageFeatures=s,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,s,u,p={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const C=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(C,u);let w=2;p.isCaseSensitive&&(w+=1024),p.isReadonly&&(w+=2048),typeof u.copy=="function"&&(w+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(w+=4),this._proxy.$registerFileSystemProvider(C,s,w).catch(f=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${s}`),console.error(f)});const o=u.onDidChangeFile(f=>{const S=[];for(const i of f){let{uri:g,type:a}=i;if(g.scheme!==s)continue;let r;switch(a){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}S.push({resource:g,type:r})}this._proxy.$onFileSystemChange(C,S)});return(0,E.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(C),this._proxy.$unregisterProvider(C)})}static _asIStat(m){const{type:s,ctime:u,mtime:p,size:C,permissions:w}=m;return{type:s,ctime:u,mtime:p,size:C,permissions:w}}$stat(m,s){return Promise.resolve(this._getFsProvider(m).stat(d.URI.revive(s))).then(u=>_._asIStat(u))}$readdir(m,s){return Promise.resolve(this._getFsProvider(m).readDirectory(d.URI.revive(s)))}$readFile(m,s){return Promise.resolve(this._getFsProvider(m).readFile(d.URI.revive(s))).then(u=>T.VSBuffer.wrap(u))}$writeFile(m,s,u,p){return Promise.resolve(this._getFsProvider(m).writeFile(d.URI.revive(s),u.buffer,p))}$delete(m,s,u){return Promise.resolve(this._getFsProvider(m).delete(d.URI.revive(s),u))}$rename(m,s,u,p){return Promise.resolve(this._getFsProvider(m).rename(d.URI.revive(s),d.URI.revive(u),p))}$copy(m,s,u,p){const C=this._getFsProvider(m);if(!C.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(C.copy(d.URI.revive(s),d.URI.revive(u),p))}$mkdir(m,s){return Promise.resolve(this._getFsProvider(m).createDirectory(d.URI.revive(s)))}$watch(m,s,u,p){const C=this._getFsProvider(m).watch(d.URI.revive(u),p);this._watches.set(s,C)}$unwatch(m,s){const u=this._watches.get(s);u&&(u.dispose(),this._watches.delete(s))}$open(m,s,u){const p=this._getFsProvider(m);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(d.URI.revive(s),u))}$close(m,s){const u=this._getFsProvider(m);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(s))}$read(m,s,u,p){const C=this._getFsProvider(m);if(!C.read)throw new Error('FileSystemProvider does not implement "read"');const w=T.VSBuffer.alloc(p);return Promise.resolve(C.read(s,u,w.buffer,0,p)).then(o=>w.slice(0,o))}$write(m,s,u,p){const C=this._getFsProvider(m);if(!C.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(C.write(s,u,p.buffer,0,p.byteLength))}_getFsProvider(m){const s=this._fsProvider.get(m);if(!s){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return s}}e.ExtHostFileSystem=_}),define(be[72],Ee([0,1,5,60,7,22,4,13,37]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class Ut{constructor(_,n){const m=_.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return m.$stat(s).catch(Ut._handleError)},readDirectory(s){return m.$readdir(s).catch(Ut._handleError)},createDirectory(s){return m.$mkdir(s).catch(Ut._handleError)},async readFile(s){return m.$readFile(s).then(u=>u.buffer).catch(Ut._handleError)},writeFile(s,u){return m.$writeFile(s,A.VSBuffer.wrap(u)).catch(Ut._handleError)},delete(s,u){return m.$delete(s,{recursive:!1,useTrash:!1,...u}).catch(Ut._handleError)},rename(s,u,p){return m.$rename(s,u,{overwrite:!1,...p}).catch(Ut._handleError)},copy(s,u,p){return m.$copy(s,u,{overwrite:!1,...p}).catch(Ut._handleError)},isWritableFileSystem(s){const u=n.getCapabilities(s);if(typeof u=="number")return!(u&2048)}})}static _handleError(_){if(!(_ instanceof Error))throw new E.FileSystemError(String(_));if(_.name==="ENOPRO")throw E.FileSystemError.Unavailable(_.message);switch(_.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(_.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(_.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(_.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(_.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(_.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(_.message);default:throw new E.FileSystemError(_.message,_.name)}}};T=$e([ze(0,P.IExtHostRpcService),ze(1,D.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(be[191],Ee([0,1,2,39]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(F,P,D,T){this._extHostNotebooks=P,this._textDocumentsAndEditors=D,this._commands=T;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new M.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new M.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new M.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new M.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:d.URI.revive(_.notebookUri),inputUri:d.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:d.URI.revive(_.notebookUri),inputUri:d.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,P,D,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:D,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=E}),define(be[192],Ee([0,1,6,5]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,F),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=E}),define(be[193],Ee([0,1,2,23,8,7,5,9,44,14,10,233,6,81,54,64,194,16,3]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor($,Q){this._documents=$,this._provider=Q}async provideDocumentSymbols($,Q){const te=this._documents.getDocument($),ae=await this._provider.provideDocumentSymbols(te,Q);if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(E.DocumentSymbol.from):o._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree($){$=$.slice(0).sort((ae,K)=>{let se=ae.location.range.start.compareTo(K.location.range.start);return se===0&&(se=K.location.range.end.compareTo(ae.location.range.end)),se});const Q=[],te=[];for(const ae of $){const K={name:ae.name||"!!MISSING: name!!",kind:E.SymbolKind.from(ae.kind),tags:ae.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:E.Range.from(ae.location.range),selectionRange:E.Range.from(ae.location.range),children:[]};for(;;){if(te.length===0){te.push(K),Q.push(K);break}const se=te[te.length-1];if(D.Range.containsRange(se.range,K.range)&&!D.Range.equalsRange(se.range,K.range)){se.children&&se.children.push(K),te.push(K);break}te.pop()}}return Q}}class f{constructor($,Q,te){this._documents=$,this._commands=Q,this._provider=te,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,Q){const te=this._documents.getDocument($),ae=await this._provider.provideCodeLenses(te,Q);if(!ae||Q.isCancellationRequested)return;const K=this._cache.add(ae),se=new n.DisposableStore;this._disposables.set(K,se);const he={cacheId:K,lenses:[]};for(let Ae=0;Ae<ae.length;Ae++)he.lenses.push({cacheId:[K,Ae],range:E.Range.from(ae[Ae].range),command:this._commands.toInternal(ae[Ae].command,se)});return he}async resolveCodeLens($,Q){const te=$.cacheId&&this._cache.get(...$.cacheId);if(!te)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?ae=te:ae=await this._provider.resolveCodeLens(te,Q),ae||(ae=te),Q.isCancellationRequested)return;const K=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!K)return $.command=this._commands.toInternal(ae.command??f._badCmd,K),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(Ve){return Array.isArray(Ve)?Ve.map(E.DefinitionLink.from):Ve?[E.DefinitionLink.from(Ve)]:[]}class i{constructor($,Q){this._documents=$,this._provider=Q}async provideDefinition($,Q,te){const ae=this._documents.getDocument($),K=E.Position.to(Q),se=await this._provider.provideDefinition(ae,K,te);return S(se)}}class g{constructor($,Q){this._documents=$,this._provider=Q}async provideDeclaration($,Q,te){const ae=this._documents.getDocument($),K=E.Position.to(Q),se=await this._provider.provideDeclaration(ae,K,te);return S(se)}}class a{constructor($,Q){this._documents=$,this._provider=Q}async provideImplementation($,Q,te){const ae=this._documents.getDocument($),K=E.Position.to(Q),se=await this._provider.provideImplementation(ae,K,te);return S(se)}}class r{constructor($,Q){this._documents=$,this._provider=Q}async provideTypeDefinition($,Q,te){const ae=this._documents.getDocument($),K=E.Position.to(Q),se=await this._provider.provideTypeDefinition(ae,K,te);return S(se)}}class v{constructor($,Q){this._documents=$,this._provider=Q}async provideHover($,Q,te){const ae=this._documents.getDocument($),K=E.Position.to(Q),se=await this._provider.provideHover(ae,K,te);if(!(!se||(0,T.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(K)),se.range||(se.range=new A.Range(K,K)),E.Hover.from(se)}}class l{constructor($,Q){this._documents=$,this._provider=Q}async provideEvaluatableExpression($,Q,te){const ae=this._documents.getDocument($),K=E.Position.to(Q),se=await this._provider.provideEvaluatableExpression(ae,K,te);if(se)return E.EvaluatableExpression.from(se)}}class c{constructor($,Q){this._documents=$,this._provider=Q}async provideInlineValues($,Q,te,ae){const K=this._documents.getDocument($),se=await this._provider.provideInlineValues(K,E.Range.to(Q),E.InlineValueContext.to(te),ae);if(Array.isArray(se))return se.map(he=>E.InlineValue.from(he))}}class b{constructor($,Q){this._documents=$,this._provider=Q}async provideDocumentHighlights($,Q,te){const ae=this._documents.getDocument($),K=E.Position.to(Q),se=await this._provider.provideDocumentHighlights(ae,K,te);if(Array.isArray(se))return se.map(E.DocumentHighlight.from)}}class h{constructor($,Q){this._documents=$,this._provider=Q}async provideLinkedEditingRanges($,Q,te){const ae=this._documents.getDocument($),K=E.Position.to(Q),se=await this._provider.provideLinkedEditingRanges(ae,K,te);if(se&&Array.isArray(se.ranges))return{ranges:(0,T.coalesce)(se.ranges.map(E.Range.from)),wordPattern:se.wordPattern}}}class y{constructor($,Q){this._documents=$,this._provider=Q}async provideReferences($,Q,te,ae){const K=this._documents.getDocument($),se=E.Position.to(Q),he=await this._provider.provideReferences(K,se,te,ae);if(Array.isArray(he))return he.map(E.location.from)}}class R{constructor($,Q,te,ae,K,se,he){this._documents=$,this._commands=Q,this._diagnostics=te,this._provider=ae,this._logService=K,this._extension=se,this._apiDeprecation=he,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,Q,te,ae){const K=this._documents.getDocument($),se=_.Selection.isISelection(Q)?E.Selection.to(Q):E.Range.to(Q),he=[];for(const st of this._diagnostics.getDiagnostics($))if(se.intersection(st.range)&&he.push(st)>R._maxCodeActionsPerFile)break;const Ae={diagnostics:he,only:te.only?new A.CodeActionKind(te.only):void 0,triggerKind:E.CodeActionTriggerKind.to(te.trigger)},Ue=await this._provider.provideCodeActions(K,se,Ae,ae);if(!(0,T.isNonEmptyArray)(Ue)||ae.isCancellationRequested)return;const He=this._cache.add(Ue),Qe=new n.DisposableStore;this._disposables.set(He,Qe);const et=[];for(let st=0;st<Ue.length;st++){const ye=Ue[st];!ye||(R._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Qe)})):(Ae.only&&(ye.kind?Ae.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[He,st],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Qe),diagnostics:ye.diagnostics&&ye.diagnostics.map(E.Diagnostic.from),edit:ye.edit&&E.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:He,actions:et}}async resolveCodeAction($,Q){const[te,ae]=$,K=this._cache.get(te,ae);if(!K||R._isCommand(K)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(K,Q)??K;return se?.edit?E.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}R._maxCodeActionsPerFile=1e3;class k{constructor($,Q){this._documents=$,this._provider=Q}async provideDocumentFormattingEdits($,Q,te){const ae=this._documents.getDocument($),K=await this._provider.provideDocumentFormattingEdits(ae,Q,te);if(Array.isArray(K))return K.map(E.TextEdit.from)}}class O{constructor($,Q){this._documents=$,this._provider=Q}async provideDocumentRangeFormattingEdits($,Q,te,ae){const K=this._documents.getDocument($),se=E.Range.to(Q),he=await this._provider.provideDocumentRangeFormattingEdits(K,se,te,ae);if(Array.isArray(he))return he.map(E.TextEdit.from)}}class N{constructor($,Q){this._documents=$,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,Q,te,ae,K){const se=this._documents.getDocument($),he=E.Position.to(Q),Ae=await this._provider.provideOnTypeFormattingEdits(se,he,te,ae,K);if(Array.isArray(Ae))return Ae.map(E.TextEdit.from)}}class I{constructor($,Q){this._provider=$,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,Q){const te=F.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols($,Q);if((0,T.isNonEmptyArray)(ae))for(const K of ae){if(!K)continue;if(!K.name){this._logService.warn("INVALID SymbolInformation, lacks name",K);continue}const se=F.IdObject.mixin(E.WorkspaceSymbol.from(K));this._symbolCache.set(se._id,K),te.symbols.push(se)}return te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te}async resolveWorkspaceSymbol($,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const te=this._symbolCache.get($._id);if(te){const ae=await this._provider.resolveWorkspaceSymbol(te,Q);return ae&&(0,M.mixin)($,E.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols($){const Q=this._resultCache.get($);if(Q){for(let[te,ae]=Q;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete($)}}}class B{constructor($,Q,te){this._documents=$,this._provider=Q,this._logService=te}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,Q,te,ae){const K=this._documents.getDocument($),se=E.Position.to(Q);try{const he=await this._provider.provideRenameEdits(K,se,te,ae);return he?E.WorkspaceEdit.from(he):void 0}catch(he){const Ae=B._asMessage(he);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation($,Q,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument($),K=E.Position.to(Q);try{const se=await this._provider.prepareRename(ae,K,te);let he,Ae;if(A.Range.isRange(se)?(he=se,Ae=ae.getText(se)):(0,t.isObject)(se)&&(he=se.range,Ae=se.placeholder),!he||!Ae)return;if(he.start.line>K.line||he.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(he),text:Ae}}catch(se){const he=B._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class x{constructor($,Q){this.resultId=$,this.tokens=Q}}class V{constructor($,Q){this._documents=$,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,Q,te){const ae=this._documents.getDocument($),K=Q!==0?this._previousResults.get(Q):null;let se=typeof K?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,K.resultId,te):await this._provider.provideDocumentSemanticTokens(ae,te);return K&&this._previousResults.delete(Q),se?(se=V._fixProvidedSemanticTokens(se),this._send(V._convertToEdits(K,se),se)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return V._isSemanticTokens($)?V._isCorrectSemanticTokens($)?$:new A.SemanticTokens(new Uint32Array($.data),$.resultId):V._isSemanticTokensEdits($)?V._isCorrectSemanticTokensEdits($)?$:new A.SemanticTokensEdits($.edits.map(Q=>new A.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const Q of $.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,Q){if(!V._isSemanticTokens(Q)||!$||!$.tokens)return Q;const te=$.tokens,ae=te.length,K=Q.data,se=K.length;let he=0;const Ae=Math.min(ae,se);for(;he<Ae&&te[he]===K[he];)he++;if(he===ae&&he===se)return new A.SemanticTokensEdits([],Q.resultId);let Ue=0;const He=Ae-he;for(;Ue<He&&te[ae-Ue-1]===K[se-Ue-1];)Ue++;return new A.SemanticTokensEdits([{start:he,deleteCount:ae-he-Ue,data:K.subarray(he,se-Ue)}],Q.resultId)}_send($,Q){if(V._isSemanticTokens($)){const te=this._nextResultId++;return this._previousResults.set(te,new x($.resultId,$.data)),(0,m.encodeSemanticTokensDto)({id:te,type:"full",data:$.data})}if(V._isSemanticTokensEdits($)){const te=this._nextResultId++;return V._isSemanticTokens(Q)?this._previousResults.set(te,new x(Q.resultId,Q.data)):this._previousResults.set(te,new x($.resultId)),(0,m.encodeSemanticTokensDto)({id:te,type:"delta",deltas:($.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class H{constructor($,Q){this._documents=$,this._provider=Q}async provideDocumentRangeSemanticTokens($,Q,te){const ae=this._documents.getDocument($),K=await this._provider.provideDocumentRangeSemanticTokens(ae,E.Range.to(Q),te);return K?this._send(K):null}_send($){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=H;class W{constructor($,Q,te,ae,K){this._documents=$,this._commands=Q,this._provider=te,this._apiDeprecation=ae,this._extension=K,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,Q,te,ae){const K=this._documents.getDocument($),se=E.Position.to(Q),he=K.getWordRangeAtPosition(se)||new A.Range(se,se),Ae=he.with({end:se}),Ue=new p.StopWatch(!0),He=await this._provider.provideCompletionItems(K,se,ae,E.CompletionContext.to(te));if(!He||ae.isCancellationRequested)return;const Qe=Array.isArray(He)?new A.CompletionList(He):He,et=W.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const ye=[],nt={x:et,b:ye,a:{replace:E.Range.from(he),insert:E.Range.from(Ae)},c:Qe.isIncomplete||void 0,d:Ue.elapsed()};for(let G=0;G<Qe.items.length;G++){const Z=Qe.items[G],pe=this._convertCompletionItem(Z,[et,G],Ae,he);ye.push(pe)}return nt}async resolveCompletionItem($,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...$);if(!te)return;const ae=await this._provider.resolveCompletionItem(te,Q);if(!!ae)return this._convertCompletionItem(ae,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,Q,te,ae){const K=this._disposables.get(Q[0]);if(!K)throw Error("DisposableStore is missing...");const se={x:Q,a:$.label,b:$.kind!==void 0?E.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(E.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:E.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal($.command,K)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=$.textEdit.newText):typeof $.insertText=="string"?se.h=$.insertText:$.insertText instanceof A.SnippetString&&(se.h=$.insertText.value,se.i|=4);let he;return $.textEdit?he=$.textEdit.range:$.range&&(he=$.range),A.Range.isRange(he)?se.j=E.Range.from(he):he&&(!te?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(se.j={insert:E.Range.from(he.inserting),replace:E.Range.from(he.replacing)}),se}}class ee{constructor($,Q,te){this._documents=$,this._provider=Q,this._commands=te,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,Q,te,ae){const K=this._documents.getDocument($),se=E.Position.to(Q),he=await this._provider.provideInlineCompletionItems(K,se,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:E.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:te.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Ae=(0,t.isArray)(he)?{items:he}:he,Ue=this._cache.add(Ae.items);let He;return{pid:Ue,items:Ae.items.map((Qe,et)=>{let st;return Qe.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ue,He)),st=this._commands.toInternal(Qe.command,He)),{text:Qe.text,range:Qe.range?E.Range.from(Qe.range):void 0,command:st,idx:et}})}}disposeCompletions($){this._cache.delete($);const Q=this._disposables.get($);Q&&Q.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,Q){const te=this._cache.get($,Q);te&&q.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class q{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let Q=q.map.get($);return Q||(Q=new q,q.map.set($,Q)),Q}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=q,q.map=new WeakMap;class Y{constructor($,Q){this._documents=$,this._provider=Q,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp($,Q,te,ae){const K=this._documents.getDocument($),se=E.Position.to(Q),he=this.reviveContext(te),Ae=await this._provider.provideSignatureHelp(K,se,ae,he);if(Ae){const Ue=this._cache.add([Ae]);return{...E.SignatureHelp.from(Ae),id:Ue}}}reviveContext($){let Q;if($.activeSignatureHelp){const te=E.SignatureHelp.to($.activeSignatureHelp),ae=this._cache.get($.activeSignatureHelp.id,0);ae?(Q=ae,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return{...$,activeSignatureHelp:Q}}releaseSignatureHelp($){this._cache.delete($)}}class j{constructor($,Q){this._documents=$,this._provider=Q}async provideInlayHints($,Q,te){const ae=this._documents.getDocument($),K=await this._provider.provideInlayHints(ae,E.Range.to(Q),te);return K?{hints:K.map(E.InlayHint.from)}:void 0}}class le{constructor($,Q){this._documents=$,this._provider=Q,this._cache=new u.Cache("DocumentLink")}async provideLinks($,Q){const te=this._documents.getDocument($),ae=await this._provider.provideDocumentLinks(te,Q);if(!(!Array.isArray(ae)||ae.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(E.DocumentLink.from)};{const K=this._cache.add(ae),se={links:[],id:K};for(let he=0;he<ae.length;he++){if(!le._validateLink(ae[he]))continue;const Ae=E.DocumentLink.from(ae[he]);Ae.cacheId=[K,he],se.links.push(Ae)}return se}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...$);if(!te)return;const ae=await this._provider.resolveDocumentLink(te,Q);if(!(!ae||!le._validateLink(ae)))return E.DocumentLink.from(ae)}releaseLinks($){this._cache.delete($)}}class re{constructor($,Q){this._documents=$,this._provider=Q}async provideColors($,Q){const te=this._documents.getDocument($),ae=await this._provider.provideDocumentColors(te,Q);return Array.isArray(ae)?ae.map(se=>({color:E.Color.from(se.color),range:E.Range.from(se.range)})):[]}async provideColorPresentations($,Q,te){const ae=this._documents.getDocument($),K=E.Range.to(Q.range),se=E.Color.to(Q.color),he=await this._provider.provideColorPresentations(se,{document:ae,range:K},te);if(!!Array.isArray(he))return he.map(E.ColorPresentation.from)}}class ve{constructor($,Q){this._documents=$,this._provider=Q}async provideFoldingRanges($,Q,te){const ae=this._documents.getDocument($),K=await this._provider.provideFoldingRanges(ae,Q,te);if(!!Array.isArray(K))return K.map(E.FoldingRange.from)}}class Fe{constructor($,Q,te){this._documents=$,this._provider=Q,this._logService=te}async provideSelectionRanges($,Q,te){const ae=this._documents.getDocument($),K=Q.map(E.Position.to),se=await this._provider.provideSelectionRanges(ae,K,te);if(!(0,T.isNonEmptyArray)(se))return[];if(se.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ae=0;Ae<K.length;Ae++){const Ue=[];he.push(Ue);let He=K[Ae],Qe=se[Ae];for(;;){if(!Qe.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(E.SelectionRange.from(Qe)),!Qe.parent)break;He=Qe.range,Qe=Qe.parent}}return he}}class Me{constructor($,Q){this._documents=$,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession($,Q,te){const ae=this._documents.getDocument($),K=E.Position.to(Q),se=await this._provider.prepareCallHierarchy(ae,K,te);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo($,Q,te){const ae=this._itemFromCache($,Q);if(!ae)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!K)return K.map(se=>({from:this._cacheAndConvertItem($,se.from),fromRanges:se.fromRanges.map(he=>E.Range.from(he))}))}async provideCallsFrom($,Q,te){const ae=this._itemFromCache($,Q);if(!ae)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!K)return K.map(se=>({to:this._cacheAndConvertItem($,se.to),fromRanges:se.fromRanges.map(he=>E.Range.from(he))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,Q){const te=this._cache.get($),ae=E.CallHierarchyItem.from(Q,$,te.size.toString(36));return te.set(ae._itemId,Q),ae}_itemFromCache($,Q){return this._cache.get($)?.get(Q)}}class Oe{constructor($,Q){this._documents=$,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession($,Q,te){const ae=this._documents.getDocument($),K=E.Position.to(Q),se=await this._provider.prepareTypeHierarchy(ae,K,te);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,se)]}async provideSupertypes($,Q,te){const ae=this._itemFromCache($,Q);if(!ae)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySupertypes(ae,te);if(!!K)return K.map(se=>this._cacheAndConvertItem($,se))}async provideSubtypes($,Q,te){const ae=this._itemFromCache($,Q);if(!ae)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySubtypes(ae,te);if(!!K)return K.map(se=>this._cacheAndConvertItem($,se))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,Q){const te=this._cache.get($),ae=E.TypeHierarchyItem.from(Q,$,te.size.toString(36));return te.set(ae._itemId,Q),ae}_itemFromCache($,Q){return this._cache.get($)?.get(Q)}}class Ke{constructor($,Q){this.adapter=$,this.extension=Q}}class qe{constructor($,Q,te,ae,K,se,he){this._adapter=new Map,this._uriTransformer=Q,this._proxy=$.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=K,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector($){return E.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new A.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return qe._handlePool++}_withAdapter($,Q,te,ae,K=!1){const se=this._adapter.get($);if(!se)return Promise.resolve(ae);if(se.adapter instanceof Q){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Ae=te(se.adapter,se.extension),Ue=se.extension;return Ue&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-he}ms`),He=>{K&&He instanceof C.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error(He))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,Q){const te=this._nextHandle();return this._adapter.set(te,new Ke($,Q)),te}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,Q,te,ae){const K=this._addNewAdapter(new o(this._documents,te),$),se=ae&&ae.label||qe._extLabel($);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(Q),se),this._createDisposable(K)}$provideDocumentSymbols($,Q,te){return this._withAdapter($,o,ae=>ae.provideDocumentSymbols(d.URI.revive(Q),te),void 0)}registerCodeLensProvider($,Q,te){const ae=this._nextHandle(),K=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ke(new f(this._documents,this._commands.converter,te),$)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Q),K);let se=this._createDisposable(ae);if(K!==void 0){const he=te.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(K));se=A.Disposable.from(se,he)}return se}$provideCodeLenses($,Q,te){return this._withAdapter($,f,ae=>ae.provideCodeLenses(d.URI.revive(Q),te),void 0)}$resolveCodeLens($,Q,te){return this._withAdapter($,f,ae=>ae.resolveCodeLens(Q,te),void 0)}$releaseCodeLenses($,Q){this._withAdapter($,f,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider($,Q,te){const ae=this._addNewAdapter(new i(this._documents,te),$);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDefinition($,Q,te,ae){return this._withAdapter($,i,K=>K.provideDefinition(d.URI.revive(Q),te,ae),[])}registerDeclarationProvider($,Q,te){const ae=this._addNewAdapter(new g(this._documents,te),$);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDeclaration($,Q,te,ae){return this._withAdapter($,g,K=>K.provideDeclaration(d.URI.revive(Q),te,ae),[])}registerImplementationProvider($,Q,te){const ae=this._addNewAdapter(new a(this._documents,te),$);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideImplementation($,Q,te,ae){return this._withAdapter($,a,K=>K.provideImplementation(d.URI.revive(Q),te,ae),[])}registerTypeDefinitionProvider($,Q,te){const ae=this._addNewAdapter(new r(this._documents,te),$);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideTypeDefinition($,Q,te,ae){return this._withAdapter($,r,K=>K.provideTypeDefinition(d.URI.revive(Q),te,ae),[])}registerHoverProvider($,Q,te,ae){const K=this._addNewAdapter(new v(this._documents,te),$);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideHover($,Q,te,ae){return this._withAdapter($,v,K=>K.provideHover(d.URI.revive(Q),te,ae),void 0)}registerEvaluatableExpressionProvider($,Q,te,ae){const K=this._addNewAdapter(new l(this._documents,te),$);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideEvaluatableExpression($,Q,te,ae){return this._withAdapter($,l,K=>K.provideEvaluatableExpression(d.URI.revive(Q),te,ae),void 0)}registerInlineValuesProvider($,Q,te,ae){const K=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new c(this._documents,te),$);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Q),K);let he=this._createDisposable(se);if(K!==void 0){const Ae=te.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(K));he=A.Disposable.from(he,Ae)}return he}$provideInlineValues($,Q,te,ae,K){return this._withAdapter($,c,se=>se.provideInlineValues(d.URI.revive(Q),te,ae,K),void 0)}registerDocumentHighlightProvider($,Q,te){const ae=this._addNewAdapter(new b(this._documents,te),$);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentHighlights($,Q,te,ae){return this._withAdapter($,b,K=>K.provideDocumentHighlights(d.URI.revive(Q),te,ae),void 0)}registerLinkedEditingRangeProvider($,Q,te){const ae=this._addNewAdapter(new h(this._documents,te),$);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideLinkedEditingRanges($,Q,te,ae){return this._withAdapter($,h,async K=>{const se=await K.provideLinkedEditingRanges(d.URI.revive(Q),te,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?qe._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider($,Q,te){const ae=this._addNewAdapter(new y(this._documents,te),$);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideReferences($,Q,te,ae,K){return this._withAdapter($,y,se=>se.provideReferences(d.URI.revive(Q),te,ae,K),void 0)}registerCodeActionProvider($,Q,te,ae){const K=new n.DisposableStore,se=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,te,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(Q),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,K)}))},qe._extLabel($),Boolean(te.resolveCodeAction)),K.add(this._createDisposable(se)),K}$provideCodeActions($,Q,te,ae,K){return this._withAdapter($,R,se=>se.provideCodeActions(d.URI.revive(Q),te,ae,K),void 0)}$resolveCodeAction($,Q,te){return this._withAdapter($,R,ae=>ae.resolveCodeAction(Q,te),void 0)}$releaseCodeActions($,Q){this._withAdapter($,R,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider($,Q,te){const ae=this._addNewAdapter(new k(this._documents,te),$);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Q),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentFormattingEdits($,Q,te,ae){return this._withAdapter($,k,K=>K.provideDocumentFormattingEdits(d.URI.revive(Q),te,ae),void 0)}registerDocumentRangeFormattingEditProvider($,Q,te){const ae=this._addNewAdapter(new O(this._documents,te),$);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Q),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits($,Q,te,ae,K){return this._withAdapter($,O,se=>se.provideDocumentRangeFormattingEdits(d.URI.revive(Q),te,ae,K),void 0)}registerOnTypeFormattingEditProvider($,Q,te,ae){const K=this._addNewAdapter(new N(this._documents,te),$);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(Q),ae,$.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits($,Q,te,ae,K,se){return this._withAdapter($,N,he=>he.provideOnTypeFormattingEdits(d.URI.revive(Q),te,ae,K,se),void 0)}registerWorkspaceSymbolProvider($,Q){const te=this._addNewAdapter(new I(Q,this._logService),$);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols($,Q,te){return this._withAdapter($,I,ae=>ae.provideWorkspaceSymbols(Q,te),{symbols:[]})}$resolveWorkspaceSymbol($,Q,te){return this._withAdapter($,I,ae=>ae.resolveWorkspaceSymbol(Q,te),void 0)}$releaseWorkspaceSymbols($,Q){this._withAdapter($,I,te=>te.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider($,Q,te){const ae=this._addNewAdapter(new B(this._documents,te,this._logService),$);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Q),B.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits($,Q,te,ae,K){return this._withAdapter($,B,se=>se.provideRenameEdits(d.URI.revive(Q),te,ae,K),void 0)}$resolveRenameLocation($,Q,te,ae){return this._withAdapter($,B,K=>K.resolveRenameLocation(d.URI.revive(Q),te,ae),void 0)}registerDocumentSemanticTokensProvider($,Q,te,ae){const K=this._nextHandle(),se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(K,new Ke(new V(this._documents,te),$)),this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(Q),ae,se);let he=this._createDisposable(K);if(se){const Ae=te.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=A.Disposable.from(he,Ae)}return he}$provideDocumentSemanticTokens($,Q,te,ae){return this._withAdapter($,V,K=>K.provideDocumentSemanticTokens(d.URI.revive(Q),te,ae),null,!0)}$releaseDocumentSemanticTokens($,Q){this._withAdapter($,V,te=>te.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider($,Q,te,ae){const K=this._addNewAdapter(new H(this._documents,te),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(Q),ae),this._createDisposable(K)}$provideDocumentRangeSemanticTokens($,Q,te,ae){return this._withAdapter($,H,K=>K.provideDocumentRangeSemanticTokens(d.URI.revive(Q),te,ae),null,!0)}registerCompletionItemProvider($,Q,te,ae){const K=this._addNewAdapter(new W(this._documents,this._commands.converter,te,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(K,this._transformDocumentSelector(Q),ae,W.supportsResolving(te),`${$.identifier.value}(${ae.join("")})`),this._createDisposable(K)}$provideCompletionItems($,Q,te,ae,K){return this._withAdapter($,W,se=>se.provideCompletionItems(d.URI.revive(Q),te,ae,K),void 0)}$resolveCompletionItem($,Q,te){return this._withAdapter($,W,ae=>ae.resolveCompletionItem(Q,te),void 0)}$releaseCompletionItems($,Q){this._withAdapter($,W,te=>te.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider($,Q,te){const ae=this._addNewAdapter(new ee(this._documents,te,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideInlineCompletions($,Q,te,ae,K){return this._withAdapter($,ee,se=>se.provideInlineCompletions(d.URI.revive(Q),te,ae,K),void 0)}$handleInlineCompletionDidShow($,Q,te){this._withAdapter($,ee,async ae=>{ae.handleDidShowCompletionItem(Q,te)},void 0)}$freeInlineCompletionsList($,Q){this._withAdapter($,ee,async te=>{te.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider($,Q,te,ae){const K=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new Y(this._documents,te),$);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Q),K),this._createDisposable(se)}$provideSignatureHelp($,Q,te,ae,K){return this._withAdapter($,Y,se=>se.provideSignatureHelp(d.URI.revive(Q),te,ae,K),void 0)}$releaseSignatureHelp($,Q){this._withAdapter($,Y,te=>te.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider($,Q,te){const ae=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new j(this._documents,te),$);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(Q),ae);let se=this._createDisposable(K);if(ae!==void 0){const he=te.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(ae));se=A.Disposable.from(se,he)}return se}$provideInlayHints($,Q,te,ae){return this._withAdapter($,j,K=>K.provideInlayHints(d.URI.revive(Q),te,ae),void 0)}registerDocumentLinkProvider($,Q,te){const ae=this._addNewAdapter(new le(this._documents,te),$);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Q),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks($,Q,te){return this._withAdapter($,le,ae=>ae.provideLinks(d.URI.revive(Q),te),void 0)}$resolveDocumentLink($,Q,te){return this._withAdapter($,le,ae=>ae.resolveLink(Q,te),void 0)}$releaseDocumentLinks($,Q){this._withAdapter($,le,te=>te.releaseLinks(Q),void 0)}registerColorProvider($,Q,te){const ae=this._addNewAdapter(new re(this._documents,te),$);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentColors($,Q,te){return this._withAdapter($,re,ae=>ae.provideColors(d.URI.revive(Q),te),[])}$provideColorPresentations($,Q,te,ae){return this._withAdapter($,re,K=>K.provideColorPresentations(d.URI.revive(Q),te,ae),void 0)}registerFoldingRangeProvider($,Q,te){const ae=this._nextHandle(),K=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ke(new ve(this._documents,te),$)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Q),K);let se=this._createDisposable(ae);if(K!==void 0){const he=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));se=A.Disposable.from(se,he)}return se}$provideFoldingRanges($,Q,te,ae){return this._withAdapter($,ve,K=>K.provideFoldingRanges(d.URI.revive(Q),te,ae),void 0)}registerSelectionRangeProvider($,Q,te){const ae=this._addNewAdapter(new Fe(this._documents,te,this._logService),$);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideSelectionRanges($,Q,te,ae){return this._withAdapter($,Fe,K=>K.provideSelectionRanges(d.URI.revive(Q),te,ae),[])}registerCallHierarchyProvider($,Q,te){const ae=this._addNewAdapter(new Me(this._documents,te),$);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareCallHierarchy($,Q,te,ae){return this._withAdapter($,Me,K=>Promise.resolve(K.prepareSession(d.URI.revive(Q),te,ae)),void 0)}$provideCallHierarchyIncomingCalls($,Q,te,ae){return this._withAdapter($,Me,K=>K.provideCallsTo(Q,te,ae),void 0)}$provideCallHierarchyOutgoingCalls($,Q,te,ae){return this._withAdapter($,Me,K=>K.provideCallsFrom(Q,te,ae),void 0)}$releaseCallHierarchy($,Q){this._withAdapter($,Me,te=>Promise.resolve(te.releaseSession(Q)),void 0)}registerTypeHierarchyProvider($,Q,te){const ae=this._addNewAdapter(new Oe(this._documents,te),$);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareTypeHierarchy($,Q,te,ae){return this._withAdapter($,Oe,K=>Promise.resolve(K.prepareSession(d.URI.revive(Q),te,ae)),void 0)}$provideTypeHierarchySupertypes($,Q,te,ae){return this._withAdapter($,Oe,K=>K.provideSupertypes(Q,te,ae),void 0)}$provideTypeHierarchySubtypes($,Q,te,ae){return this._withAdapter($,Oe,K=>K.provideSubtypes(Q,te,ae),void 0)}$releaseTypeHierarchy($,Q){this._withAdapter($,Oe,te=>Promise.resolve(te.releaseSession(Q)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,P.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:qe._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:qe._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?qe._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?qe._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:qe._serializeRegExp($.beforeText),afterText:$.afterText?qe._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?qe._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(qe._serializeOnEnterRule)}setLanguageConfiguration($,Q,te){let{wordPattern:ae}=te;if(ae&&(0,P.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Q,ae):this._documents.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const K=this._nextHandle(),se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?qe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?qe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?qe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(K,Q,se),this._createDisposable(K)}$setWordDefinitions($){for(const Q of $)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=qe,qe._handlePool=0}),define(be[195],Ee([0,1,5,8,7,35,12,6]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(t,_,n,m){this._documents=_,this._commands=n,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,_){await this._proxy.$changeLanguage(t,_);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,_){const n=t.version,m=M.Position.from(_),s=await this._proxy.$tokensAtPosition(t.uri,m),u={type:E.StandardTokenType.Other,range:t.getWordRangeAtPosition(_)??new E.Range(_.line,_.character,_.line,_.character)};if(!s)return u;const p={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!p.range.contains(_)||n!==t.version?u:p}createLanguageStatusItem(t,_,n){const m=this._handlePool++,s=this._proxy,u=this._ids,p=`${t.identifier.value}/${_}`;if(u.has(p))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);u.add(p);const C={selector:n,id:_,name:t.displayName??t.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let w,o=new P.DisposableStore;const f=()=>{w?.dispose(),w=(0,F.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(m,{id:p,name:C.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(C.selector,this._uriTransformer),label:C.text,detail:C.detail??"",severity:C.severity===E.LanguageStatusSeverity.Error?A.default.Error:C.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:C.command&&this._commands.toInternal(C.command,o),accessibilityInfo:C.accessibilityInformation})},0)},S={dispose(){o.dispose(),w?.dispose(),s.$removeLanguageStatus(m),u.delete(p)},get id(){return C.id},get name(){return C.name},set name(i){C.name=i,f()},get selector(){return C.selector},set selector(i){C.selector=i,f()},get text(){return C.text},set text(i){C.text=i,f()},get detail(){return C.detail},set detail(i){C.detail=i,f()},get severity(){return C.severity},set severity(i){C.severity=i,f()},get accessibilityInformation(){return C.accessibilityInformation},set accessibilityInformation(i){C.accessibilityInformation=i,f()},get command(){return C.command},set command(i){C.command=i,f()}};return f(),S}}e.ExtHostLanguages=D}),define(be[196],Ee([0,1,5,15,30]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let F=class{constructor(D,T){this._logService=T,this._proxy=D.getProxy(d.MainContext.MainThreadMessageService)}showMessage(D,T,t,_,n){const m={extension:D};let s;typeof _=="string"||A(_)?s=[_,...n]:(m.modal=_?.modal,m.useCustom=_?.useCustom,m.detail=_?.detail,s=n),m.useCustom&&(0,E.checkProposedApiEnabled)(D);const u=[];for(let p=0;p<s.length;p++){const C=s[p];if(typeof C=="string")u.push({title:C,handle:p,isCloseAffordance:!1});else if(typeof C=="object"){let{title:w,isCloseAffordance:o}=C;u.push({title:w,isCloseAffordance:!!o,handle:p})}else this._logService.warn("Invalid message item:",C)}return this._proxy.$showMessage(T,t,m,u).then(p=>{if(typeof p=="number")return s[p]})}};F=$e([ze(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(be[197],Ee([0,1,22,3,58,6,20,9,10,2,64,5,8,7,38,172,93]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class C{constructor(o,f,S,i,g){this._textDocumentsAndEditors=S,this._textDocuments=i,this._extensionStoragePaths=g,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=f.converter,f.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const r=a.notebookEditor?.notebookUri,v=a.cell.handle,c=this._documents.get(r)?.getCell(v);if(c)return c.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const f=this._editors.get(o);if(!f)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return f}getIdByEditor(o){for(const[f,S]of this._editors)if(S.apiEditor===o)return f}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,f){const S=this._documents.get(o);if(!S&&!f)throw new Error(`NO notebook document for '${o}'`);return S}_getProviderData(o){const f=this._notebookContentProviders.get(o);if(!f)throw new Error(`NO provider for '${o}'`);return f}registerNotebookContentProvider(o,f,S,i,g){if((0,P.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(f))throw new Error(`Notebook provider for '${f}' already registered`);this._notebookContentProviders.set(f,{extension:o,provider:S});let a;return S.onDidChangeNotebookContentOptions&&(a=S.onDidChangeNotebookContentOptions(()=>{const r=n.NotebookDocumentContentOptions.from(S.options);this._notebookProxy.$updateNotebookProviderOptions(f,r)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},f,n.NotebookDocumentContentOptions.from(i),C._convertNotebookRegistrationData(o,g)),new m.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(f),this._notebookProxy.$unregisterNotebookProvider(f)})}static _convertNotebookRegistrationData(o,f){if(!f)return;const S=f.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(f.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:f.displayName,filenamePattern:S,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,f,S){const i=C._notebookStatusBarItemProviderHandlePool++,g=typeof S.onDidChangeCellStatusBarItems=="function"?C._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,g,f);let a;return g!==void 0&&(a=S.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(g))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,g),a&&a.dispose()})}async createNotebookDocument(o){const f=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return T.URI.revive(f)}async openNotebookDocument(o){const f=this._documents.get(o);if(f)return f.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(o),i=this._documents.get(T.URI.revive(S));return(0,D.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(o,f){T.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let S;typeof f=="object"?S={position:n.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(n.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:S={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,S),g=i&&this._editors.get(i)?.apiEditor;if(g)return g;throw i?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,f,S,i){const g=this._notebookStatusBarItemProviders.get(o),a=T.URI.revive(f),r=this._documents.get(a);if(!r||!g)return;const v=r.getCellFromIndex(S);if(!v)return;const l=await g.provideCellStatusBarItems(v.apiCell,i);if(!l)return;const c=new A.DisposableStore,b=this._statusBarCache.add([c]),y=(Array.isArray(l)?l:[l]).map(R=>n.NotebookStatusBarItem.from(R,this._commandsConverter,c));return{cacheId:b,items:y}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,f,S,i,g){if((0,P.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,S),this._notebookProxy.$registerNotebookSerializer(a,{id:o.identifier,location:o.extensionLocation},f,n.NotebookDocumentContentOptions.from(i),C._convertNotebookRegistrationData(o,g)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(o,f,S){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const g=await i.deserializeNotebook(f.buffer,S);return new s.SerializableObjectWithBuffers(n.NotebookData.from(g))}async $notebookToData(o,f,S){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const g=await i.serializeNotebook(n.NotebookData.to(f.value),S);return d.VSBuffer.wrap(g)}async $openNotebook(o,f,S,i,g){const{provider:a}=this._getProviderData(o),r=await a.openNotebook(T.URI.revive(f),{backupId:S,untitledDocumentData:i?.buffer},g);return new s.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,f,S){const i=this.getNotebookDocument(T.URI.revive(f)),{provider:g}=this._getProviderData(o);return await g.saveNotebook(i.apiNotebook,S),!0}async $saveNotebookAs(o,f,S,i){const g=this.getNotebookDocument(T.URI.revive(f)),{provider:a}=this._getProviderData(o);return await a.saveNotebookAs(T.URI.revive(S),g.apiNotebook,i),!0}async $backupNotebook(o,f,S){const i=this.getNotebookDocument(T.URI.revive(f)),g=this._getProviderData(o),a=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension),r=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),v=T.URI.joinPath(a,r),l=await g.provider.backupNotebook(i.apiNotebook,{destination:v},S);return i.updateBackup(l),l.id}_createExtHostEditor(o,f,S){if(this._editors.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const i=new p.ExtHostNotebookEditor(f,this._notebookEditorsProxy,o,S.visibleRanges.map(n.NotebookRange.to),S.selections.map(n.NotebookRange.to),typeof S.viewColumn=="number"?n.ViewColumn.to(S.viewColumn):void 0);this._editors.set(f,i)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const S of o.value.removedDocuments){const i=T.URI.revive(S),g=this._documents.get(i);g&&(g.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(g.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===i.toString()&&this._editors.delete(a.id)}if(o.value.addedDocuments){const S=[];for(const i of o.value.addedDocuments){const g=T.URI.revive(i.uri);if(this._documents.has(g))throw new Error(`adding EXISTING notebook ${g} `);const a=this,r=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(v){a._onDidChangeNotebookCells.fire(v)},emitCellOutputsChange(v){a._onDidChangeCellOutputs.fire(v)},emitCellMetadataChange(v){a._onDidChangeCellMetadata.fire(v)},emitCellExecutionStateChange(v){a._onDidChangeCellExecutionState.fire(v)}},g,i);S.push(...i.cells.map(v=>u.ExtHostCell.asModelAddData(r.apiNotebook,v))),this._documents.get(g)?.dispose(),this._documents.set(g,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(o.value.addedEditors)for(const S of o.value.addedEditors){if(this._editors.has(S.id))return;const i=T.URI.revive(S.documentUri),g=this._documents.get(i);g&&this._createExtHostEditor(g,S.id,S)}const f=[];if(o.value.removedEditors)for(const S of o.value.removedEditors){const i=this._editors.get(S);i&&(this._editors.delete(S),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),f.push(i))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const S=new Set;this._visibleNotebookEditors.forEach(i=>S.add(i.id));for(const i of this._editors.values()){const g=S.has(i.id);i._acceptVisibility(g)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=C,C._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Ee([0,1,3,54,15,5,13,8]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(_,n){const m=D._Keys.nextId();_.$registerNotebookEditorDecorationType(m,P.NotebookDecorationRenderOptions.from(n)),this.value={key:m,dispose(){_.$removeNotebookEditorDecorationType(m)}}}}D._Keys=new M.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(_,n,m){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new D(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const m=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&m._acceptVisibleRanges(n.visibleRanges.ranges.map(P.NotebookRange.to)),n.selections&&m._acceptSelections(n.selections.selections.map(P.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(P.ViewColumn.to(_[n]))}};T=$e([ze(0,E.ILogService),ze(1,F.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(be[199],Ee([0,1,14,12,21,3,6,20,2,26,15,5,39,8,7,67,165,30,38]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(a,r,v,l,c){this._initData=r,this._extHostNotebook=v,this._commands=l,this._logService=c,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=a.getProxy(_.MainContext.MainThreadNotebookKernels);const b=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",h=>!0,h=>{if(h&&"notebookEditor"in h&&"id"in h){const y=this._extHostNotebook.getIdByEditor(h.notebookEditor);return{id:h.id,extension:h.extension,notebookEditorId:y}}else if(h&&"notebookEditor"in h){const y=this._extHostNotebook.getIdByEditor(h.notebookEditor);if(y===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${h.notebookEditor.document.uri.toString()}`);return{notebookEditorId:y}}return h})],n.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(a,r,v,l,c,b){for(let Y of this._kernelData.values())if(Y.controller.id===r&&T.ExtensionIdentifier.equals(a.identifier,Y.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const h=this._handlePool++,y=this;this._logService.trace(`NotebookController[${h}], CREATED by ${a.identifier.value}, ${r}`);const R=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${a.identifier}'`);let k=!1;const O=new F.DisposableStore,N=new A.Emitter,I=new A.Emitter,B={id:`${a.identifier.value}/${r}`,notebookType:v,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:l||a.identifier.value,preloads:b?b.map(m.NotebookRendererScript.from):[]};let x=c??R,V;this._proxy.$addKernel(h,B).catch(Y=>{console.log(Y),k=!0});let H=0;const W=()=>{if(k)return;const Y=++H;Promise.resolve().then(()=>{Y===H&&this._proxy.$updateKernel(h,B)})},ee=new P.ResourceMap,q={get id(){return r},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return B.label},set label(Y){B.label=Y??a.displayName??a.name,W()},get detail(){return B.detail??""},set detail(Y){B.detail=Y,W()},get description(){return B.description??""},set description(Y){B.description=Y,W()},get kind(){return(0,C.checkProposedApiEnabled)(a),B.kind??""},set kind(Y){(0,C.checkProposedApiEnabled)(a),B.kind=Y,W()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(Y){B.supportedLanguages=Y,W()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){B.supportsExecutionOrder=Y,W()},get rendererScripts(){return B.preloads?B.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(Y){x=Y??R},get interruptHandler(){return V},set interruptHandler(Y){V=Y,B.supportsInterrupt=Boolean(Y),W()},createNotebookCellExecution(Y){if(k)throw new Error("notebook controller is DISPOSED");if(!ee.has(Y.notebook.uri))throw y._logService.trace(`NotebookController[${h}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return y._createNotebookCellExecution(Y)},dispose:()=>{k||(this._logService.trace(`NotebookController[${h}], DISPOSED`),k=!0,this._kernelData.delete(h),O.dispose(),N.dispose(),I.dispose(),this._proxy.$removeKernel(h))},updateNotebookAffinity(Y,j){y._proxy.$updateNotebookPriority(h,Y.uri,j)},onDidReceiveMessage:I.event,postMessage(Y,j){return(0,C.checkProposedApiEnabled)(a),y._proxy.$postMessage(h,j&&y._extHostNotebook.getIdByEditor(j),Y)},asWebviewUri(Y){return(0,C.checkProposedApiEnabled)(a),(0,u.asWebviewUri)(Y,y._initData.remote)}};return this._kernelData.set(h,{extensionId:a.identifier,controller:q,onDidReceiveMessage:I,onDidChangeSelection:N,associatedNotebooks:ee}),q}$acceptNotebookAssociation(a,r,v){const l=this._kernelData.get(a);if(l){const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));v?l.associatedNotebooks.set(c.uri,!0):l.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${a}] ASSOCIATE notebook`,c.uri.toString(),v),l.onDidChangeSelection.fire({selected:v,notebook:c.apiNotebook})}}async $executeCells(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r)),b=[];for(let h of v){const y=c.getCell(h);y&&b.push(y.apiCell)}try{this._logService.trace(`NotebookController[${a}] EXECUTE cells`,c.uri.toString(),b.length),await l.controller.executeHandler.call(l.controller,b,c.apiNotebook,l.controller)}catch(h){this._logService.error(`NotebookController[${a}] execute cells FAILED`,h),console.error(h)}}async $cancelCells(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,c.apiNotebook);else for(let b of v){const h=c.getCell(b);h&&this._activeExecutions.get(h.uri)?.cancel()}}$acceptKernelMessageFromRenderer(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getEditorById(r);l.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:v}))}_createNotebookCellExecution(a){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this._extHostNotebook.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!v)throw new Error("invalid cell");if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const l=new S(v.notebook,v,this._proxy);this._activeExecutions.set(v.uri,l);const c=l.onDidChangeState(()=>{l.state===f.Resolved&&(l.dispose(),c.dispose(),this._activeExecutions.delete(v.uri))});return l.asApiObject()}};o=$e([ze(4,t.ILogService)],o),e.ExtHostNotebookKernels=o;var f;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(f||(f={}));class S extends F.Disposable{constructor(a,r,v){super();this._document=a,this._cell=r,this._proxy=v,this._handle=S.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new i(10,l=>this.update(l)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(a){await this._collector.addItem(a)}async update(a){const r=Array.isArray(a)?a:[a];return this._proxy.$updateExecutions(new w.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===f.Init)throw new Error("Must call start before modifying cell output");if(this._state===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(a){let r=this._cell;if(a&&(r=this._document.getCellFromApiCell(a)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(a){return a.map(r=>{const v=s.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return v===r.items?m.NotebookCellOutput.from(r):m.NotebookCellOutput.from({items:v,id:r.id,metadata:r.metadata})})}async updateOutputs(a,r,v){const l=this.cellIndexToHandle(r),c=this.validateAndConvertOutputs((0,d.asArray)(a));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:v,outputs:c})}async updateOutputItems(a,r,v){return a=s.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(a),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:a.map(m.NotebookCellOutputItem.from),outputId:r.id,append:v})}asApiObject(){const a=this;return Object.freeze({get token(){return a._tokenSource.token},get cell(){return a._cell.apiCell},get executionOrder(){return a._executionOrder},set executionOrder(v){a._executionOrder=v,a.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,executionOrder:a._executionOrder}])},start(v){if(a._state===f.Resolved||a._state===f.Started)throw new Error("Cannot call start again");a._state=f.Started,a._onDidChangeState.fire(),a.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,runStartTime:v})},end(v,l){if(a._state===f.Resolved)throw new Error("Cannot call resolve twice");a._state=f.Resolved,a._onDidChangeState.fire(),a.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:a._handle,runEndTime:l,lastRunSuccess:v}),a._collector.flush(),a._proxy.$removeExecution(a._handle)},clearOutput(v){return a.verifyStateForOutput(),a.updateOutputs([],v,!1)},appendOutput(v,l){return a.verifyStateForOutput(),a.updateOutputs(v,l,!0)},replaceOutput(v,l){return a.verifyStateForOutput(),a.updateOutputs(v,l,!1)},appendOutputItems(v,l){return a.verifyStateForOutput(),a.updateOutputItems(v,l,!0)},replaceOutputItems(v,l){return a.verifyStateForOutput(),a.updateOutputItems(v,l,!1)}})}}S.HANDLE=0;class i{constructor(a,r){this.delay=a,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(a){return this.batch.push(a),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const a=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>a.complete())}}}),define(be[200],Ee([0,1,3,5,93]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(P,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,D,T){const t=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(D)?.fire({editor:t.apiEditor,message:T})}createRendererMessaging(P,D){if(!P.contributes?.notebookRenderer?.some(n=>n.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const T=!!P.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,m,s)=>{const u=T?n:p=>{const C={};t.set(C,p.editor),n({editor:C,message:p.message})};return this.getOrCreateEmitterFor(D).event(u,m,s)},postMessage:(n,m)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,m]=[m,n]);const s=T?m:t.get(m),u=s&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(s);return this.proxy.$postMessage(u?.id,D,n)}}}getOrCreateEmitterFor(P){let D=this._rendererMessageEmitters.get(P);return D||(D=new d.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,D),D)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,6,22,4,13]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends E.Disposable{constructor(s,u,p,C,w){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=w,this._id=w.$register(this.name,u,p,C),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?A.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(u=>this._proxy.$clear(u,s))}show(s,u){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof s=="boolean"?s:u)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class T extends D{constructor(s,u,p){super(s,!1,void 0,u,p)}append(s){super.append(s),this._id.then(u=>this._proxy.$append(u,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class t extends D{constructor(s,u,p){super(s,!0,u,void 0,p)}append(s){throw new Error("Not supported")}}class _{constructor(s,u){this.name=s,this._channel=u}append(s){this._channel.then(u=>u.append(s))}appendLine(s){this._channel.then(u=>u.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,u){this._channel.then(p=>p.show(s,u))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=_;let n=class{constructor(s){this._proxy=s.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new T(s,u.identifier.value,this._proxy)}createOutputChannelFromLogFile(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new t(s,u,this._proxy)}};n=$e([ze(0,P.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(be[201],Ee([0,1,12,21,3,6,5,2,7,16,14,35,47]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(s,u,p){const C=s.getProxy(F.MainContext.MainThreadQuickOpen);class w{constructor(l,c){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=c}showQuickPick(l,c,b,h=M.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(l),R=++this._instances,k=C.$show(R,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},h),O={},N=k.then(()=>O);return Promise.race([N,y]).then(I=>{if(I!==O)return y.then(B=>{const x=[];for(let V=0;V<B.length;V++){const H=B[V];let W,ee,q,Y,j;typeof H=="string"?W=H:(W=H.label,ee=H.description,q=H.detail,Y=H.picked,j=H.alwaysShow),x.push({label:W,description:ee,handle:V,detail:q,picked:Y,alwaysShow:j})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{b.onDidSelectItem(B[V])}),C.$setItems(R,x),k.then(V=>{if(typeof V=="number")return B[V];if(Array.isArray(V))return V.map(H=>B[H])})})}).then(void 0,I=>{if(!(0,T.isPromiseCanceledError)(I))return C.$setError(R,I),Promise.reject(I)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,c=M.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,C.$input(l,typeof this._validateInput=="function",c).then(void 0,b=>{if(!(0,T.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(l){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,c=M.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!b)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(y=>y.uri.toString()===b.uri.toString())}createQuickPick(l,c){const b=new a(l,c,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(l){const c=new r(l,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(l,c){const b=this._sessions.get(l);b&&b._fireDidChangeValue(c)}$onDidAccept(l){const c=this._sessions.get(l);c&&c._fireDidAccept()}$onDidChangeActive(l,c){const b=this._sessions.get(l);b instanceof a&&b._fireDidChangeActive(c)}$onDidChangeSelection(l,c){const b=this._sessions.get(l);b instanceof a&&b._fireDidChangeSelection(c)}$onDidTriggerButton(l,c){const b=this._sessions.get(l);b&&b._fireDidTriggerButton(c)}$onDidTriggerItemButton(l,c,b){const h=this._sessions.get(l);h instanceof a&&h._fireDidTriggerItemButton(c,b)}$onDidHide(l){const c=this._sessions.get(l);c&&c._fireDidHide()}}class o{constructor(l,c){this._extensionId=l,this._onDidDispose=c,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((c,b)=>{const h=c===D.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(h,c)}),this.update({buttons:l.map((c,b)=>({...g(c),tooltip:c.tooltip,handle:c===D.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const c=this._handlesToButtons.get(l);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),C.$dispose(this._id))}update(l){if(!this._disposed){for(const c of Object.keys(l)){const b=l[c];this._pendingUpdate[c]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){C.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function f(v){if(v instanceof D.ThemeIcon)return{id:v.id};const l=i(v),c=S(v);return{dark:typeof l=="string"?P.URI.file(l):l,light:typeof c=="string"?P.URI.file(c):c}}function S(v){return typeof v=="object"&&"light"in v?v.light:v}function i(v){return typeof v=="object"&&"dark"in v?v.dark:v}function g(v){const l=f(v.iconPath);let c,b;return"id"in l?b=n.ThemeIcon.asClassName(l):c=l,{iconPath:c,iconClass:b}}class a extends o{constructor(l,c,b){super(l,b);this.enableProposedApi=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((c,b)=>{this._handlesToItems.set(b,c),this._itemsToHandles.set(c,b)}),this.update({items:l.map((c,b)=>({label:c.label,description:c.description,handle:b,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons&&this.enableProposedApi?c.buttons.map((h,y)=>({...g(h),tooltip:h.tooltip,handle:y})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(l){const c=(0,t.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(l){const c=(0,t.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(l,c){const b=this._handlesToItems.get(l);if(!b||!b.buttons||!b.buttons.length)return;const h=b.buttons[c];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:b})}}class r extends o{constructor(l,c){super(l,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?_.default.Error:_.default.Ignore})}}return new w(u,p)}e.createExtHostQuickOpen=m}),define(be[202],Ee([0,1,2,3,53,6,12,5,14,107,15,26,30,47,8]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(l){if(l)return typeof l.iconPath=="string"?d.URI.file(l.iconPath):d.URI.isUri(l.iconPath)||m.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function p(l,c){if(!l.iconPath&&!c.iconPath)return 0;if(l.iconPath){if(!c.iconPath)return 1}else return-1;const b=typeof l.iconPath=="string"?l.iconPath:d.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,h=typeof c.iconPath=="string"?c.iconPath:d.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,T.comparePaths)(b,h)}function C(l,c){let b=0;if(l.strikeThrough!==c.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==c.faded)return l.faded?1:-1;if(l.tooltip!==c.tooltip)return(l.tooltip||"").localeCompare(c.tooltip||"");if(b=p(l,c),b!==0)return b;if(l.light&&c.light)b=p(l.light,c.light);else{if(l.light)return 1;if(c.light)return-1}if(b!==0)return b;if(l.dark&&c.dark)b=p(l.dark,c.dark);else{if(l.dark)return 1;if(c.dark)return-1}return b}function w(l,c){if(l.command!==c.command)return l.command<c.command?-1:1;if(l.title!==c.title)return l.title<c.title?-1:1;if(l.tooltip!==c.tooltip){if(l.tooltip!==void 0&&c.tooltip!==void 0)return l.tooltip<c.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(l.arguments===c.arguments)return 0;if(l.arguments)if(c.arguments){if(l.arguments.length!==c.arguments.length)return l.arguments.length-c.arguments.length}else return 1;else return-1;for(let b=0;b<l.arguments.length;b++){const h=l.arguments[b],y=c.arguments[b];if(h!==y)return h<y?-1:1}return 0}function o(l,c){let b=(0,T.comparePaths)(l.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(b!==0)return b;if(l.command&&c.command)b=w(l.command,c.command);else{if(l.command)return 1;if(c.command)return-1}if(b!==0)return b;if(l.decorations&&c.decorations)b=C(l.decorations,c.decorations);else{if(l.decorations)return 1;if(c.decorations)return-1}return b}function f(l,c){for(let b=0;b<l.length;b++)if(l[b]!==c[b])return!1;return!0}function S(l,c){return l.command===c.command&&l.title===c.title&&l.tooltip===c.tooltip&&(l.arguments&&c.arguments?f(l.arguments,c.arguments):l.arguments===c.arguments)}function i(l,c){return(0,D.equals)(l,c,S)}class g{constructor(c,b,h){this._extension=c,this._proxy=b,this._sourceControlHandle=h,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,n.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,b){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,b)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=g;class a{constructor(c,b,h,y,R){this._proxy=c,this._commands=b,this._sourceControlHandle=h,this._id=y,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,b){const h=this._resourceStatesCommandsMap.get(c);return h?(0,F.asPromise)(()=>this._commands.executeCommand(h.command,...h.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(o),h=(0,D.sortedDiff)(this._resourceSnapshot,c,o).map(k=>{const O=k.toInsert.map(N=>{const I=this._resourceHandlePool++;this._resourceStatesMap.set(I,N);const B=N.resourceUri;let x;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const ve=new A.DisposableStore;x=this._commands.converter.toInternal(N.command,ve),this._resourceStatesDisposablesMap.set(I,ve)}else this._resourceStatesCommandsMap.set(I,N.command);const V=u(N.decorations),H=N.decorations&&u(N.decorations.light)||V,W=N.decorations&&u(N.decorations.dark)||V,ee=[H,W],q=N.decorations&&N.decorations.tooltip||"",Y=N.decorations&&!!N.decorations.strikeThrough,j=N.decorations&&!!N.decorations.faded,le=N.contextValue||"";return{rawResource:[I,B,ee,q,Y,j,le,x],handle:I}});return{start:k.start,deleteCount:k.deleteCount,toInsert:O}}),y=h.map(({start:k,deleteCount:O,toInsert:N})=>[k,O,N.map(I=>I.rawResource)]),R=h.reverse();for(const{start:k,deleteCount:O,toInsert:N}of R){const I=N.map(x=>x.handle),B=this._handlesSnapshot.splice(k,O,...I);for(const x of B)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),this._resourceStatesDisposablesMap.get(x)?.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=c,y}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class r{constructor(c,b,h,y,R,k){this._extension=c,this._proxy=b,this._commands=h,this._id=y,this._label=R,this._rootUri=k,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,y,R,k)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=c;const b=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(c){(0,n.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=c;const b=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&i(this._statusBarCommands,c))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=c;const b=(c||[]).map(h=>this._commands.converter.toInternal(h,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(c,b){const h=new a(this._proxy,this._commands,this.handle,c,b),y=M.Event.once(h.onDidDispose)(()=>this.createdResourceGroups.delete(h));return this.createdResourceGroups.set(h,y),this.eventuallyAddResourceGroups(),h}eventuallyAddResourceGroups(){const c=[],b=[];for(const[h,y]of this.createdResourceGroups){y.dispose();const R=h.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(h),this.eventuallyUpdateResourceStates()});M.Event.once(h.onDidDispose)(()=>{this.updatedResourceGroups.delete(h),R.dispose(),this._groups.delete(h.handle),this._proxy.$unregisterGroup(this.handle,h.handle)}),c.push([h.handle,h.id,h.label,h.features]);const k=h._takeResourceStateSnapshot();k.length>0&&b.push([h.handle,k]),this._groups.set(h.handle,h)}this._proxy.$registerGroups(this.handle,c,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(b=>{const h=b._takeResourceStateSnapshot();h.length!==0&&c.push([b.handle,h])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,$e([(0,E.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),$e([(0,E.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let v=class Ui{constructor(c,b,h){this._commands=b,this.logService=h,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=c.getProxy(P.MainContext.MainThreadSCM),this._telemetry=c.getProxy(P.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===3){const R=this._sourceControls.get(y.sourceControlHandle);if(!R)return y;const k=R.getResourceGroup(y.groupHandle);return k?k.getResourceState(y.handle):y}else if(y&&y.$mid===4){const R=this._sourceControls.get(y.sourceControlHandle);return R?R.getResourceGroup(y.groupHandle):y}else if(y&&y.$mid===5){const R=this._sourceControls.get(y.handle);return R||y}return y}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,b,h,y){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,b,h,y),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const R=Ui._handlePool++,k=new r(c,this._proxy,this._commands,b,h,y);this._sourceControls.set(R,k);const O=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(c.identifier))||[];return O.push(k),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(c.identifier),O),k}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const b=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(c.identifier)),h=b&&b[b.length-1];return h&&h.inputBox}$provideOriginalResource(c,b,h){const y=d.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,y.toString());const R=this._sourceControls.get(c);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(y,h)).then(k=>k||null)}$onInputBoxValueChange(c,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const h=this._sourceControls.get(c);return h&&h.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(c,b,h,y){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,b,h);const R=this._sourceControls.get(c);if(!R)return Promise.resolve(void 0);const k=R.getResourceGroup(b);return k?k.$executeResourceCommand(h,y):Promise.resolve(void 0)}$validateInput(c,b,h){this.logService.trace("ExtHostSCM#$validateInput",c);const y=this._sourceControls.get(c);return!y||!y.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>y.inputBox.validateInput(b,h)).then(R=>{if(!R)return Promise.resolve(void 0);const k=s.MarkdownString.fromStrict(R.message);return k?Promise.resolve([k,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};v._handlePool=0,v=$e([ze(2,t.ILogService)],v),e.ExtHostSCM=v});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[203],Ee([0,1,7,5,126,6,8,10]),function(oe,e,d,M,E,A,F,P){"use strict";var D,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(s,u,p,C,w=d.StatusBarAlignment.Left,o){D.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Ze(this,D,s,"f"),Ze(this,T,u,"f"),this._entryId=t.ID_GEN++,this._extension=p,this._id=C,this._alignment=w,this._priority=this.validatePriority(o)}validatePriority(s){if(!!(0,P.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!t.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:Re(this,T,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:Re(this,T,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Re(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let u;this._name?u=this._name:u=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const C=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Re(this,D,"f").$setEntry(this._entryId,s,u,this._text,C,this._command?.internal,p,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,D=new WeakMap,T=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const u={message:s};return this._messages.unshift(u),this._update(),new d.Disposable(()=>{const p=this._messages.indexOf(u);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(s,u){this._proxy=s.getProxy(M.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new _(this)}createStatusBarEntry(s,u,p,C){return new t(this._proxy,this._commands,s,u,p,C)}setStatusBarMessage(s,u){const p=this._statusMessage.setMessage(s);let C;return typeof u=="number"?C=setTimeout(()=>p.dispose(),u):typeof u!="undefined"&&u.then(()=>p.dispose(),()=>p.dispose()),new d.Disposable(()=>{p.dispose(),clearTimeout(C)})}}e.ExtHostStatusBar=n}),define(be[73],Ee([0,1,5,3,4]),function(oe,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,D){this._proxy.$registerExtensionStorageKeysToSync(P,D)}getValue(P,D,T){return this._proxy.$getValue(P,D).then(t=>t||T)}setValue(P,D,T){return this._proxy.$setValue(P,D,T)}$acceptValue(P,D,T){this._onDidChangeStorage.fire({shared:P,key:D,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(be[74],Ee([0,1,4,29,15,72,2]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let P=class{constructor(T,t,_){this._logService=t,this._extHostFileSystem=_,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(T){return F.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,t=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(T){if(this._value)return F.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return F.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=$e([ze(0,M.IExtHostInitDataService),ze(1,E.ILogService),ze(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(be[40],Ee([0,1,3,5,4,2,13,6,7,127,16,167,21,36,149,47,10,12]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class w{constructor(l,c,b,h){this._proxy=l,this._id=c,this._creationOptions=b,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(R,k=!0){y._checkDisposed(),y._proxy.$sendText(y._id,R,k)},show(R){y._checkDisposed(),y._proxy.$show(y._id,R)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(l,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,p.withNullAsUndefined)(l.shellPath),shellArgs:(0,p.withNullAsUndefined)(l.shellArgs),cwd:(0,p.withNullAsUndefined)(l.cwd),env:(0,p.withNullAsUndefined)(l.env),icon:(0,p.withNullAsUndefined)(a(l.iconPath)),color:u.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,p.withNullAsUndefined)(l.message),strictEnv:(0,p.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(l.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(l,c,b,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:u.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(l,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,c){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in l?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,c){return l===this._cols&&c===this._rows||l===0||c===0?!1:(this._cols=l,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=w;class o{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new d.Emitter,this._onProcessTitleChanged=new d.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new d.Emitter,this._onProcessShellTypeChanged=new d.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(l){return Promise.resolve("")}async updateProperty(l,c){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,c){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:c})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>this._onProcessOverrideDimensions.fire(c&&{cols:c.columns,rows:c.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>this._onProcessTitleChanged.fire(c)),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let f=1,S=class extends P.Disposable{constructor(l,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[b,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,c){const b=new w(this._proxy,(0,m.generateUuid)(),l,l.name),h=new o(l.pty);return b.createExtensionTerminal(l.location,this._serializeParentTerminal(l,c).resolvedExtHostIdentifier,a(l.iconPath),r(l.color)).then(y=>{const R=this._setupExtHostProcessListeners(y,h);this._terminalProcessDisposables[y]=R}),this._terminals.push(b),b.value}_serializeParentTerminal(l,c){if(c=c||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const b=l.location.parentTerminal;if(b){const h=this._terminals.find(y=>y.value===b);h&&(c.resolvedExtHostIdentifier=h._id)}}else l.location&&typeof l.location!="object"?c.location=l.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(l,c){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const h=new o(c),y=this._setupExtHostProcessListeners(l,h);this._terminalProcessDisposables[l]=y}async $acceptActiveTerminalChanged(l){const c=this._activeTerminal;if(l===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(l);b&&(this._activeTerminal=b,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,c){const b=this._getTerminalById(l);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:c})}async $acceptTerminalDimensions(l,c,b){const h=this._getTerminalById(l);h&&h.setDimensions(c,b)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(l,c,b){this._terminalProcesses.get(l)?.resize(c,b)}async $acceptTerminalTitleChange(l,c){const b=this._getTerminalById(l);b&&(b.name=c)}async $acceptTerminalClosed(l,c){const b=this._getTerminalObjectIndexById(this._terminals,l);if(b!==null){const h=this._terminals.splice(b,1)[0];h.setExitCode(c),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(l,c,b,h){if(c){const k=this._getTerminalObjectIndexById(this._terminals,c);if(k!==null){this._terminals[k]._id=l,this._onDidOpenTerminal.fire(this.terminals[k]),this._terminals[k].isOpen=!0;return}}const y={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:A.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},R=new w(this._proxy,l,y,b);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(l,c){const b=this._getTerminalById(l);b&&b._setProcessId(c)}async $startExtensionTerminal(l,c){const b=this._getTerminalById(l);if(!b)return{message:(0,T.localize)(0,null,l)};b.isOpen||await new Promise(y=>{const R=this.onDidOpenTerminal(async k=>{k===b.value&&(R.dispose(),y())})});const h=this._terminalProcesses.get(l);h?h.startSendingEvents(c):this._extensionTerminalAwaitingStart[l]={initialDimensions:c}}_setupExtHostProcessListeners(l,c){const b=new P.DisposableStore;b.add(c.onProcessReady(y=>this._proxy.$sendProcessReady(l,y.pid,y.cwd))),b.add(c.onProcessTitleChanged(y=>this._proxy.$sendProcessTitle(l,y))),this._bufferer.startBuffering(l,c.onProcessData),b.add(c.onProcessExit(y=>this._onProcessExit(l,y))),c.onProcessOverrideDimensions&&b.add(c.onProcessOverrideDimensions(y=>this._proxy.$sendOverrideDimensions(l,y))),this._terminalProcesses.set(l,c);const h=this._extensionTerminalAwaitingStart[l];return h&&c instanceof o&&(c.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),b}$acceptProcessAckDataEvent(l,c){this._terminalProcesses.get(l)?.acknowledgeDataEvent(c)}$acceptProcessInput(l,c){this._terminalProcesses.get(l)?.input(c)}$acceptTerminalInteraction(l){const c=this._getTerminalById(l);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(l,c,b){try{this._terminalProcesses.get(l)?.resize(c,b)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(l,c){this._terminalProcesses.get(l)?.shutdown(c)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(c=>this._proxy.$sendProcessInitialCwd(l,c))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(c=>this._proxy.$sendProcessCwd(l,c))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,c,b){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,b),this._proxy.$registerProfileProvider(c,l.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(l,c){const b=new n.CancellationTokenSource().token,h=await this._profileProviders.get(l)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,c);return}this.createTerminalFromOptions(h.options,c)}}async $provideLinks(l,c){const b=this._getTerminalById(l);if(!b)return[];this._terminalLinkCache.delete(l);const h=this._terminalLinkCancellationSource.get(l);h&&h.dispose(!0);const y=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,y);const R=[],k={terminal:b.value,line:c},O=[];for(const B of this._linkProviders)O.push(C.Promises.withAsyncBody(async x=>{y.token.onCancellationRequested(()=>x({provider:B,links:[]}));const V=await B.provideTerminalLinks(k,y.token)||[];y.token.isCancellationRequested||x({provider:B,links:V})}));const N=await Promise.all(O);if(y.token.isCancellationRequested)return[];const I=new Map;for(const B of N)B&&B.links.length>0&&R.push(...B.links.map(x=>{const V={id:f++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return I.set(V.id,{provider:B.provider,link:x}),V}));return this._terminalLinkCache.set(l,I),R}$activateLink(l,c){const b=this._terminalLinkCache.get(l)?.get(c);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(l,c){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const b=this._terminalProcessDisposables[l];b&&(b.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,c)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,c){const b=this._getTerminalObjectIndexById(l,c);return b!==null?l[b]:null}_getTerminalObjectIndexById(l,c){let b=null;return l.some((h,y)=>h._id===c?(b=y,!0):!1),b}getEnvironmentVariableCollection(l){let c=this._environmentVariableCollections.get(l.identifier.value);return c||(c=new i,this._setEnvironmentVariableCollection(l.identifier.value,c)),c}_syncEnvironmentVariableCollection(l,c){const b=(0,_.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(l,c.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(l){l.forEach(c=>{const b=c[0],h=new i(c[1]);this._setEnvironmentVariableCollection(b,h)})}$acceptDefaultProfile(l,c){this._defaultProfile=l,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(l,c){this._environmentVariableCollections.set(l,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,c)})}};S=$e([ze(1,F.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class i{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,c){this._setIfDiffers(l,{value:c,type:D.EnvironmentVariableMutatorType.Replace})}append(l,c){this._setIfDiffers(l,{value:c,type:D.EnvironmentVariableMutatorType.Append})}prepend(l,c){this._setIfDiffers(l,{value:c,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,c){const b=this.map.get(l);(!b||b.value!==c.value||b.type!==c.type)&&(this.map.set(l,c),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,c){this.map.forEach((b,h)=>l.call(c,h,b,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let g=class extends S{constructor(l){super(!1,l)}createTerminal(l,c,b){throw new t.NotSupportedError}createTerminalFromOptions(l,c){throw new t.NotSupportedError}};g=$e([ze(0,F.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function a(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function r(v){return u.ThemeColor.isThemeColor(v)?v:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[204],Ee([0,1,14,22,21,3,234,58,6,23,10,36,5,13,49,8,7,175,90,68]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w,o){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let S=class{constructor(k,O){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(n.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new g(this.proxy),O.registerArgumentProcessor({processArgument:N=>N?.$mid===13?u.TestItem.toItemFromContext(N):N})}createTestController(k,O){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const N=new D.DisposableStore,I=N.add(new C.SingleUseTestCollection(k));I.root.label=O;const B=new Map,x=this.proxy,V={items:I.root.children,get label(){return O},set label(W){O=W,I.root.label=W,x.$updateControllerLabel(k,O)},get id(){return k},createRunProfile:(W,ee,q,Y,j)=>{let le=(0,P.hash)(W);for(;B.has(le);)le++;const re=new h(this.proxy,k,le,W,ee,q,Y,j);return B.set(le,re),re},createTestItem(W,ee,q){return new s.TestItemImpl(k,W,ee,q)},createTestRun:(W,ee,q=!0)=>this.runTracker.createTestRun(k,I,W,ee,q),set resolveHandler(W){I.resolveHandler=W},get resolveHandler(){return I.resolveHandler},dispose:()=>{N.dispose()}};V.createRunConfiguration=V.createRunProfile,x.$registerTestController(k,O),N.add((0,D.toDisposable)(()=>x.$unregisterTestController(k)));const H={controller:V,collection:I,profiles:B};return this.controllers.set(k,H),N.add((0,D.toDisposable)(()=>this.controllers.delete(k))),N.add(I.onDidGenerateDiff(W=>x.$publishDiff(k,W))),V}createTestObserver(){return this.observer.checkout()}async runTests(k,O=E.CancellationToken.None){const N=a(k);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const I=this.controllers.get(N.controllerId);if(!I)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:k.include?.map(B=>B.id)??[I.collection.root.id],profileGroup:y[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:k.exclude?.map(B=>B.id)},O)}$provideFileCoverage(k,O,N){return(0,d.mapFind)(this.runTracker.trackers,B=>B.id===k?B.getCoverage(O):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(k,O,N,I){return(0,d.mapFind)(this.runTracker.trackers,x=>x.id===k?x.getCoverage(O):void 0)?.resolveFileCoverage(N,I)??Promise.resolve([])}$configureRunProfile(k,O){this.controllers.get(k)?.profiles.get(O)?.configureHandler?.()}$publishTestResults(k){this.results=Object.freeze(k.map(O=>(0,T.deepFreeze)(u.TestResults.to(O))).concat(this.results).sort((O,N)=>N.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,O){const N=this.controllers.get(o.TestId.fromString(k).controllerId)?.collection;N&&(await N.expand(k,O<0?Infinity:O),N.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k)}async $runControllerTests(k,O){const N=this.controllers.get(k.controllerId);if(!N)return;const{collection:I,profiles:B}=N,x=B.get(k.profileId);if(!x)return;const V=k.testIds.map(q=>I.tree.get(q)).filter(t.isDefined),H=k.excludeExtIds.map(q=>N.collection.tree.get(q)).filter(t.isDefined).filter(q=>V.some(Y=>Y.fullId.compare(q.fullId)===2));if(!V.length)return;const W=new p.TestRunRequest(V.some(q=>q.actual instanceof s.TestItemRootImpl)?void 0:V.map(q=>q.actual),H.map(q=>q.actual),x),ee=this.runTracker.prepareForMainThreadTestRun(W,r.fromInternal(k,N.collection),O);try{await x.runHandler(W,O)}finally{ee.isRunning&&!O.isCancellationRequested&&await A.Event.toPromise(ee.onEnd),ee.dispose()}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};S=$e([ze(0,m.IExtHostRpcService)],S),e.ExtHostTesting=S;class i extends D.Disposable{constructor(k,O,N){super();this.dto=k,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:I}of this.tasks.values())I.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(k){return this.tasks.get(k)?.coverage}createRun(k){const O=this.dto.id,N=this.dto.controllerId,I=(0,_.generateUuid)(),B=new v(this.proxy,O,I),x=ee=>(q,...Y)=>{if(H){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(q)||(this.ensureTestIsKnown(q),ee(q,...Y))},V=(ee,q)=>{const Y=q instanceof Array?q.map(u.TestMessage.from):[u.TestMessage.from(q)];if(ee.uri&&ee.range){const j={range:u.Range.from(ee.range),uri:ee.uri};for(const le of Y)le.location=le.location||j}this.proxy.$appendTestMessagesInRun(O,I,o.TestId.fromExtHostTestItem(ee,N).toString(),Y)};let H=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,get coverageProvider(){return B.coverageProvider},set coverageProvider(ee){B.coverageProvider=ee},enqueued:x(ee=>{this.proxy.$updateTestStateInRun(O,I,o.TestId.fromExtHostTestItem(ee,N).toString(),1)}),skipped:x(ee=>{this.proxy.$updateTestStateInRun(O,I,o.TestId.fromExtHostTestItem(ee,N).toString(),5)}),started:x(ee=>{this.proxy.$updateTestStateInRun(O,I,o.TestId.fromExtHostTestItem(ee,N).toString(),2)}),errored:x((ee,q,Y)=>{V(ee,q),this.proxy.$updateTestStateInRun(O,I,o.TestId.fromExtHostTestItem(ee,N).toString(),6,Y)}),failed:x((ee,q,Y)=>{V(ee,q),this.proxy.$updateTestStateInRun(O,I,o.TestId.fromExtHostTestItem(ee,N).toString(),4,Y)}),passed:x((ee,q)=>{this.proxy.$updateTestStateInRun(O,I,o.TestId.fromExtHostTestItem(ee,this.dto.controllerId).toString(),3,q)}),appendOutput:(ee,q,Y)=>{H||(Y&&(this.dto.isIncluded(Y)?this.ensureTestIsKnown(Y):Y=void 0),this.proxy.$appendOutputToRun(O,I,M.VSBuffer.fromString(ee),q&&u.location.from(q),Y&&o.TestId.fromExtHostTestItem(Y,N).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(O,I),this.tasks.delete(I),this.isRunning||this.dispose())}};return this.tasks.set(I,{run:W,coverage:B}),this.proxy.$startedTestRunTask(O,{id:I,name:k,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(k){if(!(k instanceof s.TestItemImpl))throw new s.InvalidTestItemError(k.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const O=[],N=this.dto.colllection.root;for(;;){const I=u.TestItem.from(k);if(O.unshift(I),this.sharedTestIds.has(I.extId)||(this.sharedTestIds.add(I.extId),k===N))break;k=k.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class g{constructor(k){this.proxy=k,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(k,O,N){return this.getTracker(k,O,N)}cancelRunById(k){for(const O of this.tracked.values())if(O.id===k){O.dispose();return}}cancelAllRuns(){for(const k of this.tracked.values())k.dispose()}createTestRun(k,O,N,I,B){const x=this.tracked.get(N);if(x)return x.createRun(I);const V=r.fromPublic(k,O,N,B),H=a(N);this.proxy.$startedExtensionTestRun({controllerId:k,profile:H&&{group:y[H.kind],id:H.profileId},exclude:N.exclude?.map(ee=>ee.id)??[],id:V.id,include:N.include?.map(ee=>ee.id)??[O.root.id],persist:B});const W=this.getTracker(N,V);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),W.createRun(I)}getTracker(k,O,N){const I=new i(O,this.proxy,N);return this.tracked.set(k,I),I.onEnd(()=>this.tracked.delete(k)),I}}e.TestRunCoordinator=g;const a=R=>{if(!!R.profile){if(!(R.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class r{constructor(k,O,N,I,B,x){this.controllerId=k,this.id=O,this.isPersisted=B,this.colllection=x,this.includePrefix=N.map(V=>V+"\0"),this.excludePrefix=I.map(V=>V+"\0")}static fromPublic(k,O,N,I){return new r(k,(0,_.generateUuid)(),N.include?.map(B=>o.TestId.fromExtHostTestItem(B,k).toString())??[k],N.exclude?.map(B=>o.TestId.fromExtHostTestItem(B,k).toString())??[],I,O)}static fromInternal(k,O){return new r(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,O)}isIncluded(k){const O=o.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(O===N||O.startsWith(N))return!1;for(const N of this.includePrefix)if(O===N||O.startsWith(N))return!0;return!1}}e.TestRunDto=r;class v{constructor(k,O,N){this.proxy=k,this.runId=O,this.taskId=N}set coverageProvider(k){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!k||(this._coverageProvider=k,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(k){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(k))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(k,O){const N=await this.fileCoverage;let I=N?.[k];return!this._coverageProvider||!N||!I?[]:(I.detailedCoverage||(I=N[k]=await this._coverageProvider.resolveFileCoverage?.(I,O)??I),I.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class l extends w.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,u.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:O,removed:N}=this;return{get added(){return[...k].map(I=>I.revived)},get updated(){return[...O].map(I=>I.revived)},get removed(){return[...N].map(I=>I.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,O){return{...k,revived:u.TestItem.toPlain(k.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=c;class b{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(O=>O.revived)},dispose:(0,F.once)(()=>{--k.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}class h{constructor(k,O,N,I,B,x,V=!1,H=void 0){this.controllerId=O,this.profileId=N,this._label=I,this.kind=B,this.runHandler=x,this._isDefault=V,this._tag=H,f.set(this,void 0),Ze(this,f,k,"f");const W=y[B];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${B}`);Re(this,f,"f").$publishTestRunProfile({profileId:N,controllerId:O,tag:H?u.TestTag.namespace(this.controllerId,H.id):null,label:I,group:W,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(k){k!==this._label&&(this._label=k,Re(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:k}))}get isDefault(){return this._isDefault}set isDefault(k){k!==this._isDefault&&(this._isDefault=k,Re(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,Re(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:k?u.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,Re(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!k}))}dispose(){Re(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=h,f=new WeakMap;const y={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(be[205],Ee([0,1,3,14,5,94,8,7]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(t,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const _=this._extHostDocumentsAndEditors.allEditors();return t?_:_.map(n=>n.value)}async showTextDocument(t,_,n){let m;typeof _=="number"?m={position:F.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?m={position:F.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?F.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:m={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(t.uri,m),u=s&&this._extHostDocumentsAndEditors.getEditor(s);if(u)return u.value;throw s?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,_){return new A.TextEditorDecorationType(this._proxy,t,_).value}$acceptEditorPropertiesChanged(t,_){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const m=_.selections.selections.map(F.Selection.to);n._acceptSelections(m)}if(_.visibleRanges){const m=M.coalesce(_.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(m)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:F.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const m=P.TextEditorSelectionChangeKind.fromValue(_.selections.source),s=_.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:m})}if(_.visibleRanges){const m=M.coalesce(_.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:m})}}$acceptEditorPositionData(t){for(const _ in t){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const m=F.ViewColumn.to(t[_]);n.value.viewColumn!==m&&(n._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:m}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=D}),define(be[206],Ee([0,1,2,4,5,6,7]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class P{constructor(t,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const m=n.uri===void 0?void 0:d.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(D(m))?.get(n.handle)}return n}})}async $getTimeline(t,_,n,m,s){return this._providers.get(t)?.provideTimeline(d.URI.revive(_),n,m,s)}registerTimelineProvider(t,_,n,m){const s=new A.DisposableStore,u=this.convertTimelineItem(_.id,m,s).bind(this);let p;_.onDidChange&&(p=_.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:_.id}),this));const C=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:t,onDidChange:void 0,async provideTimeline(w,o,f,S){S?.resetCache&&(s.clear(),C.get(_.id)?.clear());const i=await _.provideTimeline(w,o,f);if(i==null)return;const g=u(w,S);return{...i,source:_.id,items:i.items.map(g)}},dispose(){for(const w of C.values())w.get(_.id)?.clear();p?.dispose(),s.dispose()}})}convertTimelineItem(t,_,n){return(m,s)=>{let u;if(s?.cacheResults){let p=this._itemsBySourceAndUriMap.get(t);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(t,p));const C=D(m);u=p.get(C),u===void 0&&(u=new Map,p.set(C,u))}return p=>{const{iconPath:C,...w}=p,o=`${t}|${p.id??p.timestamp}`;u?.set(o,p);let f,S,i;return p.iconPath&&(C instanceof F.ThemeIcon?i={id:C.id,color:C.color}:d.URI.isUri(C)?(f=C,S=C):{light:f,dark:S}=C),{...w,id:w.id??void 0,handle:o,source:t,command:p.command?_.toInternal(p.command,n):void 0,icon:f,iconDark:S,themeIcon:i,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=P;function D(T){return T?.toString()}}),define(be[207],Ee([0,1,6,11,2,5]),function(oe,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,T,t,_){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const n=_.schemes.find(m=>!F.supportedSchemes.has(m));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,t),this._proxy.$registerUriOpener(T,_.schemes,D,_.label),(0,d.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(D,T,t){const _=this._openers.get(D);if(!_)throw new Error(`Unknown opener with id: ${D}`);const n=E.URI.revive(T);return _.canOpenExternalUri(n,t)}async $openUri(D,T,t){const _=this._openers.get(D);if(!_)throw new Error(`Unknown opener id: '${D}'`);return _.openExternalUri(E.URI.revive(T.resolvedUri),{sourceUri:E.URI.revive(T.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[208],Ee([0,1,5,2,6,16,26]),function(oe,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(T,t){if(this.handles.has(F.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const _=P.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(T)),this.handlers.set(_,t),this._proxy.$registerUriHandler(_,T),(0,E.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(T)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(T,t){const _=this.handlers.get(T);if(!_)return Promise.resolve(void 0);try{_.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(T){return M.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=P,P.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[51],Ee([0,1,3,11,2,137,157,67,5]),function(oe,e,d,M,E,A,F,P,D){"use strict";var T,t,_,n,m,s,u,p,C,w,o,f;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class S{constructor(b,h,y,R,k,O,N){T.set(this,void 0),t.set(this,void 0),_.set(this,void 0),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,""),p.set(this,void 0),C.set(this,!1),w.set(this,!1),o.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,f.set(this,new d.Emitter),this._onDidDispose=Re(this,f,"f").event,Ze(this,T,b,"f"),Ze(this,t,h,"f"),Ze(this,p,y,"f"),Ze(this,n,R,"f"),Ze(this,m,k,"f"),Ze(this,s,O,"f"),Ze(this,o,i(O),"f"),Ze(this,_,N,"f")}dispose(){Ze(this,C,!0,"f"),Re(this,f,"f").fire(),Re(this,f,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Ze(this,w,!0,"f"),(0,P.asWebviewUri)(b,Re(this,n,"f").remote)}get cspSource(){const b=Re(this,s,"f").extensionLocation;if(b.scheme===M.Schemas.https||b.scheme===M.Schemas.http){let h=b.toString();return h.endsWith("/")||(h+="/"),h+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Re(this,u,"f")}set html(b){this.assertNotDisposed(),Re(this,u,"f")!==b&&(Ze(this,u,b,"f"),!Re(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Ze(this,w,!0,"f"),Re(this,_,"f").report("Webview vscode-resource: uris",Re(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,t,"f").$setHtml(Re(this,T,"f"),b))}get options(){return this.assertNotDisposed(),Re(this,p,"f")}set options(b){this.assertNotDisposed(),Re(this,t,"f").$setOptions(Re(this,T,"f"),r(Re(this,s,"f"),Re(this,m,"f"),b)),Ze(this,p,b,"f")}async postMessage(b){if(Re(this,C,"f"))return!1;const h=(0,F.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Re(this,o,"f")});return Re(this,t,"f").$postMessage(Re(this,T,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Re(this,C,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=S,T=new WeakMap,t=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap,C=new WeakMap,w=new WeakMap,o=new WeakMap,f=new WeakMap;function i(c){try{const b=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;class g{constructor(b,h,y,R,k){this.initData=h,this.workspace=y,this._logService=R,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=b.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(b,h,...y){const R=this.getWebview(b);if(R){const{message:k}=(0,F.deserializeWebviewMessage)(h,y);R._onMessageEmitter.fire(k)}}$onMissingCsp(b,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,h,y){const R=new S(b,this._webviewProxy,v(h),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(b,R),R._onDidDispose(()=>{this._webviews.delete(b)}),R}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=g;function a(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=a;function r(c,b,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||l(c,b)}}e.serializeWebviewOptions=r;function v(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(b=>E.URI.from(b))}}e.reviveOptions=v;function l(c,b){return[...(b?.getWorkspaceFolders()||[]).map(h=>h.uri),c.extensionLocation]}}),define(be[209],Ee([0,1,21,58,6,11,24,2,8,51,64,5,7]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(i,g){this.document=i,this._storagePath=g,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,g){await this.getEdit(i).undo(),g||this.disposeBackup()}async redo(i,g){await this.getEdit(i).redo(),g||this.disposeBackup()}disposeEdits(i){for(const g of i)this._edits.delete(g)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=f(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const g=this._edits.get(i,0);if(!g)throw new Error("No edit found");return g}}class s{constructor(){this._documents=new Map}get(i,g){return this._documents.get(this.key(i,g))}add(i,g,a){const r=this.key(i,g.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${i} resource:${g.uri}`);const v=new m(g,a);return this._documents.set(r,v),v}delete(i,g){const a=this.key(i,g.uri);this._documents.delete(a)}key(i,g){return`${i}@@@${g}`}}var u;(function(S){S[S.Text=0]="Text",S[S.Custom=1]="Custom"})(u||(u={}));class p{constructor(){this._providers=new Map}addTextProvider(i,g,a){return this.add(0,i,g,a)}addCustomProvider(i,g,a){return this.add(1,i,g,a)}get(i){return this._providers.get(i)}add(i,g,a,r){if(this._providers.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this._providers.set(g,{type:i,extension:a,provider:r}),new n.Disposable(()=>this._providers.delete(g))}}class C{constructor(i,g,a,r,v){this._extHostDocuments=g,this._extensionStoragePaths=a,this._extHostWebview=r,this._extHostWebviewPanels=v,this._editorProviders=new p,this._documents=new s,this._proxy=i.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,g,a,r){const v=new E.DisposableStore;return w(a)?(v.add(this._editorProviders.addTextProvider(g,i,a)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(i),g,r.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(i))):(v.add(this._editorProviders.addCustomProvider(g,i,a)),this.supportEditing(a)&&v.add(a.onDidChangeCustomDocument(l=>{const c=this.getCustomDocumentEntry(g,l.document.uri);if(o(l)){const b=c.addEdit(l);this._proxy.$onDidEdit(l.document.uri,g,b,l.label)}else this._proxy.$onContentChange(l.document.uri,g)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(i),g,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(v,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(g)}))}async $createCustomDocument(i,g,a,r,v){const l=this._editorProviders.get(g);if(!l)throw new Error(`No provider found for '${g}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${g}'`);const c=P.URI.revive(i),b=await l.provider.openCustomDocument(c,{backupId:a,untitledDocumentData:r?.buffer},v);let h;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(g,b,h),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(i,g){const a=this._editorProviders.get(g);if(!a)throw new Error(`No provider found for '${g}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${g}'`);const r=P.URI.revive(i),{document:v}=this.getCustomDocumentEntry(g,r);this._documents.delete(g,v),v.dispose()}async $resolveWebviewEditor(i,g,a,r,v,l){const c=this._editorProviders.get(a);if(!c)throw new Error(`No provider found for '${a}'`);const b=D.ViewColumn.to(v),h=this._extHostWebview.createNewWebview(g,r.webviewOptions,c.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(g,a,r.title,b,r.panelOptions,h),R=P.URI.revive(i);switch(c.type){case 1:{const{document:k}=this.getCustomDocumentEntry(a,R);return c.provider.resolveCustomEditor(k,y,l)}case 0:{const k=this._extHostDocuments.getDocument(R);return c.provider.resolveCustomTextEditor(k,y,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,g,a){this.getCustomDocumentEntry(g,i).disposeEdits(a)}async $onMoveCustomEditor(i,g,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const v=this._extHostWebviewPanels.getWebviewPanel(i);if(!v)throw new Error("No webview found");const l=P.URI.revive(g),c=this._extHostDocuments.getDocument(l);await r.provider.moveCustomTextEditor(c,v,d.CancellationToken.None)}async $undo(i,g,a,r){return this.getCustomDocumentEntry(g,i).undo(a,r)}async $redo(i,g,a,r){return this.getCustomDocumentEntry(g,i).redo(a,r)}async $revert(i,g,a){const r=this.getCustomDocumentEntry(g,i);await this.getCustomEditorProvider(g).revertCustomDocument(r.document,a),r.disposeBackup()}async $onSave(i,g,a){const r=this.getCustomDocumentEntry(g,i);await this.getCustomEditorProvider(g).saveCustomDocument(r.document,a),r.disposeBackup()}async $onSaveAs(i,g,a,r){const v=this.getCustomDocumentEntry(g,i);return this.getCustomEditorProvider(g).saveCustomDocumentAs(v.document,P.URI.revive(a),r)}async $backup(i,g,a){const r=this.getCustomDocumentEntry(g,i),l=await this.getCustomEditorProvider(g).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},a);return r.updateBackup(l),l.id}getCustomDocumentEntry(i,g){const a=this._documents.get(i,P.URI.revive(g));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(i){const a=this._editorProviders.get(i)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=C;function w(S){return typeof S.resolveCustomTextEditor=="function"}function o(S){return typeof S.undo=="function"&&typeof S.redo=="function"}function f(S){const i=S.scheme===A.Schemas.file||S.scheme===A.Schemas.untitled?S.fsPath:S.toString();return(0,M.hash)(i)+""}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[210],Ee([0,1,3,6,2,36,8,51,5,7]),function(oe,e,d,M,E,A,F,P,D,T){"use strict";var t,_,n,m,s,u,p,C,w,o,f,S,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class g extends M.Disposable{constructor(l,c,b,h,y,R,k){super();t.set(this,void 0),_.set(this,void 0),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,void 0),p.set(this,void 0),C.set(this,void 0),w.set(this,!0),o.set(this,!0),f.set(this,!1),S.set(this,this._register(new d.Emitter)),this.onDidDispose=Re(this,S,"f").event,i.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Re(this,i,"f").event,Ze(this,t,l,"f"),Ze(this,_,c,"f"),Ze(this,n,b,"f"),Ze(this,s,R,"f"),Ze(this,C,y,"f"),Ze(this,u,h,"f"),Ze(this,m,k,"f")}dispose(){Re(this,f,"f")||(Ze(this,f,!0,"f"),Re(this,S,"f").fire(),Re(this,_,"f").$disposeWebview(Re(this,t,"f")),Re(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Re(this,m,"f")}get viewType(){return this.assertNotDisposed(),Re(this,n,"f")}get title(){return this.assertNotDisposed(),Re(this,u,"f")}set title(l){this.assertNotDisposed(),Re(this,u,"f")!==l&&(Ze(this,u,l,"f"),Re(this,_,"f").$setTitle(Re(this,t,"f"),l))}get iconPath(){return this.assertNotDisposed(),Re(this,p,"f")}set iconPath(l){this.assertNotDisposed(),Re(this,p,"f")!==l&&(Ze(this,p,l,"f"),Re(this,_,"f").$setIconPath(Re(this,t,"f"),E.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Re(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Re(this,C,"f")=="number"&&Re(this,C,"f")<0))return Re(this,C,"f")}get active(){return this.assertNotDisposed(),Re(this,o,"f")}get visible(){return this.assertNotDisposed(),Re(this,w,"f")}_updateViewState(l){Re(this,f,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(Ze(this,o,l.active,"f"),Ze(this,w,l.visible,"f"),Ze(this,C,l.viewColumn,"f"),Re(this,i,"f").fire({webviewPanel:this}))}reveal(l,c){this.assertNotDisposed(),Re(this,_,"f").$reveal(Re(this,t,"f"),{viewColumn:l?F.ViewColumn.from(l):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Re(this,f,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap,C=new WeakMap,w=new WeakMap,o=new WeakMap,f=new WeakMap,S=new WeakMap,i=new WeakMap;class a{constructor(l,c,b){this.webviews=c,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(l,c,b,h,y={}){const R=typeof h=="object"?h.viewColumn:h,k={viewColumn:F.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},O=(0,P.shouldSerializeBuffersForPostMessage)(l),N=a.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(l),N,c,{title:b,panelOptions:r(y),webviewOptions:(0,P.serializeWebviewOptions)(l,this.workspace,y),serializeBuffersForPostMessage:O},k);const I=this.webviews.createNewWebview(N,y,l);return this.createNewWebviewPanel(N,c,b,R,y,I)}$onDidChangeWebviewPanelViewStates(l){const c=Object.keys(l);c.sort((b,h)=>{const y=l[b],R=l[h];return y.active?1:R.active?-1:+y.visible-+R.visible});for(const b of c){const h=this.getWebviewPanel(b);if(!h)continue;const y=l[b];h._updateViewState({active:y.active,visible:y.visible,viewColumn:F.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,c,b){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:b,extension:l}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(l)}),new T.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(l,c,b,h){const y=this._serializers.get(c);if(!y)throw new Error(`No serializer found for '${c}'`);const{serializer:R,extension:k}=y,O=this.webviews.createNewWebview(l,b.webviewOptions,k),N=this.createNewWebviewPanel(l,c,b.title,h,b.panelOptions,O);await R.deserializeWebviewPanel(N,b.state)}createNewWebviewPanel(l,c,b,h,y,R){const k=new g(l,this._proxy,c,b,h,y,R);return this._webviewPanels.set(l,k),k}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=a;function r(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[211],Ee([0,1,3,6,51,5,7]),function(oe,e,d,M,E,A,F){"use strict";var P,D,T,t,_,n,m,s,u,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class C extends M.Disposable{constructor(f,S,i,g,a,r){super();P.set(this,void 0),D.set(this,void 0),T.set(this,void 0),t.set(this,void 0),_.set(this,!1),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Re(this,u,"f").event,p.set(this,this._register(new d.Emitter)),this.onDidDispose=Re(this,p,"f").event,Ze(this,T,i,"f"),Ze(this,m,g,"f"),Ze(this,P,f,"f"),Ze(this,D,S,"f"),Ze(this,t,a,"f"),Ze(this,n,r,"f")}dispose(){Re(this,_,"f")||(Ze(this,_,!0,"f"),Re(this,p,"f").fire(),Re(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Re(this,m,"f")}set title(f){this.assertNotDisposed(),Re(this,m,"f")!==f&&(Ze(this,m,f,"f"),Re(this,D,"f").$setWebviewViewTitle(Re(this,P,"f"),f))}get description(){return this.assertNotDisposed(),Re(this,s,"f")}set description(f){this.assertNotDisposed(),Re(this,s,"f")!==f&&(Ze(this,s,f,"f"),Re(this,D,"f").$setWebviewViewDescription(Re(this,P,"f"),f))}get visible(){return Re(this,n,"f")}get webview(){return Re(this,t,"f")}get viewType(){return Re(this,T,"f")}_setVisible(f){f===Re(this,n,"f")||Re(this,_,"f")||(Ze(this,n,f,"f"),Re(this,u,"f").fire())}show(f){this.assertNotDisposed(),Re(this,D,"f").$show(Re(this,P,"f"),!!f)}assertNotDisposed(){if(Re(this,_,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,D=new WeakMap,T=new WeakMap,t=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap;class w{constructor(f,S){this._extHostWebview=S,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,S,i,g){if(this._viewProviders.has(S))throw new Error(`View provider for '${S}' already registered`);return this._viewProviders.set(S,{provider:i,extension:f}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(f),S,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(S),this._proxy.$unregisterWebviewViewProvider(S)})}async $resolveWebviewView(f,S,i,g,a){const r=this._viewProviders.get(S);if(!r)throw new Error(`No view provider found for '${S}'`);const{provider:v,extension:l}=r,c=this._extHostWebview.createNewWebview(f,{},l),b=new C(f,this._proxy,S,i,c,!0);this._webviewViews.set(f,b),await v.resolveWebviewView(b,{state:g},a)}async $onDidChangeWebviewViewVisibility(f,S){this.getWebviewView(f)._setVisible(S)}async $disposeWebviewView(f){const S=this.getWebviewView(f);this._webviewViews.delete(f),S.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const S=this._webviewViews.get(f);if(!S)throw new Error("No webview found");return S}}e.ExtHostWebviewViews=w}),define(be[97],Ee([0,1,3,5,2,11,9,4,13]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class $i{constructor(_){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$i.InitialState,this._proxy=_.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let m;if(typeof _=="string"){m=_;try{_=E.URI.parse(_)}catch(s){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,F.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,m,n)}async asExternalUri(_,n){if((0,F.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(_,n);return E.URI.from(m)}};T.InitialState={focused:!0},T=$e([ze(0,D.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(be[212],Ee([0,1,15,5,29,13]),function(oe,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends d.AbstractLogger{constructor(D,T){super();this._proxy=D.getProxy(M.MainContext.MainThreadLog),this._logFile=T.logFile.toJSON(),this.setLevel(T.logLevel)}$setLevel(D){this.setLevel(D)}trace(D,...T){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(D,...T){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(D,...T){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(D,...T){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(D,...T){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(D,...T){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};F=$e([ze(0,A.IExtHostRpcService),ze(1,E.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(be[213],Ee([0,1,12,22,21,16,3,6,108,180,38]),function(oe,e,d,M,E,A,F,P,D,T,t){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(y,R){try{return JSON.stringify(y,R)}catch(k){return"null"}}const m="$$ref$$",s={[m]:-1};class u{constructor(R,k){this.jsonString=R,this.referencedBuffers=k}}function p(y,R=null,k=!1){const O=[];return{jsonString:(k?n:JSON.stringify)(y,(I,B)=>{if(typeof B=="undefined")return s;if(typeof B=="object"){if(B instanceof M.VSBuffer){const x=O.push(B)-1;return{[m]:x}}if(R)return R(I,B)}return B}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=p;function C(y,R,k){return JSON.parse(y,(O,N)=>{if(N){const I=N[m];if(typeof I=="number")return R[I];if(k&&N.$mid===1)return k.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=C;function w(y,R){return JSON.stringify(y,R)}function o(y){return y?(R,k)=>k&&k.$mid===1?y.transformOutgoing(k):k:null}var f;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},g=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class r extends P.Disposable{constructor(R,k=null,O=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=k,this._uriTransformer=O,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,I=t.ProxyIdentifier.count;N<I;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,D.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:k,sid:O}=R;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,O)),this._proxies[k]}_createProxy(R,k){let O={get:(N,I)=>(typeof I=="string"&&!N[I]&&I.charCodeAt(0)===36&&(N[I]=(...B)=>this._remoteCall(R,I,B)),I===a?k:N[I])};return new Proxy(Object.create(null),O)}set(R,k){return this._locals[R.nid]=k,k}assertRegistered(R){for(let k=0,O=R.length;k<O;k++){const N=R[k];if(!this._locals[N.nid])throw new Error(`Missing actor ${N.sid} (isMain: ${N.isMain})`)}}_receiveOneMessage(R){if(this._isDisposed)return;const k=R.byteLength,O=v.read(R,0),N=O.readUInt8(),I=O.readUInt32();switch(N){case 1:case 2:{let{rpcId:B,method:x,args:V}=c.deserializeRequestJSONArgs(O);this._uriTransformer&&(V=(0,D.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(k,I,B,x,V,N===2);break}case 3:case 4:{let{rpcId:B,method:x,args:V}=c.deserializeRequestMixedArgs(O);this._uriTransformer&&(V=(0,D.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(k,I,B,x,V,N===4);break}case 5:{this._logger&&this._logger.logIncoming(k,I,0,"ack"),this._onDidReceiveAcknowledge(I);break}case 6:{this._receiveCancel(k,I);break}case 7:{this._receiveReply(k,I,void 0);break}case 9:{let B=c.deserializeReplyOKJSON(O);this._uriTransformer&&(B=(0,D.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(k,I,B);break}case 10:{const B=c.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(k,I,B);break}case 8:{let B=c.deserializeReplyOKVSBuffer(O);this._receiveReply(k,I,B);break}case 11:{let B=c.deserializeReplyErrError(O);this._uriTransformer&&(B=(0,D.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(k,I,B);break}case 12:{this._receiveReplyErr(k,I,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,k,O,N,I,B){this._logger&&this._logger.logIncoming(R,k,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(O)}.${N}(`,I);const x=String(k);let V,H;if(B){const ee=new E.CancellationTokenSource;I.push(ee.token),V=this._invokeHandler(O,N,I),H=()=>ee.cancel()}else V=this._invokeHandler(O,N,I),H=i;this._cancelInvokedHandlers[x]=H;const W=c.serializeAcknowledged(k);this._logger&&this._logger.logOutgoing(W.byteLength,k,1,"ack"),this._protocol.send(W),V.then(ee=>{delete this._cancelInvokedHandlers[x];const q=c.serializeReplyOK(k,ee,this._uriReplacer);this._logger&&this._logger.logOutgoing(q.byteLength,k,1,"reply:",ee),this._protocol.send(q)},ee=>{delete this._cancelInvokedHandlers[x];const q=c.serializeReplyErr(k,ee);this._logger&&this._logger.logOutgoing(q.byteLength,k,1,"replyErr:",ee),this._protocol.send(q)})}_receiveCancel(R,k){this._logger&&this._logger.logIncoming(R,k,1,"receiveCancel");const O=String(k);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(R,k,O){this._logger&&this._logger.logIncoming(R,k,0,"receiveReply:",O);const N=String(k);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const I=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],I.resolveOk(O)}_receiveReplyErr(R,k,O){this._logger&&this._logger.logIncoming(R,k,0,"receiveReplyErr:",O);const N=String(k);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const I=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let B;O&&(O.$isError?(B=new Error,B.name=O.name,B.message=O.message,B.stack=O.stack):B=O),I.resolveErr(B)}_invokeHandler(R,k,O){try{return Promise.resolve(this._doInvokeHandler(R,k,O))}catch(N){return Promise.reject(N)}}_doInvokeHandler(R,k,O){const N=this._locals[R];if(!N)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(R));let I=N[k];if(typeof I!="function")throw new Error("Unknown method "+k+" on actor "+(0,t.getStringIdentifierForProxy)(R));return I.apply(N,O)}_remoteCall(R,k,O){if(this._isDisposed)return Promise.reject(A.canceled());let N=null;if(O.length>0&&E.CancellationToken.isCancellationToken(O[O.length-1])&&(N=O.pop()),N&&N.isCancellationRequested)return Promise.reject(A.canceled());const I=c.serializeRequestArguments(O,this._uriReplacer),B=++this._lastMessageId,x=String(B),V=new T.LazyPromise;N&&N.onCancellationRequested(()=>{const W=c.serializeCancel(B);this._logger&&this._logger.logOutgoing(W.byteLength,B,0,"cancel"),this._protocol.send(c.serializeCancel(B))}),this._pendingRPCReplies[x]=V,this._onWillSendRequest(B);const H=c.serializeRequest(B,R,k,I,!!N);return this._logger&&this._logger.logOutgoing(H.byteLength,B,0,`request: ${(0,t.getStringIdentifierForProxy)(R)}.${k}(`,O),this._protocol.send(H),V}}e.RPCProtocol=r,_=g,r.UNRESPONSIVE_TIME=3*1e3;class v{constructor(R,k){this._buff=R,this._offset=k}static alloc(R,k,O){let N=new v(M.VSBuffer.alloc(O+1+4),0);return N.writeUInt8(R),N.writeUInt32(k),N}static read(R,k){return new v(R,k)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,O}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,O}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,k}static sizeMixedArray(R){let k=0;k+=1;for(let O=0,N=R.length;O<N;O++){const I=R[O];switch(k+=1,I.type){case 1:k+=this.sizeLongString(I.value);break;case 2:k+=this.sizeVSBuffer(I.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(I.value);for(let B=0;B<I.buffers.length;++B)k+=this.sizeVSBuffer(I.buffers[B]);break;case 4:break}}return k}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let k=0,O=R.length;k<O;k++){const N=R[k];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let I=0;I<N.buffers.length;++I)this.writeBuffer(N.buffers[I]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let k=new Array(R);for(let O=0;O<R;O++)switch(this.readUInt8()){case 1:k[O]=this.readLongString();break;case 2:k[O]=this.readVSBuffer();break;case 3:const I=this.readUInt32(),B=this.readLongString(),x=[];for(let V=0;V<I;++V)x.push(this.readVSBuffer());k[O]=new t.SerializableObjectWithBuffers(C(B,x,null));break;case 4:k[O]=void 0;break}return k}}v.sizeUInt32=4;var l;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(l||(l={}));class c{static _useMixedArgSerialization(R){for(let k=0,O=R.length;k<O;k++)if(R[k]instanceof M.VSBuffer||R[k]instanceof t.SerializableObjectWithBuffers||typeof R[k]=="undefined")return!0;return!1}static serializeRequestArguments(R,k){if(this._useMixedArgSerialization(R)){const O=[];for(let N=0,I=R.length;N<I;N++){const B=R[N];if(B instanceof M.VSBuffer)O[N]={type:2,value:B};else if(typeof B=="undefined")O[N]={type:4};else if(B instanceof t.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:V}=p(B.value,k);O[N]={type:3,value:M.VSBuffer.fromString(x),buffers:V}}else O[N]={type:1,value:M.VSBuffer.fromString(w(B,k))}}return{type:1,args:O}}return{type:0,args:w(R,k)}}static serializeRequest(R,k,O,N,I){switch(N.type){case 0:return this._requestJSONArgs(R,k,O,N.args,I);case 1:return this._requestMixedArgs(R,k,O,N.args,I)}}static _requestJSONArgs(R,k,O,N,I){const B=M.VSBuffer.fromString(O),x=M.VSBuffer.fromString(N);let V=0;V+=v.sizeUInt8(),V+=v.sizeShortString(B),V+=v.sizeLongString(x);let H=v.alloc(I?2:1,R,V);return H.writeUInt8(k),H.writeShortString(B),H.writeLongString(x),H.buffer}static deserializeRequestJSONArgs(R){const k=R.readUInt8(),O=R.readShortString(),N=R.readLongString();return{rpcId:k,method:O,args:JSON.parse(N)}}static _requestMixedArgs(R,k,O,N,I){const B=M.VSBuffer.fromString(O);let x=0;x+=v.sizeUInt8(),x+=v.sizeShortString(B),x+=v.sizeMixedArray(N);let V=v.alloc(I?4:3,R,x);return V.writeUInt8(k),V.writeShortString(B),V.writeMixedArray(N),V.buffer}static deserializeRequestMixedArgs(R){const k=R.readUInt8(),O=R.readShortString(),N=R.readMixedArray(),I=new Array(N.length);for(let B=0,x=N.length;B<x;B++){const V=N[B];typeof V=="string"?I[B]=JSON.parse(V):I[B]=V}return{rpcId:k,method:O,args:I}}static serializeAcknowledged(R){return v.alloc(5,R,0).buffer}static serializeCancel(R){return v.alloc(6,R,0).buffer}static serializeReplyOK(R,k,O){if(typeof k=="undefined")return this._serializeReplyOKEmpty(R);if(k instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(R,k);if(k instanceof t.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:I}=p(k.value,O,!0);return this._serializeReplyOKJSONWithBuffers(R,N,I)}else return this._serializeReplyOKJSON(R,n(k,O))}static _serializeReplyOKEmpty(R){return v.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,k){let O=0;O+=v.sizeVSBuffer(k);let N=v.alloc(8,R,O);return N.writeVSBuffer(k),N.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,k){const O=M.VSBuffer.fromString(k);let N=0;N+=v.sizeLongString(O);let I=v.alloc(9,R,N);return I.writeLongString(O),I.buffer}static _serializeReplyOKJSONWithBuffers(R,k,O){const N=M.VSBuffer.fromString(k);let I=0;I+=v.sizeUInt32,I+=v.sizeLongString(N);for(const x of O)I+=v.sizeVSBuffer(x);let B=v.alloc(10,R,I);B.writeUInt32(O.length),B.writeLongString(N);for(const x of O)B.writeBuffer(x);return B.buffer}static deserializeReplyOKJSON(R){const k=R.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(R,k){const O=R.readUInt32(),N=R.readLongString(),I=[];for(let B=0;B<O;++B)I.push(R.readVSBuffer());return new t.SerializableObjectWithBuffers(C(N,I,k))}static serializeReplyErr(R,k){return k?this._serializeReplyErrEror(R,k):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,k){const O=M.VSBuffer.fromString(n(A.transformErrorForSerialization(k),null));let N=0;N+=v.sizeLongString(O);let I=v.alloc(11,R,N);return I.writeLongString(O),I.buffer}static deserializeReplyErrError(R){const k=R.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(R){return v.alloc(12,R,0).buffer}}var b;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var h;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(h||(h={}))}),define(be[214],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(A){const F=P=>{self.removeEventListener("message",F);const D=P.data;Object.defineProperties(self,{postMessage:{value(T,t){D.postMessage(T,t)}},onmessage:{get(){return D.onmessage},set(T){D.onmessage=T}}}),D.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(A,F,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${d})('${F}'))`,T=new Blob([D],{type:"application/javascript"}),t=URL.createObjectURL(T),_=new MessageChannel,n=t,m={type:"_newWorker",id:n,port:_.port2,url:t,options:P};A(m,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};_.port1.postMessage(s),URL.revokeObjectURL(t),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(s){_.port1.onmessage=s}},onmessageerror:{get(){return _.port1.onmessageerror},set(s){_.port1.onmessageerror=s}}}),_.port1.addEventListener("messageerror",s=>{const u=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(u)}),_.port1.addEventListener("message",s=>{const u=new MessageEvent("message",{data:s.data});this.dispatchEvent(u)}),_.port1.start()}}e.NestedWorker=M}),define(be[215],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(be[216],Ee([0,1,11,17,25,2,4,63,48,176,215]),function(oe,e,d,M,E,A,F,P,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let _=class Wi{constructor(m,s,u,p){this.localUserHome=m,this.remoteAgentService=s,this.environmentService=u,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const C=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=C?.userHome||m})()}get defaultUriScheme(){return Wi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,s){if(m.remoteAuthority)return d.Schemas.vscodeRemote;const u=(0,P.getVirtualWorkspaceScheme)(s.getWorkspace());if(u)return u;const p=s.getWorkspace().folders[0];if(p)return p.uri.scheme;const C=s.getWorkspace().configuration;return C?C.scheme:d.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?M.win32:M.posix)}async fileURI(m){let s="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const p=m.indexOf("/",2);p===-1?(s=m.substring(2),m="/"):(s=m.substring(2,p),m=m.substring(p)||"/")}return A.URI.from({scheme:d.Schemas.file,authority:s,path:m,query:"",fragment:""})}};_=$e([ze(1,t.IRemoteAgentService),ze(2,T.IWorkbenchEnvironmentService),ze(3,D.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(be[98],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(F,P){this.line=F,this.character=P}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,P){return new d(0,0)}with(F){return new d(0,0)}}e.Position=d;class M{constructor(F,P,D,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(F,P),this.end=new d(D,T)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],Ee([0,1,14,27,23,43,9,4,17,16,98,10]),function(oe,e,d,M,E,A,F,P,D,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",m=" characters skipped \u27EB",s=(n.length+m.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function C(W){return!!W.preview}e.resultIsMatch=C;function w(W){return!!W.resource}e.isFileMatch=w;function o(W){return!!W.message}e.isProgressMessage=o;var f;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class S{constructor(ee){this.resource=ee,this.results=[]}}e.FileMatch=S;class i{constructor(ee,q,Y){this.ranges=q;const j=Array.isArray(q)?q:[q];if(Y&&Y.matchLines===1&&g(j)){ee=(0,F.getNLines)(ee,Y.matchLines);let le="",re=0,ve=0;const Fe=Math.floor(Y.charsPerLine/5),Me=[];for(const Oe of j){const Ke=Math.max(Oe.startColumn-Fe,0),qe=Oe.startColumn+Y.charsPerLine;if(Ke>ve+Fe+s){const Ve=n+(Ke-ve)+m;le+=Ve+ee.slice(Ke,qe),re+=Ke-(ve+Ve.length)}else le+=ee.slice(ve,qe);Me.push(new r(0,Oe.startColumn-re,Oe.endColumn-re)),ve=qe}this.preview={text:le,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const le=Array.isArray(q)?q[0].startLineNumber:q.startLineNumber;this.preview={text:ee,matches:(0,d.mapArrayOrNot)(q,re=>new a(re.startLineNumber-le,re.startColumn,re.endLineNumber-le,re.endColumn))}}}}e.TextSearchMatch=i;function g(W){const ee=W[0].startLineNumber;for(const q of W)if(q.startLineNumber!==ee||q.endLineNumber!==ee)return!1;return!0}class a{constructor(ee,q,Y,j){this.startLineNumber=ee,this.startColumn=q,this.endLineNumber=Y,this.endColumn=j}}e.SearchRange=a;class r extends a{constructor(ee,q,Y){super(ee,q,ee,Y)}}e.OneLineRange=r;var v;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(v=e.SearchSortOrder||(e.SearchSortOrder={}));function l(W,ee=!0){const q=W&&W.files&&W.files.exclude,Y=ee&&W&&W.search&&W.search.exclude;if(!q&&!Y)return;if(!q||!Y)return q||Y;let j=Object.create(null);return j=E.mixin(j,E.deepClone(q)),j=E.mixin(j,E.deepClone(Y),!0),j}e.getExcludes=l;function c(W,ee){return W.excludePattern&&M.match(W.excludePattern,ee)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&M.match(W.includePattern,ee)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(q=>{const Y=q.folder.fsPath;if(A.isEqualOrParent(ee,Y)){const j=D.relative(Y,ee);return!q.includePattern||!!M.match(q.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var b;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(ee,q){super(ee);this.code=q}}e.SearchError=h;function y(W){const ee=W.message;if((0,T.isPromiseCanceledError)(W))return new h(ee,b.canceled);try{const q=JSON.parse(ee);return new h(q.message,q.code)}catch(q){return new h(ee,b.other)}}e.deserializeSearchError=y;function R(W){const ee={message:W.message,code:W.code};return new Error(JSON.stringify(ee))}e.serializeSearchError=R;function k(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=k;function O(W){return W.type==="success"}e.isSerializedSearchSuccess=O;function N(W){return!!W.path}e.isSerializedFileMatch=N;function I(W,ee){const q=W.searchPath?W.searchPath:W.relativePath;return(0,F.fuzzyContains)(q,ee)}e.isFilePatternMatch=I;class B{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function x(W,ee){const q={...W||{},...ee||{}};return Object.keys(q).filter(Y=>{const j=q[Y];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=x;class V{constructor(ee,q){this._parsedIncludeExpression=null,this._excludeExpression={...ee.excludePattern||{},...q.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let Y=ee.includePattern;q.includePattern&&(Y?Y={...Y,...q.includePattern}:Y=q.includePattern),Y&&(this._parsedIncludeExpression=M.parse(Y))}matchesExcludesSync(ee,q,Y){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ee,q,Y))}includedInQuerySync(ee,q,Y){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ee,q,Y)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ee,q,Y))}includedInQuery(ee,q,Y){const j=this._parsedExcludeExpression(ee,q,Y),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ee,q,Y):!0;return(0,_.isPromise)(j)?j.then(re=>re?!1:le()):le()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=V;function H(W){for(const ee in W)if(typeof W[ee]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,14,12,21,3,20,11,76,24,9,10,2,129,4,15,143,48,37,29,13,7,41,5]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w,o,f,S,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(R,k,O){return new T.ExtUri(N=>c(N,O)).isEqual(R,k)}function r(R,k,O){return a(R.uri,k.uri,O)?0:(0,t.compare)(R.uri.toString(),k.uri.toString())}function v(R,k,O){return R.index!==k.index?R.index<k.index?-1:1:a(R.uri,k.uri,O)?(0,t.compare)(R.name,k.name):(0,t.compare)(R.uri.toString(),k.uri.toString())}function l(R,k,O,N){const I=R.slice(0).sort((x,V)=>O(x,V,N)),B=k.slice(0).sort((x,V)=>O(x,V,N));return(0,d.delta)(I,B,(x,V)=>O(x,V,N))}function c(R,k){const O=k.getCapabilities(R.scheme);return!(O&&O&1024)}class b extends C.Workspace{constructor(k,O,N,I,B,x,V){super(k,N.map(H=>new C.WorkspaceFolder(H)),I,B,V);this._name=O,this._isUntitled=x,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(V),N.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(k,O,N,I){if(!k)return{workspace:null,added:[],removed:[]};const{id:B,name:x,folders:V,configuration:H,transient:W,isUntitled:ee}=k,q=[],Y=O;O?V.forEach((ve,Fe)=>{const Me=n.URI.revive(ve.uri),Oe=b._findFolder(N||O,Me,I);Oe?(Oe.name=ve.name,Oe.index=ve.index,q.push(Oe)):q.push({uri:Me,name:ve.name,index:Fe})}):q.push(...V.map(({uri:ve,name:Fe,index:Me})=>({uri:n.URI.revive(ve),name:Fe,index:Me}))),q.sort((ve,Fe)=>ve.index<Fe.index?-1:1);const j=new b(B,x,q,!!W,H?n.URI.revive(H):null,!!ee,ve=>c(ve,I)),{added:le,removed:re}=l(Y?Y.workspaceFolders:[],j.workspaceFolders,r,I);return{workspace:j,added:le,removed:re}}static _findFolder(k,O,N){for(let I=0;I<k.folders.length;I++){const B=k.workspaceFolders[I];if(a(B.uri,O,N))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(k,O){return O&&this._structure.get(k)&&(k=(0,T.dirname)(k)),this._structure.findSubstr(k)}resolveWorkspaceFolder(k){return this._structure.get(k)}}let h=class{constructor(k,O,N,I){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=I,this._extHostFileSystemInfo=N,this._requestIdProvider=new D.Counter,this._barrier=new M.Barrier,this._proxy=k.getProxy(g.MainContext.MainThreadWorkspace),this._messageService=k.getProxy(g.MainContext.MainThreadMessageService);const B=O.workspace;this._confirmedWorkspace=B?new b(B.id,B.name,[],!!B.transient,B.configuration?n.URI.revive(B.configuration):null,!!B.isUntitled,x=>c(x,N)):void 0}$initializeWorkspace(k,O){this._trusted=O,this.$acceptWorkspaceData(k),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:P.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(k,O,N,...I){const B=[];if(Array.isArray(I)&&I.forEach(ee=>{n.URI.isUri(ee.uri)&&!B.some(q=>a(q.uri,ee.uri,this._extHostFileSystemInfo))&&B.push({uri:ee.uri,name:ee.name||(0,T.basenameOrAuthority)(ee.uri)})}),this._unconfirmedWorkspace||[O,N].some(ee=>typeof ee!="number"||ee<0)||N===0&&B.length===0)return!1;const x=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(O+N>x.length)return!1;const V=x.slice(0);V.splice(O,N,...B.map(ee=>({uri:ee.uri,name:ee.name||(0,T.basenameOrAuthority)(ee.uri),index:void 0})));for(let ee=0;ee<V.length;ee++){const q=V[ee];if(V.some((Y,j)=>j!==ee&&a(q.uri,Y.uri,this._extHostFileSystemInfo)))return!1}V.forEach((ee,q)=>ee.index=q);const{added:H,removed:W}=l(x,V,v,this._extHostFileSystemInfo);if(H.length===0&&W.length===0)return!1;if(this._proxy){const ee=k.displayName||k.name;this._proxy.$updateWorkspaceFolders(ee,O,N,B).then(void 0,q=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,m.localize)(0,null,ee,q.toString()),{extension:k},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(k,O){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(k,O)}async getWorkspaceFolder2(k,O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(k,O)}async resolveWorkspaceFolder(k){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(k)}getPath(){if(!this._actualWorkspace)return;const{folders:k}=this._actualWorkspace;if(k.length!==0)return k[0].uri.fsPath}getRelativePath(k,O){let N,I="";if(typeof k=="string"?(N=n.URI.file(k),I=k):typeof k!="undefined"&&(N=k,I=k.fsPath),!N)return I;const B=this.getWorkspaceFolder(N,!0);if(!B)return I;typeof O=="undefined"&&this._actualWorkspace&&(O=this._actualWorkspace.folders.length>1);let x=(0,T.relativePath)(B.uri,N);return O&&B.name&&(x=`${B.name}/${x}`),x}trySetWorkspaceFolders(k){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:k,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(k){const{workspace:O,added:N,removed:I}=b.toExtHostWorkspace(k,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=O||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:I}))}findFiles(k,O,N,I,B=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${I.value}, entryPoint: findFiles`);let x;if(O===null?x=!1:O&&(typeof O=="string"?x=O:x=O.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:H}=y(k);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(V),(0,_.withUndefinedAsNull)(H),(0,_.withUndefinedAsNull)(x),(0,_.withUndefinedAsNull)(N),B).then(W=>Array.isArray(W)?W.map(ee=>n.URI.revive(ee)):[])}async findTextInFiles(k,O,N,I,B=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${I.value}, entryPoint: findTextInFiles`);const x=this._requestIdProvider.getNext(),V=typeof O.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:H,folder:W}=y(O.include),ee=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,q={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:V,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:H,excludePattern:ee},Y=!1;if(this._activeSearchCallbacks[x]=j=>{if(Y)return;const le=n.URI.revive(j.resource);j.results.forEach(re=>{(0,i.resultIsMatch)(re)?N({uri:le,preview:{text:re.preview.text,matches:(0,d.mapArrayOrNot)(re.preview.matches,ve=>new S.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,d.mapArrayOrNot)(re.ranges,ve=>new S.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):N({uri:le,text:re.text,lineNumber:re.lineNumber})})},B.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(k,(0,_.withUndefinedAsNull)(W),q,x,B);return delete this._activeSearchCallbacks[x],j||{}}catch(j){throw delete this._activeSearchCallbacks[x],j}}$handleTextSearchResult(k,O){this._activeSearchCallbacks[O]&&this._activeSearchCallbacks[O](k)}saveAll(k){return this._proxy.$saveAll(k)}resolveProxy(k){return this._proxy.$resolveProxy(k)}get trusted(){return this._trusted}requestWorkspaceTrust(k){return this._proxy.$requestWorkspaceTrust(k)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};h=$e([ze(0,f.IExtHostRpcService),ze(1,o.IExtHostInitDataService),ze(2,w.IExtHostFileSystemInfo),ze(3,u.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function y(R){let k,O;return R&&(typeof R=="string"?k=R:(k=R.pattern,O=R.baseFolder||n.URI.file(R.base))),{includePattern:k,folder:O}}}),define(be[32],Ee([0,1,23,3,31,5,7,146,62,10,12,4,13,15,2]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(g,a){if(a){const r=a.split(".");let v=g;for(let l=0;v&&l<r.length;l++)v=v[r[l]];return v}}function p(g){return g instanceof s.URI}function C(g){return g&&g.uri instanceof s.URI&&g.languageId&&typeof g.languageId=="string"}function w(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function o(g){return g&&g.uri instanceof s.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function f(g){if(p(g))return{resource:g};if(C(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(w(g))return{overrideIdentifier:g.languageId};if(o(g))return{resource:g.uri};if(g===null)return{resource:null}}let S=class{constructor(a,r,v){this._proxy=a.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=v,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new i(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,r){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(a,r))}};S=$e([ze(0,n.IExtHostRpcService),ze(1,E.IExtHostWorkspace),ze(2,m.ILogService)],S),e.ExtHostConfiguration=S;class i{constructor(a,r,v,l){this._onDidChangeConfiguration=new M.Emitter,this._proxy=a,this._logService=l,this._extHostWorkspace=r,this._configuration=P.Configuration.parse(v),this._configurationScopes=this._toMap(v.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,r){const v={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,v))}getConfiguration(a,r,v){const l=f(r)||{},c=this._toReadonlyValue(a?u(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,l,v?.identifier);function b(y){if(y==null)return null;if(typeof y=="boolean")return y?1:4;switch(y){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(y){return typeof u(c,y)!="undefined"},get:(y,R)=>{this._validateConfigurationAccess(a?`${a}.${y}`:y,l,v?.identifier);let k=u(c,y);if(typeof k=="undefined")k=R;else{let O;const N=(I,B)=>{let x;const V=()=>{O=O||(0,d.deepClone)(c),x=x||u(O,B)};return(0,T.isObject)(I)?new Proxy(I,{get:(H,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return V(),()=>x;if(O)return x=x||u(O,B),x[W];const ee=H[W];return typeof W=="string"?N(ee,`${B}.${W}`):ee},set:(H,W,ee)=>(V(),x&&(x[W]=ee),!0),deleteProperty:(H,W)=>(V(),x&&delete x[W],!0),defineProperty:(H,W,ee)=>(V(),x&&Object.defineProperty(x,W,ee),!0)}):I};k=N(k,y)}return k},update:(y,R,k,O)=>{y=a?`${a}.${y}`:y;const N=b(k);return R!==void 0?this._proxy.$updateConfigurationOption(N,y,R,l,O):this._proxy.$removeConfigurationOption(N,y,l,O)},inspect:y=>{y=a?`${a}.${y}`:y;const R=(0,d.deepClone)(this._configuration.inspect(y,l,this._extHostWorkspace.workspace));if(R)return{key:y,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof c=="object"&&(0,d.mixin)(h,c,!1),Object.freeze(h)}_toReadonlyValue(a){const r=v=>(0,T.isObject)(v)?new Proxy(v,{get:(l,c)=>r(l[c]),set:(l,c,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(l,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(l,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return r(a)}_validateConfigurationAccess(a,r,v){const l=D.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),c=v?`[${v.value}] `:"";if(l===4){typeof r?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){r?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,r){const v=new P.ConfigurationChangeEvent(a,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,c)=>v.affectsConfiguration(l,f(c))})}_toMap(a){return a.reduce((r,v)=>(r.set(v[0],v[1]),r),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[99],Ee([0,1,2,12,3,5,7,31,50,32,21,40,13,29,4,11,25,15,70,166,16]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w,o,f){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(B){function x(H){if(H!=null)return H}B.from=x;function V(H){if(H!=null)return H}B.to=V})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var g;(function(B){function x(H){if(H!=null)return H}B.from=x;function V(H){if(H!=null)return H}B.to=V})(g=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(B){function x(H){if(H!=null)return H}B.from=x;function V(H){if(H!=null)return H}B.to=V})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(B){function x(W){if(W){const ee=W;return ee&&!!ee.process}else return!1}B.is=x;function V(W){if(W==null)return;const ee={process:W.process,args:W.args};return W.options&&(ee.options=a.from(W.options)),ee}B.from=V;function H(W){if(W!=null)return new F.ProcessExecution(W.process,W.args,W.options)}B.to=H})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var v;(function(B){function x(H){if(H!=null)return H}B.from=x;function V(H){if(H!=null)return H}B.to=V})(v=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(B){function x(W){if(W){const ee=W;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}B.is=x;function V(W){if(W==null)return;const ee={};return W.commandLine!==void 0?ee.commandLine=W.commandLine:(ee.command=W.command,ee.args=W.args),W.options&&(ee.options=v.from(W.options)),ee}B.from=V;function H(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new F.ShellExecution(W.commandLine,W.options):new F.ShellExecution(W.command,W.args?W.args:[],W.options)}B.to=H})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(B){function x(W){if(W){let ee=W;return ee&&ee.customExecution==="customExecution"}else return!1}B.is=x;function V(W){return{customExecution:"customExecution"}}B.from=V;function H(W,ee){return ee.get(W)}B.to=H})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(B){function x(V,H){let W;return V.scope!==void 0&&typeof V.scope!="number"?W=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===F.TaskScope.Workspace&&H&&H.workspaceFile?W=H.workspaceFile:W=o.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:W}}B.from=x})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(B){function x(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}B.from=x})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function(B){function x(W,ee){if(W==null)return[];const q=[];for(let Y of W){const j=V(Y,ee);j&&q.push(j)}return q}B.fromMany=x;function V(W,ee){if(W==null)return;let q;W.execution instanceof F.ProcessExecution?q=r.from(W.execution):W.execution instanceof F.ShellExecution?q=l.from(W.execution):W.execution&&W.execution instanceof F.CustomExecution&&(q=c.from(W.execution));const Y=i.from(W.definition);let j;return W.scope?typeof W.scope=="number"?j=W.scope:j=W.scope.uri:j=F.TaskScope.Workspace,!Y||!j?void 0:{_id:W._id,definition:Y,name:W.name,source:{extensionId:ee.identifier.value,label:W.source,scope:j},execution:q,isBackground:W.isBackground,group:h.from(W.group),presentationOptions:g.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}B.from=V;async function H(W,ee,q){if(W==null)return;let Y;r.is(W.execution)?Y=r.to(W.execution):l.is(W.execution)?Y=l.to(W.execution):c.is(W.execution)&&(Y=c.to(W._id,q));const j=i.to(W.definition);let le;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?le=W.source.scope:le=await ee.resolveWorkspaceFolder(d.URI.revive(W.source.scope)):le=F.TaskScope.Workspace),!j||!le)return;const re=new F.Task(j,le,W.name,W.source.label,Y,W.problemMatchers);return W.isBackground!==void 0&&(re.isBackground=W.isBackground),W.group!==void 0&&(re.group=F.TaskGroup.from(W.group._id),re.group&&W.group.isDefault&&(re.group=new F.TaskGroup(re.group.id,re.group.label),W.group.isDefault&&(re.group.isDefault=W.group.isDefault))),W.presentationOptions&&(re.presentationOptions=g.to(W.presentationOptions)),W._id&&(re._id=W._id),W.detail&&(re.detail=W.detail),re}B.to=H})(y=e.TaskDTO||(e.TaskDTO={}));var R;(function(B){function x(H){return H}B.from=x;function V(H){if(!!H)return Object.assign(Object.create(null),H)}B.to=V})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(x,V,H){this._id=V,this._task=H,S.set(this,void 0),Ze(this,S,x,"f")}get task(){return this._task}terminate(){Re(this,S,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}S=new WeakMap;var O;(function(B){function x(V){return{id:V._id,task:void 0}}B.from=x})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(x,V,H,W,ee,q,Y,j){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=x.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=W,this._configurationService=ee,this._terminalService=q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Y,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,V,H){if(!H)return new F.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:V,provider:H,extension:x}),this._proxy.$registerTaskProvider(W,V),new F.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(x,V){this._proxy.$registerTaskSystem(x,V)}fetchTasks(x){return this._proxy.$fetchTasks(R.from(x)).then(async V=>{const H=[];for(let W of V){const ee=await y.to(W,this._workspaceProvider,this._providedCustomExecutions2);ee&&H.push(ee)}return H})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(V=>x.push(V)),x}terminateTask(x){if(!(x instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,V,H){const W=this._providedCustomExecutions2.get(x.id);if(W){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,W),this._terminalService.attachPtyToTerminal(V,await W.callback(H))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const V=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const V=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:V,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const V=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:x.exitCode})}$provideTasks(x,V){const H=this._handlers.get(x);if(!H)return Promise.reject(new Error("no handler found"));const W=[],ee=(0,M.asPromise)(()=>H.provider.provideTasks(t.CancellationToken.None)).then(q=>this.provideTasksInternal(V,W,H,q));return new Promise(q=>{ee.then(Y=>{Promise.all(W).then(()=>{q(Y)})})})}async $resolveTask(x,V){const H=this._handlers.get(x);if(!H)return Promise.reject(new Error("no handler found"));if(V.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${H.type}].`);const W=await y.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const ee=await H.provider.resolveTask(W,t.CancellationToken.None);if(!ee)return;this.checkDeprecation(ee,H);const q=y.from(ee,H.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(q.execution)&&await this.addCustomExecution(q,ee,!0),await this.resolveTaskInternal(q)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,V,H){const W=await this._proxy.$createTaskId(x);!H&&!this._providedCustomExecutions2.has(W)&&this._notProvidedCustomExecutions.add(W),this._providedCustomExecutions2.set(W,V.execution)}async getTaskExecution(x,V){if(typeof x=="string"){const ee=this._taskExecutionPromises.get(x);if(!ee)throw new Error("Unexpected: The specified task is missing an execution");return ee}let H=this._taskExecutionPromises.get(x.id);if(H)return H;const W=new Promise(async(ee,q)=>{const Y=V||await y.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);Y?ee(new k(this,x.id,Y)):q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,W),W.then(ee=>(this._taskExecutions.set(x.id,ee),ee),ee=>Promise.reject(ee))}checkDeprecation(x,V){x._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let H=this._notProvidedCustomExecutions.values(),W=H.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=H.next()}};N=$e([ze(0,n.IExtHostRpcService),ze(1,m.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,_.IExtHostTerminalService),ze(6,C.ILogService),ze(7,w.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let I=class extends N{constructor(x,V,H,W,ee,q,Y,j){super(x,V,H,W,ee,q,Y,j);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(x,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const H=y.from(V,x);if(H===void 0)throw new Error("Task is not valid");if(c.is(H.execution))await this.addCustomExecution(H,V,!1);else throw new f.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),V);return this._proxy.$executeTask(H).catch(ee=>{throw new Error(ee)}),W}provideTasksInternal(x,V,H,W){const ee=[];if(W)for(let q of W){this.checkDeprecation(q,H),(!q.definition||!x[q.definition.type])&&this._logService.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=y.from(q,H.extension);Y&&c.is(Y.execution)?(ee.push(Y),V.push(this.addCustomExecution(Y,q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:H.extension}}async resolveTaskInternal(x){if(c.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,V,H){}};I=$e([ze(0,n.IExtHostRpcService),ze(1,m.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,_.IExtHostTerminalService),ze(6,C.ILogService),ze(7,w.IExtHostApiDeprecationService)],I),e.WorkerExtHostTask=I,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(be[217],Ee([0,1,14,52,27,78,20,11,17,24,9,10,2,110,133,85,48,92,216,41]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(b,h,y,R){this.configurationService=b,this.workspaceContextService=h,this.editorGroupsService=y,this.pathService=R}text(b,h,y={}){b=this.getContentPattern(b,y);const R=this.configurationService.getValue(),k=h&&h.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(h?.map(p.toWorkspaceFolder),y),type:2,contentPattern:b,previewOptions:y.previewOptions,maxFileSize:y.maxFileSize,usePCRE2:R.search.usePCRE2||k||!1,beforeContext:y.beforeContext,afterContext:y.afterContext,userDisabledExcludesAndIgnoreFiles:y.disregardExcludeSettings&&y.disregardIgnoreFiles}}getContentPattern(b,h){const y=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const R={...b,wordSeparators:y.editor.wordSeparators};return this.isCaseSensitive(b,h)&&(R.isCaseSensitive=!0),this.isMultiline(b)&&(R.isMultiline=!0),R}file(b,h={}){return{...this.commonQuery(b,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}handleIncludeExclude(b,h){return b?(b=Array.isArray(b)?b.map(r):r(b),h?this.parseSearchPaths(b):{pattern:i(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],h={}){const y=this.handleIncludeExclude(h.includePattern,h.expandPatterns),R=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),k=b.length>1,O=(y.searchPaths&&y.searchPaths.length?y.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,h,R)):b.map(B=>this.getFolderQueryForRoot(B,h,R,k))).filter(B=>!!B),N={_reason:h._reason,folderQueries:O,usingSearchPaths:!!(y.searchPaths&&y.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:R.pattern,includePattern:y.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const x=d.coalesce(d.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(W=>W.resource)))).filter(H=>(0,o.pathIncludedInQuery)(N,H.fsPath)),V=this.commonQueryFromFileList(x);return{...N,...V}}const I=h.extraFileResources&&h.extraFileResources.filter(B=>(0,o.pathIncludedInQuery)(N,B.fsPath));return N.extraFileResources=I&&I.length?I:void 0,N}commonQueryFromFileList(b){const h=[],y=new F.ResourceMap,R={};let k=!1;return b.forEach(O=>{if(O.scheme===P.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(O)){const I=this.workspaceContextService.getWorkspaceFolder(O)?.uri??O.with({path:D.dirname(O.fsPath)});let B=y.get(I);B||(k=!0,B={folder:I,includePattern:{}},h.push(B),y.set(I,B));const x=D.relative(I.fsPath,O.fsPath);(0,_.assertIsDefined)(B.includePattern)[x.replace(/\\/g,"/")]=!0}else O.fsPath&&(k=!0,R[O.fsPath]=!0)}),{folderQueries:h,includePattern:R,usingSearchPaths:!0,excludePattern:k?void 0:{"**/*":!0}}}isCaseSensitive(b,h){if(h.isSmartCase){if(b.isRegExp){if(t.containsUppercaseCharacter(b.pattern,!0))return!0}else if(t.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,m.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const h=V=>D.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),R=(Array.isArray(b)?b:g(b)).map(V=>{const H=this.pathService.resolvedUserHome;return H?(0,A.untildify)(V,H.scheme===P.Schemas.file?H.fsPath:H.path):V}),k=M.groupBy(R,V=>h(V)?"searchPaths":"exprSegments"),O=(k.exprSegments||[]).map(V=>t.rtrim(V,"/")).map(V=>t.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),a(V))),N={},I=this.expandSearchPathPatterns(k.searchPaths||[]);I&&I.length&&(N.searchPaths=I);const B=d.flatten(O),x=i(...B);return x&&(N.pattern=x),N}getExcludesForFolder(b,h){return h.disregardExcludeSettings?void 0:(0,o.getExcludes)(b,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const h=d.flatten(b.map(R=>{let{pathPortion:k,globPortion:O}=S(R);O&&(O=v(O));const N=this.expandOneSearchPath(k);return d.flatten(N.map(I=>this.resolveOneSearchPathPattern(I,O)))})),y=new Map;return h.forEach(R=>{const k=R.searchPath.toString(),O=y.get(k);O?R.pattern&&(O.pattern=O.pattern||{},O.pattern[R.pattern]=!0):y.set(k,{searchPath:R.searchPath,pattern:R.pattern?i(R.pattern):void 0})}),Array.from(y.values())}expandOneSearchPath(b){if(D.isAbsolute(b)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==P.Schemas.file?[{searchPath:h[0].uri.with({path:b})}]:[{searchPath:n.URI.file(D.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=r(b),b.startsWith("../")||b===".."){const R=D.posix.resolve(h.path,b);return[{searchPath:h.with({path:R})}]}const y=v(b);return[{searchPath:h,pattern:y}]}else{if(b==="./"||b===".\\")return[];{const h=b.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(k=>{const O=h.match(new RegExp(`^${t.escapeRegExpCharacters(k.name)}(?:/(.*)|$)`));return O?{match:O,folder:k}:null}).filter(_.isDefined);if(R.length)return R.map(k=>{const O=k.match[1];return{searchPath:k.folder.uri,pattern:O&&v(O)}});{const k=b.match(/\.[\/\\](.+)[\/\\]?/),O=k?k[1]:b,N=s.localize(0,null,O);throw new Error(N)}}}}resolveOneSearchPathPattern(b,h){const y=b.pattern&&h?`${b.pattern}/${h}`:b.pattern||h,R=[{searchPath:b.searchPath,pattern:y}];return y&&!y.endsWith("**")&&R.push({searchPath:b.searchPath,pattern:y+"/**"}),R}getFolderQueryForSearchPath(b,h,y){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(b.searchPath),h,y,!1);return R?{...R,includePattern:b.pattern}:null}getFolderQueryForRoot(b,h,y,R){let k;const O=n.URI.isUri(b)?b:b.uri;if(y.searchPaths){const V=y.searchPaths.filter(H=>(0,T.isEqual)(H.searchPath,O))[0];if(V&&!V.pattern)return null;V&&(k=V.pattern)}const N=this.configurationService.getValue({resource:O}),B={...this.getExcludesForFolder(N,h)||{},...k||{}},x=n.URI.isUri(b)?(0,T.basename)(b):b.name;return{folder:O,folderName:R?x:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!N.search.followSymlinks}}};f=$e([ze(0,u.IConfigurationService),ze(1,p.IWorkspaceContextService),ze(2,C.IEditorGroupsService),ze(3,w.IPathService)],f),e.QueryBuilder=f;function S(c){const b=c.match(/[\*\{\}\(\)\[\]\?]/);if(b){const h=b.index,y=c.substr(0,h).match(/[/|\\][^/\\]*$/);if(y){let R=c.substr(0,y.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:c.substr((y.index||0)+1)}}}return{pathPortion:c}}function i(...c){return c.length?c.reduce((b,h)=>(b[h]=!0,b),Object.create(null)):void 0}function g(c){return E.splitGlobAware(c,",").map(b=>b.trim()).filter(b=>!!b.length)}function a(c){return[`**/${c}/**`,`**/${c}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function r(c){return c.replace(/\\/g,"/")}function v(c){return r(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(c,b){c=d.distinct(c,R=>R.toString());const h=[],y=b.getWorkspace();return c&&c.forEach(R=>{let k;if(b.getWorkbenchState()===2)k=(0,T.relativePath)(y.folders[0].uri,R),k&&k!=="."&&(k="./"+k);else{const O=b.getWorkspaceFolder(R);if(O){const N=O.name;if(y.folders.filter(B=>B.name===N).length===1){const B=(0,T.relativePath)(O.uri,R);B===""?k=`./${O.name}`:k=`./${O.name}/${B}`}else k=R.fsPath}}k&&h.push(k)}),h}e.resolveResourcesForSearchIncludes=l}),define(be[218],Ee([0,1,24,2,21,16,4,217,41,48]),function(oe,e,d,M,E,A,F,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function _(u,p){const C=p.activationEvents;if(!C)return Promise.resolve(void 0);const w=[],o=[];for(const r of C)if(/^workspaceContains:/.test(r)){const v=r.substr("workspaceContains:".length);v.indexOf("*")>=0||v.indexOf("?")>=0||u.forceUsingSearch?o.push(v):w.push(v)}if(w.length===0&&o.length===0)return Promise.resolve(void 0);let f;const S=new Promise((r,v)=>{f=r}),i=r=>f({activationEvent:r}),g=Promise.all(w.map(r=>n(u,r,i))).then(()=>{}),a=m(u,p.identifier,o,i);return Promise.all([g,a]).then(()=>{f(void 0)}),S}e.checkActivateWorkspaceContainsExtension=_;async function n(u,p,C){for(const w of u.folders)if(await u.exists(d.joinPath(M.URI.revive(w),p))){C(`workspaceContains:${p}`);return}}async function m(u,p,C,w){if(C.length===0)return Promise.resolve(void 0);const o=new E.CancellationTokenSource,f=u.checkExists(u.folders,C,o.token),S=setTimeout(async()=>{o.cancel(),w(`workspaceContainsTimeout:${C.join(",")}`)},t);let i=!1;try{i=await f}catch(g){A.isPromiseCanceledError(g)||A.onUnexpectedError(g)}o.dispose(),clearTimeout(S),i&&w(`workspaceContains:${C.join(",")}`)}function s(u,p,C,w){const o=u.get(F.IInstantiationService),f=u.get(D.ISearchService),i=o.createInstance(P.QueryBuilder).file(p.map(g=>(0,T.toWorkspaceFolder)(M.URI.revive(g))),{_reason:"checkExists",includePattern:C,exists:!0});return f.fileSearch(i,w).then(g=>!!g.limitHit,g=>A.isPromiseCanceledError(g)?!1:Promise.reject(g))}e.checkGlobFileExists=s});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!E:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(oe,d):E?E.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[33],Ee([0,1,124,17,75,24,12,6,20,2,15,5,32,179,73,31,30,177,16,26,22,152,7,86,4,29,74,13,61,65,40,3,218,69,154,11]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w,o,f,S,i,g,a,r,v,l,c,b,h,y,R,k,O,N){"use strict";var I,B,x;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let V=class Hi extends P.Disposable{constructor(q,Y,j,le,re,ve,Fe,Me,Oe,Ke){super();this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=j,this._initData=Fe,this._extHostWorkspace=le,this._extHostConfiguration=re,this._logService=ve,this._extHostTunnelService=Oe,this._extHostTerminalService=Ke,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new C.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=Me,this._instaService=q.createChild(new c.ServiceCollection([s.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState]));const qe=new Set;this._initData.hostExtensions.forEach(Ve=>qe.add(o.ExtensionIdentifier.toKey(Ve))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,$,Q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,w.transformErrorForSerialization($),Q)},actualActivateExtension:async(Ve,$)=>{if(qe.has(o.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,$),new m.HostExtension;const Q=this._registry.getExtensionDescription(Ve);return this._activateExtension(Q,$)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(q){w.onUnexpectedError(q)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let q=[];try{q=this._registry.getAllExtensionDescriptions().map(re=>re.identifier).filter(re=>this.isActivated(re)).map(re=>this._deactivate(re))}catch(Y){}await Promise.all(q)}isActivated(q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(q):!1}_activateByEvent(q,Y){return this._activator.activateByEvent(q,Y)}_activateById(q,Y){return this._activator.activateById(q,Y)}activateByIdWithErrors(q,Y){return this._activateById(q,Y).then(()=>{const j=this._activator.getActivatedExtension(q);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(q=>this._registry)}getExtensionExports(q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(q).exports:null}async _realPathExtensionUri(q){if(q.scheme!==N.Schemas.file)return q;const Y=await this._hostUtils.realpath(q.fsPath);return T.URI.file(Y)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const q=D.TernarySearchTree.forUris(Y=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Y));for(const Y of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Y)){const j=await this._realPathExtensionUri(Y.extensionLocation);q.set(j,Y)}return q})()),this._extensionPathIndex}_deactivate(q){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(q))return Y;const j=this._activator.getActivatedExtension(q);if(!j)return Y;try{typeof j.module.deactivate=="function"&&(Y=Promise.resolve(j.module.deactivate()).then(void 0,le=>(this._logService.error(le),Promise.resolve(void 0))))}catch(le){this._logService.error(le)}try{(0,P.dispose)(j.subscriptions)}catch(le){this._logService.error(le)}return Y}async _activateExtension(q,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(q.identifier),this._doActivateExtension(q,Y).then(j=>{const le=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(q.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,Y),this._logExtensionActivationTimes(q,Y,"success",le),j},j=>{throw this._logExtensionActivationTimes(q,Y,"failure"),j})}_logExtensionActivationTimes(q,Y,j,le){const re=H(q,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...re,...le||{},outcome:j})}_doActivateExtension(q,Y){const j=H(q,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const le=this._getEntryPoint(q);if(!le)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${q.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this._logService.flush();const re=new m.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(q.identifier,(0,A.joinPath)(q.extensionLocation,le),re),this._loadExtensionContext(q)]).then(ve=>(E.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),Hi._callActivate(this._logService,q.identifier,ve[0],ve[1],re))).then(ve=>(E.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),ve))}_loadExtensionContext(q){const Y=new S.ExtensionGlobalMemento(q,this._storage),j=new S.ExtensionMemento(q.identifier.value,!1,this._storage),le=new O.ExtensionSecrets(q,this._secretState),re=q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ve=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([Y.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let Me;return Object.freeze({globalState:Y,workspaceState:j,secrets:le,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(Oe){return M.join(q.extensionLocation.fsPath,Oe)},get storagePath(){return Fe._storagePath.workspaceValue(q)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(q).fsPath},get logPath(){return M.join(Fe._initData.logsLocation.fsPath,q.identifier.value)},get logUri(){return T.URI.joinPath(Fe._initData.logsLocation,q.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(q)},get globalStorageUri(){return Fe._storagePath.globalValue(q)},get extensionMode(){return re},get extension(){return Me===void 0&&(Me=new W(Fe,q.identifier,q,ve)),Me},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(q),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(q)}})})}static _callActivate(q,Y,j,le,re){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(q,Y,j,le,re).then(ve=>new m.ActivatedExtension(!1,null,re.build(),j,ve,le.subscriptions))}static _callActivateOptional(q,Y,j,le,re){if(typeof j.activate=="function")try{re.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const ve=typeof global=="object"?global:self,Fe=j.activate.apply(ve,[le]);return re.activateCallStop(),re.activateResolveStart(),Promise.resolve(Fe).then(Me=>(re.activateResolveStop(),Me))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(j)}_activateOneStartupFinished(q,Y){this._activateById(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:Y}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const q of this._registry.getAllExtensionDescriptions())if(q.activationEvents)for(const Y of q.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(q,Y)}_handleEagerExtensions(){const q=this._activateByEvent("*",!0).then(void 0,re=>{this._logService.error(re)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(re=>this._handleWorkspaceContainsEagerExtensions(re.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(Y),le=Promise.all([q,j]).then(()=>{});return Promise.race([le,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),le}_handleWorkspaceContainsEagerExtensions(q){return q.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(q,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(q,Y){if(this.isActivated(Y.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,le={folders:q.map(ve=>ve.uri),forceUsingSearch:j,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Fe,Me)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Fe,Me)},re=await(0,R.checkActivateWorkspaceContainsExtension)(le,Y);if(!!re)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:re.activationEvent}).then(void 0,ve=>this._logService.error(ve))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(q){throw console.error(q),q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:Y}=this._initData.environment;if(!q||!Y)throw new Error(d.localize(0,null));const j=await this._loadCommonJSModule(null,Y,new m.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(d.localize(1,null,Y.toString()));return new Promise((le,re)=>{const ve=(Oe,Ke)=>{Oe?re(Oe):le(typeof Ke=="number"&&Ke>0?1:0)},Fe=(0,A.originalFSPath)(Y),Me=j.run(Fe,ve);Me&&Me.then&&Me.then(()=>{le(0)}).catch(Oe=>{re(Oe.toString())})})}async $extensionTestsExit(q){this._logService.info(`Extension host terminating: test runner requested exit with code ${q}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${q}`),this._logService.flush(),this._hostUtils.exit(q)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,Y){return this._resolvers[q]=Y,(0,P.toDisposable)(()=>{delete this._resolvers[q]})}async _activateAndGetResolver(q){const Y=q.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const j=q.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(q,Y){const{authorityPrefix:j,resolver:le}=await this._activateAndGetResolver(q);if(!le)return{type:"error",error:{code:g.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(le)),E.mark(`code/extHost/willResolveAuthority/${j}`);const re=await le.resolve(q,{resolveAttempt:Y});E.mark(`code/extHost/didResolveAuthorityOK/${j}`);const ve={authority:q,host:re.host,port:re.port,connectionToken:re.connectionToken},Fe={extensionHostEnv:re.extensionHostEnv,isTrusted:re.isTrusted};return{type:"ok",value:{authority:ve,options:Fe,tunnelInformation:{environmentTunnels:re.environmentTunnels}}}}catch(re){if(E.mark(`code/extHost/didResolveAuthorityError/${j}`),re instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:re._code,message:re._message,detail:re._detail}};throw re}}async $getCanonicalURI(q,Y){const{authorityPrefix:j,resolver:le}=await this._activateAndGetResolver(q);if(!le)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const re=T.URI.revive(Y);if(typeof le.getCanonicalURI=="undefined")return re;const ve=await(0,F.asPromise)(()=>le.getCanonicalURI(re));return ve||re}$startExtensionHost(q){return this._registry.keepOnly(q),this._startExtensionHost()}$activateByEvent(q,Y){return Y===1?this._activateByEvent(q,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(q,!1))}async $activate(q,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(q)?(await this._activateById(q,Y),!0):!1}async $deltaExtensions(q,Y){q.forEach(le=>le.extensionLocation=T.URI.revive(le.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(Y.map(async le=>{const re=this._registry.getExtensionDescription(le);re&&j.delete(await this._realPathExtensionUri(re.extensionLocation))})),await Promise.all(q.map(async le=>{const re=await this._realPathExtensionUri(le.extensionLocation);j.set(re,le)})),this._registry.deltaExtensions(q,Y),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){let Y=f.VSBuffer.alloc(q),j=Math.random()%256;for(let le=0;le<q;le++)Y.writeUInt8(j,le);return Y}async $updateRemoteConnectionData(q){this._remoteConnectionData=q,this._onDidChangeRemoteConnectionData.fire()}};V=$e([ze(0,a.IInstantiationService),ze(1,e.IHostUtils),ze(2,l.IExtHostRpcService),ze(3,u.IExtHostWorkspace),ze(4,n.IExtHostConfiguration),ze(5,t.ILogService),ze(6,r.IExtHostInitDataService),ze(7,v.IExtensionStoragePaths),ze(8,b.IExtHostTunnelService),ze(9,h.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function H(ee,q){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class W{constructor(q,Y,j,le){I.set(this,void 0),B.set(this,void 0),x.set(this,void 0),Ze(this,I,q,"f"),Ze(this,B,Y,"f"),Ze(this,x,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=le}get isActive(){return Re(this,I,"f").isActivated(Re(this,x,"f"))}get exports(){if(this.packageJSON.api!=="none")return Re(this,I,"f").getExtensionExports(Re(this,x,"f"))}activate(){return Re(this,I,"f").activateByIdWithErrors(Re(this,x,"f"),{startup:!1,extensionId:Re(this,B,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,I=new WeakMap,B=new WeakMap,x=new WeakMap}),define(be[100],Ee([0,1,17,2,3,12,5,7,162,31,33,50,168,32,163,13,4,10,91,71]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let f=class{constructor(c,b,h,y,R,k){this._workspaceService=b,this._extensionService=h,this._editorsService=y,this._configurationService=R,this._editorTabs=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=c.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange(N=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,b){const h=c;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let y=`debug:${encodeURIComponent(h.path||"")}`,R="?";return b&&(y+=`${R}session=${encodeURIComponent(b.id)}`,R="&"),y+=`${R}ref=${h.sourceReference}`,M.URI.parse(y)}else{if(h.path)return M.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const b=[];for(const h of c.getAllExtensionDescriptions())if(h.contributes){const y=h.contributes.debuggers;if(y&&y.length>0)for(const R of y)(0,s.isDebuggerMainContribution)(R)&&b.push(R.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(b=>c.push(b)),c}addBreakpoints(c){this.startBreakpoints();const b=c.filter(R=>{const k=R.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,R),!0)});this.fireBreakpointChanges(b,[],[]);const h=[],y=new Map;for(const R of b)if(R instanceof P.SourceBreakpoint){let k=y.get(R.location.uri.toString());k||(k={type:"sourceMulti",uri:R.location.uri,lines:[]},y.set(R.location.uri.toString(),k),h.push(k)),k.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof P.FunctionBreakpoint&&h.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(c){this.startBreakpoints();const b=c.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],b,[]);const h=b.filter(k=>k instanceof P.SourceBreakpoint).map(k=>k.id),y=b.filter(k=>k instanceof P.FunctionBreakpoint).map(k=>k.id),R=b.filter(k=>k instanceof P.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(h,y,R)}startDebugging(c,b,h){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,b,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,b,h){if(!b)return new P.Disposable(()=>{});const y=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:y,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,h,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,y),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(c,b,h){if(!h)return new P.Disposable(()=>{});if(!this.definesDebugType(c,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:y,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,y),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(c,b){if(!b)return new P.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:h,factory:b}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(y=>y.factory!==b)})}async $runInTerminal(c,b){return Promise.resolve(void 0)}async $substituteVariables(c,b){if(!this._variableResolver){const[R,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,k)}let h;const y=await this.getFolder(c);return y&&(h={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,b)}createDebugAdapter(c,b){if(c.type==="implementation")return new r(c.implementation)}createSignService(){}async $startDASession(c,b){const h=this,y=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(y.type),y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const k=this.convertToDto(R),O=this.createDebugAdapter(k,y);if(!O)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const N=O;return this._debugAdapters.set(c,N),this.getDebugAdapterTrackers(y).then(I=>(I&&this._debugAdaptersTrackers.set(c,I),N.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const x=B,V={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(x.arguments.value);V.body={signature:H},N.sendResponse(V)}else throw new Error("no signer")}catch(H){V.success=!1,V.message=H.message,N.sendResponse(V)}}else I&&I.onDidSendMessage&&I.onDidSendMessage(B),B=(0,s.convertToVSCPaths)(B,!0),h._debugServiceProxy.$acceptDAMessage(c,B)}),N.onError(B=>{I&&I.onError&&I.onError(B),this._debugServiceProxy.$acceptDAError(c,B.name,B.message,B.stack)}),N.onExit(B=>{I&&I.onExit&&I.onExit((0,C.withNullAsUndefined)(B),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,C.withNullAsUndefined)(B),void 0)}),I&&I.onWillStartSession&&I.onWillStartSession(),N.startSession()))})}$sendDAMessage(c,b){b=(0,s.convertToDAPaths)(b,!1);const h=this._debugAdaptersTrackers.get(c);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(b);const y=this._debugAdapters.get(c);y&&y.sendMessage(b)}$stopDASession(c){const b=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),b&&b.onWillStopSession&&b.onWillStopSession();const h=this._debugAdapters.get(c);return this._debugAdapters.delete(c),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const b=[],h=[],y=[];if(c.added)for(const R of c.added){const k=R.id;if(k&&!this._breakpoints.has(k)){let O;if(R.type==="function")O=new P.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")O=new P.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const N=M.URI.revive(R.uri);O=new P.SourceBreakpoint(new P.Location(N,new P.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}O._id=k,this._breakpoints.set(k,O),b.push(O)}}if(c.removed)for(const R of c.removed){const k=this._breakpoints.get(R);k&&(this._breakpoints.delete(R),h.push(k))}if(c.changed){for(const R of c.changed)if(R.id){const k=this._breakpoints.get(R.id);if(k){if(k instanceof P.FunctionBreakpoint&&R.type==="function"){const O=k;O.enabled=R.enabled,O.condition=R.condition,O.hitCondition=R.hitCondition,O.logMessage=R.logMessage,O.functionName=R.functionName}else if(k instanceof P.SourceBreakpoint&&R.type==="source"){const O=k;O.enabled=R.enabled,O.condition=R.condition,O.hitCondition=R.hitCondition,O.logMessage=R.logMessage,O.location=new P.Location(M.URI.revive(R.uri),new P.Position(R.line,R.character))}y.push(k)}}}this.fireBreakpointChanges(b,h,y)}$provideDebugConfigurations(c,b,h){return(0,A.asPromise)(async()=>{const y=this.getConfigProviderByHandle(c);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(b);return y.provideDebugConfigurations(R,h)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(c,b,h,y){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(b);return R.resolveDebugConfiguration(k,h,y)})}$resolveDebugConfigurationWithSubstitutedVariables(c,b,h,y){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(b);return R.resolveDebugConfigurationWithSubstitutedVariables(k,h,y)})}async $provideDebugAdapter(c,b){const h=this.getAdapterDescriptorFactoryByHandle(c);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.getSession(b);return this.getAdapterDescriptor(h,y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(c){const b=await this.getSession(c);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(c){const b=await this.getSession(c);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,b){const h=await this.getSession(c);h&&h._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(c,b){const y={session:await this.getSession(c),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(y)}convertToDto(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const b=this._adapterFactories.filter(h=>h.type===c);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(c){const b=this._adapterFactories.filter(h=>h.handle===c);if(b.length>0)return b[0].factory}getConfigProviderByHandle(c){const b=this._configProviders.filter(h=>h.handle===c);if(b.length>0)return b[0].provider}definesDebugType(c,b){if(c.contributes){const h=c.contributes.debuggers;if(h&&h.length>0){for(const y of h)if(y.label&&y.type&&y.type===b)return!0}}return!1}getDebugAdapterTrackers(c){const h=c.configuration.type,y=this._trackerFactories.filter(R=>R.type===h||R.type==="*").map(R=>(0,A.asPromise)(()=>R.factory.createDebugAdapterTracker(c)).then(k=>k,k=>null));return Promise.race([Promise.all(y).then(R=>{const k=R.filter(O=>!!O);if(k.length>0)return new a(k)}),new Promise((R,k)=>{const O=setTimeout(()=>{clearTimeout(O),k(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(c,b){const h=b.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new P.DebugAdapterServer(h));if(c){const R=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,R))).then(k=>{if(k)return k})}const y=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,y))}daExecutableFromPackage(c,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,b,h){(c.length>0||b.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:b,changed:h}))}async getSession(c){if(c)if(typeof c=="string"){const b=this._debugSessions.get(c);if(b)return b}else{let b=this._debugSessions.get(c.id);if(!b){const h=await this.getFolder(c.folderUri),y=c.parent?this._debugSessions.get(c.parent):void 0;b=new S(this._debugServiceProxy,c.id,c.type,c.name,h,c.configuration,y),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(c){if(c){const b=M.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};f=$e([ze(0,u.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,_.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class S{constructor(c,b,h,y,R,k,O){this._debugServiceProxy=c,this._id=b,this._type=h,this._name=y,this._workspaceFolder=R,this._configuration=k,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,b)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=S;class i{constructor(c){this.value=Object.freeze({append(b){c.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=i;class g extends n.AbstractVariableResolverService{constructor(c,b,h,y,R){function k(){if(b){const O=b.activeEditor();if(O)return O.document.uri;const N=y.tabs.filter(I=>I.isActive);if(N.length>0){const I=N[0].resource;return I&&(I.primary||I.secondary)?I.primary??I.secondary:N[0].resource}}}super({getFolderUri:O=>{const N=c.filter(I=>I.name===O);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(O,N)=>h.getConfiguration(void 0,O).get(N),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const O=k();if(O)return d.normalize(O.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const O=k();if(O){const N=R.getWorkspaceFolder(O);if(N)return d.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(b){const O=b.activeEditor();if(O&&!O.selection.isEmpty)return O.document.getText(O.selection)}},getLineNumber:()=>{if(b){const O=b.activeEditor();if(O)return String(O.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=g;class a{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(b=>b.onError?b.onError(c):void 0)}onExit(c,b){this.trackers.forEach(h=>h.onExit?h.onExit(c,b):void 0)}}class r extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let v=class extends f{constructor(c,b,h,y,R,k){super(c,b,h,y,R,k)}createVariableResolver(c,b,h){return new g(c,b,h,this._editorTabs)}};v=$e([ze(0,u.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,_.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],v),e.WorkerExtHostDebugService=v}),define(be[219],Ee([0,1,75,2,5,32,30,26,13,29,4,33,91,15]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(o,f,S,i,g,a,r){this._apiFactory=o,this._extensionRegistry=f,this._instaService=S,this._extHostConfiguration=i,this._extHostExtensionService=g,this._initData=a,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,f,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(p,f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(C,f,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let f of o.nodeModuleName)this._factories.set(f,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(f=>o.alternativeModuleName(f))}};s=$e([ze(2,t.IInstantiationService),ze(3,A.IExtHostConfiguration),ze(4,_.IExtHostExtensionService),ze(5,T.IExtHostInitDataService),ze(6,m.ILogService)],s),e.RequireInterceptor=s;class u{constructor(o,f,S,i,g){this._apiFactory=o,this._extensionPaths=f,this._extensionRegistry=S,this._configProvider=i,this._logService=g,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,f){const S=this._extensionPaths.findSubstr(f);if(S){let i=this._extApiImpl.get(P.ExtensionIdentifier.toKey(S.identifier));return i||(i=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(S.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((g,a)=>i+=`	${a} -> ${g.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(o,f,S){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=f.getProxy(E.MainContext.MainThreadTelemetry);const{environment:i}=S,g=f.getProxy(E.MainContext.MainThreadKeytar);if(i.appRoot){let a=i.appRoot.fsPath;n.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,r)=>g.$getPassword(a,r),setPassword:(a,r,v)=>g.$setPassword(a,r,v),deletePassword:(a,r)=>g.$deletePassword(a,r),findPassword:a=>g.$findPassword(a),findCredentials(a){return g.$findCredentials(a)}}}load(o,f){const S=this._extensionPaths.findSubstr(f);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:S?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const f=o.length;if(f<=7||!this.alternativeNames)return;const S=f-7;if((o.charAt(S)==="/"||o.charAt(S)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};p=$e([ze(1,D.IExtHostRpcService),ze(2,T.IExtHostInitDataService)],p);let C=class{constructor(o,f,S){this._extensionPaths=o,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(E.MainContext.MainThreadTelemetry);const i=S.getProxy(E.MainContext.MainThreadWindow);this._impl=(g,a)=>{const r=M.URI.parse(g);return a?this.callOriginal(g,a):r.scheme==="http"||r.scheme==="https"?i.$openUri(r,g,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?i.$openUri(r,g,{}):this.callOriginal(g,a)}}load(o,f,S){const i=this._extensionPaths.findSubstr(f);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=S(o),this._impl}callOriginal(o,f){return this.sendNoForwardTelemetry(),this._original(o,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};C=$e([ze(2,D.IExtHostRpcService)],C)}),define(be[220],Ee([0,1,12,16,75,6,2,5,213,15,57,61,29,142,13,66,33,40]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(f,S,i,g){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new D.RPCProtocol(f,null,g),S=w._transform(S,this._rpcProtocol);const a=new _.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());a.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...S}),a.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),a.set(u.IURITransformerService,new u.URITransformerService(g)),a.set(p.IHostUtils,i);const r=new m.InstantiationService(a,!0),v=r.invokeFunction(h=>h.get(C.IExtHostTerminalService));this._disposables.add(v),this._logService=r.invokeFunction(h=>h.get(T.ILogService)),E.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",S),this._extensionService=r.invokeFunction(h=>h.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(y,R)=>{let k="",O,N;for(const I of R)k+=`
	at ${I.toString()}`,N=I.getFileName(),!O&&N&&(O=h.findSubstr(F.URI.file(N)));return l.set(y,O),`${y.name||"Error"}: ${y.message||""}${k}`}});const c=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(h=>{const y=M.transformErrorForSerialization(h),R=l.get(h);R?c.$onExtensionRuntimeError(R.identifier,y):b.$onUnexpectedError(y)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const S=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),S]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,S){f.extensions.forEach(g=>g.extensionLocation=F.URI.revive(S.transformIncomingURIs(g.extensionLocation))),f.environment.appRoot=F.URI.revive(S.transformIncomingURIs(f.environment.appRoot));const i=f.environment.extensionDevelopmentLocationURI;return i&&(f.environment.extensionDevelopmentLocationURI=i.map(g=>F.URI.revive(S.transformIncomingURIs(g)))),f.environment.extensionTestsLocationURI=F.URI.revive(S.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=F.URI.revive(S.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=F.URI.revive(S.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=F.URI.revive(S.transformIncomingURIs(f.logsLocation)),f.logFile=F.URI.revive(S.transformIncomingURIs(f.logFile)),f.workspace=S.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=w}),define(be[221],Ee([0,1,17,21,45,27,24,194,41]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(n,m,s){this.config=n,this.provider=m,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const m=this.config.folderQueries||[];return new Promise((s,u)=>{const p=C=>{this.resultCount++,n(C)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(C=>{const w=C.toString(),o=d.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,o)||this.matchFile(p,{base:C,basename:o})}),Promise.all(m.map(C=>this.searchInFolder(C,p))).then(C=>{s({limitHit:this.isLimitHit,stats:C[0]||void 0})},C=>{u(new Error((0,E.toErrorMessage)(C)))})})}async searchInFolder(n,m){const s=new M.CancellationTokenSource,u=this.getSearchOptionsForFolder(n),p=this.initDirectoryTree(),C=new D.QueryGlobTester(this.config,n),w=!C.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(s),o=P.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,s.token),S=o.elapsed(),i=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(g=>{const a=d.posix.relative(n.folder.path,g.path);if(w){const r=d.basename(g.path);this.matchFile(m,{base:n.folder,relativePath:a,basename:r});return}this.addDirectoryEntries(p,n.folder,a,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,C,m),{providerTime:S,postProcessTime:i.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const m=(0,D.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,D.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:m,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},m,s,u){if(s===this.filePattern){const C=d.basename(this.filePattern);this.matchFile(u,{base:m,relativePath:this.filePattern,basename:C})}function p(C){const w=d.basename(C),o=d.dirname(C);let f=n[o];f||(f=n[o]=[],p(o)),f.push({base:m,relativePath:C,basename:w})}p(s)}matchDirectoryTree({rootEntries:n,pathToEntries:m},s,u){const p=this,C=this.filePattern;function w(o){const f=A.hasSiblingFn(()=>o.map(S=>S.basename));for(let S=0,i=o.length;S<i;S++){const g=o[S],{relativePath:a,basename:r}=g;if(s.matchesExcludesSync(a,r,C!==r?f:void 0))continue;const v=m[a];if(v)w(v);else{if(a===C)continue;p.matchFile(u,g)}if(p.isLimitHit)break}}w(n)}matchFile(n,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(m))}}class t{constructor(){this.sessions=new Map}fileSearch(n,m,s,u){const p=this.getSessionTokenSource(n.cacheKey),C=new T(n,m,p&&p.token);let w=0;const o=f=>{w+=f.length,s(f.map(S=>this.rawMatchToSearchItem(S)))};return this.doSearch(C,t.BATCH_SIZE,o,u).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:f.stats}}))}clearCache(n){const m=this.getSessionTokenSource(n);m&&m.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,m,s,u){u.onCancellationRequested(()=>{n.cancel()});const p=w=>{w&&(C.push(w),m>0&&C.length>=m&&(s(C),C=[]))};let C=[];return n.search(p).then(w=>(C.length&&s(C),w),w=>(C.length&&s(C),Promise.reject(w)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[222],Ee([0,1,14,21,45,27,11,17,24,10,2,41]),function(oe,e,d,M,E,A,F,P,D,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,f,S,i){this.query=o,this.provider=f,this.fileUtils=S,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,f){const S=this.query.folderQueries||[],i=new M.CancellationTokenSource;return f.onCancellationRequested(()=>i.cancel()),new Promise((g,a)=>{this.collector=new s(o);let r=!1;const v=(l,c)=>{if(!r&&!this.isLimitHit){const b=this.resultSize(l);p(l)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,r=!0,i.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const h=this.resultSize(l);this.resultCount+=h,(h>0||!p(l))&&this.collector.add(l,c)}};Promise.all(S.map((l,c)=>this.searchInFolder(l,b=>v(b,c),i.token))).then(l=>{i.dispose(),this.collector.flush();const c=l.some(b=>!!b&&!!b.limitHit);g({limitHit:this.isLimitHit||c,messages:(0,d.flatten)(l.map(b=>b?.message?(0,T.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},l=>{i.dispose();const c=(0,E.toErrorMessage)(l);a(new Error(c))})})}resultSize(o){return p(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,f){const S=Array.isArray(o.ranges)?o.ranges:[o.ranges],i=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:S.slice(0,f),preview:{matches:i.slice(0,f),text:o.preview.text},uri:o.uri}}async searchInFolder(o,f,S){const i=new _.QueryGlobTester(this.query,o),g=[],a={report:l=>{if(!this.validateProviderResult(l))return;const c=o.folder.scheme===F.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(l.uri))):void 0,b=D.relativePath(o.folder,l.uri);if(b){const h=i.includedInQuery(b,P.basename(b),c);(0,T.isPromise)(h)?g.push(h.then(y=>{y&&f(l)})):h&&f(l)}}},r=this.getSearchOptionsForFolder(o),v=await this.provider.provideTextSearchResults(m(this.query.contentPattern),r,a,S);return g.length&&await Promise.all(g),v}validateProviderResult(o){if(p(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const f=(0,_.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),S=(0,_.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),i={folder:t.URI.from(o.folder),excludes:S,includes:f,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function m(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class s{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new C(512,f=>this.sendItems(f))}add(o,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!D.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(u(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=s;function u(w){return p(w)?{preview:{matches:(0,d.mapArrayOrNot)(w.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:w.preview.text},ranges:(0,d.mapArrayOrNot)(w.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function p(w){return!!w.preview}e.extensionResultIsMatch=p;class C{constructor(o,f){this.maxBatchSize=o,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,f){!o||this.addItemToBatch(o,f)}addItems(o,f){!o||this.addItemsToBatch(o,f)}addItemToBatch(o,f){this.batch.push(o),this.batchSize+=f,this.onUpdate()}addItemsToBatch(o,f){this.batch=this.batch.concat(o),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<C.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},C.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=C,C.TIMEOUT=4e3,C.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,221,13,66,15,2,222]),function(oe,e,d,M,E,A,F,P,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let _=class{constructor(u,p,C){this.extHostRpc=u,this._uriTransformer=p,this._logService=C,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,p){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const C=this._handlePool++;return this._textSearchProvider.set(C,p),this._proxy.$registerTextSearchProvider(C,this._transformScheme(u)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(C),this._proxy.$unregisterProvider(C)})}registerFileSearchProvider(u,p){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const C=this._handlePool++;return this._fileSearchProvider.set(C,p),this._proxy.$registerFileSearchProvider(C,this._transformScheme(u)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(C),this._proxy.$unregisterProvider(C)})}$provideFileSearchResults(u,p,C,w){const o=n(C),f=this._fileSearchProvider.get(u);if(f)return this._fileSearchManager.fileSearch(o,f,S=>{this._proxy.$handleFileMatch(u,p,S.map(i=>i.resource))},w);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,p,C,w){const o=this._textSearchProvider.get(u);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const f=n(C);return this.createTextSearchManager(f,o).search(i=>this._proxy.$handleTextMatch(u,p,i),w)}$enableExtensionHostSearch(){}createTextSearchManager(u,p){return new t.TextSearchManager(u,p,{readdir:C=>Promise.resolve([]),toCanonicalName:C=>C},"textSearchProvider")}};_=$e([ze(0,F.IExtHostRpcService),ze(1,P.IURITransformerService),ze(2,D.ILogService)],_),e.ExtHostSearch=_;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(m),extraFileResources:s.extraFileResources&&s.extraFileResources.map(u=>T.URI.revive(u))}}e.reviveQuery=n;function m(s){return{...s,folder:T.URI.revive(s.folder)}}}),define(be[223],Ee([0,1,21,16,3,35,2,116,80,112,56,60,5,184,183,39,185,32,186,187,188,170,189,50,33,190,171,193,195,196,96,173,201,202,203,73,40,205,174,8,7,208,51,97,31,30,52,159,192,63,95,99,100,101,15,66,13,29,197,156,65,70,181,206,155,74,72,211,209,210,182,37,204,207,69,71,87,199,98,200,11,144,198,153,191]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w,o,f,S,i,g,a,r,v,l,c,b,h,y,R,k,O,N,I,B,x,V,H,W,ee,q,Y,j,le,re,ve,Fe,Me,Oe,Ke,qe,Ve,$,Q,te,ae,K,se,he,Ae,Ue,He,Qe,et,st,ye,nt,G,Z,pe,We,Ye,rt,mt,ut,St,Tt,It,Xe,vt,Pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(ie){const ue=ie.get(te.IExtHostInitDataService),me=ie.get(Z.IExtHostFileSystemInfo),fe=ie.get(et.IExtHostConsumerFileSystem),Ie=ie.get(a.IExtHostExtensionService),Be=ie.get(Y.IExtHostWorkspace),Ne=ie.get(mt.IExtHostTelemetry),je=ie.get(C.IExtHostConfiguration),it=ie.get($.IURITransformerService),Le=ie.get(Q.IExtHostRpcService),de=ie.get(N.IExtHostStorage),ge=ie.get(Qe.IExtensionStoragePaths),X=ie.get(Ve.ILogService),z=ie.get(se.IExtHostTunnelService),we=ie.get(he.IExtHostApiDeprecationService),ke=ie.get(q.IExtHostWindow),Je=ie.get(Ye.IExtHostSecretState),xe=ie.get(rt.IExtHostEditorTabs);Le.set(n.ExtHostContext.ExtHostFileSystemInfo,me),Le.set(n.ExtHostContext.ExtHostLogService,X),Le.set(n.ExtHostContext.ExtHostWorkspace,Be),Le.set(n.ExtHostContext.ExtHostConfiguration,je),Le.set(n.ExtHostContext.ExtHostExtensionService,Ie),Le.set(n.ExtHostContext.ExtHostStorage,de),Le.set(n.ExtHostContext.ExtHostTunnelService,z),Le.set(n.ExtHostContext.ExtHostWindow,ke),Le.set(n.ExtHostContext.ExtHostSecretState,Je),Le.set(n.ExtHostContext.ExtHostTelemetry,Ne),Le.set(n.ExtHostContext.ExtHostEditorTabs,xe);const ct=Le.set(n.ExtHostContext.ExtHostDecorations,ie.get(Me.IExtHostDecorations)),pt=Le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ie.get(g.IExtHostDocumentsAndEditors)),dt=Le.set(n.ExtHostContext.ExtHostCommands,ie.get(u.IExtHostCommands)),ht=Le.set(n.ExtHostContext.ExtHostTerminalService,ie.get(I.IExtHostTerminalService)),ft=Le.set(n.ExtHostContext.ExtHostDebugService,ie.get(Ke.IExtHostDebugService)),_t=Le.set(n.ExtHostContext.ExtHostSearch,ie.get(qe.IExtHostSearch)),yt=Le.set(n.ExtHostContext.ExtHostTask,ie.get(Oe.IExtHostTask)),Pt=Le.set(n.ExtHostContext.ExtHostOutputService,ie.get(h.IExtHostOutputService)),Nt=Le.set(n.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(Le)),Ct=Le.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Le,pt)),xt=Le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(Le,pt,X)),$t=Le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new S.ExtHostDocumentSaveParticipant(X,Ct,Le.getProxy(n.MainContext.MainThreadBulkEdits))),bt=Le.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Le,dt,pt,Ct,ge)),Qt=Le.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(X,bt)),zt=Le.set(n.ExtHostContext.ExtHostNotebookEditors,new vt.ExtHostNotebookEditors(X,Le,bt)),ii=Le.set(n.ExtHostContext.ExtHostNotebookKernels,new ut.ExtHostNotebookKernels(Le,ue,bt,dt,X)),ni=Le.set(n.ExtHostContext.ExtHostNotebookRenderers,new Tt.ExtHostNotebookRenderers(Le,bt)),At=Le.set(n.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(Le,pt)),Yt=Le.set(n.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(Le.getProxy(n.MainContext.MainThreadTreeViews),dt,X)),ri=Le.set(n.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Le.getProxy(n.MainContext.MainThreadEditorInsets),At,ue)),Jt=Le.set(n.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Le,X,me)),Wt=Le.set(n.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Le,Ct,dt.converter,it)),gt=Le.set(n.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Le,it,Ct,dt,Jt,X,we)),si=Le.set(n.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Le,gt)),Mt=Le.set(n.ExtHostContext.ExtHostFileSystemEventService,new v.ExtHostFileSystemEventService(Le,X,pt)),Vt=Le.set(n.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(Le,Be,dt)),Xt=Le.set(n.ExtHostContext.ExtHostSCM,new k.ExtHostSCM(Le,dt,X)),oi=Le.set(n.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(Le,dt,Ct)),di=Le.set(n.ExtHostContext.ExtHostProgress,new y.ExtHostProgress(Le.getProxy(n.MainContext.MainThreadProgress))),wi=Le.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Le)),hi=Le.set(n.ExtHostContext.ExtHostTheming,new K.ExtHostTheming(Le)),Zt=Le.set(n.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(Le)),bi=Le.set(n.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(Le,dt)),qt=Le.set(n.ExtHostContext.ExtHostWebviews,new ee.ExtHostWebviews(Le,{remote:ue.remote},Be,X,we)),jt=Le.set(n.ExtHostContext.ExtHostWebviewPanels,new nt.ExtHostWebviewPanels(Le,qt,Be)),Ei=Le.set(n.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Le,Ct,ge,qt,jt)),_i=Le.set(n.ExtHostContext.ExtHostWebviewViews,new st.ExtHostWebviewViews(Le,qt)),Gt=Le.set(n.ExtHostContext.ExtHostTesting,new pe.ExtHostTesting(Le,dt)),yi=Le.set(n.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Le));Le.set(n.ExtHostContext.ExtHostInteractive,new Se.ExtHostInteractive(Le,bt,pt,dt));const ei=(0,le.values)(n.ExtHostContext);Le.assertRegistered(ei);const Si=new G.ExtHostBulkEdits(Le,pt),Di=new s.ExtHostClipboard(Le),Kt=new b.ExtHostMessageService(Le,X),fi=new o.ExtHostDialogs(Le),Ht=new O.ExtHostStatusBar(Le,dt.converter);return m.ExtHostApiCommands.register(dt),function(Te,ai,Ft){const wt=function(){let J=!Te.isUnderDevelopment;function ce(De){J||(X.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function De(at){if(Array.isArray(at))at.forEach(De);else if(typeof at=="string")ce(at);else{const Et=at;typeof Et.scheme=="undefined"&&ce(at),!Te.enableProposedApi&&typeof Et.exclusive=="boolean"&&(0,j.throwProposedApiError)(Te)}return at}}(),Ci={getSession(J,ce,De){return(De?.forceNewSession||De?.silent)&&(0,j.checkProposedApiEnabled)(Te),Zt.getSession(Te,J,ce,De)},async hasSession(J,ce){return(0,j.checkProposedApiEnabled)(Te),!!await Zt.getSession(Te,J,ce,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(J,ce,De,at){return Zt.registerAuthenticationProvider(J,ce,De,at)}},ki={registerCommand(J,ce,De){return dt.registerCommand(!0,J,ce,De,void 0,Te)},registerTextEditorCommand(J,ce,De){return dt.registerCommand(!0,J,(...at)=>{const Et=At.getActiveTextEditor();if(!Et){X.warn("Cannot execute "+J+" because there is no active text editor.");return}return Et.edit(kt=>{ce.apply(De,[Et,kt,...at])}).then(kt=>{kt||X.warn("Edits from command "+J+" were not applied.")},kt=>{X.warn("An error occurred while running command "+J,kt)})},void 0,void 0,Te)},registerDiffInformationCommand:(J,ce,De)=>((0,j.checkProposedApiEnabled)(Te),dt.registerCommand(!0,J,async(...at)=>{const Et=pt.activeEditor(!0);if(!Et){X.warn("Cannot execute "+J+" because there is no active text editor.");return}const kt=await At.getDiffInformation(Et.id);ce.apply(De,[kt,...at])},void 0,void 0,Te)),executeCommand(J,...ce){return dt.executeCommand(J,...ce)},getCommands(J=!1){return dt.getCommands(J)}},mi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return ht.getDefaultShell(!1)},get isTelemetryEnabled(){return Ne.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ne.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ce){return ke.openUri(J,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===ue.environment.appUriScheme)return Nt.createAppUri(J);try{return await ke.asExternalUri(J,{allowTunneling:!!ue.remote.authority})}catch(ce){if((0,Xe.matchesScheme)(J,It.Schemas.http)||(0,Xe.matchesScheme)(J,It.Schemas.https))return J;throw ce}},get remoteName(){return(0,Fe.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,j.checkProposedApiEnabled)(Te),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ue.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ii={createTestController(J,ce){return Gt.createTestController(J,ce)},createTestObserver(){return(0,j.checkProposedApiEnabled)(Te),Gt.createTestObserver()},runTests(J){return(0,j.checkProposedApiEnabled)(Te),Gt.runTests(J)},get onDidChangeTestResults(){return(0,j.checkProposedApiEnabled)(Te),Gt.onResultsChanged},get testResults(){return(0,j.checkProposedApiEnabled)(Te),Gt.results}},Pi={getExtension(J){const ce=ai.getExtensionDescription(J);if(ce)return new a.Extension(Ie,Te.identifier,ce,gi)},get all(){return ai.getAllExtensionDescriptions().map(J=>new a.Extension(Ie,Te.identifier,J,gi))},get onDidChange(){return ai.onDidChange}},Ti={createDiagnosticCollection(J){return Jt.createDiagnosticCollection(Te.identifier,J)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:J=>Jt.getDiagnostics(J),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(J,ce){return Wt.changeLanguage(J.uri,ce)},match(J,ce){return(0,t.score)(V.LanguageSelector.from(J),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(J,ce,De){return gt.registerCodeActionProvider(Te,wt(J),ce,De)},registerCodeLensProvider(J,ce){return gt.registerCodeLensProvider(Te,wt(J),ce)},registerDefinitionProvider(J,ce){return gt.registerDefinitionProvider(Te,wt(J),ce)},registerDeclarationProvider(J,ce){return gt.registerDeclarationProvider(Te,wt(J),ce)},registerImplementationProvider(J,ce){return gt.registerImplementationProvider(Te,wt(J),ce)},registerTypeDefinitionProvider(J,ce){return gt.registerTypeDefinitionProvider(Te,wt(J),ce)},registerHoverProvider(J,ce){return gt.registerHoverProvider(Te,wt(J),ce,Te.identifier)},registerEvaluatableExpressionProvider(J,ce){return gt.registerEvaluatableExpressionProvider(Te,wt(J),ce,Te.identifier)},registerInlineValuesProvider(J,ce){return gt.registerInlineValuesProvider(Te,wt(J),ce,Te.identifier)},registerDocumentHighlightProvider(J,ce){return gt.registerDocumentHighlightProvider(Te,wt(J),ce)},registerLinkedEditingRangeProvider(J,ce){return gt.registerLinkedEditingRangeProvider(Te,wt(J),ce)},registerReferenceProvider(J,ce){return gt.registerReferenceProvider(Te,wt(J),ce)},registerRenameProvider(J,ce){return gt.registerRenameProvider(Te,wt(J),ce)},registerDocumentSymbolProvider(J,ce,De){return gt.registerDocumentSymbolProvider(Te,wt(J),ce,De)},registerWorkspaceSymbolProvider(J){return gt.registerWorkspaceSymbolProvider(Te,J)},registerDocumentFormattingEditProvider(J,ce){return gt.registerDocumentFormattingEditProvider(Te,wt(J),ce)},registerDocumentRangeFormattingEditProvider(J,ce){return gt.registerDocumentRangeFormattingEditProvider(Te,wt(J),ce)},registerOnTypeFormattingEditProvider(J,ce,De,...at){return gt.registerOnTypeFormattingEditProvider(Te,wt(J),ce,[De].concat(at))},registerDocumentSemanticTokensProvider(J,ce,De){return gt.registerDocumentSemanticTokensProvider(Te,wt(J),ce,De)},registerDocumentRangeSemanticTokensProvider(J,ce,De){return gt.registerDocumentRangeSemanticTokensProvider(Te,wt(J),ce,De)},registerSignatureHelpProvider(J,ce,De,...at){return typeof De=="object"?gt.registerSignatureHelpProvider(Te,wt(J),ce,De):gt.registerSignatureHelpProvider(Te,wt(J),ce,typeof De=="undefined"?[]:[De,...at])},registerCompletionItemProvider(J,ce,...De){return gt.registerCompletionItemProvider(Te,wt(J),ce,De)},registerInlineCompletionItemProvider(J,ce){return(0,j.checkProposedApiEnabled)(Te),gt.registerInlineCompletionsProvider(Te,wt(J),ce)},registerDocumentLinkProvider(J,ce){return gt.registerDocumentLinkProvider(Te,wt(J),ce)},registerColorProvider(J,ce){return gt.registerColorProvider(Te,wt(J),ce)},registerFoldingRangeProvider(J,ce){return gt.registerFoldingRangeProvider(Te,wt(J),ce)},registerSelectionRangeProvider(J,ce){return gt.registerSelectionRangeProvider(Te,J,ce)},registerCallHierarchyProvider(J,ce){return gt.registerCallHierarchyProvider(Te,J,ce)},registerTypeHierarchyProvider(J,ce){return gt.registerTypeHierarchyProvider(Te,J,ce)},setLanguageConfiguration:(J,ce)=>gt.setLanguageConfiguration(Te,J,ce),getTokenInformationAtPosition(J,ce){return(0,j.checkProposedApiEnabled)(Te),Wt.tokenAtPosition(J,ce)},registerInlayHintsProvider(J,ce){return(0,j.checkProposedApiEnabled)(Te),gt.registerInlayHintsProvider(Te,J,ce)},createLanguageStatusItem(J,ce){return(0,j.checkProposedApiEnabled)(Te),Wt.createLanguageStatusItem(Te,J,ce)}},li={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(J,ce,De){const at=await(F.URI.isUri(J)?Promise.resolve(pi.openTextDocument(J)):Promise.resolve(J));return At.showTextDocument(at,ce,De)},createTextEditorDecorationType(J){return At.createTextEditorDecorationType(Te,J)},onDidChangeActiveTextEditor(J,ce,De){return At.onDidChangeActiveTextEditor(J,ce,De)},onDidChangeVisibleTextEditors(J,ce,De){return At.onDidChangeVisibleTextEditors(J,ce,De)},onDidChangeTextEditorSelection(J,ce,De){return At.onDidChangeTextEditorSelection(J,ce,De)},onDidChangeTextEditorOptions(J,ce,De){return At.onDidChangeTextEditorOptions(J,ce,De)},onDidChangeTextEditorVisibleRanges(J,ce,De){return At.onDidChangeTextEditorVisibleRanges(J,ce,De)},onDidChangeTextEditorViewColumn(J,ce,De){return At.onDidChangeTextEditorViewColumn(J,ce,De)},onDidCloseTerminal(J,ce,De){return ht.onDidCloseTerminal(J,ce,De)},onDidOpenTerminal(J,ce,De){return ht.onDidOpenTerminal(J,ce,De)},onDidChangeActiveTerminal(J,ce,De){return ht.onDidChangeActiveTerminal(J,ce,De)},onDidChangeTerminalDimensions(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),ht.onDidChangeTerminalDimensions(J,ce,De)},onDidChangeTerminalState(J,ce,De){return ht.onDidChangeTerminalState(J,ce,De)},onDidWriteTerminalData(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),ht.onDidWriteTerminalData(J,ce,De)},get state(){return ke.state},onDidChangeWindowState(J,ce,De){return ke.onDidChangeWindowState(J,ce,De)},showInformationMessage(J,...ce){return Kt.showMessage(Te,A.default.Info,J,ce[0],ce.slice(1))},showWarningMessage(J,...ce){return Kt.showMessage(Te,A.default.Warning,J,ce[0],ce.slice(1))},showErrorMessage(J,...ce){return Kt.showMessage(Te,A.default.Error,J,ce[0],ce.slice(1))},showQuickPick(J,ce,De){return Vt.showQuickPick(J,!!Te.enableProposedApi,ce,De)},showWorkspaceFolderPick(J){return Vt.showWorkspaceFolderPick(J)},showInputBox(J,ce){return Vt.showInput(J,ce)},showOpenDialog(J){return fi.showOpenDialog(J)},showSaveDialog(J){return fi.showSaveDialog(J)},createStatusBarItem(J,ce,De){let at,Et,kt;return typeof J=="string"?(at=J,Et=ce,kt=De):(Et=J,kt=ce),Ht.createStatusBarEntry(Te,at,Et,kt)},setStatusBarMessage(J,ce){return Ht.setStatusBarMessage(J,ce)},withScmProgress(J){return we.report("window.withScmProgress",Te,"Use 'withProgress' instead."),di.withProgress(Te,{location:H.ProgressLocation.SourceControl},(ce,De)=>J({report(at){}}))},withProgress(J,ce){return di.withProgress(Te,J,ce)},createOutputChannel(J){return Pt.createOutputChannel(J,Te)},createWebviewPanel(J,ce,De,at){return jt.createWebviewPanel(Te,J,ce,De,at)},createWebviewTextEditorInset(J,ce,De,at){return(0,j.checkProposedApiEnabled)(Te),ri.createWebviewEditorInset(J,ce,De,at,Te)},createTerminal(J,ce,De){return typeof J=="object"?("location"in J&&(0,j.checkProposedApiEnabled)(Te),"pty"in J?ht.createExtensionTerminal(J):ht.createTerminalFromOptions(J)):ht.createTerminal(J,ce,De)},registerTerminalLinkProvider(J){return ht.registerLinkProvider(J)},registerTerminalProfileProvider(J,ce){return ht.registerProfileProvider(Te,J,ce)},registerTreeDataProvider(J,ce){return Yt.registerTreeDataProvider(J,ce,Te)},createTreeView(J,ce){return Yt.createTreeView(J,ce,Te)},registerWebviewPanelSerializer:(J,ce)=>jt.registerWebviewPanelSerializer(Te,J,ce),registerCustomEditorProvider:(J,ce,De={})=>Ei.registerCustomEditorProvider(Te,J,ce,De),registerFileDecorationProvider(J){return ct.registerFileDecorationProvider(J,Te.identifier)},registerUriHandler(J){return Nt.registerUriHandler(Te.identifier,J)},createQuickPick(){return Vt.createQuickPick(Te.identifier,!!Te.enableProposedApi)},createInputBox(){return Vt.createInputBox(Te.identifier)},get activeColorTheme(){return hi.activeColorTheme},onDidChangeActiveColorTheme(J,ce,De){return hi.onDidChangeActiveColorTheme(J,ce,De)},registerWebviewViewProvider(J,ce,De){return _i.registerWebviewViewProvider(Te,J,ce,De?.webviewOptions)},get activeNotebookEditor(){return(0,j.checkProposedApiEnabled)(Te),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeActiveNotebookEditor(J,ce,De)},get visibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Te),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),zt.onDidChangeNotebookEditorSelection(J,ce,De)},onDidChangeNotebookEditorVisibleRanges(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),zt.onDidChangeNotebookEditorVisibleRanges(J,ce,De)},showNotebookDocument(J,ce){return(0,j.checkProposedApiEnabled)(Te),bt.showNotebookDocument(J,ce)},registerExternalUriOpener(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),yi.registerExternalUriOpener(Te.identifier,J,ce,De)},get tabs(){return(0,j.checkProposedApiEnabled)(Te),xe.tabs},get activeTab(){return(0,j.checkProposedApiEnabled)(Te),xe.activeTab},get onDidChangeTabs(){return(0,j.checkProposedApiEnabled)(Te),xe.onDidChangeTabs},get onDidChangeActiveTab(){return(0,j.checkProposedApiEnabled)(Te),xe.onDidChangeActiveTab},getInlineCompletionItemController(J){return(0,j.checkProposedApiEnabled)(Te),l.InlineCompletionController.get(J)}},pi={get rootPath(){return we.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(J){throw M.readonly()},getWorkspaceFolder(J){return Be.getWorkspaceFolder(J)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(J){throw M.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(J){throw M.readonly()},updateWorkspaceFolders:(J,ce,...De)=>Be.updateWorkspaceFolders(Te,J,ce||0,...De),onDidChangeWorkspaceFolders:function(J,ce,De){return Be.onDidChangeWorkspace(J,ce,De)},asRelativePath:(J,ce)=>Be.getRelativePath(J,ce),findFiles:(J,ce,De,at)=>Be.findFiles(V.GlobPattern.from(J),V.GlobPattern.from(ce),De,Te.identifier,at),findTextInFiles:(J,ce,De,at)=>{let Et,kt;return typeof ce=="object"?(Et=ce,kt=De):(Et={},kt=ce,at=De),Be.findTextInFiles(J,Et||{},kt,Te.identifier,at)},saveAll:J=>Be.saveAll(J),applyEdit(J){return Si.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ce,De,at)=>Mt.createFileSystemWatcher(V.GlobPattern.from(J),ce,De,at),get textDocuments(){return Ct.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw M.readonly()},openTextDocument(J){let ce;const De=J;if(typeof J=="string")ce=Promise.resolve(F.URI.file(J));else if(F.URI.isUri(J))ce=Promise.resolve(J);else if(!De||typeof De=="object")ce=Ct.createDocumentData(De);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(at=>Ct.ensureDocumentData(at).then(Et=>Et.document))},onDidOpenTextDocument:(J,ce,De)=>Ct.onDidAddDocument(J,ce,De),onDidCloseTextDocument:(J,ce,De)=>Ct.onDidRemoveDocument(J,ce,De),onDidChangeTextDocument:(J,ce,De)=>Ct.onDidChangeDocument(J,ce,De),onDidSaveTextDocument:(J,ce,De)=>Ct.onDidSaveDocument(J,ce,De),onWillSaveTextDocument:(J,ce,De)=>$t.getOnWillSaveTextDocumentEvent(Te)(J,ce,De),get notebookDocuments(){return bt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ce){let De;if(F.URI.isUri(J))De=J,await bt.openNotebookDocument(J);else if(typeof J=="string")De=F.URI.revive(await bt.createNotebookDocument({viewType:J,content:ce}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(De).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(J,ce,De,at){return bt.registerNotebookSerializer(Te,J,ce,De,Te.enableProposedApi?at:void 0)},registerNotebookContentProvider:(J,ce,De,at)=>((0,j.checkProposedApiEnabled)(Te),bt.registerNotebookContentProvider(Te,J,ce,De,Te.enableProposedApi?at:void 0)),onDidChangeConfiguration:(J,ce,De)=>Ft.onDidChangeConfiguration(J,ce,De),getConfiguration(J,ce){return ce=arguments.length===1?void 0:ce,Ft.getConfiguration(J,ce,Te)},registerTextDocumentContentProvider(J,ce){return xt.registerTextDocumentContentProvider(J,ce)},registerTaskProvider:(J,ce)=>(we.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Te,J,ce)),registerFileSystemProvider(J,ce,De){return si.registerFileSystemProvider(Te.identifier,J,ce,De)},get fs(){return fe.value},registerFileSearchProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),_t.registerFileSearchProvider(J,ce)),registerTextSearchProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),_t.registerTextSearchProvider(J,ce)),registerRemoteAuthorityResolver:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),Ie.registerRemoteAuthorityResolver(J,ce)),registerResourceLabelFormatter:J=>((0,j.checkProposedApiEnabled)(Te),wi.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ce,De)=>Mt.onDidCreateFile(J,ce,De),onDidDeleteFiles:(J,ce,De)=>Mt.onDidDeleteFile(J,ce,De),onDidRenameFiles:(J,ce,De)=>Mt.onDidRenameFile(J,ce,De),onWillCreateFiles:(J,ce,De)=>Mt.getOnWillCreateFileEvent(Te)(J,ce,De),onWillDeleteFiles:(J,ce,De)=>Mt.getOnWillDeleteFileEvent(Te)(J,ce,De),onWillRenameFiles:(J,ce,De)=>Mt.getOnWillRenameFileEvent(Te)(J,ce,De),openTunnel:J=>((0,j.checkProposedApiEnabled)(Te),z.openTunnel(Te,J).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,j.checkProposedApiEnabled)(Te),z.getTunnels()},onDidChangeTunnels:(J,ce,De)=>((0,j.checkProposedApiEnabled)(Te),z.onDidChangeTunnels(J,ce,De)),registerPortAttributesProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),z.registerPortsAttributesProvider(J,ce)),registerTimelineProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),bi.registerTimelineProvider(J,ce,Te.identifier,dt.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:J=>((0,j.checkProposedApiEnabled)(Te),Be.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ce,De)=>Be.onDidGrantWorkspaceTrust(J,ce,De)},Ai={get inputBox(){return we.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Te)},createSourceControl(J,ce,De){return Xt.createSourceControl(Te,J,ce,De)}},Ri={createCommentController(J,ce){return oi.createCommentController(Te,J,ce)}},Fi={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(J,ce,De){return ft.onDidStartDebugSession(J,ce,De)},onDidTerminateDebugSession(J,ce,De){return ft.onDidTerminateDebugSession(J,ce,De)},onDidChangeActiveDebugSession(J,ce,De){return ft.onDidChangeActiveDebugSession(J,ce,De)},onDidReceiveDebugSessionCustomEvent(J,ce,De){return ft.onDidReceiveDebugSessionCustomEvent(J,ce,De)},onDidChangeBreakpoints(J,ce,De){return ft.onDidChangeBreakpoints(J,ce,De)},registerDebugConfigurationProvider(J,ce,De){return ft.registerDebugConfigurationProvider(J,ce,De||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ce){return ft.registerDebugAdapterDescriptorFactory(Te,J,ce)},registerDebugAdapterTrackerFactory(J,ce){return ft.registerDebugAdapterTrackerFactory(J,ce)},startDebugging(J,ce,De){return!De||typeof De=="object"&&"configuration"in De?ft.startDebugging(J,ce,{parentSession:De}):ft.startDebugging(J,ce,De||{})},stopDebugging(J){return ft.stopDebugging(J)},addBreakpoints(J){return ft.addBreakpoints(J)},removeBreakpoints(J){return ft.removeBreakpoints(J)},asDebugSourceUri(J,ce){return ft.asDebugSourceUri(J,ce)}},Mi={registerTaskProvider:(J,ce)=>yt.registerTaskProvider(Te,J,ce),fetchTasks:J=>yt.fetchTasks(J),executeTask:J=>yt.executeTask(Te,J),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(J,ce,De)=>yt.onDidStartTask(J,ce,De),onDidEndTask:(J,ce,De)=>yt.onDidEndTask(J,ce,De),onDidStartTaskProcess:(J,ce,De)=>yt.onDidStartTaskProcess(J,ce,De),onDidEndTaskProcess:(J,ce,De)=>yt.onDidEndTaskProcess(J,ce,De)},Li={createNotebookController(J,ce,De,at,Et){return ii.createNotebookController(Te,J,ce,De,at,Te.enableProposedApi?Et:void 0)},registerNotebookCellStatusBarItemProvider:(J,ce)=>bt.registerNotebookCellStatusBarItemProvider(Te,J,ce),get onDidSaveNotebookDocument(){return(0,j.checkProposedApiEnabled)(Te),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,j.checkProposedApiEnabled)(Te),zt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return ni.createRendererMessaging(Te,J)},onDidChangeNotebookDocumentMetadata(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),Qt.onDidChangeNotebookDocumentMetadata(J,ce,De)},onDidChangeNotebookCells(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeNotebookCells(J,ce,De)},onDidChangeNotebookCellExecutionState(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeNotebookCellExecutionState(J,ce,De)},onDidChangeCellOutputs(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeCellOutputs(J,ce,De)},onDidChangeCellMetadata(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeCellMetadata(J,ce,De)},createConcatTextDocument(J,ce){return(0,j.checkProposedApiEnabled)(Te),new He.ExtHostNotebookConcatDocument(bt,Ct,J,ce)}};return{version:ue.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:Ti,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:li,workspace:pi,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:T.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:St.TextSearchCompleteMessageType,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(be[224],Ee([0,1,57,96,31,95,32,39,50,40,99,100,101,73,65,70,97,72,37,69,87,71]),function(oe,e,d,M,E,A,F,P,D,T,t,_,n,m,s,u,p,C,w,o,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,d.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,d.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,d.registerSingleton)(C.IExtHostConsumerFileSystem,C.ExtHostConsumerFileSystem),(0,d.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,d.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,d.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,d.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,d.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,d.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,d.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,d.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,d.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,d.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,d.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,d.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,d.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs)}),define(be[225],Ee([0,1,223,33,219,7,12,5,11]),function(oe,e,d,M,E,A,F,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var T;(function(s){const u=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(C,...w)=>{w.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const o=w.slice(0,-1).join(","),f=w.pop().toString();return`(function anonymous(${o}) {${f}
})`}});function p(...C){return u?self.eval(u.createScript("",...C)):new Function(...C)}s.create=p})(T||(T={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(u,p){for(let C of this._alternatives){let w=C(u);if(w){u=w;break}}if(this._factories.has(u))return this._factories.get(u).load(u,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const u=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);m(u,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(u){return u.browser}async _loadCommonJSModule(u,p,C){p=p.with({path:n(p.path,".js")}),u&&performance.mark(`code/extHost/willFetchExtensionCode/${u.value}`);const w=await fetch(D.FileAccess.asBrowserUri(p).toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u.value}`),w.status!==200)throw new Error(w.statusText);const o=await w.text(),f=`${p.toString(!0)}#vscode-extension`,S=`${o}
//# sourceURL=${f}`;let i;try{i=T.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(S)??S)}catch(v){throw console.error(u?`Loading code for extension ${u.value} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${p.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}const g={},a={exports:g},r=v=>{const l=this._fakeModules.getModule(v,p);if(l===void 0)throw new Error(`Cannot load module '${v}'`);return l};try{return C.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u.value}`),i(a,g,r),a.exports!==g?a.exports:g}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u.value}`),C.codeLoadingStop()}}async $setRemoteEnvironment(u){}async _waitForDebuggerAttachment(u=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+u;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:s=>s});function n(s,u){return s.endsWith(u)?s:s+u}function m(s,u){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(o,f){const S=console[o];console[o]=function(){s.$logExtensionHostMessage({type:"__$console",severity:f,arguments:w(arguments)}),u&&S.apply(console,arguments)}}const C=1e5;function w(o){const f=[],S=[];if(o.length)for(let i=0;i<o.length;i++){if(typeof o[i]=="undefined")o[i]="undefined";else if(o[i]instanceof Error){const g=o[i];g.stack?o[i]=g.stack:o[i]=g.toString()}S.push(o[i])}try{const i=JSON.stringify(S,function(g,a){if(a&&typeof a=="object"){if(f.indexOf(a)!==-1)return"[Circular]";f.push(a)}return a});return i.length>C?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[226],Ee([0,1,57,15,33,74,225,212]),function(oe,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(E.IExtHostExtensionService,F.ExtHostExtensionService),(0,d.registerSingleton)(M.ILogService,P.ExtHostLogService),(0,d.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[235],Ee([0,1,22,3,178,220,214,17,75,11,2,224,226]),function(oe,e,d,M,E,A,F,P,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(o,f){return o instanceof Request||/^file:/i.test(String(o))&&(o=T.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),m(o,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,f,S,i,g){return/^file:/i.test(f.toString())&&(f=T.FileAccess.asBrowserUri(t.URI.parse(f.toString())).toString(!0)),super.open(o,f,S??!0,i,g)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:S=>S}),f=self.Worker;Worker=function(S,i){/^file:/i.test(S.toString())&&(S=T.FileAccess.asBrowserUri(t.URI.parse(S.toString())).toString(!0));const a=`(${function(c){function b(k){return typeof k=="string"||k instanceof URL?String(k).replace(/^file:\/\//i,"vscode-file://vscode-app"):k}const h=fetch.bind(self);self.fetch=function(k,O){return k instanceof Request?h(k,O):h(b(k),O)},self.XMLHttpRequest=class extends XMLHttpRequest{open(k,O,N,I,B){return super.open(k,b(O),N??!0,I,B)}};const y=importScripts.bind(self);self.importScripts=(...k)=>{y(...k.map(b))};const R=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:k=>k}):void 0;y(R?R.createScriptURL(c):c)}.toString()}('${S}'))`;i=i||{},i.name=i.name||P.basename(S.toString());const r=new Blob([a],{type:"application/javascript"}),v=URL.createObjectURL(r);return new f(o?o.createScriptURL(v):v,i)}}else self.Worker=class extends F.NestedWorker{constructor(o,f){super(n,o,{name:P.basename(o.toString()),...f})}};const s=new class{constructor(){this.pid=void 0}exit(o){_()}async exists(o){return!0}async realpath(o){return o}};class u{constructor(){const f=new MessageChannel,S=new M.Emitter;let i=!1;n(f.port2,[f.port2]),f.port1.onmessage=g=>{const{data:a}=g;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const r=d.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,E.isMessageOfType)(r,2)){i=!0,C("received terminate message from renderer");return}S.fire(r)},this.protocol={onMessage:S.event,send:g=>{if(!i){const a=g.buffer.buffer.slice(g.buffer.byteOffset,g.buffer.byteOffset+g.buffer.byteLength);f.port1.postMessage(a,[a])}}}}}function p(o){return new Promise(f=>{const S=o.onMessage(i=>{S.dispose();const g=JSON.parse(i.toString());o.send((0,E.createMessageOfType)(0)),f({protocol:o,initData:g})});o.send((0,E.createMessageOfType)(1))})}let C=o=>_();function w(){const o=new u;D.mark("code/extHost/willConnectToRenderer"),p(o.protocol).then(f=>{D.mark("code/extHost/didWaitForInitData");const S=new A.ExtensionHostMain(f.protocol,f.initData,s,null);C=i=>S.terminate(i)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4bbec283c36a51cf80f9b77c7a81c140a76a363b/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
